// SPDX-License-Identifier: GPL-2.0-only
/*
 * Copyright (c) 2021, The Linux Foundation. All rights reserved.
 * Copyright (c) 2022 Qualcomm Innovation Center, Inc. All rights reserved.
 */

#ifndef __IPA_GCC_HWIO_H__
#define __IPA_GCC_HWIO_H__
/**
  @file ipa_gcc_hwio.h
  @brief Auto-generated HWIO interface include file.

  This file contains HWIO register definitions for the following modules:
    GCC_CLK_CTL_REG.*

  'Include' filters applied: <none>
  'Exclude' filters applied: RESERVED DUMMY

  Attribute definitions for the HWIO_*_ATTR macros are as follows:
    0x0: Command register
    0x1: Read-Only
    0x2: Write-Only
    0x3: Read/Write
*/

/*----------------------------------------------------------------------------
 * MODULE: GCC_CLK_CTL_REG
 *--------------------------------------------------------------------------*/

#define GCC_CLK_CTL_REG_REG_BASE                                                                       (CLK_CTL_BASE      + 0x00010000)
#define GCC_CLK_CTL_REG_REG_BASE_PHYS                                                                  (CLK_CTL_BASE_PHYS + 0x00010000)
#define GCC_CLK_CTL_REG_REG_BASE_OFFS                                                                  0x00010000

#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00067048)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067048)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067048)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_RMSK                                                         0x1
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ATTR                                                         0x3
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_ACGCR_CLK_ENABLE_SHFT                                              0x0

#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00067058)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067058)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067058)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_RMSK                                                         0x1
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ATTR                                                         0x3
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_ACGCR_CLK_ENABLE_SHFT                                              0x0

#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000670d4)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670d4)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670d4)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_RMSK                                                         0x1
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ATTR                                                         0x3
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_ACGCR_CLK_ENABLE_SHFT                                              0x0

#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002906c)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002906c)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002906c)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_RMSK                                                                 0x3
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ATTR                                                                 0x3
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ADDR, HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_MUX_SEL_BMSK                                                         0x3
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_MUXR_MUX_SEL_SHFT                                                         0x0

#define HWIO_GCC_PCIE_0_PIPE_MUXR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b070)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b070)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b070)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_RMSK                                                                        0x3
#define HWIO_GCC_PCIE_0_PIPE_MUXR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_PIPE_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_MUXR_ADDR, HWIO_GCC_PCIE_0_PIPE_MUXR_RMSK)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PIPE_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PIPE_MUXR_ADDR,m,v,HWIO_GCC_PCIE_0_PIPE_MUXR_IN)
#define HWIO_GCC_PCIE_0_PIPE_MUXR_MUX_SEL_BMSK                                                                0x3
#define HWIO_GCC_PCIE_0_PIPE_MUXR_MUX_SEL_SHFT                                                                0x0

#define HWIO_GCC_PCIE_0_MBIST_MUXR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b08c)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b08c)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b08c)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_RMSK                                                                       0x1
#define HWIO_GCC_PCIE_0_MBIST_MUXR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_MBIST_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MBIST_MUXR_ADDR, HWIO_GCC_PCIE_0_MBIST_MUXR_RMSK)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MBIST_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MBIST_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MBIST_MUXR_ADDR,m,v,HWIO_GCC_PCIE_0_MBIST_MUXR_IN)
#define HWIO_GCC_PCIE_0_MBIST_MUXR_MUX_SEL_BMSK                                                               0x1
#define HWIO_GCC_PCIE_0_MBIST_MUXR_MUX_SEL_SHFT                                                               0x0

#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b090)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b090)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b090)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_RMSK                                                           0x1
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ATTR                                                           0x3
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ADDR, HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_RMSK)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_ADDR,m,v,HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_IN)
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_MUX_SEL_BMSK                                                   0x1
#define HWIO_GCC_PCIE_0_MBIST_PLL_TEST_SE_MUXR_MUX_SEL_SHFT                                                   0x0

#define HWIO_GCC_PCIE_1_PIPE_MUXR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d078)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d078)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d078)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_RMSK                                                                        0x3
#define HWIO_GCC_PCIE_1_PIPE_MUXR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_PIPE_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_MUXR_ADDR, HWIO_GCC_PCIE_1_PIPE_MUXR_RMSK)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PIPE_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PIPE_MUXR_ADDR,m,v,HWIO_GCC_PCIE_1_PIPE_MUXR_IN)
#define HWIO_GCC_PCIE_1_PIPE_MUXR_MUX_SEL_BMSK                                                                0x3
#define HWIO_GCC_PCIE_1_PIPE_MUXR_MUX_SEL_SHFT                                                                0x0

#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d094)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d094)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d094)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_RMSK                                                                     0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ADDR, HWIO_GCC_PCIE_1_PHY_AUX_MUXR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_AUX_MUXR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_AUX_MUXR_IN)
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_MUX_SEL_BMSK                                                             0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_MUXR_MUX_SEL_SHFT                                                             0x0

#define HWIO_GCC_PCIE_1_MBIST_MUXR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d098)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d098)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d098)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_RMSK                                                                       0x1
#define HWIO_GCC_PCIE_1_MBIST_MUXR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_MBIST_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MBIST_MUXR_ADDR, HWIO_GCC_PCIE_1_MBIST_MUXR_RMSK)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MBIST_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MBIST_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MBIST_MUXR_ADDR,m,v,HWIO_GCC_PCIE_1_MBIST_MUXR_IN)
#define HWIO_GCC_PCIE_1_MBIST_MUXR_MUX_SEL_BMSK                                                               0x1
#define HWIO_GCC_PCIE_1_MBIST_MUXR_MUX_SEL_SHFT                                                               0x0

#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d09c)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d09c)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d09c)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_RMSK                                                           0x1
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ATTR                                                           0x3
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ADDR, HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_RMSK)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ADDR, m)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ADDR,v)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_ADDR,m,v,HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_IN)
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_MUX_SEL_BMSK                                                   0x1
#define HWIO_GCC_PCIE_1_MBIST_PLL_TEST_SE_MUXR_MUX_SEL_SHFT                                                   0x0

#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00067050)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067050)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067050)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_RMSK                                      0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ATTR                                      0x3
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ADDR, HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_RMSK)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ADDR, m)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ADDR,v)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_ADDR,m,v,HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_IN)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_MUX_SEL_BMSK                              0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_TX_SYMBOL_0_MUX_MUXR_MUX_SEL_SHFT                              0x0

#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00067054)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067054)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067054)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_RMSK                                                                0x3
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ADDR, HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_RMSK)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ADDR, m)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ADDR,v)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_ADDR,m,v,HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_IN)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_MUX_SEL_BMSK                                                        0x3
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_MUXR_MUX_SEL_SHFT                                                        0x0

#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00067060)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067060)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067060)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_RMSK                                      0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ATTR                                      0x3
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ADDR, HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_RMSK)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ADDR, m)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ADDR,v)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_ADDR,m,v,HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_IN)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_MUX_SEL_BMSK                              0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_0_MUX_MUXR_MUX_SEL_SHFT                              0x0

#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00067064)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067064)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067064)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_RMSK                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ADDR, HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_RMSK)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ADDR, m)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ADDR,v)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_ADDR,m,v,HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_IN)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_MUX_SEL_BMSK                                                        0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_MUXR_MUX_SEL_SHFT                                                        0x0

#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000670dc)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670dc)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670dc)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_RMSK                                      0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ATTR                                      0x3
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ADDR, HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_RMSK)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ADDR, m)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ADDR,v)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_ADDR,m,v,HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_IN)
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_MUX_SEL_BMSK                              0x1
#define HWIO_GCC_GPLL0_AND_PLL_TEST_SE_UFS_PHY_RX_SYMBOL_1_MUX_MUXR_MUX_SEL_SHFT                              0x0

#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000670e0)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670e0)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670e0)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_RMSK                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ADDR, HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_RMSK)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ADDR, m)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ADDR,v)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_ADDR,m,v,HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_IN)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_MUX_SEL_BMSK                                                        0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_MUXR_MUX_SEL_SHFT                                                        0x0

#define HWIO_GCC_SYSTEM_NOC_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00066000)
#define HWIO_GCC_SYSTEM_NOC_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066000)
#define HWIO_GCC_SYSTEM_NOC_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066000)
#define HWIO_GCC_SYSTEM_NOC_BCR_RMSK                                                                          0x1
#define HWIO_GCC_SYSTEM_NOC_BCR_ATTR                                                                          0x3
#define HWIO_GCC_SYSTEM_NOC_BCR_IN          \
        in_dword_masked(HWIO_GCC_SYSTEM_NOC_BCR_ADDR, HWIO_GCC_SYSTEM_NOC_BCR_RMSK)
#define HWIO_GCC_SYSTEM_NOC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYSTEM_NOC_BCR_ADDR, m)
#define HWIO_GCC_SYSTEM_NOC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_SYSTEM_NOC_BCR_ADDR,v)
#define HWIO_GCC_SYSTEM_NOC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYSTEM_NOC_BCR_ADDR,m,v,HWIO_GCC_SYSTEM_NOC_BCR_IN)
#define HWIO_GCC_SYSTEM_NOC_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_SYSTEM_NOC_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_SYSTEM_NOC_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SYSTEM_NOC_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003817c)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003817c)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003817c)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_RMSK                                                           0x81c0000e
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ADDR, HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IN)
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_SYS_NOC_CPUSS_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00005008)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00005008)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00005008)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_RMSK                                                              0x81d00005
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ADDR, HWIO_GCC_SYS_NOC_NAV_QX_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_NAV_QX_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IN)
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_NAV_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00024018)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024018)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024018)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_RMSK                                                             0x81d00005
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ADDR, HWIO_GCC_SYS_NOC_TME_QXM_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_TME_QXM_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IN)
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SYS_NOC_TME_QXM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SYS_NOC_AXI_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00066004)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066004)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066004)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_SYS_NOC_AXI_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_AXI_CBCR_ADDR, HWIO_GCC_SYS_NOC_AXI_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_AXI_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_AXI_CBCR_IN)
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_SYS_NOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_SYS_NOC_AXI_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_SYS_NOC_AXI_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_SYS_NOC_AXI_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_SYS_NOC_AXI_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_SYS_NOC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SYS_NOC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_SYS_NOC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00066008)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066008)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066008)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_RMSK                                                              0x81f0000f
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ADDR, HWIO_GCC_SYS_NOC_GC_AXI_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_GC_AXI_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IN)
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                             0x200000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                 0x15
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006600c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006600c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006600c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_RMSK                                                              0x81f0700f
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ADDR, HWIO_GCC_SYS_NOC_SF_AXI_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_AXI_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IN)
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                             0x200000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                 0x15
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00066010)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066010)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066010)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ADDR, HWIO_GCC_SYS_NOC_SF_AXI_SREGR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_AXI_SREGR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IN)
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00066014)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066014)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066014)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ADDR, HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_IN)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00066018)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066018)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066018)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_RMSK                                                             0x81d0000f
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ADDR, HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IN)
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SYS_NOC_AHB_CFG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SYS_NOC_AT_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006601c)
#define HWIO_GCC_SYS_NOC_AT_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006601c)
#define HWIO_GCC_SYS_NOC_AT_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006601c)
#define HWIO_GCC_SYS_NOC_AT_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_SYS_NOC_AT_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SYS_NOC_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_AT_CBCR_ADDR, HWIO_GCC_SYS_NOC_AT_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_AT_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_AT_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_AT_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_AT_CBCR_IN)
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_SYS_NOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_SYS_NOC_AT_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_SYS_NOC_AT_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SYS_NOC_AT_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_SYS_NOC_AT_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_SYS_NOC_AT_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_SYS_NOC_AT_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SYS_NOC_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00066020)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066020)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066020)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_RMSK                                                       0x81c00005
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ATTR                                                              0x3
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SYS_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00066024)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066024)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066024)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_RMSK                                                               0x1
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ATTR                                                               0x3
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SYS_NOC_TME_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00066028)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066028)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066028)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_RMSK                                                               0x1
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ATTR                                                               0x3
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SYS_NOC_NAV_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00066040)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066040)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066040)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_RMSK                                                              0x3fffff
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ATTR                                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_RCG_SW_CTRL_BMSK                                                  0x3f8000
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_RCG_SW_CTRL_SHFT                                                       0xf
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_SW_PERF_STATE_BMSK                                                  0x7800
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_SW_PERF_STATE_SHFT                                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_SW_OVERRIDE_BMSK                                                     0x400
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_SW_OVERRIDE_SHFT                                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                        0x200
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_FSM_STATE_BMSK                                                   0x1c0
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_FSM_STATE_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                   0x20
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_CURR_PERF_STATE_BMSK                                                  0x1e
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_CURR_PERF_STATE_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_EN_BMSK                                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_EN_SHFT                                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066048)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066048)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066048)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006604c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006604c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006604c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066050)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066050)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066050)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066054)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066054)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066054)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066058)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066058)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066058)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006605c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006605c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006605c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066060)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066060)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066060)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066064)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066064)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066064)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00066068)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066068)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066068)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006606c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006606c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006606c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066070)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066070)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066070)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066074)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066074)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066074)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066078)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066078)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066078)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006607c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006607c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006607c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066080)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066080)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066080)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066084)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066084)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066084)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_GC_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006602c)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006602c)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006602c)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ADDR, HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_IN)
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066030)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066030)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066030)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ADDR, HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_IN)
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_SYS_NOC_GC_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00066158)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066158)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066158)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_RMSK                                                                0x1
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ATTR                                                                0x3
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SYS_NOC_GC_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066178)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066178)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066178)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006617c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006617c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006617c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066180)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066180)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066180)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066184)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066184)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066184)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066188)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066188)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066188)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006618c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006618c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006618c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066190)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066190)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066190)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066194)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066194)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066194)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00066198)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066198)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066198)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006619c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006619c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006619c)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661a0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661a0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661a0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661a4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661a4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661a4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000661b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000661b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000661b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_SYS_NOC_CMD_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006615c)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006615c)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006615c)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_RMSK                                                                 0x80000013
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_SYS_NOC_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_CMD_RCGR_ADDR, HWIO_GCC_SYS_NOC_CMD_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_CMD_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_CMD_RCGR_IN)
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_OFF_SHFT                                                              0x1f
#define HWIO_GCC_SYS_NOC_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                        0x10
#define HWIO_GCC_SYS_NOC_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                         0x4
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_EN_BMSK                                                                0x2
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_EN_SHFT                                                                0x1
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_SYS_NOC_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_SYS_NOC_CMD_RCGR_UPDATE_BMSK                                                                 0x1
#define HWIO_GCC_SYS_NOC_CMD_RCGR_UPDATE_SHFT                                                                 0x0
#define HWIO_GCC_SYS_NOC_CMD_RCGR_UPDATE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SYS_NOC_CMD_RCGR_UPDATE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SYS_NOC_CFG_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00066160)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066160)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066160)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_RMSK                                                                   0x11071f
#define HWIO_GCC_SYS_NOC_CFG_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_SYS_NOC_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_CFG_RCGR_ADDR, HWIO_GCC_SYS_NOC_CFG_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_CFG_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_CFG_RCGR_IN)
#define HWIO_GCC_SYS_NOC_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                    0x100000
#define HWIO_GCC_SYS_NOC_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                        0x14
#define HWIO_GCC_SYS_NOC_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SYS_NOC_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SYS_NOC_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                    0x10000
#define HWIO_GCC_SYS_NOC_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                       0x10
#define HWIO_GCC_SYS_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                        0x0
#define HWIO_GCC_SYS_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                       0x1
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_BMSK                                                              0x700
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SHFT                                                                0x8
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                           0x0
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                           0x1
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                           0x2
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                           0x3
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                           0x4
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                           0x5
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                           0x6
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                           0x7
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_BMSK                                                               0x1f
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_SHFT                                                                0x0
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                           0x1
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                         0x2
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                           0x3
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                         0x4
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                           0x5
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                         0x6
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                           0x7
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                         0x8
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                           0x9
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                         0xa
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                           0xb
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                         0xc
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                           0xd
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                         0xe
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                           0xf
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                        0x10
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                          0x11
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                        0x12
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                         0x13
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                       0x14
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                         0x15
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                       0x16
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                         0x17
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                       0x18
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                         0x19
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                       0x1a
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                         0x1b
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                       0x1c
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                         0x1d
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                       0x1e
#define HWIO_GCC_SYS_NOC_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                         0x1f

#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00066288)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066288)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066288)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_RMSK                                                                   0x1
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ATTR                                                                   0x3
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SYS_NOC_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662a8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662ac)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662b0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662b4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662b8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662b8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662b8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662bc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662bc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662bc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662c0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662c0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662c0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662c4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662c4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662c4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662c8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662c8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662c8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000662cc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662cc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662cc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662d0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662d0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662d0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662d4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662d4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662d4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662d8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662d8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662d8)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662dc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662dc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662dc)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662e0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662e0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662e0)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000662e4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000662e4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000662e4)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SYS_NOC_SYS_NOC_SF_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006628c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006628c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006628c)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ADDR, HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_IN)
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00066290)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00066290)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00066290)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ADDR, HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_IN)
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_SYS_NOC_SF_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000663b8)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000663b8)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000663b8)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_RMSK                                                                0x1
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ATTR                                                                0x3
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SYS_NOC_SF_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_CONFIG_NOC_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00064000)
#define HWIO_GCC_CONFIG_NOC_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064000)
#define HWIO_GCC_CONFIG_NOC_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064000)
#define HWIO_GCC_CONFIG_NOC_BCR_RMSK                                                                          0x1
#define HWIO_GCC_CONFIG_NOC_BCR_ATTR                                                                          0x3
#define HWIO_GCC_CONFIG_NOC_BCR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_BCR_ADDR, HWIO_GCC_CONFIG_NOC_BCR_RMSK)
#define HWIO_GCC_CONFIG_NOC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_BCR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_BCR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_BCR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_BCR_IN)
#define HWIO_GCC_CONFIG_NOC_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_CONFIG_NOC_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_CONFIG_NOC_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_CONFIG_NOC_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_CNOC_APSS_QH_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00038180)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038180)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038180)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_RMSK                                                                0x81c0000f
#define HWIO_GCC_CNOC_APSS_QH_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_CNOC_APSS_QH_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_APSS_QH_CBCR_ADDR, HWIO_GCC_CNOC_APSS_QH_CBCR_RMSK)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_APSS_QH_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_APSS_QH_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_APSS_QH_CBCR_ADDR,m,v,HWIO_GCC_CNOC_APSS_QH_CBCR_IN)
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_CNOC_APSS_QH_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_CNOC_APSS_QH_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_CNOC_APSS_QH_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_CNOC_APSS_QH_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_CNOC_APSS_QH_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_CNOC_APSS_QH_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_CNOC_APSS_QH_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_CNOC_APSS_QH_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_CNOC_APSS_QH_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_CNOC_APSS_QH_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CNOC_APSS_QH_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_CNOC_CENTER_QX_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00064004)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064004)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064004)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_RMSK                                                              0x81d0000f
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CBCR_ADDR, HWIO_GCC_CNOC_CENTER_QX_CBCR_RMSK)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_CENTER_QX_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_CENTER_QX_CBCR_ADDR,m,v,HWIO_GCC_CNOC_CENTER_QX_CBCR_IN)
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CNOC_CENTER_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_CNOC_SF_QX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00064008)
#define HWIO_GCC_CNOC_SF_QX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064008)
#define HWIO_GCC_CNOC_SF_QX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064008)
#define HWIO_GCC_CNOC_SF_QX_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_CNOC_SF_QX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_CNOC_SF_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_SF_QX_CBCR_ADDR, HWIO_GCC_CNOC_SF_QX_CBCR_RMSK)
#define HWIO_GCC_CNOC_SF_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_SF_QX_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_SF_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_SF_QX_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_SF_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_SF_QX_CBCR_ADDR,m,v,HWIO_GCC_CNOC_SF_QX_CBCR_IN)
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_CNOC_SF_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_CNOC_SF_QX_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_CNOC_SF_QX_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_CNOC_SF_QX_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_CNOC_SF_QX_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_CNOC_SF_QX_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_CNOC_SF_QX_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CNOC_SF_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_CNOC_NORTH_QX_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006400c)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006400c)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006400c)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CBCR_ADDR, HWIO_GCC_CNOC_NORTH_QX_CBCR_RMSK)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_NORTH_QX_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_NORTH_QX_CBCR_ADDR,m,v,HWIO_GCC_CNOC_NORTH_QX_CBCR_IN)
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CNOC_NORTH_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064010)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064010)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064010)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_RMSK                                                           0x81d00005
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ADDR, HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IN)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CNOC_PERIPH_SOUTH_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064014)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064014)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064014)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_RMSK                                                           0x81d00005
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ADDR, HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IN)
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CNOC_PERIPH_NORTH_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CFG_NOC_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064018)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064018)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064018)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_CFG_NOC_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_CFG_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_CFG_NOC_AHB_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_CFG_NOC_AHB_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_CFG_NOC_AHB_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_CFG_NOC_AHB_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_CFG_NOC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_CFG_NOC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CFG_NOC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006401c)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006401c)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006401c)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_RMSK                                                            0x81d0000f
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_WEST_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00000030)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000030)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000030)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_RMSK                                                            0x81d0700e
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ADDR, HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_RMSK)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_ADDR,m,v,HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IN)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                              0x4000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                 0xe
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                            0x2000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                               0xd
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                           0x1000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                              0xc
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00000034)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000034)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000034)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_RMSK                                                            0xf1ffffe
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ATTR                                                                  0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ADDR, HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_RMSK)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ADDR, m)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ADDR,v)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_ADDR,m,v,HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IN)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                  0xf000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                       0x18
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                             0x100000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                 0x14
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                     0xf0000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                        0x10
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                       0x8000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                          0xf
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                   0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                        0x4000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                           0xe
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                           0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                        0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                       0x2000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                          0xd
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                              0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                 0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                   0x1000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                      0xc
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                             0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                0x800
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                  0xb
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                              0x400
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                0xa
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                       0x300
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                         0x8
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                0x2
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                  0x80
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                   0x7
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_FORCE_CLK_ON_BMSK                                                    0x40
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_FORCE_CLK_ON_SHFT                                                     0x6
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                            0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                              0x20
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                               0x5
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                      0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                 0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                  0x10
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                   0x4
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                         0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                            0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                 0x8
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                 0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                      0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                         0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                            0x4
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                            0x2
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                0x2
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                0x1
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                          0x0
#define HWIO_GCC_CNOC_PCIE_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                           0x1

#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00000038)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000038)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000038)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_RMSK                                                       0xffffffff
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ATTR                                                              0x3
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ADDR, HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_IN)
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                    0xfc000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                          0x1a
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                               0x2000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                    0x19
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                 0x1000000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                      0x18
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                    0x800000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                        0x17
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                      0x400000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                          0x16
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                           0x3f0000
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                               0x10
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                               0xff00
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                  0x8
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                0xff
#define HWIO_GCC_CNOC_PCIE_SF_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                 0x0

#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064020)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064020)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064020)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_RMSK                                                           0x81d0000f
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_NORTH_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00064024)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064024)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064024)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_RMSK                                                            0x81d0000f
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_EAST_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064028)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064028)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064028)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_RMSK                                                           0x81d0000f
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_SOUTH_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006402c)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006402c)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006402c)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_RMSK                                                           0x81d0000f
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_MMNOC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CNOC_QDSS_STM_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064030)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064030)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064030)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_QDSS_STM_CBCR_ADDR, HWIO_GCC_CNOC_QDSS_STM_CBCR_RMSK)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_QDSS_STM_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_QDSS_STM_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_QDSS_STM_CBCR_ADDR,m,v,HWIO_GCC_CNOC_QDSS_STM_CBCR_IN)
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CNOC_QDSS_STM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00029088)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029088)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029088)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_RMSK                                                       0x81c0000f
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ATTR                                                              0x3
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ADDR, HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IN)
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_SW_ONLY_EN_BMSK                                                   0x8
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_SW_ONLY_EN_SHFT                                                   0x3
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_HW_CTL_BMSK                                                       0x2
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_HW_CTL_SHFT                                                       0x1
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_HW_CTL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_CFG_NOC_USB3_PRIM_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_CFG_NOC_LPASS_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003715c)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003715c)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003715c)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_RMSK                                                               0x81d00005
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CBCR_ADDR, HWIO_GCC_CFG_NOC_LPASS_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_LPASS_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_LPASS_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_LPASS_CBCR_IN)
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_LPASS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00064034)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064034)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064034)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_RMSK                                                             0x81c00005
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_WEST_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_WEST_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_NOC_WEST_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00064038)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064038)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064038)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_RMSK                                                             0x81c00005
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_EAST_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_EAST_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_NOC_EAST_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006403c)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006403c)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006403c)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_RMSK                                                            0x81c00005
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_NOC_NORTH_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00000024)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000024)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000024)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_RMSK                                                       0x81c00004
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ATTR                                                              0x3
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_NOC_PCIE_NORTH_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                               0x1

#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00064040)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064040)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064040)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_RMSK                                                            0x81c00005
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_NOC_SOUTH_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064044)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064044)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064044)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_RMSK                                                           0x81c00005
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_NOC_CENTER_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064048)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064048)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064048)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_RMSK                                                           0x81c0000f
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ADDR, HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IN)
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_AH2PHY_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00035148)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035148)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035148)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_RMSK                                                            0x81c00005
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_NOC_LPASS_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0006404c)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006404c)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006404c)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_RMSK                                                       0x81c00005
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ATTR                                                              0x3
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_NOC_MMNOC_CNOC_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_CNOC_PERIPH_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064050)
#define HWIO_GCC_CNOC_PERIPH_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064050)
#define HWIO_GCC_CNOC_PERIPH_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064050)
#define HWIO_GCC_CNOC_PERIPH_CBCR_RMSK                                                                 0x81d00005
#define HWIO_GCC_CNOC_PERIPH_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_CNOC_PERIPH_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CBCR_ADDR, HWIO_GCC_CNOC_PERIPH_CBCR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CBCR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_CBCR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_CBCR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_CBCR_IN)
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_CNOC_PERIPH_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CNOC_PERIPH_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CONFIG_NOC_AT_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064054)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064054)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064054)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_AT_CBCR_ADDR, HWIO_GCC_CONFIG_NOC_AT_CBCR_RMSK)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_AT_CBCR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_AT_CBCR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_AT_CBCR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_AT_CBCR_IN)
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CONFIG_NOC_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006406c)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006406c)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006406c)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_RMSK                                                                 0x1fffff
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_ATTR                                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CMD_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_RCG_SW_CTRL_BMSK                                                     0x1f8000
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_RCG_SW_CTRL_SHFT                                                          0xf
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_SW_PERF_STATE_BMSK                                                     0x7800
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_SW_PERF_STATE_SHFT                                                        0xb
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_SW_OVERRIDE_BMSK                                                        0x400
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_SW_OVERRIDE_SHFT                                                          0xa
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                           0x200
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                             0x9
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_FSM_STATE_BMSK                                                      0x1c0
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_FSM_STATE_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_CURR_PERF_STATE_BMSK                                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_CURR_PERF_STATE_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_EN_BMSK                                                               0x1
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_EN_SHFT                                                               0x0
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RPMH_CNOC_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064074)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064074)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064074)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064078)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064078)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064078)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006407c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006407c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006407c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064080)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064080)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064080)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064084)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064084)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064084)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064088)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064088)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064088)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006408c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006408c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006408c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064090)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064090)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064090)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064094)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064094)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064094)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064098)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064098)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064098)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006409c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006409c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006409c)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000640a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000640a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000640a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000640a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000640a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000640a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000640a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000640a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000640a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000640ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000640ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000640ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000640b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000640b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000640b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_NORTH_QX_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064058)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064058)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064058)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_RMSK                                                           0x80000013
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ADDR, HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_RMSK)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ADDR,m,v,HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_IN)
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_OFF_SHFT                                                        0x1f
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                  0x10
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                   0x4
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_EN_BMSK                                                          0x2
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_EN_SHFT                                                          0x1
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_UPDATE_BMSK                                                           0x1
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_UPDATE_SHFT                                                           0x0
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CNOC_NORTH_QX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006405c)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006405c)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006405c)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RMSK                                                             0x11071f
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ADDR, HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RMSK)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_ADDR,m,v,HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_IN)
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                              0x100000
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                  0x14
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                           0x0
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                            0x1
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                              0x10000
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                 0x10
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                  0x0
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                 0x1
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_CNOC_NORTH_QX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641a0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641a4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641a8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641ac)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641b0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641b4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641b4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641b4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641b8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641b8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641b8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641bc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641bc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641bc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641c0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641c0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641c0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000641c4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641c4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641c4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641c8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641c8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641c8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641cc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641cc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641cc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641d0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641d0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641d0)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641d4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641d4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641d4)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641d8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641d8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641d8)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000641dc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000641dc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000641dc)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_CENTER_QX_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00064184)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064184)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064184)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ADDR, HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_RMSK)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ADDR,m,v,HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_IN)
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CNOC_CENTER_QX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00064188)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064188)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064188)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ADDR, HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RMSK)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_ADDR,m,v,HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_IN)
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_CNOC_CENTER_QX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642cc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642cc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642cc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642d0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642d0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642d0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642d4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642d4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642d4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642d8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642d8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642d8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642dc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642dc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642dc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642e0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642e0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642e0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642e4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642e4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642e4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642e8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642e8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642e8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642ec)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642ec)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642ec)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x000642f0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642f0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642f0)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000642f4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642f4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642f4)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000642f8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642f8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642f8)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000642fc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642fc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642fc)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064300)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064300)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064300)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064304)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064304)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064304)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064308)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064308)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064308)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000642b0)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642b0)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642b0)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_RMSK                                                              0x80000013
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CMD_RCGR_ADDR, HWIO_GCC_CONFIG_NOC_CMD_RCGR_RMSK)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_CMD_RCGR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_CMD_RCGR_IN)
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CONFIG_NOC_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000642b4)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000642b4)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000642b4)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_RMSK                                                                0x11071f
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CFG_RCGR_ADDR, HWIO_GCC_CONFIG_NOC_CFG_RCGR_RMSK)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_CFG_RCGR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_CFG_RCGR_IN)
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                 0x10000
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                    0x10
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                     0x0
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                    0x1
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_CONFIG_NOC_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000643f8)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000643f8)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000643f8)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000643fc)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000643fc)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000643fc)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064400)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064400)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064400)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064404)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064404)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064404)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064408)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064408)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064408)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006440c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006440c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006440c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064410)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064410)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064410)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064414)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064414)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064414)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00064418)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064418)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064418)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006441c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006441c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006441c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064420)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064420)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064420)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064424)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064424)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064424)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064428)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064428)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064428)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006442c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006442c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006442c)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064430)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064430)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064430)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064434)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064434)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064434)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_CNOC_CNOC_PERIPH_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000643dc)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000643dc)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000643dc)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_RMSK                                                             0x80000013
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ADDR, HWIO_GCC_CNOC_PERIPH_CMD_RCGR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_CMD_RCGR_IN)
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_OFF_SHFT                                                          0x1f
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                    0x10
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                     0x4
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_EN_BMSK                                                            0x2
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_EN_SHFT                                                            0x1
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_UPDATE_BMSK                                                             0x1
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_UPDATE_SHFT                                                             0x0
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_UPDATE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CNOC_PERIPH_CMD_RCGR_UPDATE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000643e0)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000643e0)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000643e0)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RMSK                                                               0x11071f
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ADDR, HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_CFG_RCGR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_CFG_RCGR_IN)
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                0x100000
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                    0x14
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                0x10000
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                   0x10
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                    0x0
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                   0x1
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_BMSK                                                          0x700
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SHFT                                                            0x8
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                       0x0
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                       0x1
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                       0x2
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                       0x3
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                       0x4
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                       0x5
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                       0x6
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                       0x7
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_BMSK                                                           0x1f
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_SHFT                                                            0x0
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                       0x1
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                     0x2
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                       0x3
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                     0x4
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                       0x5
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                     0x6
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                       0x7
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                     0x8
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                       0x9
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                     0xa
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                       0xb
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                     0xc
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                       0xd
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                     0xe
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                       0xf
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                    0x10
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                      0x11
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                    0x12
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                     0x13
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                   0x14
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                     0x15
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                   0x16
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                     0x17
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                   0x18
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                     0x19
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                   0x1a
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                     0x1b
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                   0x1c
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                     0x1d
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                   0x1e
#define HWIO_GCC_CNOC_PERIPH_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                     0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064524)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064524)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064524)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064528)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064528)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064528)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006452c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006452c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006452c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064530)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064530)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064530)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064534)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064534)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064534)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064538)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064538)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064538)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006453c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006453c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006453c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064540)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064540)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064540)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064544)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064544)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064544)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00064548)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064548)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064548)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_RMSK                                              0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ATTR                                                0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_BMSK                                      0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SHFT                                        0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                   0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                   0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                   0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                   0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_BMSK                                       0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_SHFT                                        0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                 0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                   0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                 0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                   0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                 0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                   0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                 0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                   0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                 0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                   0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                 0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                   0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                 0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                   0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                 0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                   0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                  0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                 0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                               0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                 0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                               0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                 0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                               0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                 0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                               0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                 0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                               0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                 0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                               0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                 0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0006454c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006454c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006454c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00064550)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064550)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064550)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00064554)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064554)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064554)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00064558)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064558)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064558)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0006455c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006455c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006455c)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00064560)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064560)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064560)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_RMSK                                             0x71f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ATTR                                               0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_RPMH_CNOC_CONFIG_NOC_DDRSS_SF_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00064508)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064508)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064508)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_RMSK                                                     0x80000013
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ATTR                                                            0x3
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ADDR, HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_RMSK)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_IN)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_OFF_BMSK                                            0x80000000
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_OFF_SHFT                                                  0x1f
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                            0x10
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                             0x4
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_EN_BMSK                                                    0x2
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_EN_SHFT                                                    0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                            0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                             0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_UPDATE_BMSK                                                     0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_UPDATE_SHFT                                                     0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_UPDATE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CMD_RCGR_UPDATE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006450c)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006450c)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006450c)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RMSK                                                       0x11071f
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ATTR                                                            0x3
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ADDR, HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RMSK)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_IN)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_HW_CLK_CONTROL_BMSK                                        0x100000
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_HW_CLK_CONTROL_SHFT                                            0x14
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                     0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                      0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RCGLITE_DISABLE_BMSK                                        0x10000
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RCGLITE_DISABLE_SHFT                                           0x10
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                            0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                           0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_CFG_RCGR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064650)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064650)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064650)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064654)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064654)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064654)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064658)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064658)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064658)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006465c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006465c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006465c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064660)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064660)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064660)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064664)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064664)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064664)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064668)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064668)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064668)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006466c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006466c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006466c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064670)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064670)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064670)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00064674)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064674)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064674)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00064678)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064678)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064678)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006467c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006467c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006467c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00064680)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064680)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064680)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00064684)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064684)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064684)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00064688)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064688)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064688)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006468c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006468c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006468c)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_CNOC_CFG_NOC_LPASS_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064634)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064634)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064634)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_RMSK                                                           0x80000013
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ADDR, HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_RMSK)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ADDR,m,v,HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_IN)
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_OFF_SHFT                                                        0x1f
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                  0x10
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                   0x4
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_EN_BMSK                                                          0x2
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_EN_SHFT                                                          0x1
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_UPDATE_BMSK                                                           0x1
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_UPDATE_SHFT                                                           0x0
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_UPDATE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_LPASS_CMD_RCGR_UPDATE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00064638)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064638)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064638)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RMSK                                                             0x11071f
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ADDR, HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RMSK)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_ADDR,m,v,HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_IN)
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_HW_CLK_CONTROL_BMSK                                              0x100000
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                  0x14
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                           0x0
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                            0x1
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RCGLITE_DISABLE_BMSK                                              0x10000
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                 0x10
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                  0x0
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                 0x1
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_CFG_NOC_LPASS_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00064760)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064760)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064760)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_RMSK                                                         0x1
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ATTR                                                         0x3
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                              0x1
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                              0x0
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_CNOC_PERIPH_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00064764)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064764)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064764)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_RMSK                                                         0x1
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ATTR                                                         0x3
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                              0x1
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                              0x0
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_CNOC_PERIPH_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00064768)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064768)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064768)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_RMSK                                                               0x1
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ATTR                                                               0x3
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_CNOC_PERIPH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006476c)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006476c)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006476c)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_RMSK                                                             0x1
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ATTR                                                             0x3
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_CFG_NOC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00064770)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064770)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064770)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_RMSK                                                       0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ATTR                                                       0x3
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                            0x1
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                            0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_CONFIG_NOC_DDRSS_SF_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00064774)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064774)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064774)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_RMSK                                                         0x1
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ATTR                                                         0x3
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                              0x1
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                              0x0
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_CONFIG_NOC_CENTER_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00064778)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064778)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064778)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_RMSK                                                           0x1
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ATTR                                                           0x3
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                0x1
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                0x0
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_CONFIG_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006477c)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006477c)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006477c)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_RMSK                                                          0x1
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ATTR                                                          0x3
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                               0x1
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                               0x0
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_CONFIG_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00064780)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064780)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064780)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_RMSK                                                           0x1
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ATTR                                                           0x3
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                0x1
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                0x0
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_CONFIG_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00064784)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064784)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064784)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_RMSK                                                          0x1
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ATTR                                                          0x3
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                               0x1
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                               0x0
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_CONFIG_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00064788)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064788)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064788)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_RMSK                                                          0x1
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ATTR                                                          0x3
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                               0x1
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                               0x0
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_CONFIG_NOC_MMNOC_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006478c)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006478c)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006478c)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_RMSK                                                            0x1
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ATTR                                                            0x3
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_CNOC_CENTER_QX_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00064790)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00064790)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00064790)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_RMSK                                                             0x1
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ATTR                                                             0x3
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_CNOC_NORTH_QX_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_AGGRE_NOC_BCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00072000)
#define HWIO_GCC_AGGRE_NOC_BCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072000)
#define HWIO_GCC_AGGRE_NOC_BCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072000)
#define HWIO_GCC_AGGRE_NOC_BCR_RMSK                                                                           0x1
#define HWIO_GCC_AGGRE_NOC_BCR_ATTR                                                                           0x3
#define HWIO_GCC_AGGRE_NOC_BCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_BCR_ADDR, HWIO_GCC_AGGRE_NOC_BCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_BCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_BCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_BCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_BCR_IN)
#define HWIO_GCC_AGGRE_NOC_BCR_BLK_ARES_BMSK                                                                  0x1
#define HWIO_GCC_AGGRE_NOC_BCR_BLK_ARES_SHFT                                                                  0x0
#define HWIO_GCC_AGGRE_NOC_BCR_BLK_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_AGGRE_NOC_BCR_BLK_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00000028)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000028)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000028)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_RMSK                                                       0x81d0000e
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ATTR                                                              0x3
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ADDR, HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_RMSK)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_ADDR,m,v,HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IN)
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                     0x100000
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                         0x14
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_SW_ONLY_EN_BMSK                                                   0x8
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_SW_ONLY_EN_SHFT                                                   0x3
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_HW_CTL_BMSK                                                       0x2
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_HW_CTL_SHFT                                                       0x1
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CFG_NOC_PCIE_ANOC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00072004)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072004)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072004)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_RMSK                                                     0x81d0000f
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_ALL_ARES_BMSK                                      0x1000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_ALL_ARES_SHFT                                           0x18
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                    0x800000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                        0x17
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_DIS_BMSK                                               0x400000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_DIS_SHFT                                                   0x16
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                   0x100000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                       0x14
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_SW_ONLY_EN_BMSK                                                 0x8
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_SW_ONLY_EN_SHFT                                                 0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ARES_BMSK                                                   0x4
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ARES_SHFT                                                   0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ARES_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ARES_RESET_FVAL                                             0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_HW_CTL_BMSK                                                     0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_HW_CTL_SHFT                                                     0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_HW_CTL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_HW_CTL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CBCR_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00072008)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072008)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072008)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_AHB_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_AHB_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_AHB_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_AHB_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_AGGRE_NOC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007200c)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007200c)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007200c)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ADDR, HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QMIP_AGGRE_NOC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00072010)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072010)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072010)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_RMSK                                                 0x81d0000f
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ATTR                                                        0x3
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ADDR, HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_RMSK)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IN)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_OFF_BMSK                                         0x80000000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_OFF_SHFT                                               0x1f
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                  0x1000000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                       0x18
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                0x800000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                    0x17
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_DIS_BMSK                                           0x400000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_DIS_SHFT                                               0x16
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                               0x100000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                   0x14
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_SW_ONLY_EN_BMSK                                             0x8
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_SW_ONLY_EN_SHFT                                             0x3
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ARES_BMSK                                               0x4
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ARES_SHFT                                               0x2
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                      0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ARES_RESET_FVAL                                         0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_HW_CTL_BMSK                                                 0x2
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_HW_CTL_SHFT                                                 0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_HW_CTL_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_HW_CTL_ENABLE_FVAL                                          0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ENABLE_BMSK                                             0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ENABLE_SHFT                                             0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00072014)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072014)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072014)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_RMSK                                                 0x81d0000f
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ATTR                                                        0x3
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ADDR, HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_RMSK)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IN)
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_OFF_BMSK                                         0x80000000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_OFF_SHFT                                               0x1f
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                  0x1000000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                       0x18
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                0x800000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                    0x17
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_DIS_BMSK                                           0x400000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_DIS_SHFT                                               0x16
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                               0x100000
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                   0x14
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_SW_ONLY_EN_BMSK                                             0x8
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_SW_ONLY_EN_SHFT                                             0x3
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ARES_BMSK                                               0x4
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ARES_SHFT                                               0x2
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                      0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ARES_RESET_FVAL                                         0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_HW_CTL_BMSK                                                 0x2
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_HW_CTL_SHFT                                                 0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_HW_CTL_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_HW_CTL_ENABLE_FVAL                                          0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ENABLE_BMSK                                             0x1
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ENABLE_SHFT                                             0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00072018)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072018)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072018)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_RMSK                                                     0x81c00005
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                      0x1000000
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                           0x18
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                    0x800000
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                        0x17
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                               0x400000
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                   0x16
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                   0x4
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                   0x2
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                             0x1
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007201c)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007201c)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007201c)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_RMSK                                                        0x81d0700f
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ATTR                                                               0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                         0x1000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                              0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                       0x800000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                           0x17
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_DIS_BMSK                                                  0x400000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_DIS_SHFT                                                      0x16
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                      0x100000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                          0x14
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                          0x4000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                             0xe
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                               0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                        0x2000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                           0xd
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                             0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                              0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                       0x1000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                          0xc
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                             0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_SW_ONLY_EN_BMSK                                                    0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_SW_ONLY_EN_SHFT                                                    0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ARES_BMSK                                                      0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ARES_SHFT                                                      0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                             0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ARES_RESET_FVAL                                                0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_HW_CTL_BMSK                                                        0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_HW_CTL_SHFT                                                        0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00072020)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072020)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072020)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_RMSK                                                        0xf1ffffe
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ATTR                                                              0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                              0xf000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                   0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                         0x100000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                             0x14
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                 0xf0000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                    0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                   0x8000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                      0xf
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                               0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                    0x4000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                       0xe
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                       0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                    0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                   0x2000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                      0xd
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                          0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                             0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                               0x1000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                  0xc
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                            0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                            0x800
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                              0xb
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                          0x400
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                            0xa
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                   0x300
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                     0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                            0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                            0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                            0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                              0x80
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                               0x7
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_FORCE_CLK_ON_BMSK                                                0x40
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_FORCE_CLK_ON_SHFT                                                 0x6
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                        0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                          0x20
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                           0x5
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                  0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL             0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SLP_STG_BMSK                                              0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SLP_STG_SHFT                                               0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                     0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                        0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                             0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                             0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                  0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                     0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                        0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                        0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                            0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                            0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                      0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                       0x1

#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00072024)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072024)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072024)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_RMSK                                                   0xffffffff
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ATTR                                                          0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                0xfc000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                      0x1a
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                           0x2000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                0x19
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                             0x1000000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                  0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                0x800000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                    0x17
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                  0x400000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                      0x16
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                       0x3f0000
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                           0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                           0xff00
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                              0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                            0xff
#define HWIO_GCC_AGGRE_NOC_CENTER_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                             0x0

#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00072028)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072028)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072028)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_RMSK                                                          0x81d0700f
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_CORE_ON_BMSK                                            0x4000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_CORE_ON_SHFT                                               0xe
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                          0x2000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                             0xd
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                               0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                         0x1000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                            0xc
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                               0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007202c)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007202c)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007202c)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_RMSK                                                          0xf1ffffe
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ATTR                                                                0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                0xf000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                     0x18
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PWR_FSM_CLK_SEL_BMSK                                           0x100000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PWR_FSM_CLK_SEL_SHFT                                               0x14
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                   0xf0000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                      0x10
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                     0x8000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                        0xf
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                 0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                      0x4000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                         0xe
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                      0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                     0x2000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                        0xd
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                               0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                 0x1000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                    0xc
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                           0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                              0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CORE_ON_ACK_BMSK                                              0x800
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CORE_ON_ACK_SHFT                                                0xb
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_PERIPH_ON_ACK_BMSK                                            0x400
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_PERIPH_ON_ACK_SHFT                                              0xa
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                     0x300
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                       0x8
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                              0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                              0x2
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                              0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_ENABLE_BMSK                                                0x80
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_ENABLE_SHFT                                                 0x7
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_FORCE_CLK_ON_BMSK                                                  0x40
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_FORCE_CLK_ON_SHFT                                                   0x6
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SEL_SLP_STG_BMSK                                            0x20
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SEL_SLP_STG_SHFT                                             0x5
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                    0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL               0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SLP_STG_BMSK                                                0x10
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SLP_STG_SHFT                                                 0x4
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                       0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                          0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CTRL_PWR_DOWN_BMSK                                               0x8
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CTRL_PWR_DOWN_SHFT                                               0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                    0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                       0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                          0x4
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                          0x2
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SLP_STG_BMSK                                              0x2
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SLP_STG_SHFT                                              0x1
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                        0x0
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                         0x1

#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00072030)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072030)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072030)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_RMSK                                                     0xffffffff
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                  0xfc000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                        0x1a
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                             0x2000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                  0x19
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                               0x1000000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                    0x18
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                  0x800000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                      0x17
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                    0x400000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                        0x16
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CPH_TIMER_BMSK                                         0x3f0000
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_MEM_CPH_TIMER_SHFT                                             0x10
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_SLEEP_TIMER_BMSK                                             0xff00
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_SLEEP_TIMER_SHFT                                                0x8
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_WAKEUP_TIMER_BMSK                                              0xff
#define HWIO_GCC_AGGRE_NOC_QDSS_BAM_CFG_SREGR_WAKEUP_TIMER_SHFT                                               0x0

#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00072034)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072034)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072034)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_RMSK                                                     0x81d0700f
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                      0x1000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                           0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                    0x800000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                        0x17
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_DIS_BMSK                                               0x400000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_DIS_SHFT                                                   0x16
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                   0x100000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                       0x14
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                       0x4000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                          0xe
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                             0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                     0x2000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                        0xd
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                          0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                           0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                    0x1000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                       0xc
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                          0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_SW_ONLY_EN_BMSK                                                 0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_SW_ONLY_EN_SHFT                                                 0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ARES_BMSK                                                   0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ARES_SHFT                                                   0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ARES_RESET_FVAL                                             0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_HW_CTL_BMSK                                                     0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_HW_CTL_SHFT                                                     0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_HW_CTL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_HW_CTL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00072038)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072038)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072038)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_RMSK                                                     0xf1ffffe
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ATTR                                                           0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                           0xf000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                      0x100000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                          0x14
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                              0xf0000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                 0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                0x8000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                   0xf
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                            0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                 0x4000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                    0xe
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                    0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                 0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                0x2000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                   0xd
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                       0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                          0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                            0x1000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                               0xc
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                      0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                         0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                         0x800
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                           0xb
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                       0x400
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                         0xa
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                0x300
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                  0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                         0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                         0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                         0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                           0x80
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                            0x7
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_FORCE_CLK_ON_BMSK                                             0x40
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_FORCE_CLK_ON_SHFT                                              0x6
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                     0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                       0x20
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                        0x5
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL               0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL          0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SLP_STG_BMSK                                           0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SLP_STG_SHFT                                            0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                  0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                     0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                          0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                          0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                               0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                  0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                     0x4
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                     0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                         0x2
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                         0x1
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                   0x0
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                    0x1

#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007203c)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007203c)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007203c)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_RMSK                                                0xffffffff
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ATTR                                                       0x3
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                             0xfc000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                   0x1a
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                        0x2000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                             0x19
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                          0x1000000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                               0x18
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                             0x800000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                 0x17
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                               0x400000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                   0x16
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                    0x3f0000
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                        0x10
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                        0xff00
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                           0x8
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                         0xff
#define HWIO_GCC_AGGRE_NOC_CENTER_HS_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                          0x0

#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00072040)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072040)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072040)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_WEST_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00072044)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072044)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072044)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_RMSK                                                       0x81d00005
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ATTR                                                              0x3
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                     0x100000
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                         0x14
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00072048)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072048)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072048)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_EAST_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007204c)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007204c)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007204c)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_RMSK                                                       0x81d00005
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ATTR                                                              0x3
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                     0x100000
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                         0x14
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00072050)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072050)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072050)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_RMSK                                                      0x81d0000f
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ATTR                                                             0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                       0x1000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                            0x18
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                     0x800000
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                         0x17
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_DIS_BMSK                                                0x400000
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_DIS_SHFT                                                    0x16
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                    0x100000
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                        0x14
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_SW_ONLY_EN_BMSK                                                  0x8
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_SW_ONLY_EN_SHFT                                                  0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ARES_BMSK                                                    0x4
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ARES_SHFT                                                    0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                           0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ARES_RESET_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_HW_CTL_BMSK                                                      0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_HW_CTL_SHFT                                                      0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_HW_CTL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_HW_CTL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0001313c)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001313c)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001313c)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_RMSK                                                         0x81d00004
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ATTR                                                                0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_AXI_CBCR_CLK_ARES_RESET_FVAL                                                 0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00072054)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072054)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072054)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_RMSK                                                      0x81d00005
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ATTR                                                             0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_ALL_ARES_BMSK                                       0x1000000
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_ALL_ARES_SHFT                                            0x18
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                     0x800000
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                         0x17
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_DIS_BMSK                                                0x400000
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_DIS_SHFT                                                    0x16
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                    0x100000
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                        0x14
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ARES_BMSK                                                    0x4
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ARES_SHFT                                                    0x2
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ARES_NO_RESET_FVAL                                           0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ARES_RESET_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_CBCR_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00072058)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072058)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072058)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ATTR                                                                0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007205c)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007205c)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007205c)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_RMSK                                                      0x81d00005
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ATTR                                                             0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_ALL_ARES_BMSK                                       0x1000000
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_ALL_ARES_SHFT                                            0x18
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                     0x800000
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                         0x17
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_DIS_BMSK                                                0x400000
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_DIS_SHFT                                                    0x16
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                    0x100000
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                        0x14
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ARES_BMSK                                                    0x4
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ARES_SHFT                                                    0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ARES_NO_RESET_FVAL                                           0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ARES_RESET_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_CBCR_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000003c)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000003c)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000003c)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_RMSK                                                          0x81f0700e
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                         0x200000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                             0x15
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                            0x4000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                               0xe
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                          0x2000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                             0xd
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                               0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                         0x1000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                            0xc
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                               0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00000040)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000040)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000040)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_RMSK                                                          0xf1ffffe
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ATTR                                                                0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                0xf000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                     0x18
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                           0x100000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                               0x14
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                   0xf0000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                      0x10
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                     0x8000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                        0xf
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                 0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                      0x4000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                         0xe
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                         0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                      0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                     0x2000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                        0xd
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                            0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                               0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                 0x1000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                    0xc
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                           0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                              0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                              0x800
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                0xb
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                            0x400
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                              0xa
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                     0x300
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                       0x8
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                              0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                              0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                              0x2
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                              0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                0x80
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                 0x7
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_FORCE_CLK_ON_BMSK                                                  0x40
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_FORCE_CLK_ON_SHFT                                                   0x6
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                          0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                            0x20
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                             0x5
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                    0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL               0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                0x10
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                 0x4
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                       0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                          0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                               0x8
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                               0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                    0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                       0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                          0x4
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                          0x2
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                              0x2
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                              0x1
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                        0x0
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                         0x1

#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00000044)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000044)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000044)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_RMSK                                                     0xffffffff
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ADDR, HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_IN)
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                  0xfc000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                        0x1a
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                             0x2000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                  0x19
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                               0x1000000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                    0x18
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                  0x800000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                      0x17
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                    0x400000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                        0x16
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                         0x3f0000
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                             0x10
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                             0xff00
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                0x8
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                              0xff
#define HWIO_GCC_AGGRE_NOC_PCIE_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                               0x0

#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002908c)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002908c)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002908c)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_RMSK                                                         0x81c0000f
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ATTR                                                                0x3
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_AGGRE_USB3_PRIM_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000670e4)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670e4)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670e4)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_RMSK                                                           0x81c0000f
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ADDR, HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_RMSK)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IN)
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_AGGRE_UFS_PHY_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00079174)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079174)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079174)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_RMSK                                                               0x81d00005
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_IPA_CBCR_ADDR, HWIO_GCC_AGGRE_NOC_IPA_CBCR_RMSK)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_IPA_CBCR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_IPA_CBCR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_IPA_CBCR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_IPA_CBCR_IN)
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_AGGRE_NOC_IPA_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000002c)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000002c)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000002c)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_RMSK                                                            0x81d0000e
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ADDR, HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IN)
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_ANOC_PCIE_PWRCTL_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007207c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007207c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007207c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072080)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072080)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072080)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072084)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072084)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072084)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072088)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072088)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072088)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007208c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007208c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007208c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072090)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072090)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072090)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072094)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072094)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072094)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00072098)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072098)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072098)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007209c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007209c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007209c)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000720a0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720a0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720a0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720a4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720a4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720a4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000720b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000720b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000720b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00072060)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072060)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072060)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CMD_RCGR_ADDR, HWIO_GCC_AGGRE_NOC_CMD_RCGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CMD_RCGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CMD_RCGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CMD_RCGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CMD_RCGR_IN)
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_AGGRE_NOC_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00072064)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072064)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072064)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CFG_RCGR_ADDR, HWIO_GCC_AGGRE_NOC_CFG_RCGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_CFG_RCGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_CFG_RCGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_CFG_RCGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_CFG_RCGR_IN)
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_AGGRE_NOC_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721a8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF0_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721ac)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF1_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721b0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF2_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721b4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF3_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721b8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF4_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721bc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721bc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721bc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF5_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721c0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721c0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721c0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF6_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721c4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721c4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721c4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF7_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721c8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721c8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721c8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF8_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000721cc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721cc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721cc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_RMSK                                            0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ATTR                                              0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_BMSK                                    0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SHFT                                      0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                 0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                 0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                 0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                 0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_BMSK                                     0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_SHFT                                      0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                 0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                               0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                 0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                               0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                 0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                               0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                 0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                 0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                               0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                 0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                               0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                 0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                               0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                 0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                              0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                              0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV10_FVAL                               0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                             0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV11_FVAL                               0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                             0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV12_FVAL                               0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                             0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV13_FVAL                               0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                             0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV14_FVAL                               0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                             0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV15_FVAL                               0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                             0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF9_DFSR_SRC_DIV_DIV16_FVAL                               0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721d0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721d0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721d0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF10_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721d4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721d4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721d4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF11_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721d8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721d8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721d8)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF12_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721dc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721dc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721dc)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF13_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721e0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721e0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721e0)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF14_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000721e4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000721e4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000721e4)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_RMSK                                           0x71f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ATTR                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_BMSK                                   0x700
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SHFT                                     0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_BMSK                                    0x1f
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_SHFT                                     0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                0x1
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                              0x2
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                0x3
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                              0x4
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                0x5
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                              0x6
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                0x7
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                0x9
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                              0xa
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                0xb
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                              0xc
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                0xd
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                              0xe
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                0xf
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                             0x10
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV9_FVAL                               0x11
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                             0x12
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV10_FVAL                              0x13
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                            0x14
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV11_FVAL                              0x15
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                            0x16
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV12_FVAL                              0x17
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                            0x18
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV13_FVAL                              0x19
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                            0x1a
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV14_FVAL                              0x1b
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                            0x1c
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV15_FVAL                              0x1d
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                            0x1e
#define HWIO_GCC_RPMH_SYS_NOC_AGGRE_NOC_NORTH_SF_PERF15_DFSR_SRC_DIV_DIV16_FVAL                              0x1f

#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007218c)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007218c)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007218c)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_RMSK                                                      0x80000013
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ATTR                                                             0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_OFF_BMSK                                             0x80000000
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_OFF_SHFT                                                   0x1f
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                             0x10
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                              0x4
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_EN_BMSK                                                     0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_EN_SHFT                                                     0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                             0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                              0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_UPDATE_BMSK                                                      0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_UPDATE_SHFT                                                      0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_UPDATE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CMD_RCGR_UPDATE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00072190)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00072190)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00072190)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RMSK                                                        0x11071f
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ATTR                                                             0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_HW_CLK_CONTROL_BMSK                                         0x100000
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_HW_CLK_CONTROL_SHFT                                             0x14
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                      0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                       0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RCGLITE_DISABLE_BMSK                                         0x10000
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RCGLITE_DISABLE_SHFT                                            0x10
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                             0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                            0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_CFG_RCGR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000722b8)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722b8)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722b8)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_RMSK                                                                 0x1
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ATTR                                                                 0x3
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_AGGRE_NOC_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x000722bc)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722bc)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722bc)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_RMSK                                                            0x1
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_WEST_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x000722c0)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722c0)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722c0)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_RMSK                                                            0x1
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ATTR                                                            0x3
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_AGGRE_NOC_EAST_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x000722c4)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722c4)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722c4)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_RMSK                                                           0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ATTR                                                           0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000722c8)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722c8)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722c8)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_RMSK                                                        0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ATTR                                                        0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                             0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                             0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_HS_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x000722cc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722cc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722cc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_RMSK                                                           0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ATTR                                                           0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000722d0)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722d0)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722d0)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_RMSK                                                     0x1
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ATTR                                                     0x3
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                          0x1
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                          0x0
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_AGGRE_NOC_WEST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000722d4)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722d4)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722d4)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_RMSK                                                     0x1
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ATTR                                                     0x3
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                          0x1
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                          0x0
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_AGGRE_NOC_EAST_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000722d8)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722d8)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722d8)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_RMSK                                                    0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ATTR                                                    0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                         0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                         0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000722dc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722dc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722dc)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_RMSK                                                    0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ATTR                                                    0x3
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                         0x1
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                         0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_AGGRE_NOC_SOUTH_TUNNEL_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000722e0)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000722e0)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000722e0)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_RMSK                                                        0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ATTR                                                        0x3
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ADDR, HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                             0x1
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                             0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_AGGRE_NOC_NORTH_SF_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_TIC_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00011000)
#define HWIO_GCC_TIC_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00011000)
#define HWIO_GCC_TIC_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00011000)
#define HWIO_GCC_TIC_CBCR_RMSK                                                                         0x81c0000f
#define HWIO_GCC_TIC_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_TIC_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TIC_CBCR_ADDR, HWIO_GCC_TIC_CBCR_RMSK)
#define HWIO_GCC_TIC_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TIC_CBCR_ADDR, m)
#define HWIO_GCC_TIC_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TIC_CBCR_ADDR,v)
#define HWIO_GCC_TIC_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TIC_CBCR_ADDR,m,v,HWIO_GCC_TIC_CBCR_IN)
#define HWIO_GCC_TIC_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_TIC_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_TIC_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_TIC_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_TIC_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_TIC_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_TIC_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_TIC_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_TIC_CBCR_SW_ONLY_EN_BMSK                                                                     0x8
#define HWIO_GCC_TIC_CBCR_SW_ONLY_EN_SHFT                                                                     0x3
#define HWIO_GCC_TIC_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_TIC_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_TIC_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_TIC_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_TIC_CBCR_HW_CTL_BMSK                                                                         0x2
#define HWIO_GCC_TIC_CBCR_HW_CTL_SHFT                                                                         0x1
#define HWIO_GCC_TIC_CBCR_HW_CTL_DISABLE_FVAL                                                                 0x0
#define HWIO_GCC_TIC_CBCR_HW_CTL_ENABLE_FVAL                                                                  0x1
#define HWIO_GCC_TIC_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_TIC_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_TIC_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_TIC_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_TIC_CFG_QX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00011004)
#define HWIO_GCC_TIC_CFG_QX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00011004)
#define HWIO_GCC_TIC_CFG_QX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00011004)
#define HWIO_GCC_TIC_CFG_QX_CBCR_RMSK                                                                  0x81d0700f
#define HWIO_GCC_TIC_CFG_QX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_TIC_CFG_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_CBCR_ADDR, HWIO_GCC_TIC_CFG_QX_CBCR_RMSK)
#define HWIO_GCC_TIC_CFG_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_CBCR_ADDR, m)
#define HWIO_GCC_TIC_CFG_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TIC_CFG_QX_CBCR_ADDR,v)
#define HWIO_GCC_TIC_CFG_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TIC_CFG_QX_CBCR_ADDR,m,v,HWIO_GCC_TIC_CFG_QX_CBCR_IN)
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_TIC_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_TIC_CFG_QX_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_TIC_CFG_QX_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TIC_CFG_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_TIC_CFG_QX_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00011008)
#define HWIO_GCC_TIC_CFG_QX_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00011008)
#define HWIO_GCC_TIC_CFG_QX_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00011008)
#define HWIO_GCC_TIC_CFG_QX_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_TIC_CFG_QX_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_TIC_CFG_QX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_SREGR_ADDR, HWIO_GCC_TIC_CFG_QX_SREGR_RMSK)
#define HWIO_GCC_TIC_CFG_QX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_SREGR_ADDR, m)
#define HWIO_GCC_TIC_CFG_QX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_TIC_CFG_QX_SREGR_ADDR,v)
#define HWIO_GCC_TIC_CFG_QX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TIC_CFG_QX_SREGR_ADDR,m,v,HWIO_GCC_TIC_CFG_QX_SREGR_IN)
#define HWIO_GCC_TIC_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_TIC_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_TIC_CFG_QX_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_TIC_CFG_QX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_TIC_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_TIC_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_TIC_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_TIC_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_TIC_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_TIC_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_TIC_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_TIC_CFG_QX_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_TIC_CFG_QX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_TIC_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0001100c)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001100c)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001100c)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ADDR, HWIO_GCC_TIC_CFG_QX_CFG_SREGR_RMSK)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TIC_CFG_QX_CFG_SREGR_ADDR,m,v,HWIO_GCC_TIC_CFG_QX_CFG_SREGR_IN)
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_TIC_CFG_QX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_IMEM_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000b000)
#define HWIO_GCC_IMEM_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000b000)
#define HWIO_GCC_IMEM_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000b000)
#define HWIO_GCC_IMEM_BCR_RMSK                                                                                0x1
#define HWIO_GCC_IMEM_BCR_ATTR                                                                                0x3
#define HWIO_GCC_IMEM_BCR_IN          \
        in_dword_masked(HWIO_GCC_IMEM_BCR_ADDR, HWIO_GCC_IMEM_BCR_RMSK)
#define HWIO_GCC_IMEM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IMEM_BCR_ADDR, m)
#define HWIO_GCC_IMEM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_IMEM_BCR_ADDR,v)
#define HWIO_GCC_IMEM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IMEM_BCR_ADDR,m,v,HWIO_GCC_IMEM_BCR_IN)
#define HWIO_GCC_IMEM_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_IMEM_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_IMEM_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_IMEM_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_IMEM_CFG_QX_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000b004)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000b004)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000b004)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_RMSK                                                                 0x81d07005
#define HWIO_GCC_IMEM_CFG_QX_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_CBCR_ADDR, HWIO_GCC_IMEM_CFG_QX_CBCR_RMSK)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_CBCR_ADDR, m)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IMEM_CFG_QX_CBCR_ADDR,v)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IMEM_CFG_QX_CBCR_ADDR,m,v,HWIO_GCC_IMEM_CFG_QX_CBCR_IN)
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_IMEM_CFG_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_IMEM_CFG_QX_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000b008)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000b008)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000b008)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_IMEM_CFG_QX_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_IMEM_CFG_QX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_SREGR_ADDR, HWIO_GCC_IMEM_CFG_QX_SREGR_RMSK)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_SREGR_ADDR, m)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IMEM_CFG_QX_SREGR_ADDR,v)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IMEM_CFG_QX_SREGR_ADDR,m,v,HWIO_GCC_IMEM_CFG_QX_SREGR_IN)
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_IMEM_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_IMEM_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_IMEM_CFG_QX_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_IMEM_CFG_QX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_IMEM_CFG_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000b00c)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000b00c)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000b00c)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ADDR, HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_RMSK)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_ADDR,m,v,HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_IN)
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_IMEM_CFG_QX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_IMEM_CFG_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000b010)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000b010)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000b010)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_RMSK                                                                0x81d00005
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IMEM_CFG_AHB_CBCR_ADDR, HWIO_GCC_IMEM_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IMEM_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IMEM_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IMEM_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_IMEM_CFG_AHB_CBCR_IN)
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_IMEM_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_MMU_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00073000)
#define HWIO_GCC_MMU_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073000)
#define HWIO_GCC_MMU_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073000)
#define HWIO_GCC_MMU_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_MMU_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_MMU_BCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_BCR_ADDR, HWIO_GCC_MMU_BCR_RMSK)
#define HWIO_GCC_MMU_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_BCR_ADDR, m)
#define HWIO_GCC_MMU_BCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_BCR_ADDR,v)
#define HWIO_GCC_MMU_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_BCR_ADDR,m,v,HWIO_GCC_MMU_BCR_IN)
#define HWIO_GCC_MMU_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_MMU_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_MMU_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_MMU_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_MMU_GDSCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00073004)
#define HWIO_GCC_MMU_GDSCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073004)
#define HWIO_GCC_MMU_GDSCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073004)
#define HWIO_GCC_MMU_GDSCR_RMSK                                                                        0xf8ffffff
#define HWIO_GCC_MMU_GDSCR_ATTR                                                                               0x3
#define HWIO_GCC_MMU_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_GDSCR_ADDR, HWIO_GCC_MMU_GDSCR_RMSK)
#define HWIO_GCC_MMU_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_GDSCR_ADDR, m)
#define HWIO_GCC_MMU_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_GDSCR_ADDR,v)
#define HWIO_GCC_MMU_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_GDSCR_ADDR,m,v,HWIO_GCC_MMU_GDSCR_IN)
#define HWIO_GCC_MMU_GDSCR_PWR_ON_BMSK                                                                 0x80000000
#define HWIO_GCC_MMU_GDSCR_PWR_ON_SHFT                                                                       0x1f
#define HWIO_GCC_MMU_GDSCR_GDSC_STATE_BMSK                                                             0x78000000
#define HWIO_GCC_MMU_GDSCR_GDSC_STATE_SHFT                                                                   0x1b
#define HWIO_GCC_MMU_GDSCR_EN_REST_WAIT_BMSK                                                             0xf00000
#define HWIO_GCC_MMU_GDSCR_EN_REST_WAIT_SHFT                                                                 0x14
#define HWIO_GCC_MMU_GDSCR_EN_FEW_WAIT_BMSK                                                               0xf0000
#define HWIO_GCC_MMU_GDSCR_EN_FEW_WAIT_SHFT                                                                  0x10
#define HWIO_GCC_MMU_GDSCR_CLK_DIS_WAIT_BMSK                                                               0xf000
#define HWIO_GCC_MMU_GDSCR_CLK_DIS_WAIT_SHFT                                                                  0xc
#define HWIO_GCC_MMU_GDSCR_RETAIN_FF_ENABLE_BMSK                                                            0x800
#define HWIO_GCC_MMU_GDSCR_RETAIN_FF_ENABLE_SHFT                                                              0xb
#define HWIO_GCC_MMU_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_MMU_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_MMU_GDSCR_RESTORE_BMSK                                                                     0x400
#define HWIO_GCC_MMU_GDSCR_RESTORE_SHFT                                                                       0xa
#define HWIO_GCC_MMU_GDSCR_RESTORE_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_MMU_GDSCR_RESTORE_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_MMU_GDSCR_SAVE_BMSK                                                                        0x200
#define HWIO_GCC_MMU_GDSCR_SAVE_SHFT                                                                          0x9
#define HWIO_GCC_MMU_GDSCR_SAVE_DISABLE_FVAL                                                                  0x0
#define HWIO_GCC_MMU_GDSCR_SAVE_ENABLE_FVAL                                                                   0x1
#define HWIO_GCC_MMU_GDSCR_RETAIN_BMSK                                                                      0x100
#define HWIO_GCC_MMU_GDSCR_RETAIN_SHFT                                                                        0x8
#define HWIO_GCC_MMU_GDSCR_RETAIN_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_MMU_GDSCR_RETAIN_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_MMU_GDSCR_EN_REST_BMSK                                                                      0x80
#define HWIO_GCC_MMU_GDSCR_EN_REST_SHFT                                                                       0x7
#define HWIO_GCC_MMU_GDSCR_EN_REST_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_MMU_GDSCR_EN_REST_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_MMU_GDSCR_EN_FEW_BMSK                                                                       0x40
#define HWIO_GCC_MMU_GDSCR_EN_FEW_SHFT                                                                        0x6
#define HWIO_GCC_MMU_GDSCR_EN_FEW_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_MMU_GDSCR_EN_FEW_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_MMU_GDSCR_CLAMP_IO_BMSK                                                                     0x20
#define HWIO_GCC_MMU_GDSCR_CLAMP_IO_SHFT                                                                      0x5
#define HWIO_GCC_MMU_GDSCR_CLAMP_IO_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MMU_GDSCR_CLAMP_IO_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MMU_GDSCR_CLK_DISABLE_BMSK                                                                  0x10
#define HWIO_GCC_MMU_GDSCR_CLK_DISABLE_SHFT                                                                   0x4
#define HWIO_GCC_MMU_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MMU_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                    0x1
#define HWIO_GCC_MMU_GDSCR_PD_ARES_BMSK                                                                       0x8
#define HWIO_GCC_MMU_GDSCR_PD_ARES_SHFT                                                                       0x3
#define HWIO_GCC_MMU_GDSCR_PD_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_MMU_GDSCR_PD_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_MMU_GDSCR_SW_OVERRIDE_BMSK                                                                   0x4
#define HWIO_GCC_MMU_GDSCR_SW_OVERRIDE_SHFT                                                                   0x2
#define HWIO_GCC_MMU_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MMU_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_MMU_GDSCR_HW_CONTROL_BMSK                                                                    0x2
#define HWIO_GCC_MMU_GDSCR_HW_CONTROL_SHFT                                                                    0x1
#define HWIO_GCC_MMU_GDSCR_HW_CONTROL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_MMU_GDSCR_HW_CONTROL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_MMU_GDSCR_SW_COLLAPSE_BMSK                                                                   0x1
#define HWIO_GCC_MMU_GDSCR_SW_COLLAPSE_SHFT                                                                   0x0
#define HWIO_GCC_MMU_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MMU_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_MMU_CFG_GDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073008)
#define HWIO_GCC_MMU_CFG_GDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073008)
#define HWIO_GCC_MMU_CFG_GDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073008)
#define HWIO_GCC_MMU_CFG_GDSCR_RMSK                                                                     0x7ffffff
#define HWIO_GCC_MMU_CFG_GDSCR_ATTR                                                                           0x3
#define HWIO_GCC_MMU_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_CFG_GDSCR_ADDR, HWIO_GCC_MMU_CFG_GDSCR_RMSK)
#define HWIO_GCC_MMU_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_MMU_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_MMU_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_CFG_GDSCR_ADDR,m,v,HWIO_GCC_MMU_CFG_GDSCR_IN)
#define HWIO_GCC_MMU_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4000000
#define HWIO_GCC_MMU_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                               0x1a
#define HWIO_GCC_MMU_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MMU_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                                  0x2000000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                       0x19
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                                   0x1000000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                        0x18
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                            0xf00000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                                0x14
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                               0x80000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                                  0x13
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                                   0x40000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                      0x12
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                                   0x20000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                      0x11
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                                0x10000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                                   0x10
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                               0x8000
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                                  0xf
#define HWIO_GCC_MMU_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                              0x7800
#define HWIO_GCC_MMU_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                                 0xb
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                      0x400
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                        0xa
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                               0x200
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                                 0x9
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                               0x100
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                                 0x8
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                                   0x80
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                    0x7
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                          0x60
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                           0x5
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                    0x10
#define HWIO_GCC_MMU_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                     0x4
#define HWIO_GCC_MMU_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                              0x8
#define HWIO_GCC_MMU_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                              0x3
#define HWIO_GCC_MMU_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                            0x4
#define HWIO_GCC_MMU_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                            0x2
#define HWIO_GCC_MMU_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                                0x2
#define HWIO_GCC_MMU_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                                0x1
#define HWIO_GCC_MMU_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                             0x1
#define HWIO_GCC_MMU_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                             0x0

#define HWIO_GCC_MMU_CFG2_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0007300c)
#define HWIO_GCC_MMU_CFG2_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007300c)
#define HWIO_GCC_MMU_CFG2_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007300c)
#define HWIO_GCC_MMU_CFG2_GDSCR_RMSK                                                                      0x7ffff
#define HWIO_GCC_MMU_CFG2_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_MMU_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_CFG2_GDSCR_ADDR, HWIO_GCC_MMU_CFG2_GDSCR_RMSK)
#define HWIO_GCC_MMU_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_MMU_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_MMU_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_MMU_CFG2_GDSCR_IN)
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                          0x40000
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                             0x12
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                      0x20000
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                         0x11
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                    0x10000
#define HWIO_GCC_MMU_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                       0x10
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                        0xf000
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                           0xc
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                                 0xf00
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                                   0x8
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                    0xf0
#define HWIO_GCC_MMU_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                     0x4
#define HWIO_GCC_MMU_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                      0xf
#define HWIO_GCC_MMU_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                      0x0

#define HWIO_GCC_MMU_CFG3_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00073010)
#define HWIO_GCC_MMU_CFG3_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073010)
#define HWIO_GCC_MMU_CFG3_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073010)
#define HWIO_GCC_MMU_CFG3_GDSCR_RMSK                                                                    0x7ffffff
#define HWIO_GCC_MMU_CFG3_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_MMU_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_CFG3_GDSCR_ADDR, HWIO_GCC_MMU_CFG3_GDSCR_RMSK)
#define HWIO_GCC_MMU_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_MMU_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_MMU_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_MMU_CFG3_GDSCR_IN)
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                                  0x4000000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                       0x1a
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                               0x2000000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                    0x19
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                          0x1e00000
#define HWIO_GCC_MMU_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                               0x15
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                           0x100000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                               0x14
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                                  0x80000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                     0x13
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                              0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                               0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                      0x40000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                         0x12
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                                   0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                       0x20000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                          0x11
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                    0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                            0x10000
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                               0x10
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                    0xff00
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                       0x8
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                     0xff
#define HWIO_GCC_MMU_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                      0x0

#define HWIO_GCC_MMU_CFG4_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00073014)
#define HWIO_GCC_MMU_CFG4_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073014)
#define HWIO_GCC_MMU_CFG4_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073014)
#define HWIO_GCC_MMU_CFG4_GDSCR_RMSK                                                                     0xffffff
#define HWIO_GCC_MMU_CFG4_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_MMU_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_CFG4_GDSCR_ADDR, HWIO_GCC_MMU_CFG4_GDSCR_RMSK)
#define HWIO_GCC_MMU_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_MMU_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_MMU_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_MMU_CFG4_GDSCR_IN)
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                       0xf00000
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                           0x14
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                        0xf0000
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                           0x10
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                        0xf000
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                           0xc
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                       0xf00
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                         0x8
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                             0xf0
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                              0x4
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                             0xf
#define HWIO_GCC_MMU_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                             0x0

#define HWIO_GCC_TCU_CFG_QX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00073018)
#define HWIO_GCC_TCU_CFG_QX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073018)
#define HWIO_GCC_TCU_CFG_QX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073018)
#define HWIO_GCC_TCU_CFG_QX_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_TCU_CFG_QX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_TCU_CFG_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_CFG_QX_CBCR_ADDR, HWIO_GCC_TCU_CFG_QX_CBCR_RMSK)
#define HWIO_GCC_TCU_CFG_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_CFG_QX_CBCR_ADDR, m)
#define HWIO_GCC_TCU_CFG_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_CFG_QX_CBCR_ADDR,v)
#define HWIO_GCC_TCU_CFG_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_CFG_QX_CBCR_ADDR,m,v,HWIO_GCC_TCU_CFG_QX_CBCR_IN)
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_TCU_CFG_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_TCU_CFG_QX_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_TCU_CFG_QX_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_TCU_CFG_QX_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_TCU_CFG_QX_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_TCU_CFG_QX_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_TCU_CFG_QX_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TCU_CFG_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_MMU_TCU_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007301c)
#define HWIO_GCC_MMU_TCU_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007301c)
#define HWIO_GCC_MMU_TCU_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007301c)
#define HWIO_GCC_MMU_TCU_CBCR_RMSK                                                                     0x81f0700f
#define HWIO_GCC_MMU_TCU_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_MMU_TCU_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_CBCR_ADDR, HWIO_GCC_MMU_TCU_CBCR_RMSK)
#define HWIO_GCC_MMU_TCU_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_CBCR_ADDR, m)
#define HWIO_GCC_MMU_TCU_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_CBCR_ADDR,v)
#define HWIO_GCC_MMU_TCU_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_CBCR_ADDR,m,v,HWIO_GCC_MMU_TCU_CBCR_IN)
#define HWIO_GCC_MMU_TCU_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_MMU_TCU_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_MMU_TCU_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_MMU_TCU_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                    0x200000
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                        0x15
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_MMU_TCU_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_CORE_ON_BMSK                                                       0x4000
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_CORE_ON_SHFT                                                          0xe
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                     0x2000
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                        0xd
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                    0x1000
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                       0xc
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_MMU_TCU_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_MMU_TCU_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_MMU_TCU_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_MMU_TCU_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_MMU_TCU_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_MMU_TCU_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_MMU_TCU_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMU_TCU_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_MMU_TCU_SREGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073020)
#define HWIO_GCC_MMU_TCU_SREGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073020)
#define HWIO_GCC_MMU_TCU_SREGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073020)
#define HWIO_GCC_MMU_TCU_SREGR_RMSK                                                                     0xf1ffffe
#define HWIO_GCC_MMU_TCU_SREGR_ATTR                                                                           0x3
#define HWIO_GCC_MMU_TCU_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_SREGR_ADDR, HWIO_GCC_MMU_TCU_SREGR_RMSK)
#define HWIO_GCC_MMU_TCU_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_SREGR_ADDR, m)
#define HWIO_GCC_MMU_TCU_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_SREGR_ADDR,v)
#define HWIO_GCC_MMU_TCU_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_SREGR_ADDR,m,v,HWIO_GCC_MMU_TCU_SREGR_IN)
#define HWIO_GCC_MMU_TCU_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                           0xf000000
#define HWIO_GCC_MMU_TCU_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                                0x18
#define HWIO_GCC_MMU_TCU_SREGR_PWR_FSM_CLK_SEL_BMSK                                                      0x100000
#define HWIO_GCC_MMU_TCU_SREGR_PWR_FSM_CLK_SEL_SHFT                                                          0x14
#define HWIO_GCC_MMU_TCU_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                              0xf0000
#define HWIO_GCC_MMU_TCU_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                 0x10
#define HWIO_GCC_MMU_TCU_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                                0x8000
#define HWIO_GCC_MMU_TCU_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                   0xf
#define HWIO_GCC_MMU_TCU_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                         0x0
#define HWIO_GCC_MMU_TCU_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                            0x1
#define HWIO_GCC_MMU_TCU_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                 0x4000
#define HWIO_GCC_MMU_TCU_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                    0xe
#define HWIO_GCC_MMU_TCU_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                    0x0
#define HWIO_GCC_MMU_TCU_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                 0x1
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                                0x2000
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                   0xd
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                       0x0
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                          0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                            0x1000
#define HWIO_GCC_MMU_TCU_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                               0xc
#define HWIO_GCC_MMU_TCU_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                      0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                         0x1
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CORE_ON_ACK_BMSK                                                         0x800
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CORE_ON_ACK_SHFT                                                           0xb
#define HWIO_GCC_MMU_TCU_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                       0x400
#define HWIO_GCC_MMU_TCU_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                         0xa
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                                0x300
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                  0x8
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                         0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                         0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                         0x2
#define HWIO_GCC_MMU_TCU_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                         0x3
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_ENABLE_BMSK                                                           0x80
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_ENABLE_SHFT                                                            0x7
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MMU_TCU_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_MMU_TCU_SREGR_FORCE_CLK_ON_BMSK                                                             0x40
#define HWIO_GCC_MMU_TCU_SREGR_FORCE_CLK_ON_SHFT                                                              0x6
#define HWIO_GCC_MMU_TCU_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                     0x0
#define HWIO_GCC_MMU_TCU_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                       0x20
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                        0x5
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                               0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                          0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SLP_STG_BMSK                                                           0x10
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SLP_STG_SHFT                                                            0x4
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                  0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                     0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                          0x8
#define HWIO_GCC_MMU_TCU_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                          0x3
#define HWIO_GCC_MMU_TCU_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                               0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                  0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                     0x4
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                     0x2
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                 0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                         0x2
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                         0x1
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MMU_TCU_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                    0x1

#define HWIO_GCC_MMU_TCU_CFG_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00073024)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073024)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073024)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_RMSK                                                                0xffffffff
#define HWIO_GCC_MMU_TCU_CFG_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_MMU_TCU_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_CFG_SREGR_ADDR, HWIO_GCC_MMU_TCU_CFG_SREGR_RMSK)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_CFG_SREGR_ADDR, m)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_CFG_SREGR_ADDR,v)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_CFG_SREGR_ADDR,m,v,HWIO_GCC_MMU_TCU_CFG_SREGR_IN)
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                             0xfc000000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                   0x1a
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                        0x2000000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                             0x19
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                          0x1000000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                               0x18
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                             0x800000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                 0x17
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                               0x400000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                   0x16
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                    0x3f0000
#define HWIO_GCC_MMU_TCU_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                        0x10
#define HWIO_GCC_MMU_TCU_CFG_SREGR_SLEEP_TIMER_BMSK                                                        0xff00
#define HWIO_GCC_MMU_TCU_CFG_SREGR_SLEEP_TIMER_SHFT                                                           0x8
#define HWIO_GCC_MMU_TCU_CFG_SREGR_WAKEUP_TIMER_BMSK                                                         0xff
#define HWIO_GCC_MMU_TCU_CFG_SREGR_WAKEUP_TIMER_SHFT                                                          0x0

#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0007303c)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007303c)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007303c)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_RMSK                                                                0x3ffffff
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_ATTR                                                                      0x3
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CMD_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_RCG_SW_CTRL_BMSK                                                    0x3ff8000
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_RCG_SW_CTRL_SHFT                                                          0xf
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_SW_PERF_STATE_BMSK                                                     0x7800
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_SW_PERF_STATE_SHFT                                                        0xb
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_SW_OVERRIDE_BMSK                                                        0x400
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_SW_OVERRIDE_SHFT                                                          0xa
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                           0x200
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                             0x9
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_FSM_STATE_BMSK                                                      0x1c0
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_FSM_STATE_SHFT                                                        0x6
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                      0x20
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                       0x5
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_CURR_PERF_STATE_BMSK                                                     0x1e
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_CURR_PERF_STATE_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_EN_BMSK                                                               0x1
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_EN_SHFT                                                               0x0
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RPMH_SHUB_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073044)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073044)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073044)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073048)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073048)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073048)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007304c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007304c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007304c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073050)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073050)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073050)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073054)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073054)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073054)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073058)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073058)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073058)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007305c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007305c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007305c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073060)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073060)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073060)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073064)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073064)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073064)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00073068)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073068)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073068)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007306c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007306c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007306c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073070)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073070)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073070)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073074)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073074)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073074)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073078)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073078)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073078)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007307c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007307c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007307c)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00073080)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073080)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073080)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_SHUB_MMU_TCU_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_MMU_TCU_CMD_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00073028)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073028)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073028)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_RMSK                                                                 0x80000013
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_MMU_TCU_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_CMD_RCGR_ADDR, HWIO_GCC_MMU_TCU_CMD_RCGR_RMSK)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_CMD_RCGR_ADDR,m,v,HWIO_GCC_MMU_TCU_CMD_RCGR_IN)
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_OFF_SHFT                                                              0x1f
#define HWIO_GCC_MMU_TCU_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                        0x10
#define HWIO_GCC_MMU_TCU_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                         0x4
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_EN_BMSK                                                                0x2
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_EN_SHFT                                                                0x1
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MMU_TCU_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_MMU_TCU_CMD_RCGR_UPDATE_BMSK                                                                 0x1
#define HWIO_GCC_MMU_TCU_CMD_RCGR_UPDATE_SHFT                                                                 0x0
#define HWIO_GCC_MMU_TCU_CMD_RCGR_UPDATE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMU_TCU_CMD_RCGR_UPDATE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_MMU_TCU_CFG_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007302c)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007302c)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007302c)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_RMSK                                                                   0x11071f
#define HWIO_GCC_MMU_TCU_CFG_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_MMU_TCU_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_CFG_RCGR_ADDR, HWIO_GCC_MMU_TCU_CFG_RCGR_RMSK)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_CFG_RCGR_ADDR,m,v,HWIO_GCC_MMU_TCU_CFG_RCGR_IN)
#define HWIO_GCC_MMU_TCU_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                    0x100000
#define HWIO_GCC_MMU_TCU_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                        0x14
#define HWIO_GCC_MMU_TCU_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MMU_TCU_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_MMU_TCU_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                    0x10000
#define HWIO_GCC_MMU_TCU_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                       0x10
#define HWIO_GCC_MMU_TCU_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                        0x0
#define HWIO_GCC_MMU_TCU_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                       0x1
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_BMSK                                                              0x700
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SHFT                                                                0x8
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                           0x0
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                           0x1
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                           0x2
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                           0x3
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                           0x4
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                           0x5
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                           0x6
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                           0x7
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_BMSK                                                               0x1f
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_SHFT                                                                0x0
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                           0x1
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                         0x2
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                           0x3
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                         0x4
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                           0x5
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                         0x6
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                           0x7
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                         0x8
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                           0x9
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                         0xa
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                           0xb
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                         0xc
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                           0xd
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                         0xe
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                           0xf
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                        0x10
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                          0x11
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                        0x12
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                         0x13
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                       0x14
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                         0x15
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                       0x16
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                         0x17
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                       0x18
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                         0x19
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                       0x1a
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                         0x1b
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                       0x1c
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                         0x1d
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                       0x1e
#define HWIO_GCC_MMU_TCU_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                         0x1f

#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00073154)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073154)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073154)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_RMSK                                                                   0x1
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ATTR                                                                   0x3
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MMU_TCU_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00073158)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073158)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073158)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_ANOC_QTB1_CBCR_ADDR, HWIO_GCC_TCU_ANOC_QTB1_CBCR_RMSK)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_ANOC_QTB1_CBCR_ADDR, m)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_ANOC_QTB1_CBCR_ADDR,v)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_ANOC_QTB1_CBCR_ADDR,m,v,HWIO_GCC_TCU_ANOC_QTB1_CBCR_IN)
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TCU_ANOC_QTB1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0007315c)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007315c)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007315c)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_ANOC_QTB2_CBCR_ADDR, HWIO_GCC_TCU_ANOC_QTB2_CBCR_RMSK)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_ANOC_QTB2_CBCR_ADDR, m)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_ANOC_QTB2_CBCR_ADDR,v)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_ANOC_QTB2_CBCR_ADDR,m,v,HWIO_GCC_TCU_ANOC_QTB2_CBCR_IN)
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TCU_ANOC_QTB2_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00073160)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073160)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073160)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_RMSK                                                            0x81d0000f
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ADDR, HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_RMSK)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ADDR, m)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ADDR,v)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_ADDR,m,v,HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IN)
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TCU_MMNOC_QTB_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00073164)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073164)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073164)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ADDR, HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_RMSK)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ADDR, m)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ADDR,v)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_ADDR,m,v,HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IN)
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF01_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00073168)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073168)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073168)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ADDR, HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_RMSK)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ADDR, m)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ADDR,v)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_ADDR,m,v,HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IN)
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TCU_MMNOC_QTB_HF23_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00073180)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073180)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073180)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_RMSK                                                                 0x1ffff
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ATTR                                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_RCG_SW_CTRL_BMSK                                                     0x18000
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_RCG_SW_CTRL_SHFT                                                         0xf
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_SW_PERF_STATE_BMSK                                                    0x7800
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_SW_PERF_STATE_SHFT                                                       0xb
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_SW_OVERRIDE_BMSK                                                       0x400
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_SW_OVERRIDE_SHFT                                                         0xa
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                          0x200
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                            0x9
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_FSM_STATE_BMSK                                                     0x1c0
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_FSM_STATE_SHFT                                                       0x6
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                     0x20
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                      0x5
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_CURR_PERF_STATE_BMSK                                                    0x1e
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_CURR_PERF_STATE_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_EN_BMSK                                                              0x1
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_EN_SHFT                                                              0x0
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RPMH_MMNOC_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00073188)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073188)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073188)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007318c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007318c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007318c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00073190)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073190)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073190)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00073194)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073194)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073194)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00073198)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073198)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073198)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007319c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007319c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007319c)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000731a0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731a0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731a0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000731a4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731a4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731a4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000731a8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731a8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731a8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000731ac)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731ac)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731ac)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731b0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731b0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731b0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731b4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731b4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731b4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000731c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000731c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000731c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_HF_QX_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007316c)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007316c)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007316c)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_RMSK                                                             0x80000013
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ADDR, HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_IN)
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_OFF_SHFT                                                          0x1f
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                    0x10
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                     0x4
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_EN_BMSK                                                            0x2
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_EN_SHFT                                                            0x1
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_UPDATE_BMSK                                                             0x1
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_UPDATE_SHFT                                                             0x0
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00073170)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073170)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073170)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RMSK                                                               0x11071f
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ADDR, HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_IN)
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                0x100000
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                    0x14
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                0x10000
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                   0x10
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                    0x0
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                   0x1
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_BMSK                                                          0x700
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SHFT                                                            0x8
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                       0x0
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                       0x1
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                       0x2
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                       0x3
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                       0x4
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                       0x5
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                       0x6
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                       0x7
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_BMSK                                                           0x1f
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_SHFT                                                            0x0
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                       0x1
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                     0x2
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                       0x3
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                     0x4
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                       0x5
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                     0x6
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                       0x7
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                     0x8
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                       0x9
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                     0xa
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                       0xb
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                     0xc
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                       0xd
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                     0xe
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                       0xf
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                    0x10
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                      0x11
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                    0x12
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                     0x13
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                   0x14
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                     0x15
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                   0x16
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                     0x17
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                   0x18
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                     0x19
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                   0x1a
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                     0x1b
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                   0x1c
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                     0x1d
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                   0x1e
#define HWIO_GCC_MMNOC_HF_QX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                     0x1f

#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00073298)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00073298)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00073298)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_RMSK                                                               0x1
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ATTR                                                               0x3
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MMNOC_HF_QX_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732b8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732bc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732c0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732c4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732c8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732c8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732c8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732cc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732cc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732cc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732d0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732d0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732d0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732d4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732d4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732d4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732d8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732d8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732d8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000732dc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732dc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732dc)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732e0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732e0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732e0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732e4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732e4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732e4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732e8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732e8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732e8)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732ec)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732ec)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732ec)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732f0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732f0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732f0)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000732f4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732f4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732f4)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_MMNOC_MMNOC_SF_QX_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007329c)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007329c)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007329c)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_RMSK                                                             0x80000013
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ADDR, HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_RMSK)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ADDR,m,v,HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_IN)
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_OFF_SHFT                                                          0x1f
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                    0x10
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                     0x4
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_EN_BMSK                                                            0x2
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_EN_SHFT                                                            0x1
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_UPDATE_BMSK                                                             0x1
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_UPDATE_SHFT                                                             0x0
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_SF_QX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000732a0)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000732a0)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000732a0)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RMSK                                                               0x11071f
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ADDR, HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RMSK)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_ADDR,m,v,HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_IN)
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                0x100000
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                    0x14
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                0x10000
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                   0x10
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                    0x0
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                   0x1
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_BMSK                                                          0x700
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SHFT                                                            0x8
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                       0x0
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                       0x1
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                       0x2
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                       0x3
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                       0x4
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                       0x5
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                       0x6
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                       0x7
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_BMSK                                                           0x1f
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_SHFT                                                            0x0
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                       0x1
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                     0x2
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                       0x3
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                     0x4
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                       0x5
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                     0x6
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                       0x7
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                     0x8
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                       0x9
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                     0xa
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                       0xb
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                     0xc
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                       0xd
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                     0xe
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                       0xf
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                    0x10
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                      0x11
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                    0x12
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                     0x13
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                   0x14
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                     0x15
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                   0x16
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                     0x17
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                   0x18
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                     0x19
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                   0x1a
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                     0x1b
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                   0x1c
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                     0x1d
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                   0x1e
#define HWIO_GCC_MMNOC_SF_QX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                     0x1f

#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000733c8)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000733c8)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000733c8)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_RMSK                                                               0x1
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ATTR                                                               0x3
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MMNOC_SF_QX_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00000048)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000048)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000048)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_RMSK                                                           0x81d0000e
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ADDR, HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_RMSK)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ADDR, m)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ADDR,v)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_ADDR,m,v,HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IN)
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TCU_ANOC_PCIE_QTB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d038)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d038)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d038)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ADDR, HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_RMSK)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ADDR, m)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ADDR,v)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_ADDR,m,v,HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IN)
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TCU_TURING_Q6_QTB0_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00089038)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089038)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089038)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ATTR                                                                0x3
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ADDR, HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_RMSK)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ADDR, m)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ADDR,v)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_ADDR,m,v,HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IN)
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_TCU_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_ANOC_PCIE_BCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00000000)
#define HWIO_GCC_ANOC_PCIE_BCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000000)
#define HWIO_GCC_ANOC_PCIE_BCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000000)
#define HWIO_GCC_ANOC_PCIE_BCR_RMSK                                                                           0x1
#define HWIO_GCC_ANOC_PCIE_BCR_ATTR                                                                           0x3
#define HWIO_GCC_ANOC_PCIE_BCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_BCR_ADDR, HWIO_GCC_ANOC_PCIE_BCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_BCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_BCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_BCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_BCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_BCR_IN)
#define HWIO_GCC_ANOC_PCIE_BCR_BLK_ARES_BMSK                                                                  0x1
#define HWIO_GCC_ANOC_PCIE_BCR_BLK_ARES_SHFT                                                                  0x0
#define HWIO_GCC_ANOC_PCIE_BCR_BLK_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_ANOC_PCIE_BCR_BLK_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_ANOC_PCIE_GDSCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00000004)
#define HWIO_GCC_ANOC_PCIE_GDSCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000004)
#define HWIO_GCC_ANOC_PCIE_GDSCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000004)
#define HWIO_GCC_ANOC_PCIE_GDSCR_RMSK                                                                  0xf8ffffff
#define HWIO_GCC_ANOC_PCIE_GDSCR_ATTR                                                                         0x3
#define HWIO_GCC_ANOC_PCIE_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDSCR_ADDR, HWIO_GCC_ANOC_PCIE_GDSCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDSCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDSCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDSCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDSCR_IN)
#define HWIO_GCC_ANOC_PCIE_GDSCR_PWR_ON_BMSK                                                           0x80000000
#define HWIO_GCC_ANOC_PCIE_GDSCR_PWR_ON_SHFT                                                                 0x1f
#define HWIO_GCC_ANOC_PCIE_GDSCR_GDSC_STATE_BMSK                                                       0x78000000
#define HWIO_GCC_ANOC_PCIE_GDSCR_GDSC_STATE_SHFT                                                             0x1b
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_WAIT_BMSK                                                       0xf00000
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_WAIT_SHFT                                                           0x14
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_WAIT_BMSK                                                         0xf0000
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_WAIT_SHFT                                                            0x10
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DIS_WAIT_BMSK                                                         0xf000
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DIS_WAIT_SHFT                                                            0xc
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x800
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_FF_ENABLE_SHFT                                                        0xb
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_RESTORE_BMSK                                                               0x400
#define HWIO_GCC_ANOC_PCIE_GDSCR_RESTORE_SHFT                                                                 0xa
#define HWIO_GCC_ANOC_PCIE_GDSCR_RESTORE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_RESTORE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_SAVE_BMSK                                                                  0x200
#define HWIO_GCC_ANOC_PCIE_GDSCR_SAVE_SHFT                                                                    0x9
#define HWIO_GCC_ANOC_PCIE_GDSCR_SAVE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_SAVE_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_BMSK                                                                0x100
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_SHFT                                                                  0x8
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_RETAIN_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_BMSK                                                                0x80
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_SHFT                                                                 0x7
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_REST_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_BMSK                                                                 0x40
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_SHFT                                                                  0x6
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_EN_FEW_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLAMP_IO_BMSK                                                               0x20
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLAMP_IO_SHFT                                                                0x5
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLAMP_IO_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLAMP_IO_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DISABLE_BMSK                                                            0x10
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DISABLE_SHFT                                                             0x4
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                             0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                              0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_PD_ARES_BMSK                                                                 0x8
#define HWIO_GCC_ANOC_PCIE_GDSCR_PD_ARES_SHFT                                                                 0x3
#define HWIO_GCC_ANOC_PCIE_GDSCR_PD_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_PD_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_OVERRIDE_BMSK                                                             0x4
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_OVERRIDE_SHFT                                                             0x2
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_HW_CONTROL_BMSK                                                              0x2
#define HWIO_GCC_ANOC_PCIE_GDSCR_HW_CONTROL_SHFT                                                              0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_HW_CONTROL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_HW_CONTROL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_COLLAPSE_BMSK                                                             0x1
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_COLLAPSE_SHFT                                                             0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_ANOC_PCIE_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00000008)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000008)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000008)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_RMSK                                                               0x7ffffff
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ATTR                                                                     0x3
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ADDR, HWIO_GCC_ANOC_PCIE_CFG_GDSCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_CFG_GDSCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_CFG_GDSCR_IN)
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4000000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x1a
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                            0x2000000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                 0x19
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                             0x1000000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                  0x18
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                      0xf00000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                          0x14
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                         0x80000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                            0x13
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                             0x40000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                0x12
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                             0x20000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                0x11
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                          0x10000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                             0x10
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                         0x8000
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                            0xf
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                        0x7800
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                           0xb
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                0x400
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                  0xa
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                         0x200
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                           0x9
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                         0x100
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                           0x8
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                             0x80
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                              0x7
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                    0x60
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                     0x5
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                              0x10
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                               0x4
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                        0x8
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                        0x3
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                      0x4
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                      0x2
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                          0x2
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                          0x1
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                       0x1
#define HWIO_GCC_ANOC_PCIE_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                       0x0

#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000000c)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000000c)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000000c)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_RMSK                                                                0x7ffff
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ADDR, HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_IN)
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                    0x40000
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                       0x12
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                0x20000
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                   0x11
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                              0x10000
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                 0x10
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                  0xf000
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                     0xc
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                           0xf00
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                             0x8
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                              0xf0
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                               0x4
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                0xf
#define HWIO_GCC_ANOC_PCIE_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                0x0

#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00000010)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000010)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000010)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ADDR, HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_IN)
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                            0x4000000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                 0x1a
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                         0x2000000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                              0x19
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                    0x1e00000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                         0x15
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                     0x100000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                         0x14
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                  0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                   0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                            0x80000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                               0x13
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                        0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                         0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                0x40000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                   0x12
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                 0x20000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                    0x11
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                             0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                              0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                      0x10000
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                         0x10
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                              0xff00
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                 0x8
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                               0xff
#define HWIO_GCC_ANOC_PCIE_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                0x0

#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00000014)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000014)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000014)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_RMSK                                                               0xffffff
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ADDR, HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_IN)
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                 0xf00000
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                     0x14
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                  0xf0000
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                     0x10
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                  0xf000
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                     0xc
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                 0xf00
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                   0x8
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                       0xf0
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                        0x4
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                       0xf
#define HWIO_GCC_ANOC_PCIE_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                       0x0

#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00000018)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000018)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000018)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ADDR, HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IN)
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_ANOC_PCIE_NORTH_AT_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000001c)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000001c)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000001c)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_RMSK                                                             0x81c0000e
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ADDR, HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IN)
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_ANOC_PCIE_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00000020)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000020)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000020)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_RMSK                                                     0x81c00004
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ATTR                                                            0x3
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                      0x1000000
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                           0x18
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                    0x800000
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                        0x17
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                               0x400000
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                   0x16
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                   0x4
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                   0x2
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_ANOC_PCIE_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                             0x1

#define HWIO_GCC_MMNOC_BCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c000)
#define HWIO_GCC_MMNOC_BCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c000)
#define HWIO_GCC_MMNOC_BCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c000)
#define HWIO_GCC_MMNOC_BCR_RMSK                                                                               0x1
#define HWIO_GCC_MMNOC_BCR_ATTR                                                                               0x3
#define HWIO_GCC_MMNOC_BCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_BCR_ADDR, HWIO_GCC_MMNOC_BCR_RMSK)
#define HWIO_GCC_MMNOC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_BCR_ADDR, m)
#define HWIO_GCC_MMNOC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_BCR_ADDR,v)
#define HWIO_GCC_MMNOC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_BCR_ADDR,m,v,HWIO_GCC_MMNOC_BCR_IN)
#define HWIO_GCC_MMNOC_BCR_BLK_ARES_BMSK                                                                      0x1
#define HWIO_GCC_MMNOC_BCR_BLK_ARES_SHFT                                                                      0x0
#define HWIO_GCC_MMNOC_BCR_BLK_ARES_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MMNOC_BCR_BLK_ARES_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_MMNOC_GDSCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c004)
#define HWIO_GCC_MMNOC_GDSCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c004)
#define HWIO_GCC_MMNOC_GDSCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c004)
#define HWIO_GCC_MMNOC_GDSCR_RMSK                                                                      0xf8ffffff
#define HWIO_GCC_MMNOC_GDSCR_ATTR                                                                             0x3
#define HWIO_GCC_MMNOC_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDSCR_ADDR, HWIO_GCC_MMNOC_GDSCR_RMSK)
#define HWIO_GCC_MMNOC_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDSCR_ADDR, m)
#define HWIO_GCC_MMNOC_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_GDSCR_ADDR,v)
#define HWIO_GCC_MMNOC_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_GDSCR_ADDR,m,v,HWIO_GCC_MMNOC_GDSCR_IN)
#define HWIO_GCC_MMNOC_GDSCR_PWR_ON_BMSK                                                               0x80000000
#define HWIO_GCC_MMNOC_GDSCR_PWR_ON_SHFT                                                                     0x1f
#define HWIO_GCC_MMNOC_GDSCR_GDSC_STATE_BMSK                                                           0x78000000
#define HWIO_GCC_MMNOC_GDSCR_GDSC_STATE_SHFT                                                                 0x1b
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_WAIT_BMSK                                                           0xf00000
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_WAIT_SHFT                                                               0x14
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_WAIT_BMSK                                                             0xf0000
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_WAIT_SHFT                                                                0x10
#define HWIO_GCC_MMNOC_GDSCR_CLK_DIS_WAIT_BMSK                                                             0xf000
#define HWIO_GCC_MMNOC_GDSCR_CLK_DIS_WAIT_SHFT                                                                0xc
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_FF_ENABLE_BMSK                                                          0x800
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_FF_ENABLE_SHFT                                                            0xb
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_MMNOC_GDSCR_RESTORE_BMSK                                                                   0x400
#define HWIO_GCC_MMNOC_GDSCR_RESTORE_SHFT                                                                     0xa
#define HWIO_GCC_MMNOC_GDSCR_RESTORE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_MMNOC_GDSCR_RESTORE_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_MMNOC_GDSCR_SAVE_BMSK                                                                      0x200
#define HWIO_GCC_MMNOC_GDSCR_SAVE_SHFT                                                                        0x9
#define HWIO_GCC_MMNOC_GDSCR_SAVE_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_MMNOC_GDSCR_SAVE_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_BMSK                                                                    0x100
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_SHFT                                                                      0x8
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MMNOC_GDSCR_RETAIN_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_BMSK                                                                    0x80
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_SHFT                                                                     0x7
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_MMNOC_GDSCR_EN_REST_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_BMSK                                                                     0x40
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_SHFT                                                                      0x6
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MMNOC_GDSCR_EN_FEW_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MMNOC_GDSCR_CLAMP_IO_BMSK                                                                   0x20
#define HWIO_GCC_MMNOC_GDSCR_CLAMP_IO_SHFT                                                                    0x5
#define HWIO_GCC_MMNOC_GDSCR_CLAMP_IO_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_MMNOC_GDSCR_CLAMP_IO_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_MMNOC_GDSCR_CLK_DISABLE_BMSK                                                                0x10
#define HWIO_GCC_MMNOC_GDSCR_CLK_DISABLE_SHFT                                                                 0x4
#define HWIO_GCC_MMNOC_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MMNOC_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                  0x1
#define HWIO_GCC_MMNOC_GDSCR_PD_ARES_BMSK                                                                     0x8
#define HWIO_GCC_MMNOC_GDSCR_PD_ARES_SHFT                                                                     0x3
#define HWIO_GCC_MMNOC_GDSCR_PD_ARES_NO_RESET_FVAL                                                            0x0
#define HWIO_GCC_MMNOC_GDSCR_PD_ARES_RESET_FVAL                                                               0x1
#define HWIO_GCC_MMNOC_GDSCR_SW_OVERRIDE_BMSK                                                                 0x4
#define HWIO_GCC_MMNOC_GDSCR_SW_OVERRIDE_SHFT                                                                 0x2
#define HWIO_GCC_MMNOC_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MMNOC_GDSCR_HW_CONTROL_BMSK                                                                  0x2
#define HWIO_GCC_MMNOC_GDSCR_HW_CONTROL_SHFT                                                                  0x1
#define HWIO_GCC_MMNOC_GDSCR_HW_CONTROL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MMNOC_GDSCR_HW_CONTROL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_MMNOC_GDSCR_SW_COLLAPSE_BMSK                                                                 0x1
#define HWIO_GCC_MMNOC_GDSCR_SW_COLLAPSE_SHFT                                                                 0x0
#define HWIO_GCC_MMNOC_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_MMNOC_CFG_GDSCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c008)
#define HWIO_GCC_MMNOC_CFG_GDSCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c008)
#define HWIO_GCC_MMNOC_CFG_GDSCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c008)
#define HWIO_GCC_MMNOC_CFG_GDSCR_RMSK                                                                   0x7ffffff
#define HWIO_GCC_MMNOC_CFG_GDSCR_ATTR                                                                         0x3
#define HWIO_GCC_MMNOC_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_CFG_GDSCR_ADDR, HWIO_GCC_MMNOC_CFG_GDSCR_RMSK)
#define HWIO_GCC_MMNOC_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_MMNOC_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_MMNOC_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_CFG_GDSCR_ADDR,m,v,HWIO_GCC_MMNOC_CFG_GDSCR_IN)
#define HWIO_GCC_MMNOC_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4000000
#define HWIO_GCC_MMNOC_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                             0x1a
#define HWIO_GCC_MMNOC_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MMNOC_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                                0x2000000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                     0x19
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                                 0x1000000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                      0x18
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                          0xf00000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                              0x14
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                             0x80000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                                0x13
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                                 0x40000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                    0x12
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                                 0x20000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                    0x11
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                              0x10000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                                 0x10
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                             0x8000
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                                0xf
#define HWIO_GCC_MMNOC_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                            0x7800
#define HWIO_GCC_MMNOC_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                               0xb
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                    0x400
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                      0xa
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                             0x200
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                               0x9
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                             0x100
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                               0x8
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                                 0x80
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                  0x7
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                        0x60
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                         0x5
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                  0x10
#define HWIO_GCC_MMNOC_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                   0x4
#define HWIO_GCC_MMNOC_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                            0x8
#define HWIO_GCC_MMNOC_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                            0x3
#define HWIO_GCC_MMNOC_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                          0x4
#define HWIO_GCC_MMNOC_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                          0x2
#define HWIO_GCC_MMNOC_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                              0x2
#define HWIO_GCC_MMNOC_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                              0x1
#define HWIO_GCC_MMNOC_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                           0x1
#define HWIO_GCC_MMNOC_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                           0x0

#define HWIO_GCC_MMNOC_CFG2_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c00c)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c00c)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c00c)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_RMSK                                                                    0x7ffff
#define HWIO_GCC_MMNOC_CFG2_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_MMNOC_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_CFG2_GDSCR_ADDR, HWIO_GCC_MMNOC_CFG2_GDSCR_RMSK)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_MMNOC_CFG2_GDSCR_IN)
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                        0x40000
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                           0x12
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                    0x20000
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                       0x11
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                  0x10000
#define HWIO_GCC_MMNOC_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                     0x10
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                      0xf000
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                         0xc
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                               0xf00
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                                 0x8
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                  0xf0
#define HWIO_GCC_MMNOC_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                   0x4
#define HWIO_GCC_MMNOC_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                    0xf
#define HWIO_GCC_MMNOC_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                    0x0

#define HWIO_GCC_MMNOC_CFG3_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c010)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c010)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c010)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_RMSK                                                                  0x7ffffff
#define HWIO_GCC_MMNOC_CFG3_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_MMNOC_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_CFG3_GDSCR_ADDR, HWIO_GCC_MMNOC_CFG3_GDSCR_RMSK)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_MMNOC_CFG3_GDSCR_IN)
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                                0x4000000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                     0x1a
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                             0x2000000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                  0x19
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                        0x1e00000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                             0x15
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                         0x100000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                             0x14
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                       0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                                0x80000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                   0x13
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                            0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                             0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                    0x40000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                       0x12
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                                0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                                 0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                     0x20000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                        0x11
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                                 0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                  0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                          0x10000
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                             0x10
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                  0xff00
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                     0x8
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                   0xff
#define HWIO_GCC_MMNOC_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                    0x0

#define HWIO_GCC_MMNOC_CFG4_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c014)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c014)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c014)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_RMSK                                                                   0xffffff
#define HWIO_GCC_MMNOC_CFG4_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_MMNOC_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_CFG4_GDSCR_ADDR, HWIO_GCC_MMNOC_CFG4_GDSCR_RMSK)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_MMNOC_CFG4_GDSCR_IN)
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                     0xf00000
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                         0x14
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                      0xf0000
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                         0x10
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                      0xf000
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                         0xc
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                     0xf00
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                       0x8
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                           0xf0
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                            0x4
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                           0xf
#define HWIO_GCC_MMNOC_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                           0x0

#define HWIO_GCC_MMNOC_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c018)
#define HWIO_GCC_MMNOC_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c018)
#define HWIO_GCC_MMNOC_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c018)
#define HWIO_GCC_MMNOC_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_MMNOC_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_MMNOC_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_AT_CBCR_ADDR, HWIO_GCC_MMNOC_AT_CBCR_RMSK)
#define HWIO_GCC_MMNOC_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_AT_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_AT_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_AT_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_AT_CBCR_IN)
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_MMNOC_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_MMNOC_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_MMNOC_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_MMNOC_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_MMNOC_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_MMNOC_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_MMNOC_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MMNOC_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c01c)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c01c)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c01c)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_AHB_CFG_CBCR_ADDR, HWIO_GCC_MMNOC_AHB_CFG_CBCR_RMSK)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_AHB_CFG_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_AHB_CFG_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_AHB_CFG_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_AHB_CFG_CBCR_IN)
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MMNOC_AHB_CFG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c020)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c020)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c020)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_RMSK                                                            0x81c00005
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ADDR, HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_RMSK)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ADDR, m)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ADDR,v)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_ADDR,m,v,HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IN)
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_NOC_MMNOC_DCD_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MMNOC_TSCTR_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c024)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c024)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c024)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_RMSK                                                                 0x81c0000f
#define HWIO_GCC_MMNOC_TSCTR_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_MMNOC_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_TSCTR_CBCR_ADDR, HWIO_GCC_MMNOC_TSCTR_CBCR_RMSK)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_TSCTR_CBCR_IN)
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MMNOC_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_MMNOC_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_MMNOC_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_MMNOC_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_MMNOC_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_MMNOC_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_MMNOC_TSCTR_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_MMNOC_TSCTR_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_MMNOC_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_TSCTR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_MMNOC_SF_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c028)
#define HWIO_GCC_MMNOC_SF_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c028)
#define HWIO_GCC_MMNOC_SF_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c028)
#define HWIO_GCC_MMNOC_SF_CBCR_RMSK                                                                    0x81f0700f
#define HWIO_GCC_MMNOC_SF_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_MMNOC_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_CBCR_ADDR, HWIO_GCC_MMNOC_SF_CBCR_RMSK)
#define HWIO_GCC_MMNOC_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_SF_CBCR_IN)
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                   0x200000
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                       0x15
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_CORE_ON_BMSK                                                      0x4000
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_CORE_ON_SHFT                                                         0xe
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                    0x2000
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                       0xd
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                   0x1000
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                      0xc
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MMNOC_SF_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MMNOC_SF_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_MMNOC_SF_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_MMNOC_SF_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_MMNOC_SF_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_MMNOC_SF_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_MMNOC_SF_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MMNOC_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_MMNOC_SF_SREGR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c02c)
#define HWIO_GCC_MMNOC_SF_SREGR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c02c)
#define HWIO_GCC_MMNOC_SF_SREGR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c02c)
#define HWIO_GCC_MMNOC_SF_SREGR_RMSK                                                                    0xf1ffffe
#define HWIO_GCC_MMNOC_SF_SREGR_ATTR                                                                          0x3
#define HWIO_GCC_MMNOC_SF_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_SREGR_ADDR, HWIO_GCC_MMNOC_SF_SREGR_RMSK)
#define HWIO_GCC_MMNOC_SF_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_SREGR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_SREGR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_SREGR_ADDR,m,v,HWIO_GCC_MMNOC_SF_SREGR_IN)
#define HWIO_GCC_MMNOC_SF_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                          0xf000000
#define HWIO_GCC_MMNOC_SF_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                               0x18
#define HWIO_GCC_MMNOC_SF_SREGR_PWR_FSM_CLK_SEL_BMSK                                                     0x100000
#define HWIO_GCC_MMNOC_SF_SREGR_PWR_FSM_CLK_SEL_SHFT                                                         0x14
#define HWIO_GCC_MMNOC_SF_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                             0xf0000
#define HWIO_GCC_MMNOC_SF_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                0x10
#define HWIO_GCC_MMNOC_SF_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                               0x8000
#define HWIO_GCC_MMNOC_SF_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                  0xf
#define HWIO_GCC_MMNOC_SF_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                        0x0
#define HWIO_GCC_MMNOC_SF_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                           0x1
#define HWIO_GCC_MMNOC_SF_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                0x4000
#define HWIO_GCC_MMNOC_SF_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                   0xe
#define HWIO_GCC_MMNOC_SF_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                   0x0
#define HWIO_GCC_MMNOC_SF_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                0x1
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                               0x2000
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                  0xd
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                      0x0
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                         0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                           0x1000
#define HWIO_GCC_MMNOC_SF_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                              0xc
#define HWIO_GCC_MMNOC_SF_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                     0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                        0x1
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CORE_ON_ACK_BMSK                                                        0x800
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CORE_ON_ACK_SHFT                                                          0xb
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                      0x400
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                        0xa
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                               0x300
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                 0x8
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                        0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                        0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                        0x2
#define HWIO_GCC_MMNOC_SF_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                        0x3
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_ENABLE_BMSK                                                          0x80
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_ENABLE_SHFT                                                           0x7
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MMNOC_SF_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_MMNOC_SF_SREGR_FORCE_CLK_ON_BMSK                                                            0x40
#define HWIO_GCC_MMNOC_SF_SREGR_FORCE_CLK_ON_SHFT                                                             0x6
#define HWIO_GCC_MMNOC_SF_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_SF_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                      0x20
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                       0x5
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                              0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                         0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SLP_STG_BMSK                                                          0x10
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SLP_STG_SHFT                                                           0x4
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                 0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                    0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                         0x8
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                         0x3
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                              0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                 0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                    0x4
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                    0x2
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                        0x2
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                        0x1
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MMNOC_SF_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                   0x1

#define HWIO_GCC_MMNOC_SF_CFG_SREGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c030)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c030)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c030)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_RMSK                                                               0xffffffff
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_ATTR                                                                      0x3
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SF_CFG_SREGR_ADDR, HWIO_GCC_MMNOC_SF_CFG_SREGR_RMSK)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SF_CFG_SREGR_ADDR, m)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SF_CFG_SREGR_ADDR,v)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SF_CFG_SREGR_ADDR,m,v,HWIO_GCC_MMNOC_SF_CFG_SREGR_IN)
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                            0xfc000000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                  0x1a
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                       0x2000000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                            0x19
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                         0x1000000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                              0x18
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                            0x800000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                0x17
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                              0x400000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                  0x16
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                   0x3f0000
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                       0x10
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_SLEEP_TIMER_BMSK                                                       0xff00
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_SLEEP_TIMER_SHFT                                                          0x8
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_WAKEUP_TIMER_BMSK                                                        0xff
#define HWIO_GCC_MMNOC_SF_CFG_SREGR_WAKEUP_TIMER_SHFT                                                         0x0

#define HWIO_GCC_MMNOC_HF_QX_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c034)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c034)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c034)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_RMSK                                                                 0x81f0700f
#define HWIO_GCC_MMNOC_HF_QX_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CBCR_ADDR, HWIO_GCC_MMNOC_HF_QX_CBCR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_CBCR_IN)
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                0x200000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                    0x15
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_MMNOC_HF_QX_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_MMNOC_HF_QX_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_MMNOC_HF_QX_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c038)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c038)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c038)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_MMNOC_HF_QX_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_MMNOC_HF_QX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_SREGR_ADDR, HWIO_GCC_MMNOC_HF_QX_SREGR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_SREGR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_SREGR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_SREGR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_SREGR_IN)
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_MMNOC_HF_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_MMNOC_HF_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_MMNOC_HF_QX_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_MMNOC_HF_QX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_MMNOC_HF_QX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c03c)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c03c)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c03c)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ADDR, HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_RMSK)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_ADDR,m,v,HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_IN)
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_MMNOC_HF_QX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_MMNOC_PWRCTL_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c040)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c040)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c040)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_PWRCTL_CBCR_ADDR, HWIO_GCC_MMNOC_PWRCTL_CBCR_RMSK)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_PWRCTL_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_PWRCTL_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_PWRCTL_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_PWRCTL_CBCR_IN)
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MMNOC_PWRCTL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c044)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c044)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c044)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_RMSK                                                         0x81c00005
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ATTR                                                                0x3
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MMNOC_QOSGEN_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_MMSS_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b000)
#define HWIO_GCC_MMSS_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b000)
#define HWIO_GCC_MMSS_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b000)
#define HWIO_GCC_MMSS_BCR_RMSK                                                                                0x1
#define HWIO_GCC_MMSS_BCR_ATTR                                                                                0x3
#define HWIO_GCC_MMSS_BCR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_BCR_ADDR, HWIO_GCC_MMSS_BCR_RMSK)
#define HWIO_GCC_MMSS_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_BCR_ADDR, m)
#define HWIO_GCC_MMSS_BCR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_BCR_ADDR,v)
#define HWIO_GCC_MMSS_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_BCR_ADDR,m,v,HWIO_GCC_MMSS_BCR_IN)
#define HWIO_GCC_MMSS_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_MMSS_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_MMSS_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_MMSS_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_MMSS_AT_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b004)
#define HWIO_GCC_MMSS_AT_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b004)
#define HWIO_GCC_MMSS_AT_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b004)
#define HWIO_GCC_MMSS_AT_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_MMSS_AT_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_MMSS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_AT_CBCR_ADDR, HWIO_GCC_MMSS_AT_CBCR_RMSK)
#define HWIO_GCC_MMSS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_AT_CBCR_ADDR, m)
#define HWIO_GCC_MMSS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_AT_CBCR_ADDR,v)
#define HWIO_GCC_MMSS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_AT_CBCR_ADDR,m,v,HWIO_GCC_MMSS_AT_CBCR_IN)
#define HWIO_GCC_MMSS_AT_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_MMSS_AT_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_MMSS_AT_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_MMSS_AT_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_MMSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_MMSS_AT_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_MMSS_AT_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_MMSS_AT_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_MMSS_AT_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_MMSS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_MMSS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MMSS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b008)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b008)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b008)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_RMSK                                                              0x81c00005
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CBCR_ADDR, HWIO_GCC_MMSS_QMIP_CORE_CBCR_RMSK)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CBCR_ADDR, m)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_QMIP_CORE_CBCR_ADDR,v)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_QMIP_CORE_CBCR_ADDR,m,v,HWIO_GCC_MMSS_QMIP_CORE_CBCR_IN)
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_MMSS_TRIG_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b00c)
#define HWIO_GCC_MMSS_TRIG_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b00c)
#define HWIO_GCC_MMSS_TRIG_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b00c)
#define HWIO_GCC_MMSS_TRIG_CBCR_RMSK                                                                   0x81d0000f
#define HWIO_GCC_MMSS_TRIG_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_MMSS_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_TRIG_CBCR_ADDR, HWIO_GCC_MMSS_TRIG_CBCR_RMSK)
#define HWIO_GCC_MMSS_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_MMSS_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_MMSS_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_TRIG_CBCR_ADDR,m,v,HWIO_GCC_MMSS_TRIG_CBCR_IN)
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_MMSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_MMSS_TRIG_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_MMSS_TRIG_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_MMSS_TRIG_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_MMSS_TRIG_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_MMSS_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MMSS_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MMSS_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b010)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b010)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b010)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ADDR, HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_IN)
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b014)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b014)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b014)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ADDR, HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_IN)
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_MMSS_QMIP_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_MMSS_QM_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0002b028)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002b028)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002b028)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_RMSK                                                                 0x81d00005
#define HWIO_GCC_MMSS_QM_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMSS_QM_AHB_CBCR_ADDR, HWIO_GCC_MMSS_QM_AHB_CBCR_RMSK)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMSS_QM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMSS_QM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMSS_QM_AHB_CBCR_ADDR,m,v,HWIO_GCC_MMSS_QM_AHB_CBCR_IN)
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_MMSS_QM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MMSS_QM_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CAMERA_BCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00016000)
#define HWIO_GCC_CAMERA_BCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016000)
#define HWIO_GCC_CAMERA_BCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016000)
#define HWIO_GCC_CAMERA_BCR_RMSK                                                                              0x1
#define HWIO_GCC_CAMERA_BCR_ATTR                                                                              0x3
#define HWIO_GCC_CAMERA_BCR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_BCR_ADDR, HWIO_GCC_CAMERA_BCR_RMSK)
#define HWIO_GCC_CAMERA_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_BCR_ADDR, m)
#define HWIO_GCC_CAMERA_BCR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_BCR_ADDR,v)
#define HWIO_GCC_CAMERA_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_BCR_ADDR,m,v,HWIO_GCC_CAMERA_BCR_IN)
#define HWIO_GCC_CAMERA_BCR_BLK_ARES_BMSK                                                                     0x1
#define HWIO_GCC_CAMERA_BCR_BLK_ARES_SHFT                                                                     0x0
#define HWIO_GCC_CAMERA_BCR_BLK_ARES_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_CAMERA_BCR_BLK_ARES_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_CAMERA_AHB_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00016004)
#define HWIO_GCC_CAMERA_AHB_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016004)
#define HWIO_GCC_CAMERA_AHB_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016004)
#define HWIO_GCC_CAMERA_AHB_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_CAMERA_AHB_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_CAMERA_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_AHB_CBCR_ADDR, HWIO_GCC_CAMERA_AHB_CBCR_RMSK)
#define HWIO_GCC_CAMERA_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CAMERA_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CAMERA_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_AHB_CBCR_ADDR,m,v,HWIO_GCC_CAMERA_AHB_CBCR_IN)
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_CAMERA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_CAMERA_AHB_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_CAMERA_AHB_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_CAMERA_AHB_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_CAMERA_AHB_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_CAMERA_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_CAMERA_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CAMERA_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00016008)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016008)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016008)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ATTR                                                                0x3
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ADDR, HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QMIP_CAMERA_NRT_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0001600c)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001600c)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001600c)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ADDR, HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QMIP_CAMERA_RT_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_CAMERA_HF_AXI_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00016010)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016010)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016010)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_RMSK                                                               0x81f0700f
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_CBCR_ADDR, HWIO_GCC_CAMERA_HF_AXI_CBCR_RMSK)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_HF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_HF_AXI_CBCR_ADDR,m,v,HWIO_GCC_CAMERA_HF_AXI_CBCR_IN)
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                              0x200000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                  0x15
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                 0x4000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                    0xe
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                               0x2000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                  0xd
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                              0x1000
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                 0xc
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CAMERA_HF_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CAMERA_HF_AXI_SREGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00016014)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016014)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016014)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_RMSK                                                               0xf1ffffe
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_ATTR                                                                     0x3
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_SREGR_ADDR, HWIO_GCC_CAMERA_HF_AXI_SREGR_RMSK)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_SREGR_ADDR, m)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_HF_AXI_SREGR_ADDR,v)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_HF_AXI_SREGR_ADDR,m,v,HWIO_GCC_CAMERA_HF_AXI_SREGR_IN)
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                     0xf000000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                          0x18
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                                0x100000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                    0x14
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                        0xf0000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                           0x10
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                          0x8000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                             0xf
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                   0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                      0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                           0x4000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                              0xe
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                              0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                           0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                          0x2000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                             0xd
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                 0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                    0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                      0x1000
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                         0xc
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                   0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                   0x800
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                     0xb
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                 0x400
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                   0xa
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                          0x300
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                            0x8
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                   0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                   0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                   0x2
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                   0x3
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                     0x80
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                      0x7
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_FORCE_CLK_ON_BMSK                                                       0x40
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_FORCE_CLK_ON_SHFT                                                        0x6
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                               0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                 0x20
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                  0x5
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                         0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                    0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                     0x10
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                      0x4
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                            0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                               0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                    0x8
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                    0x3
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                         0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                            0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                               0x4
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                               0x2
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL           0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                   0x2
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                   0x1
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                             0x0
#define HWIO_GCC_CAMERA_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                              0x1

#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00016018)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016018)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016018)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_RMSK                                                          0xffffffff
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ATTR                                                                 0x3
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ADDR, HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_IN)
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                       0xfc000000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                             0x1a
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                  0x2000000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                       0x19
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                    0x1000000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                         0x18
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                       0x800000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                           0x17
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                         0x400000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                             0x16
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                              0x3f0000
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                  0x10
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                  0xff00
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                     0x8
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                   0xff
#define HWIO_GCC_CAMERA_HF_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                    0x0

#define HWIO_GCC_CAMERA_SF_AXI_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0001601c)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001601c)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001601c)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_RMSK                                                               0x81f0700f
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_CBCR_ADDR, HWIO_GCC_CAMERA_SF_AXI_CBCR_RMSK)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_SF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_SF_AXI_CBCR_ADDR,m,v,HWIO_GCC_CAMERA_SF_AXI_CBCR_IN)
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                              0x200000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                  0x15
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                 0x4000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                    0xe
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                               0x2000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                  0xd
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                              0x1000
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                 0xc
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_CAMERA_SF_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_CAMERA_SF_AXI_SREGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00016020)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016020)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016020)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_RMSK                                                               0xf1ffffe
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_ATTR                                                                     0x3
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_SREGR_ADDR, HWIO_GCC_CAMERA_SF_AXI_SREGR_RMSK)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_SREGR_ADDR, m)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_SF_AXI_SREGR_ADDR,v)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_SF_AXI_SREGR_ADDR,m,v,HWIO_GCC_CAMERA_SF_AXI_SREGR_IN)
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                     0xf000000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                          0x18
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                                0x100000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                    0x14
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                        0xf0000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                           0x10
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                          0x8000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                             0xf
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                   0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                      0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                           0x4000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                              0xe
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                              0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                           0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                          0x2000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                             0xd
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                 0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                    0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                      0x1000
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                         0xc
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                   0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                   0x800
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                     0xb
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                 0x400
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                   0xa
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                          0x300
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                            0x8
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                   0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                   0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                   0x2
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                   0x3
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                     0x80
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                      0x7
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_FORCE_CLK_ON_BMSK                                                       0x40
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_FORCE_CLK_ON_SHFT                                                        0x6
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                               0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                 0x20
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                  0x5
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                         0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                    0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                     0x10
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                      0x4
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                            0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                               0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                    0x8
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                    0x3
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                         0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                            0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                               0x4
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                               0x2
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL           0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                   0x2
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                   0x1
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                             0x0
#define HWIO_GCC_CAMERA_SF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                              0x1

#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00016024)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016024)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016024)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_RMSK                                                          0xffffffff
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ATTR                                                                 0x3
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ADDR, HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_IN)
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                       0xfc000000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                             0x1a
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                  0x2000000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                       0x19
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                    0x1000000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                         0x18
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                       0x800000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                           0x17
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                         0x400000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                             0x16
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                              0x3f0000
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                  0x10
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                  0xff00
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                     0x8
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                   0xff
#define HWIO_GCC_CAMERA_SF_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                    0x0

#define HWIO_GCC_CAMERA_XO_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00016028)
#define HWIO_GCC_CAMERA_XO_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016028)
#define HWIO_GCC_CAMERA_XO_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016028)
#define HWIO_GCC_CAMERA_XO_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_CAMERA_XO_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_CAMERA_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_XO_CBCR_ADDR, HWIO_GCC_CAMERA_XO_CBCR_RMSK)
#define HWIO_GCC_CAMERA_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_XO_CBCR_ADDR, m)
#define HWIO_GCC_CAMERA_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_XO_CBCR_ADDR,v)
#define HWIO_GCC_CAMERA_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_XO_CBCR_ADDR,m,v,HWIO_GCC_CAMERA_XO_CBCR_IN)
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_CAMERA_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_CAMERA_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_CAMERA_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_CAMERA_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CAMERA_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_DISPLAY_BCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00017000)
#define HWIO_GCC_DISPLAY_BCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017000)
#define HWIO_GCC_DISPLAY_BCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017000)
#define HWIO_GCC_DISPLAY_BCR_RMSK                                                                             0x1
#define HWIO_GCC_DISPLAY_BCR_ATTR                                                                             0x3
#define HWIO_GCC_DISPLAY_BCR_IN          \
        in_dword_masked(HWIO_GCC_DISPLAY_BCR_ADDR, HWIO_GCC_DISPLAY_BCR_RMSK)
#define HWIO_GCC_DISPLAY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISPLAY_BCR_ADDR, m)
#define HWIO_GCC_DISPLAY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_DISPLAY_BCR_ADDR,v)
#define HWIO_GCC_DISPLAY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISPLAY_BCR_ADDR,m,v,HWIO_GCC_DISPLAY_BCR_IN)
#define HWIO_GCC_DISPLAY_BCR_BLK_ARES_BMSK                                                                    0x1
#define HWIO_GCC_DISPLAY_BCR_BLK_ARES_SHFT                                                                    0x0
#define HWIO_GCC_DISPLAY_BCR_BLK_ARES_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_DISPLAY_BCR_BLK_ARES_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_DISP_AHB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00017004)
#define HWIO_GCC_DISP_AHB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017004)
#define HWIO_GCC_DISP_AHB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017004)
#define HWIO_GCC_DISP_AHB_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_DISP_AHB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_DISP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DISP_AHB_CBCR_ADDR, HWIO_GCC_DISP_AHB_CBCR_RMSK)
#define HWIO_GCC_DISP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_DISP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DISP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_DISP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_AHB_CBCR_ADDR,m,v,HWIO_GCC_DISP_AHB_CBCR_IN)
#define HWIO_GCC_DISP_AHB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_DISP_AHB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_DISP_AHB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_DISP_AHB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_DISP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_DISP_AHB_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_DISP_AHB_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_DISP_AHB_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_DISP_AHB_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_DISP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_DISP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_DISP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_QMIP_DISP_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00017008)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017008)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017008)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_DISP_AHB_CBCR_ADDR, HWIO_GCC_QMIP_DISP_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_DISP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_DISP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_DISP_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_DISP_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QMIP_DISP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_DISP_HF_AXI_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0001700c)
#define HWIO_GCC_DISP_HF_AXI_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001700c)
#define HWIO_GCC_DISP_HF_AXI_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001700c)
#define HWIO_GCC_DISP_HF_AXI_CBCR_RMSK                                                                 0x81f0700f
#define HWIO_GCC_DISP_HF_AXI_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_DISP_HF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_CBCR_ADDR, HWIO_GCC_DISP_HF_AXI_CBCR_RMSK)
#define HWIO_GCC_DISP_HF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DISP_HF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DISP_HF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DISP_HF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_HF_AXI_CBCR_ADDR,m,v,HWIO_GCC_DISP_HF_AXI_CBCR_IN)
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                0x200000
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                    0x15
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_DISP_HF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_DISP_HF_AXI_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_DISP_HF_AXI_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_DISP_HF_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_DISP_HF_AXI_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00017010)
#define HWIO_GCC_DISP_HF_AXI_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017010)
#define HWIO_GCC_DISP_HF_AXI_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017010)
#define HWIO_GCC_DISP_HF_AXI_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_DISP_HF_AXI_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_DISP_HF_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_SREGR_ADDR, HWIO_GCC_DISP_HF_AXI_SREGR_RMSK)
#define HWIO_GCC_DISP_HF_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_SREGR_ADDR, m)
#define HWIO_GCC_DISP_HF_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_DISP_HF_AXI_SREGR_ADDR,v)
#define HWIO_GCC_DISP_HF_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_HF_AXI_SREGR_ADDR,m,v,HWIO_GCC_DISP_HF_AXI_SREGR_IN)
#define HWIO_GCC_DISP_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_DISP_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_DISP_HF_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_DISP_HF_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_DISP_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_DISP_HF_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_DISP_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_DISP_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_DISP_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_DISP_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_DISP_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_DISP_HF_AXI_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_DISP_HF_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_DISP_HF_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00017014)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017014)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017014)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ADDR, HWIO_GCC_DISP_HF_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_HF_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_DISP_HF_AXI_CFG_SREGR_IN)
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_DISP_HF_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_DISP_XO_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00017018)
#define HWIO_GCC_DISP_XO_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017018)
#define HWIO_GCC_DISP_XO_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017018)
#define HWIO_GCC_DISP_XO_CBCR_RMSK                                                                     0x81c00005
#define HWIO_GCC_DISP_XO_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_DISP_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DISP_XO_CBCR_ADDR, HWIO_GCC_DISP_XO_CBCR_RMSK)
#define HWIO_GCC_DISP_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_XO_CBCR_ADDR, m)
#define HWIO_GCC_DISP_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DISP_XO_CBCR_ADDR,v)
#define HWIO_GCC_DISP_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_XO_CBCR_ADDR,m,v,HWIO_GCC_DISP_XO_CBCR_IN)
#define HWIO_GCC_DISP_XO_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_DISP_XO_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_DISP_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_DISP_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_DISP_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_DISP_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_DISP_XO_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_DISP_XO_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_DISP_XO_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_DISP_XO_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_DISP_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_DISP_XO_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_DISP_XO_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_DISP_XO_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_DISP_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_DISP_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_VIDEO_BCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00022000)
#define HWIO_GCC_VIDEO_BCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022000)
#define HWIO_GCC_VIDEO_BCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022000)
#define HWIO_GCC_VIDEO_BCR_RMSK                                                                               0x1
#define HWIO_GCC_VIDEO_BCR_ATTR                                                                               0x3
#define HWIO_GCC_VIDEO_BCR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_BCR_ADDR, HWIO_GCC_VIDEO_BCR_RMSK)
#define HWIO_GCC_VIDEO_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_BCR_ADDR, m)
#define HWIO_GCC_VIDEO_BCR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_BCR_ADDR,v)
#define HWIO_GCC_VIDEO_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_BCR_ADDR,m,v,HWIO_GCC_VIDEO_BCR_IN)
#define HWIO_GCC_VIDEO_BCR_BLK_ARES_BMSK                                                                      0x1
#define HWIO_GCC_VIDEO_BCR_BLK_ARES_SHFT                                                                      0x0
#define HWIO_GCC_VIDEO_BCR_BLK_ARES_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_VIDEO_BCR_BLK_ARES_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_VIDEO_AHB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00022004)
#define HWIO_GCC_VIDEO_AHB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022004)
#define HWIO_GCC_VIDEO_AHB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022004)
#define HWIO_GCC_VIDEO_AHB_CBCR_RMSK                                                                   0x81d0000f
#define HWIO_GCC_VIDEO_AHB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_VIDEO_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AHB_CBCR_ADDR, HWIO_GCC_VIDEO_AHB_CBCR_RMSK)
#define HWIO_GCC_VIDEO_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AHB_CBCR_ADDR, m)
#define HWIO_GCC_VIDEO_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AHB_CBCR_ADDR,v)
#define HWIO_GCC_VIDEO_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AHB_CBCR_ADDR,m,v,HWIO_GCC_VIDEO_AHB_CBCR_IN)
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_VIDEO_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_VIDEO_AHB_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_VIDEO_AHB_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_VIDEO_AHB_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_VIDEO_AHB_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_VIDEO_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_VIDEO_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_VIDEO_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00022008)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022008)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022008)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ADDR, HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QMIP_VIDEO_CVP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002200c)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002200c)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002200c)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_RMSK                                                       0x81d0000f
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ATTR                                                              0x3
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ADDR, HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                     0x100000
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                         0x14
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_SW_ONLY_EN_BMSK                                                   0x8
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_SW_ONLY_EN_SHFT                                                   0x3
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_HW_CTL_BMSK                                                       0x2
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_HW_CTL_SHFT                                                       0x1
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_QMIP_VIDEO_VCODEC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00022010)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022010)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022010)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_RMSK                                                        0x81d0000f
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ATTR                                                               0x3
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ADDR, HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                         0x1000000
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                              0x18
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                       0x800000
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                           0x17
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_DIS_BMSK                                                  0x400000
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_DIS_SHFT                                                      0x16
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                      0x100000
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                          0x14
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_SW_ONLY_EN_BMSK                                                    0x8
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_SW_ONLY_EN_SHFT                                                    0x3
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ARES_BMSK                                                      0x4
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ARES_SHFT                                                      0x2
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                             0x0
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ARES_RESET_FVAL                                                0x1
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_HW_CTL_BMSK                                                        0x2
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_HW_CTL_SHFT                                                        0x1
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QMIP_VIDEO_V_CPU_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00022014)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022014)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022014)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_RMSK                                                       0x81d0000f
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ATTR                                                              0x3
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ADDR, HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                     0x100000
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                         0x14
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_SW_ONLY_EN_BMSK                                                   0x8
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_SW_ONLY_EN_SHFT                                                   0x3
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_HW_CTL_BMSK                                                       0x2
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_HW_CTL_SHFT                                                       0x1
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_HW_CTL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_QMIP_VIDEO_CV_CPU_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_VIDEO_AXI0_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00022018)
#define HWIO_GCC_VIDEO_AXI0_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022018)
#define HWIO_GCC_VIDEO_AXI0_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022018)
#define HWIO_GCC_VIDEO_AXI0_CBCR_RMSK                                                                  0x81f0700f
#define HWIO_GCC_VIDEO_AXI0_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_VIDEO_AXI0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_CBCR_ADDR, HWIO_GCC_VIDEO_AXI0_CBCR_RMSK)
#define HWIO_GCC_VIDEO_AXI0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_CBCR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI0_CBCR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI0_CBCR_ADDR,m,v,HWIO_GCC_VIDEO_AXI0_CBCR_IN)
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                 0x200000
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                     0x15
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_VIDEO_AXI0_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_VIDEO_AXI0_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_VIDEO_AXI0_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_VIDEO_AXI0_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_VIDEO_AXI0_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0002201c)
#define HWIO_GCC_VIDEO_AXI0_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002201c)
#define HWIO_GCC_VIDEO_AXI0_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002201c)
#define HWIO_GCC_VIDEO_AXI0_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_VIDEO_AXI0_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_VIDEO_AXI0_SREGR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_SREGR_ADDR, HWIO_GCC_VIDEO_AXI0_SREGR_RMSK)
#define HWIO_GCC_VIDEO_AXI0_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_SREGR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI0_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI0_SREGR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI0_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI0_SREGR_ADDR,m,v,HWIO_GCC_VIDEO_AXI0_SREGR_IN)
#define HWIO_GCC_VIDEO_AXI0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_VIDEO_AXI0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_VIDEO_AXI0_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_VIDEO_AXI0_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_VIDEO_AXI0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_VIDEO_AXI0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_VIDEO_AXI0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_VIDEO_AXI0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_VIDEO_AXI0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_VIDEO_AXI0_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_VIDEO_AXI0_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_VIDEO_AXI0_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_VIDEO_AXI0_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_VIDEO_AXI0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00022020)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022020)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022020)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ADDR, HWIO_GCC_VIDEO_AXI0_CFG_SREGR_RMSK)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI0_CFG_SREGR_ADDR,m,v,HWIO_GCC_VIDEO_AXI0_CFG_SREGR_IN)
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_VIDEO_AXI0_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_VIDEO_AXI1_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00022024)
#define HWIO_GCC_VIDEO_AXI1_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022024)
#define HWIO_GCC_VIDEO_AXI1_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022024)
#define HWIO_GCC_VIDEO_AXI1_CBCR_RMSK                                                                  0x81f0700f
#define HWIO_GCC_VIDEO_AXI1_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_VIDEO_AXI1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_CBCR_ADDR, HWIO_GCC_VIDEO_AXI1_CBCR_RMSK)
#define HWIO_GCC_VIDEO_AXI1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_CBCR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI1_CBCR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI1_CBCR_ADDR,m,v,HWIO_GCC_VIDEO_AXI1_CBCR_IN)
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                 0x200000
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                     0x15
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_VIDEO_AXI1_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_VIDEO_AXI1_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_VIDEO_AXI1_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_VIDEO_AXI1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_VIDEO_AXI1_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00022028)
#define HWIO_GCC_VIDEO_AXI1_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022028)
#define HWIO_GCC_VIDEO_AXI1_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022028)
#define HWIO_GCC_VIDEO_AXI1_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_VIDEO_AXI1_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_VIDEO_AXI1_SREGR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_SREGR_ADDR, HWIO_GCC_VIDEO_AXI1_SREGR_RMSK)
#define HWIO_GCC_VIDEO_AXI1_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_SREGR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI1_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI1_SREGR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI1_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI1_SREGR_ADDR,m,v,HWIO_GCC_VIDEO_AXI1_SREGR_IN)
#define HWIO_GCC_VIDEO_AXI1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_VIDEO_AXI1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_VIDEO_AXI1_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_VIDEO_AXI1_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_VIDEO_AXI1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_VIDEO_AXI1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_VIDEO_AXI1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_VIDEO_AXI1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_VIDEO_AXI1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_VIDEO_AXI1_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_VIDEO_AXI1_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_VIDEO_AXI1_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_VIDEO_AXI1_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_VIDEO_AXI1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002202c)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002202c)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002202c)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ADDR, HWIO_GCC_VIDEO_AXI1_CFG_SREGR_RMSK)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ADDR, m)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ADDR,v)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_AXI1_CFG_SREGR_ADDR,m,v,HWIO_GCC_VIDEO_AXI1_CFG_SREGR_IN)
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_VIDEO_AXI1_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_VIDEO_XO_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00022030)
#define HWIO_GCC_VIDEO_XO_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022030)
#define HWIO_GCC_VIDEO_XO_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022030)
#define HWIO_GCC_VIDEO_XO_CBCR_RMSK                                                                    0x81c00005
#define HWIO_GCC_VIDEO_XO_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_VIDEO_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_XO_CBCR_ADDR, HWIO_GCC_VIDEO_XO_CBCR_RMSK)
#define HWIO_GCC_VIDEO_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_XO_CBCR_ADDR, m)
#define HWIO_GCC_VIDEO_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_XO_CBCR_ADDR,v)
#define HWIO_GCC_VIDEO_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_XO_CBCR_ADDR,m,v,HWIO_GCC_VIDEO_XO_CBCR_IN)
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_VIDEO_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_VIDEO_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_VIDEO_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_VIDEO_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_VIDEO_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_QDSS_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f000)
#define HWIO_GCC_QDSS_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f000)
#define HWIO_GCC_QDSS_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f000)
#define HWIO_GCC_QDSS_BCR_RMSK                                                                                0x1
#define HWIO_GCC_QDSS_BCR_ATTR                                                                                0x3
#define HWIO_GCC_QDSS_BCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_BCR_ADDR, HWIO_GCC_QDSS_BCR_RMSK)
#define HWIO_GCC_QDSS_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_BCR_ADDR, m)
#define HWIO_GCC_QDSS_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_BCR_ADDR,v)
#define HWIO_GCC_QDSS_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_BCR_ADDR,m,v,HWIO_GCC_QDSS_BCR_IN)
#define HWIO_GCC_QDSS_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_QDSS_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_QDSS_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_QDSS_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_QDSS_DAP_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f004)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f004)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f004)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_DAP_AHB_CBCR_ADDR, HWIO_GCC_QDSS_DAP_AHB_CBCR_RMSK)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_DAP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_DAP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_DAP_AHB_CBCR_ADDR,m,v,HWIO_GCC_QDSS_DAP_AHB_CBCR_IN)
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QDSS_DAP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QDSS_CFG_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f008)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f008)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f008)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_RMSK                                                                0x81d0000e
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_CFG_AHB_CBCR_ADDR, HWIO_GCC_QDSS_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_QDSS_CFG_AHB_CBCR_IN)
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_QDSS_CENTER_AT_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f00c)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f00c)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f00c)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_RMSK                                                              0x81d0700f
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_CBCR_ADDR, HWIO_GCC_QDSS_CENTER_AT_CBCR_RMSK)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_CENTER_AT_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_CENTER_AT_CBCR_ADDR,m,v,HWIO_GCC_QDSS_CENTER_AT_CBCR_IN)
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QDSS_CENTER_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QDSS_CENTER_AT_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f010)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f010)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f010)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_SREGR_ADDR, HWIO_GCC_QDSS_CENTER_AT_SREGR_RMSK)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_SREGR_ADDR, m)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_CENTER_AT_SREGR_ADDR,v)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_CENTER_AT_SREGR_ADDR,m,v,HWIO_GCC_QDSS_CENTER_AT_SREGR_IN)
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QDSS_CENTER_AT_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f014)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f014)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f014)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ADDR, HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_RMSK)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_ADDR,m,v,HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_IN)
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QDSS_CENTER_AT_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_SOUTH_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f018)
#define HWIO_GCC_SOUTH_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f018)
#define HWIO_GCC_SOUTH_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f018)
#define HWIO_GCC_SOUTH_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_SOUTH_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_SOUTH_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SOUTH_AT_CBCR_ADDR, HWIO_GCC_SOUTH_AT_CBCR_RMSK)
#define HWIO_GCC_SOUTH_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SOUTH_AT_CBCR_ADDR, m)
#define HWIO_GCC_SOUTH_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SOUTH_AT_CBCR_ADDR,v)
#define HWIO_GCC_SOUTH_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SOUTH_AT_CBCR_ADDR,m,v,HWIO_GCC_SOUTH_AT_CBCR_IN)
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_SOUTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_SOUTH_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_SOUTH_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_SOUTH_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_SOUTH_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_SOUTH_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_SOUTH_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_SOUTH_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_WEST_AT_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f01c)
#define HWIO_GCC_WEST_AT_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f01c)
#define HWIO_GCC_WEST_AT_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f01c)
#define HWIO_GCC_WEST_AT_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_WEST_AT_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_WEST_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_WEST_AT_CBCR_ADDR, HWIO_GCC_WEST_AT_CBCR_RMSK)
#define HWIO_GCC_WEST_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_WEST_AT_CBCR_ADDR, m)
#define HWIO_GCC_WEST_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_WEST_AT_CBCR_ADDR,v)
#define HWIO_GCC_WEST_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_WEST_AT_CBCR_ADDR,m,v,HWIO_GCC_WEST_AT_CBCR_IN)
#define HWIO_GCC_WEST_AT_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_WEST_AT_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_WEST_AT_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_WEST_AT_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_WEST_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_WEST_AT_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_WEST_AT_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_WEST_AT_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_WEST_AT_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_WEST_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_WEST_AT_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_WEST_AT_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_WEST_AT_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_WEST_AT_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_WEST_AT_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_WEST_AT_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_WEST_AT_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_WEST_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_WEST_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_NORTH_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f020)
#define HWIO_GCC_NORTH_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f020)
#define HWIO_GCC_NORTH_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f020)
#define HWIO_GCC_NORTH_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_NORTH_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_NORTH_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NORTH_AT_CBCR_ADDR, HWIO_GCC_NORTH_AT_CBCR_RMSK)
#define HWIO_GCC_NORTH_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NORTH_AT_CBCR_ADDR, m)
#define HWIO_GCC_NORTH_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NORTH_AT_CBCR_ADDR,v)
#define HWIO_GCC_NORTH_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NORTH_AT_CBCR_ADDR,m,v,HWIO_GCC_NORTH_AT_CBCR_IN)
#define HWIO_GCC_NORTH_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_NORTH_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_NORTH_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_NORTH_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_NORTH_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_NORTH_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_NORTH_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_NORTH_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_NORTH_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_NORTH_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_NORTH_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_NORTH_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_PHY_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f024)
#define HWIO_GCC_PHY_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f024)
#define HWIO_GCC_PHY_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f024)
#define HWIO_GCC_PHY_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_PHY_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_PHY_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PHY_AT_CBCR_ADDR, HWIO_GCC_PHY_AT_CBCR_RMSK)
#define HWIO_GCC_PHY_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PHY_AT_CBCR_ADDR, m)
#define HWIO_GCC_PHY_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PHY_AT_CBCR_ADDR,v)
#define HWIO_GCC_PHY_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PHY_AT_CBCR_ADDR,m,v,HWIO_GCC_PHY_AT_CBCR_IN)
#define HWIO_GCC_PHY_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_PHY_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_PHY_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_PHY_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_PHY_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_PHY_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_PHY_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_PHY_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_PHY_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_PHY_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_PHY_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_PHY_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_PHY_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_PHY_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_PHY_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_PHY_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_PHY_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_PHY_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_PHY_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_QDSS_ETR_USB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00029094)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029094)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029094)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_QDSS_ETR_USB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ETR_USB_CBCR_ADDR, HWIO_GCC_QDSS_ETR_USB_CBCR_RMSK)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ETR_USB_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ETR_USB_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ETR_USB_CBCR_ADDR,m,v,HWIO_GCC_QDSS_ETR_USB_CBCR_IN)
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_QDSS_ETR_USB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_QDSS_ETR_USB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_QDSS_ETR_USB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ETR_USB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_QDSS_ETR_USB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_QDSS_ETR_USB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_ETR_USB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QDSS_ETR_USB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QDSS_ETR_DDR_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f028)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f028)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f028)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ETR_DDR_CBCR_ADDR, HWIO_GCC_QDSS_ETR_DDR_CBCR_RMSK)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ETR_DDR_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ETR_DDR_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ETR_DDR_CBCR_ADDR,m,v,HWIO_GCC_QDSS_ETR_DDR_CBCR_IN)
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QDSS_ETR_DDR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QDSS_STM_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f02c)
#define HWIO_GCC_QDSS_STM_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f02c)
#define HWIO_GCC_QDSS_STM_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f02c)
#define HWIO_GCC_QDSS_STM_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_QDSS_STM_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_QDSS_STM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_STM_CBCR_ADDR, HWIO_GCC_QDSS_STM_CBCR_RMSK)
#define HWIO_GCC_QDSS_STM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_STM_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_STM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_STM_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_STM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_STM_CBCR_ADDR,m,v,HWIO_GCC_QDSS_STM_CBCR_IN)
#define HWIO_GCC_QDSS_STM_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_QDSS_STM_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_QDSS_STM_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_QDSS_STM_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_QDSS_STM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_QDSS_STM_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_QDSS_STM_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_QDSS_STM_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_QDSS_STM_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_QDSS_STM_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_QDSS_STM_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_STM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f030)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f030)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f030)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_RMSK                                                             0x81d0000f
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CBCR_ADDR, HWIO_GCC_QDSS_TRACECLKIN_CBCR_RMSK)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRACECLKIN_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRACECLKIN_CBCR_ADDR,m,v,HWIO_GCC_QDSS_TRACECLKIN_CBCR_IN)
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QDSS_TSCTR_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f034)
#define HWIO_GCC_QDSS_TSCTR_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f034)
#define HWIO_GCC_QDSS_TSCTR_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f034)
#define HWIO_GCC_QDSS_TSCTR_CBCR_RMSK                                                                  0x81c0000f
#define HWIO_GCC_QDSS_TSCTR_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_QDSS_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TSCTR_CBCR_ADDR, HWIO_GCC_QDSS_TSCTR_CBCR_RMSK)
#define HWIO_GCC_QDSS_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_QDSS_TSCTR_CBCR_IN)
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_QDSS_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_QDSS_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_QDSS_TSCTR_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_QDSS_TSCTR_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_QDSS_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_QDSS_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_TSCTR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QDSS_TRIG_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f038)
#define HWIO_GCC_QDSS_TRIG_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f038)
#define HWIO_GCC_QDSS_TRIG_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f038)
#define HWIO_GCC_QDSS_TRIG_CBCR_RMSK                                                                   0x81d0000f
#define HWIO_GCC_QDSS_TRIG_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_QDSS_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CBCR_ADDR, HWIO_GCC_QDSS_TRIG_CBCR_RMSK)
#define HWIO_GCC_QDSS_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRIG_CBCR_ADDR,m,v,HWIO_GCC_QDSS_TRIG_CBCR_IN)
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_QDSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_QDSS_TRIG_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_QDSS_TRIG_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_QDSS_TRIG_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_QDSS_TRIG_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_QDSS_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_QDSS_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QDSS_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QDSS_DAP_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f03c)
#define HWIO_GCC_QDSS_DAP_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f03c)
#define HWIO_GCC_QDSS_DAP_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f03c)
#define HWIO_GCC_QDSS_DAP_CBCR_RMSK                                                                    0x81c0000f
#define HWIO_GCC_QDSS_DAP_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_QDSS_DAP_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_DAP_CBCR_ADDR, HWIO_GCC_QDSS_DAP_CBCR_RMSK)
#define HWIO_GCC_QDSS_DAP_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_DAP_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_DAP_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_DAP_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_DAP_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_DAP_CBCR_ADDR,m,v,HWIO_GCC_QDSS_DAP_CBCR_IN)
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_QDSS_DAP_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_QDSS_DAP_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_QDSS_DAP_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_QDSS_DAP_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_QDSS_DAP_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_QDSS_DAP_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_QDSS_DAP_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_QDSS_DAP_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_QDSS_DAP_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_QDSS_DAP_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_DAP_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_CENTER_APB_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f040)
#define HWIO_GCC_CENTER_APB_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f040)
#define HWIO_GCC_CENTER_APB_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f040)
#define HWIO_GCC_CENTER_APB_CBCR_RMSK                                                                  0x81c0000f
#define HWIO_GCC_CENTER_APB_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_CENTER_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CENTER_APB_CBCR_ADDR, HWIO_GCC_CENTER_APB_CBCR_RMSK)
#define HWIO_GCC_CENTER_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CENTER_APB_CBCR_ADDR, m)
#define HWIO_GCC_CENTER_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CENTER_APB_CBCR_ADDR,v)
#define HWIO_GCC_CENTER_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CENTER_APB_CBCR_ADDR,m,v,HWIO_GCC_CENTER_APB_CBCR_IN)
#define HWIO_GCC_CENTER_APB_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_CENTER_APB_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_CENTER_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_CENTER_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_CENTER_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_CENTER_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_CENTER_APB_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_CENTER_APB_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_CENTER_APB_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_CENTER_APB_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_CENTER_APB_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_CENTER_APB_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_CENTER_APB_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_CENTER_APB_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CENTER_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_NORTH_APB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f044)
#define HWIO_GCC_NORTH_APB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f044)
#define HWIO_GCC_NORTH_APB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f044)
#define HWIO_GCC_NORTH_APB_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_NORTH_APB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_NORTH_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NORTH_APB_CBCR_ADDR, HWIO_GCC_NORTH_APB_CBCR_RMSK)
#define HWIO_GCC_NORTH_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NORTH_APB_CBCR_ADDR, m)
#define HWIO_GCC_NORTH_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NORTH_APB_CBCR_ADDR,v)
#define HWIO_GCC_NORTH_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NORTH_APB_CBCR_ADDR,m,v,HWIO_GCC_NORTH_APB_CBCR_IN)
#define HWIO_GCC_NORTH_APB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_NORTH_APB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_NORTH_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_NORTH_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_NORTH_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_NORTH_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_NORTH_APB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_NORTH_APB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_NORTH_APB_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_NORTH_APB_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_NORTH_APB_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_NORTH_APB_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_NORTH_APB_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_NORTH_APB_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_NORTH_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SOUTH_APB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f048)
#define HWIO_GCC_SOUTH_APB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f048)
#define HWIO_GCC_SOUTH_APB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f048)
#define HWIO_GCC_SOUTH_APB_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_SOUTH_APB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_SOUTH_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SOUTH_APB_CBCR_ADDR, HWIO_GCC_SOUTH_APB_CBCR_RMSK)
#define HWIO_GCC_SOUTH_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SOUTH_APB_CBCR_ADDR, m)
#define HWIO_GCC_SOUTH_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SOUTH_APB_CBCR_ADDR,v)
#define HWIO_GCC_SOUTH_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SOUTH_APB_CBCR_ADDR,m,v,HWIO_GCC_SOUTH_APB_CBCR_IN)
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_SOUTH_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_SOUTH_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_SOUTH_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_SOUTH_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_SOUTH_APB_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_SOUTH_APB_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_SOUTH_APB_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_SOUTH_APB_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_SOUTH_APB_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_SOUTH_APB_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_SOUTH_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_WEST_APB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f04c)
#define HWIO_GCC_WEST_APB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f04c)
#define HWIO_GCC_WEST_APB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f04c)
#define HWIO_GCC_WEST_APB_CBCR_RMSK                                                                    0x81c0000f
#define HWIO_GCC_WEST_APB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_WEST_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_WEST_APB_CBCR_ADDR, HWIO_GCC_WEST_APB_CBCR_RMSK)
#define HWIO_GCC_WEST_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_WEST_APB_CBCR_ADDR, m)
#define HWIO_GCC_WEST_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_WEST_APB_CBCR_ADDR,v)
#define HWIO_GCC_WEST_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_WEST_APB_CBCR_ADDR,m,v,HWIO_GCC_WEST_APB_CBCR_IN)
#define HWIO_GCC_WEST_APB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_WEST_APB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_WEST_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_WEST_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_WEST_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_WEST_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_WEST_APB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_WEST_APB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_WEST_APB_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_WEST_APB_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_WEST_APB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_WEST_APB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_WEST_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_WEST_APB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_WEST_APB_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_WEST_APB_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_WEST_APB_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_WEST_APB_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_WEST_APB_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_WEST_APB_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_WEST_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_WEST_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_EAST_APB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f050)
#define HWIO_GCC_EAST_APB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f050)
#define HWIO_GCC_EAST_APB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f050)
#define HWIO_GCC_EAST_APB_CBCR_RMSK                                                                    0x81c0000f
#define HWIO_GCC_EAST_APB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_EAST_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_EAST_APB_CBCR_ADDR, HWIO_GCC_EAST_APB_CBCR_RMSK)
#define HWIO_GCC_EAST_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_EAST_APB_CBCR_ADDR, m)
#define HWIO_GCC_EAST_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_EAST_APB_CBCR_ADDR,v)
#define HWIO_GCC_EAST_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_EAST_APB_CBCR_ADDR,m,v,HWIO_GCC_EAST_APB_CBCR_IN)
#define HWIO_GCC_EAST_APB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_EAST_APB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_EAST_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_EAST_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_EAST_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_EAST_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_EAST_APB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_EAST_APB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_EAST_APB_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_EAST_APB_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_EAST_APB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_EAST_APB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_EAST_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_EAST_APB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_EAST_APB_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_EAST_APB_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_EAST_APB_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_EAST_APB_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_EAST_APB_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_EAST_APB_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_EAST_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_EAST_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_MMNOC_APB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f054)
#define HWIO_GCC_MMNOC_APB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f054)
#define HWIO_GCC_MMNOC_APB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f054)
#define HWIO_GCC_MMNOC_APB_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_MMNOC_APB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_MMNOC_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_APB_CBCR_ADDR, HWIO_GCC_MMNOC_APB_CBCR_RMSK)
#define HWIO_GCC_MMNOC_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_APB_CBCR_ADDR, m)
#define HWIO_GCC_MMNOC_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_APB_CBCR_ADDR,v)
#define HWIO_GCC_MMNOC_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_APB_CBCR_ADDR,m,v,HWIO_GCC_MMNOC_APB_CBCR_IN)
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_MMNOC_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_MMNOC_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_MMNOC_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_MMNOC_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_MMNOC_APB_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_MMNOC_APB_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_MMNOC_APB_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_MMNOC_APB_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_MMNOC_APB_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MMNOC_APB_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MMNOC_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QDSS_XO_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f058)
#define HWIO_GCC_QDSS_XO_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f058)
#define HWIO_GCC_QDSS_XO_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f058)
#define HWIO_GCC_QDSS_XO_CBCR_RMSK                                                                     0x81c0000f
#define HWIO_GCC_QDSS_XO_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_QDSS_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_XO_CBCR_ADDR, HWIO_GCC_QDSS_XO_CBCR_RMSK)
#define HWIO_GCC_QDSS_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_XO_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_XO_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_XO_CBCR_ADDR,m,v,HWIO_GCC_QDSS_XO_CBCR_IN)
#define HWIO_GCC_QDSS_XO_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_QDSS_XO_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_QDSS_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_QDSS_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_QDSS_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_QDSS_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_QDSS_XO_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_QDSS_XO_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_QDSS_XO_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_QDSS_XO_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_QDSS_XO_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_QDSS_XO_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_QDSS_XO_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_QDSS_XO_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_QDSS_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_QDSS_USB_PRIM_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00029090)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029090)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029090)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_RMSK                                                               0x81c0000f
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_USB_PRIM_CBCR_ADDR, HWIO_GCC_QDSS_USB_PRIM_CBCR_RMSK)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_USB_PRIM_CBCR_ADDR, m)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_USB_PRIM_CBCR_ADDR,v)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_USB_PRIM_CBCR_ADDR,m,v,HWIO_GCC_QDSS_USB_PRIM_CBCR_IN)
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QDSS_USB_PRIM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f078)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f078)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f078)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f07c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f07c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f07c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f080)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f080)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f080)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f084)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f084)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f084)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f088)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f088)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f088)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f08c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f08c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f08c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f090)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f090)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f090)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f094)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f094)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f094)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f098)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f098)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f098)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f09c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f09c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f09c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0a0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0a0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0a0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f0b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f0b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f0b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_A_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f05c)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f05c)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f05c)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_RMSK                                                              0x80000013
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ADDR, HWIO_GCC_QDSS_ATB_A_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_A_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_A_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f060)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f060)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f060)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RMSK                                                                0x11071f
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ADDR, HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_A_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_A_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                 0x10000
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                    0x10
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                     0x0
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                    0x1
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_QDSS_ATB_A_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1a4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1a8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1ac)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1b0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1b4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1b8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1b8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1b8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1bc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1bc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1bc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1c0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1c0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1c0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1c4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1c4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1c4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1c8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1c8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1c8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1cc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1cc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1cc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f1e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f1e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f1e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_B_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f188)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f188)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f188)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_RMSK                                                              0x80000013
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ADDR, HWIO_GCC_QDSS_ATB_B_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_B_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_B_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f18c)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f18c)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f18c)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RMSK                                                                0x11071f
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ADDR, HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_B_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_B_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                 0x10000
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                    0x10
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                     0x0
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                    0x1
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_QDSS_ATB_B_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2d0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2d4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2d8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2dc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2e0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2e4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2e4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2e4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2e8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2e8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2e8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2ec)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2ec)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2ec)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2f0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2f0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2f0)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2f4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2f4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2f4)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2f8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2f8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2f8)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2fc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2fc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2fc)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f300)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f300)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f300)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f304)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f304)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f304)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f308)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f308)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f308)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f30c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f30c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f30c)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_ATB_C_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2b4)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2b4)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2b4)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_RMSK                                                              0x80000013
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ADDR, HWIO_GCC_QDSS_ATB_C_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_C_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_C_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f2b8)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f2b8)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f2b8)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RMSK                                                                0x11071f
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ADDR, HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_ATB_C_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_ATB_C_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                 0x10000
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                    0x10
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                     0x0
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                    0x1
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_QDSS_ATB_C_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f3fc)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f3fc)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f3fc)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f400)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f400)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f400)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f404)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f404)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f404)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f408)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f408)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f408)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f40c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f40c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f40c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f410)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f410)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f410)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f414)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f414)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f414)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f418)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f418)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f418)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f41c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f41c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f41c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f420)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f420)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f420)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_RMSK                                                      0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ATTR                                                        0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_BMSK                                              0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SHFT                                                0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                           0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                           0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                           0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_BMSK                                               0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_SHFT                                                0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                           0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                           0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                           0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                         0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                           0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                         0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                           0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                         0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                           0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                         0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                           0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                        0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                          0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                        0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                         0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                       0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                         0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                       0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                         0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                       0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                         0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                       0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                         0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                       0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                         0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                       0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                         0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f424)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f424)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f424)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f428)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f428)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f428)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f42c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f42c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f42c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f430)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f430)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f430)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f434)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f434)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f434)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f438)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f438)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f438)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_STM_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_QDSS_STM_CMD_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f3e0)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f3e0)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f3e0)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_RMSK                                                                0x80000013
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_STM_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_STM_CMD_RCGR_ADDR, HWIO_GCC_QDSS_STM_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_STM_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_STM_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_STM_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_STM_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_OFF_SHFT                                                             0x1f
#define HWIO_GCC_QDSS_STM_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                       0x10
#define HWIO_GCC_QDSS_STM_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                        0x4
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_EN_BMSK                                                               0x2
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_EN_SHFT                                                               0x1
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QDSS_STM_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_QDSS_STM_CMD_RCGR_UPDATE_BMSK                                                                0x1
#define HWIO_GCC_QDSS_STM_CMD_RCGR_UPDATE_SHFT                                                                0x0
#define HWIO_GCC_QDSS_STM_CMD_RCGR_UPDATE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QDSS_STM_CMD_RCGR_UPDATE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_QDSS_STM_CFG_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f3e4)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f3e4)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f3e4)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_RMSK                                                                  0x11071f
#define HWIO_GCC_QDSS_STM_CFG_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_QDSS_STM_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_STM_CFG_RCGR_ADDR, HWIO_GCC_QDSS_STM_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_STM_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_STM_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_STM_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_STM_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_STM_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                   0x100000
#define HWIO_GCC_QDSS_STM_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                       0x14
#define HWIO_GCC_QDSS_STM_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_QDSS_STM_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_QDSS_STM_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                   0x10000
#define HWIO_GCC_QDSS_STM_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                      0x10
#define HWIO_GCC_QDSS_STM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                       0x0
#define HWIO_GCC_QDSS_STM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                      0x1
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_BMSK                                                             0x700
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SHFT                                                               0x8
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                          0x0
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                          0x1
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                          0x2
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                          0x3
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                          0x4
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                          0x5
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                          0x6
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                          0x7
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_BMSK                                                              0x1f
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_SHFT                                                               0x0
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                        0x0
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                          0x1
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                        0x2
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                          0x3
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                        0x4
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                          0x5
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                        0x6
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                          0x7
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                        0x8
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                          0x9
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                        0xa
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                          0xb
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                        0xc
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                          0xd
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                        0xe
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                          0xf
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                       0x10
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                         0x11
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                       0x12
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                        0x13
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                      0x14
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                        0x15
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                      0x16
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                        0x17
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                      0x18
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                        0x19
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                      0x1a
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                        0x1b
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                      0x1c
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                        0x1d
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                      0x1e
#define HWIO_GCC_QDSS_STM_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                        0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f528)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f528)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f528)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f52c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f52c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f52c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f530)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f530)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f530)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f534)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f534)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f534)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f538)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f538)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f538)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f53c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f53c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f53c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f540)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f540)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f540)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f544)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f544)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f544)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f548)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f548)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f548)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f54c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f54c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f54c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f550)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f550)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f550)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f554)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f554)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f554)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f558)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f558)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f558)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f55c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f55c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f55c)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f560)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f560)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f560)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f564)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f564)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f564)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_QDSS_TRACECLKIN_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f50c)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f50c)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f50c)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_RMSK                                                         0x80000013
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ATTR                                                                0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ADDR, HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_OFF_BMSK                                                0x80000000
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_OFF_SHFT                                                      0x1f
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                0x10
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                 0x4
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_EN_BMSK                                                        0x2
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_EN_SHFT                                                        0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_UPDATE_BMSK                                                         0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_UPDATE_SHFT                                                         0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_UPDATE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CMD_RCGR_UPDATE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f510)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f510)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f510)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RMSK                                                           0x11071f
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ATTR                                                                0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ADDR, HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_HW_CLK_CONTROL_BMSK                                            0x100000
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                0x14
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                         0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RCGLITE_DISABLE_BMSK                                            0x10000
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RCGLITE_DISABLE_SHFT                                               0x10
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                               0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_BMSK                                                      0x700
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SHFT                                                        0x8
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                   0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                   0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                   0x2
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                   0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                   0x4
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                   0x5
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                   0x6
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                   0x7
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_BMSK                                                       0x1f
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_SHFT                                                        0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                 0x0
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                   0x1
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                 0x2
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                   0x3
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                 0x4
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                   0x5
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                 0x6
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                   0x7
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                 0x8
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                   0x9
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                 0xa
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                   0xb
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                 0xc
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                   0xd
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                 0xe
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                   0xf
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                0x10
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                  0x11
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                0x12
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                 0x13
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                               0x14
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                 0x15
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                               0x16
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                 0x17
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                               0x18
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                 0x19
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                               0x1a
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                 0x1b
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                               0x1c
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                 0x1d
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                               0x1e
#define HWIO_GCC_QDSS_TRACECLKIN_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                 0x1f

#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f638)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f638)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f638)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ADDR, HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f63c)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f63c)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f63c)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ADDR, HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QDSS_APB_TSCTR_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f66c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f66c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f66c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f670)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f670)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f670)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f674)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f674)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f674)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f678)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f678)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f678)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f67c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f67c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f67c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f680)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f680)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f680)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f684)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f684)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f684)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f688)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f688)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f688)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f68c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f68c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f68c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f690)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f690)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f690)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_RMSK                                                     0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ATTR                                                       0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_BMSK                                             0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SHFT                                               0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                          0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                          0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                          0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_BMSK                                              0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_SHFT                                               0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                        0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                          0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                        0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                          0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                        0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                          0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                        0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                          0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                        0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                          0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                        0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                          0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                        0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                          0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                        0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                          0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                       0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                         0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                       0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                        0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                      0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                        0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                      0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                        0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                      0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                        0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                      0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                        0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                      0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                        0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                      0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                        0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f694)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f694)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f694)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f698)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f698)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f698)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f69c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f69c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f69c)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f6a0)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f6a0)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f6a0)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f6a4)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f6a4)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f6a4)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f6a8)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f6a8)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f6a8)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_RMSK                                                    0x71f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ATTR                                                      0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_BMSK                                            0x700
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SHFT                                              0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                         0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                         0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                         0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                         0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_BMSK                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_SHFT                                              0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                       0x0
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                         0x1
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                       0x2
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                         0x3
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                       0x4
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                         0x5
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                       0x6
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                         0x7
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                       0x8
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                         0x9
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                       0xa
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                         0xb
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                       0xc
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                         0xd
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                       0xe
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                         0xf
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                      0x10
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                        0x11
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                      0x12
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                       0x13
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                     0x14
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                       0x15
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                     0x16
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                       0x17
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                     0x18
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                       0x19
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                     0x1a
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                       0x1b
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                     0x1c
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                       0x1d
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                     0x1e
#define HWIO_GCC_RPMH_SYS_NOC_QDSS_TRIG_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                       0x1f

#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f650)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f650)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f650)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CMD_RCGR_ADDR, HWIO_GCC_QDSS_TRIG_CMD_RCGR_RMSK)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRIG_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRIG_CMD_RCGR_ADDR,m,v,HWIO_GCC_QDSS_TRIG_CMD_RCGR_IN)
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QDSS_TRIG_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000f654)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000f654)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000f654)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CFG_RCGR_ADDR, HWIO_GCC_QDSS_TRIG_CFG_RCGR_RMSK)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QDSS_TRIG_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QDSS_TRIG_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QDSS_TRIG_CFG_RCGR_ADDR,m,v,HWIO_GCC_QDSS_TRIG_CFG_RCGR_IN)
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_QDSS_TRIG_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_USB30_PRIM_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00029000)
#define HWIO_GCC_USB30_PRIM_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029000)
#define HWIO_GCC_USB30_PRIM_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029000)
#define HWIO_GCC_USB30_PRIM_BCR_RMSK                                                                          0x1
#define HWIO_GCC_USB30_PRIM_BCR_ATTR                                                                          0x3
#define HWIO_GCC_USB30_PRIM_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_BCR_ADDR, HWIO_GCC_USB30_PRIM_BCR_RMSK)
#define HWIO_GCC_USB30_PRIM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_BCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_BCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_BCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_BCR_IN)
#define HWIO_GCC_USB30_PRIM_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_USB30_PRIM_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_USB30_PRIM_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_USB30_PRIM_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_USB30_PRIM_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00029004)
#define HWIO_GCC_USB30_PRIM_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029004)
#define HWIO_GCC_USB30_PRIM_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029004)
#define HWIO_GCC_USB30_PRIM_GDSCR_RMSK                                                                 0xf8ffffff
#define HWIO_GCC_USB30_PRIM_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_USB30_PRIM_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_GDSCR_ADDR, HWIO_GCC_USB30_PRIM_GDSCR_RMSK)
#define HWIO_GCC_USB30_PRIM_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_GDSCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_GDSCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_GDSCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_GDSCR_IN)
#define HWIO_GCC_USB30_PRIM_GDSCR_PWR_ON_BMSK                                                          0x80000000
#define HWIO_GCC_USB30_PRIM_GDSCR_PWR_ON_SHFT                                                                0x1f
#define HWIO_GCC_USB30_PRIM_GDSCR_GDSC_STATE_BMSK                                                      0x78000000
#define HWIO_GCC_USB30_PRIM_GDSCR_GDSC_STATE_SHFT                                                            0x1b
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_WAIT_BMSK                                                      0xf00000
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_WAIT_SHFT                                                          0x14
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_WAIT_BMSK                                                        0xf0000
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_WAIT_SHFT                                                           0x10
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DIS_WAIT_BMSK                                                        0xf000
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DIS_WAIT_SHFT                                                           0xc
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x800
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_FF_ENABLE_SHFT                                                       0xb
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_RESTORE_BMSK                                                              0x400
#define HWIO_GCC_USB30_PRIM_GDSCR_RESTORE_SHFT                                                                0xa
#define HWIO_GCC_USB30_PRIM_GDSCR_RESTORE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_RESTORE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_SAVE_BMSK                                                                 0x200
#define HWIO_GCC_USB30_PRIM_GDSCR_SAVE_SHFT                                                                   0x9
#define HWIO_GCC_USB30_PRIM_GDSCR_SAVE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_SAVE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_BMSK                                                               0x100
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_SHFT                                                                 0x8
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_RETAIN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_BMSK                                                               0x80
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_SHFT                                                                0x7
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_REST_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_BMSK                                                                0x40
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_SHFT                                                                 0x6
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_EN_FEW_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_CLAMP_IO_BMSK                                                              0x20
#define HWIO_GCC_USB30_PRIM_GDSCR_CLAMP_IO_SHFT                                                               0x5
#define HWIO_GCC_USB30_PRIM_GDSCR_CLAMP_IO_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_CLAMP_IO_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DISABLE_BMSK                                                           0x10
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DISABLE_SHFT                                                            0x4
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                            0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                             0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_PD_ARES_BMSK                                                                0x8
#define HWIO_GCC_USB30_PRIM_GDSCR_PD_ARES_SHFT                                                                0x3
#define HWIO_GCC_USB30_PRIM_GDSCR_PD_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_PD_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_OVERRIDE_BMSK                                                            0x4
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_OVERRIDE_SHFT                                                            0x2
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_HW_CONTROL_BMSK                                                             0x2
#define HWIO_GCC_USB30_PRIM_GDSCR_HW_CONTROL_SHFT                                                             0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_HW_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_HW_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_COLLAPSE_BMSK                                                            0x1
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_COLLAPSE_SHFT                                                            0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_USB30_PRIM_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00029008)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029008)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029008)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG_GDSCR_ADDR, HWIO_GCC_USB30_PRIM_CFG_GDSCR_RMSK)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_CFG_GDSCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_CFG_GDSCR_IN)
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                   0x4000000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x1a
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                           0x2000000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                0x19
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                            0x1000000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                 0x18
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                     0xf00000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                         0x14
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                        0x80000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                           0x13
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                            0x40000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                               0x12
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                            0x20000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                               0x11
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                         0x10000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                            0x10
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                        0x8000
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                           0xf
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                       0x7800
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                          0xb
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                               0x400
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                 0xa
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                        0x200
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                          0x9
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                        0x100
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                          0x8
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                            0x80
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                             0x7
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                   0x60
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                    0x5
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                             0x10
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                              0x4
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                       0x8
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                       0x3
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                     0x4
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                     0x2
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                         0x2
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                         0x1
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                      0x1
#define HWIO_GCC_USB30_PRIM_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                      0x0

#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0002900c)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002900c)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002900c)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_RMSK                                                               0x7ffff
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ADDR, HWIO_GCC_USB30_PRIM_CFG2_GDSCR_RMSK)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_CFG2_GDSCR_IN)
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                   0x40000
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                      0x12
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                               0x20000
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                  0x11
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                             0x10000
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                0x10
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                 0xf000
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                    0xc
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                          0xf00
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                            0x8
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                             0xf0
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                              0x4
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                               0xf
#define HWIO_GCC_USB30_PRIM_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                               0x0

#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00029010)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029010)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029010)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_RMSK                                                             0x7ffffff
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ADDR, HWIO_GCC_USB30_PRIM_CFG3_GDSCR_RMSK)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_CFG3_GDSCR_IN)
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                           0x4000000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                0x1a
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                        0x2000000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                             0x19
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                   0x1e00000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                        0x15
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                    0x100000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                        0x14
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                 0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                  0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                           0x80000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                              0x13
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                       0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                        0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                               0x40000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                  0x12
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                           0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                            0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                0x20000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                   0x11
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                     0x10000
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                        0x10
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                             0xff00
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                0x8
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                              0xff
#define HWIO_GCC_USB30_PRIM_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                               0x0

#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00029014)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029014)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029014)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_RMSK                                                              0xffffff
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ADDR, HWIO_GCC_USB30_PRIM_CFG4_GDSCR_RMSK)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_CFG4_GDSCR_IN)
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                0xf00000
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                    0x14
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                 0xf0000
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                    0x10
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                 0xf000
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                    0xc
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                0xf00
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                  0x8
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                      0xf0
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                       0x4
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                      0xf
#define HWIO_GCC_USB30_PRIM_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                      0x0

#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00029018)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029018)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029018)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_RMSK                                                           0x81c07005
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CBCR_ADDR, HWIO_GCC_USB30_PRIM_MASTER_CBCR_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CBCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_CBCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_CBCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_CBCR_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_CORE_ON_BMSK                                             0x4000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_CORE_ON_SHFT                                                0xe
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                           0x2000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                              0xd
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                          0x1000
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                             0xc
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002901c)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002901c)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002901c)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_RMSK                                                           0xf1ffffe
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_ATTR                                                                 0x3
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_SREGR_ADDR, HWIO_GCC_USB30_PRIM_MASTER_SREGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_SREGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_SREGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_SREGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_SREGR_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                 0xf000000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                      0x18
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PWR_FSM_CLK_SEL_BMSK                                            0x100000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PWR_FSM_CLK_SEL_SHFT                                                0x14
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                    0xf0000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                       0x10
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                      0x8000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                         0xf
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                  0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                       0x4000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                          0xe
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                          0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                       0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                      0x2000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                         0xd
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                             0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                  0x1000
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                     0xc
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                            0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                               0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CORE_ON_ACK_BMSK                                               0x800
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CORE_ON_ACK_SHFT                                                 0xb
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_PERIPH_ON_ACK_BMSK                                             0x400
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_PERIPH_ON_ACK_SHFT                                               0xa
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                      0x300
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                        0x8
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                               0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                               0x2
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                               0x3
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_ENABLE_BMSK                                                 0x80
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_ENABLE_SHFT                                                  0x7
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_FORCE_CLK_ON_BMSK                                                   0x40
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_FORCE_CLK_ON_SHFT                                                    0x6
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                           0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SEL_SLP_STG_BMSK                                             0x20
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SEL_SLP_STG_SHFT                                              0x5
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                     0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SLP_STG_BMSK                                                 0x10
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SLP_STG_SHFT                                                  0x4
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                        0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                           0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                0x8
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                0x3
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                     0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                        0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                           0x4
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                           0x2
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SLP_STG_BMSK                                               0x2
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SLP_STG_SHFT                                               0x1
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                         0x0
#define HWIO_GCC_USB30_PRIM_MASTER_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                          0x1

#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00029020)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029020)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029020)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_RMSK                                                      0xffffffff
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ATTR                                                             0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ADDR, HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                   0xfc000000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                         0x1a
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                              0x2000000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                   0x19
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                0x1000000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                     0x18
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                   0x800000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                       0x17
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                     0x400000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                         0x16
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CPH_TIMER_BMSK                                          0x3f0000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_MEM_CPH_TIMER_SHFT                                              0x10
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_SLEEP_TIMER_BMSK                                              0xff00
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_SLEEP_TIMER_SHFT                                                 0x8
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_WAKEUP_TIMER_BMSK                                               0xff
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_SREGR_WAKEUP_TIMER_SHFT                                                0x0

#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00029024)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029024)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029024)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_RMSK                                                            0x81c00005
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ADDR, HWIO_GCC_USB30_PRIM_SLEEP_CBCR_RMSK)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_SLEEP_CBCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IN)
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_USB30_PRIM_SLEEP_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00029028)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029028)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029028)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_RMSK                                                        0x81c00005
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ATTR                                                               0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ADDR, HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_RMSK)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IN)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IGNORE_ALL_ARES_BMSK                                         0x1000000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IGNORE_ALL_ARES_SHFT                                              0x18
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                       0x800000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                           0x17
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_DIS_BMSK                                                  0x400000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_DIS_SHFT                                                      0x16
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ARES_BMSK                                                      0x4
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ARES_SHFT                                                      0x2
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ARES_NO_RESET_FVAL                                             0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ARES_RESET_FVAL                                                0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CBCR_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002902c)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002902c)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002902c)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_RMSK                                                       0x800000f3
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ATTR                                                              0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ADDR, HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_OFF_BMSK                                              0x80000000
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_OFF_SHFT                                                    0x1f
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_D_BMSK                                                     0x80
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_D_SHFT                                                      0x7
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_N_BMSK                                                     0x40
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_N_SHFT                                                      0x6
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_M_BMSK                                                     0x20
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_M_SHFT                                                      0x5
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                              0x10
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                               0x4
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_EN_BMSK                                                      0x2
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_EN_SHFT                                                      0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                              0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                               0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_UPDATE_BMSK                                                       0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_UPDATE_SHFT                                                       0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_UPDATE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CMD_RCGR_UPDATE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00029030)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029030)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029030)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_RMSK                                                         0x10371f
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ATTR                                                              0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ADDR, HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_HW_CLK_CONTROL_BMSK                                          0x100000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_HW_CLK_CONTROL_SHFT                                              0x14
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                       0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                        0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_BMSK                                                      0x3000
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_SHFT                                                         0xc
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_SWALLOW_FVAL                                                 0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                               0x2
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                             0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_USB30_PRIM_MASTER_CFG_RCGR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_USB30_PRIM_MASTER_M_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00029034)
#define HWIO_GCC_USB30_PRIM_MASTER_M_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029034)
#define HWIO_GCC_USB30_PRIM_MASTER_M_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029034)
#define HWIO_GCC_USB30_PRIM_MASTER_M_RMSK                                                                    0xff
#define HWIO_GCC_USB30_PRIM_MASTER_M_ATTR                                                                     0x3
#define HWIO_GCC_USB30_PRIM_MASTER_M_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_M_ADDR, HWIO_GCC_USB30_PRIM_MASTER_M_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_M_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_M_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_M_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_M_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_M_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_M_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_M_M_BMSK                                                                  0xff
#define HWIO_GCC_USB30_PRIM_MASTER_M_M_SHFT                                                                   0x0

#define HWIO_GCC_USB30_PRIM_MASTER_N_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00029038)
#define HWIO_GCC_USB30_PRIM_MASTER_N_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029038)
#define HWIO_GCC_USB30_PRIM_MASTER_N_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029038)
#define HWIO_GCC_USB30_PRIM_MASTER_N_RMSK                                                                    0xff
#define HWIO_GCC_USB30_PRIM_MASTER_N_ATTR                                                                     0x3
#define HWIO_GCC_USB30_PRIM_MASTER_N_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_N_ADDR, HWIO_GCC_USB30_PRIM_MASTER_N_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_N_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_N_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_N_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_N_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_N_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_N_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_N_NOT_N_MINUS_M_BMSK                                                      0xff
#define HWIO_GCC_USB30_PRIM_MASTER_N_NOT_N_MINUS_M_SHFT                                                       0x0

#define HWIO_GCC_USB30_PRIM_MASTER_D_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0002903c)
#define HWIO_GCC_USB30_PRIM_MASTER_D_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002903c)
#define HWIO_GCC_USB30_PRIM_MASTER_D_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002903c)
#define HWIO_GCC_USB30_PRIM_MASTER_D_RMSK                                                                    0xff
#define HWIO_GCC_USB30_PRIM_MASTER_D_ATTR                                                                     0x3
#define HWIO_GCC_USB30_PRIM_MASTER_D_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_D_ADDR, HWIO_GCC_USB30_PRIM_MASTER_D_RMSK)
#define HWIO_GCC_USB30_PRIM_MASTER_D_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MASTER_D_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MASTER_D_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MASTER_D_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MASTER_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MASTER_D_ADDR,m,v,HWIO_GCC_USB30_PRIM_MASTER_D_IN)
#define HWIO_GCC_USB30_PRIM_MASTER_D_NOT_2D_BMSK                                                             0xff
#define HWIO_GCC_USB30_PRIM_MASTER_D_NOT_2D_SHFT                                                              0x0

#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00029044)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029044)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029044)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_RMSK                                                    0x80000013
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ATTR                                                           0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ADDR, HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_IN)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_OFF_BMSK                                           0x80000000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_OFF_SHFT                                                 0x1f
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                           0x10
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                            0x4
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_EN_BMSK                                                   0x2
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_EN_SHFT                                                   0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                           0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                            0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_UPDATE_BMSK                                                    0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_UPDATE_SHFT                                                    0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_UPDATE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CMD_RCGR_UPDATE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00029048)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029048)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029048)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RMSK                                                      0x11071f
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ATTR                                                           0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ADDR, HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RMSK)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_IN)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                       0x100000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                           0x14
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                    0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                     0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                       0x10000
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                          0x10
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                           0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                          0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0002905c)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002905c)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002905c)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_RMSK                                                      0xf
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ATTR                                                      0x3
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ADDR, HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_RMSK)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ADDR, m)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ADDR,v)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_ADDR,m,v,HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_IN)
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_CLK_DIV_BMSK                                              0xf
#define HWIO_GCC_USB30_PRIM_MOCK_UTMI_POSTDIV_CDIVR_CLK_DIV_SHFT                                              0x0

#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00029060)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029060)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029060)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_RMSK                                                           0x81c00005
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ADDR, HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00029064)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029064)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029064)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_RMSK                                                       0x81c00005
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ATTR                                                              0x3
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ADDR, HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_OFF_BMSK                                               0x80000000
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_OFF_SHFT                                                     0x1f
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                        0x1000000
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                             0x18
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                      0x800000
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                          0x17
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_DIS_BMSK                                                 0x400000
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_DIS_SHFT                                                     0x16
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ARES_BMSK                                                     0x4
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ARES_SHFT                                                     0x2
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                            0x0
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ARES_RESET_FVAL                                               0x1
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ENABLE_BMSK                                                   0x1
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ENABLE_SHFT                                                   0x0
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_USB3_PRIM_PHY_COM_AUX_CBCR_CLK_ENABLE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00029068)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029068)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029068)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_RMSK                                                          0x81c0000f
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ADDR, HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_USB3_PRIM_PHY_PIPE_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00029070)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029070)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029070)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_RMSK                                                       0x80000013
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ATTR                                                              0x3
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ADDR, HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_OFF_BMSK                                              0x80000000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_OFF_SHFT                                                    0x1f
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                              0x10
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                               0x4
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_EN_BMSK                                                      0x2
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_EN_SHFT                                                      0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                              0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                               0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_UPDATE_BMSK                                                       0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_UPDATE_SHFT                                                       0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_UPDATE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00029074)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00029074)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00029074)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RMSK                                                         0x11071f
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ATTR                                                              0x3
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ADDR, HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RMSK)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_ADDR,m,v,HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_IN)
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                          0x100000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                              0x14
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                       0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                        0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                          0x10000
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                             0x10
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                              0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                             0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_USB3_PRIM_PHY_AUX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_USB3_PHY_PRIM_BCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00040000)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040000)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040000)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_RMSK                                                                       0x1
#define HWIO_GCC_USB3_PHY_PRIM_BCR_ATTR                                                                       0x3
#define HWIO_GCC_USB3_PHY_PRIM_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_PRIM_BCR_ADDR, HWIO_GCC_USB3_PHY_PRIM_BCR_RMSK)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_PRIM_BCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_PRIM_BCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_PRIM_BCR_ADDR,m,v,HWIO_GCC_USB3_PHY_PRIM_BCR_IN)
#define HWIO_GCC_USB3_PHY_PRIM_BCR_BLK_ARES_BMSK                                                              0x1
#define HWIO_GCC_USB3_PHY_PRIM_BCR_BLK_ARES_SHFT                                                              0x0
#define HWIO_GCC_USB3_PHY_PRIM_BCR_BLK_ARES_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_USB3_PHY_PRIM_BCR_BLK_ARES_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00040004)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040004)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040004)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_RMSK                                                                    0x1
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ATTR                                                                    0x3
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ADDR, HWIO_GCC_USB3PHY_PHY_PRIM_BCR_RMSK)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ADDR, m)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ADDR,v)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3PHY_PHY_PRIM_BCR_ADDR,m,v,HWIO_GCC_USB3PHY_PHY_PRIM_BCR_IN)
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_BLK_ARES_BMSK                                                           0x1
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_BLK_ARES_SHFT                                                           0x0
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_BLK_ARES_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_USB3PHY_PHY_PRIM_BCR_BLK_ARES_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00040008)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040008)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040008)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_RMSK                                                                    0x1
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ATTR                                                                    0x3
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ADDR, HWIO_GCC_USB3_DP_PHY_PRIM_BCR_RMSK)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ADDR, m)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ADDR,v)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_DP_PHY_PRIM_BCR_ADDR,m,v,HWIO_GCC_USB3_DP_PHY_PRIM_BCR_IN)
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_BLK_ARES_BMSK                                                           0x1
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_BLK_ARES_SHFT                                                           0x0
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_BLK_ARES_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_USB3_DP_PHY_PRIM_BCR_BLK_ARES_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_USB3_PHY_SEC_BCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0004000c)
#define HWIO_GCC_USB3_PHY_SEC_BCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004000c)
#define HWIO_GCC_USB3_PHY_SEC_BCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004000c)
#define HWIO_GCC_USB3_PHY_SEC_BCR_RMSK                                                                        0x1
#define HWIO_GCC_USB3_PHY_SEC_BCR_ATTR                                                                        0x3
#define HWIO_GCC_USB3_PHY_SEC_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_SEC_BCR_ADDR, HWIO_GCC_USB3_PHY_SEC_BCR_RMSK)
#define HWIO_GCC_USB3_PHY_SEC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_SEC_BCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_SEC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_SEC_BCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_SEC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_SEC_BCR_ADDR,m,v,HWIO_GCC_USB3_PHY_SEC_BCR_IN)
#define HWIO_GCC_USB3_PHY_SEC_BCR_BLK_ARES_BMSK                                                               0x1
#define HWIO_GCC_USB3_PHY_SEC_BCR_BLK_ARES_SHFT                                                               0x0
#define HWIO_GCC_USB3_PHY_SEC_BCR_BLK_ARES_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_USB3_PHY_SEC_BCR_BLK_ARES_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00040010)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040010)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040010)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_RMSK                                                                     0x1
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_ATTR                                                                     0x3
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3PHY_PHY_SEC_BCR_ADDR, HWIO_GCC_USB3PHY_PHY_SEC_BCR_RMSK)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3PHY_PHY_SEC_BCR_ADDR, m)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3PHY_PHY_SEC_BCR_ADDR,v)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3PHY_PHY_SEC_BCR_ADDR,m,v,HWIO_GCC_USB3PHY_PHY_SEC_BCR_IN)
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_BLK_ARES_BMSK                                                            0x1
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_BLK_ARES_SHFT                                                            0x0
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_BLK_ARES_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_USB3PHY_PHY_SEC_BCR_BLK_ARES_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00040014)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040014)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040014)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_RMSK                                                                     0x1
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_ATTR                                                                     0x3
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_DP_PHY_SEC_BCR_ADDR, HWIO_GCC_USB3_DP_PHY_SEC_BCR_RMSK)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_DP_PHY_SEC_BCR_ADDR, m)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_DP_PHY_SEC_BCR_ADDR,v)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_DP_PHY_SEC_BCR_ADDR,m,v,HWIO_GCC_USB3_DP_PHY_SEC_BCR_IN)
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_BLK_ARES_BMSK                                                            0x1
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_BLK_ARES_SHFT                                                            0x0
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_BLK_ARES_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_USB3_DP_PHY_SEC_BCR_BLK_ARES_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_USB3_PHY_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00040018)
#define HWIO_GCC_USB3_PHY_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040018)
#define HWIO_GCC_USB3_PHY_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040018)
#define HWIO_GCC_USB3_PHY_GDSCR_RMSK                                                                   0xf8ffffff
#define HWIO_GCC_USB3_PHY_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_USB3_PHY_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_GDSCR_ADDR, HWIO_GCC_USB3_PHY_GDSCR_RMSK)
#define HWIO_GCC_USB3_PHY_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_GDSCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_GDSCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_GDSCR_ADDR,m,v,HWIO_GCC_USB3_PHY_GDSCR_IN)
#define HWIO_GCC_USB3_PHY_GDSCR_PWR_ON_BMSK                                                            0x80000000
#define HWIO_GCC_USB3_PHY_GDSCR_PWR_ON_SHFT                                                                  0x1f
#define HWIO_GCC_USB3_PHY_GDSCR_GDSC_STATE_BMSK                                                        0x78000000
#define HWIO_GCC_USB3_PHY_GDSCR_GDSC_STATE_SHFT                                                              0x1b
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_WAIT_BMSK                                                        0xf00000
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_WAIT_SHFT                                                            0x14
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_WAIT_BMSK                                                          0xf0000
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_WAIT_SHFT                                                             0x10
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DIS_WAIT_BMSK                                                          0xf000
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DIS_WAIT_SHFT                                                             0xc
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_FF_ENABLE_BMSK                                                       0x800
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_FF_ENABLE_SHFT                                                         0xb
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_USB3_PHY_GDSCR_RESTORE_BMSK                                                                0x400
#define HWIO_GCC_USB3_PHY_GDSCR_RESTORE_SHFT                                                                  0xa
#define HWIO_GCC_USB3_PHY_GDSCR_RESTORE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_USB3_PHY_GDSCR_RESTORE_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_USB3_PHY_GDSCR_SAVE_BMSK                                                                   0x200
#define HWIO_GCC_USB3_PHY_GDSCR_SAVE_SHFT                                                                     0x9
#define HWIO_GCC_USB3_PHY_GDSCR_SAVE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_USB3_PHY_GDSCR_SAVE_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_BMSK                                                                 0x100
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_SHFT                                                                   0x8
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_USB3_PHY_GDSCR_RETAIN_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_BMSK                                                                 0x80
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_SHFT                                                                  0x7
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_USB3_PHY_GDSCR_EN_REST_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_BMSK                                                                  0x40
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_SHFT                                                                   0x6
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_USB3_PHY_GDSCR_EN_FEW_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_USB3_PHY_GDSCR_CLAMP_IO_BMSK                                                                0x20
#define HWIO_GCC_USB3_PHY_GDSCR_CLAMP_IO_SHFT                                                                 0x5
#define HWIO_GCC_USB3_PHY_GDSCR_CLAMP_IO_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_USB3_PHY_GDSCR_CLAMP_IO_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DISABLE_BMSK                                                             0x10
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DISABLE_SHFT                                                              0x4
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                              0x0
#define HWIO_GCC_USB3_PHY_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                               0x1
#define HWIO_GCC_USB3_PHY_GDSCR_PD_ARES_BMSK                                                                  0x8
#define HWIO_GCC_USB3_PHY_GDSCR_PD_ARES_SHFT                                                                  0x3
#define HWIO_GCC_USB3_PHY_GDSCR_PD_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_USB3_PHY_GDSCR_PD_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_USB3_PHY_GDSCR_SW_OVERRIDE_BMSK                                                              0x4
#define HWIO_GCC_USB3_PHY_GDSCR_SW_OVERRIDE_SHFT                                                              0x2
#define HWIO_GCC_USB3_PHY_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_USB3_PHY_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_USB3_PHY_GDSCR_HW_CONTROL_BMSK                                                               0x2
#define HWIO_GCC_USB3_PHY_GDSCR_HW_CONTROL_SHFT                                                               0x1
#define HWIO_GCC_USB3_PHY_GDSCR_HW_CONTROL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_USB3_PHY_GDSCR_HW_CONTROL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_USB3_PHY_GDSCR_SW_COLLAPSE_BMSK                                                              0x1
#define HWIO_GCC_USB3_PHY_GDSCR_SW_COLLAPSE_SHFT                                                              0x0
#define HWIO_GCC_USB3_PHY_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_USB3_PHY_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_USB3_PHY_CFG_GDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0004001c)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004001c)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004001c)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_RMSK                                                                0x7ffffff
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_ATTR                                                                      0x3
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG_GDSCR_ADDR, HWIO_GCC_USB3_PHY_CFG_GDSCR_RMSK)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_CFG_GDSCR_ADDR,m,v,HWIO_GCC_USB3_PHY_CFG_GDSCR_IN)
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4000000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                          0x1a
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                             0x2000000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                  0x19
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                              0x1000000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                   0x18
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                       0xf00000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                           0x14
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                          0x80000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                             0x13
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                              0x40000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                 0x12
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                              0x20000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                 0x11
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                           0x10000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                              0x10
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                          0x8000
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                             0xf
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                         0x7800
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                            0xb
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                 0x400
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                   0xa
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                          0x200
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                            0x9
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                          0x100
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                            0x8
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                              0x80
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                               0x7
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                     0x60
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                      0x5
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                               0x10
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                0x4
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                         0x8
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                         0x3
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                       0x4
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                       0x2
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                           0x2
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                           0x1
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                        0x1
#define HWIO_GCC_USB3_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                        0x0

#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00040020)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040020)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040020)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_RMSK                                                                 0x7ffff
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_ATTR                                                                     0x3
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG2_GDSCR_ADDR, HWIO_GCC_USB3_PHY_CFG2_GDSCR_RMSK)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_USB3_PHY_CFG2_GDSCR_IN)
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                     0x40000
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                        0x12
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                 0x20000
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                    0x11
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                               0x10000
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                  0x10
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                   0xf000
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                      0xc
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                            0xf00
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                              0x8
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                               0xf0
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                0x4
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                 0xf
#define HWIO_GCC_USB3_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                 0x0

#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00040024)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040024)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040024)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_RMSK                                                               0x7ffffff
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_ATTR                                                                     0x3
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG3_GDSCR_ADDR, HWIO_GCC_USB3_PHY_CFG3_GDSCR_RMSK)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_USB3_PHY_CFG3_GDSCR_IN)
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                             0x4000000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                  0x1a
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                          0x2000000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                               0x19
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                     0x1e00000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                          0x15
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                      0x100000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                          0x14
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                   0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                    0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                             0x80000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                0x13
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                         0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                          0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                 0x40000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                    0x12
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                             0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                              0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                  0x20000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                     0x11
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                              0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                               0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                       0x10000
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                          0x10
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                               0xff00
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                  0x8
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                0xff
#define HWIO_GCC_USB3_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                 0x0

#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00040028)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00040028)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00040028)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_RMSK                                                                0xffffff
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_ATTR                                                                     0x3
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG4_GDSCR_ADDR, HWIO_GCC_USB3_PHY_CFG4_GDSCR_RMSK)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB3_PHY_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_USB3_PHY_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB3_PHY_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_USB3_PHY_CFG4_GDSCR_IN)
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                  0xf00000
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                      0x14
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                   0xf0000
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                      0x10
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                   0xf000
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                      0xc
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                  0xf00
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                    0x8
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                        0xf0
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                         0x4
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                        0xf
#define HWIO_GCC_USB3_PHY_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                        0x0

#define HWIO_GCC_QUSB2PHY_PRIM_BCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00002000)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00002000)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00002000)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_RMSK                                                                       0x1
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_ATTR                                                                       0x3
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_IN          \
        in_dword_masked(HWIO_GCC_QUSB2PHY_PRIM_BCR_ADDR, HWIO_GCC_QUSB2PHY_PRIM_BCR_RMSK)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUSB2PHY_PRIM_BCR_ADDR, m)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QUSB2PHY_PRIM_BCR_ADDR,v)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUSB2PHY_PRIM_BCR_ADDR,m,v,HWIO_GCC_QUSB2PHY_PRIM_BCR_IN)
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_BLK_ARES_BMSK                                                              0x1
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_BLK_ARES_SHFT                                                              0x0
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_BLK_ARES_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QUSB2PHY_PRIM_BCR_BLK_ARES_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_QUSB2PHY_SEC_BCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00002004)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00002004)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00002004)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_RMSK                                                                        0x1
#define HWIO_GCC_QUSB2PHY_SEC_BCR_ATTR                                                                        0x3
#define HWIO_GCC_QUSB2PHY_SEC_BCR_IN          \
        in_dword_masked(HWIO_GCC_QUSB2PHY_SEC_BCR_ADDR, HWIO_GCC_QUSB2PHY_SEC_BCR_RMSK)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUSB2PHY_SEC_BCR_ADDR, m)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QUSB2PHY_SEC_BCR_ADDR,v)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUSB2PHY_SEC_BCR_ADDR,m,v,HWIO_GCC_QUSB2PHY_SEC_BCR_IN)
#define HWIO_GCC_QUSB2PHY_SEC_BCR_BLK_ARES_BMSK                                                               0x1
#define HWIO_GCC_QUSB2PHY_SEC_BCR_BLK_ARES_SHFT                                                               0x0
#define HWIO_GCC_QUSB2PHY_SEC_BCR_BLK_ARES_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QUSB2PHY_SEC_BCR_BLK_ARES_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0005a000)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005a000)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005a000)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_RMSK                                                                 0x1
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ATTR                                                                 0x3
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ADDR, HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_RMSK)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ADDR, m)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ADDR,v)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_ADDR,m,v,HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_IN)
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_BLK_ARES_BMSK                                                        0x1
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_BLK_ARES_SHFT                                                        0x0
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_BLK_ARES_DISABLE_FVAL                                                0x0
#define HWIO_GCC_USB_PHY_CFG_AHB2PHY_BCR_BLK_ARES_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_AHB2PHY_0_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0005a004)
#define HWIO_GCC_AHB2PHY_0_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005a004)
#define HWIO_GCC_AHB2PHY_0_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005a004)
#define HWIO_GCC_AHB2PHY_0_CBCR_RMSK                                                                   0x81d0000f
#define HWIO_GCC_AHB2PHY_0_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_AHB2PHY_0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AHB2PHY_0_CBCR_ADDR, HWIO_GCC_AHB2PHY_0_CBCR_RMSK)
#define HWIO_GCC_AHB2PHY_0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AHB2PHY_0_CBCR_ADDR, m)
#define HWIO_GCC_AHB2PHY_0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AHB2PHY_0_CBCR_ADDR,v)
#define HWIO_GCC_AHB2PHY_0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AHB2PHY_0_CBCR_ADDR,m,v,HWIO_GCC_AHB2PHY_0_CBCR_IN)
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_AHB2PHY_0_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_AHB2PHY_0_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_AHB2PHY_0_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_AHB2PHY_0_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_AHB2PHY_0_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_AHB2PHY_0_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_AHB2PHY_0_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_AHB2PHY_0_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SDCC2_BCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00004000)
#define HWIO_GCC_SDCC2_BCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004000)
#define HWIO_GCC_SDCC2_BCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004000)
#define HWIO_GCC_SDCC2_BCR_RMSK                                                                               0x1
#define HWIO_GCC_SDCC2_BCR_ATTR                                                                               0x3
#define HWIO_GCC_SDCC2_BCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_BCR_ADDR, HWIO_GCC_SDCC2_BCR_RMSK)
#define HWIO_GCC_SDCC2_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_BCR_ADDR, m)
#define HWIO_GCC_SDCC2_BCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_BCR_ADDR,v)
#define HWIO_GCC_SDCC2_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_BCR_ADDR,m,v,HWIO_GCC_SDCC2_BCR_IN)
#define HWIO_GCC_SDCC2_BCR_BLK_ARES_BMSK                                                                      0x1
#define HWIO_GCC_SDCC2_BCR_BLK_ARES_SHFT                                                                      0x0
#define HWIO_GCC_SDCC2_BCR_BLK_ARES_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_SDCC2_BCR_BLK_ARES_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_SDCC2_APPS_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00004004)
#define HWIO_GCC_SDCC2_APPS_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004004)
#define HWIO_GCC_SDCC2_APPS_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004004)
#define HWIO_GCC_SDCC2_APPS_CBCR_RMSK                                                                  0x81c07005
#define HWIO_GCC_SDCC2_APPS_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SDCC2_APPS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CBCR_ADDR, HWIO_GCC_SDCC2_APPS_CBCR_RMSK)
#define HWIO_GCC_SDCC2_APPS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CBCR_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_CBCR_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_CBCR_ADDR,m,v,HWIO_GCC_SDCC2_APPS_CBCR_IN)
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SDCC2_APPS_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SDCC2_APPS_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SDCC2_APPS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SDCC2_APPS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SDCC2_APPS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SDCC2_APPS_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00004008)
#define HWIO_GCC_SDCC2_APPS_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004008)
#define HWIO_GCC_SDCC2_APPS_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004008)
#define HWIO_GCC_SDCC2_APPS_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_SDCC2_APPS_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_SDCC2_APPS_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_SREGR_ADDR, HWIO_GCC_SDCC2_APPS_SREGR_RMSK)
#define HWIO_GCC_SDCC2_APPS_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_SREGR_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_SREGR_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_SREGR_ADDR,m,v,HWIO_GCC_SDCC2_APPS_SREGR_IN)
#define HWIO_GCC_SDCC2_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_SDCC2_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_SDCC2_APPS_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_SDCC2_APPS_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_SDCC2_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_SDCC2_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_SDCC2_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_SDCC2_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_SDCC2_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_SDCC2_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_SDCC2_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_SDCC2_APPS_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_SDCC2_APPS_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_SDCC2_APPS_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000400c)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000400c)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000400c)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CFG_SREGR_ADDR, HWIO_GCC_SDCC2_APPS_CFG_SREGR_RMSK)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CFG_SREGR_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_CFG_SREGR_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_CFG_SREGR_ADDR,m,v,HWIO_GCC_SDCC2_APPS_CFG_SREGR_IN)
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_SDCC2_APPS_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_SDCC2_AHB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00004010)
#define HWIO_GCC_SDCC2_AHB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004010)
#define HWIO_GCC_SDCC2_AHB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004010)
#define HWIO_GCC_SDCC2_AHB_CBCR_RMSK                                                                   0x81d00005
#define HWIO_GCC_SDCC2_AHB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_SDCC2_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_AHB_CBCR_ADDR, HWIO_GCC_SDCC2_AHB_CBCR_RMSK)
#define HWIO_GCC_SDCC2_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_AHB_CBCR_ADDR, m)
#define HWIO_GCC_SDCC2_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_AHB_CBCR_ADDR,v)
#define HWIO_GCC_SDCC2_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_AHB_CBCR_ADDR,m,v,HWIO_GCC_SDCC2_AHB_CBCR_IN)
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_SDCC2_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_SDCC2_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SDCC2_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00004014)
#define HWIO_GCC_SDCC2_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004014)
#define HWIO_GCC_SDCC2_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004014)
#define HWIO_GCC_SDCC2_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_SDCC2_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_SDCC2_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_AT_CBCR_ADDR, HWIO_GCC_SDCC2_AT_CBCR_RMSK)
#define HWIO_GCC_SDCC2_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_AT_CBCR_ADDR, m)
#define HWIO_GCC_SDCC2_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_AT_CBCR_ADDR,v)
#define HWIO_GCC_SDCC2_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_AT_CBCR_ADDR,m,v,HWIO_GCC_SDCC2_AT_CBCR_IN)
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_SDCC2_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_SDCC2_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_SDCC2_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_SDCC2_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_SDCC2_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_SDCC2_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_SDCC2_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_SDCC2_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00004018)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004018)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004018)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_RMSK                                                              0x800000f3
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CMD_RCGR_ADDR, HWIO_GCC_SDCC2_APPS_CMD_RCGR_RMSK)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_CMD_RCGR_ADDR,m,v,HWIO_GCC_SDCC2_APPS_CMD_RCGR_IN)
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_D_BMSK                                                            0x80
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_D_SHFT                                                             0x7
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_N_BMSK                                                            0x40
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_N_SHFT                                                             0x6
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_M_BMSK                                                            0x20
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_M_SHFT                                                             0x5
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SDCC2_APPS_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000401c)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000401c)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000401c)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_RMSK                                                                0x10371f
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CFG_RCGR_ADDR, HWIO_GCC_SDCC2_APPS_CFG_RCGR_RMSK)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_CFG_RCGR_ADDR,m,v,HWIO_GCC_SDCC2_APPS_CFG_RCGR_IN)
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_BMSK                                                             0x3000
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_SHFT                                                                0xc
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_SWALLOW_FVAL                                                        0x1
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                      0x2
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                    0x3
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_SDCC2_APPS_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_SDCC2_APPS_M_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00004020)
#define HWIO_GCC_SDCC2_APPS_M_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004020)
#define HWIO_GCC_SDCC2_APPS_M_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004020)
#define HWIO_GCC_SDCC2_APPS_M_RMSK                                                                           0xff
#define HWIO_GCC_SDCC2_APPS_M_ATTR                                                                            0x3
#define HWIO_GCC_SDCC2_APPS_M_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_M_ADDR, HWIO_GCC_SDCC2_APPS_M_RMSK)
#define HWIO_GCC_SDCC2_APPS_M_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_M_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_M_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_M_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_M_ADDR,m,v,HWIO_GCC_SDCC2_APPS_M_IN)
#define HWIO_GCC_SDCC2_APPS_M_M_BMSK                                                                         0xff
#define HWIO_GCC_SDCC2_APPS_M_M_SHFT                                                                          0x0

#define HWIO_GCC_SDCC2_APPS_N_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00004024)
#define HWIO_GCC_SDCC2_APPS_N_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004024)
#define HWIO_GCC_SDCC2_APPS_N_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004024)
#define HWIO_GCC_SDCC2_APPS_N_RMSK                                                                           0xff
#define HWIO_GCC_SDCC2_APPS_N_ATTR                                                                            0x3
#define HWIO_GCC_SDCC2_APPS_N_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_N_ADDR, HWIO_GCC_SDCC2_APPS_N_RMSK)
#define HWIO_GCC_SDCC2_APPS_N_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_N_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_N_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_N_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_N_ADDR,m,v,HWIO_GCC_SDCC2_APPS_N_IN)
#define HWIO_GCC_SDCC2_APPS_N_NOT_N_MINUS_M_BMSK                                                             0xff
#define HWIO_GCC_SDCC2_APPS_N_NOT_N_MINUS_M_SHFT                                                              0x0

#define HWIO_GCC_SDCC2_APPS_D_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00004028)
#define HWIO_GCC_SDCC2_APPS_D_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00004028)
#define HWIO_GCC_SDCC2_APPS_D_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00004028)
#define HWIO_GCC_SDCC2_APPS_D_RMSK                                                                           0xff
#define HWIO_GCC_SDCC2_APPS_D_ATTR                                                                            0x3
#define HWIO_GCC_SDCC2_APPS_D_IN          \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_D_ADDR, HWIO_GCC_SDCC2_APPS_D_RMSK)
#define HWIO_GCC_SDCC2_APPS_D_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC2_APPS_D_ADDR, m)
#define HWIO_GCC_SDCC2_APPS_D_OUT(v)      \
        out_dword(HWIO_GCC_SDCC2_APPS_D_ADDR,v)
#define HWIO_GCC_SDCC2_APPS_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC2_APPS_D_ADDR,m,v,HWIO_GCC_SDCC2_APPS_D_IN)
#define HWIO_GCC_SDCC2_APPS_D_NOT_2D_BMSK                                                                    0xff
#define HWIO_GCC_SDCC2_APPS_D_NOT_2D_SHFT                                                                     0x0

#define HWIO_GCC_SDCC4_BCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00006000)
#define HWIO_GCC_SDCC4_BCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006000)
#define HWIO_GCC_SDCC4_BCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006000)
#define HWIO_GCC_SDCC4_BCR_RMSK                                                                               0x1
#define HWIO_GCC_SDCC4_BCR_ATTR                                                                               0x3
#define HWIO_GCC_SDCC4_BCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_BCR_ADDR, HWIO_GCC_SDCC4_BCR_RMSK)
#define HWIO_GCC_SDCC4_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_BCR_ADDR, m)
#define HWIO_GCC_SDCC4_BCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_BCR_ADDR,v)
#define HWIO_GCC_SDCC4_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_BCR_ADDR,m,v,HWIO_GCC_SDCC4_BCR_IN)
#define HWIO_GCC_SDCC4_BCR_BLK_ARES_BMSK                                                                      0x1
#define HWIO_GCC_SDCC4_BCR_BLK_ARES_SHFT                                                                      0x0
#define HWIO_GCC_SDCC4_BCR_BLK_ARES_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_SDCC4_BCR_BLK_ARES_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_SDCC4_APPS_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00006004)
#define HWIO_GCC_SDCC4_APPS_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006004)
#define HWIO_GCC_SDCC4_APPS_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006004)
#define HWIO_GCC_SDCC4_APPS_CBCR_RMSK                                                                  0x81c07005
#define HWIO_GCC_SDCC4_APPS_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SDCC4_APPS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CBCR_ADDR, HWIO_GCC_SDCC4_APPS_CBCR_RMSK)
#define HWIO_GCC_SDCC4_APPS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CBCR_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_CBCR_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_CBCR_ADDR,m,v,HWIO_GCC_SDCC4_APPS_CBCR_IN)
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SDCC4_APPS_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SDCC4_APPS_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SDCC4_APPS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SDCC4_APPS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SDCC4_APPS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SDCC4_APPS_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00006008)
#define HWIO_GCC_SDCC4_APPS_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006008)
#define HWIO_GCC_SDCC4_APPS_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006008)
#define HWIO_GCC_SDCC4_APPS_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_SDCC4_APPS_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_SDCC4_APPS_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_SREGR_ADDR, HWIO_GCC_SDCC4_APPS_SREGR_RMSK)
#define HWIO_GCC_SDCC4_APPS_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_SREGR_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_SREGR_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_SREGR_ADDR,m,v,HWIO_GCC_SDCC4_APPS_SREGR_IN)
#define HWIO_GCC_SDCC4_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_SDCC4_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_SDCC4_APPS_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_SDCC4_APPS_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_SDCC4_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_SDCC4_APPS_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_SDCC4_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_SDCC4_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_SDCC4_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_SDCC4_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_SDCC4_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_SDCC4_APPS_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_SDCC4_APPS_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_SDCC4_APPS_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000600c)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000600c)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000600c)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CFG_SREGR_ADDR, HWIO_GCC_SDCC4_APPS_CFG_SREGR_RMSK)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CFG_SREGR_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_CFG_SREGR_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_CFG_SREGR_ADDR,m,v,HWIO_GCC_SDCC4_APPS_CFG_SREGR_IN)
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_SDCC4_APPS_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_SDCC4_AHB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00006010)
#define HWIO_GCC_SDCC4_AHB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006010)
#define HWIO_GCC_SDCC4_AHB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006010)
#define HWIO_GCC_SDCC4_AHB_CBCR_RMSK                                                                   0x81d00005
#define HWIO_GCC_SDCC4_AHB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_SDCC4_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_AHB_CBCR_ADDR, HWIO_GCC_SDCC4_AHB_CBCR_RMSK)
#define HWIO_GCC_SDCC4_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_AHB_CBCR_ADDR, m)
#define HWIO_GCC_SDCC4_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_AHB_CBCR_ADDR,v)
#define HWIO_GCC_SDCC4_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_AHB_CBCR_ADDR,m,v,HWIO_GCC_SDCC4_AHB_CBCR_IN)
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_SDCC4_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_SDCC4_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SDCC4_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00006014)
#define HWIO_GCC_SDCC4_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006014)
#define HWIO_GCC_SDCC4_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006014)
#define HWIO_GCC_SDCC4_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_SDCC4_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_SDCC4_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_AT_CBCR_ADDR, HWIO_GCC_SDCC4_AT_CBCR_RMSK)
#define HWIO_GCC_SDCC4_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_AT_CBCR_ADDR, m)
#define HWIO_GCC_SDCC4_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_AT_CBCR_ADDR,v)
#define HWIO_GCC_SDCC4_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_AT_CBCR_ADDR,m,v,HWIO_GCC_SDCC4_AT_CBCR_IN)
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_SDCC4_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_SDCC4_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_SDCC4_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_SDCC4_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_SDCC4_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_SDCC4_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_SDCC4_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_SDCC4_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00006018)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006018)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006018)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_RMSK                                                              0x800000f3
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CMD_RCGR_ADDR, HWIO_GCC_SDCC4_APPS_CMD_RCGR_RMSK)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_CMD_RCGR_ADDR,m,v,HWIO_GCC_SDCC4_APPS_CMD_RCGR_IN)
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_D_BMSK                                                            0x80
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_D_SHFT                                                             0x7
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_N_BMSK                                                            0x40
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_N_SHFT                                                             0x6
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_M_BMSK                                                            0x20
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_M_SHFT                                                             0x5
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SDCC4_APPS_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000601c)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000601c)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000601c)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_RMSK                                                                0x10371f
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CFG_RCGR_ADDR, HWIO_GCC_SDCC4_APPS_CFG_RCGR_RMSK)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_CFG_RCGR_ADDR,m,v,HWIO_GCC_SDCC4_APPS_CFG_RCGR_IN)
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_BMSK                                                             0x3000
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_SHFT                                                                0xc
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_SWALLOW_FVAL                                                        0x1
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                      0x2
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                    0x3
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_SDCC4_APPS_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_SDCC4_APPS_M_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00006020)
#define HWIO_GCC_SDCC4_APPS_M_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006020)
#define HWIO_GCC_SDCC4_APPS_M_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006020)
#define HWIO_GCC_SDCC4_APPS_M_RMSK                                                                           0xff
#define HWIO_GCC_SDCC4_APPS_M_ATTR                                                                            0x3
#define HWIO_GCC_SDCC4_APPS_M_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_M_ADDR, HWIO_GCC_SDCC4_APPS_M_RMSK)
#define HWIO_GCC_SDCC4_APPS_M_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_M_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_M_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_M_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_M_ADDR,m,v,HWIO_GCC_SDCC4_APPS_M_IN)
#define HWIO_GCC_SDCC4_APPS_M_M_BMSK                                                                         0xff
#define HWIO_GCC_SDCC4_APPS_M_M_SHFT                                                                          0x0

#define HWIO_GCC_SDCC4_APPS_N_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00006024)
#define HWIO_GCC_SDCC4_APPS_N_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006024)
#define HWIO_GCC_SDCC4_APPS_N_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006024)
#define HWIO_GCC_SDCC4_APPS_N_RMSK                                                                           0xff
#define HWIO_GCC_SDCC4_APPS_N_ATTR                                                                            0x3
#define HWIO_GCC_SDCC4_APPS_N_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_N_ADDR, HWIO_GCC_SDCC4_APPS_N_RMSK)
#define HWIO_GCC_SDCC4_APPS_N_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_N_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_N_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_N_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_N_ADDR,m,v,HWIO_GCC_SDCC4_APPS_N_IN)
#define HWIO_GCC_SDCC4_APPS_N_NOT_N_MINUS_M_BMSK                                                             0xff
#define HWIO_GCC_SDCC4_APPS_N_NOT_N_MINUS_M_SHFT                                                              0x0

#define HWIO_GCC_SDCC4_APPS_D_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00006028)
#define HWIO_GCC_SDCC4_APPS_D_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00006028)
#define HWIO_GCC_SDCC4_APPS_D_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00006028)
#define HWIO_GCC_SDCC4_APPS_D_RMSK                                                                           0xff
#define HWIO_GCC_SDCC4_APPS_D_ATTR                                                                            0x3
#define HWIO_GCC_SDCC4_APPS_D_IN          \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_D_ADDR, HWIO_GCC_SDCC4_APPS_D_RMSK)
#define HWIO_GCC_SDCC4_APPS_D_INM(m)      \
        in_dword_masked(HWIO_GCC_SDCC4_APPS_D_ADDR, m)
#define HWIO_GCC_SDCC4_APPS_D_OUT(v)      \
        out_dword(HWIO_GCC_SDCC4_APPS_D_ADDR,v)
#define HWIO_GCC_SDCC4_APPS_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SDCC4_APPS_D_ADDR,m,v,HWIO_GCC_SDCC4_APPS_D_IN)
#define HWIO_GCC_SDCC4_APPS_D_NOT_2D_BMSK                                                                    0xff
#define HWIO_GCC_SDCC4_APPS_D_NOT_2D_SHFT                                                                     0x0

#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007000)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007000)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007000)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_RMSK                                                                   0x1
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ADDR, HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_RMSK)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_IN)
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_BLK_ARES_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_BLK_ARES_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_BLK_ARES_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAPPER_I2C_BCR_BLK_ARES_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00013140)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013140)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013140)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_RMSK                                                             0x81d0000e
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00013144)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013144)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013144)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_RMSK                                                              0x81d07004
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_CORE_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_CORE_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_CORE_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_CORE_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00013148)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013148)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013148)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_SREGR_ADDR, HWIO_GCC_QUPV3_I2C_CORE_SREGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_CORE_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_CORE_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_CORE_SREGR_IN)
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_I2C_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0001314c)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001314c)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001314c)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00013164)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013164)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013164)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_RMSK                                                         0x3ffff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_RCG_SW_CTRL_BMSK                                             0x38000
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_RCG_SW_CTRL_SHFT                                                 0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_SW_PERF_STATE_BMSK                                            0x7800
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_SW_PERF_STATE_SHFT                                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_SW_OVERRIDE_BMSK                                               0x400
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_SW_OVERRIDE_SHFT                                                 0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                  0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                    0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_FSM_STATE_BMSK                                             0x1c0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_FSM_STATE_SHFT                                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_HW_CLK_CONTROL_BMSK                                             0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_HW_CLK_CONTROL_SHFT                                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_CURR_PERF_STATE_BMSK                                            0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_CURR_PERF_STATE_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_EN_BMSK                                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_EN_SHFT                                                      0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_EN_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_CMD_DFSR_DFS_EN_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0001316c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001316c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001316c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF0_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013170)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013170)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013170)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF1_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013174)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013174)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013174)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF2_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013178)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013178)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013178)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF3_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0001317c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001317c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001317c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF4_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013180)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013180)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013180)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF5_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013184)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013184)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013184)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF6_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013188)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013188)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013188)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF7_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0001318c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001318c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001318c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF8_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ADDR                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013190)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_PHYS                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013190)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_OFFS                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013190)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_RMSK                                          0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ATTR                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_BMSK                                  0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SHFT                                    0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC0_FVAL                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC2_FVAL                               0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC3_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC4_FVAL                               0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC5_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC6_FVAL                               0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_SEL_SRC7_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_BMSK                                   0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_SHFT                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV1_FVAL                               0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV2_FVAL                               0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV3_FVAL                               0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV4_FVAL                               0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV5_FVAL                               0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                             0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV6_FVAL                               0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                             0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV7_FVAL                               0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                             0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV8_FVAL                               0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV9_FVAL                              0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                            0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV10_FVAL                             0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                           0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV11_FVAL                             0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                           0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV12_FVAL                             0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                           0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV13_FVAL                             0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                           0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV14_FVAL                             0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                           0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV15_FVAL                             0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                           0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF9_DFSR_SRC_DIV_DIV16_FVAL                             0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00013194)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013194)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013194)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF10_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00013198)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013198)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013198)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF11_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0001319c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001319c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001319c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF12_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x000131a0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000131a0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000131a0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF13_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x000131a4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000131a4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000131a4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF14_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ADDR                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x000131a8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_PHYS                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000131a8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_OFFS                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000131a8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_RMSK                                         0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ATTR                                           0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_BMSK                                 0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SHFT                                   0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC0_FVAL                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC2_FVAL                              0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC3_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC4_FVAL                              0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC5_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC6_FVAL                              0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_SEL_SRC7_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_BMSK                                  0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_SHFT                                   0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV1_FVAL                              0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV2_FVAL                              0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV3_FVAL                              0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV4_FVAL                              0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV5_FVAL                              0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                            0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV6_FVAL                              0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                            0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV7_FVAL                              0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                            0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV8_FVAL                              0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV9_FVAL                             0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                           0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV10_FVAL                            0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                          0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV11_FVAL                            0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                          0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV12_FVAL                            0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                          0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV13_FVAL                            0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                          0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV14_FVAL                            0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                          0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV15_FVAL                            0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                          0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_I2C_CORE_PERF15_DFSR_SRC_DIV_DIV16_FVAL                            0x1f

#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00013150)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013150)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013150)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00013154)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013154)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013154)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_I2C_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_I2C_S0_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007004)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007004)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007004)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S0_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S0_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S0_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S0_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S0_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007008)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007008)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007008)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S0_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000700c)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000700c)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000700c)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S0_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S1_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007020)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007020)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007020)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S1_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S1_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S1_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S1_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S1_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007024)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007024)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007024)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S1_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007028)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007028)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007028)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S1_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S2_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000703c)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000703c)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000703c)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S2_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S2_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S2_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S2_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S2_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007040)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007040)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007040)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S2_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007044)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007044)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007044)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S2_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S3_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007058)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007058)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007058)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S3_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S3_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S3_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S3_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S3_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000705c)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000705c)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000705c)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S3_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007060)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007060)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007060)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S3_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S4_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007074)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007074)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007074)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S4_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S4_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S4_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S4_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S4_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007078)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007078)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007078)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S4_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000707c)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000707c)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000707c)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S4_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S5_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007090)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007090)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007090)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S5_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S5_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S5_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S5_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S5_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007094)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007094)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007094)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S5_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007098)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007098)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007098)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S5_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S6_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000070ac)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070ac)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070ac)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S6_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S6_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S6_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S6_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S6_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070b0)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070b0)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070b0)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S6_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070b4)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070b4)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070b4)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S6_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S7_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000070c8)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070c8)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070c8)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S7_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S7_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S7_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S7_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S7_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070cc)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070cc)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070cc)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S7_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070d0)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070d0)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070d0)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S7_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S8_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000070e4)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070e4)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070e4)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S8_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S8_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S8_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S8_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S8_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070e8)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070e8)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070e8)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S8_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000070ec)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000070ec)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000070ec)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S8_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_I2C_S9_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00007100)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007100)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007100)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_RMSK                                                                0x81c00004
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CBCR_ADDR, HWIO_GCC_QUPV3_I2C_S9_CBCR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S9_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S9_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S9_CBCR_IN)
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_I2C_S9_CBCR_CLK_ARES_RESET_FVAL                                                        0x1

#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007104)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007104)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007104)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_RMSK                                                            0x80000013
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_OFF_SHFT                                                         0x1f
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_EN_BMSK                                                           0x2
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_EN_SHFT                                                           0x1
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_UPDATE_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_UPDATE_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_UPDATE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S9_CMD_RCGR_UPDATE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00007108)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00007108)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00007108)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RMSK                                                              0x11071f
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_HW_CLK_CONTROL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RCGLITE_DISABLE_BMSK                                               0x10000
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                  0x10
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                   0x0
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                  0x1
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_BMSK                                                         0x700
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SHFT                                                           0x8
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                      0x0
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                      0x2
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                      0x4
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                      0x6
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_BMSK                                                          0x1f
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_SHFT                                                           0x0
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                      0x1
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                      0x3
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                      0x5
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                      0x7
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                    0x8
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                      0x9
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                    0xa
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                      0xb
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                    0xc
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                      0xd
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                    0xe
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                      0xf
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                   0x10
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                     0x11
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                   0x12
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                    0x13
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                  0x14
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                    0x15
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                  0x16
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                    0x17
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                  0x18
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                    0x19
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                  0x1a
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                    0x1b
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                  0x1c
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                    0x1d
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                  0x1e
#define HWIO_GCC_QUPV3_I2C_S9_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                    0x1f

#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00008000)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008000)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008000)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_RMSK                                                                     0x1
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_1_BCR_ADDR, HWIO_GCC_QUPV3_WRAPPER_1_BCR_RMSK)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_1_BCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAPPER_1_BCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAPPER_1_BCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAPPER_1_BCR_IN)
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_BLK_ARES_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_BLK_ARES_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_BLK_ARES_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAPPER_1_BCR_BLK_ARES_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0001327c)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001327c)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001327c)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP_1_M_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00013280)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013280)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013280)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP_1_S_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00013284)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013284)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013284)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_RMSK                                                            0x81d07004
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_CORE_ON_BMSK                                              0x4000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                 0xe
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                            0x2000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                               0xd
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                           0x1000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                              0xc
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_CBCR_CLK_ARES_RESET_FVAL                                                    0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00013288)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013288)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013288)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_RMSK                                                            0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ATTR                                                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                  0xf000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                       0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PWR_FSM_CLK_SEL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                     0xf0000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                        0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                       0x8000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                          0xf
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                        0x4000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                           0xe
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                        0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                       0x2000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                          0xd
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                              0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                   0x1000
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                      0xc
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CORE_ON_ACK_BMSK                                                0x800
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CORE_ON_ACK_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                              0x400
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                0xa
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                       0x300
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_ENABLE_BMSK                                                  0x80
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_ENABLE_SHFT                                                   0x7
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_FORCE_CLK_ON_BMSK                                                    0x40
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_FORCE_CLK_ON_SHFT                                                     0x6
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                              0x20
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                               0x5
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                      0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                 0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SLP_STG_BMSK                                                  0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SLP_STG_SHFT                                                   0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                         0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                            0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                 0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                      0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                          0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                           0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0001328c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001328c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001328c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_RMSK                                                       0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ATTR                                                              0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                    0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                          0x1a
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                               0x2000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                    0x19
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                 0x1000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                      0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                    0x800000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                        0x17
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                      0x400000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                          0x16
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                           0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                               0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_SLEEP_TIMER_BMSK                                               0xff00
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_SLEEP_TIMER_SHFT                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                0xff
#define HWIO_GCC_QUPV3_WRAP1_CORE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00013290)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013290)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013290)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_RMSK                                                              0xf
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ATTR                                                              0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_CLK_DIV_BMSK                                                      0xf
#define HWIO_GCC_QUPV3_WRAP1_CORE_DIV_CDIVR_CLK_DIV_SHFT                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00013294)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013294)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013294)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_RMSK                                                         0x81d07004
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_CORE_ON_BMSK                                           0x4000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_CORE_ON_SHFT                                              0xe
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                              0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                               0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                        0x1000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                           0xc
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CBCR_CLK_ARES_RESET_FVAL                                                 0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00013298)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013298)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013298)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_RMSK                                                         0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ATTR                                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                               0xf000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PWR_FSM_CLK_SEL_BMSK                                          0x100000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PWR_FSM_CLK_SEL_SHFT                                              0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                  0xf0000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                     0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                    0x8000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                       0xf
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                     0x4000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                        0xe
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                     0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                    0x2000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                       0xd
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                0x1000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                   0xc
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                          0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                             0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CORE_ON_ACK_BMSK                                             0x800
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CORE_ON_ACK_SHFT                                               0xb
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_PERIPH_ON_ACK_BMSK                                           0x400
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_PERIPH_ON_ACK_SHFT                                             0xa
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                    0x300
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                      0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                             0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                             0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                             0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_ENABLE_BMSK                                               0x80
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_ENABLE_SHFT                                                0x7
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_FORCE_CLK_ON_BMSK                                                 0x40
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_FORCE_CLK_ON_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_BMSK                                           0x20
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SHFT                                            0x5
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                   0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL              0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SLP_STG_BMSK                                               0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SLP_STG_SHFT                                                0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                      0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                         0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_BMSK                                              0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_SHFT                                              0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                         0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_BMSK                                             0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SHFT                                             0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                       0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                        0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0001329c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001329c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001329c)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_RMSK                                                    0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ATTR                                                           0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                 0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                       0x1a
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                            0x2000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                 0x19
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                              0x1000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                   0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                 0x800000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                     0x17
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                   0x400000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                       0x16
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CPH_TIMER_BMSK                                        0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_MEM_CPH_TIMER_SHFT                                            0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_SLEEP_TIMER_BMSK                                            0xff00
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_SLEEP_TIMER_SHFT                                               0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_WAKEUP_TIMER_BMSK                                             0xff
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_SREGR_WAKEUP_TIMER_SHFT                                              0x0

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132bc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132bc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132bc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF0_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132c0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132c0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132c0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF1_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132c4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132c4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132c4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF2_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132c8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132c8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132c8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF3_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132cc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132cc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132cc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF4_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132d0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132d0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132d0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF5_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132d4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132d4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132d4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF6_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132d8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132d8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132d8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF7_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132dc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132dc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132dc)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF8_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x000132e0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132e0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132e0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF9_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132e4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132e4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132e4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF10_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132e8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132e8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132e8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF11_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132ec)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132ec)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132ec)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF12_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132f0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132f0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132f0)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF13_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132f4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132f4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132f4)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF14_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x000132f8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132f8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132f8)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP1_CORE_2X_PERF15_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x000132a0)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132a0)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132a0)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_RMSK                                                     0x80000013
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ATTR                                                            0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_OFF_BMSK                                            0x80000000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_OFF_SHFT                                                  0x1f
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                            0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                             0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_EN_BMSK                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_EN_SHFT                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_UPDATE_BMSK                                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_UPDATE_SHFT                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_UPDATE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CMD_RCGR_UPDATE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x000132a4)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000132a4)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000132a4)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RMSK                                                       0x11071f
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ATTR                                                            0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_BMSK                                        0x10000
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_SHFT                                           0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                           0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_QUPV3_WRAP1_CORE_2X_CFG_RCGR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00008004)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008004)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008004)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008008)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008008)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008008)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000800c)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000800c)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000800c)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008024)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008024)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008024)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000802c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000802c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000802c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008030)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008030)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008030)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008034)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008034)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008034)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008038)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008038)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008038)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000803c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000803c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000803c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008040)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008040)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008040)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008044)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008044)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008044)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008048)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008048)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008048)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000806c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000806c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000806c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008070)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008070)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008070)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008074)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008074)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008074)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008078)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008078)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008078)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000807c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000807c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000807c)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008080)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008080)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008080)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008084)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008084)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008084)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008088)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008088)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008088)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080ac)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080ac)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080ac)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080b0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080b0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080b0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080b4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080b4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080b4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080b8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080b8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080b8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080bc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080bc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080bc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080c0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080c0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080c0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080c4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080c4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080c4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080c8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080c8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080c8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080ec)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080ec)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080ec)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080f0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080f0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080f0)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080f4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080f4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080f4)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080f8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080f8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080f8)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000080fc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000080fc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000080fc)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008100)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008100)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008100)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008104)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008104)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008104)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008108)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008108)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008108)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE0_QUPV3_WRAP1_S0_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008010)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008010)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008010)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008014)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008014)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008014)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S0_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S0_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008018)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008018)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008018)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S0_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000801c)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000801c)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000801c)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S0_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008020)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008020)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008020)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S0_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S0_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S0_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S0_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S0_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S0_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S0_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S0_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000813c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000813c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000813c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008140)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008140)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008140)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008144)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008144)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008144)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000815c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000815c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000815c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008164)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008164)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008164)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008168)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008168)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008168)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000816c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000816c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000816c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008170)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008170)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008170)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008174)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008174)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008174)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008178)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008178)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008178)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000817c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000817c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000817c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008180)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008180)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008180)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081a4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081a4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081a4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081a8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081a8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081a8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081ac)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081ac)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081ac)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081b0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081b0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081b0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081b4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081b4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081b4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081b8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081b8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081b8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081bc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081bc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081bc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081c0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081c0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081c0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081e4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081e4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081e4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081e8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081e8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081e8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081ec)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081ec)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081ec)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081f0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081f0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081f0)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081f4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081f4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081f4)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081f8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081f8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081f8)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000081fc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000081fc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000081fc)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008200)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008200)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008200)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008224)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008224)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008224)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008228)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008228)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008228)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000822c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000822c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000822c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008230)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008230)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008230)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008234)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008234)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008234)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008238)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008238)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008238)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000823c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000823c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000823c)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008240)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008240)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008240)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE1_QUPV3_WRAP1_S1_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008148)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008148)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008148)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000814c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000814c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000814c)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S1_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S1_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008150)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008150)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008150)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S1_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008154)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008154)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008154)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S1_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008158)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008158)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008158)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S1_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S1_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S1_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S1_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S1_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S1_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S1_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S1_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00008274)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008274)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008274)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008278)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008278)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008278)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000827c)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000827c)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000827c)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008294)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008294)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008294)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000829c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000829c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000829c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082a0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082a0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082a0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082a4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082a4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082a4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082a8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082a8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082a8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082ac)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082ac)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082ac)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082b0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082b0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082b0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082b4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082b4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082b4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000082b8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082b8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082b8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082dc)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082dc)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082dc)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082e0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082e0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082e0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082e4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082e4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082e4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082e8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082e8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082e8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082ec)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082ec)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082ec)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082f0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082f0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082f0)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082f4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082f4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082f4)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000082f8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000082f8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000082f8)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000831c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000831c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000831c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008320)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008320)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008320)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008324)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008324)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008324)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008328)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008328)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008328)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000832c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000832c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000832c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008330)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008330)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008330)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008334)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008334)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008334)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008338)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008338)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008338)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000835c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000835c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000835c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008360)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008360)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008360)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008364)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008364)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008364)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008368)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008368)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008368)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000836c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000836c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000836c)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008370)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008370)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008370)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008374)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008374)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008374)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008378)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008378)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008378)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE2_QUPV3_WRAP1_S2_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008280)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008280)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008280)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008284)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008284)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008284)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S2_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S2_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008288)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008288)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008288)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S2_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000828c)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000828c)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000828c)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S2_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008290)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008290)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008290)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S2_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S2_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S2_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S2_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S2_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S2_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S2_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S2_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000083ac)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083ac)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083ac)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000083b0)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083b0)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083b0)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000083b4)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083b4)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083b4)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000083cc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083cc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083cc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083d4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083d4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083d4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083d8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083d8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083d8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083dc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083dc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083dc)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083e0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083e0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083e0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083e4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083e4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083e4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083e8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083e8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083e8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083ec)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083ec)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083ec)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000083f0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083f0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083f0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008414)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008414)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008414)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008418)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008418)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008418)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000841c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000841c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000841c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008420)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008420)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008420)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008424)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008424)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008424)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008428)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008428)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008428)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000842c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000842c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000842c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008430)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008430)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008430)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008454)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008454)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008454)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008458)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008458)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008458)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000845c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000845c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000845c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008460)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008460)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008460)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008464)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008464)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008464)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008468)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008468)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008468)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000846c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000846c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000846c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008470)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008470)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008470)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008494)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008494)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008494)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008498)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008498)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008498)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000849c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000849c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000849c)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000084a0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084a0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084a0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000084a4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084a4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084a4)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000084a8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084a8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084a8)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000084ac)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084ac)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084ac)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000084b0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084b0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084b0)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE3_QUPV3_WRAP1_S3_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000083b8)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083b8)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083b8)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000083bc)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083bc)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083bc)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S3_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S3_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000083c0)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083c0)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083c0)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S3_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000083c4)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083c4)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083c4)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S3_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000083c8)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000083c8)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000083c8)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S3_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S3_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S3_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S3_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S3_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S3_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S3_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S3_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000084e4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084e4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084e4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000084e8)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084e8)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084e8)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000084ec)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084ec)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084ec)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008504)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008504)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008504)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000850c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000850c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000850c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008510)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008510)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008510)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008514)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008514)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008514)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008518)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008518)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008518)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000851c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000851c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000851c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008520)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008520)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008520)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008524)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008524)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008524)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008528)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008528)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008528)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000854c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000854c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000854c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008550)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008550)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008550)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008554)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008554)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008554)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008558)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008558)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008558)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000855c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000855c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000855c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008560)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008560)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008560)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008564)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008564)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008564)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008568)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008568)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008568)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000858c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000858c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000858c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008590)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008590)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008590)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008594)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008594)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008594)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008598)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008598)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008598)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000859c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000859c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000859c)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085a0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085a0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085a0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085a4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085a4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085a4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085a8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085a8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085a8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085cc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085cc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085cc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085d0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085d0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085d0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085d4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085d4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085d4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085d8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085d8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085d8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085dc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085dc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085dc)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085e0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085e0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085e0)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085e4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085e4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085e4)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000085e8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000085e8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000085e8)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE4_QUPV3_WRAP1_S4_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000084f0)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084f0)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084f0)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000084f4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084f4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084f4)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S4_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S4_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000084f8)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084f8)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084f8)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S4_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000084fc)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000084fc)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000084fc)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S4_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008500)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008500)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008500)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S4_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S4_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S4_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S4_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S4_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S4_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S4_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S4_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000861c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000861c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000861c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008620)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008620)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008620)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008624)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008624)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008624)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000863c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000863c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000863c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008644)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008644)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008644)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008648)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008648)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008648)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000864c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000864c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000864c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008650)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008650)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008650)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008654)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008654)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008654)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008658)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008658)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008658)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000865c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000865c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000865c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008660)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008660)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008660)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008684)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008684)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008684)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008688)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008688)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008688)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000868c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000868c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000868c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008690)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008690)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008690)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008694)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008694)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008694)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008698)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008698)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008698)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000869c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000869c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000869c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086a0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086a0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086a0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086c4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086c4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086c4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086c8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086c8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086c8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086cc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086cc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086cc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086d0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086d0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086d0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086d4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086d4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086d4)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086d8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086d8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086d8)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086dc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086dc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086dc)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000086e0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000086e0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000086e0)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008704)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008704)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008704)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008708)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008708)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008708)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000870c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000870c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000870c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008710)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008710)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008710)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008714)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008714)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008714)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008718)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008718)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008718)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000871c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000871c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000871c)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008720)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008720)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008720)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE5_QUPV3_WRAP1_S5_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008628)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008628)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008628)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000862c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000862c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000862c)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S5_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S5_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008630)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008630)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008630)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S5_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008634)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008634)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008634)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S5_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008638)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008638)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008638)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S5_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S5_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S5_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S5_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S5_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S5_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S5_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S5_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00008754)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008754)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008754)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008758)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008758)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008758)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000875c)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000875c)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000875c)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008774)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008774)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008774)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000877c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000877c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000877c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008780)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008780)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008780)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008784)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008784)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008784)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008788)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008788)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008788)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000878c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000878c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000878c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008790)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008790)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008790)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008794)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008794)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008794)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00008798)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008798)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008798)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087bc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087bc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087bc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087c0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087c0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087c0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087c4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087c4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087c4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087c8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087c8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087c8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087cc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087cc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087cc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087d0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087d0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087d0)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087d4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087d4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087d4)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087d8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087d8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087d8)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000087fc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000087fc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000087fc)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008800)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008800)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008800)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008804)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008804)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008804)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008808)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008808)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008808)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000880c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000880c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000880c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008810)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008810)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008810)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008814)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008814)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008814)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008818)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008818)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008818)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000883c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000883c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000883c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008840)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008840)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008840)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008844)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008844)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008844)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008848)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008848)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008848)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000884c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000884c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000884c)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008850)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008850)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008850)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008854)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008854)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008854)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008858)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008858)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008858)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE6_QUPV3_WRAP1_S6_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008760)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008760)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008760)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008764)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008764)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008764)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S6_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S6_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008768)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008768)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008768)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S6_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000876c)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000876c)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000876c)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S6_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00008770)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008770)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008770)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S6_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S6_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S6_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S6_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S6_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S6_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S6_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S6_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000888c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000888c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000888c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00008890)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008890)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008890)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00008894)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008894)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008894)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000088ac)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088ac)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088ac)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088b4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088b4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088b4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088b8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088b8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088b8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088bc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088bc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088bc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088c0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088c0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088c0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088c4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088c4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088c4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088c8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088c8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088c8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088cc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088cc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088cc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x000088d0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088d0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088d0)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000088f4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088f4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088f4)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000088f8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088f8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088f8)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000088fc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088fc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088fc)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008900)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008900)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008900)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008904)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008904)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008904)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008908)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008908)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008908)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000890c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000890c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000890c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008910)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008910)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008910)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008934)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008934)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008934)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008938)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008938)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008938)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000893c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000893c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000893c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008940)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008940)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008940)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008944)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008944)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008944)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008948)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008948)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008948)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000894c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000894c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000894c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008950)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008950)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008950)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008974)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008974)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008974)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008978)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008978)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008978)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000897c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000897c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000897c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008980)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008980)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008980)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008984)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008984)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008984)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008988)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008988)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008988)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000898c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000898c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000898c)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00008990)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008990)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008990)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_SE7_QUPV3_WRAP1_S7_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00008898)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00008898)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00008898)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000889c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000889c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000889c)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP1_S7_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP1_S7_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000088a0)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088a0)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088a0)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_M_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_M_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP1_S7_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000088a4)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088a4)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088a4)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_N_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_N_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP1_S7_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x000088a8)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000088a8)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000088a8)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP1_S7_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_D_ADDR, HWIO_GCC_QUPV3_WRAP1_S7_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP1_S7_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP1_S7_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP1_S7_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP1_S7_D_IN)
#define HWIO_GCC_QUPV3_WRAP1_S7_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP1_S7_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e000)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e000)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e000)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_RMSK                                                                     0x1
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_2_BCR_ADDR, HWIO_GCC_QUPV3_WRAPPER_2_BCR_RMSK)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAPPER_2_BCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAPPER_2_BCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAPPER_2_BCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAPPER_2_BCR_IN)
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_BLK_ARES_BMSK                                                            0x1
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_BLK_ARES_SHFT                                                            0x0
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_BLK_ARES_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAPPER_2_BCR_BLK_ARES_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000133cc)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000133cc)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000133cc)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP_2_M_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x000133d0)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000133d0)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000133d0)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_RMSK                                                          0x81d0000e
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP_2_S_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x000133d4)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000133d4)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000133d4)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_RMSK                                                            0x81d07004
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_CORE_ON_BMSK                                              0x4000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                 0xe
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                            0x2000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                               0xd
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                           0x1000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                              0xc
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_CBCR_CLK_ARES_RESET_FVAL                                                    0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x000133d8)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000133d8)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000133d8)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_RMSK                                                            0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ATTR                                                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                  0xf000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                       0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PWR_FSM_CLK_SEL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                     0xf0000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                        0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                       0x8000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                          0xf
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                        0x4000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                           0xe
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                        0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                       0x2000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                          0xd
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                              0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                   0x1000
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                      0xc
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CORE_ON_ACK_BMSK                                                0x800
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CORE_ON_ACK_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                              0x400
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                0xa
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                       0x300
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_ENABLE_BMSK                                                  0x80
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_ENABLE_SHFT                                                   0x7
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_FORCE_CLK_ON_BMSK                                                    0x40
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_FORCE_CLK_ON_SHFT                                                     0x6
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                              0x20
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                               0x5
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                      0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                 0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SLP_STG_BMSK                                                  0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SLP_STG_SHFT                                                   0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                         0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                            0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                 0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                      0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                          0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                           0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000133dc)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000133dc)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000133dc)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_RMSK                                                       0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ATTR                                                              0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                    0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                          0x1a
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                               0x2000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                    0x19
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                 0x1000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                      0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                    0x800000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                        0x17
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                      0x400000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                          0x16
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                           0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                               0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_SLEEP_TIMER_BMSK                                               0xff00
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_SLEEP_TIMER_SHFT                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                0xff
#define HWIO_GCC_QUPV3_WRAP2_CORE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00013000)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013000)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013000)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_RMSK                                                              0xf
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ATTR                                                              0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_CLK_DIV_BMSK                                                      0xf
#define HWIO_GCC_QUPV3_WRAP2_CORE_DIV_CDIVR_CLK_DIV_SHFT                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00013004)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013004)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013004)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_RMSK                                                         0x81d07004
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_CORE_ON_BMSK                                           0x4000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_CORE_ON_SHFT                                              0xe
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                              0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                               0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                        0x1000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                           0xc
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CBCR_CLK_ARES_RESET_FVAL                                                 0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00013008)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013008)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013008)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_RMSK                                                         0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ATTR                                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                               0xf000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PWR_FSM_CLK_SEL_BMSK                                          0x100000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PWR_FSM_CLK_SEL_SHFT                                              0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                  0xf0000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                     0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                    0x8000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                       0xf
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                     0x4000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                        0xe
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                     0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                    0x2000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                       0xd
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                0x1000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                   0xc
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                          0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                             0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CORE_ON_ACK_BMSK                                             0x800
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CORE_ON_ACK_SHFT                                               0xb
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_PERIPH_ON_ACK_BMSK                                           0x400
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_PERIPH_ON_ACK_SHFT                                             0xa
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                    0x300
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                      0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                             0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                             0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                             0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_ENABLE_BMSK                                               0x80
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_ENABLE_SHFT                                                0x7
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_FORCE_CLK_ON_BMSK                                                 0x40
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_FORCE_CLK_ON_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_BMSK                                           0x20
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SHFT                                            0x5
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                   0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL              0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SLP_STG_BMSK                                               0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SLP_STG_SHFT                                                0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                      0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                         0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_BMSK                                              0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_SHFT                                              0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                         0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_BMSK                                             0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SHFT                                             0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                       0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                        0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0001300c)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001300c)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001300c)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_RMSK                                                    0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ATTR                                                           0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                 0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                       0x1a
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                            0x2000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                 0x19
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                              0x1000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                   0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                 0x800000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                     0x17
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                   0x400000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                       0x16
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CPH_TIMER_BMSK                                        0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_MEM_CPH_TIMER_SHFT                                            0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_SLEEP_TIMER_BMSK                                            0xff00
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_SLEEP_TIMER_SHFT                                               0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_WAKEUP_TIMER_BMSK                                             0xff
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_SREGR_WAKEUP_TIMER_SHFT                                              0x0

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0001302c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001302c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001302c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF0_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF1_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF2_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF3_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0001303c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001303c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001303c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF4_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013040)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013040)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013040)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF5_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013044)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013044)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013044)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF6_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013048)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013048)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013048)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF7_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0001304c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001304c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001304c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF8_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ADDR                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00013050)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_PHYS                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013050)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_OFFS                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013050)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_RMSK                                     0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ATTR                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_BMSK                             0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SHFT                               0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC0_FVAL                          0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC2_FVAL                          0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC3_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC4_FVAL                          0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC5_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC6_FVAL                          0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_SEL_SRC7_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_BMSK                              0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_SHFT                               0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                        0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV1_FVAL                          0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                        0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV2_FVAL                          0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                        0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV3_FVAL                          0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                        0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV4_FVAL                          0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                        0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV5_FVAL                          0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                        0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV6_FVAL                          0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                        0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV7_FVAL                          0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                        0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV8_FVAL                          0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                       0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV9_FVAL                         0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                       0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV10_FVAL                        0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                      0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV11_FVAL                        0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                      0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV12_FVAL                        0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                      0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV13_FVAL                        0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                      0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV14_FVAL                        0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                      0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV15_FVAL                        0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                      0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF9_DFSR_SRC_DIV_DIV16_FVAL                        0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00013054)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013054)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013054)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF10_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00013058)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013058)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013058)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF11_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0001305c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001305c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001305c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF12_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00013060)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013060)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013060)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF13_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00013064)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013064)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013064)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF14_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ADDR                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00013068)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_PHYS                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013068)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_OFFS                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013068)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_RMSK                                    0x71f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ATTR                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_BMSK                            0x700
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SHFT                              0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC0_FVAL                         0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC2_FVAL                         0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC3_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC4_FVAL                         0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC5_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC6_FVAL                         0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_SEL_SRC7_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_BMSK                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_SHFT                              0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                       0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV1_FVAL                         0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                       0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV2_FVAL                         0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                       0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV3_FVAL                         0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                       0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV4_FVAL                         0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                       0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV5_FVAL                         0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                       0xa
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV6_FVAL                         0xb
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                       0xc
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV7_FVAL                         0xd
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                       0xe
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV8_FVAL                         0xf
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                      0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV9_FVAL                        0x11
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                      0x12
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV10_FVAL                       0x13
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                     0x14
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV11_FVAL                       0x15
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                     0x16
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV12_FVAL                       0x17
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                     0x18
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV13_FVAL                       0x19
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                     0x1a
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV14_FVAL                       0x1b
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                     0x1c
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV15_FVAL                       0x1d
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                     0x1e
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_QUPV3_WRAP2_CORE_2X_PERF15_DFSR_SRC_DIV_DIV16_FVAL                       0x1f

#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013010)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013010)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013010)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_RMSK                                                     0x80000013
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ATTR                                                            0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_OFF_BMSK                                            0x80000000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_OFF_SHFT                                                  0x1f
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                            0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                             0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_EN_BMSK                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_EN_SHFT                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_UPDATE_BMSK                                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_UPDATE_SHFT                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_UPDATE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CMD_RCGR_UPDATE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00013014)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00013014)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00013014)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RMSK                                                       0x11071f
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ATTR                                                            0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_BMSK                                        0x100000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_SHFT                                            0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_BMSK                                        0x10000
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_SHFT                                           0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                           0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_QUPV3_WRAP2_CORE_2X_CFG_RCGR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e004)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e004)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e004)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e008)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e008)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e008)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e00c)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e00c)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e00c)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e024)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e024)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e024)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e02c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e02c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e02c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e030)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e030)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e030)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e034)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e034)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e034)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e038)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e038)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e038)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e03c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e03c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e03c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e040)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e040)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e040)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e044)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e044)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e044)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e048)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e048)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e048)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e06c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e06c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e06c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e070)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e070)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e070)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e074)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e074)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e074)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e078)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e078)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e078)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e07c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e07c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e07c)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e080)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e080)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e080)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e084)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e084)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e084)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e088)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e088)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e088)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0ac)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0ac)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0ac)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0b0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0b0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0b0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0b4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0b4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0b4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0b8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0b8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0b8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0bc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0bc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0bc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0c0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0c0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0c0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0c4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0c4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0c4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0c8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0c8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0c8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0ec)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0ec)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0ec)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0f0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0f0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0f0)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0f4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0f4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0f4)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0f8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0f8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0f8)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e0fc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e0fc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e0fc)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e100)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e100)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e100)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e104)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e104)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e104)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e108)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e108)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e108)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE0_QUPV3_WRAP2_S0_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e010)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e010)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e010)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e014)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e014)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e014)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S0_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S0_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e018)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e018)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e018)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S0_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e01c)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e01c)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e01c)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S0_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e020)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e020)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e020)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S0_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S0_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S0_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S0_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S0_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S0_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S0_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S0_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e13c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e13c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e13c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e140)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e140)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e140)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e144)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e144)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e144)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e15c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e15c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e15c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e164)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e164)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e164)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e168)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e168)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e168)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e16c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e16c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e16c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e170)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e170)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e170)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e174)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e174)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e174)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e178)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e178)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e178)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e17c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e17c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e17c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e180)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e180)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e180)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1a4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1a4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1a4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1a8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1a8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1a8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1ac)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1ac)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1ac)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1b0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1b0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1b0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1b4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1b4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1b4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1b8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1b8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1b8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1bc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1bc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1bc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1c0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1c0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1c0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1e4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1e4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1e4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1e8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1e8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1e8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1ec)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1ec)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1ec)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1f0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1f0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1f0)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1f4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1f4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1f4)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1f8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1f8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1f8)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e1fc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e1fc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e1fc)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e200)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e200)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e200)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e224)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e224)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e224)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e228)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e228)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e228)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e22c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e22c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e22c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e230)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e230)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e230)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e234)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e234)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e234)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e238)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e238)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e238)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e23c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e23c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e23c)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e240)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e240)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e240)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE1_QUPV3_WRAP2_S1_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e148)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e148)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e148)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e14c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e14c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e14c)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S1_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S1_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e150)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e150)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e150)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S1_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e154)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e154)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e154)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S1_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e158)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e158)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e158)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S1_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S1_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S1_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S1_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S1_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S1_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S1_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S1_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e274)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e274)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e274)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e278)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e278)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e278)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e27c)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e27c)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e27c)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e294)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e294)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e294)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e29c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e29c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e29c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2a0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2a0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2a0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2a4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2a4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2a4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2a8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2a8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2a8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2ac)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2ac)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2ac)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2b0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2b0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2b0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2b4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2b4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2b4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2b8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2b8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2b8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2dc)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2dc)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2dc)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2e0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2e0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2e0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2e4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2e4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2e4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2e8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2e8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2e8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2ec)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2ec)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2ec)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2f0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2f0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2f0)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2f4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2f4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2f4)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e2f8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e2f8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e2f8)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e31c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e31c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e31c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e320)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e320)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e320)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e324)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e324)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e324)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e328)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e328)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e328)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e32c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e32c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e32c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e330)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e330)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e330)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e334)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e334)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e334)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e338)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e338)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e338)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e35c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e35c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e35c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e360)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e360)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e360)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e364)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e364)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e364)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e368)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e368)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e368)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e36c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e36c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e36c)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e370)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e370)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e370)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e374)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e374)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e374)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e378)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e378)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e378)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE2_QUPV3_WRAP2_S2_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e280)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e280)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e280)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e284)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e284)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e284)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S2_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S2_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e288)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e288)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e288)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S2_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e28c)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e28c)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e28c)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S2_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e290)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e290)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e290)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S2_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S2_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S2_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S2_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S2_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S2_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S2_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S2_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3ac)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3ac)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3ac)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3b0)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3b0)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3b0)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3b4)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3b4)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3b4)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3cc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3cc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3cc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3d4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3d4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3d4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3d8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3d8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3d8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3dc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3dc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3dc)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3e0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3e0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3e0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3e4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3e4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3e4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3e8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3e8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3e8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3ec)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3ec)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3ec)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3f0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3f0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3f0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e414)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e414)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e414)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e418)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e418)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e418)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e41c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e41c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e41c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e420)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e420)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e420)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e424)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e424)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e424)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e428)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e428)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e428)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e42c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e42c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e42c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e430)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e430)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e430)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e454)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e454)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e454)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e458)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e458)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e458)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e45c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e45c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e45c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e460)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e460)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e460)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e464)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e464)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e464)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e468)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e468)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e468)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e46c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e46c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e46c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e470)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e470)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e470)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e494)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e494)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e494)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e498)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e498)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e498)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e49c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e49c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e49c)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4a0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4a0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4a0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4a4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4a4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4a4)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4a8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4a8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4a8)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4ac)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4ac)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4ac)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4b0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4b0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4b0)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE3_QUPV3_WRAP2_S3_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3b8)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3b8)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3b8)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3bc)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3bc)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3bc)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S3_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S3_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3c0)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3c0)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3c0)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S3_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3c4)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3c4)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3c4)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S3_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e3c8)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e3c8)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e3c8)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S3_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S3_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S3_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S3_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S3_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S3_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S3_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S3_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4e4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4e4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4e4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4e8)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4e8)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4e8)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4ec)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4ec)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4ec)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e504)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e504)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e504)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e50c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e50c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e50c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e510)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e510)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e510)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e514)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e514)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e514)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e518)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e518)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e518)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e51c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e51c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e51c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e520)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e520)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e520)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e524)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e524)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e524)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e528)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e528)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e528)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e54c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e54c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e54c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e550)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e550)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e550)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e554)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e554)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e554)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e558)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e558)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e558)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e55c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e55c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e55c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e560)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e560)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e560)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e564)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e564)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e564)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e568)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e568)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e568)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e58c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e58c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e58c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e590)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e590)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e590)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e594)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e594)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e594)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e598)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e598)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e598)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e59c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e59c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e59c)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5a0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5a0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5a0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5a4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5a4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5a4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5a8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5a8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5a8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5cc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5cc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5cc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5d0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5d0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5d0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5d4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5d4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5d4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5d8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5d8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5d8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5dc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5dc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5dc)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5e0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5e0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5e0)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5e4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5e4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5e4)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e5e8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e5e8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e5e8)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE4_QUPV3_WRAP2_S4_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4f0)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4f0)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4f0)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4f4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4f4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4f4)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S4_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S4_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4f8)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4f8)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4f8)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S4_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e4fc)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e4fc)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e4fc)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S4_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e500)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e500)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e500)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S4_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S4_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S4_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S4_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S4_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S4_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S4_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S4_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e61c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e61c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e61c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e620)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e620)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e620)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e624)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e624)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e624)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e63c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e63c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e63c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e644)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e644)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e644)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e648)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e648)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e648)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e64c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e64c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e64c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e650)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e650)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e650)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e654)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e654)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e654)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e658)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e658)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e658)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e65c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e65c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e65c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e660)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e660)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e660)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e684)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e684)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e684)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e688)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e688)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e688)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e68c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e68c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e68c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e690)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e690)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e690)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e694)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e694)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e694)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e698)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e698)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e698)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e69c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e69c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e69c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6a0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6a0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6a0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6c4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6c4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6c4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6c8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6c8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6c8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6cc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6cc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6cc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6d0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6d0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6d0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6d4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6d4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6d4)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6d8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6d8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6d8)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6dc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6dc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6dc)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e6e0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e6e0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e6e0)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e704)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e704)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e704)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e708)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e708)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e708)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e70c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e70c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e70c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e710)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e710)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e710)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e714)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e714)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e714)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e718)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e718)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e718)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e71c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e71c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e71c)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e720)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e720)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e720)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE5_QUPV3_WRAP2_S5_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e628)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e628)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e628)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e62c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e62c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e62c)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S5_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S5_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e630)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e630)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e630)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S5_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e634)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e634)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e634)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S5_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e638)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e638)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e638)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S5_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S5_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S5_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S5_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S5_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S5_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S5_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S5_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e754)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e754)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e754)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e758)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e758)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e758)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e75c)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e75c)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e75c)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e774)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e774)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e774)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e77c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e77c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e77c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e780)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e780)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e780)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e784)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e784)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e784)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e788)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e788)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e788)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e78c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e78c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e78c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e790)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e790)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e790)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e794)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e794)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e794)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e798)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e798)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e798)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7bc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7bc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7bc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7c0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7c0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7c0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7c4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7c4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7c4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7c8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7c8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7c8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7cc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7cc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7cc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7d0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7d0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7d0)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7d4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7d4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7d4)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7d8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7d8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7d8)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e7fc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e7fc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e7fc)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e800)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e800)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e800)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e804)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e804)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e804)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e808)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e808)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e808)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e80c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e80c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e80c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e810)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e810)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e810)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e814)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e814)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e814)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e818)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e818)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e818)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e83c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e83c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e83c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e840)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e840)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e840)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e844)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e844)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e844)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e848)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e848)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e848)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e84c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e84c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e84c)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e850)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e850)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e850)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e854)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e854)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e854)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e858)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e858)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e858)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE6_QUPV3_WRAP2_S6_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e760)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e760)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e760)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e764)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e764)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e764)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S6_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S6_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e768)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e768)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e768)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S6_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e76c)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e76c)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e76c)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S6_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e770)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e770)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e770)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S6_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S6_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S6_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S6_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S6_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S6_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S6_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S6_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e88c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e88c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e88c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_CBCR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_CBCR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e890)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e890)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e890)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e894)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e894)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e894)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8ac)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8ac)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8ac)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_RMSK                                                             0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ATTR                                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_RCG_SW_CTRL_BMSK                                                 0x8000
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_RCG_SW_CTRL_SHFT                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_SW_PERF_STATE_BMSK                                               0x7800
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_SW_PERF_STATE_SHFT                                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_SW_OVERRIDE_BMSK                                                  0x400
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_SW_OVERRIDE_SHFT                                                    0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                     0x200
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                       0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_FSM_STATE_BMSK                                                0x1c0
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_FSM_STATE_SHFT                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                0x20
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                 0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_CURR_PERF_STATE_BMSK                                               0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_CURR_PERF_STATE_SHFT                                                0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_EN_BMSK                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_EN_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8b4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8b4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8b4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8b8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8b8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8b8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8bc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8bc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8bc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8c0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8c0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8c0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8c4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8c4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8c4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8c8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8c8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8c8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8cc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8cc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8cc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8d0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8d0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8d0)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_RMSK                                            0x371f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ATTR                                               0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_BMSK                                       0x3000
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_SHFT                                          0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_BYPASS_FVAL                                   0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_SWALLOW_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_DUAL_EDGE_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_MODE_SINGLE_EDGE_FVAL                              0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_BMSK                                     0x700
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SHFT                                       0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_BMSK                                      0x1f
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_SHFT                                       0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                0x0
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                0x2
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                  0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                0x4
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                  0x5
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                0x6
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                  0x7
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                0x8
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                  0x9
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                0xa
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                  0xb
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                0xc
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                  0xd
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                0xe
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                  0xf
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                               0x10
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                 0x11
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                               0x12
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                0x13
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                              0x14
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                0x15
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                              0x16
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                0x17
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                              0x18
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                0x19
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                              0x1a
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                0x1b
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                              0x1c
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                0x1d
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                              0x1e
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                0x1f

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8f4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8f4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8f4)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8f8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8f8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8f8)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8fc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8fc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8fc)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e900)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e900)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e900)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e904)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e904)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e904)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e908)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e908)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e908)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e90c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e90c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e90c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e910)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e910)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e910)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_M_BMSK                                        0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_M_DFSR_M_SHFT                                           0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e934)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e934)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e934)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e938)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e938)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e938)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e93c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e93c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e93c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e940)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e940)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e940)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e944)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e944)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e944)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e948)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e948)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e948)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e94c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e94c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e94c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e950)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e950)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e950)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_NOT_N_MINUS_M_BMSK                            0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_N_DFSR_NOT_N_MINUS_M_SHFT                               0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e974)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e974)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e974)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF0_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e978)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e978)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e978)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF1_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e97c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e97c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e97c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF2_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e980)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e980)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e980)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF3_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e984)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e984)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e984)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF4_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e988)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e988)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e988)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF5_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e98c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e98c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e98c)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF6_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ADDR                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e990)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_PHYS                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e990)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_OFFS                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e990)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_RMSK                                          0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ATTR                                             0x3
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ADDR, HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_IN)
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_NOT_2D_BMSK                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_SE7_QUPV3_WRAP2_S7_PERF7_D_DFSR_NOT_2D_SHFT                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e898)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e898)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e898)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_RMSK                                                          0x800000f3
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_D_BMSK                                                        0x80
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_D_SHFT                                                         0x7
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_N_BMSK                                                        0x40
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_N_SHFT                                                         0x6
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_M_BMSK                                                        0x20
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_M_SHFT                                                         0x5
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e89c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e89c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e89c)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_RMSK                                                            0x10371f
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_BMSK                                                         0x3000
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_SHFT                                                            0xc
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_SWALLOW_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_QUPV3_WRAP2_S7_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_QUPV3_WRAP2_S7_M_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8a0)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8a0)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8a0)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_M_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_M_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_M_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_M_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_M_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_M_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_M_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_M_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_M_M_BMSK                                                                   0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_M_M_SHFT                                                                      0x0

#define HWIO_GCC_QUPV3_WRAP2_S7_N_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8a4)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8a4)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8a4)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_N_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_N_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_N_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_N_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_N_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_N_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_N_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_N_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_N_NOT_N_MINUS_M_BMSK                                                       0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_N_NOT_N_MINUS_M_SHFT                                                          0x0

#define HWIO_GCC_QUPV3_WRAP2_S7_D_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0000e8a8)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000e8a8)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000e8a8)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_RMSK                                                                     0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_D_ATTR                                                                        0x3
#define HWIO_GCC_QUPV3_WRAP2_S7_D_IN          \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_D_ADDR, HWIO_GCC_QUPV3_WRAP2_S7_D_RMSK)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_INM(m)      \
        in_dword_masked(HWIO_GCC_QUPV3_WRAP2_S7_D_ADDR, m)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_OUT(v)      \
        out_dword(HWIO_GCC_QUPV3_WRAP2_S7_D_ADDR,v)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QUPV3_WRAP2_S7_D_ADDR,m,v,HWIO_GCC_QUPV3_WRAP2_S7_D_IN)
#define HWIO_GCC_QUPV3_WRAP2_S7_D_NOT_2D_BMSK                                                              0xffff
#define HWIO_GCC_QUPV3_WRAP2_S7_D_NOT_2D_SHFT                                                                 0x0

#define HWIO_GCC_PDM_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00023000)
#define HWIO_GCC_PDM_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023000)
#define HWIO_GCC_PDM_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023000)
#define HWIO_GCC_PDM_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_PDM_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_PDM_BCR_IN          \
        in_dword_masked(HWIO_GCC_PDM_BCR_ADDR, HWIO_GCC_PDM_BCR_RMSK)
#define HWIO_GCC_PDM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM_BCR_ADDR, m)
#define HWIO_GCC_PDM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PDM_BCR_ADDR,v)
#define HWIO_GCC_PDM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM_BCR_ADDR,m,v,HWIO_GCC_PDM_BCR_IN)
#define HWIO_GCC_PDM_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_PDM_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_PDM_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_PDM_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_PDM_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00023004)
#define HWIO_GCC_PDM_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023004)
#define HWIO_GCC_PDM_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023004)
#define HWIO_GCC_PDM_AHB_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_PDM_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_PDM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PDM_AHB_CBCR_ADDR, HWIO_GCC_PDM_AHB_CBCR_RMSK)
#define HWIO_GCC_PDM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_PDM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PDM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_PDM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM_AHB_CBCR_ADDR,m,v,HWIO_GCC_PDM_AHB_CBCR_IN)
#define HWIO_GCC_PDM_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_PDM_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_PDM_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_PDM_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_PDM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_PDM_AHB_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_PDM_AHB_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_PDM_AHB_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_PDM_AHB_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_PDM_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PDM_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PDM_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_PDM_XO4_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00023008)
#define HWIO_GCC_PDM_XO4_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023008)
#define HWIO_GCC_PDM_XO4_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023008)
#define HWIO_GCC_PDM_XO4_CBCR_RMSK                                                                     0x81c00005
#define HWIO_GCC_PDM_XO4_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_PDM_XO4_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PDM_XO4_CBCR_ADDR, HWIO_GCC_PDM_XO4_CBCR_RMSK)
#define HWIO_GCC_PDM_XO4_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM_XO4_CBCR_ADDR, m)
#define HWIO_GCC_PDM_XO4_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PDM_XO4_CBCR_ADDR,v)
#define HWIO_GCC_PDM_XO4_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM_XO4_CBCR_ADDR,m,v,HWIO_GCC_PDM_XO4_CBCR_IN)
#define HWIO_GCC_PDM_XO4_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_PDM_XO4_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_PDM_XO4_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_PDM_XO4_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_PDM_XO4_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_PDM_XO4_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_PDM_XO4_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_PDM_XO4_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PDM_XO4_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_PDM2_CBCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0002300c)
#define HWIO_GCC_PDM2_CBCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002300c)
#define HWIO_GCC_PDM2_CBCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002300c)
#define HWIO_GCC_PDM2_CBCR_RMSK                                                                        0x81c00005
#define HWIO_GCC_PDM2_CBCR_ATTR                                                                               0x3
#define HWIO_GCC_PDM2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PDM2_CBCR_ADDR, HWIO_GCC_PDM2_CBCR_RMSK)
#define HWIO_GCC_PDM2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM2_CBCR_ADDR, m)
#define HWIO_GCC_PDM2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PDM2_CBCR_ADDR,v)
#define HWIO_GCC_PDM2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM2_CBCR_ADDR,m,v,HWIO_GCC_PDM2_CBCR_IN)
#define HWIO_GCC_PDM2_CBCR_CLK_OFF_BMSK                                                                0x80000000
#define HWIO_GCC_PDM2_CBCR_CLK_OFF_SHFT                                                                      0x1f
#define HWIO_GCC_PDM2_CBCR_IGNORE_ALL_ARES_BMSK                                                         0x1000000
#define HWIO_GCC_PDM2_CBCR_IGNORE_ALL_ARES_SHFT                                                              0x18
#define HWIO_GCC_PDM2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                       0x800000
#define HWIO_GCC_PDM2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                           0x17
#define HWIO_GCC_PDM2_CBCR_CLK_DIS_BMSK                                                                  0x400000
#define HWIO_GCC_PDM2_CBCR_CLK_DIS_SHFT                                                                      0x16
#define HWIO_GCC_PDM2_CBCR_CLK_ARES_BMSK                                                                      0x4
#define HWIO_GCC_PDM2_CBCR_CLK_ARES_SHFT                                                                      0x2
#define HWIO_GCC_PDM2_CBCR_CLK_ARES_NO_RESET_FVAL                                                             0x0
#define HWIO_GCC_PDM2_CBCR_CLK_ARES_RESET_FVAL                                                                0x1
#define HWIO_GCC_PDM2_CBCR_CLK_ENABLE_BMSK                                                                    0x1
#define HWIO_GCC_PDM2_CBCR_CLK_ENABLE_SHFT                                                                    0x0
#define HWIO_GCC_PDM2_CBCR_CLK_ENABLE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PDM2_CBCR_CLK_ENABLE_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_PDM2_CMD_RCGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00023010)
#define HWIO_GCC_PDM2_CMD_RCGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023010)
#define HWIO_GCC_PDM2_CMD_RCGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023010)
#define HWIO_GCC_PDM2_CMD_RCGR_RMSK                                                                    0x80000013
#define HWIO_GCC_PDM2_CMD_RCGR_ATTR                                                                           0x3
#define HWIO_GCC_PDM2_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PDM2_CMD_RCGR_ADDR, HWIO_GCC_PDM2_CMD_RCGR_RMSK)
#define HWIO_GCC_PDM2_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM2_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PDM2_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PDM2_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PDM2_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM2_CMD_RCGR_ADDR,m,v,HWIO_GCC_PDM2_CMD_RCGR_IN)
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_PDM2_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                           0x10
#define HWIO_GCC_PDM2_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                            0x4
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_EN_BMSK                                                                   0x2
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_EN_SHFT                                                                   0x1
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PDM2_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_PDM2_CMD_RCGR_UPDATE_BMSK                                                                    0x1
#define HWIO_GCC_PDM2_CMD_RCGR_UPDATE_SHFT                                                                    0x0
#define HWIO_GCC_PDM2_CMD_RCGR_UPDATE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PDM2_CMD_RCGR_UPDATE_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_PDM2_CFG_RCGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00023014)
#define HWIO_GCC_PDM2_CFG_RCGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023014)
#define HWIO_GCC_PDM2_CFG_RCGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023014)
#define HWIO_GCC_PDM2_CFG_RCGR_RMSK                                                                      0x11071f
#define HWIO_GCC_PDM2_CFG_RCGR_ATTR                                                                           0x3
#define HWIO_GCC_PDM2_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PDM2_CFG_RCGR_ADDR, HWIO_GCC_PDM2_CFG_RCGR_RMSK)
#define HWIO_GCC_PDM2_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM2_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PDM2_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PDM2_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PDM2_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM2_CFG_RCGR_ADDR,m,v,HWIO_GCC_PDM2_CFG_RCGR_IN)
#define HWIO_GCC_PDM2_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                       0x100000
#define HWIO_GCC_PDM2_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                           0x14
#define HWIO_GCC_PDM2_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_PDM2_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_PDM2_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                       0x10000
#define HWIO_GCC_PDM2_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                          0x10
#define HWIO_GCC_PDM2_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                           0x0
#define HWIO_GCC_PDM2_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                          0x1
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_BMSK                                                                 0x700
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SHFT                                                                   0x8
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                              0x0
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                              0x1
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                              0x2
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                              0x3
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                              0x4
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                              0x5
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                              0x6
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                              0x7
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_BMSK                                                                  0x1f
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_SHFT                                                                   0x0
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                            0x0
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                              0x1
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                            0x2
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                              0x3
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                            0x4
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                              0x5
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                            0x6
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                              0x7
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                            0x8
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                              0x9
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                            0xa
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                              0xb
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                            0xc
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                              0xd
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                            0xe
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                              0xf
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                           0x10
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                             0x11
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                           0x12
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                            0x13
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                          0x14
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                            0x15
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                          0x16
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                            0x17
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                          0x18
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                            0x19
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                          0x1a
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                            0x1b
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                          0x1c
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                            0x1d
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                          0x1e
#define HWIO_GCC_PDM2_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                            0x1f

#define HWIO_GCC_PDM_XO4_DIV_CDIVR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00023028)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00023028)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00023028)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_RMSK                                                                       0xf
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_ATTR                                                                       0x3
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_PDM_XO4_DIV_CDIVR_ADDR, HWIO_GCC_PDM_XO4_DIV_CDIVR_RMSK)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_PDM_XO4_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_PDM_XO4_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PDM_XO4_DIV_CDIVR_ADDR,m,v,HWIO_GCC_PDM_XO4_DIV_CDIVR_IN)
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_CLK_DIV_BMSK                                                               0xf
#define HWIO_GCC_PDM_XO4_DIV_CDIVR_CLK_DIV_SHFT                                                               0x0

#define HWIO_GCC_PMU_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00026000)
#define HWIO_GCC_PMU_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026000)
#define HWIO_GCC_PMU_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026000)
#define HWIO_GCC_PMU_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_PMU_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_PMU_BCR_IN          \
        in_dword_masked(HWIO_GCC_PMU_BCR_ADDR, HWIO_GCC_PMU_BCR_RMSK)
#define HWIO_GCC_PMU_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PMU_BCR_ADDR, m)
#define HWIO_GCC_PMU_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PMU_BCR_ADDR,v)
#define HWIO_GCC_PMU_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PMU_BCR_ADDR,m,v,HWIO_GCC_PMU_BCR_IN)
#define HWIO_GCC_PMU_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_PMU_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_PMU_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_PMU_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_PMU_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026004)
#define HWIO_GCC_PMU_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026004)
#define HWIO_GCC_PMU_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026004)
#define HWIO_GCC_PMU_AHB_CBCR_RMSK                                                                     0x81d00005
#define HWIO_GCC_PMU_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_PMU_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PMU_AHB_CBCR_ADDR, HWIO_GCC_PMU_AHB_CBCR_RMSK)
#define HWIO_GCC_PMU_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PMU_AHB_CBCR_ADDR, m)
#define HWIO_GCC_PMU_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PMU_AHB_CBCR_ADDR,v)
#define HWIO_GCC_PMU_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PMU_AHB_CBCR_ADDR,m,v,HWIO_GCC_PMU_AHB_CBCR_IN)
#define HWIO_GCC_PMU_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_PMU_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_PMU_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_PMU_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_PMU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PMU_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_PMU_CORE_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026008)
#define HWIO_GCC_PMU_CORE_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026008)
#define HWIO_GCC_PMU_CORE_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026008)
#define HWIO_GCC_PMU_CORE_CBCR_RMSK                                                                    0x81d00005
#define HWIO_GCC_PMU_CORE_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_PMU_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PMU_CORE_CBCR_ADDR, HWIO_GCC_PMU_CORE_CBCR_RMSK)
#define HWIO_GCC_PMU_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PMU_CORE_CBCR_ADDR, m)
#define HWIO_GCC_PMU_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PMU_CORE_CBCR_ADDR,v)
#define HWIO_GCC_PMU_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PMU_CORE_CBCR_ADDR,m,v,HWIO_GCC_PMU_CORE_CBCR_IN)
#define HWIO_GCC_PMU_CORE_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_PMU_CORE_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_PMU_CORE_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_PMU_CORE_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_PMU_CORE_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PMU_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_RPMH_PMU_CMD_DFSR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00026020)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026020)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026020)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_RMSK                                                                    0xffff
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_ATTR                                                                       0x3
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_CMD_DFSR_ADDR, HWIO_GCC_RPMH_PMU_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_RCG_SW_CTRL_BMSK                                                        0x8000
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_RCG_SW_CTRL_SHFT                                                           0xf
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_SW_PERF_STATE_BMSK                                                      0x7800
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_SW_PERF_STATE_SHFT                                                         0xb
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_SW_OVERRIDE_BMSK                                                         0x400
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_SW_OVERRIDE_SHFT                                                           0xa
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                            0x200
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                              0x9
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_FSM_STATE_BMSK                                                       0x1c0
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_FSM_STATE_SHFT                                                         0x6
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                       0x20
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                        0x5
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_CURR_PERF_STATE_BMSK                                                      0x1e
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_CURR_PERF_STATE_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_EN_BMSK                                                                0x1
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_EN_SHFT                                                                0x0
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_RPMH_PMU_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026028)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026028)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026028)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0002602c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002602c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002602c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026030)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026030)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026030)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026034)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026034)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026034)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026038)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026038)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026038)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0002603c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002603c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002603c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026040)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026040)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026040)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026044)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026044)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026044)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00026048)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026048)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026048)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0002604c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002604c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002604c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026050)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026050)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026050)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026054)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026054)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026054)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026058)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026058)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026058)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0002605c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002605c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002605c)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026060)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026060)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026060)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00026064)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026064)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026064)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_RMSK                                                         0x71f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ATTR                                                           0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_BMSK                                                 0x700
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SHFT                                                   0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                              0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                              0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                              0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_SHFT                                                   0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                            0x0
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                              0x1
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                            0x2
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                              0x3
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                            0x4
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                              0x5
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                            0x6
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                              0x7
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                            0x8
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                              0x9
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                            0xa
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                              0xb
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                            0xc
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                              0xd
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                            0xe
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                              0xf
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                           0x10
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                             0x11
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                           0x12
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                            0x13
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                          0x14
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                            0x15
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                          0x16
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                            0x17
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                          0x18
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                            0x19
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                          0x1a
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                            0x1b
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                          0x1c
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                            0x1d
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                          0x1e
#define HWIO_GCC_RPMH_PMU_PMU_CORE_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                            0x1f

#define HWIO_GCC_PMU_CORE_CMD_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0002600c)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002600c)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002600c)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_RMSK                                                                0x80000013
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_PMU_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PMU_CORE_CMD_RCGR_ADDR, HWIO_GCC_PMU_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PMU_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PMU_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PMU_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_PMU_CORE_CMD_RCGR_IN)
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                             0x1f
#define HWIO_GCC_PMU_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                       0x10
#define HWIO_GCC_PMU_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                        0x4
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_EN_BMSK                                                               0x2
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_EN_SHFT                                                               0x1
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_PMU_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_PMU_CORE_CMD_RCGR_UPDATE_BMSK                                                                0x1
#define HWIO_GCC_PMU_CORE_CMD_RCGR_UPDATE_SHFT                                                                0x0
#define HWIO_GCC_PMU_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PMU_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_PMU_CORE_CFG_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00026010)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00026010)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00026010)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_RMSK                                                                  0x11071f
#define HWIO_GCC_PMU_CORE_CFG_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_PMU_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PMU_CORE_CFG_RCGR_ADDR, HWIO_GCC_PMU_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PMU_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PMU_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PMU_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_PMU_CORE_CFG_RCGR_IN)
#define HWIO_GCC_PMU_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                   0x100000
#define HWIO_GCC_PMU_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                       0x14
#define HWIO_GCC_PMU_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PMU_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_PMU_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                   0x10000
#define HWIO_GCC_PMU_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                      0x10
#define HWIO_GCC_PMU_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                       0x0
#define HWIO_GCC_PMU_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                      0x1
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_BMSK                                                             0x700
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SHFT                                                               0x8
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                          0x0
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                          0x1
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                          0x2
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                          0x3
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                          0x4
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                          0x5
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                          0x6
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                          0x7
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_BMSK                                                              0x1f
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_SHFT                                                               0x0
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                        0x0
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                          0x1
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                        0x2
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                          0x3
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                        0x4
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                          0x5
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                        0x6
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                          0x7
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                        0x8
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                          0x9
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                        0xa
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                          0xb
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                        0xc
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                          0xd
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                        0xe
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                          0xf
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                       0x10
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                         0x11
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                       0x12
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                        0x13
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                      0x14
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                        0x15
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                      0x16
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                        0x17
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                      0x18
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                        0x19
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                      0x1a
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                        0x1b
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                      0x1c
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                        0x1d
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                      0x1e
#define HWIO_GCC_PMU_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                        0x1f

#define HWIO_GCC_PRNG_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00088000)
#define HWIO_GCC_PRNG_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00088000)
#define HWIO_GCC_PRNG_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00088000)
#define HWIO_GCC_PRNG_BCR_RMSK                                                                                0x1
#define HWIO_GCC_PRNG_BCR_ATTR                                                                                0x3
#define HWIO_GCC_PRNG_BCR_IN          \
        in_dword_masked(HWIO_GCC_PRNG_BCR_ADDR, HWIO_GCC_PRNG_BCR_RMSK)
#define HWIO_GCC_PRNG_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PRNG_BCR_ADDR, m)
#define HWIO_GCC_PRNG_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PRNG_BCR_ADDR,v)
#define HWIO_GCC_PRNG_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PRNG_BCR_ADDR,m,v,HWIO_GCC_PRNG_BCR_IN)
#define HWIO_GCC_PRNG_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_PRNG_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_PRNG_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_PRNG_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_PRNG_AHB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00088004)
#define HWIO_GCC_PRNG_AHB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00088004)
#define HWIO_GCC_PRNG_AHB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00088004)
#define HWIO_GCC_PRNG_AHB_CBCR_RMSK                                                                    0x81d00004
#define HWIO_GCC_PRNG_AHB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_PRNG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PRNG_AHB_CBCR_ADDR, HWIO_GCC_PRNG_AHB_CBCR_RMSK)
#define HWIO_GCC_PRNG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PRNG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_PRNG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PRNG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_PRNG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PRNG_AHB_CBCR_ADDR,m,v,HWIO_GCC_PRNG_AHB_CBCR_IN)
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_PRNG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_PRNG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1

#define HWIO_GCC_TME_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00024000)
#define HWIO_GCC_TME_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024000)
#define HWIO_GCC_TME_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024000)
#define HWIO_GCC_TME_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_TME_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_TME_BCR_IN          \
        in_dword_masked(HWIO_GCC_TME_BCR_ADDR, HWIO_GCC_TME_BCR_RMSK)
#define HWIO_GCC_TME_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_BCR_ADDR, m)
#define HWIO_GCC_TME_BCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_BCR_ADDR,v)
#define HWIO_GCC_TME_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_BCR_ADDR,m,v,HWIO_GCC_TME_BCR_IN)
#define HWIO_GCC_TME_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_TME_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_TME_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_TME_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_TME_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00024004)
#define HWIO_GCC_TME_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024004)
#define HWIO_GCC_TME_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024004)
#define HWIO_GCC_TME_AHB_CBCR_RMSK                                                                     0x81d00005
#define HWIO_GCC_TME_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_TME_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TME_AHB_CBCR_ADDR, HWIO_GCC_TME_AHB_CBCR_RMSK)
#define HWIO_GCC_TME_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TME_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TME_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_AHB_CBCR_ADDR,m,v,HWIO_GCC_TME_AHB_CBCR_IN)
#define HWIO_GCC_TME_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_TME_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_TME_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_TME_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_TME_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_TME_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_TME_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_TME_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_TME_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_TME_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_TME_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_TME_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_TME_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00024008)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024008)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024008)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_RMSK                                                            0x81d00005
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ADDR, HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_RMSK)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_ADDR,m,v,HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IN)
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_BOOT_ROM_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TME_SNOC_QXM_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0002400c)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002400c)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002400c)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_RMSK                                                                0x81d00005
#define HWIO_GCC_TME_SNOC_QXM_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TME_SNOC_QXM_CBCR_ADDR, HWIO_GCC_TME_SNOC_QXM_CBCR_RMSK)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_SNOC_QXM_CBCR_ADDR, m)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_SNOC_QXM_CBCR_ADDR,v)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_SNOC_QXM_CBCR_ADDR,m,v,HWIO_GCC_TME_SNOC_QXM_CBCR_IN)
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_TME_SNOC_QXM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_TME_SNOC_QXM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_TME_TRIG_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00024010)
#define HWIO_GCC_TME_TRIG_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024010)
#define HWIO_GCC_TME_TRIG_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024010)
#define HWIO_GCC_TME_TRIG_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_TME_TRIG_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_TME_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TME_TRIG_CBCR_ADDR, HWIO_GCC_TME_TRIG_CBCR_RMSK)
#define HWIO_GCC_TME_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_TME_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_TME_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_TRIG_CBCR_ADDR,m,v,HWIO_GCC_TME_TRIG_CBCR_IN)
#define HWIO_GCC_TME_TRIG_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_TME_TRIG_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_TME_TRIG_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_TME_TRIG_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_TME_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_TME_TRIG_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_TME_TRIG_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_TME_TRIG_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_TME_TRIG_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_TME_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_TME_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_TME_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_TME_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00024014)
#define HWIO_GCC_TME_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024014)
#define HWIO_GCC_TME_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024014)
#define HWIO_GCC_TME_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_TME_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_TME_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TME_AT_CBCR_ADDR, HWIO_GCC_TME_AT_CBCR_RMSK)
#define HWIO_GCC_TME_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_AT_CBCR_ADDR, m)
#define HWIO_GCC_TME_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_AT_CBCR_ADDR,v)
#define HWIO_GCC_TME_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_AT_CBCR_ADDR,m,v,HWIO_GCC_TME_AT_CBCR_IN)
#define HWIO_GCC_TME_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_TME_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_TME_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_TME_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_TME_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_TME_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_TME_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_TME_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_TME_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_TME_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_TME_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_TME_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_TME_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_TME_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_TME_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_TME_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_TME_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_TME_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_TME_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_TME_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_TME_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_TME_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_TME_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_TME_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_TCSR_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00027000)
#define HWIO_GCC_TCSR_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00027000)
#define HWIO_GCC_TCSR_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00027000)
#define HWIO_GCC_TCSR_BCR_RMSK                                                                                0x1
#define HWIO_GCC_TCSR_BCR_ATTR                                                                                0x3
#define HWIO_GCC_TCSR_BCR_IN          \
        in_dword_masked(HWIO_GCC_TCSR_BCR_ADDR, HWIO_GCC_TCSR_BCR_RMSK)
#define HWIO_GCC_TCSR_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCSR_BCR_ADDR, m)
#define HWIO_GCC_TCSR_BCR_OUT(v)      \
        out_dword(HWIO_GCC_TCSR_BCR_ADDR,v)
#define HWIO_GCC_TCSR_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCSR_BCR_ADDR,m,v,HWIO_GCC_TCSR_BCR_IN)
#define HWIO_GCC_TCSR_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_TCSR_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_TCSR_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_TCSR_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_TCSR_AHB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00027004)
#define HWIO_GCC_TCSR_AHB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00027004)
#define HWIO_GCC_TCSR_AHB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00027004)
#define HWIO_GCC_TCSR_AHB_CBCR_RMSK                                                                    0x81d00004
#define HWIO_GCC_TCSR_AHB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_TCSR_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCSR_AHB_CBCR_ADDR, HWIO_GCC_TCSR_AHB_CBCR_RMSK)
#define HWIO_GCC_TCSR_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCSR_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TCSR_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCSR_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TCSR_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCSR_AHB_CBCR_ADDR,m,v,HWIO_GCC_TCSR_AHB_CBCR_IN)
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_TCSR_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_TCSR_AHB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1

#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00027008)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00027008)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00027008)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_RMSK                                                             0x81c0000f
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ADDR, HWIO_GCC_TCSR_ACC_SERIAL_CBCR_RMSK)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ADDR, m)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ADDR,v)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TCSR_ACC_SERIAL_CBCR_ADDR,m,v,HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IN)
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TCSR_ACC_SERIAL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_MEMRED_P2S_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0002d000)
#define HWIO_GCC_MEMRED_P2S_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002d000)
#define HWIO_GCC_MEMRED_P2S_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002d000)
#define HWIO_GCC_MEMRED_P2S_CBCR_RMSK                                                                  0x81c0000f
#define HWIO_GCC_MEMRED_P2S_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_MEMRED_P2S_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MEMRED_P2S_CBCR_ADDR, HWIO_GCC_MEMRED_P2S_CBCR_RMSK)
#define HWIO_GCC_MEMRED_P2S_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMRED_P2S_CBCR_ADDR, m)
#define HWIO_GCC_MEMRED_P2S_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MEMRED_P2S_CBCR_ADDR,v)
#define HWIO_GCC_MEMRED_P2S_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMRED_P2S_CBCR_ADDR,m,v,HWIO_GCC_MEMRED_P2S_CBCR_IN)
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_MEMRED_P2S_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_MEMRED_P2S_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_MEMRED_P2S_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_MEMRED_P2S_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_MEMRED_P2S_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_MEMRED_P2S_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_MEMRED_P2S_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_MEMRED_P2S_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_MEMRED_P2S_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MEMRED_P2S_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_MEMRED_P2S_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_MEMRED_CMD_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0002d004)
#define HWIO_GCC_MEMRED_CMD_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002d004)
#define HWIO_GCC_MEMRED_CMD_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002d004)
#define HWIO_GCC_MEMRED_CMD_RCGR_RMSK                                                                  0x80000013
#define HWIO_GCC_MEMRED_CMD_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_MEMRED_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MEMRED_CMD_RCGR_ADDR, HWIO_GCC_MEMRED_CMD_RCGR_RMSK)
#define HWIO_GCC_MEMRED_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMRED_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MEMRED_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MEMRED_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MEMRED_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMRED_CMD_RCGR_ADDR,m,v,HWIO_GCC_MEMRED_CMD_RCGR_IN)
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MEMRED_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                         0x10
#define HWIO_GCC_MEMRED_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                          0x4
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_EN_BMSK                                                                 0x2
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_EN_SHFT                                                                 0x1
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MEMRED_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MEMRED_CMD_RCGR_UPDATE_BMSK                                                                  0x1
#define HWIO_GCC_MEMRED_CMD_RCGR_UPDATE_SHFT                                                                  0x0
#define HWIO_GCC_MEMRED_CMD_RCGR_UPDATE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MEMRED_CMD_RCGR_UPDATE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_MEMRED_CFG_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0002d008)
#define HWIO_GCC_MEMRED_CFG_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002d008)
#define HWIO_GCC_MEMRED_CFG_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002d008)
#define HWIO_GCC_MEMRED_CFG_RCGR_RMSK                                                                    0x11071f
#define HWIO_GCC_MEMRED_CFG_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_MEMRED_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MEMRED_CFG_RCGR_ADDR, HWIO_GCC_MEMRED_CFG_RCGR_RMSK)
#define HWIO_GCC_MEMRED_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMRED_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MEMRED_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MEMRED_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MEMRED_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMRED_CFG_RCGR_ADDR,m,v,HWIO_GCC_MEMRED_CFG_RCGR_IN)
#define HWIO_GCC_MEMRED_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                     0x100000
#define HWIO_GCC_MEMRED_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                         0x14
#define HWIO_GCC_MEMRED_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_MEMRED_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_MEMRED_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                     0x10000
#define HWIO_GCC_MEMRED_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                        0x10
#define HWIO_GCC_MEMRED_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                         0x0
#define HWIO_GCC_MEMRED_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                        0x1
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_BMSK                                                               0x700
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SHFT                                                                 0x8
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                            0x0
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                            0x1
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                            0x2
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                            0x3
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                            0x4
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                            0x5
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                            0x6
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                            0x7
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_BMSK                                                                0x1f
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_SHFT                                                                 0x0
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                          0x0
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                            0x1
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                          0x2
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                            0x3
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                          0x4
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                            0x5
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                          0x6
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                            0x7
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                          0x8
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                            0x9
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                          0xa
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                            0xb
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                          0xc
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                            0xd
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                          0xe
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                            0xf
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                         0x10
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                           0x11
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                         0x12
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                          0x13
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                        0x14
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                          0x15
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                        0x16
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                          0x17
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                        0x18
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                          0x19
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                        0x1a
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                          0x1b
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                        0x1c
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                          0x1d
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                        0x1e
#define HWIO_GCC_MEMRED_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                          0x1f

#define HWIO_GCC_BOOT_ROM_BCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00028000)
#define HWIO_GCC_BOOT_ROM_BCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00028000)
#define HWIO_GCC_BOOT_ROM_BCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00028000)
#define HWIO_GCC_BOOT_ROM_BCR_RMSK                                                                            0x1
#define HWIO_GCC_BOOT_ROM_BCR_ATTR                                                                            0x3
#define HWIO_GCC_BOOT_ROM_BCR_IN          \
        in_dword_masked(HWIO_GCC_BOOT_ROM_BCR_ADDR, HWIO_GCC_BOOT_ROM_BCR_RMSK)
#define HWIO_GCC_BOOT_ROM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_BOOT_ROM_BCR_ADDR, m)
#define HWIO_GCC_BOOT_ROM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_BOOT_ROM_BCR_ADDR,v)
#define HWIO_GCC_BOOT_ROM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_BOOT_ROM_BCR_ADDR,m,v,HWIO_GCC_BOOT_ROM_BCR_IN)
#define HWIO_GCC_BOOT_ROM_BCR_BLK_ARES_BMSK                                                                   0x1
#define HWIO_GCC_BOOT_ROM_BCR_BLK_ARES_SHFT                                                                   0x0
#define HWIO_GCC_BOOT_ROM_BCR_BLK_ARES_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_BOOT_ROM_BCR_BLK_ARES_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_BOOT_ROM_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00028004)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00028004)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00028004)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_RMSK                                                                0x81d0700e
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_CBCR_ADDR, HWIO_GCC_BOOT_ROM_AHB_CBCR_RMSK)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_BOOT_ROM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_BOOT_ROM_AHB_CBCR_ADDR,m,v,HWIO_GCC_BOOT_ROM_AHB_CBCR_IN)
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_CORE_ON_BMSK                                                  0x4000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_CORE_ON_SHFT                                                     0xe
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                0x2000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                   0xd
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                               0x1000
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                  0xc
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_BOOT_ROM_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_BOOT_ROM_AHB_SREGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00028008)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00028008)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00028008)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_RMSK                                                                0xf1ffffe
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_ATTR                                                                      0x3
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_IN          \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_SREGR_ADDR, HWIO_GCC_BOOT_ROM_AHB_SREGR_RMSK)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_SREGR_ADDR, m)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_BOOT_ROM_AHB_SREGR_ADDR,v)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_BOOT_ROM_AHB_SREGR_ADDR,m,v,HWIO_GCC_BOOT_ROM_AHB_SREGR_IN)
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                      0xf000000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                           0x18
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PWR_FSM_CLK_SEL_BMSK                                                 0x100000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PWR_FSM_CLK_SEL_SHFT                                                     0x14
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                         0xf0000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                            0x10
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                           0x8000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                              0xf
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                    0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                       0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                            0x4000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                               0xe
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                               0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                            0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                           0x2000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                              0xd
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                  0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                     0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                       0x1000
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                          0xc
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                 0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                    0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CORE_ON_ACK_BMSK                                                    0x800
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CORE_ON_ACK_SHFT                                                      0xb
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                  0x400
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                    0xa
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                           0x300
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                             0x8
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                    0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                    0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                    0x2
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                    0x3
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_ENABLE_BMSK                                                      0x80
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_ENABLE_SHFT                                                       0x7
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_FORCE_CLK_ON_BMSK                                                        0x40
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_FORCE_CLK_ON_SHFT                                                         0x6
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                  0x20
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                   0x5
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                          0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                     0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SLP_STG_BMSK                                                      0x10
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SLP_STG_SHFT                                                       0x4
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                             0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                     0x8
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                     0x3
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                          0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                             0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                0x4
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                0x2
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL            0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                    0x2
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                    0x1
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                              0x0
#define HWIO_GCC_BOOT_ROM_AHB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                               0x1

#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0002800c)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002800c)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002800c)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_RMSK                                                           0xffffffff
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ATTR                                                                  0x3
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ADDR, HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_RMSK)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ADDR, m)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ADDR,v)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_ADDR,m,v,HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_IN)
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                        0xfc000000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                              0x1a
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                   0x2000000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                        0x19
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                     0x1000000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                          0x18
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                        0x800000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                            0x17
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                          0x400000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                              0x16
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CPH_TIMER_BMSK                                               0x3f0000
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                   0x10
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_SLEEP_TIMER_BMSK                                                   0xff00
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_SLEEP_TIMER_SHFT                                                      0x8
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_WAKEUP_TIMER_BMSK                                                    0xff
#define HWIO_GCC_BOOT_ROM_AHB_CFG_SREGR_WAKEUP_TIMER_SHFT                                                     0x0

#define HWIO_GCC_TLMM_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002a000)
#define HWIO_GCC_TLMM_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002a000)
#define HWIO_GCC_TLMM_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002a000)
#define HWIO_GCC_TLMM_BCR_RMSK                                                                                0x1
#define HWIO_GCC_TLMM_BCR_ATTR                                                                                0x3
#define HWIO_GCC_TLMM_BCR_IN          \
        in_dword_masked(HWIO_GCC_TLMM_BCR_ADDR, HWIO_GCC_TLMM_BCR_RMSK)
#define HWIO_GCC_TLMM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TLMM_BCR_ADDR, m)
#define HWIO_GCC_TLMM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_TLMM_BCR_ADDR,v)
#define HWIO_GCC_TLMM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TLMM_BCR_ADDR,m,v,HWIO_GCC_TLMM_BCR_IN)
#define HWIO_GCC_TLMM_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_TLMM_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_TLMM_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_TLMM_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_TLMM_AHB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0002a004)
#define HWIO_GCC_TLMM_AHB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002a004)
#define HWIO_GCC_TLMM_AHB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002a004)
#define HWIO_GCC_TLMM_AHB_CBCR_RMSK                                                                    0x81d0000e
#define HWIO_GCC_TLMM_AHB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_TLMM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TLMM_AHB_CBCR_ADDR, HWIO_GCC_TLMM_AHB_CBCR_RMSK)
#define HWIO_GCC_TLMM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TLMM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TLMM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TLMM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TLMM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TLMM_AHB_CBCR_ADDR,m,v,HWIO_GCC_TLMM_AHB_CBCR_IN)
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_TLMM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_TLMM_AHB_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_TLMM_AHB_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_TLMM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_TLMM_AHB_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_TLMM_AHB_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_TLMM_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_TLMM_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_TLMM_CBCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0002a008)
#define HWIO_GCC_TLMM_CBCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002a008)
#define HWIO_GCC_TLMM_CBCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002a008)
#define HWIO_GCC_TLMM_CBCR_RMSK                                                                        0x81d00004
#define HWIO_GCC_TLMM_CBCR_ATTR                                                                               0x3
#define HWIO_GCC_TLMM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TLMM_CBCR_ADDR, HWIO_GCC_TLMM_CBCR_RMSK)
#define HWIO_GCC_TLMM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TLMM_CBCR_ADDR, m)
#define HWIO_GCC_TLMM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TLMM_CBCR_ADDR,v)
#define HWIO_GCC_TLMM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TLMM_CBCR_ADDR,m,v,HWIO_GCC_TLMM_CBCR_IN)
#define HWIO_GCC_TLMM_CBCR_CLK_OFF_BMSK                                                                0x80000000
#define HWIO_GCC_TLMM_CBCR_CLK_OFF_SHFT                                                                      0x1f
#define HWIO_GCC_TLMM_CBCR_IGNORE_ALL_ARES_BMSK                                                         0x1000000
#define HWIO_GCC_TLMM_CBCR_IGNORE_ALL_ARES_SHFT                                                              0x18
#define HWIO_GCC_TLMM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                       0x800000
#define HWIO_GCC_TLMM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                           0x17
#define HWIO_GCC_TLMM_CBCR_CLK_DIS_BMSK                                                                  0x400000
#define HWIO_GCC_TLMM_CBCR_CLK_DIS_SHFT                                                                      0x16
#define HWIO_GCC_TLMM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                      0x100000
#define HWIO_GCC_TLMM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                          0x14
#define HWIO_GCC_TLMM_CBCR_CLK_ARES_BMSK                                                                      0x4
#define HWIO_GCC_TLMM_CBCR_CLK_ARES_SHFT                                                                      0x2
#define HWIO_GCC_TLMM_CBCR_CLK_ARES_NO_RESET_FVAL                                                             0x0
#define HWIO_GCC_TLMM_CBCR_CLK_ARES_RESET_FVAL                                                                0x1

#define HWIO_GCC_AOSS_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002c000)
#define HWIO_GCC_AOSS_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002c000)
#define HWIO_GCC_AOSS_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002c000)
#define HWIO_GCC_AOSS_BCR_RMSK                                                                                0x1
#define HWIO_GCC_AOSS_BCR_ATTR                                                                                0x3
#define HWIO_GCC_AOSS_BCR_IN          \
        in_dword_masked(HWIO_GCC_AOSS_BCR_ADDR, HWIO_GCC_AOSS_BCR_RMSK)
#define HWIO_GCC_AOSS_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AOSS_BCR_ADDR, m)
#define HWIO_GCC_AOSS_BCR_OUT(v)      \
        out_dword(HWIO_GCC_AOSS_BCR_ADDR,v)
#define HWIO_GCC_AOSS_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AOSS_BCR_ADDR,m,v,HWIO_GCC_AOSS_BCR_IN)
#define HWIO_GCC_AOSS_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_AOSS_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_AOSS_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_AOSS_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002c004)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002c004)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002c004)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_RMSK                                                             0x81d00005
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ADDR, HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_RMSK)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_ADDR,m,v,HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IN)
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_AOSS_CNOC_M_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002c008)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002c008)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002c008)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_RMSK                                                             0x81d0000f
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ADDR, HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_RMSK)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_ADDR,m,v,HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IN)
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_AOSS_CNOC_S_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_AOSS_AT_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0002c00c)
#define HWIO_GCC_AOSS_AT_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002c00c)
#define HWIO_GCC_AOSS_AT_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002c00c)
#define HWIO_GCC_AOSS_AT_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_AOSS_AT_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_AOSS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AOSS_AT_CBCR_ADDR, HWIO_GCC_AOSS_AT_CBCR_RMSK)
#define HWIO_GCC_AOSS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AOSS_AT_CBCR_ADDR, m)
#define HWIO_GCC_AOSS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AOSS_AT_CBCR_ADDR,v)
#define HWIO_GCC_AOSS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AOSS_AT_CBCR_ADDR,m,v,HWIO_GCC_AOSS_AT_CBCR_IN)
#define HWIO_GCC_AOSS_AT_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_AOSS_AT_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_AOSS_AT_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_AOSS_AT_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_AOSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_AOSS_AT_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_AOSS_AT_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_AOSS_AT_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_AOSS_AT_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_AOSS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_AOSS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_AOSS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SPDM_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00030000)
#define HWIO_GCC_SPDM_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030000)
#define HWIO_GCC_SPDM_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030000)
#define HWIO_GCC_SPDM_BCR_RMSK                                                                                0x1
#define HWIO_GCC_SPDM_BCR_ATTR                                                                                0x3
#define HWIO_GCC_SPDM_BCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_BCR_ADDR, HWIO_GCC_SPDM_BCR_RMSK)
#define HWIO_GCC_SPDM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_BCR_ADDR, m)
#define HWIO_GCC_SPDM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_BCR_ADDR,v)
#define HWIO_GCC_SPDM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_BCR_ADDR,m,v,HWIO_GCC_SPDM_BCR_IN)
#define HWIO_GCC_SPDM_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_SPDM_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_SPDM_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_SPDM_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_SPDM_FF_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00030004)
#define HWIO_GCC_SPDM_FF_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030004)
#define HWIO_GCC_SPDM_FF_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030004)
#define HWIO_GCC_SPDM_FF_CBCR_RMSK                                                                     0x81c00005
#define HWIO_GCC_SPDM_FF_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_SPDM_FF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_FF_CBCR_ADDR, HWIO_GCC_SPDM_FF_CBCR_RMSK)
#define HWIO_GCC_SPDM_FF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_FF_CBCR_ADDR, m)
#define HWIO_GCC_SPDM_FF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_FF_CBCR_ADDR,v)
#define HWIO_GCC_SPDM_FF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_FF_CBCR_ADDR,m,v,HWIO_GCC_SPDM_FF_CBCR_IN)
#define HWIO_GCC_SPDM_FF_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_SPDM_FF_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_SPDM_FF_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_SPDM_FF_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_SPDM_FF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_SPDM_FF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_SPDM_FF_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_SPDM_FF_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SPDM_FF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00030008)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030008)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030008)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_RMSK                                                              0x81d00005
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ADDR, HWIO_GCC_SPDM_MEMNOC_CY_CBCR_RMSK)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ADDR, m)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ADDR,v)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_MEMNOC_CY_CBCR_ADDR,m,v,HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IN)
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SPDM_MEMNOC_CY_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SPDM_SNOC_CY_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0003000c)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003000c)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003000c)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_RMSK                                                                0x81d00005
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_SNOC_CY_CBCR_ADDR, HWIO_GCC_SPDM_SNOC_CY_CBCR_RMSK)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_SNOC_CY_CBCR_ADDR, m)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_SNOC_CY_CBCR_ADDR,v)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_SNOC_CY_CBCR_ADDR,m,v,HWIO_GCC_SPDM_SNOC_CY_CBCR_IN)
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SPDM_SNOC_CY_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00030010)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030010)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030010)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_RMSK                                                               0x81c00005
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_DEBUG_CY_CBCR_ADDR, HWIO_GCC_SPDM_DEBUG_CY_CBCR_RMSK)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_DEBUG_CY_CBCR_ADDR, m)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_DEBUG_CY_CBCR_ADDR,v)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_DEBUG_CY_CBCR_ADDR,m,v,HWIO_GCC_SPDM_DEBUG_CY_CBCR_IN)
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_SPDM_DEBUG_CY_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_SPDM_PNOC_CY_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00030014)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030014)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030014)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_RMSK                                                                0x81d00005
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_PNOC_CY_CBCR_ADDR, HWIO_GCC_SPDM_PNOC_CY_CBCR_RMSK)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_PNOC_CY_CBCR_ADDR, m)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_PNOC_CY_CBCR_ADDR,v)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_PNOC_CY_CBCR_ADDR,m,v,HWIO_GCC_SPDM_PNOC_CY_CBCR_IN)
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SPDM_PNOC_CY_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00030018)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030018)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030018)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_RMSK                                                                0xf
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ATTR                                                                0x3
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ADDR, HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_RMSK)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_ADDR,m,v,HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_IN)
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_CLK_DIV_BMSK                                                        0xf
#define HWIO_GCC_SPDM_MEMNOC_CY_DIV_CDIVR_CLK_DIV_SHFT                                                        0x0

#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003001c)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003001c)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003001c)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_RMSK                                                                  0xf
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ATTR                                                                  0x3
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ADDR, HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_RMSK)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_ADDR,m,v,HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_IN)
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_CLK_DIV_BMSK                                                          0xf
#define HWIO_GCC_SPDM_SNOC_CY_DIV_CDIVR_CLK_DIV_SHFT                                                          0x0

#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00030020)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00030020)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00030020)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_RMSK                                                                 0xf
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ATTR                                                                 0x3
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ADDR, HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_RMSK)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_ADDR,m,v,HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_IN)
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_CLK_DIV_BMSK                                                         0xf
#define HWIO_GCC_SPDM_DEBUG_CY_DIV_CDIVR_CLK_DIV_SHFT                                                         0x0

#define HWIO_GCC_CE1_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00031000)
#define HWIO_GCC_CE1_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031000)
#define HWIO_GCC_CE1_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031000)
#define HWIO_GCC_CE1_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_CE1_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_CE1_BCR_IN          \
        in_dword_masked(HWIO_GCC_CE1_BCR_ADDR, HWIO_GCC_CE1_BCR_RMSK)
#define HWIO_GCC_CE1_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_BCR_ADDR, m)
#define HWIO_GCC_CE1_BCR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_BCR_ADDR,v)
#define HWIO_GCC_CE1_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_BCR_ADDR,m,v,HWIO_GCC_CE1_BCR_IN)
#define HWIO_GCC_CE1_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_CE1_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_CE1_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_CE1_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_CE1_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00031004)
#define HWIO_GCC_CE1_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031004)
#define HWIO_GCC_CE1_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031004)
#define HWIO_GCC_CE1_CBCR_RMSK                                                                         0x81d07004
#define HWIO_GCC_CE1_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_CE1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CE1_CBCR_ADDR, HWIO_GCC_CE1_CBCR_RMSK)
#define HWIO_GCC_CE1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_CBCR_ADDR, m)
#define HWIO_GCC_CE1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_CBCR_ADDR,v)
#define HWIO_GCC_CE1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_CBCR_ADDR,m,v,HWIO_GCC_CE1_CBCR_IN)
#define HWIO_GCC_CE1_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_CE1_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_CE1_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_CE1_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_CE1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_CE1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_CE1_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_CE1_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_CE1_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                       0x100000
#define HWIO_GCC_CE1_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                           0x14
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_CORE_ON_BMSK                                                           0x4000
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_CORE_ON_SHFT                                                              0xe
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                         0x2000
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                            0xd
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                        0x1000
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                           0xc
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_CE1_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_CE1_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_CE1_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_CE1_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_CE1_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1

#define HWIO_GCC_CE1_SREGR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00031008)
#define HWIO_GCC_CE1_SREGR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031008)
#define HWIO_GCC_CE1_SREGR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031008)
#define HWIO_GCC_CE1_SREGR_RMSK                                                                         0xf1ffffe
#define HWIO_GCC_CE1_SREGR_ATTR                                                                               0x3
#define HWIO_GCC_CE1_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CE1_SREGR_ADDR, HWIO_GCC_CE1_SREGR_RMSK)
#define HWIO_GCC_CE1_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_SREGR_ADDR, m)
#define HWIO_GCC_CE1_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_SREGR_ADDR,v)
#define HWIO_GCC_CE1_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_SREGR_ADDR,m,v,HWIO_GCC_CE1_SREGR_IN)
#define HWIO_GCC_CE1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                               0xf000000
#define HWIO_GCC_CE1_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                                    0x18
#define HWIO_GCC_CE1_SREGR_PWR_FSM_CLK_SEL_BMSK                                                          0x100000
#define HWIO_GCC_CE1_SREGR_PWR_FSM_CLK_SEL_SHFT                                                              0x14
#define HWIO_GCC_CE1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                                  0xf0000
#define HWIO_GCC_CE1_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                     0x10
#define HWIO_GCC_CE1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                                    0x8000
#define HWIO_GCC_CE1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                       0xf
#define HWIO_GCC_CE1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                             0x0
#define HWIO_GCC_CE1_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                                0x1
#define HWIO_GCC_CE1_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                     0x4000
#define HWIO_GCC_CE1_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                        0xe
#define HWIO_GCC_CE1_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                        0x0
#define HWIO_GCC_CE1_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                     0x1
#define HWIO_GCC_CE1_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                                    0x2000
#define HWIO_GCC_CE1_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                       0xd
#define HWIO_GCC_CE1_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                           0x0
#define HWIO_GCC_CE1_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                              0x1
#define HWIO_GCC_CE1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                                0x1000
#define HWIO_GCC_CE1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                                   0xc
#define HWIO_GCC_CE1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_CE1_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                             0x1
#define HWIO_GCC_CE1_SREGR_MEM_CORE_ON_ACK_BMSK                                                             0x800
#define HWIO_GCC_CE1_SREGR_MEM_CORE_ON_ACK_SHFT                                                               0xb
#define HWIO_GCC_CE1_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                           0x400
#define HWIO_GCC_CE1_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                             0xa
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                                    0x300
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                      0x8
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                             0x0
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                             0x1
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                             0x2
#define HWIO_GCC_CE1_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                             0x3
#define HWIO_GCC_CE1_SREGR_MEM_CPH_ENABLE_BMSK                                                               0x80
#define HWIO_GCC_CE1_SREGR_MEM_CPH_ENABLE_SHFT                                                                0x7
#define HWIO_GCC_CE1_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_CE1_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_CE1_SREGR_FORCE_CLK_ON_BMSK                                                                 0x40
#define HWIO_GCC_CE1_SREGR_FORCE_CLK_ON_SHFT                                                                  0x6
#define HWIO_GCC_CE1_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                         0x0
#define HWIO_GCC_CE1_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CE1_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                           0x20
#define HWIO_GCC_CE1_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                            0x5
#define HWIO_GCC_CE1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                                   0x0
#define HWIO_GCC_CE1_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                              0x1
#define HWIO_GCC_CE1_SREGR_SW_RST_SLP_STG_BMSK                                                               0x10
#define HWIO_GCC_CE1_SREGR_SW_RST_SLP_STG_SHFT                                                                0x4
#define HWIO_GCC_CE1_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                      0x0
#define HWIO_GCC_CE1_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                         0x1
#define HWIO_GCC_CE1_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                              0x8
#define HWIO_GCC_CE1_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                              0x3
#define HWIO_GCC_CE1_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                                   0x0
#define HWIO_GCC_CE1_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                      0x1
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                         0x4
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                         0x2
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                     0x0
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                             0x2
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                             0x1
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                       0x0
#define HWIO_GCC_CE1_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                        0x1

#define HWIO_GCC_CE1_CFG_SREGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003100c)
#define HWIO_GCC_CE1_CFG_SREGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003100c)
#define HWIO_GCC_CE1_CFG_SREGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003100c)
#define HWIO_GCC_CE1_CFG_SREGR_RMSK                                                                    0xffffffff
#define HWIO_GCC_CE1_CFG_SREGR_ATTR                                                                           0x3
#define HWIO_GCC_CE1_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_CE1_CFG_SREGR_ADDR, HWIO_GCC_CE1_CFG_SREGR_RMSK)
#define HWIO_GCC_CE1_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_CFG_SREGR_ADDR, m)
#define HWIO_GCC_CE1_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_CFG_SREGR_ADDR,v)
#define HWIO_GCC_CE1_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_CFG_SREGR_ADDR,m,v,HWIO_GCC_CE1_CFG_SREGR_IN)
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                                 0xfc000000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                       0x1a
#define HWIO_GCC_CE1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                            0x2000000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                                 0x19
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                              0x1000000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                                   0x18
#define HWIO_GCC_CE1_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                                 0x800000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                     0x17
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                                   0x400000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                       0x16
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                        0x3f0000
#define HWIO_GCC_CE1_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                            0x10
#define HWIO_GCC_CE1_CFG_SREGR_SLEEP_TIMER_BMSK                                                            0xff00
#define HWIO_GCC_CE1_CFG_SREGR_SLEEP_TIMER_SHFT                                                               0x8
#define HWIO_GCC_CE1_CFG_SREGR_WAKEUP_TIMER_BMSK                                                             0xff
#define HWIO_GCC_CE1_CFG_SREGR_WAKEUP_TIMER_SHFT                                                              0x0

#define HWIO_GCC_CE1_AXI_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00031010)
#define HWIO_GCC_CE1_AXI_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031010)
#define HWIO_GCC_CE1_AXI_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031010)
#define HWIO_GCC_CE1_AXI_CBCR_RMSK                                                                     0x81d00004
#define HWIO_GCC_CE1_AXI_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_CE1_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CE1_AXI_CBCR_ADDR, HWIO_GCC_CE1_AXI_CBCR_RMSK)
#define HWIO_GCC_CE1_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_AXI_CBCR_ADDR, m)
#define HWIO_GCC_CE1_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_AXI_CBCR_ADDR,v)
#define HWIO_GCC_CE1_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_AXI_CBCR_ADDR,m,v,HWIO_GCC_CE1_AXI_CBCR_IN)
#define HWIO_GCC_CE1_AXI_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_CE1_AXI_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_CE1_AXI_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_CE1_AXI_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_CE1_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_CE1_AXI_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_CE1_AXI_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_CE1_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_CE1_AXI_CBCR_CLK_ARES_RESET_FVAL                                                             0x1

#define HWIO_GCC_CE1_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00031014)
#define HWIO_GCC_CE1_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031014)
#define HWIO_GCC_CE1_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031014)
#define HWIO_GCC_CE1_AHB_CBCR_RMSK                                                                     0x81d0000e
#define HWIO_GCC_CE1_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_CE1_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CE1_AHB_CBCR_ADDR, HWIO_GCC_CE1_AHB_CBCR_RMSK)
#define HWIO_GCC_CE1_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CE1_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CE1_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_AHB_CBCR_ADDR,m,v,HWIO_GCC_CE1_AHB_CBCR_IN)
#define HWIO_GCC_CE1_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_CE1_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_CE1_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_CE1_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_CE1_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_CE1_AHB_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_CE1_AHB_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_CE1_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_CE1_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_CE1_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_CE1_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_CE1_AHB_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_CE1_AHB_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_CE1_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_CE1_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_RPMH_CE_CMD_DFSR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0003102c)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003102c)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003102c)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_RMSK                                                                     0xffff
#define HWIO_GCC_RPMH_CE_CMD_DFSR_ATTR                                                                        0x3
#define HWIO_GCC_RPMH_CE_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CMD_DFSR_ADDR, HWIO_GCC_RPMH_CE_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CMD_DFSR_RCG_SW_CTRL_BMSK                                                         0x8000
#define HWIO_GCC_RPMH_CE_CMD_DFSR_RCG_SW_CTRL_SHFT                                                            0xf
#define HWIO_GCC_RPMH_CE_CMD_DFSR_SW_PERF_STATE_BMSK                                                       0x7800
#define HWIO_GCC_RPMH_CE_CMD_DFSR_SW_PERF_STATE_SHFT                                                          0xb
#define HWIO_GCC_RPMH_CE_CMD_DFSR_SW_OVERRIDE_BMSK                                                          0x400
#define HWIO_GCC_RPMH_CE_CMD_DFSR_SW_OVERRIDE_SHFT                                                            0xa
#define HWIO_GCC_RPMH_CE_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                             0x200
#define HWIO_GCC_RPMH_CE_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                               0x9
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_FSM_STATE_BMSK                                                        0x1c0
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_FSM_STATE_SHFT                                                          0x6
#define HWIO_GCC_RPMH_CE_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                        0x20
#define HWIO_GCC_RPMH_CE_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                         0x5
#define HWIO_GCC_RPMH_CE_CMD_DFSR_CURR_PERF_STATE_BMSK                                                       0x1e
#define HWIO_GCC_RPMH_CE_CMD_DFSR_CURR_PERF_STATE_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_EN_BMSK                                                                 0x1
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_EN_SHFT                                                                 0x0
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_RPMH_CE_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031034)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031034)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031034)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031038)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031038)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031038)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003103c)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003103c)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003103c)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031040)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031040)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031040)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031044)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031044)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031044)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031048)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031048)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031048)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003104c)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003104c)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003104c)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031050)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031050)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031050)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031054)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031054)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031054)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00031058)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031058)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031058)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_RMSK                                                                0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0003105c)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003105c)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003105c)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00031060)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031060)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031060)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00031064)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031064)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031064)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00031068)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031068)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031068)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0003106c)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003106c)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003106c)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00031070)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031070)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031070)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_RMSK                                                               0x71f
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_RPMH_CE_CE1_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_CE1_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00031018)
#define HWIO_GCC_CE1_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00031018)
#define HWIO_GCC_CE1_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00031018)
#define HWIO_GCC_CE1_CMD_RCGR_RMSK                                                                     0x80000013
#define HWIO_GCC_CE1_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_CE1_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CE1_CMD_RCGR_ADDR, HWIO_GCC_CE1_CMD_RCGR_RMSK)
#define HWIO_GCC_CE1_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CE1_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CE1_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_CMD_RCGR_ADDR,m,v,HWIO_GCC_CE1_CMD_RCGR_IN)
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_CE1_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_CE1_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_CE1_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_CE1_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_CE1_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_CE1_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_CE1_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_CE1_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003101c)
#define HWIO_GCC_CE1_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003101c)
#define HWIO_GCC_CE1_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003101c)
#define HWIO_GCC_CE1_CFG_RCGR_RMSK                                                                       0x11071f
#define HWIO_GCC_CE1_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_CE1_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CE1_CFG_RCGR_ADDR, HWIO_GCC_CE1_CFG_RCGR_RMSK)
#define HWIO_GCC_CE1_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CE1_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CE1_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CE1_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CE1_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CE1_CFG_RCGR_ADDR,m,v,HWIO_GCC_CE1_CFG_RCGR_IN)
#define HWIO_GCC_CE1_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_CE1_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_CE1_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CE1_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_CE1_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                        0x10000
#define HWIO_GCC_CE1_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                           0x10
#define HWIO_GCC_CE1_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                            0x0
#define HWIO_GCC_CE1_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                           0x1
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_CE1_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_CE1_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_AT_CBCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00033000)
#define HWIO_GCC_AT_CBCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033000)
#define HWIO_GCC_AT_CBCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033000)
#define HWIO_GCC_AT_CBCR_RMSK                                                                          0x81d0000f
#define HWIO_GCC_AT_CBCR_ATTR                                                                                 0x3
#define HWIO_GCC_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AT_CBCR_ADDR, HWIO_GCC_AT_CBCR_RMSK)
#define HWIO_GCC_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AT_CBCR_ADDR, m)
#define HWIO_GCC_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AT_CBCR_ADDR,v)
#define HWIO_GCC_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AT_CBCR_ADDR,m,v,HWIO_GCC_AT_CBCR_IN)
#define HWIO_GCC_AT_CBCR_CLK_OFF_BMSK                                                                  0x80000000
#define HWIO_GCC_AT_CBCR_CLK_OFF_SHFT                                                                        0x1f
#define HWIO_GCC_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                           0x1000000
#define HWIO_GCC_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                                0x18
#define HWIO_GCC_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                         0x800000
#define HWIO_GCC_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                             0x17
#define HWIO_GCC_AT_CBCR_CLK_DIS_BMSK                                                                    0x400000
#define HWIO_GCC_AT_CBCR_CLK_DIS_SHFT                                                                        0x16
#define HWIO_GCC_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                        0x100000
#define HWIO_GCC_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                            0x14
#define HWIO_GCC_AT_CBCR_SW_ONLY_EN_BMSK                                                                      0x8
#define HWIO_GCC_AT_CBCR_SW_ONLY_EN_SHFT                                                                      0x3
#define HWIO_GCC_AT_CBCR_CLK_ARES_BMSK                                                                        0x4
#define HWIO_GCC_AT_CBCR_CLK_ARES_SHFT                                                                        0x2
#define HWIO_GCC_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                               0x0
#define HWIO_GCC_AT_CBCR_CLK_ARES_RESET_FVAL                                                                  0x1
#define HWIO_GCC_AT_CBCR_HW_CTL_BMSK                                                                          0x2
#define HWIO_GCC_AT_CBCR_HW_CTL_SHFT                                                                          0x1
#define HWIO_GCC_AT_CBCR_HW_CTL_DISABLE_FVAL                                                                  0x0
#define HWIO_GCC_AT_CBCR_HW_CTL_ENABLE_FVAL                                                                   0x1
#define HWIO_GCC_AT_CBCR_CLK_ENABLE_BMSK                                                                      0x1
#define HWIO_GCC_AT_CBCR_CLK_ENABLE_SHFT                                                                      0x0
#define HWIO_GCC_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_AHB_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00033004)
#define HWIO_GCC_AHB_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033004)
#define HWIO_GCC_AHB_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033004)
#define HWIO_GCC_AHB_CBCR_RMSK                                                                         0x81d00004
#define HWIO_GCC_AHB_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AHB_CBCR_ADDR, HWIO_GCC_AHB_CBCR_RMSK)
#define HWIO_GCC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AHB_CBCR_ADDR,m,v,HWIO_GCC_AHB_CBCR_IN)
#define HWIO_GCC_AHB_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_AHB_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_AHB_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_AHB_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                       0x100000
#define HWIO_GCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                           0x14
#define HWIO_GCC_AHB_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_AHB_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1

#define HWIO_GCC_XO_CBCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00033008)
#define HWIO_GCC_XO_CBCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033008)
#define HWIO_GCC_XO_CBCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033008)
#define HWIO_GCC_XO_CBCR_RMSK                                                                          0x81c00005
#define HWIO_GCC_XO_CBCR_ATTR                                                                                 0x3
#define HWIO_GCC_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_XO_CBCR_ADDR, HWIO_GCC_XO_CBCR_RMSK)
#define HWIO_GCC_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_CBCR_ADDR, m)
#define HWIO_GCC_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_XO_CBCR_ADDR,v)
#define HWIO_GCC_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_CBCR_ADDR,m,v,HWIO_GCC_XO_CBCR_IN)
#define HWIO_GCC_XO_CBCR_CLK_OFF_BMSK                                                                  0x80000000
#define HWIO_GCC_XO_CBCR_CLK_OFF_SHFT                                                                        0x1f
#define HWIO_GCC_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                           0x1000000
#define HWIO_GCC_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                                0x18
#define HWIO_GCC_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                         0x800000
#define HWIO_GCC_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                             0x17
#define HWIO_GCC_XO_CBCR_CLK_DIS_BMSK                                                                    0x400000
#define HWIO_GCC_XO_CBCR_CLK_DIS_SHFT                                                                        0x16
#define HWIO_GCC_XO_CBCR_CLK_ARES_BMSK                                                                        0x4
#define HWIO_GCC_XO_CBCR_CLK_ARES_SHFT                                                                        0x2
#define HWIO_GCC_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                               0x0
#define HWIO_GCC_XO_CBCR_CLK_ARES_RESET_FVAL                                                                  0x1
#define HWIO_GCC_XO_CBCR_CLK_ENABLE_BMSK                                                                      0x1
#define HWIO_GCC_XO_CBCR_CLK_ENABLE_SHFT                                                                      0x0
#define HWIO_GCC_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_XO_DIV4_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003300c)
#define HWIO_GCC_XO_DIV4_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003300c)
#define HWIO_GCC_XO_DIV4_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003300c)
#define HWIO_GCC_XO_DIV4_CBCR_RMSK                                                                     0x81c00005
#define HWIO_GCC_XO_DIV4_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_XO_DIV4_CBCR_IN          \
        in_dword_masked(HWIO_GCC_XO_DIV4_CBCR_ADDR, HWIO_GCC_XO_DIV4_CBCR_RMSK)
#define HWIO_GCC_XO_DIV4_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_DIV4_CBCR_ADDR, m)
#define HWIO_GCC_XO_DIV4_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_XO_DIV4_CBCR_ADDR,v)
#define HWIO_GCC_XO_DIV4_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_DIV4_CBCR_ADDR,m,v,HWIO_GCC_XO_DIV4_CBCR_IN)
#define HWIO_GCC_XO_DIV4_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_XO_DIV4_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_XO_DIV4_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_XO_DIV4_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_XO_DIV4_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_XO_DIV4_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_XO_DIV4_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_XO_DIV4_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_XO_DIV4_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_XO_DIV16_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00033010)
#define HWIO_GCC_XO_DIV16_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033010)
#define HWIO_GCC_XO_DIV16_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033010)
#define HWIO_GCC_XO_DIV16_CBCR_RMSK                                                                    0x81c00005
#define HWIO_GCC_XO_DIV16_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_XO_DIV16_CBCR_IN          \
        in_dword_masked(HWIO_GCC_XO_DIV16_CBCR_ADDR, HWIO_GCC_XO_DIV16_CBCR_RMSK)
#define HWIO_GCC_XO_DIV16_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_DIV16_CBCR_ADDR, m)
#define HWIO_GCC_XO_DIV16_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_XO_DIV16_CBCR_ADDR,v)
#define HWIO_GCC_XO_DIV16_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_DIV16_CBCR_ADDR,m,v,HWIO_GCC_XO_DIV16_CBCR_IN)
#define HWIO_GCC_XO_DIV16_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_XO_DIV16_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_XO_DIV16_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_XO_DIV16_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_XO_DIV16_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_XO_DIV16_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_XO_DIV16_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_XO_DIV16_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_XO_DIV16_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_SLEEP_CBCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00033014)
#define HWIO_GCC_SLEEP_CBCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033014)
#define HWIO_GCC_SLEEP_CBCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033014)
#define HWIO_GCC_SLEEP_CBCR_RMSK                                                                       0x81c00005
#define HWIO_GCC_SLEEP_CBCR_ATTR                                                                              0x3
#define HWIO_GCC_SLEEP_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SLEEP_CBCR_ADDR, HWIO_GCC_SLEEP_CBCR_RMSK)
#define HWIO_GCC_SLEEP_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SLEEP_CBCR_ADDR, m)
#define HWIO_GCC_SLEEP_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SLEEP_CBCR_ADDR,v)
#define HWIO_GCC_SLEEP_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SLEEP_CBCR_ADDR,m,v,HWIO_GCC_SLEEP_CBCR_IN)
#define HWIO_GCC_SLEEP_CBCR_CLK_OFF_BMSK                                                               0x80000000
#define HWIO_GCC_SLEEP_CBCR_CLK_OFF_SHFT                                                                     0x1f
#define HWIO_GCC_SLEEP_CBCR_IGNORE_ALL_ARES_BMSK                                                        0x1000000
#define HWIO_GCC_SLEEP_CBCR_IGNORE_ALL_ARES_SHFT                                                             0x18
#define HWIO_GCC_SLEEP_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                      0x800000
#define HWIO_GCC_SLEEP_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                          0x17
#define HWIO_GCC_SLEEP_CBCR_CLK_DIS_BMSK                                                                 0x400000
#define HWIO_GCC_SLEEP_CBCR_CLK_DIS_SHFT                                                                     0x16
#define HWIO_GCC_SLEEP_CBCR_CLK_ARES_BMSK                                                                     0x4
#define HWIO_GCC_SLEEP_CBCR_CLK_ARES_SHFT                                                                     0x2
#define HWIO_GCC_SLEEP_CBCR_CLK_ARES_NO_RESET_FVAL                                                            0x0
#define HWIO_GCC_SLEEP_CBCR_CLK_ARES_RESET_FVAL                                                               0x1
#define HWIO_GCC_SLEEP_CBCR_CLK_ENABLE_BMSK                                                                   0x1
#define HWIO_GCC_SLEEP_CBCR_CLK_ENABLE_SHFT                                                                   0x0
#define HWIO_GCC_SLEEP_CBCR_CLK_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_SLEEP_CBCR_CLK_ENABLE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_XO_DIV16_CDIVR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00033018)
#define HWIO_GCC_XO_DIV16_CDIVR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033018)
#define HWIO_GCC_XO_DIV16_CDIVR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033018)
#define HWIO_GCC_XO_DIV16_CDIVR_RMSK                                                                          0xf
#define HWIO_GCC_XO_DIV16_CDIVR_ATTR                                                                          0x3
#define HWIO_GCC_XO_DIV16_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_XO_DIV16_CDIVR_ADDR, HWIO_GCC_XO_DIV16_CDIVR_RMSK)
#define HWIO_GCC_XO_DIV16_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_DIV16_CDIVR_ADDR, m)
#define HWIO_GCC_XO_DIV16_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_XO_DIV16_CDIVR_ADDR,v)
#define HWIO_GCC_XO_DIV16_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_DIV16_CDIVR_ADDR,m,v,HWIO_GCC_XO_DIV16_CDIVR_IN)
#define HWIO_GCC_XO_DIV16_CDIVR_CLK_DIV_BMSK                                                                  0xf
#define HWIO_GCC_XO_DIV16_CDIVR_CLK_DIV_SHFT                                                                  0x0

#define HWIO_GCC_XO_DIV4_CDIVR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003301c)
#define HWIO_GCC_XO_DIV4_CDIVR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003301c)
#define HWIO_GCC_XO_DIV4_CDIVR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003301c)
#define HWIO_GCC_XO_DIV4_CDIVR_RMSK                                                                           0xf
#define HWIO_GCC_XO_DIV4_CDIVR_ATTR                                                                           0x3
#define HWIO_GCC_XO_DIV4_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_XO_DIV4_CDIVR_ADDR, HWIO_GCC_XO_DIV4_CDIVR_RMSK)
#define HWIO_GCC_XO_DIV4_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_DIV4_CDIVR_ADDR, m)
#define HWIO_GCC_XO_DIV4_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_XO_DIV4_CDIVR_ADDR,v)
#define HWIO_GCC_XO_DIV4_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_DIV4_CDIVR_ADDR,m,v,HWIO_GCC_XO_DIV4_CDIVR_IN)
#define HWIO_GCC_XO_DIV4_CDIVR_CLK_DIV_BMSK                                                                   0xf
#define HWIO_GCC_XO_DIV4_CDIVR_CLK_DIV_SHFT                                                                   0x0

#define HWIO_GCC_SLEEP_CMD_RCGR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00033020)
#define HWIO_GCC_SLEEP_CMD_RCGR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033020)
#define HWIO_GCC_SLEEP_CMD_RCGR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033020)
#define HWIO_GCC_SLEEP_CMD_RCGR_RMSK                                                                   0x80000013
#define HWIO_GCC_SLEEP_CMD_RCGR_ATTR                                                                          0x3
#define HWIO_GCC_SLEEP_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SLEEP_CMD_RCGR_ADDR, HWIO_GCC_SLEEP_CMD_RCGR_RMSK)
#define HWIO_GCC_SLEEP_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SLEEP_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SLEEP_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SLEEP_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SLEEP_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SLEEP_CMD_RCGR_ADDR,m,v,HWIO_GCC_SLEEP_CMD_RCGR_IN)
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SLEEP_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                          0x10
#define HWIO_GCC_SLEEP_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                           0x4
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_EN_BMSK                                                                  0x2
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_EN_SHFT                                                                  0x1
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_SLEEP_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_SLEEP_CMD_RCGR_UPDATE_BMSK                                                                   0x1
#define HWIO_GCC_SLEEP_CMD_RCGR_UPDATE_SHFT                                                                   0x0
#define HWIO_GCC_SLEEP_CMD_RCGR_UPDATE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_SLEEP_CMD_RCGR_UPDATE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_SLEEP_CFG_RCGR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00033024)
#define HWIO_GCC_SLEEP_CFG_RCGR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033024)
#define HWIO_GCC_SLEEP_CFG_RCGR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033024)
#define HWIO_GCC_SLEEP_CFG_RCGR_RMSK                                                                     0x11071f
#define HWIO_GCC_SLEEP_CFG_RCGR_ATTR                                                                          0x3
#define HWIO_GCC_SLEEP_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SLEEP_CFG_RCGR_ADDR, HWIO_GCC_SLEEP_CFG_RCGR_RMSK)
#define HWIO_GCC_SLEEP_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SLEEP_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SLEEP_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SLEEP_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SLEEP_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SLEEP_CFG_RCGR_ADDR,m,v,HWIO_GCC_SLEEP_CFG_RCGR_IN)
#define HWIO_GCC_SLEEP_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                      0x100000
#define HWIO_GCC_SLEEP_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                          0x14
#define HWIO_GCC_SLEEP_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_SLEEP_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_SLEEP_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                      0x10000
#define HWIO_GCC_SLEEP_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                         0x10
#define HWIO_GCC_SLEEP_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                          0x0
#define HWIO_GCC_SLEEP_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                         0x1
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_BMSK                                                                0x700
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SHFT                                                                  0x8
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                             0x0
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                             0x1
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                             0x2
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                             0x3
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                             0x4
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                             0x5
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                             0x6
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                             0x7
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_BMSK                                                                 0x1f
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_SHFT                                                                  0x0
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                           0x0
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                             0x1
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                           0x2
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                             0x3
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                           0x4
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                             0x5
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                           0x6
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                             0x7
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                           0x8
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                             0x9
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                           0xa
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                             0xb
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                           0xc
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                             0xd
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                           0xe
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                             0xf
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                          0x10
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                            0x11
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                          0x12
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                           0x13
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                         0x14
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                           0x15
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                         0x16
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                           0x17
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                         0x18
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                           0x19
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                         0x1a
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                           0x1b
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                         0x1c
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                           0x1d
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                         0x1e
#define HWIO_GCC_SLEEP_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                           0x1f

#define HWIO_GCC_XO_CMD_RCGR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00033038)
#define HWIO_GCC_XO_CMD_RCGR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00033038)
#define HWIO_GCC_XO_CMD_RCGR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00033038)
#define HWIO_GCC_XO_CMD_RCGR_RMSK                                                                      0x80000013
#define HWIO_GCC_XO_CMD_RCGR_ATTR                                                                             0x3
#define HWIO_GCC_XO_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_XO_CMD_RCGR_ADDR, HWIO_GCC_XO_CMD_RCGR_RMSK)
#define HWIO_GCC_XO_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_CMD_RCGR_ADDR, m)
#define HWIO_GCC_XO_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_XO_CMD_RCGR_ADDR,v)
#define HWIO_GCC_XO_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_CMD_RCGR_ADDR,m,v,HWIO_GCC_XO_CMD_RCGR_IN)
#define HWIO_GCC_XO_CMD_RCGR_ROOT_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_XO_CMD_RCGR_ROOT_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_XO_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                             0x10
#define HWIO_GCC_XO_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                              0x4
#define HWIO_GCC_XO_CMD_RCGR_ROOT_EN_BMSK                                                                     0x2
#define HWIO_GCC_XO_CMD_RCGR_ROOT_EN_SHFT                                                                     0x1
#define HWIO_GCC_XO_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_XO_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_XO_CMD_RCGR_UPDATE_BMSK                                                                      0x1
#define HWIO_GCC_XO_CMD_RCGR_UPDATE_SHFT                                                                      0x0
#define HWIO_GCC_XO_CMD_RCGR_UPDATE_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_XO_CMD_RCGR_UPDATE_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_XO_CFG_RCGR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0003303c)
#define HWIO_GCC_XO_CFG_RCGR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003303c)
#define HWIO_GCC_XO_CFG_RCGR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003303c)
#define HWIO_GCC_XO_CFG_RCGR_RMSK                                                                        0x11071f
#define HWIO_GCC_XO_CFG_RCGR_ATTR                                                                             0x3
#define HWIO_GCC_XO_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_XO_CFG_RCGR_ADDR, HWIO_GCC_XO_CFG_RCGR_RMSK)
#define HWIO_GCC_XO_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_XO_CFG_RCGR_ADDR, m)
#define HWIO_GCC_XO_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_XO_CFG_RCGR_ADDR,v)
#define HWIO_GCC_XO_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_XO_CFG_RCGR_ADDR,m,v,HWIO_GCC_XO_CFG_RCGR_IN)
#define HWIO_GCC_XO_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                         0x100000
#define HWIO_GCC_XO_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                             0x14
#define HWIO_GCC_XO_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_XO_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_XO_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                         0x10000
#define HWIO_GCC_XO_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                            0x10
#define HWIO_GCC_XO_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                             0x0
#define HWIO_GCC_XO_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                            0x1
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_BMSK                                                                   0x700
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SHFT                                                                     0x8
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                                0x0
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                                0x1
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                                0x2
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                                0x3
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                                0x4
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                                0x5
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                                0x6
#define HWIO_GCC_XO_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                                0x7
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_BMSK                                                                    0x1f
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_SHFT                                                                     0x0
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                              0x0
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                                0x1
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                              0x2
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                                0x3
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                              0x4
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                                0x5
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                              0x6
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                                0x7
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                              0x8
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                                0x9
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                              0xa
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                                0xb
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                              0xc
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                                0xd
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                              0xe
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                                0xf
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                             0x10
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                               0x11
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                             0x12
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                              0x13
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                            0x14
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                              0x15
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                            0x16
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                              0x17
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                            0x18
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                              0x19
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                            0x1a
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                              0x1b
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                            0x1c
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                              0x1d
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                            0x1e
#define HWIO_GCC_XO_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                              0x1f

#define HWIO_GCC_DDRSS_BCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034000)
#define HWIO_GCC_DDRSS_BCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034000)
#define HWIO_GCC_DDRSS_BCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034000)
#define HWIO_GCC_DDRSS_BCR_RMSK                                                                               0x1
#define HWIO_GCC_DDRSS_BCR_ATTR                                                                               0x3
#define HWIO_GCC_DDRSS_BCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_BCR_ADDR, HWIO_GCC_DDRSS_BCR_RMSK)
#define HWIO_GCC_DDRSS_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_BCR_ADDR, m)
#define HWIO_GCC_DDRSS_BCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_BCR_ADDR,v)
#define HWIO_GCC_DDRSS_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_BCR_ADDR,m,v,HWIO_GCC_DDRSS_BCR_IN)
#define HWIO_GCC_DDRSS_BCR_BLK_ARES_BMSK                                                                      0x1
#define HWIO_GCC_DDRSS_BCR_BLK_ARES_SHFT                                                                      0x0
#define HWIO_GCC_DDRSS_BCR_BLK_ARES_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_DDRSS_BCR_BLK_ARES_ENABLE_FVAL                                                               0x1

#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c048)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c048)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c048)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_RMSK                                                              0x81f0000f
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ADDR, HWIO_GCC_DDRSS_MMNOC_SF_CBCR_RMSK)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_MMNOC_SF_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IN)
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                             0x200000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                 0x15
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_DDRSS_MMNOC_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c04c)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c04c)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c04c)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_RMSK                                                           0x81f0000f
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ADDR, HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_RMSK)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IN)
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                          0x200000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                              0x15
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_DDRSS_MMNOC_HF_QX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_DDRSS_TCU_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x000733cc)
#define HWIO_GCC_DDRSS_TCU_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000733cc)
#define HWIO_GCC_DDRSS_TCU_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000733cc)
#define HWIO_GCC_DDRSS_TCU_CBCR_RMSK                                                                   0x81f0000f
#define HWIO_GCC_DDRSS_TCU_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_DDRSS_TCU_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_TCU_CBCR_ADDR, HWIO_GCC_DDRSS_TCU_CBCR_RMSK)
#define HWIO_GCC_DDRSS_TCU_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_TCU_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_TCU_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_TCU_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_TCU_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_TCU_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_TCU_CBCR_IN)
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                  0x200000
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                      0x15
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_DDRSS_TCU_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_DDRSS_TCU_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_DDRSS_TCU_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_DDRSS_TCU_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_DDRSS_TCU_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_DDRSS_TCU_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_DDRSS_TCU_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_DDRSS_TCU_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00034004)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034004)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034004)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_RMSK                                                         0x81f0000f
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ATTR                                                                0x3
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ADDR, HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_RMSK)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IN)
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                        0x200000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                            0x15
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_DDRSS_TURING_Q6_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a288)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a288)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a288)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_RMSK                                                            0x81f0000f
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ADDR, HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_RMSK)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IN)
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                           0x200000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                               0x15
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_DDRSS_MSS_Q6_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_DDRSS_MODEM_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a28c)
#define HWIO_GCC_DDRSS_MODEM_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a28c)
#define HWIO_GCC_DDRSS_MODEM_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a28c)
#define HWIO_GCC_DDRSS_MODEM_CBCR_RMSK                                                                 0x81f0000f
#define HWIO_GCC_DDRSS_MODEM_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_DDRSS_MODEM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MODEM_CBCR_ADDR, HWIO_GCC_DDRSS_MODEM_CBCR_RMSK)
#define HWIO_GCC_DDRSS_MODEM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MODEM_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_MODEM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_MODEM_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_MODEM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_MODEM_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_MODEM_CBCR_IN)
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                                0x200000
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                    0x15
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_DDRSS_MODEM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_DDRSS_MODEM_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_DDRSS_MODEM_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_DDRSS_MODEM_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_DDRSS_MODEM_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_DDRSS_MODEM_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_DDRSS_MODEM_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_DDRSS_MODEM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00061154)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061154)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061154)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_RMSK                                                               0x81f0000f
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_GPU_AXI_CBCR_ADDR, HWIO_GCC_DDRSS_GPU_AXI_CBCR_RMSK)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_GPU_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_GPU_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_GPU_AXI_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_GPU_AXI_CBCR_IN)
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                              0x200000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                  0x15
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_GPU_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0000004c)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000004c)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000004c)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_RMSK                                                           0x81f0000e
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ADDR, HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_RMSK)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IN)
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                          0x200000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                              0x15
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_PCIE_SF_QTB_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00034008)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034008)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034008)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_RMSK                                                           0x81f0000f
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ADDR, HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_RMSK)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IN)
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                          0x200000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                              0x15
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_DDRSS_SNOC_GC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003400c)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003400c)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003400c)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_RMSK                                                           0x81f0000f
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ADDR, HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_RMSK)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IN)
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                          0x200000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                              0x15
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_DDRSS_SNOC_SF_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00034010)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034010)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034010)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ATTR                                                                0x3
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ADDR, HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_RMSK)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IN)
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_DDRSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00034014)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034014)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034014)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_CFG_AHB_CBCR_ADDR, HWIO_GCC_DDRSS_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_CFG_AHB_CBCR_IN)
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_MEMNOC_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034018)
#define HWIO_GCC_MEMNOC_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034018)
#define HWIO_GCC_MEMNOC_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034018)
#define HWIO_GCC_MEMNOC_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_MEMNOC_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_MEMNOC_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_CBCR_ADDR, HWIO_GCC_MEMNOC_CBCR_RMSK)
#define HWIO_GCC_MEMNOC_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_CBCR_ADDR, m)
#define HWIO_GCC_MEMNOC_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_CBCR_ADDR,v)
#define HWIO_GCC_MEMNOC_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_CBCR_ADDR,m,v,HWIO_GCC_MEMNOC_CBCR_IN)
#define HWIO_GCC_MEMNOC_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_MEMNOC_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_MEMNOC_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_MEMNOC_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_MEMNOC_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_MEMNOC_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_MEMNOC_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_MEMNOC_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_MEMNOC_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_MEMNOC_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_MEMNOC_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_MEMNOC_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_MEMNOC_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_MEMNOC_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MEMNOC_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MEMNOC_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_MEMNOC_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_MEMNOC_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MEMNOC_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0003514c)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003514c)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003514c)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_RMSK                                                            0x81f0000f
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ADDR, HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_RMSK)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IN)
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                           0x200000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                               0x15
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_DDRSS_LPASS_SHUB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_DDRSS_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003401c)
#define HWIO_GCC_DDRSS_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003401c)
#define HWIO_GCC_DDRSS_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003401c)
#define HWIO_GCC_DDRSS_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_DDRSS_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_DDRSS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_AT_CBCR_ADDR, HWIO_GCC_DDRSS_AT_CBCR_RMSK)
#define HWIO_GCC_DDRSS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_AT_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_AT_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_AT_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_AT_CBCR_IN)
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_DDRSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_DDRSS_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_DDRSS_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_DDRSS_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_DDRSS_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_DDRSS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_DDRSS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_DDRSS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_SHRM_CBCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034020)
#define HWIO_GCC_SHRM_CBCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034020)
#define HWIO_GCC_SHRM_CBCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034020)
#define HWIO_GCC_SHRM_CBCR_RMSK                                                                        0x81d0000f
#define HWIO_GCC_SHRM_CBCR_ATTR                                                                               0x3
#define HWIO_GCC_SHRM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SHRM_CBCR_ADDR, HWIO_GCC_SHRM_CBCR_RMSK)
#define HWIO_GCC_SHRM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SHRM_CBCR_ADDR, m)
#define HWIO_GCC_SHRM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SHRM_CBCR_ADDR,v)
#define HWIO_GCC_SHRM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SHRM_CBCR_ADDR,m,v,HWIO_GCC_SHRM_CBCR_IN)
#define HWIO_GCC_SHRM_CBCR_CLK_OFF_BMSK                                                                0x80000000
#define HWIO_GCC_SHRM_CBCR_CLK_OFF_SHFT                                                                      0x1f
#define HWIO_GCC_SHRM_CBCR_IGNORE_ALL_ARES_BMSK                                                         0x1000000
#define HWIO_GCC_SHRM_CBCR_IGNORE_ALL_ARES_SHFT                                                              0x18
#define HWIO_GCC_SHRM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                       0x800000
#define HWIO_GCC_SHRM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                           0x17
#define HWIO_GCC_SHRM_CBCR_CLK_DIS_BMSK                                                                  0x400000
#define HWIO_GCC_SHRM_CBCR_CLK_DIS_SHFT                                                                      0x16
#define HWIO_GCC_SHRM_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                      0x100000
#define HWIO_GCC_SHRM_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                          0x14
#define HWIO_GCC_SHRM_CBCR_SW_ONLY_EN_BMSK                                                                    0x8
#define HWIO_GCC_SHRM_CBCR_SW_ONLY_EN_SHFT                                                                    0x3
#define HWIO_GCC_SHRM_CBCR_CLK_ARES_BMSK                                                                      0x4
#define HWIO_GCC_SHRM_CBCR_CLK_ARES_SHFT                                                                      0x2
#define HWIO_GCC_SHRM_CBCR_CLK_ARES_NO_RESET_FVAL                                                             0x0
#define HWIO_GCC_SHRM_CBCR_CLK_ARES_RESET_FVAL                                                                0x1
#define HWIO_GCC_SHRM_CBCR_HW_CTL_BMSK                                                                        0x2
#define HWIO_GCC_SHRM_CBCR_HW_CTL_SHFT                                                                        0x1
#define HWIO_GCC_SHRM_CBCR_HW_CTL_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_SHRM_CBCR_HW_CTL_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_SHRM_CBCR_CLK_ENABLE_BMSK                                                                    0x1
#define HWIO_GCC_SHRM_CBCR_CLK_ENABLE_SHFT                                                                    0x0
#define HWIO_GCC_SHRM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_SHRM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_DDRSS_PWRCTL_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00034024)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034024)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034024)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_PWRCTL_CBCR_ADDR, HWIO_GCC_DDRSS_PWRCTL_CBCR_RMSK)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_PWRCTL_CBCR_ADDR, m)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_PWRCTL_CBCR_ADDR,v)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_PWRCTL_CBCR_ADDR,m,v,HWIO_GCC_DDRSS_PWRCTL_CBCR_IN)
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_DDRSS_PWRCTL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034044)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034044)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034044)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034048)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034048)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034048)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0003404c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003404c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003404c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034050)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034050)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034050)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034054)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034054)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034054)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034058)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034058)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034058)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0003405c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003405c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003405c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034060)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034060)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034060)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034064)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034064)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034064)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00034068)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034068)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034068)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003406c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003406c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003406c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00034070)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034070)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034070)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00034074)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034074)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034074)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00034078)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034078)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034078)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003407c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003407c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003407c)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00034080)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034080)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034080)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_RMSK                                                          0x71f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_RPMH_SHUB_MEMNOC_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_MEMNOC_CMD_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00034028)
#define HWIO_GCC_MEMNOC_CMD_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034028)
#define HWIO_GCC_MEMNOC_CMD_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034028)
#define HWIO_GCC_MEMNOC_CMD_RCGR_RMSK                                                                  0x80000013
#define HWIO_GCC_MEMNOC_CMD_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_MEMNOC_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_CMD_RCGR_ADDR, HWIO_GCC_MEMNOC_CMD_RCGR_RMSK)
#define HWIO_GCC_MEMNOC_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MEMNOC_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MEMNOC_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_CMD_RCGR_ADDR,m,v,HWIO_GCC_MEMNOC_CMD_RCGR_IN)
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MEMNOC_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                         0x10
#define HWIO_GCC_MEMNOC_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                          0x4
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_EN_BMSK                                                                 0x2
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_EN_SHFT                                                                 0x1
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MEMNOC_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MEMNOC_CMD_RCGR_UPDATE_BMSK                                                                  0x1
#define HWIO_GCC_MEMNOC_CMD_RCGR_UPDATE_SHFT                                                                  0x0
#define HWIO_GCC_MEMNOC_CMD_RCGR_UPDATE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MEMNOC_CMD_RCGR_UPDATE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_MEMNOC_CFG_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0003402c)
#define HWIO_GCC_MEMNOC_CFG_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003402c)
#define HWIO_GCC_MEMNOC_CFG_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003402c)
#define HWIO_GCC_MEMNOC_CFG_RCGR_RMSK                                                                    0x11071f
#define HWIO_GCC_MEMNOC_CFG_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_MEMNOC_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_CFG_RCGR_ADDR, HWIO_GCC_MEMNOC_CFG_RCGR_RMSK)
#define HWIO_GCC_MEMNOC_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MEMNOC_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MEMNOC_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_CFG_RCGR_ADDR,m,v,HWIO_GCC_MEMNOC_CFG_RCGR_IN)
#define HWIO_GCC_MEMNOC_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                     0x100000
#define HWIO_GCC_MEMNOC_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                         0x14
#define HWIO_GCC_MEMNOC_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_MEMNOC_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_MEMNOC_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                     0x10000
#define HWIO_GCC_MEMNOC_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                        0x10
#define HWIO_GCC_MEMNOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                         0x0
#define HWIO_GCC_MEMNOC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                        0x1
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_BMSK                                                               0x700
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SHFT                                                                 0x8
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                            0x0
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                            0x1
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                            0x2
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                            0x3
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                            0x4
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                            0x5
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                            0x6
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                            0x7
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_BMSK                                                                0x1f
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_SHFT                                                                 0x0
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                          0x0
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                            0x1
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                          0x2
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                            0x3
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                          0x4
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                            0x5
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                          0x6
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                            0x7
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                          0x8
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                            0x9
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                          0xa
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                            0xb
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                          0xc
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                            0xd
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                          0xe
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                            0xf
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                         0x10
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                           0x11
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                         0x12
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                          0x13
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                        0x14
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                          0x15
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                        0x16
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                          0x17
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                        0x18
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                          0x19
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                        0x1a
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                          0x1b
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                        0x1c
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                          0x1d
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                        0x1e
#define HWIO_GCC_MEMNOC_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                          0x1f

#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00034168)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034168)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034168)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_RMSK                                                                   0xffff
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_ATTR                                                                      0x3
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_CMD_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_RCG_SW_CTRL_BMSK                                                       0x8000
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_RCG_SW_CTRL_SHFT                                                          0xf
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_SW_PERF_STATE_BMSK                                                     0x7800
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_SW_PERF_STATE_SHFT                                                        0xb
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_SW_OVERRIDE_BMSK                                                        0x400
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_SW_OVERRIDE_SHFT                                                          0xa
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                           0x200
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                             0x9
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_FSM_STATE_BMSK                                                      0x1c0
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_FSM_STATE_SHFT                                                        0x6
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                      0x20
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                       0x5
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_CURR_PERF_STATE_BMSK                                                     0x1e
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_CURR_PERF_STATE_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_EN_BMSK                                                               0x1
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_EN_SHFT                                                               0x0
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RPMH_SHRM_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034170)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034170)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034170)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034174)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034174)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034174)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034178)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034178)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034178)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0003417c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003417c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003417c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034180)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034180)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034180)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034184)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034184)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034184)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034188)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034188)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034188)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0003418c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003418c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003418c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034190)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034190)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034190)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00034194)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034194)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034194)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_RMSK                                                             0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00034198)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034198)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034198)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0003419c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003419c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003419c)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000341a0)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000341a0)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000341a0)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000341a4)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000341a4)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000341a4)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000341a8)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000341a8)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000341a8)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x000341ac)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000341ac)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000341ac)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_SHRM_SHRM_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_SHRM_CMD_RCGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00034154)
#define HWIO_GCC_SHRM_CMD_RCGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034154)
#define HWIO_GCC_SHRM_CMD_RCGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034154)
#define HWIO_GCC_SHRM_CMD_RCGR_RMSK                                                                    0x80000013
#define HWIO_GCC_SHRM_CMD_RCGR_ATTR                                                                           0x3
#define HWIO_GCC_SHRM_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SHRM_CMD_RCGR_ADDR, HWIO_GCC_SHRM_CMD_RCGR_RMSK)
#define HWIO_GCC_SHRM_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SHRM_CMD_RCGR_ADDR, m)
#define HWIO_GCC_SHRM_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SHRM_CMD_RCGR_ADDR,v)
#define HWIO_GCC_SHRM_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SHRM_CMD_RCGR_ADDR,m,v,HWIO_GCC_SHRM_CMD_RCGR_IN)
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_SHRM_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                           0x10
#define HWIO_GCC_SHRM_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                            0x4
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_EN_BMSK                                                                   0x2
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_EN_SHFT                                                                   0x1
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_SHRM_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_SHRM_CMD_RCGR_UPDATE_BMSK                                                                    0x1
#define HWIO_GCC_SHRM_CMD_RCGR_UPDATE_SHFT                                                                    0x0
#define HWIO_GCC_SHRM_CMD_RCGR_UPDATE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_SHRM_CMD_RCGR_UPDATE_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_SHRM_CFG_RCGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00034158)
#define HWIO_GCC_SHRM_CFG_RCGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034158)
#define HWIO_GCC_SHRM_CFG_RCGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034158)
#define HWIO_GCC_SHRM_CFG_RCGR_RMSK                                                                      0x11071f
#define HWIO_GCC_SHRM_CFG_RCGR_ATTR                                                                           0x3
#define HWIO_GCC_SHRM_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_SHRM_CFG_RCGR_ADDR, HWIO_GCC_SHRM_CFG_RCGR_RMSK)
#define HWIO_GCC_SHRM_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_SHRM_CFG_RCGR_ADDR, m)
#define HWIO_GCC_SHRM_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_SHRM_CFG_RCGR_ADDR,v)
#define HWIO_GCC_SHRM_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SHRM_CFG_RCGR_ADDR,m,v,HWIO_GCC_SHRM_CFG_RCGR_IN)
#define HWIO_GCC_SHRM_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                       0x100000
#define HWIO_GCC_SHRM_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                           0x14
#define HWIO_GCC_SHRM_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SHRM_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_SHRM_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                       0x10000
#define HWIO_GCC_SHRM_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                          0x10
#define HWIO_GCC_SHRM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                           0x0
#define HWIO_GCC_SHRM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                          0x1
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_BMSK                                                                 0x700
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SHFT                                                                   0x8
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                              0x0
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                              0x1
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                              0x2
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                              0x3
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                              0x4
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                              0x5
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                              0x6
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                              0x7
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_BMSK                                                                  0x1f
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_SHFT                                                                   0x0
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                            0x0
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                              0x1
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                            0x2
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                              0x3
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                            0x4
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                              0x5
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                            0x6
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                              0x7
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                            0x8
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                              0x9
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                            0xa
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                              0xb
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                            0xc
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                              0xd
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                            0xe
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                              0xf
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                           0x10
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                             0x11
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                           0x12
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                            0x13
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                          0x14
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                            0x15
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                          0x16
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                            0x17
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                          0x18
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                            0x19
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                          0x1a
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                            0x1b
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                          0x1c
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                            0x1d
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                          0x1e
#define HWIO_GCC_SHRM_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                            0x1f

#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00034280)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034280)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034280)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_RMSK                                                                      0x1
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_ATTR                                                                      0x3
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_SHRM_DCD_CDIV_DCDR_ADDR, HWIO_GCC_SHRM_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_SHRM_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_SHRM_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SHRM_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_SHRM_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_SHRM_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00034284)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034284)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034284)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_RMSK                                                                    0x1
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ATTR                                                                    0x3
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MEMNOC_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00034288)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034288)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034288)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_RMSK                                                              0xf
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ATTR                                                              0x3
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ADDR, HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_RMSK)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_ADDR,m,v,HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_IN)
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_CLK_DIV_BMSK                                                      0xf
#define HWIO_GCC_DDRSS_GPLL0_MAIN_DIV_CDIVR_CLK_DIV_SHFT                                                      0x0

#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00037000)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037000)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037000)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ADDR, HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_RMSK)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_ADDR,m,v,HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IN)
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_LPASS_CFG_NOC_SWAY_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00037004)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037004)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037004)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_RMSK                                                          0x81d0000f
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ADDR, HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_SW_ONLY_EN_BMSK                                                      0x8
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_SW_ONLY_EN_SHFT                                                      0x3
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ARES_RESET_FVAL                                                  0x1
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_HW_CTL_BMSK                                                          0x2
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_HW_CTL_SHFT                                                          0x1
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_QMIP_LPASS_QTB_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_LPASS_TRIG_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00037008)
#define HWIO_GCC_LPASS_TRIG_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037008)
#define HWIO_GCC_LPASS_TRIG_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037008)
#define HWIO_GCC_LPASS_TRIG_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_LPASS_TRIG_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_LPASS_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_TRIG_CBCR_ADDR, HWIO_GCC_LPASS_TRIG_CBCR_RMSK)
#define HWIO_GCC_LPASS_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_TRIG_CBCR_ADDR,m,v,HWIO_GCC_LPASS_TRIG_CBCR_IN)
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_LPASS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_LPASS_TRIG_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_LPASS_TRIG_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_LPASS_TRIG_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_LPASS_TRIG_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_LPASS_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_LPASS_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_LPASS_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_LPASS_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003700c)
#define HWIO_GCC_LPASS_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003700c)
#define HWIO_GCC_LPASS_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003700c)
#define HWIO_GCC_LPASS_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_LPASS_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_LPASS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AT_CBCR_ADDR, HWIO_GCC_LPASS_AT_CBCR_RMSK)
#define HWIO_GCC_LPASS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AT_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AT_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AT_CBCR_ADDR,m,v,HWIO_GCC_LPASS_AT_CBCR_IN)
#define HWIO_GCC_LPASS_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_LPASS_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_LPASS_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_LPASS_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_LPASS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_LPASS_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_LPASS_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_LPASS_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_LPASS_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_LPASS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_LPASS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_LPASS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00037010)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037010)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037010)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_RMSK                                                    0x81f0000f
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ATTR                                                           0x3
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ADDR, HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_RMSK)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IN)
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_OFF_BMSK                                            0x80000000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_OFF_SHFT                                                  0x1f
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_BMSK                                     0x1000000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_SHFT                                          0x18
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                   0x800000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                       0x17
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_DIS_BMSK                                              0x400000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_DIS_SHFT                                                  0x16
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                   0x200000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                       0x15
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                  0x100000
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                      0x14
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_BMSK                                                0x8
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_SHFT                                                0x3
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ARES_BMSK                                                  0x4
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ARES_SHFT                                                  0x2
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ARES_NO_RESET_FVAL                                         0x0
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ARES_RESET_FVAL                                            0x1
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_HW_CTL_BMSK                                                    0x2
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_HW_CTL_SHFT                                                    0x1
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_HW_CTL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_HW_CTL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_BMSK                                                0x1
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_SHFT                                                0x0
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_LPASS_AON_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00037014)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037014)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037014)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_RMSK                                       0x81f0000f
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ATTR                                              0x3
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ADDR, HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_RMSK)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IN)
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_OFF_BMSK                               0x80000000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_OFF_SHFT                                     0x1f
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_BMSK                        0x1000000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_SHFT                             0x18
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                      0x800000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                          0x17
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_DIS_BMSK                                 0x400000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_DIS_SHFT                                     0x16
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                      0x200000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                          0x15
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                     0x100000
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                         0x14
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_SW_ONLY_EN_BMSK                                   0x8
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_SW_ONLY_EN_SHFT                                   0x3
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ARES_BMSK                                     0x4
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ARES_SHFT                                     0x2
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ARES_NO_RESET_FVAL                            0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ARES_RESET_FVAL                               0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_HW_CTL_BMSK                                       0x2
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_HW_CTL_SHFT                                       0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_HW_CTL_DISABLE_FVAL                               0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_HW_CTL_ENABLE_FVAL                                0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ENABLE_BMSK                                   0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ENABLE_SHFT                                   0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ENABLE_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CBCR_CLK_ENABLE_ENABLE_FVAL                            0x1

#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00037018)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037018)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037018)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_RMSK                                                  0x81f0700f
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ATTR                                                         0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ADDR, HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_RMSK)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IN)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_BMSK                                   0x1000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_SHFT                                        0x18
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                 0x800000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                     0x17
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_DIS_BMSK                                            0x400000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_DIS_SHFT                                                0x16
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                 0x200000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                     0x15
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                0x100000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                    0x14
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_CORE_ON_BMSK                                    0x4000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_CORE_ON_SHFT                                       0xe
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                         0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                          0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                  0x2000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                     0xd
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                 0x1000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                    0xc
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_BMSK                                              0x8
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_SHFT                                              0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ARES_BMSK                                                0x4
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ARES_SHFT                                                0x2
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ARES_NO_RESET_FVAL                                       0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ARES_RESET_FVAL                                          0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_HW_CTL_BMSK                                                  0x2
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_HW_CTL_SHFT                                                  0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_HW_CTL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_HW_CTL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0003701c)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003701c)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003701c)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_RMSK                                                  0xf1ffffe
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ATTR                                                        0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ADDR, HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_RMSK)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ADDR, m)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ADDR,v)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_ADDR,m,v,HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IN)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                        0xf000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                             0x18
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PWR_FSM_CLK_SEL_BMSK                                   0x100000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PWR_FSM_CLK_SEL_SHFT                                       0x14
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                           0xf0000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                              0x10
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                             0x8000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                0xf
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                      0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                         0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                              0x4000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                 0xe
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                 0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL              0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                             0x2000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                0xd
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                    0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                       0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                         0x1000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                            0xc
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                   0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                      0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CORE_ON_ACK_BMSK                                      0x800
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CORE_ON_ACK_SHFT                                        0xb
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_PERIPH_ON_ACK_BMSK                                    0x400
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_PERIPH_ON_ACK_SHFT                                      0xa
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                             0x300
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                               0x8
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                      0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                      0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                      0x2
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                      0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_ENABLE_BMSK                                        0x80
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_ENABLE_SHFT                                         0x7
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_FORCE_CLK_ON_BMSK                                          0x40
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_FORCE_CLK_ON_SHFT                                           0x6
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                  0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                              0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SEL_SLP_STG_BMSK                                    0x20
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SEL_SLP_STG_SHFT                                     0x5
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL            0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SLP_STG_BMSK                                        0x10
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SLP_STG_SHFT                                         0x4
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL               0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                  0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CTRL_PWR_DOWN_BMSK                                       0x8
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CTRL_PWR_DOWN_SHFT                                       0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                            0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                               0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                  0x4
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                  0x2
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SLP_STG_BMSK                                      0x2
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SLP_STG_SHFT                                      0x1
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                0x0
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                 0x1

#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00037020)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037020)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037020)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_RMSK                                             0xffffffff
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ATTR                                                    0x3
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ADDR, HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_RMSK)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ADDR, m)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ADDR,v)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_ADDR,m,v,HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_IN)
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                          0xfc000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                0x1a
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                     0x2000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                          0x19
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                       0x1000000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                            0x18
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                          0x800000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                              0x17
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                            0x400000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                0x16
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CPH_TIMER_BMSK                                 0x3f0000
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_MEM_CPH_TIMER_SHFT                                     0x10
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_SLEEP_TIMER_BMSK                                     0xff00
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_SLEEP_TIMER_SHFT                                        0x8
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_WAKEUP_TIMER_BMSK                                      0xff
#define HWIO_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CFG_SREGR_WAKEUP_TIMER_SHFT                                       0x0

#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00037024)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037024)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037024)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_RMSK                                                  0x81f0000f
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ATTR                                                         0x3
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ADDR, HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_RMSK)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IN)
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_BMSK                                   0x1000000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_ARES_SHFT                                        0x18
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                 0x800000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                     0x17
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_DIS_BMSK                                            0x400000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_DIS_SHFT                                                0x16
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                 0x200000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                     0x15
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                0x100000
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                    0x14
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_BMSK                                              0x8
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_SW_ONLY_EN_SHFT                                              0x3
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ARES_BMSK                                                0x4
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ARES_SHFT                                                0x2
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ARES_NO_RESET_FVAL                                       0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ARES_RESET_FVAL                                          0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_HW_CTL_BMSK                                                  0x2
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_HW_CTL_SHFT                                                  0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_HW_CTL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_HW_CTL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CBCR_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00037028)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037028)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037028)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_RMSK                                                                     0x1
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_ATTR                                                                     0x3
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DCD_CDIV_DCDR_ADDR, HWIO_GCC_LPASS_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_LPASS_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_LPASS_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037048)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037048)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037048)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0003704c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003704c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003704c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037050)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037050)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037050)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037054)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037054)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037054)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037058)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037058)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037058)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0003705c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003705c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003705c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037060)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037060)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037060)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037064)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037064)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037064)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00037068)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037068)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037068)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0003706c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003706c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003706c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00037070)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037070)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037070)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00037074)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037074)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037074)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00037078)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037078)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037078)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003707c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003707c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003707c)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00037080)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037080)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037080)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00037084)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037084)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037084)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_LPASS_DDRSS_SHUB_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0003702c)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003702c)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003702c)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_RMSK                                                        0x80000013
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ATTR                                                               0x3
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ADDR, HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_RMSK)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ADDR, m)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ADDR,v)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ADDR,m,v,HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_IN)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_OFF_BMSK                                               0x80000000
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_OFF_SHFT                                                     0x1f
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                               0x10
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                0x4
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_EN_BMSK                                                       0x2
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_EN_SHFT                                                       0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                               0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_UPDATE_BMSK                                                        0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_UPDATE_SHFT                                                        0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_UPDATE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CMD_RCGR_UPDATE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00037030)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037030)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037030)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RMSK                                                          0x11071f
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ATTR                                                               0x3
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ADDR, HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RMSK)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ADDR, m)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ADDR,v)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_ADDR,m,v,HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_IN)
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_HW_CLK_CONTROL_BMSK                                           0x100000
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_HW_CLK_CONTROL_SHFT                                               0x14
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                        0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                         0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RCGLITE_DISABLE_BMSK                                           0x10000
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RCGLITE_DISABLE_SHFT                                              0x10
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                               0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                              0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_LPASS_DDRSS_SHUB_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_LPASS_QTB_GDSCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00089000)
#define HWIO_GCC_LPASS_QTB_GDSCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089000)
#define HWIO_GCC_LPASS_QTB_GDSCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089000)
#define HWIO_GCC_LPASS_QTB_GDSCR_RMSK                                                                  0xf8ffffff
#define HWIO_GCC_LPASS_QTB_GDSCR_ATTR                                                                         0x3
#define HWIO_GCC_LPASS_QTB_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDSCR_ADDR, HWIO_GCC_LPASS_QTB_GDSCR_RMSK)
#define HWIO_GCC_LPASS_QTB_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDSCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDSCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDSCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDSCR_IN)
#define HWIO_GCC_LPASS_QTB_GDSCR_PWR_ON_BMSK                                                           0x80000000
#define HWIO_GCC_LPASS_QTB_GDSCR_PWR_ON_SHFT                                                                 0x1f
#define HWIO_GCC_LPASS_QTB_GDSCR_GDSC_STATE_BMSK                                                       0x78000000
#define HWIO_GCC_LPASS_QTB_GDSCR_GDSC_STATE_SHFT                                                             0x1b
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_WAIT_BMSK                                                       0xf00000
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_WAIT_SHFT                                                           0x14
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_WAIT_BMSK                                                         0xf0000
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_WAIT_SHFT                                                            0x10
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DIS_WAIT_BMSK                                                         0xf000
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DIS_WAIT_SHFT                                                            0xc
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x800
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_FF_ENABLE_SHFT                                                        0xb
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_RESTORE_BMSK                                                               0x400
#define HWIO_GCC_LPASS_QTB_GDSCR_RESTORE_SHFT                                                                 0xa
#define HWIO_GCC_LPASS_QTB_GDSCR_RESTORE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_RESTORE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_SAVE_BMSK                                                                  0x200
#define HWIO_GCC_LPASS_QTB_GDSCR_SAVE_SHFT                                                                    0x9
#define HWIO_GCC_LPASS_QTB_GDSCR_SAVE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_SAVE_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_BMSK                                                                0x100
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_SHFT                                                                  0x8
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_RETAIN_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_BMSK                                                                0x80
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_SHFT                                                                 0x7
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_REST_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_BMSK                                                                 0x40
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_SHFT                                                                  0x6
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_EN_FEW_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_CLAMP_IO_BMSK                                                               0x20
#define HWIO_GCC_LPASS_QTB_GDSCR_CLAMP_IO_SHFT                                                                0x5
#define HWIO_GCC_LPASS_QTB_GDSCR_CLAMP_IO_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_CLAMP_IO_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DISABLE_BMSK                                                            0x10
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DISABLE_SHFT                                                             0x4
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                             0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                              0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_PD_ARES_BMSK                                                                 0x8
#define HWIO_GCC_LPASS_QTB_GDSCR_PD_ARES_SHFT                                                                 0x3
#define HWIO_GCC_LPASS_QTB_GDSCR_PD_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_PD_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_OVERRIDE_BMSK                                                             0x4
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_OVERRIDE_SHFT                                                             0x2
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_HW_CONTROL_BMSK                                                              0x2
#define HWIO_GCC_LPASS_QTB_GDSCR_HW_CONTROL_SHFT                                                              0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_HW_CONTROL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_HW_CONTROL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_COLLAPSE_BMSK                                                             0x1
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_COLLAPSE_SHFT                                                             0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_LPASS_QTB_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00089004)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089004)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089004)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_RMSK                                                               0x7ffffff
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_ATTR                                                                     0x3
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG_GDSCR_ADDR, HWIO_GCC_LPASS_QTB_CFG_GDSCR_RMSK)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_CFG_GDSCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_CFG_GDSCR_IN)
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4000000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x1a
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                            0x2000000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                 0x19
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                             0x1000000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                  0x18
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                      0xf00000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                          0x14
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                         0x80000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                            0x13
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                             0x40000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                0x12
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                             0x20000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                0x11
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                          0x10000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                             0x10
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                         0x8000
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                            0xf
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                        0x7800
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                           0xb
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                0x400
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                  0xa
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                         0x200
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                           0x9
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                         0x100
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                           0x8
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                             0x80
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                              0x7
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                    0x60
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                     0x5
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                              0x10
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                               0x4
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                        0x8
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                        0x3
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                      0x4
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                      0x2
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                          0x2
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                          0x1
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                       0x1
#define HWIO_GCC_LPASS_QTB_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                       0x0

#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00089008)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089008)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089008)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_RMSK                                                                0x7ffff
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ADDR, HWIO_GCC_LPASS_QTB_CFG2_GDSCR_RMSK)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_CFG2_GDSCR_IN)
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                    0x40000
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                       0x12
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                0x20000
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                   0x11
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                              0x10000
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                 0x10
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                  0xf000
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                     0xc
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                           0xf00
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                             0x8
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                              0xf0
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                               0x4
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                0xf
#define HWIO_GCC_LPASS_QTB_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                0x0

#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0008900c)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008900c)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008900c)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ADDR, HWIO_GCC_LPASS_QTB_CFG3_GDSCR_RMSK)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_CFG3_GDSCR_IN)
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                            0x4000000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                 0x1a
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                         0x2000000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                              0x19
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                    0x1e00000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                         0x15
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                     0x100000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                         0x14
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                  0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                   0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                            0x80000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                               0x13
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                0x40000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                   0x12
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                 0x20000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                    0x11
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                             0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                              0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                      0x10000
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                         0x10
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                              0xff00
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                 0x8
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                               0xff
#define HWIO_GCC_LPASS_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                0x0

#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00089010)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089010)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089010)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_RMSK                                                               0xffffff
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ADDR, HWIO_GCC_LPASS_QTB_CFG4_GDSCR_RMSK)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_CFG4_GDSCR_IN)
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                 0xf00000
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                     0x14
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                  0xf0000
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                     0x10
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                  0xf000
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                     0xc
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                 0xf00
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                   0x8
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                       0xf0
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                        0x4
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                       0xf
#define HWIO_GCC_LPASS_QTB_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                       0x0

#define HWIO_GCC_LPASS_QTB_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00089014)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089014)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089014)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_AHB_CBCR_ADDR, HWIO_GCC_LPASS_QTB_AHB_CBCR_RMSK)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_AHB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_AHB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_AHB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_AHB_CBCR_IN)
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_LPASS_QTB_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00089018)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089018)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089018)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_RMSK                                                             0x81f0700f
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ADDR, HWIO_GCC_LPASS_AUDIO_QTB_CBCR_RMSK)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AUDIO_QTB_CBCR_ADDR,m,v,HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IN)
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                            0x200000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                0x15
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_CORE_ON_BMSK                                               0x4000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_CORE_ON_SHFT                                                  0xe
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                             0x2000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                0xd
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                            0x1000
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                               0xc
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008901c)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008901c)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008901c)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_RMSK                                                             0xf1ffffe
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ADDR, HWIO_GCC_LPASS_AUDIO_QTB_SREGR_RMSK)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ADDR, m)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ADDR,v)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AUDIO_QTB_SREGR_ADDR,m,v,HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IN)
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                   0xf000000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                        0x18
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PWR_FSM_CLK_SEL_BMSK                                              0x100000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PWR_FSM_CLK_SEL_SHFT                                                  0x14
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                      0xf0000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                         0x10
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                        0x8000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                           0xf
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                 0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                    0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                         0x4000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                            0xe
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                            0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                         0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                        0x2000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                           0xd
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                               0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                  0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                    0x1000
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                       0xc
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                              0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                 0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CORE_ON_ACK_BMSK                                                 0x800
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CORE_ON_ACK_SHFT                                                   0xb
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_PERIPH_ON_ACK_BMSK                                               0x400
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                 0xa
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                        0x300
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                          0x8
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                 0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                 0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                 0x2
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                 0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_ENABLE_BMSK                                                   0x80
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_ENABLE_SHFT                                                    0x7
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_FORCE_CLK_ON_BMSK                                                     0x40
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_FORCE_CLK_ON_SHFT                                                      0x6
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                             0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SEL_SLP_STG_BMSK                                               0x20
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                0x5
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                       0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                  0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SLP_STG_BMSK                                                   0x10
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SLP_STG_SHFT                                                    0x4
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                          0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                             0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                  0x8
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                  0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                       0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                          0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                             0x4
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                             0x2
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL         0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                 0x2
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                 0x1
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_AUDIO_QTB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                            0x1

#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00089020)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089020)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089020)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_RMSK                                                        0xffffffff
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ATTR                                                               0x3
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ADDR, HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_RMSK)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ADDR, m)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ADDR,v)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_ADDR,m,v,HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_IN)
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                     0xfc000000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                           0x1a
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                0x2000000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                     0x19
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                  0x1000000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                       0x18
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                     0x800000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                         0x17
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                       0x400000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                           0x16
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CPH_TIMER_BMSK                                            0x3f0000
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                0x10
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_SLEEP_TIMER_BMSK                                                0xff00
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_SLEEP_TIMER_SHFT                                                   0x8
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_WAKEUP_TIMER_BMSK                                                 0xff
#define HWIO_GCC_LPASS_AUDIO_QTB_CFG_SREGR_WAKEUP_TIMER_SHFT                                                  0x0

#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00089024)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089024)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089024)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_RMSK                                                         0x81c00005
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ATTR                                                                0x3
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_LPASS_QOSGEN_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00089028)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089028)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089028)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_RMSK                                                            0x81c0000f
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ADDR, HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_RMSK)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IN)
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_LPASS_QDSS_TSCTR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_LPASS_QTB_AT_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008902c)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008902c)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008902c)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_LPASS_QTB_AT_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_AT_CBCR_ADDR, HWIO_GCC_LPASS_QTB_AT_CBCR_RMSK)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_AT_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_AT_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_AT_CBCR_ADDR,m,v,HWIO_GCC_LPASS_QTB_AT_CBCR_IN)
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_LPASS_QTB_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_LPASS_QTB_AT_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_LPASS_QTB_AT_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_LPASS_QTB_AT_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_LPASS_QTB_AT_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_LPASS_QTB_AT_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_LPASS_QTB_AT_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_LPASS_QTB_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_LPASS_XO_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00089030)
#define HWIO_GCC_LPASS_XO_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089030)
#define HWIO_GCC_LPASS_XO_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089030)
#define HWIO_GCC_LPASS_XO_CBCR_RMSK                                                                    0x81c00005
#define HWIO_GCC_LPASS_XO_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_LPASS_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_XO_CBCR_ADDR, HWIO_GCC_LPASS_XO_CBCR_RMSK)
#define HWIO_GCC_LPASS_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_XO_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_XO_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_XO_CBCR_ADDR,m,v,HWIO_GCC_LPASS_XO_CBCR_IN)
#define HWIO_GCC_LPASS_XO_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_LPASS_XO_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_LPASS_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_LPASS_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_LPASS_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_LPASS_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_LPASS_XO_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_LPASS_XO_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_LPASS_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_LPASS_PWRCTL_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00089034)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089034)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089034)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_LPASS_PWRCTL_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_PWRCTL_CBCR_ADDR, HWIO_GCC_LPASS_PWRCTL_CBCR_RMSK)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_PWRCTL_CBCR_ADDR, m)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_PWRCTL_CBCR_ADDR,v)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_PWRCTL_CBCR_ADDR,m,v,HWIO_GCC_LPASS_PWRCTL_CBCR_IN)
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_LPASS_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_LPASS_PWRCTL_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_LPASS_PWRCTL_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_LPASS_PWRCTL_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_LPASS_PWRCTL_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_LPASS_PWRCTL_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_LPASS_PWRCTL_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_LPASS_PWRCTL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_TURING_QTB_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d000)
#define HWIO_GCC_TURING_QTB_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d000)
#define HWIO_GCC_TURING_QTB_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d000)
#define HWIO_GCC_TURING_QTB_GDSCR_RMSK                                                                 0xf8ffffff
#define HWIO_GCC_TURING_QTB_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_TURING_QTB_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDSCR_ADDR, HWIO_GCC_TURING_QTB_GDSCR_RMSK)
#define HWIO_GCC_TURING_QTB_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDSCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDSCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDSCR_ADDR,m,v,HWIO_GCC_TURING_QTB_GDSCR_IN)
#define HWIO_GCC_TURING_QTB_GDSCR_PWR_ON_BMSK                                                          0x80000000
#define HWIO_GCC_TURING_QTB_GDSCR_PWR_ON_SHFT                                                                0x1f
#define HWIO_GCC_TURING_QTB_GDSCR_GDSC_STATE_BMSK                                                      0x78000000
#define HWIO_GCC_TURING_QTB_GDSCR_GDSC_STATE_SHFT                                                            0x1b
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_WAIT_BMSK                                                      0xf00000
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_WAIT_SHFT                                                          0x14
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_WAIT_BMSK                                                        0xf0000
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_WAIT_SHFT                                                           0x10
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DIS_WAIT_BMSK                                                        0xf000
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DIS_WAIT_SHFT                                                           0xc
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x800
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_FF_ENABLE_SHFT                                                       0xb
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TURING_QTB_GDSCR_RESTORE_BMSK                                                              0x400
#define HWIO_GCC_TURING_QTB_GDSCR_RESTORE_SHFT                                                                0xa
#define HWIO_GCC_TURING_QTB_GDSCR_RESTORE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_TURING_QTB_GDSCR_RESTORE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_TURING_QTB_GDSCR_SAVE_BMSK                                                                 0x200
#define HWIO_GCC_TURING_QTB_GDSCR_SAVE_SHFT                                                                   0x9
#define HWIO_GCC_TURING_QTB_GDSCR_SAVE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_TURING_QTB_GDSCR_SAVE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_BMSK                                                               0x100
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_SHFT                                                                 0x8
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_TURING_QTB_GDSCR_RETAIN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_BMSK                                                               0x80
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_SHFT                                                                0x7
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_TURING_QTB_GDSCR_EN_REST_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_BMSK                                                                0x40
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_SHFT                                                                 0x6
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_TURING_QTB_GDSCR_EN_FEW_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_TURING_QTB_GDSCR_CLAMP_IO_BMSK                                                              0x20
#define HWIO_GCC_TURING_QTB_GDSCR_CLAMP_IO_SHFT                                                               0x5
#define HWIO_GCC_TURING_QTB_GDSCR_CLAMP_IO_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_QTB_GDSCR_CLAMP_IO_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DISABLE_BMSK                                                           0x10
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DISABLE_SHFT                                                            0x4
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                            0x0
#define HWIO_GCC_TURING_QTB_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                             0x1
#define HWIO_GCC_TURING_QTB_GDSCR_PD_ARES_BMSK                                                                0x8
#define HWIO_GCC_TURING_QTB_GDSCR_PD_ARES_SHFT                                                                0x3
#define HWIO_GCC_TURING_QTB_GDSCR_PD_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_TURING_QTB_GDSCR_PD_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_TURING_QTB_GDSCR_SW_OVERRIDE_BMSK                                                            0x4
#define HWIO_GCC_TURING_QTB_GDSCR_SW_OVERRIDE_SHFT                                                            0x2
#define HWIO_GCC_TURING_QTB_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_TURING_QTB_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_TURING_QTB_GDSCR_HW_CONTROL_BMSK                                                             0x2
#define HWIO_GCC_TURING_QTB_GDSCR_HW_CONTROL_SHFT                                                             0x1
#define HWIO_GCC_TURING_QTB_GDSCR_HW_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_TURING_QTB_GDSCR_HW_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_TURING_QTB_GDSCR_SW_COLLAPSE_BMSK                                                            0x1
#define HWIO_GCC_TURING_QTB_GDSCR_SW_COLLAPSE_SHFT                                                            0x0
#define HWIO_GCC_TURING_QTB_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_TURING_QTB_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_TURING_QTB_CFG_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d004)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d004)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d004)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG_GDSCR_ADDR, HWIO_GCC_TURING_QTB_CFG_GDSCR_RMSK)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_CFG_GDSCR_ADDR,m,v,HWIO_GCC_TURING_QTB_CFG_GDSCR_IN)
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                   0x4000000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x1a
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                           0x2000000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                0x19
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                            0x1000000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                 0x18
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                     0xf00000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                         0x14
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                        0x80000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                           0x13
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                            0x40000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                               0x12
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                            0x20000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                               0x11
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                         0x10000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                            0x10
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                        0x8000
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                           0xf
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                       0x7800
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                          0xb
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                               0x400
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                 0xa
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                        0x200
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                          0x9
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                        0x100
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                          0x8
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                            0x80
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                             0x7
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                   0x60
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                    0x5
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                             0x10
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                              0x4
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                       0x8
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                       0x3
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                     0x4
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                     0x2
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                         0x2
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                         0x1
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                      0x1
#define HWIO_GCC_TURING_QTB_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                      0x0

#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d008)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d008)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d008)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_RMSK                                                               0x7ffff
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG2_GDSCR_ADDR, HWIO_GCC_TURING_QTB_CFG2_GDSCR_RMSK)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_TURING_QTB_CFG2_GDSCR_IN)
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                   0x40000
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                      0x12
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                               0x20000
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                  0x11
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                             0x10000
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                0x10
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                 0xf000
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                    0xc
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                          0xf00
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                            0x8
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                             0xf0
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                              0x4
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                               0xf
#define HWIO_GCC_TURING_QTB_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                               0x0

#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d00c)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d00c)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d00c)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_RMSK                                                             0x7ffffff
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG3_GDSCR_ADDR, HWIO_GCC_TURING_QTB_CFG3_GDSCR_RMSK)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_TURING_QTB_CFG3_GDSCR_IN)
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                           0x4000000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                0x1a
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                        0x2000000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                             0x19
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                   0x1e00000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                        0x15
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                    0x100000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                        0x14
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                           0x80000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                              0x13
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                               0x40000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                  0x12
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                0x20000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                   0x11
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                     0x10000
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                        0x10
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                             0xff00
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                0x8
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                              0xff
#define HWIO_GCC_TURING_QTB_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                               0x0

#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d010)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d010)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d010)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_RMSK                                                              0xffffff
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG4_GDSCR_ADDR, HWIO_GCC_TURING_QTB_CFG4_GDSCR_RMSK)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_TURING_QTB_CFG4_GDSCR_IN)
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                0xf00000
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                    0x14
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                 0xf0000
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                    0x10
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                 0xf000
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                    0xc
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                0xf00
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                  0x8
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                      0xf0
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                       0x4
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                      0xf
#define HWIO_GCC_TURING_QTB_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                      0x0

#define HWIO_GCC_TURING_Q6_QTB0_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d014)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d014)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d014)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_RMSK                                                              0x81f0700f
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_CBCR_ADDR, HWIO_GCC_TURING_Q6_QTB0_CBCR_RMSK)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_CBCR_ADDR, m)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_QTB0_CBCR_ADDR,v)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_QTB0_CBCR_ADDR,m,v,HWIO_GCC_TURING_Q6_QTB0_CBCR_IN)
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                             0x200000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                 0x15
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TURING_Q6_QTB0_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_TURING_Q6_QTB0_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d018)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d018)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d018)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_SREGR_ADDR, HWIO_GCC_TURING_Q6_QTB0_SREGR_RMSK)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_SREGR_ADDR, m)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_QTB0_SREGR_ADDR,v)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_QTB0_SREGR_ADDR,m,v,HWIO_GCC_TURING_Q6_QTB0_SREGR_IN)
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_TURING_Q6_QTB0_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d01c)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d01c)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d01c)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ADDR, HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_RMSK)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ADDR, m)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ADDR,v)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_ADDR,m,v,HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_IN)
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_TURING_Q6_QTB0_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_TURING_NSP_AHB_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d020)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d020)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d020)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_RMSK                                                              0x81d0000f
#define HWIO_GCC_TURING_NSP_AHB_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_NSP_AHB_CBCR_ADDR, HWIO_GCC_TURING_NSP_AHB_CBCR_RMSK)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_NSP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_NSP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_NSP_AHB_CBCR_ADDR,m,v,HWIO_GCC_TURING_NSP_AHB_CBCR_IN)
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_TURING_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_TURING_NSP_AHB_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_TURING_NSP_AHB_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_TURING_NSP_AHB_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_TURING_NSP_AHB_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_TURING_NSP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TURING_NSP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TURING_NSP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d024)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d024)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d024)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_RMSK                                                           0x81c00005
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ADDR, HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_RMSK)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IN)
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_NSP_QOSGEN_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d028)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d028)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d028)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_RMSK                                                              0x81c0000f
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ADDR, HWIO_GCC_NSP_QDSS_TSCTR_CBCR_RMSK)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NSP_QDSS_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IN)
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_NSP_QDSS_TSCTR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_TURING_QTB_AT_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d02c)
#define HWIO_GCC_TURING_QTB_AT_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d02c)
#define HWIO_GCC_TURING_QTB_AT_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d02c)
#define HWIO_GCC_TURING_QTB_AT_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_TURING_QTB_AT_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_TURING_QTB_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_AT_CBCR_ADDR, HWIO_GCC_TURING_QTB_AT_CBCR_RMSK)
#define HWIO_GCC_TURING_QTB_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_AT_CBCR_ADDR, m)
#define HWIO_GCC_TURING_QTB_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_AT_CBCR_ADDR,v)
#define HWIO_GCC_TURING_QTB_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_AT_CBCR_ADDR,m,v,HWIO_GCC_TURING_QTB_AT_CBCR_IN)
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_TURING_QTB_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_TURING_QTB_AT_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_TURING_QTB_AT_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_TURING_QTB_AT_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_TURING_QTB_AT_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_TURING_QTB_AT_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_QTB_AT_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TURING_QTB_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TURING_XO_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d030)
#define HWIO_GCC_TURING_XO_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d030)
#define HWIO_GCC_TURING_XO_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d030)
#define HWIO_GCC_TURING_XO_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_TURING_XO_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_TURING_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_XO_CBCR_ADDR, HWIO_GCC_TURING_XO_CBCR_RMSK)
#define HWIO_GCC_TURING_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_XO_CBCR_ADDR, m)
#define HWIO_GCC_TURING_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_XO_CBCR_ADDR,v)
#define HWIO_GCC_TURING_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_XO_CBCR_ADDR,m,v,HWIO_GCC_TURING_XO_CBCR_IN)
#define HWIO_GCC_TURING_XO_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_TURING_XO_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_TURING_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_TURING_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_TURING_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_TURING_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_TURING_XO_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_TURING_XO_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_TURING_XO_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_TURING_XO_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_TURING_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_TURING_XO_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_TURING_XO_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_TURING_XO_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_TURING_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_TURING_PWRCTL_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008d034)
#define HWIO_GCC_TURING_PWRCTL_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008d034)
#define HWIO_GCC_TURING_PWRCTL_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008d034)
#define HWIO_GCC_TURING_PWRCTL_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_TURING_PWRCTL_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_TURING_PWRCTL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_PWRCTL_CBCR_ADDR, HWIO_GCC_TURING_PWRCTL_CBCR_RMSK)
#define HWIO_GCC_TURING_PWRCTL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_PWRCTL_CBCR_ADDR, m)
#define HWIO_GCC_TURING_PWRCTL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_PWRCTL_CBCR_ADDR,v)
#define HWIO_GCC_TURING_PWRCTL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_PWRCTL_CBCR_ADDR,m,v,HWIO_GCC_TURING_PWRCTL_CBCR_IN)
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_TURING_PWRCTL_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_TURING_PWRCTL_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_TURING_PWRCTL_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_TURING_PWRCTL_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_TURING_PWRCTL_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_TURING_PWRCTL_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_PWRCTL_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TURING_PWRCTL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TURING_MMNOC_SF_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00035000)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035000)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035000)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_RMSK                                                             0x81f0000f
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_MMNOC_SF_CBCR_ADDR, HWIO_GCC_TURING_MMNOC_SF_CBCR_RMSK)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_MMNOC_SF_CBCR_ADDR, m)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_MMNOC_SF_CBCR_ADDR,v)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_MMNOC_SF_CBCR_ADDR,m,v,HWIO_GCC_TURING_MMNOC_SF_CBCR_IN)
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                            0x200000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                0x15
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TURING_MMNOC_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_TURING_Q6_AXI_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00035004)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035004)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035004)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_RMSK                                                               0x81f0000f
#define HWIO_GCC_TURING_Q6_AXI_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CBCR_ADDR, HWIO_GCC_TURING_Q6_AXI_CBCR_RMSK)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CBCR_ADDR, m)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_AXI_CBCR_ADDR,v)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_AXI_CBCR_ADDR,m,v,HWIO_GCC_TURING_Q6_AXI_CBCR_IN)
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                              0x200000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                  0x15
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_TURING_Q6_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_TURING_Q6_AXI_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_TURING_Q6_AXI_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_TURING_Q6_AXI_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_TURING_Q6_AXI_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_TURING_Q6_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_Q6_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TURING_Q6_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TURING_CFG_AHB_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00035008)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035008)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035008)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_RMSK                                                              0x81d00005
#define HWIO_GCC_TURING_CFG_AHB_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_CFG_AHB_CBCR_ADDR, HWIO_GCC_TURING_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_TURING_CFG_AHB_CBCR_IN)
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_TURING_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TURING_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_TURING_AT_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003500c)
#define HWIO_GCC_TURING_AT_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003500c)
#define HWIO_GCC_TURING_AT_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003500c)
#define HWIO_GCC_TURING_AT_CBCR_RMSK                                                                   0x81d0000f
#define HWIO_GCC_TURING_AT_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_TURING_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_AT_CBCR_ADDR, HWIO_GCC_TURING_AT_CBCR_RMSK)
#define HWIO_GCC_TURING_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_AT_CBCR_ADDR, m)
#define HWIO_GCC_TURING_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_AT_CBCR_ADDR,v)
#define HWIO_GCC_TURING_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_AT_CBCR_ADDR,m,v,HWIO_GCC_TURING_AT_CBCR_IN)
#define HWIO_GCC_TURING_AT_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_TURING_AT_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_TURING_AT_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_TURING_AT_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_TURING_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_TURING_AT_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_TURING_AT_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_TURING_AT_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_TURING_AT_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_TURING_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_TURING_AT_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_TURING_AT_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_TURING_AT_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_TURING_AT_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_TURING_AT_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_TURING_AT_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_TURING_AT_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_TURING_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_TURING_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00035010)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035010)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035010)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ATTR                                                                0x3
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ADDR, HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QMIP_TURING_NSP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_TURING_TRIG_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00035014)
#define HWIO_GCC_TURING_TRIG_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035014)
#define HWIO_GCC_TURING_TRIG_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035014)
#define HWIO_GCC_TURING_TRIG_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_TURING_TRIG_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_TURING_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_TURING_TRIG_CBCR_ADDR, HWIO_GCC_TURING_TRIG_CBCR_RMSK)
#define HWIO_GCC_TURING_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_TURING_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_TURING_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_TRIG_CBCR_ADDR,m,v,HWIO_GCC_TURING_TRIG_CBCR_IN)
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_TURING_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_TURING_TRIG_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_TURING_TRIG_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_TURING_TRIG_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_TURING_TRIG_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_TURING_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_TURING_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_TURING_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003502c)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003502c)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003502c)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_RMSK                                                               0xffff
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_RCG_SW_CTRL_BMSK                                                   0x8000
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_RCG_SW_CTRL_SHFT                                                      0xf
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_SW_PERF_STATE_BMSK                                                 0x7800
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_SW_PERF_STATE_SHFT                                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_SW_OVERRIDE_BMSK                                                    0x400
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_SW_OVERRIDE_SHFT                                                      0xa
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                       0x200
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                         0x9
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_FSM_STATE_BMSK                                                  0x1c0
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_FSM_STATE_SHFT                                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                  0x20
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                   0x5
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_CURR_PERF_STATE_BMSK                                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_CURR_PERF_STATE_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_EN_BMSK                                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_EN_SHFT                                                           0x0
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035034)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035034)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035034)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035038)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035038)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035038)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003503c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003503c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003503c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035040)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035040)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035040)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035044)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035044)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035044)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035048)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035048)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035048)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003504c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003504c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003504c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035050)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035050)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035050)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035054)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035054)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035054)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035058)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035058)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035058)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0003505c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003505c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003505c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00035060)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035060)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035060)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00035064)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035064)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035064)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00035068)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035068)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035068)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0003506c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003506c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003506c)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00035070)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035070)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035070)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_CDSP_NOC_TURING_Q6_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00035018)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035018)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035018)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_RMSK                                                           0x80000013
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ADDR, HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_IN)
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                        0x1f
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                  0x10
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                   0x4
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_EN_BMSK                                                          0x2
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_EN_SHFT                                                          0x1
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_UPDATE_BMSK                                                           0x1
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_UPDATE_SHFT                                                           0x0
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TURING_Q6_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0003501c)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003501c)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003501c)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RMSK                                                             0x11071f
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ATTR                                                                  0x3
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ADDR, HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_IN)
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                              0x100000
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                  0x14
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                           0x0
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                            0x1
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                              0x10000
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                 0x10
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                  0x0
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                 0x1
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_BMSK                                                        0x700
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SHFT                                                          0x8
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                     0x0
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                     0x1
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                     0x2
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                     0x3
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                     0x4
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                     0x5
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                     0x6
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                     0x7
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_BMSK                                                         0x1f
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_SHFT                                                          0x0
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                   0x0
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                     0x1
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                   0x2
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                     0x3
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                   0x4
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                     0x5
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                   0x6
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                     0x7
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                   0x8
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                     0x9
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                   0xa
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                     0xb
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                   0xc
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                     0xd
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                   0xe
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                     0xf
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                  0x10
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                    0x11
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                  0x12
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                   0x13
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                 0x14
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                   0x15
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                 0x16
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                   0x17
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                 0x18
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                   0x19
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                 0x1a
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                   0x1b
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                 0x1c
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                   0x1d
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                 0x1e
#define HWIO_GCC_TURING_Q6_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                   0x1f

#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00035144)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035144)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035144)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_RMSK                                                             0x1
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ATTR                                                             0x3
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ADDR, HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TURING_Q6_AXI_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_CPUSS_AHB_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038000)
#define HWIO_GCC_CPUSS_AHB_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038000)
#define HWIO_GCC_CPUSS_AHB_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038000)
#define HWIO_GCC_CPUSS_AHB_CBCR_RMSK                                                                   0x81c0000e
#define HWIO_GCC_CPUSS_AHB_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_CPUSS_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CBCR_ADDR, HWIO_GCC_CPUSS_AHB_CBCR_RMSK)
#define HWIO_GCC_CPUSS_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CBCR_ADDR, m)
#define HWIO_GCC_CPUSS_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AHB_CBCR_ADDR,v)
#define HWIO_GCC_CPUSS_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AHB_CBCR_ADDR,m,v,HWIO_GCC_CPUSS_AHB_CBCR_IN)
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_CPUSS_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_CPUSS_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_CPUSS_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_CPUSS_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_CPUSS_AHB_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_CPUSS_AHB_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_CPUSS_AHB_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_CPUSS_AHB_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_CPUSS_AHB_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_CPUSS_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_CPUSS_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_CPUSS_TRIG_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038004)
#define HWIO_GCC_CPUSS_TRIG_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038004)
#define HWIO_GCC_CPUSS_TRIG_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038004)
#define HWIO_GCC_CPUSS_TRIG_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_CPUSS_TRIG_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_CPUSS_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_TRIG_CBCR_ADDR, HWIO_GCC_CPUSS_TRIG_CBCR_RMSK)
#define HWIO_GCC_CPUSS_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_CPUSS_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_CPUSS_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_TRIG_CBCR_ADDR,m,v,HWIO_GCC_CPUSS_TRIG_CBCR_IN)
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_CPUSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_CPUSS_TRIG_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_CPUSS_TRIG_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_CPUSS_TRIG_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_CPUSS_TRIG_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_CPUSS_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_CPUSS_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CPUSS_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_CPUSS_AT_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00038008)
#define HWIO_GCC_CPUSS_AT_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038008)
#define HWIO_GCC_CPUSS_AT_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038008)
#define HWIO_GCC_CPUSS_AT_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_CPUSS_AT_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_CPUSS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AT_CBCR_ADDR, HWIO_GCC_CPUSS_AT_CBCR_RMSK)
#define HWIO_GCC_CPUSS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AT_CBCR_ADDR, m)
#define HWIO_GCC_CPUSS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AT_CBCR_ADDR,v)
#define HWIO_GCC_CPUSS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AT_CBCR_ADDR,m,v,HWIO_GCC_CPUSS_AT_CBCR_IN)
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_CPUSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_CPUSS_AT_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_CPUSS_AT_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_CPUSS_AT_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_CPUSS_AT_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_CPUSS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_CPUSS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_CPUSS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0003800c)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003800c)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003800c)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ATTR                                                                0x3
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ADDR, HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_RMSK)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ADDR, m)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ADDR,v)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_ADDR,m,v,HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IN)
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_CPUSS_CONFIG_NOC_SF_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00038010)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038010)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038010)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CMD_RCGR_ADDR, HWIO_GCC_CPUSS_AHB_CMD_RCGR_RMSK)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AHB_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AHB_CMD_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_AHB_CMD_RCGR_IN)
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_AHB_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00038014)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038014)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038014)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CFG_RCGR_ADDR, HWIO_GCC_CPUSS_AHB_CFG_RCGR_RMSK)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AHB_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AHB_CFG_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_AHB_CFG_RCGR_IN)
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_CPUSS_AHB_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00038028)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038028)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038028)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_RMSK                                                                 0xf
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ATTR                                                                 0x3
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ADDR, HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_RMSK)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ADDR, m)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ADDR,v)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_ADDR,m,v,HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_IN)
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_CLK_DIV_BMSK                                                         0xf
#define HWIO_GCC_CPUSS_AHB_POSTDIV_CDIVR_CLK_DIV_SHFT                                                         0x0

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038048)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038048)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038048)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003804c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003804c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003804c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038050)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038050)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038050)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038054)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038054)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038054)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038058)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038058)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038058)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003805c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003805c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003805c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038060)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038060)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038060)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038064)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038064)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038064)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038068)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038068)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038068)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003806c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003806c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003806c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_RMSK                                                        0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ATTR                                                          0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_BMSK                                                0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                             0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                             0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                             0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_BMSK                                                 0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                           0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                             0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                           0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                             0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                           0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                             0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                           0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                             0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                           0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                             0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                           0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                             0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                           0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                             0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                           0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                             0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                          0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                            0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                          0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                           0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                         0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                           0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                         0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                           0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                         0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                           0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                         0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                           0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                         0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                           0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                         0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                           0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038070)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038070)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038070)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038074)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038074)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038074)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038078)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038078)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038078)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0003807c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003807c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003807c)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038080)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038080)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038080)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00038084)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038084)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038084)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_RMSK                                                       0x71f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ATTR                                                         0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_BMSK                                               0x700
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SHFT                                                 0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                            0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                            0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                            0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                            0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_BMSK                                                0x1f
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_SHFT                                                 0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                          0x0
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                            0x1
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                          0x2
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                            0x3
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                          0x4
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                            0x5
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                          0x6
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                            0x7
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                          0x8
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                            0x9
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                          0xa
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                            0xb
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                          0xc
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                            0xd
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                          0xe
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                            0xf
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                         0x10
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                           0x11
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                         0x12
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                          0x13
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                        0x14
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                          0x15
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                        0x16
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                          0x17
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                        0x18
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                          0x19
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                        0x1a
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                          0x1b
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                        0x1c
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                          0x1d
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                        0x1e
#define HWIO_GCC_RPMH_SHUB_CPUSS_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                          0x1f

#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003802c)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003802c)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003802c)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_CMD_RCGR_ADDR, HWIO_GCC_CPUSS_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_AXI_CMD_RCGR_IN)
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00038030)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038030)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038030)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_CFG_RCGR_ADDR, HWIO_GCC_CPUSS_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_AXI_CFG_RCGR_IN)
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_CPUSS_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00038158)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038158)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038158)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_RMSK                                                             0x80000013
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ADDR, HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_RMSK)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_IN)
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_OFF_SHFT                                                          0x1f
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                    0x10
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                     0x4
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_EN_BMSK                                                            0x2
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_EN_SHFT                                                            0x1
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_UPDATE_BMSK                                                             0x1
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_UPDATE_SHFT                                                             0x0
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_UPDATE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CPUSS_GPLL0_CMD_RCGR_UPDATE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0003815c)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003815c)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003815c)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RMSK                                                               0x11071f
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ADDR, HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RMSK)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ADDR, m)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ADDR,v)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_ADDR,m,v,HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_IN)
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                0x100000
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                    0x14
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                0x10000
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                   0x10
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                    0x0
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                   0x1
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_BMSK                                                          0x700
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SHFT                                                            0x8
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                       0x0
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                       0x1
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                       0x2
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                       0x3
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                       0x4
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                       0x5
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                       0x6
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                       0x7
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_BMSK                                                           0x1f
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_SHFT                                                            0x0
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                       0x1
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                     0x2
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                       0x3
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                     0x4
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                       0x5
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                     0x6
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                       0x7
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                     0x8
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                       0x9
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                     0xa
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                       0xb
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                     0xc
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                       0xd
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                     0xe
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                       0xf
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                    0x10
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                      0x11
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                    0x12
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                     0x13
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                   0x14
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                     0x15
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                   0x16
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                     0x17
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                   0x18
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                     0x19
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                   0x1a
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                     0x1b
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                   0x1c
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                     0x1d
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                   0x1e
#define HWIO_GCC_CPUSS_GPLL0_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                     0x1f

#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00038170)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038170)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038170)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_RMSK                                                                 0x1
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ATTR                                                                 0x3
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ADDR, HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_CPUSS_AXI_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00038174)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038174)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038174)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_RMSK                                                             0x81c0000f
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ADDR, HWIO_GCC_APSS_QDSS_TSCTR_CBCR_RMSK)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ADDR, m)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ADDR,v)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APSS_QDSS_TSCTR_CBCR_ADDR,m,v,HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IN)
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_APSS_QDSS_TSCTR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_APSS_QDSS_APB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00038178)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038178)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038178)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_RMSK                                                               0x81c0000f
#define HWIO_GCC_APSS_QDSS_APB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_APSS_QDSS_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_APSS_QDSS_APB_CBCR_ADDR, HWIO_GCC_APSS_QDSS_APB_CBCR_RMSK)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APSS_QDSS_APB_CBCR_ADDR, m)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_APSS_QDSS_APB_CBCR_ADDR,v)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APSS_QDSS_APB_CBCR_ADDR,m,v,HWIO_GCC_APSS_QDSS_APB_CBCR_IN)
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_APSS_QDSS_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_APSS_QDSS_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_APSS_QDSS_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_APSS_QDSS_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_APSS_QDSS_APB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_APSS_QDSS_APB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_APSS_QDSS_APB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_APSS_QDSS_APB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_APSS_QDSS_APB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_APSS_QDSS_APB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_APSS_QDSS_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00039000)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00039000)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00039000)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_RMSK                                                              0x1
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ATTR                                                              0x3
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ADDR, HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_RMSK)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ADDR, m)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ADDR,v)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_ADDR,m,v,HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_IN)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_BLK_ARES_BMSK                                                     0x1
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_BLK_ARES_SHFT                                                     0x0
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_BLK_ARES_DISABLE_FVAL                                             0x0
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_BCR_BLK_ARES_ENABLE_FVAL                                              0x1

#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00039004)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00039004)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00039004)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_RMSK                                                      0x81c00005
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ATTR                                                             0x3
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ADDR, HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_RMSK)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ADDR, m)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ADDR,v)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_ADDR,m,v,HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IN)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IGNORE_ALL_ARES_BMSK                                       0x1000000
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IGNORE_ALL_ARES_SHFT                                            0x18
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                     0x800000
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                         0x17
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_DIS_BMSK                                                0x400000
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_DIS_SHFT                                                    0x16
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ARES_BMSK                                                    0x4
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ARES_SHFT                                                    0x2
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ARES_NO_RESET_FVAL                                           0x0
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ARES_RESET_FVAL                                              0x1
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_CBCR_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00039008)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00039008)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00039008)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_RMSK                                                        0xf
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ATTR                                                        0x3
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ADDR, HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_RMSK)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_ADDR,m,v,HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_IN)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_CLK_DIV_BMSK                                                0xf
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV_CDIVR_CLK_DIV_SHFT                                                0x0

#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0003900c)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003900c)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003900c)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_RMSK                                                                 0xf
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ATTR                                                                 0x3
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ADDR, HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_RMSK)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_ADDR,m,v,HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_IN)
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_CLK_DIV_BMSK                                                         0xf
#define HWIO_GCC_QOSGEN_EXTREF_DIV_CDIVR_CLK_DIV_SHFT                                                         0x0

#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00039010)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00039010)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00039010)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_RMSK                                                   0x1ff
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ATTR                                                     0x3
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ADDR, HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_RMSK)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ADDR, m)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ADDR,v)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_ADDR,m,v,HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_IN)
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_CLK_DIV_BMSK                                           0x1ff
#define HWIO_GCC_NOC_BUS_TIMEOUT_EXTREF_DIV512_CDIVR_CLK_DIV_SHFT                                             0x0

#define HWIO_GCC_APB2JTAG_BCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003c000)
#define HWIO_GCC_APB2JTAG_BCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003c000)
#define HWIO_GCC_APB2JTAG_BCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003c000)
#define HWIO_GCC_APB2JTAG_BCR_RMSK                                                                            0x1
#define HWIO_GCC_APB2JTAG_BCR_ATTR                                                                            0x3
#define HWIO_GCC_APB2JTAG_BCR_IN          \
        in_dword_masked(HWIO_GCC_APB2JTAG_BCR_ADDR, HWIO_GCC_APB2JTAG_BCR_RMSK)
#define HWIO_GCC_APB2JTAG_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APB2JTAG_BCR_ADDR, m)
#define HWIO_GCC_APB2JTAG_BCR_OUT(v)      \
        out_dword(HWIO_GCC_APB2JTAG_BCR_ADDR,v)
#define HWIO_GCC_APB2JTAG_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APB2JTAG_BCR_ADDR,m,v,HWIO_GCC_APB2JTAG_BCR_IN)
#define HWIO_GCC_APB2JTAG_BCR_BLK_ARES_BMSK                                                                   0x1
#define HWIO_GCC_APB2JTAG_BCR_BLK_ARES_SHFT                                                                   0x0
#define HWIO_GCC_APB2JTAG_BCR_BLK_ARES_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_APB2JTAG_BCR_BLK_ARES_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_RBCPR_CX_BCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e000)
#define HWIO_GCC_RBCPR_CX_BCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e000)
#define HWIO_GCC_RBCPR_CX_BCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e000)
#define HWIO_GCC_RBCPR_CX_BCR_RMSK                                                                            0x1
#define HWIO_GCC_RBCPR_CX_BCR_ATTR                                                                            0x3
#define HWIO_GCC_RBCPR_CX_BCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_CX_BCR_ADDR, HWIO_GCC_RBCPR_CX_BCR_RMSK)
#define HWIO_GCC_RBCPR_CX_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_CX_BCR_ADDR, m)
#define HWIO_GCC_RBCPR_CX_BCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_CX_BCR_ADDR,v)
#define HWIO_GCC_RBCPR_CX_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_CX_BCR_ADDR,m,v,HWIO_GCC_RBCPR_CX_BCR_IN)
#define HWIO_GCC_RBCPR_CX_BCR_BLK_ARES_BMSK                                                                   0x1
#define HWIO_GCC_RBCPR_CX_BCR_BLK_ARES_SHFT                                                                   0x0
#define HWIO_GCC_RBCPR_CX_BCR_BLK_ARES_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_RBCPR_CX_BCR_BLK_ARES_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_RBCPR_CX_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e004)
#define HWIO_GCC_RBCPR_CX_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e004)
#define HWIO_GCC_RBCPR_CX_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e004)
#define HWIO_GCC_RBCPR_CX_CBCR_RMSK                                                                    0x81c00005
#define HWIO_GCC_RBCPR_CX_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_RBCPR_CX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CBCR_ADDR, HWIO_GCC_RBCPR_CX_CBCR_RMSK)
#define HWIO_GCC_RBCPR_CX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_CX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_CX_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_CX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_CX_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_CX_CBCR_IN)
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_RBCPR_CX_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_RBCPR_CX_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_RBCPR_CX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_RBCPR_CX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_CX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_RBCPR_CX_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e008)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e008)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e008)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_CX_AHB_CBCR_ADDR, HWIO_GCC_RBCPR_CX_AHB_CBCR_RMSK)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_CX_AHB_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_CX_AHB_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_CX_AHB_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_CX_AHB_CBCR_IN)
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_RBCPR_CX_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e00c)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e00c)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e00c)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_RMSK                                                                0x80000013
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CMD_RCGR_ADDR, HWIO_GCC_RBCPR_CX_CMD_RCGR_RMSK)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_CX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_CX_CMD_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_CX_CMD_RCGR_IN)
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_OFF_SHFT                                                             0x1f
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                       0x10
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                        0x4
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_EN_BMSK                                                               0x2
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_EN_SHFT                                                               0x1
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_UPDATE_BMSK                                                                0x1
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_UPDATE_SHFT                                                                0x0
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_CX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_RBCPR_CX_CFG_RCGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e010)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e010)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e010)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_RMSK                                                                  0x11071f
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_ATTR                                                                       0x3
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CFG_RCGR_ADDR, HWIO_GCC_RBCPR_CX_CFG_RCGR_RMSK)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_CX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_CX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_CX_CFG_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_CX_CFG_RCGR_IN)
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                   0x100000
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                       0x14
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                   0x10000
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                      0x10
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                       0x0
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                      0x1
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_BMSK                                                             0x700
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SHFT                                                               0x8
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                          0x0
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                          0x1
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                          0x2
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                          0x3
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                          0x4
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                          0x5
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                          0x6
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                          0x7
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_BMSK                                                              0x1f
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                          0x1
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                        0x2
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                          0x3
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                        0x4
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                          0x5
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                        0x6
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                          0x7
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                        0x8
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                          0x9
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                        0xa
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                          0xb
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                        0xc
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                          0xd
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                        0xe
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                          0xf
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                       0x10
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                         0x11
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                       0x12
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                        0x13
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                      0x14
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                        0x15
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                      0x16
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                        0x17
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                      0x18
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                        0x19
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                      0x1a
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                        0x1b
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                      0x1c
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                        0x1d
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                      0x1e
#define HWIO_GCC_RBCPR_CX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                        0x1f

#define HWIO_GCC_RBCPR_MXC_BCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0003f000)
#define HWIO_GCC_RBCPR_MXC_BCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003f000)
#define HWIO_GCC_RBCPR_MXC_BCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003f000)
#define HWIO_GCC_RBCPR_MXC_BCR_RMSK                                                                           0x1
#define HWIO_GCC_RBCPR_MXC_BCR_ATTR                                                                           0x3
#define HWIO_GCC_RBCPR_MXC_BCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_BCR_ADDR, HWIO_GCC_RBCPR_MXC_BCR_RMSK)
#define HWIO_GCC_RBCPR_MXC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_BCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXC_BCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXC_BCR_ADDR,m,v,HWIO_GCC_RBCPR_MXC_BCR_IN)
#define HWIO_GCC_RBCPR_MXC_BCR_BLK_ARES_BMSK                                                                  0x1
#define HWIO_GCC_RBCPR_MXC_BCR_BLK_ARES_SHFT                                                                  0x0
#define HWIO_GCC_RBCPR_MXC_BCR_BLK_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_RBCPR_MXC_BCR_BLK_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_RBCPR_MXC_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003f004)
#define HWIO_GCC_RBCPR_MXC_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003f004)
#define HWIO_GCC_RBCPR_MXC_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003f004)
#define HWIO_GCC_RBCPR_MXC_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_RBCPR_MXC_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_RBCPR_MXC_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CBCR_ADDR, HWIO_GCC_RBCPR_MXC_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MXC_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXC_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXC_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXC_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXC_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MXC_CBCR_IN)
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_RBCPR_MXC_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_RBCPR_MXC_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_RBCPR_MXC_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_RBCPR_MXC_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXC_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003f008)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003f008)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003f008)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_AHB_CBCR_ADDR, HWIO_GCC_RBCPR_MXC_AHB_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXC_AHB_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MXC_AHB_CBCR_IN)
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_RBCPR_MXC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003f00c)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003f00c)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003f00c)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CMD_RCGR_ADDR, HWIO_GCC_RBCPR_MXC_CMD_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CMD_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXC_CMD_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXC_CMD_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MXC_CMD_RCGR_IN)
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXC_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003f010)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003f010)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003f010)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CFG_RCGR_ADDR, HWIO_GCC_RBCPR_MXC_CFG_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXC_CFG_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXC_CFG_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXC_CFG_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MXC_CFG_RCGR_IN)
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_RBCPR_MXC_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_RBCPR_MXA_BCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d000)
#define HWIO_GCC_RBCPR_MXA_BCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d000)
#define HWIO_GCC_RBCPR_MXA_BCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d000)
#define HWIO_GCC_RBCPR_MXA_BCR_RMSK                                                                           0x1
#define HWIO_GCC_RBCPR_MXA_BCR_ATTR                                                                           0x3
#define HWIO_GCC_RBCPR_MXA_BCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_BCR_ADDR, HWIO_GCC_RBCPR_MXA_BCR_RMSK)
#define HWIO_GCC_RBCPR_MXA_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_BCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXA_BCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXA_BCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXA_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXA_BCR_ADDR,m,v,HWIO_GCC_RBCPR_MXA_BCR_IN)
#define HWIO_GCC_RBCPR_MXA_BCR_BLK_ARES_BMSK                                                                  0x1
#define HWIO_GCC_RBCPR_MXA_BCR_BLK_ARES_SHFT                                                                  0x0
#define HWIO_GCC_RBCPR_MXA_BCR_BLK_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_RBCPR_MXA_BCR_BLK_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_RBCPR_MXA_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d004)
#define HWIO_GCC_RBCPR_MXA_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d004)
#define HWIO_GCC_RBCPR_MXA_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d004)
#define HWIO_GCC_RBCPR_MXA_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_RBCPR_MXA_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_RBCPR_MXA_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CBCR_ADDR, HWIO_GCC_RBCPR_MXA_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MXA_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXA_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXA_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXA_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXA_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MXA_CBCR_IN)
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_RBCPR_MXA_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_RBCPR_MXA_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_RBCPR_MXA_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_RBCPR_MXA_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXA_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d008)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d008)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d008)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_AHB_CBCR_ADDR, HWIO_GCC_RBCPR_MXA_AHB_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_AHB_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXA_AHB_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXA_AHB_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MXA_AHB_CBCR_IN)
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_RBCPR_MXA_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d00c)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d00c)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d00c)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CMD_RCGR_ADDR, HWIO_GCC_RBCPR_MXA_CMD_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CMD_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXA_CMD_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXA_CMD_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MXA_CMD_RCGR_IN)
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXA_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d010)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d010)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d010)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CFG_RCGR_ADDR, HWIO_GCC_RBCPR_MXA_CFG_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MXA_CFG_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MXA_CFG_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MXA_CFG_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MXA_CFG_RCGR_IN)
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_RBCPR_MXA_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_RBCPR_NSP_BCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d024)
#define HWIO_GCC_RBCPR_NSP_BCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d024)
#define HWIO_GCC_RBCPR_NSP_BCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d024)
#define HWIO_GCC_RBCPR_NSP_BCR_RMSK                                                                           0x1
#define HWIO_GCC_RBCPR_NSP_BCR_ATTR                                                                           0x3
#define HWIO_GCC_RBCPR_NSP_BCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_BCR_ADDR, HWIO_GCC_RBCPR_NSP_BCR_RMSK)
#define HWIO_GCC_RBCPR_NSP_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_BCR_ADDR, m)
#define HWIO_GCC_RBCPR_NSP_BCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_NSP_BCR_ADDR,v)
#define HWIO_GCC_RBCPR_NSP_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_NSP_BCR_ADDR,m,v,HWIO_GCC_RBCPR_NSP_BCR_IN)
#define HWIO_GCC_RBCPR_NSP_BCR_BLK_ARES_BMSK                                                                  0x1
#define HWIO_GCC_RBCPR_NSP_BCR_BLK_ARES_SHFT                                                                  0x0
#define HWIO_GCC_RBCPR_NSP_BCR_BLK_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_RBCPR_NSP_BCR_BLK_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_RBCPR_NSP_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d028)
#define HWIO_GCC_RBCPR_NSP_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d028)
#define HWIO_GCC_RBCPR_NSP_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d028)
#define HWIO_GCC_RBCPR_NSP_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_RBCPR_NSP_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_RBCPR_NSP_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CBCR_ADDR, HWIO_GCC_RBCPR_NSP_CBCR_RMSK)
#define HWIO_GCC_RBCPR_NSP_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_NSP_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_NSP_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_NSP_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_NSP_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_NSP_CBCR_IN)
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_RBCPR_NSP_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_RBCPR_NSP_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_RBCPR_NSP_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_RBCPR_NSP_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_NSP_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d02c)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d02c)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d02c)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_RMSK                                                               0x81d0000f
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_AHB_CBCR_ADDR, HWIO_GCC_RBCPR_NSP_AHB_CBCR_RMSK)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_AHB_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_NSP_AHB_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_NSP_AHB_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_NSP_AHB_CBCR_IN)
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ENABLE_BMSK                                                           0x1
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ENABLE_SHFT                                                           0x0
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_RBCPR_NSP_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d030)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d030)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d030)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CMD_RCGR_ADDR, HWIO_GCC_RBCPR_NSP_CMD_RCGR_RMSK)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CMD_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_NSP_CMD_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_NSP_CMD_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_NSP_CMD_RCGR_IN)
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_NSP_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0000d034)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000d034)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000d034)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CFG_RCGR_ADDR, HWIO_GCC_RBCPR_NSP_CFG_RCGR_RMSK)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_NSP_CFG_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_NSP_CFG_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_NSP_CFG_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_NSP_CFG_RCGR_IN)
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_RBCPR_NSP_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_DEBUG_DIV_CDIVR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00052000)
#define HWIO_GCC_DEBUG_DIV_CDIVR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052000)
#define HWIO_GCC_DEBUG_DIV_CDIVR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052000)
#define HWIO_GCC_DEBUG_DIV_CDIVR_RMSK                                                                         0xf
#define HWIO_GCC_DEBUG_DIV_CDIVR_ATTR                                                                         0x3
#define HWIO_GCC_DEBUG_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_DEBUG_DIV_CDIVR_ADDR, HWIO_GCC_DEBUG_DIV_CDIVR_RMSK)
#define HWIO_GCC_DEBUG_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_DEBUG_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_DEBUG_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_DEBUG_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_DEBUG_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DEBUG_DIV_CDIVR_ADDR,m,v,HWIO_GCC_DEBUG_DIV_CDIVR_IN)
#define HWIO_GCC_DEBUG_DIV_CDIVR_CLK_DIV_BMSK                                                                 0xf
#define HWIO_GCC_DEBUG_DIV_CDIVR_CLK_DIV_SHFT                                                                 0x0

#define HWIO_GCC_DEBUG_CBCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00052004)
#define HWIO_GCC_DEBUG_CBCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052004)
#define HWIO_GCC_DEBUG_CBCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052004)
#define HWIO_GCC_DEBUG_CBCR_RMSK                                                                       0x81c00005
#define HWIO_GCC_DEBUG_CBCR_ATTR                                                                              0x3
#define HWIO_GCC_DEBUG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DEBUG_CBCR_ADDR, HWIO_GCC_DEBUG_CBCR_RMSK)
#define HWIO_GCC_DEBUG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DEBUG_CBCR_ADDR, m)
#define HWIO_GCC_DEBUG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DEBUG_CBCR_ADDR,v)
#define HWIO_GCC_DEBUG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DEBUG_CBCR_ADDR,m,v,HWIO_GCC_DEBUG_CBCR_IN)
#define HWIO_GCC_DEBUG_CBCR_CLK_OFF_BMSK                                                               0x80000000
#define HWIO_GCC_DEBUG_CBCR_CLK_OFF_SHFT                                                                     0x1f
#define HWIO_GCC_DEBUG_CBCR_IGNORE_ALL_ARES_BMSK                                                        0x1000000
#define HWIO_GCC_DEBUG_CBCR_IGNORE_ALL_ARES_SHFT                                                             0x18
#define HWIO_GCC_DEBUG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                      0x800000
#define HWIO_GCC_DEBUG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                          0x17
#define HWIO_GCC_DEBUG_CBCR_CLK_DIS_BMSK                                                                 0x400000
#define HWIO_GCC_DEBUG_CBCR_CLK_DIS_SHFT                                                                     0x16
#define HWIO_GCC_DEBUG_CBCR_CLK_ARES_BMSK                                                                     0x4
#define HWIO_GCC_DEBUG_CBCR_CLK_ARES_SHFT                                                                     0x2
#define HWIO_GCC_DEBUG_CBCR_CLK_ARES_NO_RESET_FVAL                                                            0x0
#define HWIO_GCC_DEBUG_CBCR_CLK_ARES_RESET_FVAL                                                               0x1
#define HWIO_GCC_DEBUG_CBCR_CLK_ENABLE_BMSK                                                                   0x1
#define HWIO_GCC_DEBUG_CBCR_CLK_ENABLE_SHFT                                                                   0x0
#define HWIO_GCC_DEBUG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_DEBUG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00052008)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052008)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052008)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_RMSK                                                             0x81c00005
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_IN          \
        in_dword_masked(HWIO_GCC_FRQ_MEASURE_REF_CBCR_ADDR, HWIO_GCC_FRQ_MEASURE_REF_CBCR_RMSK)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_FRQ_MEASURE_REF_CBCR_ADDR, m)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_FRQ_MEASURE_REF_CBCR_ADDR,v)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_FRQ_MEASURE_REF_CBCR_ADDR,m,v,HWIO_GCC_FRQ_MEASURE_REF_CBCR_IN)
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_FRQ_MEASURE_REF_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_PLL_TEST_DIV_CDIVR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00052010)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052010)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052010)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_RMSK                                                                      0xf
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_ATTR                                                                      0x3
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_PLL_TEST_DIV_CDIVR_ADDR, HWIO_GCC_PLL_TEST_DIV_CDIVR_RMSK)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_TEST_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_PLL_TEST_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_TEST_DIV_CDIVR_ADDR,m,v,HWIO_GCC_PLL_TEST_DIV_CDIVR_IN)
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_CLK_DIV_BMSK                                                              0xf
#define HWIO_GCC_PLL_TEST_DIV_CDIVR_CLK_DIV_SHFT                                                              0x0

#define HWIO_GCC_PLL_TEST_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00052014)
#define HWIO_GCC_PLL_TEST_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052014)
#define HWIO_GCC_PLL_TEST_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052014)
#define HWIO_GCC_PLL_TEST_CBCR_RMSK                                                                    0x81c00005
#define HWIO_GCC_PLL_TEST_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_PLL_TEST_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PLL_TEST_CBCR_ADDR, HWIO_GCC_PLL_TEST_CBCR_RMSK)
#define HWIO_GCC_PLL_TEST_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_TEST_CBCR_ADDR, m)
#define HWIO_GCC_PLL_TEST_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PLL_TEST_CBCR_ADDR,v)
#define HWIO_GCC_PLL_TEST_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_TEST_CBCR_ADDR,m,v,HWIO_GCC_PLL_TEST_CBCR_IN)
#define HWIO_GCC_PLL_TEST_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_PLL_TEST_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_PLL_TEST_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_PLL_TEST_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_PLL_TEST_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_PLL_TEST_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_PLL_TEST_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_PLL_TEST_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PLL_TEST_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_GP1_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00054000)
#define HWIO_GCC_GP1_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00054000)
#define HWIO_GCC_GP1_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00054000)
#define HWIO_GCC_GP1_CBCR_RMSK                                                                         0x81c00005
#define HWIO_GCC_GP1_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_GP1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GP1_CBCR_ADDR, HWIO_GCC_GP1_CBCR_RMSK)
#define HWIO_GCC_GP1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_CBCR_ADDR, m)
#define HWIO_GCC_GP1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GP1_CBCR_ADDR,v)
#define HWIO_GCC_GP1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_CBCR_ADDR,m,v,HWIO_GCC_GP1_CBCR_IN)
#define HWIO_GCC_GP1_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_GP1_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_GP1_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_GP1_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_GP1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_GP1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_GP1_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_GP1_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_GP1_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_GP1_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_GP1_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_GP1_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_GP1_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_GP1_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_GP1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP1_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00054004)
#define HWIO_GCC_GP1_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00054004)
#define HWIO_GCC_GP1_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00054004)
#define HWIO_GCC_GP1_CMD_RCGR_RMSK                                                                     0x800000f3
#define HWIO_GCC_GP1_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP1_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP1_CMD_RCGR_ADDR, HWIO_GCC_GP1_CMD_RCGR_RMSK)
#define HWIO_GCC_GP1_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_CMD_RCGR_ADDR, m)
#define HWIO_GCC_GP1_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP1_CMD_RCGR_ADDR,v)
#define HWIO_GCC_GP1_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_CMD_RCGR_ADDR,m,v,HWIO_GCC_GP1_CMD_RCGR_IN)
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_D_BMSK                                                                   0x80
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_D_SHFT                                                                    0x7
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_N_BMSK                                                                   0x40
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_N_SHFT                                                                    0x6
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_M_BMSK                                                                   0x20
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_M_SHFT                                                                    0x5
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_GP1_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_GP1_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_GP1_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_GP1_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_GP1_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP1_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP1_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00054008)
#define HWIO_GCC_GP1_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00054008)
#define HWIO_GCC_GP1_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00054008)
#define HWIO_GCC_GP1_CFG_RCGR_RMSK                                                                       0x10371f
#define HWIO_GCC_GP1_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP1_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP1_CFG_RCGR_ADDR, HWIO_GCC_GP1_CFG_RCGR_RMSK)
#define HWIO_GCC_GP1_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_CFG_RCGR_ADDR, m)
#define HWIO_GCC_GP1_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP1_CFG_RCGR_ADDR,v)
#define HWIO_GCC_GP1_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_CFG_RCGR_ADDR,m,v,HWIO_GCC_GP1_CFG_RCGR_IN)
#define HWIO_GCC_GP1_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_GP1_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_GP1_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_GP1_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_GP1_CFG_RCGR_MODE_BMSK                                                                    0x3000
#define HWIO_GCC_GP1_CFG_RCGR_MODE_SHFT                                                                       0xc
#define HWIO_GCC_GP1_CFG_RCGR_MODE_BYPASS_FVAL                                                                0x0
#define HWIO_GCC_GP1_CFG_RCGR_MODE_SWALLOW_FVAL                                                               0x1
#define HWIO_GCC_GP1_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                             0x2
#define HWIO_GCC_GP1_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                           0x3
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_GP1_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_GP1_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_GP1_M_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005400c)
#define HWIO_GCC_GP1_M_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005400c)
#define HWIO_GCC_GP1_M_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005400c)
#define HWIO_GCC_GP1_M_RMSK                                                                                0xffff
#define HWIO_GCC_GP1_M_ATTR                                                                                   0x3
#define HWIO_GCC_GP1_M_IN          \
        in_dword_masked(HWIO_GCC_GP1_M_ADDR, HWIO_GCC_GP1_M_RMSK)
#define HWIO_GCC_GP1_M_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_M_ADDR, m)
#define HWIO_GCC_GP1_M_OUT(v)      \
        out_dword(HWIO_GCC_GP1_M_ADDR,v)
#define HWIO_GCC_GP1_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_M_ADDR,m,v,HWIO_GCC_GP1_M_IN)
#define HWIO_GCC_GP1_M_M_BMSK                                                                              0xffff
#define HWIO_GCC_GP1_M_M_SHFT                                                                                 0x0

#define HWIO_GCC_GP1_N_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00054010)
#define HWIO_GCC_GP1_N_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00054010)
#define HWIO_GCC_GP1_N_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00054010)
#define HWIO_GCC_GP1_N_RMSK                                                                                0xffff
#define HWIO_GCC_GP1_N_ATTR                                                                                   0x3
#define HWIO_GCC_GP1_N_IN          \
        in_dword_masked(HWIO_GCC_GP1_N_ADDR, HWIO_GCC_GP1_N_RMSK)
#define HWIO_GCC_GP1_N_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_N_ADDR, m)
#define HWIO_GCC_GP1_N_OUT(v)      \
        out_dword(HWIO_GCC_GP1_N_ADDR,v)
#define HWIO_GCC_GP1_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_N_ADDR,m,v,HWIO_GCC_GP1_N_IN)
#define HWIO_GCC_GP1_N_NOT_N_MINUS_M_BMSK                                                                  0xffff
#define HWIO_GCC_GP1_N_NOT_N_MINUS_M_SHFT                                                                     0x0

#define HWIO_GCC_GP1_D_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00054014)
#define HWIO_GCC_GP1_D_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00054014)
#define HWIO_GCC_GP1_D_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00054014)
#define HWIO_GCC_GP1_D_RMSK                                                                                0xffff
#define HWIO_GCC_GP1_D_ATTR                                                                                   0x3
#define HWIO_GCC_GP1_D_IN          \
        in_dword_masked(HWIO_GCC_GP1_D_ADDR, HWIO_GCC_GP1_D_RMSK)
#define HWIO_GCC_GP1_D_INM(m)      \
        in_dword_masked(HWIO_GCC_GP1_D_ADDR, m)
#define HWIO_GCC_GP1_D_OUT(v)      \
        out_dword(HWIO_GCC_GP1_D_ADDR,v)
#define HWIO_GCC_GP1_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP1_D_ADDR,m,v,HWIO_GCC_GP1_D_IN)
#define HWIO_GCC_GP1_D_NOT_2D_BMSK                                                                         0xffff
#define HWIO_GCC_GP1_D_NOT_2D_SHFT                                                                            0x0

#define HWIO_GCC_GP2_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00055000)
#define HWIO_GCC_GP2_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00055000)
#define HWIO_GCC_GP2_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00055000)
#define HWIO_GCC_GP2_CBCR_RMSK                                                                         0x81c00005
#define HWIO_GCC_GP2_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_GP2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GP2_CBCR_ADDR, HWIO_GCC_GP2_CBCR_RMSK)
#define HWIO_GCC_GP2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_CBCR_ADDR, m)
#define HWIO_GCC_GP2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GP2_CBCR_ADDR,v)
#define HWIO_GCC_GP2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_CBCR_ADDR,m,v,HWIO_GCC_GP2_CBCR_IN)
#define HWIO_GCC_GP2_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_GP2_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_GP2_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_GP2_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_GP2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_GP2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_GP2_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_GP2_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_GP2_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_GP2_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_GP2_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_GP2_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_GP2_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_GP2_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_GP2_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP2_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP2_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00055004)
#define HWIO_GCC_GP2_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00055004)
#define HWIO_GCC_GP2_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00055004)
#define HWIO_GCC_GP2_CMD_RCGR_RMSK                                                                     0x800000f3
#define HWIO_GCC_GP2_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP2_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP2_CMD_RCGR_ADDR, HWIO_GCC_GP2_CMD_RCGR_RMSK)
#define HWIO_GCC_GP2_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_CMD_RCGR_ADDR, m)
#define HWIO_GCC_GP2_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP2_CMD_RCGR_ADDR,v)
#define HWIO_GCC_GP2_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_CMD_RCGR_ADDR,m,v,HWIO_GCC_GP2_CMD_RCGR_IN)
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_D_BMSK                                                                   0x80
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_D_SHFT                                                                    0x7
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_N_BMSK                                                                   0x40
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_N_SHFT                                                                    0x6
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_M_BMSK                                                                   0x20
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_M_SHFT                                                                    0x5
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_GP2_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_GP2_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_GP2_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_GP2_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_GP2_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP2_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP2_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00055008)
#define HWIO_GCC_GP2_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00055008)
#define HWIO_GCC_GP2_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00055008)
#define HWIO_GCC_GP2_CFG_RCGR_RMSK                                                                       0x10371f
#define HWIO_GCC_GP2_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP2_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP2_CFG_RCGR_ADDR, HWIO_GCC_GP2_CFG_RCGR_RMSK)
#define HWIO_GCC_GP2_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_CFG_RCGR_ADDR, m)
#define HWIO_GCC_GP2_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP2_CFG_RCGR_ADDR,v)
#define HWIO_GCC_GP2_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_CFG_RCGR_ADDR,m,v,HWIO_GCC_GP2_CFG_RCGR_IN)
#define HWIO_GCC_GP2_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_GP2_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_GP2_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_GP2_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_GP2_CFG_RCGR_MODE_BMSK                                                                    0x3000
#define HWIO_GCC_GP2_CFG_RCGR_MODE_SHFT                                                                       0xc
#define HWIO_GCC_GP2_CFG_RCGR_MODE_BYPASS_FVAL                                                                0x0
#define HWIO_GCC_GP2_CFG_RCGR_MODE_SWALLOW_FVAL                                                               0x1
#define HWIO_GCC_GP2_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                             0x2
#define HWIO_GCC_GP2_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                           0x3
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_GP2_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_GP2_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_GP2_M_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005500c)
#define HWIO_GCC_GP2_M_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005500c)
#define HWIO_GCC_GP2_M_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005500c)
#define HWIO_GCC_GP2_M_RMSK                                                                                0xffff
#define HWIO_GCC_GP2_M_ATTR                                                                                   0x3
#define HWIO_GCC_GP2_M_IN          \
        in_dword_masked(HWIO_GCC_GP2_M_ADDR, HWIO_GCC_GP2_M_RMSK)
#define HWIO_GCC_GP2_M_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_M_ADDR, m)
#define HWIO_GCC_GP2_M_OUT(v)      \
        out_dword(HWIO_GCC_GP2_M_ADDR,v)
#define HWIO_GCC_GP2_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_M_ADDR,m,v,HWIO_GCC_GP2_M_IN)
#define HWIO_GCC_GP2_M_M_BMSK                                                                              0xffff
#define HWIO_GCC_GP2_M_M_SHFT                                                                                 0x0

#define HWIO_GCC_GP2_N_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00055010)
#define HWIO_GCC_GP2_N_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00055010)
#define HWIO_GCC_GP2_N_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00055010)
#define HWIO_GCC_GP2_N_RMSK                                                                                0xffff
#define HWIO_GCC_GP2_N_ATTR                                                                                   0x3
#define HWIO_GCC_GP2_N_IN          \
        in_dword_masked(HWIO_GCC_GP2_N_ADDR, HWIO_GCC_GP2_N_RMSK)
#define HWIO_GCC_GP2_N_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_N_ADDR, m)
#define HWIO_GCC_GP2_N_OUT(v)      \
        out_dword(HWIO_GCC_GP2_N_ADDR,v)
#define HWIO_GCC_GP2_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_N_ADDR,m,v,HWIO_GCC_GP2_N_IN)
#define HWIO_GCC_GP2_N_NOT_N_MINUS_M_BMSK                                                                  0xffff
#define HWIO_GCC_GP2_N_NOT_N_MINUS_M_SHFT                                                                     0x0

#define HWIO_GCC_GP2_D_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00055014)
#define HWIO_GCC_GP2_D_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00055014)
#define HWIO_GCC_GP2_D_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00055014)
#define HWIO_GCC_GP2_D_RMSK                                                                                0xffff
#define HWIO_GCC_GP2_D_ATTR                                                                                   0x3
#define HWIO_GCC_GP2_D_IN          \
        in_dword_masked(HWIO_GCC_GP2_D_ADDR, HWIO_GCC_GP2_D_RMSK)
#define HWIO_GCC_GP2_D_INM(m)      \
        in_dword_masked(HWIO_GCC_GP2_D_ADDR, m)
#define HWIO_GCC_GP2_D_OUT(v)      \
        out_dword(HWIO_GCC_GP2_D_ADDR,v)
#define HWIO_GCC_GP2_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP2_D_ADDR,m,v,HWIO_GCC_GP2_D_IN)
#define HWIO_GCC_GP2_D_NOT_2D_BMSK                                                                         0xffff
#define HWIO_GCC_GP2_D_NOT_2D_SHFT                                                                            0x0

#define HWIO_GCC_GP3_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00056000)
#define HWIO_GCC_GP3_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00056000)
#define HWIO_GCC_GP3_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00056000)
#define HWIO_GCC_GP3_CBCR_RMSK                                                                         0x81c00005
#define HWIO_GCC_GP3_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_GP3_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GP3_CBCR_ADDR, HWIO_GCC_GP3_CBCR_RMSK)
#define HWIO_GCC_GP3_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_CBCR_ADDR, m)
#define HWIO_GCC_GP3_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GP3_CBCR_ADDR,v)
#define HWIO_GCC_GP3_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_CBCR_ADDR,m,v,HWIO_GCC_GP3_CBCR_IN)
#define HWIO_GCC_GP3_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_GP3_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_GP3_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_GP3_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_GP3_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_GP3_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_GP3_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_GP3_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_GP3_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_GP3_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_GP3_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_GP3_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_GP3_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_GP3_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_GP3_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP3_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP3_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00056004)
#define HWIO_GCC_GP3_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00056004)
#define HWIO_GCC_GP3_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00056004)
#define HWIO_GCC_GP3_CMD_RCGR_RMSK                                                                     0x800000f3
#define HWIO_GCC_GP3_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP3_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP3_CMD_RCGR_ADDR, HWIO_GCC_GP3_CMD_RCGR_RMSK)
#define HWIO_GCC_GP3_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_CMD_RCGR_ADDR, m)
#define HWIO_GCC_GP3_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP3_CMD_RCGR_ADDR,v)
#define HWIO_GCC_GP3_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_CMD_RCGR_ADDR,m,v,HWIO_GCC_GP3_CMD_RCGR_IN)
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_D_BMSK                                                                   0x80
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_D_SHFT                                                                    0x7
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_N_BMSK                                                                   0x40
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_N_SHFT                                                                    0x6
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_M_BMSK                                                                   0x20
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_M_SHFT                                                                    0x5
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_GP3_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_GP3_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_GP3_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_GP3_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_GP3_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GP3_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GP3_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00056008)
#define HWIO_GCC_GP3_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00056008)
#define HWIO_GCC_GP3_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00056008)
#define HWIO_GCC_GP3_CFG_RCGR_RMSK                                                                       0x10371f
#define HWIO_GCC_GP3_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GP3_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GP3_CFG_RCGR_ADDR, HWIO_GCC_GP3_CFG_RCGR_RMSK)
#define HWIO_GCC_GP3_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_CFG_RCGR_ADDR, m)
#define HWIO_GCC_GP3_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GP3_CFG_RCGR_ADDR,v)
#define HWIO_GCC_GP3_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_CFG_RCGR_ADDR,m,v,HWIO_GCC_GP3_CFG_RCGR_IN)
#define HWIO_GCC_GP3_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_GP3_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_GP3_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_GP3_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_GP3_CFG_RCGR_MODE_BMSK                                                                    0x3000
#define HWIO_GCC_GP3_CFG_RCGR_MODE_SHFT                                                                       0xc
#define HWIO_GCC_GP3_CFG_RCGR_MODE_BYPASS_FVAL                                                                0x0
#define HWIO_GCC_GP3_CFG_RCGR_MODE_SWALLOW_FVAL                                                               0x1
#define HWIO_GCC_GP3_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                             0x2
#define HWIO_GCC_GP3_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                           0x3
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_GP3_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_GP3_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_GP3_M_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005600c)
#define HWIO_GCC_GP3_M_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005600c)
#define HWIO_GCC_GP3_M_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005600c)
#define HWIO_GCC_GP3_M_RMSK                                                                                0xffff
#define HWIO_GCC_GP3_M_ATTR                                                                                   0x3
#define HWIO_GCC_GP3_M_IN          \
        in_dword_masked(HWIO_GCC_GP3_M_ADDR, HWIO_GCC_GP3_M_RMSK)
#define HWIO_GCC_GP3_M_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_M_ADDR, m)
#define HWIO_GCC_GP3_M_OUT(v)      \
        out_dword(HWIO_GCC_GP3_M_ADDR,v)
#define HWIO_GCC_GP3_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_M_ADDR,m,v,HWIO_GCC_GP3_M_IN)
#define HWIO_GCC_GP3_M_M_BMSK                                                                              0xffff
#define HWIO_GCC_GP3_M_M_SHFT                                                                                 0x0

#define HWIO_GCC_GP3_N_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00056010)
#define HWIO_GCC_GP3_N_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00056010)
#define HWIO_GCC_GP3_N_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00056010)
#define HWIO_GCC_GP3_N_RMSK                                                                                0xffff
#define HWIO_GCC_GP3_N_ATTR                                                                                   0x3
#define HWIO_GCC_GP3_N_IN          \
        in_dword_masked(HWIO_GCC_GP3_N_ADDR, HWIO_GCC_GP3_N_RMSK)
#define HWIO_GCC_GP3_N_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_N_ADDR, m)
#define HWIO_GCC_GP3_N_OUT(v)      \
        out_dword(HWIO_GCC_GP3_N_ADDR,v)
#define HWIO_GCC_GP3_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_N_ADDR,m,v,HWIO_GCC_GP3_N_IN)
#define HWIO_GCC_GP3_N_NOT_N_MINUS_M_BMSK                                                                  0xffff
#define HWIO_GCC_GP3_N_NOT_N_MINUS_M_SHFT                                                                     0x0

#define HWIO_GCC_GP3_D_ADDR                                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00056014)
#define HWIO_GCC_GP3_D_PHYS                                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00056014)
#define HWIO_GCC_GP3_D_OFFS                                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00056014)
#define HWIO_GCC_GP3_D_RMSK                                                                                0xffff
#define HWIO_GCC_GP3_D_ATTR                                                                                   0x3
#define HWIO_GCC_GP3_D_IN          \
        in_dword_masked(HWIO_GCC_GP3_D_ADDR, HWIO_GCC_GP3_D_RMSK)
#define HWIO_GCC_GP3_D_INM(m)      \
        in_dword_masked(HWIO_GCC_GP3_D_ADDR, m)
#define HWIO_GCC_GP3_D_OUT(v)      \
        out_dword(HWIO_GCC_GP3_D_ADDR,v)
#define HWIO_GCC_GP3_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GP3_D_ADDR,m,v,HWIO_GCC_GP3_D_IN)
#define HWIO_GCC_GP3_D_NOT_2D_BMSK                                                                         0xffff
#define HWIO_GCC_GP3_D_NOT_2D_SHFT                                                                            0x0

#define HWIO_GCC_PCIE_0_BCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b000)
#define HWIO_GCC_PCIE_0_BCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b000)
#define HWIO_GCC_PCIE_0_BCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b000)
#define HWIO_GCC_PCIE_0_BCR_RMSK                                                                              0x1
#define HWIO_GCC_PCIE_0_BCR_ATTR                                                                              0x3
#define HWIO_GCC_PCIE_0_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_BCR_ADDR, HWIO_GCC_PCIE_0_BCR_RMSK)
#define HWIO_GCC_PCIE_0_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_BCR_ADDR, m)
#define HWIO_GCC_PCIE_0_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_BCR_ADDR,v)
#define HWIO_GCC_PCIE_0_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_BCR_ADDR,m,v,HWIO_GCC_PCIE_0_BCR_IN)
#define HWIO_GCC_PCIE_0_BCR_BLK_ARES_BMSK                                                                     0x1
#define HWIO_GCC_PCIE_0_BCR_BLK_ARES_SHFT                                                                     0x0
#define HWIO_GCC_PCIE_0_BCR_BLK_ARES_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_0_BCR_BLK_ARES_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_PCIE_0_GDSCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b004)
#define HWIO_GCC_PCIE_0_GDSCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b004)
#define HWIO_GCC_PCIE_0_GDSCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b004)
#define HWIO_GCC_PCIE_0_GDSCR_RMSK                                                                     0xf8ffffff
#define HWIO_GCC_PCIE_0_GDSCR_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_0_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_GDSCR_ADDR, HWIO_GCC_PCIE_0_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_GDSCR_IN)
#define HWIO_GCC_PCIE_0_GDSCR_PWR_ON_BMSK                                                              0x80000000
#define HWIO_GCC_PCIE_0_GDSCR_PWR_ON_SHFT                                                                    0x1f
#define HWIO_GCC_PCIE_0_GDSCR_GDSC_STATE_BMSK                                                          0x78000000
#define HWIO_GCC_PCIE_0_GDSCR_GDSC_STATE_SHFT                                                                0x1b
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_WAIT_BMSK                                                          0xf00000
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_WAIT_SHFT                                                              0x14
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_WAIT_BMSK                                                            0xf0000
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_WAIT_SHFT                                                               0x10
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DIS_WAIT_BMSK                                                            0xf000
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DIS_WAIT_SHFT                                                               0xc
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_FF_ENABLE_BMSK                                                         0x800
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_FF_ENABLE_SHFT                                                           0xb
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_PCIE_0_GDSCR_RESTORE_BMSK                                                                  0x400
#define HWIO_GCC_PCIE_0_GDSCR_RESTORE_SHFT                                                                    0xa
#define HWIO_GCC_PCIE_0_GDSCR_RESTORE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PCIE_0_GDSCR_RESTORE_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_PCIE_0_GDSCR_SAVE_BMSK                                                                     0x200
#define HWIO_GCC_PCIE_0_GDSCR_SAVE_SHFT                                                                       0x9
#define HWIO_GCC_PCIE_0_GDSCR_SAVE_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_PCIE_0_GDSCR_SAVE_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_BMSK                                                                   0x100
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_SHFT                                                                     0x8
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_0_GDSCR_RETAIN_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_BMSK                                                                   0x80
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_SHFT                                                                    0x7
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PCIE_0_GDSCR_EN_REST_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_BMSK                                                                    0x40
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_SHFT                                                                     0x6
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_0_GDSCR_EN_FEW_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_PCIE_0_GDSCR_CLAMP_IO_BMSK                                                                  0x20
#define HWIO_GCC_PCIE_0_GDSCR_CLAMP_IO_SHFT                                                                   0x5
#define HWIO_GCC_PCIE_0_GDSCR_CLAMP_IO_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PCIE_0_GDSCR_CLAMP_IO_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DISABLE_BMSK                                                               0x10
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DISABLE_SHFT                                                                0x4
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_0_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                 0x1
#define HWIO_GCC_PCIE_0_GDSCR_PD_ARES_BMSK                                                                    0x8
#define HWIO_GCC_PCIE_0_GDSCR_PD_ARES_SHFT                                                                    0x3
#define HWIO_GCC_PCIE_0_GDSCR_PD_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_PCIE_0_GDSCR_PD_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_PCIE_0_GDSCR_SW_OVERRIDE_BMSK                                                                0x4
#define HWIO_GCC_PCIE_0_GDSCR_SW_OVERRIDE_SHFT                                                                0x2
#define HWIO_GCC_PCIE_0_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_0_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_0_GDSCR_HW_CONTROL_BMSK                                                                 0x2
#define HWIO_GCC_PCIE_0_GDSCR_HW_CONTROL_SHFT                                                                 0x1
#define HWIO_GCC_PCIE_0_GDSCR_HW_CONTROL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_0_GDSCR_HW_CONTROL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_0_GDSCR_SW_COLLAPSE_BMSK                                                                0x1
#define HWIO_GCC_PCIE_0_GDSCR_SW_COLLAPSE_SHFT                                                                0x0
#define HWIO_GCC_PCIE_0_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_0_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_PCIE_0_CFG_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b008)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b008)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b008)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_RMSK                                                                  0x7ffffff
#define HWIO_GCC_PCIE_0_CFG_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG_GDSCR_ADDR, HWIO_GCC_PCIE_0_CFG_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_CFG_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_CFG_GDSCR_IN)
#define HWIO_GCC_PCIE_0_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                       0x4000000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x1a
#define HWIO_GCC_PCIE_0_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                               0x2000000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                    0x19
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                                0x1000000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                     0x18
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                         0xf00000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                             0x14
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                            0x80000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                               0x13
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                                0x40000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                   0x12
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                                0x20000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                   0x11
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                             0x10000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                                0x10
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                            0x8000
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                               0xf
#define HWIO_GCC_PCIE_0_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                           0x7800
#define HWIO_GCC_PCIE_0_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                              0xb
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                   0x400
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                     0xa
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                            0x200
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                              0x9
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                            0x100
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                              0x8
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                                0x80
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                 0x7
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                       0x60
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                        0x5
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                 0x10
#define HWIO_GCC_PCIE_0_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                  0x4
#define HWIO_GCC_PCIE_0_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                           0x8
#define HWIO_GCC_PCIE_0_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                           0x3
#define HWIO_GCC_PCIE_0_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                         0x4
#define HWIO_GCC_PCIE_0_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                         0x2
#define HWIO_GCC_PCIE_0_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                             0x2
#define HWIO_GCC_PCIE_0_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                             0x1
#define HWIO_GCC_PCIE_0_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                          0x1
#define HWIO_GCC_PCIE_0_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                          0x0

#define HWIO_GCC_PCIE_0_CFG2_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b00c)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b00c)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b00c)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_RMSK                                                                   0x7ffff
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG2_GDSCR_ADDR, HWIO_GCC_PCIE_0_CFG2_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_CFG2_GDSCR_IN)
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                       0x40000
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                          0x12
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                   0x20000
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                      0x11
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                 0x10000
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                    0x10
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                     0xf000
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                        0xc
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                              0xf00
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                                0x8
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                 0xf0
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                  0x4
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                   0xf
#define HWIO_GCC_PCIE_0_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                   0x0

#define HWIO_GCC_PCIE_0_CFG3_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b010)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b010)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b010)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_RMSK                                                                 0x7ffffff
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG3_GDSCR_ADDR, HWIO_GCC_PCIE_0_CFG3_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_CFG3_GDSCR_IN)
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                               0x4000000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                    0x1a
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                            0x2000000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                 0x19
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                       0x1e00000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                            0x15
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                        0x100000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                            0x14
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                               0x80000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                  0x13
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                   0x40000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                      0x12
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                                0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                    0x20000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                       0x11
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                                0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                 0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                         0x10000
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                            0x10
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                 0xff00
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                    0x8
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                  0xff
#define HWIO_GCC_PCIE_0_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                   0x0

#define HWIO_GCC_PCIE_0_CFG4_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b014)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b014)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b014)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_RMSK                                                                  0xffffff
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG4_GDSCR_ADDR, HWIO_GCC_PCIE_0_CFG4_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_CFG4_GDSCR_IN)
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                    0xf00000
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                        0x14
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                     0xf0000
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                        0x10
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                     0xf000
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                        0xc
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                    0xf00
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                      0x8
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                          0xf0
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                           0x4
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                          0xf
#define HWIO_GCC_PCIE_0_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                          0x0

#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b018)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b018)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b018)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_RMSK                                                               0x81d0000e
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_ATTR                                                                      0x3
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_PCIE_AHB_CBCR_ADDR, HWIO_GCC_QMIP_PCIE_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_PCIE_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_PCIE_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_PCIE_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_PCIE_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_OFF_BMSK                                                       0x80000000
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_OFF_SHFT                                                             0x1f
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                0x1000000
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                     0x18
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                              0x800000
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                  0x17
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_DIS_BMSK                                                         0x400000
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_DIS_SHFT                                                             0x16
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                             0x100000
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                 0x14
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_SW_ONLY_EN_BMSK                                                           0x8
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_SW_ONLY_EN_SHFT                                                           0x3
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_ARES_BMSK                                                             0x4
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_ARES_SHFT                                                             0x2
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                    0x0
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_CLK_ARES_RESET_FVAL                                                       0x1
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_HW_CTL_BMSK                                                               0x2
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_HW_CTL_SHFT                                                               0x1
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QMIP_PCIE_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b01c)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b01c)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b01c)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_RMSK                                                          0x81d00004
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ADDR, HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_PCIE_0_SLV_Q2A_AXI_CBCR_CLK_ARES_RESET_FVAL                                                  0x1

#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b020)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b020)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b020)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_RMSK                                                              0x81d0700e
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ADDR, HWIO_GCC_PCIE_0_SLV_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_SLV_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b024)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b024)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b024)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ADDR, HWIO_GCC_PCIE_0_SLV_AXI_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_SLV_AXI_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IN)
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_0_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b028)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b028)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b028)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ADDR, HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_PCIE_0_SLV_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b02c)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b02c)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b02c)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_RMSK                                                             0x81f0700e
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ADDR, HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                            0x200000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                0x15
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                               0x4000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                  0xe
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                             0x2000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                0xd
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                            0x1000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                               0xc
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b030)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b030)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b030)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_RMSK                                                             0xf1ffffe
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ADDR, HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IN)
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                   0xf000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                        0x18
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                              0x100000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                  0x14
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                      0xf0000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                         0x10
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                        0x8000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                           0xf
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                    0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                         0x4000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                            0xe
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                            0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                         0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                        0x2000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                           0xd
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                               0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                    0x1000
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                       0xc
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                              0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                 0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                 0x800
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                   0xb
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                               0x400
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                 0xa
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                        0x300
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                          0x8
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                 0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                 0x2
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                 0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                   0x80
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                    0x7
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_FORCE_CLK_ON_BMSK                                                     0x40
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_FORCE_CLK_ON_SHFT                                                      0x6
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                             0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                               0x20
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                0x5
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                       0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                  0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                   0x10
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                    0x4
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                          0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                             0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                  0x8
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                  0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                       0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                          0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                             0x4
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                             0x2
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL         0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                 0x2
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                 0x1
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_0_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                            0x1

#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b034)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b034)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b034)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_RMSK                                                        0xffffffff
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ADDR, HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                     0xfc000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                           0x1a
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                0x2000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                     0x19
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                  0x1000000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                       0x18
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                     0x800000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                         0x17
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                       0x400000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                           0x16
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                            0x3f0000
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                0x10
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                0xff00
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                   0x8
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                 0xff
#define HWIO_GCC_PCIE_0_MSTR_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                  0x0

#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b038)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b038)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b038)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_RMSK                                                              0x81d0000e
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ADDR, HWIO_GCC_PCIE_0_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IN)
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_0_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_0_AUX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b03c)
#define HWIO_GCC_PCIE_0_AUX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b03c)
#define HWIO_GCC_PCIE_0_AUX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b03c)
#define HWIO_GCC_PCIE_0_AUX_CBCR_RMSK                                                                  0x81c07004
#define HWIO_GCC_PCIE_0_AUX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_PCIE_0_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CBCR_ADDR, HWIO_GCC_PCIE_0_AUX_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_CBCR_IN)
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_PCIE_0_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_PCIE_0_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_PCIE_0_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_PCIE_0_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_PCIE_0_AUX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1

#define HWIO_GCC_PCIE_0_AUX_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b040)
#define HWIO_GCC_PCIE_0_AUX_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b040)
#define HWIO_GCC_PCIE_0_AUX_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b040)
#define HWIO_GCC_PCIE_0_AUX_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_PCIE_0_AUX_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_AUX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_SREGR_ADDR, HWIO_GCC_PCIE_0_AUX_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_AUX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_SREGR_IN)
#define HWIO_GCC_PCIE_0_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_PCIE_0_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_PCIE_0_AUX_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_PCIE_0_AUX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_PCIE_0_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_PCIE_0_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_PCIE_0_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_PCIE_0_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_PCIE_0_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_PCIE_0_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_PCIE_0_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_PCIE_0_AUX_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_PCIE_0_AUX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_PCIE_0_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b044)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b044)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b044)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ADDR, HWIO_GCC_PCIE_0_AUX_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_PCIE_0_AUX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_PCIE_0_PIPE_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b048)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b048)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b048)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_RMSK                                                                 0x81c07004
#define HWIO_GCC_PCIE_0_PIPE_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_PIPE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_CBCR_ADDR, HWIO_GCC_PCIE_0_PIPE_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PIPE_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PIPE_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_PIPE_CBCR_IN)
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_PCIE_0_PIPE_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_PCIE_0_PIPE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_PCIE_0_PIPE_CBCR_CLK_ARES_RESET_FVAL                                                         0x1

#define HWIO_GCC_PCIE_0_PIPE_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b04c)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b04c)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b04c)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_PCIE_0_PIPE_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_PIPE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_SREGR_ADDR, HWIO_GCC_PCIE_0_PIPE_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PIPE_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PIPE_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_PIPE_SREGR_IN)
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_PCIE_0_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_PCIE_0_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_PCIE_0_PIPE_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_PCIE_0_PIPE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_0_PIPE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b050)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b050)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b050)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ADDR, HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_PCIE_0_PIPE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b054)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b054)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b054)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_RMSK                                                            0x81c00004
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ADDR, HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IN)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CBCR_CLK_ARES_RESET_FVAL                                                    0x1

#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b058)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b058)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b058)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_RMSK                                                        0x80000013
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ADDR, HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_IN)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_OFF_BMSK                                               0x80000000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_OFF_SHFT                                                     0x1f
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                               0x10
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                0x4
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_EN_BMSK                                                       0x2
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_EN_SHFT                                                       0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_UPDATE_BMSK                                                        0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_UPDATE_SHFT                                                        0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_UPDATE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CMD_RCGR_UPDATE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b05c)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b05c)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b05c)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RMSK                                                          0x11071f
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ADDR, HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_IN)
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_BMSK                                           0x100000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_SHFT                                               0x14
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                        0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_BMSK                                           0x10000
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_SHFT                                              0x10
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                               0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                              0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_PCIE_0_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b074)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b074)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b074)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_RMSK                                                              0x800000f3
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ADDR, HWIO_GCC_PCIE_0_AUX_CMD_RCGR_RMSK)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_CMD_RCGR_IN)
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_D_BMSK                                                            0x80
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_D_SHFT                                                             0x7
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_N_BMSK                                                            0x40
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_N_SHFT                                                             0x6
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_M_BMSK                                                            0x20
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_M_SHFT                                                             0x5
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_0_AUX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b078)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b078)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b078)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_RMSK                                                                0x10371f
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ADDR, HWIO_GCC_PCIE_0_AUX_CFG_RCGR_RMSK)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_CFG_RCGR_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_CFG_RCGR_IN)
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_BMSK                                                             0x3000
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_SHFT                                                                0xc
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_SWALLOW_FVAL                                                        0x1
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                      0x2
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                    0x3
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_PCIE_0_AUX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_PCIE_0_AUX_M_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b07c)
#define HWIO_GCC_PCIE_0_AUX_M_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b07c)
#define HWIO_GCC_PCIE_0_AUX_M_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b07c)
#define HWIO_GCC_PCIE_0_AUX_M_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_0_AUX_M_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_0_AUX_M_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_M_ADDR, HWIO_GCC_PCIE_0_AUX_M_RMSK)
#define HWIO_GCC_PCIE_0_AUX_M_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_M_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_M_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_M_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_M_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_M_IN)
#define HWIO_GCC_PCIE_0_AUX_M_M_BMSK                                                                       0xffff
#define HWIO_GCC_PCIE_0_AUX_M_M_SHFT                                                                          0x0

#define HWIO_GCC_PCIE_0_AUX_N_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b080)
#define HWIO_GCC_PCIE_0_AUX_N_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b080)
#define HWIO_GCC_PCIE_0_AUX_N_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b080)
#define HWIO_GCC_PCIE_0_AUX_N_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_0_AUX_N_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_0_AUX_N_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_N_ADDR, HWIO_GCC_PCIE_0_AUX_N_RMSK)
#define HWIO_GCC_PCIE_0_AUX_N_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_N_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_N_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_N_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_N_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_N_IN)
#define HWIO_GCC_PCIE_0_AUX_N_NOT_N_MINUS_M_BMSK                                                           0xffff
#define HWIO_GCC_PCIE_0_AUX_N_NOT_N_MINUS_M_SHFT                                                              0x0

#define HWIO_GCC_PCIE_0_AUX_D_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b084)
#define HWIO_GCC_PCIE_0_AUX_D_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b084)
#define HWIO_GCC_PCIE_0_AUX_D_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b084)
#define HWIO_GCC_PCIE_0_AUX_D_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_0_AUX_D_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_0_AUX_D_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_D_ADDR, HWIO_GCC_PCIE_0_AUX_D_RMSK)
#define HWIO_GCC_PCIE_0_AUX_D_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_AUX_D_ADDR, m)
#define HWIO_GCC_PCIE_0_AUX_D_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_AUX_D_ADDR,v)
#define HWIO_GCC_PCIE_0_AUX_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_AUX_D_ADDR,m,v,HWIO_GCC_PCIE_0_AUX_D_IN)
#define HWIO_GCC_PCIE_0_AUX_D_NOT_2D_BMSK                                                                  0xffff
#define HWIO_GCC_PCIE_0_AUX_D_NOT_2D_SHFT                                                                     0x0

#define HWIO_GCC_PCIE_0_PHY_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c000)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c000)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c000)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RMSK                                                                 0xf8ffffff
#define HWIO_GCC_PCIE_0_PHY_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_PHY_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_GDSCR_ADDR, HWIO_GCC_PCIE_0_PHY_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_GDSCR_IN)
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PWR_ON_BMSK                                                          0x80000000
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PWR_ON_SHFT                                                                0x1f
#define HWIO_GCC_PCIE_0_PHY_GDSCR_GDSC_STATE_BMSK                                                      0x78000000
#define HWIO_GCC_PCIE_0_PHY_GDSCR_GDSC_STATE_SHFT                                                            0x1b
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_WAIT_BMSK                                                      0xf00000
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_WAIT_SHFT                                                          0x14
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_WAIT_BMSK                                                        0xf0000
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_WAIT_SHFT                                                           0x10
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DIS_WAIT_BMSK                                                        0xf000
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DIS_WAIT_SHFT                                                           0xc
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x800
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_FF_ENABLE_SHFT                                                       0xb
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RESTORE_BMSK                                                              0x400
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RESTORE_SHFT                                                                0xa
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RESTORE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RESTORE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SAVE_BMSK                                                                 0x200
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SAVE_SHFT                                                                   0x9
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SAVE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SAVE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_BMSK                                                               0x100
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_SHFT                                                                 0x8
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_RETAIN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_BMSK                                                               0x80
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_SHFT                                                                0x7
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_REST_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_BMSK                                                                0x40
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_SHFT                                                                 0x6
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_EN_FEW_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLAMP_IO_BMSK                                                              0x20
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLAMP_IO_SHFT                                                               0x5
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLAMP_IO_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLAMP_IO_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DISABLE_BMSK                                                           0x10
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DISABLE_SHFT                                                            0x4
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                            0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PD_ARES_BMSK                                                                0x8
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PD_ARES_SHFT                                                                0x3
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PD_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_PD_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_OVERRIDE_BMSK                                                            0x4
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_OVERRIDE_SHFT                                                            0x2
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_HW_CONTROL_BMSK                                                             0x2
#define HWIO_GCC_PCIE_0_PHY_GDSCR_HW_CONTROL_SHFT                                                             0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_HW_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_HW_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_COLLAPSE_BMSK                                                            0x1
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_COLLAPSE_SHFT                                                            0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_PCIE_0_PHY_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c004)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c004)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c004)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ADDR, HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_IN)
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                   0x4000000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x1a
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                           0x2000000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                0x19
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                            0x1000000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                 0x18
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                     0xf00000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                         0x14
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                        0x80000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                           0x13
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                            0x40000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                               0x12
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                            0x20000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                               0x11
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                         0x10000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                            0x10
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                        0x8000
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                           0xf
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                       0x7800
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                          0xb
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                               0x400
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                 0xa
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                        0x200
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                          0x9
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                        0x100
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                          0x8
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                            0x80
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                             0x7
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                   0x60
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                    0x5
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                             0x10
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                              0x4
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                       0x8
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                       0x3
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                     0x4
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                     0x2
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                         0x2
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                         0x1
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                      0x1
#define HWIO_GCC_PCIE_0_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                      0x0

#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c008)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c008)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c008)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_RMSK                                                               0x7ffff
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ADDR, HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_IN)
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                   0x40000
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                      0x12
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                               0x20000
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                  0x11
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                             0x10000
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                0x10
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                 0xf000
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                    0xc
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                          0xf00
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                            0x8
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                             0xf0
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                              0x4
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                               0xf
#define HWIO_GCC_PCIE_0_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                               0x0

#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c00c)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c00c)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c00c)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_RMSK                                                             0x7ffffff
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ADDR, HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_IN)
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                           0x4000000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                0x1a
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                        0x2000000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                             0x19
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                   0x1e00000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                        0x15
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                    0x100000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                        0x14
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                           0x80000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                              0x13
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                       0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                        0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                               0x40000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                  0x12
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                0x20000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                   0x11
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                     0x10000
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                        0x10
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                             0xff00
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                0x8
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                              0xff
#define HWIO_GCC_PCIE_0_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                               0x0

#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c010)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c010)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c010)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_RMSK                                                              0xffffff
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ADDR, HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_IN)
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                0xf00000
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                    0x14
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                 0xf0000
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                    0x10
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                 0xf000
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                    0xc
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                0xf00
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                  0x8
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                      0xf0
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                       0x4
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                      0xf
#define HWIO_GCC_PCIE_0_PHY_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                      0x0

#define HWIO_GCC_PCIE_1_BCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d000)
#define HWIO_GCC_PCIE_1_BCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d000)
#define HWIO_GCC_PCIE_1_BCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d000)
#define HWIO_GCC_PCIE_1_BCR_RMSK                                                                              0x1
#define HWIO_GCC_PCIE_1_BCR_ATTR                                                                              0x3
#define HWIO_GCC_PCIE_1_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_BCR_ADDR, HWIO_GCC_PCIE_1_BCR_RMSK)
#define HWIO_GCC_PCIE_1_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_BCR_ADDR, m)
#define HWIO_GCC_PCIE_1_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_BCR_ADDR,v)
#define HWIO_GCC_PCIE_1_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_BCR_ADDR,m,v,HWIO_GCC_PCIE_1_BCR_IN)
#define HWIO_GCC_PCIE_1_BCR_BLK_ARES_BMSK                                                                     0x1
#define HWIO_GCC_PCIE_1_BCR_BLK_ARES_SHFT                                                                     0x0
#define HWIO_GCC_PCIE_1_BCR_BLK_ARES_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_1_BCR_BLK_ARES_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_PCIE_1_GDSCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d004)
#define HWIO_GCC_PCIE_1_GDSCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d004)
#define HWIO_GCC_PCIE_1_GDSCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d004)
#define HWIO_GCC_PCIE_1_GDSCR_RMSK                                                                     0xf8ffffff
#define HWIO_GCC_PCIE_1_GDSCR_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_1_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_GDSCR_ADDR, HWIO_GCC_PCIE_1_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_GDSCR_IN)
#define HWIO_GCC_PCIE_1_GDSCR_PWR_ON_BMSK                                                              0x80000000
#define HWIO_GCC_PCIE_1_GDSCR_PWR_ON_SHFT                                                                    0x1f
#define HWIO_GCC_PCIE_1_GDSCR_GDSC_STATE_BMSK                                                          0x78000000
#define HWIO_GCC_PCIE_1_GDSCR_GDSC_STATE_SHFT                                                                0x1b
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_WAIT_BMSK                                                          0xf00000
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_WAIT_SHFT                                                              0x14
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_WAIT_BMSK                                                            0xf0000
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_WAIT_SHFT                                                               0x10
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DIS_WAIT_BMSK                                                            0xf000
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DIS_WAIT_SHFT                                                               0xc
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_FF_ENABLE_BMSK                                                         0x800
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_FF_ENABLE_SHFT                                                           0xb
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_PCIE_1_GDSCR_RESTORE_BMSK                                                                  0x400
#define HWIO_GCC_PCIE_1_GDSCR_RESTORE_SHFT                                                                    0xa
#define HWIO_GCC_PCIE_1_GDSCR_RESTORE_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PCIE_1_GDSCR_RESTORE_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_PCIE_1_GDSCR_SAVE_BMSK                                                                     0x200
#define HWIO_GCC_PCIE_1_GDSCR_SAVE_SHFT                                                                       0x9
#define HWIO_GCC_PCIE_1_GDSCR_SAVE_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_PCIE_1_GDSCR_SAVE_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_BMSK                                                                   0x100
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_SHFT                                                                     0x8
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_1_GDSCR_RETAIN_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_BMSK                                                                   0x80
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_SHFT                                                                    0x7
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_PCIE_1_GDSCR_EN_REST_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_BMSK                                                                    0x40
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_SHFT                                                                     0x6
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_PCIE_1_GDSCR_EN_FEW_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_PCIE_1_GDSCR_CLAMP_IO_BMSK                                                                  0x20
#define HWIO_GCC_PCIE_1_GDSCR_CLAMP_IO_SHFT                                                                   0x5
#define HWIO_GCC_PCIE_1_GDSCR_CLAMP_IO_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PCIE_1_GDSCR_CLAMP_IO_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DISABLE_BMSK                                                               0x10
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DISABLE_SHFT                                                                0x4
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_1_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                 0x1
#define HWIO_GCC_PCIE_1_GDSCR_PD_ARES_BMSK                                                                    0x8
#define HWIO_GCC_PCIE_1_GDSCR_PD_ARES_SHFT                                                                    0x3
#define HWIO_GCC_PCIE_1_GDSCR_PD_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_PCIE_1_GDSCR_PD_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_PCIE_1_GDSCR_SW_OVERRIDE_BMSK                                                                0x4
#define HWIO_GCC_PCIE_1_GDSCR_SW_OVERRIDE_SHFT                                                                0x2
#define HWIO_GCC_PCIE_1_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_1_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_1_GDSCR_HW_CONTROL_BMSK                                                                 0x2
#define HWIO_GCC_PCIE_1_GDSCR_HW_CONTROL_SHFT                                                                 0x1
#define HWIO_GCC_PCIE_1_GDSCR_HW_CONTROL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_1_GDSCR_HW_CONTROL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_1_GDSCR_SW_COLLAPSE_BMSK                                                                0x1
#define HWIO_GCC_PCIE_1_GDSCR_SW_COLLAPSE_SHFT                                                                0x0
#define HWIO_GCC_PCIE_1_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_1_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_PCIE_1_CFG_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d008)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d008)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d008)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_RMSK                                                                  0x7ffffff
#define HWIO_GCC_PCIE_1_CFG_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG_GDSCR_ADDR, HWIO_GCC_PCIE_1_CFG_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_CFG_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_CFG_GDSCR_IN)
#define HWIO_GCC_PCIE_1_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                       0x4000000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x1a
#define HWIO_GCC_PCIE_1_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                               0x2000000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                    0x19
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                                0x1000000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                     0x18
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                         0xf00000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                             0x14
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                            0x80000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                               0x13
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                                0x40000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                   0x12
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                                0x20000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                   0x11
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                             0x10000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                                0x10
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                            0x8000
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                               0xf
#define HWIO_GCC_PCIE_1_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                           0x7800
#define HWIO_GCC_PCIE_1_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                              0xb
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                   0x400
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                     0xa
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                            0x200
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                              0x9
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                            0x100
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                              0x8
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                                0x80
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                 0x7
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                       0x60
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                        0x5
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                 0x10
#define HWIO_GCC_PCIE_1_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                  0x4
#define HWIO_GCC_PCIE_1_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                           0x8
#define HWIO_GCC_PCIE_1_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                           0x3
#define HWIO_GCC_PCIE_1_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                         0x4
#define HWIO_GCC_PCIE_1_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                         0x2
#define HWIO_GCC_PCIE_1_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                             0x2
#define HWIO_GCC_PCIE_1_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                             0x1
#define HWIO_GCC_PCIE_1_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                          0x1
#define HWIO_GCC_PCIE_1_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                          0x0

#define HWIO_GCC_PCIE_1_CFG2_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d00c)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d00c)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d00c)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_RMSK                                                                   0x7ffff
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG2_GDSCR_ADDR, HWIO_GCC_PCIE_1_CFG2_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_CFG2_GDSCR_IN)
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                       0x40000
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                          0x12
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                   0x20000
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                      0x11
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                 0x10000
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                    0x10
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                     0xf000
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                        0xc
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                              0xf00
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                                0x8
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                 0xf0
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                  0x4
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                   0xf
#define HWIO_GCC_PCIE_1_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                   0x0

#define HWIO_GCC_PCIE_1_CFG3_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d010)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d010)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d010)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_RMSK                                                                 0x7ffffff
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG3_GDSCR_ADDR, HWIO_GCC_PCIE_1_CFG3_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_CFG3_GDSCR_IN)
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                               0x4000000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                    0x1a
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                            0x2000000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                 0x19
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                       0x1e00000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                            0x15
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                        0x100000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                            0x14
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                               0x80000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                  0x13
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                   0x40000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                      0x12
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                                0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                    0x20000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                       0x11
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                                0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                 0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                         0x10000
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                            0x10
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                 0xff00
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                    0x8
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                  0xff
#define HWIO_GCC_PCIE_1_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                   0x0

#define HWIO_GCC_PCIE_1_CFG4_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d014)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d014)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d014)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_RMSK                                                                  0xffffff
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG4_GDSCR_ADDR, HWIO_GCC_PCIE_1_CFG4_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_CFG4_GDSCR_IN)
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                    0xf00000
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                        0x14
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                     0xf0000
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                        0x10
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                     0xf000
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                        0xc
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                    0xf00
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                      0x8
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                          0xf0
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                           0x4
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                          0xf
#define HWIO_GCC_PCIE_1_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                          0x0

#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d018)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d018)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d018)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_RMSK                                                          0x81d00004
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ATTR                                                                 0x3
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ADDR, HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                           0x1000000
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                0x18
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                         0x800000
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                             0x17
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_DIS_BMSK                                                    0x400000
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_DIS_SHFT                                                        0x16
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                        0x100000
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                            0x14
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_ARES_BMSK                                                        0x4
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_ARES_SHFT                                                        0x2
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                               0x0
#define HWIO_GCC_PCIE_1_SLV_Q2A_AXI_CBCR_CLK_ARES_RESET_FVAL                                                  0x1

#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d01c)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d01c)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d01c)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_RMSK                                                              0x81d0700e
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ADDR, HWIO_GCC_PCIE_1_SLV_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_SLV_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d020)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d020)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d020)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ADDR, HWIO_GCC_PCIE_1_SLV_AXI_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_SLV_AXI_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IN)
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_1_SLV_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d024)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d024)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d024)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ADDR, HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_PCIE_1_SLV_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d028)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d028)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d028)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_RMSK                                                             0x81f0700e
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ADDR, HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IN)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                            0x200000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                0x15
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                               0x4000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                  0xe
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                             0x2000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                0xd
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                            0x1000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                               0xc
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d02c)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d02c)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d02c)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_RMSK                                                             0xf1ffffe
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ADDR, HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IN)
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                   0xf000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                        0x18
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                              0x100000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                  0x14
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                      0xf0000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                         0x10
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                        0x8000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                           0xf
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                    0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                         0x4000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                            0xe
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                            0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                         0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                        0x2000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                           0xd
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                               0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                    0x1000
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                       0xc
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                              0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                 0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                 0x800
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                   0xb
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                               0x400
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                 0xa
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                        0x300
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                          0x8
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                 0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                 0x2
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                 0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                   0x80
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                    0x7
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_FORCE_CLK_ON_BMSK                                                     0x40
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_FORCE_CLK_ON_SHFT                                                      0x6
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                             0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                               0x20
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                0x5
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                       0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                  0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                   0x10
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                    0x4
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                          0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                             0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                  0x8
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                  0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                       0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                          0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                             0x4
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                             0x2
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL         0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                 0x2
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                 0x1
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_1_MSTR_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                            0x1

#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d030)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d030)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d030)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_RMSK                                                        0xffffffff
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ADDR, HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                     0xfc000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                           0x1a
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                0x2000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                     0x19
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                  0x1000000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                       0x18
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                     0x800000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                         0x17
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                       0x400000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                           0x16
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                            0x3f0000
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                0x10
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                0xff00
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                   0x8
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                 0xff
#define HWIO_GCC_PCIE_1_MSTR_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                  0x0

#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d034)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d034)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d034)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_RMSK                                                              0x81d0000e
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ADDR, HWIO_GCC_PCIE_1_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IN)
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_1_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_1_AUX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d038)
#define HWIO_GCC_PCIE_1_AUX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d038)
#define HWIO_GCC_PCIE_1_AUX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d038)
#define HWIO_GCC_PCIE_1_AUX_CBCR_RMSK                                                                  0x81c07004
#define HWIO_GCC_PCIE_1_AUX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_PCIE_1_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CBCR_ADDR, HWIO_GCC_PCIE_1_AUX_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_CBCR_IN)
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_PCIE_1_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_PCIE_1_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_PCIE_1_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_PCIE_1_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                    0x4000
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                       0xe
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                  0x2000
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                     0xd
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                 0x1000
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                    0xc
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_PCIE_1_AUX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1

#define HWIO_GCC_PCIE_1_AUX_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d03c)
#define HWIO_GCC_PCIE_1_AUX_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d03c)
#define HWIO_GCC_PCIE_1_AUX_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d03c)
#define HWIO_GCC_PCIE_1_AUX_SREGR_RMSK                                                                  0xf1ffffe
#define HWIO_GCC_PCIE_1_AUX_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_AUX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_SREGR_ADDR, HWIO_GCC_PCIE_1_AUX_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_AUX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_SREGR_IN)
#define HWIO_GCC_PCIE_1_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                        0xf000000
#define HWIO_GCC_PCIE_1_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                             0x18
#define HWIO_GCC_PCIE_1_AUX_SREGR_PWR_FSM_CLK_SEL_BMSK                                                   0x100000
#define HWIO_GCC_PCIE_1_AUX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                       0x14
#define HWIO_GCC_PCIE_1_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                           0xf0000
#define HWIO_GCC_PCIE_1_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                              0x10
#define HWIO_GCC_PCIE_1_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                             0x8000
#define HWIO_GCC_PCIE_1_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                0xf
#define HWIO_GCC_PCIE_1_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                         0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                              0x4000
#define HWIO_GCC_PCIE_1_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                 0xe
#define HWIO_GCC_PCIE_1_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                              0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                             0x2000
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                0xd
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                    0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                       0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                         0x1000
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                            0xc
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CORE_ON_ACK_BMSK                                                      0x800
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CORE_ON_ACK_SHFT                                                        0xb
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                    0x400
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                      0xa
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                             0x300
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                               0x8
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                      0x2
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                      0x3
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_ENABLE_BMSK                                                        0x80
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_ENABLE_SHFT                                                         0x7
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_FORCE_CLK_ON_BMSK                                                          0x40
#define HWIO_GCC_PCIE_1_AUX_SREGR_FORCE_CLK_ON_SHFT                                                           0x6
#define HWIO_GCC_PCIE_1_AUX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                  0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                    0x20
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                     0x5
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                            0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                       0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SLP_STG_BMSK                                                        0x10
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SLP_STG_SHFT                                                         0x4
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                               0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                       0x8
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                       0x3
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                            0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                               0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                  0x4
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                  0x2
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL              0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                      0x2
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                      0x1
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                0x0
#define HWIO_GCC_PCIE_1_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                 0x1

#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d040)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d040)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d040)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_RMSK                                                             0xffffffff
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ADDR, HWIO_GCC_PCIE_1_AUX_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                          0xfc000000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                0x1a
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                     0x2000000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                          0x19
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                       0x1000000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                            0x18
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                          0x800000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                              0x17
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                            0x400000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                0x16
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                 0x3f0000
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                     0x10
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_SLEEP_TIMER_BMSK                                                     0xff00
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_SLEEP_TIMER_SHFT                                                        0x8
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                      0xff
#define HWIO_GCC_PCIE_1_AUX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                       0x0

#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d044)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d044)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d044)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_RMSK                                                              0x81c07004
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ADDR, HWIO_GCC_PCIE_1_PHY_AUX_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_AUX_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IN)
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_CORE_ON_BMSK                                                0x4000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_CORE_ON_SHFT                                                   0xe
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                              0x2000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                 0xd
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                             0x1000
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                0xc
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_CBCR_CLK_ARES_RESET_FVAL                                                      0x1

#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d048)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d048)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d048)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_RMSK                                                              0xf1ffffe
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ADDR, HWIO_GCC_PCIE_1_PHY_AUX_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_AUX_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IN)
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                    0xf000000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                         0x18
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PWR_FSM_CLK_SEL_BMSK                                               0x100000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PWR_FSM_CLK_SEL_SHFT                                                   0x14
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                       0xf0000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                          0x10
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                         0x8000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                            0xf
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                     0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                          0x4000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                             0xe
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                             0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                          0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                         0x2000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                            0xd
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                     0x1000
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                        0xc
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                               0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CORE_ON_ACK_BMSK                                                  0x800
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CORE_ON_ACK_SHFT                                                    0xb
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                0x400
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                  0xa
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                         0x300
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                           0x8
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                  0x2
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                  0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_ENABLE_BMSK                                                    0x80
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_ENABLE_SHFT                                                     0x7
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_FORCE_CLK_ON_BMSK                                                      0x40
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_FORCE_CLK_ON_SHFT                                                       0x6
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                              0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                0x20
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                 0x5
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                        0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                   0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SLP_STG_BMSK                                                    0x10
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SLP_STG_SHFT                                                     0x4
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                           0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                              0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                   0x8
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                   0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                        0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                           0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                              0x4
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                              0x2
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL          0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                  0x2
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                  0x1
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_1_PHY_AUX_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                             0x1

#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d04c)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d04c)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d04c)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_RMSK                                                         0xffffffff
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ATTR                                                                0x3
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ADDR, HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                      0xfc000000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                            0x1a
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                 0x2000000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                      0x19
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                   0x1000000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                        0x18
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                      0x800000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                          0x17
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                        0x400000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                            0x16
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CPH_TIMER_BMSK                                             0x3f0000
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                 0x10
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_SLEEP_TIMER_BMSK                                                 0xff00
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_SLEEP_TIMER_SHFT                                                    0x8
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_WAKEUP_TIMER_BMSK                                                  0xff
#define HWIO_GCC_PCIE_1_PHY_AUX_CFG_SREGR_WAKEUP_TIMER_SHFT                                                   0x0

#define HWIO_GCC_PCIE_1_PIPE_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d050)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d050)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d050)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_RMSK                                                                 0x81c07004
#define HWIO_GCC_PCIE_1_PIPE_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_PIPE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_CBCR_ADDR, HWIO_GCC_PCIE_1_PIPE_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PIPE_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PIPE_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_PIPE_CBCR_IN)
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_PCIE_1_PIPE_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_PCIE_1_PIPE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_PIPE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_PCIE_1_PIPE_CBCR_CLK_ARES_RESET_FVAL                                                         0x1

#define HWIO_GCC_PCIE_1_PIPE_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d054)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d054)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d054)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_PCIE_1_PIPE_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_PIPE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_SREGR_ADDR, HWIO_GCC_PCIE_1_PIPE_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PIPE_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PIPE_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_PIPE_SREGR_IN)
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_PCIE_1_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_PCIE_1_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_PCIE_1_PIPE_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_PCIE_1_PIPE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_1_PIPE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d058)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d058)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d058)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ADDR, HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_RMSK)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_ADDR,m,v,HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_IN)
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_PCIE_1_PIPE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d05c)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d05c)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d05c)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_RMSK                                                            0x81c00004
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ADDR, HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IN)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CBCR_CLK_ARES_RESET_FVAL                                                    0x1

#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d060)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d060)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d060)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_RMSK                                                        0x80000013
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ADDR, HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_IN)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_OFF_BMSK                                               0x80000000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_OFF_SHFT                                                     0x1f
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                               0x10
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                0x4
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_EN_BMSK                                                       0x2
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_EN_SHFT                                                       0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_UPDATE_BMSK                                                        0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_UPDATE_SHFT                                                        0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_UPDATE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CMD_RCGR_UPDATE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d064)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d064)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d064)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RMSK                                                          0x11071f
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ATTR                                                               0x3
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ADDR, HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_IN)
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_BMSK                                           0x100000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_SHFT                                               0x14
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                        0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                         0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_BMSK                                           0x10000
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_SHFT                                              0x10
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                               0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                              0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_PCIE_1_PHY_RCHNG_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d07c)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d07c)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d07c)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_RMSK                                                              0x800000f3
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ADDR, HWIO_GCC_PCIE_1_AUX_CMD_RCGR_RMSK)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_CMD_RCGR_IN)
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_D_BMSK                                                            0x80
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_D_SHFT                                                             0x7
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_N_BMSK                                                            0x40
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_N_SHFT                                                             0x6
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_M_BMSK                                                            0x20
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_M_SHFT                                                             0x5
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_PCIE_1_AUX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d080)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d080)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d080)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_RMSK                                                                0x10371f
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ADDR, HWIO_GCC_PCIE_1_AUX_CFG_RCGR_RMSK)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_CFG_RCGR_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_CFG_RCGR_IN)
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_BMSK                                                             0x3000
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_SHFT                                                                0xc
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_SWALLOW_FVAL                                                        0x1
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                      0x2
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                    0x3
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_PCIE_1_AUX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_PCIE_1_AUX_M_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d084)
#define HWIO_GCC_PCIE_1_AUX_M_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d084)
#define HWIO_GCC_PCIE_1_AUX_M_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d084)
#define HWIO_GCC_PCIE_1_AUX_M_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_1_AUX_M_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_1_AUX_M_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_M_ADDR, HWIO_GCC_PCIE_1_AUX_M_RMSK)
#define HWIO_GCC_PCIE_1_AUX_M_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_M_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_M_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_M_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_M_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_M_IN)
#define HWIO_GCC_PCIE_1_AUX_M_M_BMSK                                                                       0xffff
#define HWIO_GCC_PCIE_1_AUX_M_M_SHFT                                                                          0x0

#define HWIO_GCC_PCIE_1_AUX_N_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d088)
#define HWIO_GCC_PCIE_1_AUX_N_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d088)
#define HWIO_GCC_PCIE_1_AUX_N_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d088)
#define HWIO_GCC_PCIE_1_AUX_N_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_1_AUX_N_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_1_AUX_N_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_N_ADDR, HWIO_GCC_PCIE_1_AUX_N_RMSK)
#define HWIO_GCC_PCIE_1_AUX_N_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_N_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_N_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_N_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_N_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_N_IN)
#define HWIO_GCC_PCIE_1_AUX_N_NOT_N_MINUS_M_BMSK                                                           0xffff
#define HWIO_GCC_PCIE_1_AUX_N_NOT_N_MINUS_M_SHFT                                                              0x0

#define HWIO_GCC_PCIE_1_AUX_D_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d08c)
#define HWIO_GCC_PCIE_1_AUX_D_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d08c)
#define HWIO_GCC_PCIE_1_AUX_D_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d08c)
#define HWIO_GCC_PCIE_1_AUX_D_RMSK                                                                         0xffff
#define HWIO_GCC_PCIE_1_AUX_D_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_1_AUX_D_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_D_ADDR, HWIO_GCC_PCIE_1_AUX_D_RMSK)
#define HWIO_GCC_PCIE_1_AUX_D_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_AUX_D_ADDR, m)
#define HWIO_GCC_PCIE_1_AUX_D_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_AUX_D_ADDR,v)
#define HWIO_GCC_PCIE_1_AUX_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_AUX_D_ADDR,m,v,HWIO_GCC_PCIE_1_AUX_D_IN)
#define HWIO_GCC_PCIE_1_AUX_D_NOT_2D_BMSK                                                                  0xffff
#define HWIO_GCC_PCIE_1_AUX_D_NOT_2D_SHFT                                                                     0x0

#define HWIO_GCC_PCIE_1_PHY_GDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e000)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e000)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e000)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RMSK                                                                 0xf8ffffff
#define HWIO_GCC_PCIE_1_PHY_GDSCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_PHY_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_GDSCR_ADDR, HWIO_GCC_PCIE_1_PHY_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_GDSCR_IN)
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PWR_ON_BMSK                                                          0x80000000
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PWR_ON_SHFT                                                                0x1f
#define HWIO_GCC_PCIE_1_PHY_GDSCR_GDSC_STATE_BMSK                                                      0x78000000
#define HWIO_GCC_PCIE_1_PHY_GDSCR_GDSC_STATE_SHFT                                                            0x1b
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_WAIT_BMSK                                                      0xf00000
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_WAIT_SHFT                                                          0x14
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_WAIT_BMSK                                                        0xf0000
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_WAIT_SHFT                                                           0x10
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DIS_WAIT_BMSK                                                        0xf000
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DIS_WAIT_SHFT                                                           0xc
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x800
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_FF_ENABLE_SHFT                                                       0xb
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RESTORE_BMSK                                                              0x400
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RESTORE_SHFT                                                                0xa
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RESTORE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RESTORE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SAVE_BMSK                                                                 0x200
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SAVE_SHFT                                                                   0x9
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SAVE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SAVE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_BMSK                                                               0x100
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_SHFT                                                                 0x8
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_RETAIN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_BMSK                                                               0x80
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_SHFT                                                                0x7
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_REST_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_BMSK                                                                0x40
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_SHFT                                                                 0x6
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_EN_FEW_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLAMP_IO_BMSK                                                              0x20
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLAMP_IO_SHFT                                                               0x5
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLAMP_IO_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLAMP_IO_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DISABLE_BMSK                                                           0x10
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DISABLE_SHFT                                                            0x4
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                            0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                             0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PD_ARES_BMSK                                                                0x8
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PD_ARES_SHFT                                                                0x3
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PD_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_PD_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_OVERRIDE_BMSK                                                            0x4
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_OVERRIDE_SHFT                                                            0x2
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_HW_CONTROL_BMSK                                                             0x2
#define HWIO_GCC_PCIE_1_PHY_GDSCR_HW_CONTROL_SHFT                                                             0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_HW_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_HW_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_COLLAPSE_BMSK                                                            0x1
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_COLLAPSE_SHFT                                                            0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_PCIE_1_PHY_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e004)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e004)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e004)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_RMSK                                                              0x7ffffff
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ADDR, HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_IN)
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                   0x4000000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x1a
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                           0x2000000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                0x19
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                            0x1000000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                 0x18
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                     0xf00000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                         0x14
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                        0x80000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                           0x13
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                            0x40000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                               0x12
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                            0x20000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                               0x11
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                         0x10000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                            0x10
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                        0x8000
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                           0xf
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                       0x7800
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                          0xb
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                               0x400
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                 0xa
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                        0x200
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                          0x9
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                        0x100
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                          0x8
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                            0x80
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                             0x7
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                   0x60
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                    0x5
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                             0x10
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                              0x4
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                       0x8
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                       0x3
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                     0x4
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                     0x2
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                         0x2
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                         0x1
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                      0x1
#define HWIO_GCC_PCIE_1_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                      0x0

#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e008)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e008)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e008)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_RMSK                                                               0x7ffff
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ADDR, HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_IN)
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                   0x40000
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                      0x12
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                               0x20000
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                  0x11
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                             0x10000
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                0x10
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                 0xf000
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                    0xc
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                          0xf00
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                            0x8
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                             0xf0
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                              0x4
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                               0xf
#define HWIO_GCC_PCIE_1_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                               0x0

#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e00c)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e00c)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e00c)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_RMSK                                                             0x7ffffff
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ADDR, HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_IN)
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                           0x4000000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                0x1a
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                        0x2000000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                             0x19
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                   0x1e00000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                        0x15
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                    0x100000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                        0x14
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                           0x80000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                              0x13
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                       0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                        0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                               0x40000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                  0x12
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                0x20000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                   0x11
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                             0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                     0x10000
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                        0x10
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                             0xff00
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                0x8
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                              0xff
#define HWIO_GCC_PCIE_1_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                               0x0

#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e010)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e010)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e010)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_RMSK                                                              0xffffff
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ADDR, HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_IN)
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                0xf00000
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                    0x14
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                 0xf0000
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                    0x10
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                 0xf000
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                    0xc
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                0xf00
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                  0x8
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                      0xf0
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                       0x4
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                      0xf
#define HWIO_GCC_PCIE_1_PHY_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                      0x0

#define HWIO_GCC_PCIE_PHY_BCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005f000)
#define HWIO_GCC_PCIE_PHY_BCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005f000)
#define HWIO_GCC_PCIE_PHY_BCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005f000)
#define HWIO_GCC_PCIE_PHY_BCR_RMSK                                                                            0x1
#define HWIO_GCC_PCIE_PHY_BCR_ATTR                                                                            0x3
#define HWIO_GCC_PCIE_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_PHY_BCR_ADDR, HWIO_GCC_PCIE_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_PHY_BCR_IN)
#define HWIO_GCC_PCIE_PHY_BCR_BLK_ARES_BMSK                                                                   0x1
#define HWIO_GCC_PCIE_PHY_BCR_BLK_ARES_SHFT                                                                   0x0
#define HWIO_GCC_PCIE_PHY_BCR_BLK_ARES_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_PCIE_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_UFS_MEM_PHY_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008e000)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008e000)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008e000)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RMSK                                                                0xf8ffffff
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_GDSCR_ADDR, HWIO_GCC_UFS_MEM_PHY_GDSCR_RMSK)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_MEM_PHY_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_MEM_PHY_GDSCR_ADDR,m,v,HWIO_GCC_UFS_MEM_PHY_GDSCR_IN)
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PWR_ON_BMSK                                                         0x80000000
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PWR_ON_SHFT                                                               0x1f
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_GDSC_STATE_BMSK                                                     0x78000000
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_GDSC_STATE_SHFT                                                           0x1b
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_WAIT_BMSK                                                     0xf00000
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_WAIT_SHFT                                                         0x14
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_WAIT_BMSK                                                       0xf0000
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_WAIT_SHFT                                                          0x10
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DIS_WAIT_BMSK                                                       0xf000
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DIS_WAIT_SHFT                                                          0xc
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_FF_ENABLE_BMSK                                                    0x800
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_FF_ENABLE_SHFT                                                      0xb
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RESTORE_BMSK                                                             0x400
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RESTORE_SHFT                                                               0xa
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RESTORE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RESTORE_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SAVE_BMSK                                                                0x200
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SAVE_SHFT                                                                  0x9
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SAVE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SAVE_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_BMSK                                                              0x100
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_SHFT                                                                0x8
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_RETAIN_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_BMSK                                                              0x80
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_SHFT                                                               0x7
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_REST_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_BMSK                                                               0x40
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_SHFT                                                                0x6
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_EN_FEW_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLAMP_IO_BMSK                                                             0x20
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLAMP_IO_SHFT                                                              0x5
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLAMP_IO_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLAMP_IO_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DISABLE_BMSK                                                          0x10
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DISABLE_SHFT                                                           0x4
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                           0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                            0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PD_ARES_BMSK                                                               0x8
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PD_ARES_SHFT                                                               0x3
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PD_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_PD_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_OVERRIDE_BMSK                                                           0x4
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_OVERRIDE_SHFT                                                           0x2
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_HW_CONTROL_BMSK                                                            0x2
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_HW_CONTROL_SHFT                                                            0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_HW_CONTROL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_HW_CONTROL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_COLLAPSE_BMSK                                                           0x1
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_COLLAPSE_SHFT                                                           0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_UFS_MEM_PHY_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008e004)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008e004)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008e004)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_RMSK                                                             0x7ffffff
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ATTR                                                                   0x3
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ADDR, HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_RMSK)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_ADDR,m,v,HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_IN)
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                  0x4000000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                       0x1a
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                          0x2000000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                               0x19
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                           0x1000000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                0x18
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                    0xf00000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                        0x14
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                       0x80000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                          0x13
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                           0x40000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                              0x12
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                           0x20000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                              0x11
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                        0x10000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                           0x10
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                       0x8000
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                          0xf
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                      0x7800
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                         0xb
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                              0x400
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                0xa
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                       0x200
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                         0x9
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                       0x100
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                         0x8
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                           0x80
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                            0x7
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                  0x60
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                   0x5
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                            0x10
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                             0x4
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                      0x8
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                      0x3
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                    0x4
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                    0x2
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                        0x2
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                        0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                     0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                     0x0

#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008e008)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008e008)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008e008)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_RMSK                                                              0x7ffff
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ATTR                                                                  0x3
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ADDR, HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_RMSK)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_IN)
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                  0x40000
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                     0x12
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                              0x20000
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                 0x11
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                            0x10000
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                               0x10
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                0xf000
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                   0xc
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                         0xf00
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                           0x8
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                            0xf0
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                             0x4
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                              0xf
#define HWIO_GCC_UFS_MEM_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                              0x0

#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008e00c)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008e00c)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008e00c)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_RMSK                                                            0x7ffffff
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ATTR                                                                  0x3
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ADDR, HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_RMSK)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_IN)
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                          0x4000000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                               0x1a
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                       0x2000000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                            0x19
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                  0x1e00000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                       0x15
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                   0x100000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                       0x14
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                 0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                          0x80000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                             0x13
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                      0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                       0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                              0x40000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                 0x12
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                          0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                           0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                               0x20000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                  0x11
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                           0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                            0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                    0x10000
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                       0x10
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                0x0
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                            0xff00
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                               0x8
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                             0xff
#define HWIO_GCC_UFS_MEM_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                              0x0

#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008e010)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008e010)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008e010)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_RMSK                                                             0xffffff
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ATTR                                                                  0x3
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ADDR, HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_RMSK)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_IN)
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                               0xf00000
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                   0x14
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                0xf0000
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                   0x10
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                0xf000
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                   0xc
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                               0xf00
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                 0x8
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                     0xf0
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                      0x4
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                     0xf
#define HWIO_GCC_UFS_MEM_PHY_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                     0x0

#define HWIO_GCC_UFS_PHY_BCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00067000)
#define HWIO_GCC_UFS_PHY_BCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067000)
#define HWIO_GCC_UFS_PHY_BCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067000)
#define HWIO_GCC_UFS_PHY_BCR_RMSK                                                                             0x1
#define HWIO_GCC_UFS_PHY_BCR_ATTR                                                                             0x3
#define HWIO_GCC_UFS_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_BCR_ADDR, HWIO_GCC_UFS_PHY_BCR_RMSK)
#define HWIO_GCC_UFS_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_BCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_BCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_BCR_ADDR,m,v,HWIO_GCC_UFS_PHY_BCR_IN)
#define HWIO_GCC_UFS_PHY_BCR_BLK_ARES_BMSK                                                                    0x1
#define HWIO_GCC_UFS_PHY_BCR_BLK_ARES_SHFT                                                                    0x0
#define HWIO_GCC_UFS_PHY_BCR_BLK_ARES_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_UFS_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                             0x1

#define HWIO_GCC_UFS_PHY_GDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00067004)
#define HWIO_GCC_UFS_PHY_GDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067004)
#define HWIO_GCC_UFS_PHY_GDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067004)
#define HWIO_GCC_UFS_PHY_GDSCR_RMSK                                                                    0xf8ffffff
#define HWIO_GCC_UFS_PHY_GDSCR_ATTR                                                                           0x3
#define HWIO_GCC_UFS_PHY_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_GDSCR_ADDR, HWIO_GCC_UFS_PHY_GDSCR_RMSK)
#define HWIO_GCC_UFS_PHY_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_GDSCR_ADDR,m,v,HWIO_GCC_UFS_PHY_GDSCR_IN)
#define HWIO_GCC_UFS_PHY_GDSCR_PWR_ON_BMSK                                                             0x80000000
#define HWIO_GCC_UFS_PHY_GDSCR_PWR_ON_SHFT                                                                   0x1f
#define HWIO_GCC_UFS_PHY_GDSCR_GDSC_STATE_BMSK                                                         0x78000000
#define HWIO_GCC_UFS_PHY_GDSCR_GDSC_STATE_SHFT                                                               0x1b
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_WAIT_BMSK                                                         0xf00000
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_WAIT_SHFT                                                             0x14
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_WAIT_BMSK                                                           0xf0000
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_WAIT_SHFT                                                              0x10
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DIS_WAIT_BMSK                                                           0xf000
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DIS_WAIT_SHFT                                                              0xc
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_FF_ENABLE_BMSK                                                        0x800
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_FF_ENABLE_SHFT                                                          0xb
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_UFS_PHY_GDSCR_RESTORE_BMSK                                                                 0x400
#define HWIO_GCC_UFS_PHY_GDSCR_RESTORE_SHFT                                                                   0xa
#define HWIO_GCC_UFS_PHY_GDSCR_RESTORE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_UFS_PHY_GDSCR_RESTORE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_UFS_PHY_GDSCR_SAVE_BMSK                                                                    0x200
#define HWIO_GCC_UFS_PHY_GDSCR_SAVE_SHFT                                                                      0x9
#define HWIO_GCC_UFS_PHY_GDSCR_SAVE_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_UFS_PHY_GDSCR_SAVE_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_BMSK                                                                  0x100
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_SHFT                                                                    0x8
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_UFS_PHY_GDSCR_RETAIN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_BMSK                                                                  0x80
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_SHFT                                                                   0x7
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_UFS_PHY_GDSCR_EN_REST_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_BMSK                                                                   0x40
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_SHFT                                                                    0x6
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_UFS_PHY_GDSCR_EN_FEW_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_UFS_PHY_GDSCR_CLAMP_IO_BMSK                                                                 0x20
#define HWIO_GCC_UFS_PHY_GDSCR_CLAMP_IO_SHFT                                                                  0x5
#define HWIO_GCC_UFS_PHY_GDSCR_CLAMP_IO_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_UFS_PHY_GDSCR_CLAMP_IO_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DISABLE_BMSK                                                              0x10
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DISABLE_SHFT                                                               0x4
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                               0x0
#define HWIO_GCC_UFS_PHY_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                0x1
#define HWIO_GCC_UFS_PHY_GDSCR_PD_ARES_BMSK                                                                   0x8
#define HWIO_GCC_UFS_PHY_GDSCR_PD_ARES_SHFT                                                                   0x3
#define HWIO_GCC_UFS_PHY_GDSCR_PD_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_UFS_PHY_GDSCR_PD_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_UFS_PHY_GDSCR_SW_OVERRIDE_BMSK                                                               0x4
#define HWIO_GCC_UFS_PHY_GDSCR_SW_OVERRIDE_SHFT                                                               0x2
#define HWIO_GCC_UFS_PHY_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_UFS_PHY_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                        0x1
#define HWIO_GCC_UFS_PHY_GDSCR_HW_CONTROL_BMSK                                                                0x2
#define HWIO_GCC_UFS_PHY_GDSCR_HW_CONTROL_SHFT                                                                0x1
#define HWIO_GCC_UFS_PHY_GDSCR_HW_CONTROL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_UFS_PHY_GDSCR_HW_CONTROL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_UFS_PHY_GDSCR_SW_COLLAPSE_BMSK                                                               0x1
#define HWIO_GCC_UFS_PHY_GDSCR_SW_COLLAPSE_SHFT                                                               0x0
#define HWIO_GCC_UFS_PHY_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_UFS_PHY_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_UFS_PHY_CFG_GDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00067008)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067008)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067008)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_RMSK                                                                 0x7ffffff
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_ATTR                                                                       0x3
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG_GDSCR_ADDR, HWIO_GCC_UFS_PHY_CFG_GDSCR_RMSK)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_CFG_GDSCR_ADDR,m,v,HWIO_GCC_UFS_PHY_CFG_GDSCR_IN)
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                      0x4000000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                           0x1a
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                              0x2000000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                   0x19
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                               0x1000000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                    0x18
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                        0xf00000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                            0x14
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                           0x80000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                              0x13
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                               0x40000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                  0x12
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                               0x20000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                  0x11
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                            0x10000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                               0x10
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                           0x8000
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                              0xf
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                          0x7800
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                             0xb
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                  0x400
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                    0xa
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                           0x200
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                             0x9
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                           0x100
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                             0x8
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                               0x80
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                0x7
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                      0x60
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                       0x5
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                0x10
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                 0x4
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                          0x8
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                          0x3
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                        0x4
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                        0x2
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                            0x2
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                            0x1
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                         0x1
#define HWIO_GCC_UFS_PHY_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                         0x0

#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006700c)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006700c)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006700c)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_RMSK                                                                  0x7ffff
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_ATTR                                                                      0x3
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG2_GDSCR_ADDR, HWIO_GCC_UFS_PHY_CFG2_GDSCR_RMSK)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_UFS_PHY_CFG2_GDSCR_IN)
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                      0x40000
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                         0x12
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                  0x20000
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                     0x11
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                0x10000
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                   0x10
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                    0xf000
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                       0xc
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                             0xf00
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                               0x8
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                0xf0
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                 0x4
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                  0xf
#define HWIO_GCC_UFS_PHY_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                  0x0

#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00067010)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067010)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067010)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_RMSK                                                                0x7ffffff
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_ATTR                                                                      0x3
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG3_GDSCR_ADDR, HWIO_GCC_UFS_PHY_CFG3_GDSCR_RMSK)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_UFS_PHY_CFG3_GDSCR_IN)
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                              0x4000000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                   0x1a
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                           0x2000000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                0x19
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                      0x1e00000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                           0x15
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                       0x100000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                           0x14
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                    0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                              0x80000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                 0x13
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                          0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                           0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                  0x40000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                     0x12
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                              0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                               0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                   0x20000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                      0x11
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                               0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                        0x10000
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                           0x10
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                0xff00
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                   0x8
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                 0xff
#define HWIO_GCC_UFS_PHY_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                  0x0

#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00067014)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067014)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067014)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_RMSK                                                                 0xffffff
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_ATTR                                                                      0x3
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG4_GDSCR_ADDR, HWIO_GCC_UFS_PHY_CFG4_GDSCR_RMSK)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_UFS_PHY_CFG4_GDSCR_IN)
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                   0xf00000
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                       0x14
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                    0xf0000
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                       0x10
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                    0xf000
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                       0xc
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                   0xf00
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                     0x8
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                         0xf0
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                          0x4
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                         0xf
#define HWIO_GCC_UFS_PHY_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                         0x0

#define HWIO_GCC_UFS_PHY_AXI_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00067018)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067018)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067018)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_RMSK                                                                 0x81c0700f
#define HWIO_GCC_UFS_PHY_AXI_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_UFS_PHY_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CBCR_ADDR, HWIO_GCC_UFS_PHY_AXI_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_CBCR_IN)
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_UFS_PHY_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_UFS_PHY_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_CORE_ON_BMSK                                                   0x4000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_CORE_ON_SHFT                                                      0xe
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                 0x2000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                    0xd
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                0x1000
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                   0xc
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_UFS_PHY_AXI_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_UFS_PHY_AXI_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_UFS_PHY_AXI_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006701c)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006701c)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006701c)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_RMSK                                                                 0xf1ffffe
#define HWIO_GCC_UFS_PHY_AXI_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_UFS_PHY_AXI_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_SREGR_ADDR, HWIO_GCC_UFS_PHY_AXI_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_SREGR_IN)
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                       0xf000000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                            0x18
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PWR_FSM_CLK_SEL_BMSK                                                  0x100000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PWR_FSM_CLK_SEL_SHFT                                                      0x14
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                          0xf0000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                             0x10
#define HWIO_GCC_UFS_PHY_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                            0x8000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                               0xf
#define HWIO_GCC_UFS_PHY_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                        0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                             0x4000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                0xe
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                             0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                            0x2000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                               0xd
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                   0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                      0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                        0x1000
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                           0xc
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                  0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CORE_ON_ACK_BMSK                                                     0x800
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CORE_ON_ACK_SHFT                                                       0xb
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                   0x400
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                     0xa
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                            0x300
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                              0x8
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                     0x2
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                     0x3
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_ENABLE_BMSK                                                       0x80
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_ENABLE_SHFT                                                        0x7
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_FORCE_CLK_ON_BMSK                                                         0x40
#define HWIO_GCC_UFS_PHY_AXI_SREGR_FORCE_CLK_ON_SHFT                                                          0x6
#define HWIO_GCC_UFS_PHY_AXI_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                   0x20
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                    0x5
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                           0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                      0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SLP_STG_BMSK                                                       0x10
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SLP_STG_SHFT                                                        0x4
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                              0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                 0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                      0x8
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                      0x3
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                           0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                              0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                 0x4
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                 0x2
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL             0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                     0x2
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                     0x1
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                               0x0
#define HWIO_GCC_UFS_PHY_AXI_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                0x1

#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00067020)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067020)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067020)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_RMSK                                                            0xffffffff
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ATTR                                                                   0x3
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ADDR, HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_IN)
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                         0xfc000000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                               0x1a
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                    0x2000000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                         0x19
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                      0x1000000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                           0x18
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                         0x800000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                             0x17
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                           0x400000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                               0x16
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                0x3f0000
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                    0x10
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_SLEEP_TIMER_BMSK                                                    0xff00
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_SLEEP_TIMER_SHFT                                                       0x8
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_WAKEUP_TIMER_BMSK                                                     0xff
#define HWIO_GCC_UFS_PHY_AXI_CFG_SREGR_WAKEUP_TIMER_SHFT                                                      0x0

#define HWIO_GCC_UFS_PHY_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00067024)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067024)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067024)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_UFS_PHY_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AHB_CBCR_ADDR, HWIO_GCC_UFS_PHY_AHB_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AHB_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AHB_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AHB_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_AHB_CBCR_IN)
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_UFS_PHY_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_UFS_PHY_AHB_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_UFS_PHY_AHB_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_UFS_PHY_AHB_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_UFS_PHY_AHB_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_UFS_PHY_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_UFS_PHY_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_UFS_PHY_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00067028)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067028)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067028)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_RMSK                                                         0x81c00005
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ADDR, HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IN)
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_TX_SYMBOL_0_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006702c)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006702c)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006702c)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_RMSK                                                         0x81c00005
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ADDR, HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IN)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_0_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00067030)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067030)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067030)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_RMSK                                                             0x800000f3
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ADDR, HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_IN)
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                          0x1f
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_D_BMSK                                                           0x80
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_D_SHFT                                                            0x7
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_N_BMSK                                                           0x40
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_N_SHFT                                                            0x6
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_M_BMSK                                                           0x20
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_M_SHFT                                                            0x5
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                    0x10
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                     0x4
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_EN_BMSK                                                            0x2
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_EN_SHFT                                                            0x1
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_UPDATE_BMSK                                                             0x1
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_UPDATE_SHFT                                                             0x0
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00067034)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067034)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067034)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_RMSK                                                               0x10371f
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ATTR                                                                    0x3
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ADDR, HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_IN)
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                0x100000
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                    0x14
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                              0x1
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_BMSK                                                            0x3000
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_SHFT                                                               0xc
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_BYPASS_FVAL                                                        0x0
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_SWALLOW_FVAL                                                       0x1
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_DUAL_EDGE_FVAL                                                     0x2
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_MODE_SINGLE_EDGE_FVAL                                                   0x3
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_BMSK                                                          0x700
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SHFT                                                            0x8
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                       0x0
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                       0x1
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                       0x2
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                       0x3
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                       0x4
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                       0x5
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                       0x6
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                       0x7
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_BMSK                                                           0x1f
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_SHFT                                                            0x0
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                     0x0
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                       0x1
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                     0x2
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                       0x3
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                     0x4
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                       0x5
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                     0x6
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                       0x7
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                     0x8
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                       0x9
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                     0xa
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                       0xb
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                     0xc
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                       0xd
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                     0xe
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                       0xf
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                    0x10
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                      0x11
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                    0x12
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                     0x13
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                   0x14
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                     0x15
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                   0x16
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                     0x17
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                   0x18
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                     0x19
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                   0x1a
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                     0x1b
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                   0x1c
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                     0x1d
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                   0x1e
#define HWIO_GCC_UFS_PHY_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                     0x1f

#define HWIO_GCC_UFS_PHY_AXI_M_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00067038)
#define HWIO_GCC_UFS_PHY_AXI_M_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067038)
#define HWIO_GCC_UFS_PHY_AXI_M_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067038)
#define HWIO_GCC_UFS_PHY_AXI_M_RMSK                                                                          0xff
#define HWIO_GCC_UFS_PHY_AXI_M_ATTR                                                                           0x3
#define HWIO_GCC_UFS_PHY_AXI_M_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_M_ADDR, HWIO_GCC_UFS_PHY_AXI_M_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_M_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_M_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_M_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_M_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_M_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_M_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_M_IN)
#define HWIO_GCC_UFS_PHY_AXI_M_M_BMSK                                                                        0xff
#define HWIO_GCC_UFS_PHY_AXI_M_M_SHFT                                                                         0x0

#define HWIO_GCC_UFS_PHY_AXI_N_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0006703c)
#define HWIO_GCC_UFS_PHY_AXI_N_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006703c)
#define HWIO_GCC_UFS_PHY_AXI_N_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006703c)
#define HWIO_GCC_UFS_PHY_AXI_N_RMSK                                                                          0xff
#define HWIO_GCC_UFS_PHY_AXI_N_ATTR                                                                           0x3
#define HWIO_GCC_UFS_PHY_AXI_N_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_N_ADDR, HWIO_GCC_UFS_PHY_AXI_N_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_N_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_N_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_N_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_N_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_N_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_N_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_N_IN)
#define HWIO_GCC_UFS_PHY_AXI_N_NOT_N_MINUS_M_BMSK                                                            0xff
#define HWIO_GCC_UFS_PHY_AXI_N_NOT_N_MINUS_M_SHFT                                                             0x0

#define HWIO_GCC_UFS_PHY_AXI_D_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00067040)
#define HWIO_GCC_UFS_PHY_AXI_D_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067040)
#define HWIO_GCC_UFS_PHY_AXI_D_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067040)
#define HWIO_GCC_UFS_PHY_AXI_D_RMSK                                                                          0xff
#define HWIO_GCC_UFS_PHY_AXI_D_ATTR                                                                           0x3
#define HWIO_GCC_UFS_PHY_AXI_D_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_D_ADDR, HWIO_GCC_UFS_PHY_AXI_D_RMSK)
#define HWIO_GCC_UFS_PHY_AXI_D_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_AXI_D_ADDR, m)
#define HWIO_GCC_UFS_PHY_AXI_D_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_AXI_D_ADDR,v)
#define HWIO_GCC_UFS_PHY_AXI_D_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_AXI_D_ADDR,m,v,HWIO_GCC_UFS_PHY_AXI_D_IN)
#define HWIO_GCC_UFS_PHY_AXI_D_NOT_2D_BMSK                                                                   0xff
#define HWIO_GCC_UFS_PHY_AXI_D_NOT_2D_SHFT                                                                    0x0

#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006704c)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006704c)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006704c)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_RMSK                                                     0xf
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ATTR                                                     0x3
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_CLK_DIV_BMSK                                             0xf
#define HWIO_GCC_GPLL0_UFS_PHY_TX_SYMBOL_0_DIV_CDIVR_CLK_DIV_SHFT                                             0x0

#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006705c)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006705c)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006705c)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_RMSK                                                     0xf
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ATTR                                                     0x3
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_CLK_DIV_BMSK                                             0xf
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_0_DIV_CDIVR_CLK_DIV_SHFT                                             0x0

#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00067068)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067068)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067068)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_RMSK                                                         0x81c0700f
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ADDR, HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IN)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_CORE_ON_BMSK                                           0x4000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_CORE_ON_SHFT                                              0xe
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                         0x2000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                            0xd
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                              0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                               0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                        0x1000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                           0xc
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                              0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0006706c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006706c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006706c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_RMSK                                                         0xf1ffffe
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ATTR                                                               0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ADDR, HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IN)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                               0xf000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                    0x18
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PWR_FSM_CLK_SEL_BMSK                                          0x100000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PWR_FSM_CLK_SEL_SHFT                                              0x14
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                  0xf0000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                     0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                    0x8000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                       0xf
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                     0x4000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                        0xe
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                        0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                     0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                    0x2000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                       0xd
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                           0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                              0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                0x1000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                   0xc
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                          0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                             0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CORE_ON_ACK_BMSK                                             0x800
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CORE_ON_ACK_SHFT                                               0xb
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                           0x400
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                             0xa
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                    0x300
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                      0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                             0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                             0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                             0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_ENABLE_BMSK                                               0x80
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_ENABLE_SHFT                                                0x7
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_FORCE_CLK_ON_BMSK                                                 0x40
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_FORCE_CLK_ON_SHFT                                                  0x6
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                         0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                           0x20
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                            0x5
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                   0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL              0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SLP_STG_BMSK                                               0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SLP_STG_SHFT                                                0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                      0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                         0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                              0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                              0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                   0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                      0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                         0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                         0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                             0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                             0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                       0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                        0x1

#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00067070)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067070)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067070)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_RMSK                                                    0xffffffff
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ATTR                                                           0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ADDR, HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_IN)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                 0xfc000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                       0x1a
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                            0x2000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                 0x19
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                              0x1000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                   0x18
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                 0x800000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                     0x17
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                   0x400000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                       0x16
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                        0x3f0000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                            0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_SLEEP_TIMER_BMSK                                            0xff00
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_SLEEP_TIMER_SHFT                                               0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_WAKEUP_TIMER_BMSK                                             0xff
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_SREGR_WAKEUP_TIMER_SHFT                                              0x0

#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00067074)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067074)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067074)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_RMSK                                                            0x81c0700f
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ADDR, HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IN)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_CORE_ON_BMSK                                              0x4000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_CORE_ON_SHFT                                                 0xe
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                            0x2000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                               0xd
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                           0x1000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                              0xc
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00067078)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067078)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067078)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_RMSK                                                            0xf1ffffe
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ATTR                                                                  0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ADDR, HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IN)
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                  0xf000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                       0x18
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PWR_FSM_CLK_SEL_BMSK                                             0x100000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PWR_FSM_CLK_SEL_SHFT                                                 0x14
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                     0xf0000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                        0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                       0x8000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                          0xf
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                   0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                        0x4000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                           0xe
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                           0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                        0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                       0x2000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                          0xd
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                              0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                 0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                   0x1000
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                      0xc
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                             0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CORE_ON_ACK_BMSK                                                0x800
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CORE_ON_ACK_SHFT                                                  0xb
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_PERIPH_ON_ACK_BMSK                                              0x400
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                0xa
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                       0x300
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                         0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_ENABLE_BMSK                                                  0x80
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_ENABLE_SHFT                                                   0x7
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_FORCE_CLK_ON_BMSK                                                    0x40
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_FORCE_CLK_ON_SHFT                                                     0x6
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                            0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SEL_SLP_STG_BMSK                                              0x20
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SEL_SLP_STG_SHFT                                               0x5
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                      0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                 0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SLP_STG_BMSK                                                  0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SLP_STG_SHFT                                                   0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                         0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                            0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                 0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                 0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                      0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                         0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                            0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                            0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL        0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                          0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                           0x1

#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0006707c)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006707c)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006707c)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_RMSK                                                       0xffffffff
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ATTR                                                              0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ADDR, HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_RMSK)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_ADDR,m,v,HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_IN)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                    0xfc000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                          0x1a
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                               0x2000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                    0x19
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                 0x1000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                      0x18
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                    0x800000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                        0x17
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                      0x400000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                          0x16
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CPH_TIMER_BMSK                                           0x3f0000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_MEM_CPH_TIMER_SHFT                                               0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_SLEEP_TIMER_BMSK                                               0xff00
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_SLEEP_TIMER_SHFT                                                  0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_WAKEUP_TIMER_BMSK                                                0xff
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_SREGR_WAKEUP_TIMER_SHFT                                                 0x0

#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00067080)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067080)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067080)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_RMSK                                                        0x80000013
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ATTR                                                               0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ADDR, HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_IN)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_OFF_BMSK                                               0x80000000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                     0x1f
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                               0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_EN_BMSK                                                       0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_EN_SHFT                                                       0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                               0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_UPDATE_BMSK                                                        0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_UPDATE_SHFT                                                        0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00067084)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067084)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067084)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RMSK                                                          0x11071f
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ATTR                                                               0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ADDR, HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_IN)
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                           0x100000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                               0x14
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                        0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                         0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                           0x10000
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                              0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                               0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                              0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_BMSK                                                     0x700
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SHFT                                                       0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                  0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                  0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                  0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                  0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                  0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                  0x5
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                  0x6
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                  0x7
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_BMSK                                                      0x1f
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_SHFT                                                       0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                0x0
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                  0x1
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                0x2
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                  0x3
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                0x4
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                  0x5
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                0x6
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                  0x7
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                0x8
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                  0x9
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                0xa
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                  0xb
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                0xc
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                  0xd
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                0xe
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                  0xf
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                               0x10
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                 0x11
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                               0x12
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                0x13
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                              0x14
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                0x15
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                              0x16
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                0x17
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                              0x18
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                0x19
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                              0x1a
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                0x1b
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                              0x1c
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                0x1d
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                              0x1e
#define HWIO_GCC_UFS_PHY_ICE_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                0x1f

#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00067098)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00067098)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00067098)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_RMSK                                                     0x80000013
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ATTR                                                            0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ADDR, HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_IN)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_OFF_BMSK                                            0x80000000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                  0x1f
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                            0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                             0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_EN_BMSK                                                    0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_EN_SHFT                                                    0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                            0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                             0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_UPDATE_BMSK                                                     0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_UPDATE_SHFT                                                     0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006709c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006709c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006709c)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RMSK                                                       0x11071f
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ATTR                                                            0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ADDR, HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_IN)
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                        0x100000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                            0x14
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                     0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                      0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                        0x10000
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                           0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                            0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                           0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_BMSK                                                  0x700
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SHFT                                                    0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                               0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                               0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                               0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                               0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                               0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                               0x5
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                               0x6
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                               0x7
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_BMSK                                                   0x1f
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_SHFT                                                    0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                               0x1
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                             0x2
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                               0x3
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                             0x4
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                               0x5
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                             0x6
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                               0x7
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                             0x8
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                               0x9
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                             0xa
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                               0xb
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                             0xc
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                               0xd
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                             0xe
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                               0xf
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                            0x10
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                              0x11
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                            0x12
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                             0x13
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                           0x14
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                             0x15
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                           0x16
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                             0x17
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                           0x18
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                             0x19
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                           0x1a
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                             0x1b
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                           0x1c
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                             0x1d
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                           0x1e
#define HWIO_GCC_UFS_PHY_UNIPRO_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                             0x1f

#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x000670b0)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670b0)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670b0)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_RMSK                                                             0x81c0000f
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ADDR, HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IN)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000670b4)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670b4)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670b4)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_RMSK                                                         0x80000013
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ADDR, HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_IN)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_OFF_BMSK                                                0x80000000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_OFF_SHFT                                                      0x1f
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                0x10
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                 0x4
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_EN_BMSK                                                        0x2
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_EN_SHFT                                                        0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_UPDATE_BMSK                                                         0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_UPDATE_SHFT                                                         0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000670b8)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670b8)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670b8)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RMSK                                                           0x11071f
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ADDR, HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RMSK)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_ADDR,m,v,HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_IN)
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                            0x100000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                0x14
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                         0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                          0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                            0x10000
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                               0x10
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                               0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_BMSK                                                      0x700
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SHFT                                                        0x8
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                   0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                   0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                   0x2
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                   0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                   0x4
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                   0x5
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                   0x6
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                   0x7
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_BMSK                                                       0x1f
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_SHFT                                                        0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                 0x0
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                   0x1
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                 0x2
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                   0x3
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                 0x4
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                   0x5
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                 0x6
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                   0x7
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                 0x8
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                   0x9
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                 0xa
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                   0xb
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                 0xc
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                   0xd
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                 0xe
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                   0xf
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                0x10
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                  0x11
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                0x12
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                 0x13
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                               0x14
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                 0x15
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                               0x16
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                 0x17
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                               0x18
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                 0x19
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                               0x1a
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                 0x1b
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                               0x1c
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                 0x1d
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                               0x1e
#define HWIO_GCC_UFS_PHY_PHY_AUX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                 0x1f

#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x000670cc)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670cc)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670cc)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_RMSK                                                         0x81c00005
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ATTR                                                                0x3
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ADDR, HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_RMSK)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ADDR, m)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ADDR,v)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_ADDR,m,v,HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IN)
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_UFS_PHY_RX_SYMBOL_1_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_UFS_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000670d0)
#define HWIO_GCC_UFS_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670d0)
#define HWIO_GCC_UFS_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670d0)
#define HWIO_GCC_UFS_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_UFS_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_UFS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_UFS_AT_CBCR_ADDR, HWIO_GCC_UFS_AT_CBCR_RMSK)
#define HWIO_GCC_UFS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_UFS_AT_CBCR_ADDR, m)
#define HWIO_GCC_UFS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_UFS_AT_CBCR_ADDR,v)
#define HWIO_GCC_UFS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_UFS_AT_CBCR_ADDR,m,v,HWIO_GCC_UFS_AT_CBCR_IN)
#define HWIO_GCC_UFS_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_UFS_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_UFS_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_UFS_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_UFS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_UFS_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_UFS_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_UFS_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_UFS_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_UFS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_UFS_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_UFS_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_UFS_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_UFS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_UFS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_UFS_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_UFS_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_UFS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_UFS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x000670d8)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000670d8)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000670d8)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_RMSK                                                     0xf
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ATTR                                                     0x3
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ADDR, HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_RMSK)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_ADDR,m,v,HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_IN)
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_CLK_DIV_BMSK                                             0xf
#define HWIO_GCC_GPLL0_UFS_PHY_RX_SYMBOL_1_DIV_CDIVR_CLK_DIV_SHFT                                             0x0

#define HWIO_GCC_VS_BCR_ADDR                                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a000)
#define HWIO_GCC_VS_BCR_PHYS                                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a000)
#define HWIO_GCC_VS_BCR_OFFS                                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a000)
#define HWIO_GCC_VS_BCR_RMSK                                                                                  0x1
#define HWIO_GCC_VS_BCR_ATTR                                                                                  0x3
#define HWIO_GCC_VS_BCR_IN          \
        in_dword_masked(HWIO_GCC_VS_BCR_ADDR, HWIO_GCC_VS_BCR_RMSK)
#define HWIO_GCC_VS_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VS_BCR_ADDR, m)
#define HWIO_GCC_VS_BCR_OUT(v)      \
        out_dword(HWIO_GCC_VS_BCR_ADDR,v)
#define HWIO_GCC_VS_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VS_BCR_ADDR,m,v,HWIO_GCC_VS_BCR_IN)
#define HWIO_GCC_VS_BCR_BLK_ARES_BMSK                                                                         0x1
#define HWIO_GCC_VS_BCR_BLK_ARES_SHFT                                                                         0x0
#define HWIO_GCC_VS_BCR_BLK_ARES_DISABLE_FVAL                                                                 0x0
#define HWIO_GCC_VS_BCR_BLK_ARES_ENABLE_FVAL                                                                  0x1

#define HWIO_GCC_VDDMXC_VS_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a004)
#define HWIO_GCC_VDDMXC_VS_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a004)
#define HWIO_GCC_VDDMXC_VS_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a004)
#define HWIO_GCC_VDDMXC_VS_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_VDDMXC_VS_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_VDDMXC_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VDDMXC_VS_CBCR_ADDR, HWIO_GCC_VDDMXC_VS_CBCR_RMSK)
#define HWIO_GCC_VDDMXC_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VDDMXC_VS_CBCR_ADDR, m)
#define HWIO_GCC_VDDMXC_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VDDMXC_VS_CBCR_ADDR,v)
#define HWIO_GCC_VDDMXC_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VDDMXC_VS_CBCR_ADDR,m,v,HWIO_GCC_VDDMXC_VS_CBCR_IN)
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_VDDMXC_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_VDDMXC_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_VDDMXC_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_VDDMXC_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_VDDMXC_VS_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_VDDMXC_VS_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_VDDMXC_VS_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_VDDMXC_VS_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_VDDMXC_VS_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_VDDMXC_VS_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_VDDMXC_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_VDDCX_VS_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a008)
#define HWIO_GCC_VDDCX_VS_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a008)
#define HWIO_GCC_VDDCX_VS_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a008)
#define HWIO_GCC_VDDCX_VS_CBCR_RMSK                                                                    0x81c0000f
#define HWIO_GCC_VDDCX_VS_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_VDDCX_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VDDCX_VS_CBCR_ADDR, HWIO_GCC_VDDCX_VS_CBCR_RMSK)
#define HWIO_GCC_VDDCX_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VDDCX_VS_CBCR_ADDR, m)
#define HWIO_GCC_VDDCX_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VDDCX_VS_CBCR_ADDR,v)
#define HWIO_GCC_VDDCX_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VDDCX_VS_CBCR_ADDR,m,v,HWIO_GCC_VDDCX_VS_CBCR_IN)
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_VDDCX_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_VDDCX_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_VDDCX_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_VDDCX_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_VDDCX_VS_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_VDDCX_VS_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_VDDCX_VS_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_VDDCX_VS_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_VDDCX_VS_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_VDDCX_VS_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_VDDCX_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_VDDMX_VS_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a00c)
#define HWIO_GCC_VDDMX_VS_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a00c)
#define HWIO_GCC_VDDMX_VS_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a00c)
#define HWIO_GCC_VDDMX_VS_CBCR_RMSK                                                                    0x81c0000f
#define HWIO_GCC_VDDMX_VS_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_VDDMX_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VDDMX_VS_CBCR_ADDR, HWIO_GCC_VDDMX_VS_CBCR_RMSK)
#define HWIO_GCC_VDDMX_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VDDMX_VS_CBCR_ADDR, m)
#define HWIO_GCC_VDDMX_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VDDMX_VS_CBCR_ADDR,v)
#define HWIO_GCC_VDDMX_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VDDMX_VS_CBCR_ADDR,m,v,HWIO_GCC_VDDMX_VS_CBCR_IN)
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_VDDMX_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_VDDMX_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_VDDMX_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_VDDMX_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_VDDMX_VS_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_VDDMX_VS_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_VDDMX_VS_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_VDDMX_VS_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_VDDMX_VS_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_VDDMX_VS_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_VDDMX_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_VDDA_VS_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a010)
#define HWIO_GCC_VDDA_VS_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a010)
#define HWIO_GCC_VDDA_VS_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a010)
#define HWIO_GCC_VDDA_VS_CBCR_RMSK                                                                     0x81c0000f
#define HWIO_GCC_VDDA_VS_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_VDDA_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VDDA_VS_CBCR_ADDR, HWIO_GCC_VDDA_VS_CBCR_RMSK)
#define HWIO_GCC_VDDA_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VDDA_VS_CBCR_ADDR, m)
#define HWIO_GCC_VDDA_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VDDA_VS_CBCR_ADDR,v)
#define HWIO_GCC_VDDA_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VDDA_VS_CBCR_ADDR,m,v,HWIO_GCC_VDDA_VS_CBCR_IN)
#define HWIO_GCC_VDDA_VS_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_VDDA_VS_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_VDDA_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_VDDA_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_VDDA_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_VDDA_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_VDDA_VS_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_VDDA_VS_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_VDDA_VS_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_VDDA_VS_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_VDDA_VS_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_VDDA_VS_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_VDDA_VS_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_VDDA_VS_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_VDDA_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_VS_CTRL_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a014)
#define HWIO_GCC_VS_CTRL_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a014)
#define HWIO_GCC_VS_CTRL_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a014)
#define HWIO_GCC_VS_CTRL_CBCR_RMSK                                                                     0x81c0000f
#define HWIO_GCC_VS_CTRL_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_VS_CTRL_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VS_CTRL_CBCR_ADDR, HWIO_GCC_VS_CTRL_CBCR_RMSK)
#define HWIO_GCC_VS_CTRL_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VS_CTRL_CBCR_ADDR, m)
#define HWIO_GCC_VS_CTRL_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VS_CTRL_CBCR_ADDR,v)
#define HWIO_GCC_VS_CTRL_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VS_CTRL_CBCR_ADDR,m,v,HWIO_GCC_VS_CTRL_CBCR_IN)
#define HWIO_GCC_VS_CTRL_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_VS_CTRL_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_VS_CTRL_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_VS_CTRL_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_VS_CTRL_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_VS_CTRL_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_VS_CTRL_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_VS_CTRL_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_VS_CTRL_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_VS_CTRL_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_VS_CTRL_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_VS_CTRL_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_VS_CTRL_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_VS_CTRL_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_VS_CTRL_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_VS_CTRL_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a018)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a018)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a018)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_VS_CTRL_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_VS_CTRL_AHB_CBCR_ADDR, HWIO_GCC_VS_CTRL_AHB_CBCR_RMSK)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_VS_CTRL_AHB_CBCR_ADDR, m)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_VS_CTRL_AHB_CBCR_ADDR,v)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VS_CTRL_AHB_CBCR_ADDR,m,v,HWIO_GCC_VS_CTRL_AHB_CBCR_IN)
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_VS_CTRL_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_VS_CTRL_AHB_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_VS_CTRL_AHB_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_VS_CTRL_AHB_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_VS_CTRL_AHB_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_VS_CTRL_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_VS_CTRL_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_VS_CTRL_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_VSENSOR_CMD_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a01c)
#define HWIO_GCC_VSENSOR_CMD_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a01c)
#define HWIO_GCC_VSENSOR_CMD_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a01c)
#define HWIO_GCC_VSENSOR_CMD_RCGR_RMSK                                                                 0x80000013
#define HWIO_GCC_VSENSOR_CMD_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_VSENSOR_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_VSENSOR_CMD_RCGR_ADDR, HWIO_GCC_VSENSOR_CMD_RCGR_RMSK)
#define HWIO_GCC_VSENSOR_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VSENSOR_CMD_RCGR_ADDR, m)
#define HWIO_GCC_VSENSOR_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_VSENSOR_CMD_RCGR_ADDR,v)
#define HWIO_GCC_VSENSOR_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VSENSOR_CMD_RCGR_ADDR,m,v,HWIO_GCC_VSENSOR_CMD_RCGR_IN)
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_OFF_SHFT                                                              0x1f
#define HWIO_GCC_VSENSOR_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                        0x10
#define HWIO_GCC_VSENSOR_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                         0x4
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_EN_BMSK                                                                0x2
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_EN_SHFT                                                                0x1
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_VSENSOR_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_VSENSOR_CMD_RCGR_UPDATE_BMSK                                                                 0x1
#define HWIO_GCC_VSENSOR_CMD_RCGR_UPDATE_SHFT                                                                 0x0
#define HWIO_GCC_VSENSOR_CMD_RCGR_UPDATE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_VSENSOR_CMD_RCGR_UPDATE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_VSENSOR_CFG_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a020)
#define HWIO_GCC_VSENSOR_CFG_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a020)
#define HWIO_GCC_VSENSOR_CFG_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a020)
#define HWIO_GCC_VSENSOR_CFG_RCGR_RMSK                                                                   0x11071f
#define HWIO_GCC_VSENSOR_CFG_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_VSENSOR_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_VSENSOR_CFG_RCGR_ADDR, HWIO_GCC_VSENSOR_CFG_RCGR_RMSK)
#define HWIO_GCC_VSENSOR_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VSENSOR_CFG_RCGR_ADDR, m)
#define HWIO_GCC_VSENSOR_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_VSENSOR_CFG_RCGR_ADDR,v)
#define HWIO_GCC_VSENSOR_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VSENSOR_CFG_RCGR_ADDR,m,v,HWIO_GCC_VSENSOR_CFG_RCGR_IN)
#define HWIO_GCC_VSENSOR_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                    0x100000
#define HWIO_GCC_VSENSOR_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                        0x14
#define HWIO_GCC_VSENSOR_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_VSENSOR_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_VSENSOR_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                    0x10000
#define HWIO_GCC_VSENSOR_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                       0x10
#define HWIO_GCC_VSENSOR_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                        0x0
#define HWIO_GCC_VSENSOR_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                       0x1
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_BMSK                                                              0x700
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SHFT                                                                0x8
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                           0x0
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                           0x1
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                           0x2
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                           0x3
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                           0x4
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                           0x5
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                           0x6
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                           0x7
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_BMSK                                                               0x1f
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_SHFT                                                                0x0
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                           0x1
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                         0x2
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                           0x3
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                         0x4
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                           0x5
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                         0x6
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                           0x7
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                         0x8
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                           0x9
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                         0xa
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                           0xb
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                         0xc
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                           0xd
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                         0xe
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                           0xf
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                        0x10
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                          0x11
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                        0x12
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                         0x13
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                       0x14
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                         0x15
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                       0x16
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                         0x17
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                       0x18
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                         0x19
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                       0x1a
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                         0x1b
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                       0x1c
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                         0x1d
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                       0x1e
#define HWIO_GCC_VSENSOR_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                         0x1f

#define HWIO_GCC_VS_CTRL_CMD_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a034)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a034)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a034)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_RMSK                                                                 0x80000013
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_VS_CTRL_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_VS_CTRL_CMD_RCGR_ADDR, HWIO_GCC_VS_CTRL_CMD_RCGR_RMSK)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VS_CTRL_CMD_RCGR_ADDR, m)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_VS_CTRL_CMD_RCGR_ADDR,v)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VS_CTRL_CMD_RCGR_ADDR,m,v,HWIO_GCC_VS_CTRL_CMD_RCGR_IN)
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_OFF_SHFT                                                              0x1f
#define HWIO_GCC_VS_CTRL_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                        0x10
#define HWIO_GCC_VS_CTRL_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                         0x4
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_EN_BMSK                                                                0x2
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_EN_SHFT                                                                0x1
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_VS_CTRL_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_VS_CTRL_CMD_RCGR_UPDATE_BMSK                                                                 0x1
#define HWIO_GCC_VS_CTRL_CMD_RCGR_UPDATE_SHFT                                                                 0x0
#define HWIO_GCC_VS_CTRL_CMD_RCGR_UPDATE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_VS_CTRL_CMD_RCGR_UPDATE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_VS_CTRL_CFG_RCGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a038)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a038)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a038)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_RMSK                                                                   0x11071f
#define HWIO_GCC_VS_CTRL_CFG_RCGR_ATTR                                                                        0x3
#define HWIO_GCC_VS_CTRL_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_VS_CTRL_CFG_RCGR_ADDR, HWIO_GCC_VS_CTRL_CFG_RCGR_RMSK)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_VS_CTRL_CFG_RCGR_ADDR, m)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_VS_CTRL_CFG_RCGR_ADDR,v)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VS_CTRL_CFG_RCGR_ADDR,m,v,HWIO_GCC_VS_CTRL_CFG_RCGR_IN)
#define HWIO_GCC_VS_CTRL_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                    0x100000
#define HWIO_GCC_VS_CTRL_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                        0x14
#define HWIO_GCC_VS_CTRL_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_VS_CTRL_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_VS_CTRL_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                    0x10000
#define HWIO_GCC_VS_CTRL_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                       0x10
#define HWIO_GCC_VS_CTRL_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                        0x0
#define HWIO_GCC_VS_CTRL_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                       0x1
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_BMSK                                                              0x700
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SHFT                                                                0x8
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                           0x0
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                           0x1
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                           0x2
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                           0x3
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                           0x4
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                           0x5
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                           0x6
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                           0x7
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_BMSK                                                               0x1f
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_SHFT                                                                0x0
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                         0x0
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                           0x1
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                         0x2
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                           0x3
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                         0x4
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                           0x5
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                         0x6
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                           0x7
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                         0x8
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                           0x9
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                         0xa
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                           0xb
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                         0xc
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                           0xd
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                         0xe
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                           0xf
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                        0x10
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                          0x11
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                        0x12
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                         0x13
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                       0x14
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                         0x15
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                       0x16
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                         0x17
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                       0x18
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                         0x19
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                       0x1a
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                         0x1b
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                       0x1c
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                         0x1d
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                       0x1e
#define HWIO_GCC_VS_CTRL_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                         0x1f

#define HWIO_GCC_MSS_VS_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a04c)
#define HWIO_GCC_MSS_VS_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a04c)
#define HWIO_GCC_MSS_VS_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a04c)
#define HWIO_GCC_MSS_VS_CBCR_RMSK                                                                      0x81c0000f
#define HWIO_GCC_MSS_VS_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_MSS_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_VS_CBCR_ADDR, HWIO_GCC_MSS_VS_CBCR_RMSK)
#define HWIO_GCC_MSS_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VS_CBCR_ADDR, m)
#define HWIO_GCC_MSS_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VS_CBCR_ADDR,v)
#define HWIO_GCC_MSS_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VS_CBCR_ADDR,m,v,HWIO_GCC_MSS_VS_CBCR_IN)
#define HWIO_GCC_MSS_VS_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_MSS_VS_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_MSS_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_MSS_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_MSS_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_MSS_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_MSS_VS_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_MSS_VS_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_MSS_VS_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_MSS_VS_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_MSS_VS_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_MSS_VS_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_MSS_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_MSS_VS_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_MSS_VS_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_MSS_VS_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_MSS_VS_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MSS_VS_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MSS_VS_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_MSS_VS_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_MSS_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MSS_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_GPU_VS_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a050)
#define HWIO_GCC_GPU_VS_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a050)
#define HWIO_GCC_GPU_VS_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a050)
#define HWIO_GCC_GPU_VS_CBCR_RMSK                                                                      0x81c0000f
#define HWIO_GCC_GPU_VS_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_GPU_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_VS_CBCR_ADDR, HWIO_GCC_GPU_VS_CBCR_RMSK)
#define HWIO_GCC_GPU_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_VS_CBCR_ADDR, m)
#define HWIO_GCC_GPU_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_VS_CBCR_ADDR,v)
#define HWIO_GCC_GPU_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_VS_CBCR_ADDR,m,v,HWIO_GCC_GPU_VS_CBCR_IN)
#define HWIO_GCC_GPU_VS_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_GPU_VS_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_GPU_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_GPU_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_GPU_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_GPU_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_GPU_VS_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_GPU_VS_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_GPU_VS_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_GPU_VS_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_GPU_VS_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_GPU_VS_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_GPU_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_GPU_VS_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_GPU_VS_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_GPU_VS_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_GPU_VS_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_GPU_VS_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_GPU_VS_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_GPU_VS_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_GPU_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GPU_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_APC_VS_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a054)
#define HWIO_GCC_APC_VS_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a054)
#define HWIO_GCC_APC_VS_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a054)
#define HWIO_GCC_APC_VS_CBCR_RMSK                                                                      0x81c0000f
#define HWIO_GCC_APC_VS_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_APC_VS_CBCR_IN          \
        in_dword_masked(HWIO_GCC_APC_VS_CBCR_ADDR, HWIO_GCC_APC_VS_CBCR_RMSK)
#define HWIO_GCC_APC_VS_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APC_VS_CBCR_ADDR, m)
#define HWIO_GCC_APC_VS_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_APC_VS_CBCR_ADDR,v)
#define HWIO_GCC_APC_VS_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APC_VS_CBCR_ADDR,m,v,HWIO_GCC_APC_VS_CBCR_IN)
#define HWIO_GCC_APC_VS_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_APC_VS_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_APC_VS_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_APC_VS_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_APC_VS_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_APC_VS_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_APC_VS_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_APC_VS_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_APC_VS_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_APC_VS_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_APC_VS_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_APC_VS_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_APC_VS_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_APC_VS_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_APC_VS_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_APC_VS_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_APC_VS_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_APC_VS_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_APC_VS_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_APC_VS_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_APC_VS_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_APC_VS_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_MDSS_VS_0_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a058)
#define HWIO_GCC_MDSS_VS_0_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a058)
#define HWIO_GCC_MDSS_VS_0_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a058)
#define HWIO_GCC_MDSS_VS_0_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_MDSS_VS_0_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_MDSS_VS_0_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MDSS_VS_0_CBCR_ADDR, HWIO_GCC_MDSS_VS_0_CBCR_RMSK)
#define HWIO_GCC_MDSS_VS_0_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MDSS_VS_0_CBCR_ADDR, m)
#define HWIO_GCC_MDSS_VS_0_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MDSS_VS_0_CBCR_ADDR,v)
#define HWIO_GCC_MDSS_VS_0_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MDSS_VS_0_CBCR_ADDR,m,v,HWIO_GCC_MDSS_VS_0_CBCR_IN)
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_MDSS_VS_0_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_MDSS_VS_0_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_MDSS_VS_0_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_MDSS_VS_0_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_MDSS_VS_0_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_MDSS_VS_0_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_MDSS_VS_0_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_MDSS_VS_0_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_MDSS_VS_0_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MDSS_VS_0_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MDSS_VS_0_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_MDSS_VS_1_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006a05c)
#define HWIO_GCC_MDSS_VS_1_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006a05c)
#define HWIO_GCC_MDSS_VS_1_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006a05c)
#define HWIO_GCC_MDSS_VS_1_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_MDSS_VS_1_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_MDSS_VS_1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MDSS_VS_1_CBCR_ADDR, HWIO_GCC_MDSS_VS_1_CBCR_RMSK)
#define HWIO_GCC_MDSS_VS_1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MDSS_VS_1_CBCR_ADDR, m)
#define HWIO_GCC_MDSS_VS_1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MDSS_VS_1_CBCR_ADDR,v)
#define HWIO_GCC_MDSS_VS_1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MDSS_VS_1_CBCR_ADDR,m,v,HWIO_GCC_MDSS_VS_1_CBCR_IN)
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_MDSS_VS_1_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_MDSS_VS_1_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_MDSS_VS_1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_MDSS_VS_1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_MDSS_VS_1_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_MDSS_VS_1_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_MDSS_VS_1_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_MDSS_VS_1_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_MDSS_VS_1_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_MDSS_VS_1_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MDSS_VS_1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_DCC_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00074000)
#define HWIO_GCC_DCC_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00074000)
#define HWIO_GCC_DCC_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00074000)
#define HWIO_GCC_DCC_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_DCC_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_DCC_BCR_IN          \
        in_dword_masked(HWIO_GCC_DCC_BCR_ADDR, HWIO_GCC_DCC_BCR_RMSK)
#define HWIO_GCC_DCC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DCC_BCR_ADDR, m)
#define HWIO_GCC_DCC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_DCC_BCR_ADDR,v)
#define HWIO_GCC_DCC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DCC_BCR_ADDR,m,v,HWIO_GCC_DCC_BCR_IN)
#define HWIO_GCC_DCC_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_DCC_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_DCC_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_DCC_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_DCC_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00074004)
#define HWIO_GCC_DCC_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00074004)
#define HWIO_GCC_DCC_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00074004)
#define HWIO_GCC_DCC_AHB_CBCR_RMSK                                                                     0x81d0700f
#define HWIO_GCC_DCC_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_DCC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DCC_AHB_CBCR_ADDR, HWIO_GCC_DCC_AHB_CBCR_RMSK)
#define HWIO_GCC_DCC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DCC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_DCC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DCC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_DCC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DCC_AHB_CBCR_ADDR,m,v,HWIO_GCC_DCC_AHB_CBCR_IN)
#define HWIO_GCC_DCC_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_DCC_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_DCC_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_DCC_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_DCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_CORE_ON_BMSK                                                       0x4000
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_CORE_ON_SHFT                                                          0xe
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                     0x2000
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                        0xd
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                    0x1000
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                       0xc
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_DCC_AHB_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_DCC_AHB_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_DCC_AHB_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_DCC_AHB_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_DCC_AHB_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_DCC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_DCC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_DCC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_DCC_AHB_SREGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00074008)
#define HWIO_GCC_DCC_AHB_SREGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00074008)
#define HWIO_GCC_DCC_AHB_SREGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00074008)
#define HWIO_GCC_DCC_AHB_SREGR_RMSK                                                                     0xf1ffffe
#define HWIO_GCC_DCC_AHB_SREGR_ATTR                                                                           0x3
#define HWIO_GCC_DCC_AHB_SREGR_IN          \
        in_dword_masked(HWIO_GCC_DCC_AHB_SREGR_ADDR, HWIO_GCC_DCC_AHB_SREGR_RMSK)
#define HWIO_GCC_DCC_AHB_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DCC_AHB_SREGR_ADDR, m)
#define HWIO_GCC_DCC_AHB_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_DCC_AHB_SREGR_ADDR,v)
#define HWIO_GCC_DCC_AHB_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DCC_AHB_SREGR_ADDR,m,v,HWIO_GCC_DCC_AHB_SREGR_IN)
#define HWIO_GCC_DCC_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                           0xf000000
#define HWIO_GCC_DCC_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                                0x18
#define HWIO_GCC_DCC_AHB_SREGR_PWR_FSM_CLK_SEL_BMSK                                                      0x100000
#define HWIO_GCC_DCC_AHB_SREGR_PWR_FSM_CLK_SEL_SHFT                                                          0x14
#define HWIO_GCC_DCC_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                              0xf0000
#define HWIO_GCC_DCC_AHB_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                 0x10
#define HWIO_GCC_DCC_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                                0x8000
#define HWIO_GCC_DCC_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                   0xf
#define HWIO_GCC_DCC_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                         0x0
#define HWIO_GCC_DCC_AHB_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                            0x1
#define HWIO_GCC_DCC_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                 0x4000
#define HWIO_GCC_DCC_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                    0xe
#define HWIO_GCC_DCC_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                    0x0
#define HWIO_GCC_DCC_AHB_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                 0x1
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                                0x2000
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                   0xd
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                       0x0
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                          0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                            0x1000
#define HWIO_GCC_DCC_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                               0xc
#define HWIO_GCC_DCC_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                      0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                         0x1
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CORE_ON_ACK_BMSK                                                         0x800
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CORE_ON_ACK_SHFT                                                           0xb
#define HWIO_GCC_DCC_AHB_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                       0x400
#define HWIO_GCC_DCC_AHB_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                         0xa
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                                0x300
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                  0x8
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                         0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                         0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                         0x2
#define HWIO_GCC_DCC_AHB_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                         0x3
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_ENABLE_BMSK                                                           0x80
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_ENABLE_SHFT                                                            0x7
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_DCC_AHB_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_DCC_AHB_SREGR_FORCE_CLK_ON_BMSK                                                             0x40
#define HWIO_GCC_DCC_AHB_SREGR_FORCE_CLK_ON_SHFT                                                              0x6
#define HWIO_GCC_DCC_AHB_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                     0x0
#define HWIO_GCC_DCC_AHB_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                       0x20
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                        0x5
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                               0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                          0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SLP_STG_BMSK                                                           0x10
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SLP_STG_SHFT                                                            0x4
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                  0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                     0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                          0x8
#define HWIO_GCC_DCC_AHB_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                          0x3
#define HWIO_GCC_DCC_AHB_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                               0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                  0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                     0x4
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                     0x2
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                 0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                         0x2
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                         0x1
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                   0x0
#define HWIO_GCC_DCC_AHB_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                    0x1

#define HWIO_GCC_DCC_AHB_CFG_SREGR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007400c)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007400c)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007400c)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_RMSK                                                                0xffffffff
#define HWIO_GCC_DCC_AHB_CFG_SREGR_ATTR                                                                       0x3
#define HWIO_GCC_DCC_AHB_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_DCC_AHB_CFG_SREGR_ADDR, HWIO_GCC_DCC_AHB_CFG_SREGR_RMSK)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DCC_AHB_CFG_SREGR_ADDR, m)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_DCC_AHB_CFG_SREGR_ADDR,v)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DCC_AHB_CFG_SREGR_ADDR,m,v,HWIO_GCC_DCC_AHB_CFG_SREGR_IN)
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                             0xfc000000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                   0x1a
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                        0x2000000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                             0x19
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                          0x1000000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                               0x18
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                             0x800000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                 0x17
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                               0x400000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                   0x16
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                    0x3f0000
#define HWIO_GCC_DCC_AHB_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                        0x10
#define HWIO_GCC_DCC_AHB_CFG_SREGR_SLEEP_TIMER_BMSK                                                        0xff00
#define HWIO_GCC_DCC_AHB_CFG_SREGR_SLEEP_TIMER_SHFT                                                           0x8
#define HWIO_GCC_DCC_AHB_CFG_SREGR_WAKEUP_TIMER_BMSK                                                         0xff
#define HWIO_GCC_DCC_AHB_CFG_SREGR_WAKEUP_TIMER_SHFT                                                          0x0

#define HWIO_GCC_IPA_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00079000)
#define HWIO_GCC_IPA_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079000)
#define HWIO_GCC_IPA_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079000)
#define HWIO_GCC_IPA_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_IPA_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_IPA_BCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_BCR_ADDR, HWIO_GCC_IPA_BCR_RMSK)
#define HWIO_GCC_IPA_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_BCR_ADDR, m)
#define HWIO_GCC_IPA_BCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_BCR_ADDR,v)
#define HWIO_GCC_IPA_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_BCR_ADDR,m,v,HWIO_GCC_IPA_BCR_IN)
#define HWIO_GCC_IPA_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_IPA_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_IPA_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_IPA_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_IPA_GDSCR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00079004)
#define HWIO_GCC_IPA_GDSCR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079004)
#define HWIO_GCC_IPA_GDSCR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079004)
#define HWIO_GCC_IPA_GDSCR_RMSK                                                                        0xf8ffffff
#define HWIO_GCC_IPA_GDSCR_ATTR                                                                               0x3
#define HWIO_GCC_IPA_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_GDSCR_ADDR, HWIO_GCC_IPA_GDSCR_RMSK)
#define HWIO_GCC_IPA_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_GDSCR_ADDR, m)
#define HWIO_GCC_IPA_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_GDSCR_ADDR,v)
#define HWIO_GCC_IPA_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_GDSCR_ADDR,m,v,HWIO_GCC_IPA_GDSCR_IN)
#define HWIO_GCC_IPA_GDSCR_PWR_ON_BMSK                                                                 0x80000000
#define HWIO_GCC_IPA_GDSCR_PWR_ON_SHFT                                                                       0x1f
#define HWIO_GCC_IPA_GDSCR_GDSC_STATE_BMSK                                                             0x78000000
#define HWIO_GCC_IPA_GDSCR_GDSC_STATE_SHFT                                                                   0x1b
#define HWIO_GCC_IPA_GDSCR_EN_REST_WAIT_BMSK                                                             0xf00000
#define HWIO_GCC_IPA_GDSCR_EN_REST_WAIT_SHFT                                                                 0x14
#define HWIO_GCC_IPA_GDSCR_EN_FEW_WAIT_BMSK                                                               0xf0000
#define HWIO_GCC_IPA_GDSCR_EN_FEW_WAIT_SHFT                                                                  0x10
#define HWIO_GCC_IPA_GDSCR_CLK_DIS_WAIT_BMSK                                                               0xf000
#define HWIO_GCC_IPA_GDSCR_CLK_DIS_WAIT_SHFT                                                                  0xc
#define HWIO_GCC_IPA_GDSCR_RETAIN_FF_ENABLE_BMSK                                                            0x800
#define HWIO_GCC_IPA_GDSCR_RETAIN_FF_ENABLE_SHFT                                                              0xb
#define HWIO_GCC_IPA_GDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_IPA_GDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_IPA_GDSCR_RESTORE_BMSK                                                                     0x400
#define HWIO_GCC_IPA_GDSCR_RESTORE_SHFT                                                                       0xa
#define HWIO_GCC_IPA_GDSCR_RESTORE_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_IPA_GDSCR_RESTORE_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_IPA_GDSCR_SAVE_BMSK                                                                        0x200
#define HWIO_GCC_IPA_GDSCR_SAVE_SHFT                                                                          0x9
#define HWIO_GCC_IPA_GDSCR_SAVE_DISABLE_FVAL                                                                  0x0
#define HWIO_GCC_IPA_GDSCR_SAVE_ENABLE_FVAL                                                                   0x1
#define HWIO_GCC_IPA_GDSCR_RETAIN_BMSK                                                                      0x100
#define HWIO_GCC_IPA_GDSCR_RETAIN_SHFT                                                                        0x8
#define HWIO_GCC_IPA_GDSCR_RETAIN_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_IPA_GDSCR_RETAIN_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_IPA_GDSCR_EN_REST_BMSK                                                                      0x80
#define HWIO_GCC_IPA_GDSCR_EN_REST_SHFT                                                                       0x7
#define HWIO_GCC_IPA_GDSCR_EN_REST_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_IPA_GDSCR_EN_REST_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_IPA_GDSCR_EN_FEW_BMSK                                                                       0x40
#define HWIO_GCC_IPA_GDSCR_EN_FEW_SHFT                                                                        0x6
#define HWIO_GCC_IPA_GDSCR_EN_FEW_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_IPA_GDSCR_EN_FEW_ENABLE_FVAL                                                                 0x1
#define HWIO_GCC_IPA_GDSCR_CLAMP_IO_BMSK                                                                     0x20
#define HWIO_GCC_IPA_GDSCR_CLAMP_IO_SHFT                                                                      0x5
#define HWIO_GCC_IPA_GDSCR_CLAMP_IO_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_IPA_GDSCR_CLAMP_IO_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_IPA_GDSCR_CLK_DISABLE_BMSK                                                                  0x10
#define HWIO_GCC_IPA_GDSCR_CLK_DISABLE_SHFT                                                                   0x4
#define HWIO_GCC_IPA_GDSCR_CLK_DISABLE_CLK_NOT_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_IPA_GDSCR_CLK_DISABLE_CLK_IS_DISABLE_FVAL                                                    0x1
#define HWIO_GCC_IPA_GDSCR_PD_ARES_BMSK                                                                       0x8
#define HWIO_GCC_IPA_GDSCR_PD_ARES_SHFT                                                                       0x3
#define HWIO_GCC_IPA_GDSCR_PD_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_IPA_GDSCR_PD_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_IPA_GDSCR_SW_OVERRIDE_BMSK                                                                   0x4
#define HWIO_GCC_IPA_GDSCR_SW_OVERRIDE_SHFT                                                                   0x2
#define HWIO_GCC_IPA_GDSCR_SW_OVERRIDE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_IPA_GDSCR_SW_OVERRIDE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_IPA_GDSCR_HW_CONTROL_BMSK                                                                    0x2
#define HWIO_GCC_IPA_GDSCR_HW_CONTROL_SHFT                                                                    0x1
#define HWIO_GCC_IPA_GDSCR_HW_CONTROL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_IPA_GDSCR_HW_CONTROL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_IPA_GDSCR_SW_COLLAPSE_BMSK                                                                   0x1
#define HWIO_GCC_IPA_GDSCR_SW_COLLAPSE_SHFT                                                                   0x0
#define HWIO_GCC_IPA_GDSCR_SW_COLLAPSE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_IPA_GDSCR_SW_COLLAPSE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_IPA_CFG_GDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00079008)
#define HWIO_GCC_IPA_CFG_GDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079008)
#define HWIO_GCC_IPA_CFG_GDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079008)
#define HWIO_GCC_IPA_CFG_GDSCR_RMSK                                                                     0x7ffffff
#define HWIO_GCC_IPA_CFG_GDSCR_ATTR                                                                           0x3
#define HWIO_GCC_IPA_CFG_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CFG_GDSCR_ADDR, HWIO_GCC_IPA_CFG_GDSCR_RMSK)
#define HWIO_GCC_IPA_CFG_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CFG_GDSCR_ADDR, m)
#define HWIO_GCC_IPA_CFG_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CFG_GDSCR_ADDR,v)
#define HWIO_GCC_IPA_CFG_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CFG_GDSCR_ADDR,m,v,HWIO_GCC_IPA_CFG_GDSCR_IN)
#define HWIO_GCC_IPA_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4000000
#define HWIO_GCC_IPA_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                               0x1a
#define HWIO_GCC_IPA_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_IPA_CFG_GDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PWR_DWN_START_BMSK                                                  0x2000000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PWR_DWN_START_SHFT                                                       0x19
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PWR_UP_START_BMSK                                                   0x1000000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PWR_UP_START_SHFT                                                        0x18
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_BMSK                                            0xf00000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_CFG_FSM_STATE_STATUS_SHFT                                                0x14
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_BMSK                                               0x80000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_PWR_ACK_STATUS_SHFT                                                  0x13
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_ENR_ACK_STATUS_BMSK                                                   0x40000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_ENR_ACK_STATUS_SHFT                                                      0x12
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_ENF_ACK_STATUS_BMSK                                                   0x20000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_ENF_ACK_STATUS_SHFT                                                      0x11
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_BMSK                                                0x10000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_POWER_UP_COMPLETE_SHFT                                                   0x10
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_BMSK                                               0x8000
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_POWER_DOWN_COMPLETE_SHFT                                                  0xf
#define HWIO_GCC_IPA_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_BMSK                                              0x7800
#define HWIO_GCC_IPA_CFG_GDSCR_SOFTWARE_CONTROL_OVERRIDE_SHFT                                                 0xb
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_HANDSHAKE_DIS_BMSK                                                      0x400
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_HANDSHAKE_DIS_SHFT                                                        0xa
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_BMSK                                               0x200
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_PERI_FORCE_IN_SW_SHFT                                                 0x9
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_BMSK                                               0x100
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_MEM_CORE_FORCE_IN_SW_SHFT                                                 0x8
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_BMSK                                                   0x80
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PHASE_RESET_EN_SW_SHFT                                                    0x7
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_BMSK                                          0x60
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PHASE_RESET_DELAY_COUNT_SW_SHFT                                           0x5
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_BMSK                                                    0x10
#define HWIO_GCC_IPA_CFG_GDSCR_GDSC_PSCBC_PWR_DWN_SW_SHFT                                                     0x4
#define HWIO_GCC_IPA_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                              0x8
#define HWIO_GCC_IPA_CFG_GDSCR_UNCLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                              0x3
#define HWIO_GCC_IPA_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_BMSK                                            0x4
#define HWIO_GCC_IPA_CFG_GDSCR_SAVE_RESTORE_SOFTWARE_OVERRIDE_SHFT                                            0x2
#define HWIO_GCC_IPA_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_BMSK                                                0x2
#define HWIO_GCC_IPA_CFG_GDSCR_CLAMP_IO_SOFTWARE_OVERRIDE_SHFT                                                0x1
#define HWIO_GCC_IPA_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_BMSK                                             0x1
#define HWIO_GCC_IPA_CFG_GDSCR_DISABLE_CLK_SOFTWARE_OVERRIDE_SHFT                                             0x0

#define HWIO_GCC_IPA_CFG2_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0007900c)
#define HWIO_GCC_IPA_CFG2_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007900c)
#define HWIO_GCC_IPA_CFG2_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007900c)
#define HWIO_GCC_IPA_CFG2_GDSCR_RMSK                                                                      0x7ffff
#define HWIO_GCC_IPA_CFG2_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_IPA_CFG2_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CFG2_GDSCR_ADDR, HWIO_GCC_IPA_CFG2_GDSCR_RMSK)
#define HWIO_GCC_IPA_CFG2_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CFG2_GDSCR_ADDR, m)
#define HWIO_GCC_IPA_CFG2_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CFG2_GDSCR_ADDR,v)
#define HWIO_GCC_IPA_CFG2_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CFG2_GDSCR_ADDR,m,v,HWIO_GCC_IPA_CFG2_GDSCR_IN)
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_BMSK                                          0x40000
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_MEM_PWRUP_ACK_OVERRIDE_SHFT                                             0x12
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_BMSK                                      0x20000
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_PWRDWN_ENABLE_ACK_OVERRIDE_SHFT                                         0x11
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_BMSK                                                    0x10000
#define HWIO_GCC_IPA_CFG2_GDSCR_GDSC_CLAMP_MEM_SW_SHFT                                                       0x10
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_MEM_PWR_UP_BMSK                                                        0xf000
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_MEM_PWR_UP_SHFT                                                           0xc
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_BMSK                                                 0xf00
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_DEASSERT_CLAMP_MEM_SHFT                                                   0x8
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_BMSK                                                    0xf0
#define HWIO_GCC_IPA_CFG2_GDSCR_DLY_ASSERT_CLAMP_MEM_SHFT                                                     0x4
#define HWIO_GCC_IPA_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_BMSK                                                      0xf
#define HWIO_GCC_IPA_CFG2_GDSCR_MEM_PWR_DWN_TIMEOUT_SHFT                                                      0x0

#define HWIO_GCC_IPA_CFG3_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00079010)
#define HWIO_GCC_IPA_CFG3_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079010)
#define HWIO_GCC_IPA_CFG3_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079010)
#define HWIO_GCC_IPA_CFG3_GDSCR_RMSK                                                                    0x7ffffff
#define HWIO_GCC_IPA_CFG3_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_IPA_CFG3_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CFG3_GDSCR_ADDR, HWIO_GCC_IPA_CFG3_GDSCR_RMSK)
#define HWIO_GCC_IPA_CFG3_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CFG3_GDSCR_ADDR, m)
#define HWIO_GCC_IPA_CFG3_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CFG3_GDSCR_ADDR,v)
#define HWIO_GCC_IPA_CFG3_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CFG3_GDSCR_ADDR,m,v,HWIO_GCC_IPA_CFG3_GDSCR_IN)
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_BMSK                                  0x4000000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_STATUS_SHFT                                       0x1a
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_BMSK                                               0x2000000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_SHFT                                                    0x19
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_BMSK                                          0x1e00000
#define HWIO_GCC_IPA_CFG3_GDSCR_DLY_ACCU_RED_SHIFTER_DONE_SHFT                                               0x15
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_BMSK                                           0x100000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_SHFT                                               0x14
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_DISABLE_FVAL                                        0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_TIMER_EN_SW_ENABLE_FVAL                                         0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_BMSK                                  0x80000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_SHFT                                     0x13
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_DISABLE_FVAL                              0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_DONE_OVERRIDE_ENABLE_FVAL                               0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_BMSK                                      0x40000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_SHFT                                         0x12
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_DISABLE_FVAL                                  0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_CLK_EN_SW_ENABLE_FVAL                                   0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_BMSK                                       0x20000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_SHFT                                          0x11
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_DISABLE_FVAL                                   0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SHIFTER_START_SW_ENABLE_FVAL                                    0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_BMSK                                            0x10000
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_SHFT                                               0x10
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_ACCU_RED_SW_OVERRIDE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_BMSK                                                    0xff00
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_SPARE_CTRL_IN_SHFT                                                       0x8
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_BMSK                                                     0xff
#define HWIO_GCC_IPA_CFG3_GDSCR_GDSC_SPARE_CTRL_OUT_SHFT                                                      0x0

#define HWIO_GCC_IPA_CFG4_GDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00079014)
#define HWIO_GCC_IPA_CFG4_GDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079014)
#define HWIO_GCC_IPA_CFG4_GDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079014)
#define HWIO_GCC_IPA_CFG4_GDSCR_RMSK                                                                     0xffffff
#define HWIO_GCC_IPA_CFG4_GDSCR_ATTR                                                                          0x3
#define HWIO_GCC_IPA_CFG4_GDSCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CFG4_GDSCR_ADDR, HWIO_GCC_IPA_CFG4_GDSCR_RMSK)
#define HWIO_GCC_IPA_CFG4_GDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CFG4_GDSCR_ADDR, m)
#define HWIO_GCC_IPA_CFG4_GDSCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CFG4_GDSCR_ADDR,v)
#define HWIO_GCC_IPA_CFG4_GDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CFG4_GDSCR_ADDR,m,v,HWIO_GCC_IPA_CFG4_GDSCR_IN)
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_UNCLAMPIO_BMSK                                                       0xf00000
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_UNCLAMPIO_SHFT                                                           0x14
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_RESTOREFF_BMSK                                                        0xf0000
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_RESTOREFF_SHFT                                                           0x10
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_NORETAINFF_BMSK                                                        0xf000
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_NORETAINFF_SHFT                                                           0xc
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_DEASSERTARES_BMSK                                                       0xf00
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_DEASSERTARES_SHFT                                                         0x8
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_CLAMPIO_BMSK                                                             0xf0
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_CLAMPIO_SHFT                                                              0x4
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_RETAINFF_BMSK                                                             0xf
#define HWIO_GCC_IPA_CFG4_GDSCR_DLY_RETAINFF_SHFT                                                             0x0

#define HWIO_GCC_IPA_2X_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079018)
#define HWIO_GCC_IPA_2X_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079018)
#define HWIO_GCC_IPA_2X_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079018)
#define HWIO_GCC_IPA_2X_CBCR_RMSK                                                                      0x81d07005
#define HWIO_GCC_IPA_2X_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_IPA_2X_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_CBCR_ADDR, HWIO_GCC_IPA_2X_CBCR_RMSK)
#define HWIO_GCC_IPA_2X_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_CBCR_ADDR, m)
#define HWIO_GCC_IPA_2X_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_CBCR_ADDR,v)
#define HWIO_GCC_IPA_2X_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_CBCR_ADDR,m,v,HWIO_GCC_IPA_2X_CBCR_IN)
#define HWIO_GCC_IPA_2X_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_IPA_2X_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_IPA_2X_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_IPA_2X_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_IPA_2X_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_CORE_ON_BMSK                                                        0x4000
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_CORE_ON_SHFT                                                           0xe
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                      0x2000
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                         0xd
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                     0x1000
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                        0xc
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_IPA_2X_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_IPA_2X_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_IPA_2X_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_IPA_2X_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_IPA_2X_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_IPA_2X_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_IPA_2X_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_IPA_2X_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_IPA_2X_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_IPA_2X_SREGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007901c)
#define HWIO_GCC_IPA_2X_SREGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007901c)
#define HWIO_GCC_IPA_2X_SREGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007901c)
#define HWIO_GCC_IPA_2X_SREGR_RMSK                                                                      0xf1ffffe
#define HWIO_GCC_IPA_2X_SREGR_ATTR                                                                            0x3
#define HWIO_GCC_IPA_2X_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_SREGR_ADDR, HWIO_GCC_IPA_2X_SREGR_RMSK)
#define HWIO_GCC_IPA_2X_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_SREGR_ADDR, m)
#define HWIO_GCC_IPA_2X_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_SREGR_ADDR,v)
#define HWIO_GCC_IPA_2X_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_SREGR_ADDR,m,v,HWIO_GCC_IPA_2X_SREGR_IN)
#define HWIO_GCC_IPA_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                            0xf000000
#define HWIO_GCC_IPA_2X_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                                 0x18
#define HWIO_GCC_IPA_2X_SREGR_PWR_FSM_CLK_SEL_BMSK                                                       0x100000
#define HWIO_GCC_IPA_2X_SREGR_PWR_FSM_CLK_SEL_SHFT                                                           0x14
#define HWIO_GCC_IPA_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                               0xf0000
#define HWIO_GCC_IPA_2X_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                  0x10
#define HWIO_GCC_IPA_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                                 0x8000
#define HWIO_GCC_IPA_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                    0xf
#define HWIO_GCC_IPA_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                          0x0
#define HWIO_GCC_IPA_2X_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                             0x1
#define HWIO_GCC_IPA_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                  0x4000
#define HWIO_GCC_IPA_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                     0xe
#define HWIO_GCC_IPA_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                     0x0
#define HWIO_GCC_IPA_2X_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                  0x1
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                                 0x2000
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                    0xd
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                        0x0
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                           0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                             0x1000
#define HWIO_GCC_IPA_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                                0xc
#define HWIO_GCC_IPA_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                       0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                          0x1
#define HWIO_GCC_IPA_2X_SREGR_MEM_CORE_ON_ACK_BMSK                                                          0x800
#define HWIO_GCC_IPA_2X_SREGR_MEM_CORE_ON_ACK_SHFT                                                            0xb
#define HWIO_GCC_IPA_2X_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                        0x400
#define HWIO_GCC_IPA_2X_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                          0xa
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                                 0x300
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                   0x8
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                          0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                          0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                          0x2
#define HWIO_GCC_IPA_2X_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                          0x3
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_ENABLE_BMSK                                                            0x80
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_ENABLE_SHFT                                                             0x7
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_IPA_2X_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_IPA_2X_SREGR_FORCE_CLK_ON_BMSK                                                              0x40
#define HWIO_GCC_IPA_2X_SREGR_FORCE_CLK_ON_SHFT                                                               0x6
#define HWIO_GCC_IPA_2X_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                      0x0
#define HWIO_GCC_IPA_2X_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                        0x20
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                         0x5
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                                0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                           0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SLP_STG_BMSK                                                            0x10
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SLP_STG_SHFT                                                             0x4
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                   0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                      0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                           0x8
#define HWIO_GCC_IPA_2X_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                           0x3
#define HWIO_GCC_IPA_2X_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                                0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                   0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                      0x4
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                      0x2
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                  0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                          0x2
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                          0x1
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                    0x0
#define HWIO_GCC_IPA_2X_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                     0x1

#define HWIO_GCC_IPA_2X_CFG_SREGR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00079020)
#define HWIO_GCC_IPA_2X_CFG_SREGR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079020)
#define HWIO_GCC_IPA_2X_CFG_SREGR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079020)
#define HWIO_GCC_IPA_2X_CFG_SREGR_RMSK                                                                 0xffffffff
#define HWIO_GCC_IPA_2X_CFG_SREGR_ATTR                                                                        0x3
#define HWIO_GCC_IPA_2X_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_CFG_SREGR_ADDR, HWIO_GCC_IPA_2X_CFG_SREGR_RMSK)
#define HWIO_GCC_IPA_2X_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_CFG_SREGR_ADDR, m)
#define HWIO_GCC_IPA_2X_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_CFG_SREGR_ADDR,v)
#define HWIO_GCC_IPA_2X_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_CFG_SREGR_ADDR,m,v,HWIO_GCC_IPA_2X_CFG_SREGR_IN)
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                              0xfc000000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                    0x1a
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                         0x2000000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                              0x19
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                           0x1000000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                                0x18
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                              0x800000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                  0x17
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                                0x400000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                    0x16
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                     0x3f0000
#define HWIO_GCC_IPA_2X_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                         0x10
#define HWIO_GCC_IPA_2X_CFG_SREGR_SLEEP_TIMER_BMSK                                                         0xff00
#define HWIO_GCC_IPA_2X_CFG_SREGR_SLEEP_TIMER_SHFT                                                            0x8
#define HWIO_GCC_IPA_2X_CFG_SREGR_WAKEUP_TIMER_BMSK                                                          0xff
#define HWIO_GCC_IPA_2X_CFG_SREGR_WAKEUP_TIMER_SHFT                                                           0x0

#define HWIO_GCC_IPA_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00079024)
#define HWIO_GCC_IPA_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079024)
#define HWIO_GCC_IPA_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079024)
#define HWIO_GCC_IPA_CBCR_RMSK                                                                         0x81d07005
#define HWIO_GCC_IPA_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_IPA_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CBCR_ADDR, HWIO_GCC_IPA_CBCR_RMSK)
#define HWIO_GCC_IPA_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CBCR_ADDR, m)
#define HWIO_GCC_IPA_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CBCR_ADDR,v)
#define HWIO_GCC_IPA_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CBCR_ADDR,m,v,HWIO_GCC_IPA_CBCR_IN)
#define HWIO_GCC_IPA_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_IPA_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_IPA_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_IPA_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_IPA_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_IPA_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_IPA_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_IPA_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_IPA_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                       0x100000
#define HWIO_GCC_IPA_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                           0x14
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_CORE_ON_BMSK                                                           0x4000
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_CORE_ON_SHFT                                                              0xe
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_CORE_ON_FORCE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_CORE_ON_FORCE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_ON_BMSK                                                         0x2000
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_ON_SHFT                                                            0xd
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_ON_FORCE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_ON_FORCE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_OFF_BMSK                                                        0x1000
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_OFF_SHFT                                                           0xc
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_IPA_CBCR_FORCE_MEM_PERIPH_OFF_FORCE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_IPA_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_IPA_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_IPA_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_IPA_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_IPA_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_IPA_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_IPA_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_IPA_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_IPA_SREGR_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00079028)
#define HWIO_GCC_IPA_SREGR_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079028)
#define HWIO_GCC_IPA_SREGR_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079028)
#define HWIO_GCC_IPA_SREGR_RMSK                                                                         0xf1ffffe
#define HWIO_GCC_IPA_SREGR_ATTR                                                                               0x3
#define HWIO_GCC_IPA_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_SREGR_ADDR, HWIO_GCC_IPA_SREGR_RMSK)
#define HWIO_GCC_IPA_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_SREGR_ADDR, m)
#define HWIO_GCC_IPA_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_SREGR_ADDR,v)
#define HWIO_GCC_IPA_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_SREGR_ADDR,m,v,HWIO_GCC_IPA_SREGR_IN)
#define HWIO_GCC_IPA_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_BMSK                                               0xf000000
#define HWIO_GCC_IPA_SREGR_SREG_PSCBC_SPARE_CTRL_OUT_SHFT                                                    0x18
#define HWIO_GCC_IPA_SREGR_PWR_FSM_CLK_SEL_BMSK                                                          0x100000
#define HWIO_GCC_IPA_SREGR_PWR_FSM_CLK_SEL_SHFT                                                              0x14
#define HWIO_GCC_IPA_SREGR_SREG_PSCBC_SPARE_CTRL_IN_BMSK                                                  0xf0000
#define HWIO_GCC_IPA_SREGR_SREG_PSCBC_SPARE_CTRL_IN_SHFT                                                     0x10
#define HWIO_GCC_IPA_SREGR_IGNORE_GDSC_PWR_DWN_CSR_BMSK                                                    0x8000
#define HWIO_GCC_IPA_SREGR_IGNORE_GDSC_PWR_DWN_CSR_SHFT                                                       0xf
#define HWIO_GCC_IPA_SREGR_IGNORE_GDSC_PWR_DWN_CSR_NO_IGNORE_FVAL                                             0x0
#define HWIO_GCC_IPA_SREGR_IGNORE_GDSC_PWR_DWN_CSR_IGNORE_FVAL                                                0x1
#define HWIO_GCC_IPA_SREGR_PSCBC_SLP_STG_MODE_CSR_BMSK                                                     0x4000
#define HWIO_GCC_IPA_SREGR_PSCBC_SLP_STG_MODE_CSR_SHFT                                                        0xe
#define HWIO_GCC_IPA_SREGR_PSCBC_SLP_STG_MODE_CSR_SREG_PSCBC_MODE_FVAL                                        0x0
#define HWIO_GCC_IPA_SREGR_PSCBC_SLP_STG_MODE_CSR_PSCBC_SLP_STG_MODE_FVAL                                     0x1
#define HWIO_GCC_IPA_SREGR_MEM_CPH_RST_SW_OVERRIDE_BMSK                                                    0x2000
#define HWIO_GCC_IPA_SREGR_MEM_CPH_RST_SW_OVERRIDE_SHFT                                                       0xd
#define HWIO_GCC_IPA_SREGR_MEM_CPH_RST_SW_OVERRIDE_NO_OVERRIDE_FVAL                                           0x0
#define HWIO_GCC_IPA_SREGR_MEM_CPH_RST_SW_OVERRIDE_OVERRIDE_FVAL                                              0x1
#define HWIO_GCC_IPA_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_BMSK                                                0x1000
#define HWIO_GCC_IPA_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_SHFT                                                   0xc
#define HWIO_GCC_IPA_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_NO_RESET_FVAL                                          0x0
#define HWIO_GCC_IPA_SREGR_SW_SM_PSCBC_SEQ_IN_OVERRIDE_RESET_FVAL                                             0x1
#define HWIO_GCC_IPA_SREGR_MEM_CORE_ON_ACK_BMSK                                                             0x800
#define HWIO_GCC_IPA_SREGR_MEM_CORE_ON_ACK_SHFT                                                               0xb
#define HWIO_GCC_IPA_SREGR_MEM_PERIPH_ON_ACK_BMSK                                                           0x400
#define HWIO_GCC_IPA_SREGR_MEM_PERIPH_ON_ACK_SHFT                                                             0xa
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_BMSK                                                    0x300
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_SHFT                                                      0x8
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_1_FVAL                                             0x0
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_2_FVAL                                             0x1
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_4_FVAL                                             0x2
#define HWIO_GCC_IPA_SREGR_SW_DIV_RATIO_SLP_STG_CLK_DIV_BY_8_FVAL                                             0x3
#define HWIO_GCC_IPA_SREGR_MEM_CPH_ENABLE_BMSK                                                               0x80
#define HWIO_GCC_IPA_SREGR_MEM_CPH_ENABLE_SHFT                                                                0x7
#define HWIO_GCC_IPA_SREGR_MEM_CPH_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_IPA_SREGR_MEM_CPH_ENABLE_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_IPA_SREGR_FORCE_CLK_ON_BMSK                                                                 0x40
#define HWIO_GCC_IPA_SREGR_FORCE_CLK_ON_SHFT                                                                  0x6
#define HWIO_GCC_IPA_SREGR_FORCE_CLK_ON_NO_FORCE_FVAL                                                         0x0
#define HWIO_GCC_IPA_SREGR_FORCE_CLK_ON_FORCE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_IPA_SREGR_SW_RST_SEL_SLP_STG_BMSK                                                           0x20
#define HWIO_GCC_IPA_SREGR_SW_RST_SEL_SLP_STG_SHFT                                                            0x5
#define HWIO_GCC_IPA_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_HARDWARE_ARES_FVAL                                   0x0
#define HWIO_GCC_IPA_SREGR_SW_RST_SEL_SLP_STG_SELECT_THE_SW_RST_SLP_STG_BIT_FVAL                              0x1
#define HWIO_GCC_IPA_SREGR_SW_RST_SLP_STG_BMSK                                                               0x10
#define HWIO_GCC_IPA_SREGR_SW_RST_SLP_STG_SHFT                                                                0x4
#define HWIO_GCC_IPA_SREGR_SW_RST_SLP_STG_DE_ASSERTION_OF_THE_RESET_FVAL                                      0x0
#define HWIO_GCC_IPA_SREGR_SW_RST_SLP_STG_ASSERTION_OF_THE_RESET_FVAL                                         0x1
#define HWIO_GCC_IPA_SREGR_SW_CTRL_PWR_DOWN_BMSK                                                              0x8
#define HWIO_GCC_IPA_SREGR_SW_CTRL_PWR_DOWN_SHFT                                                              0x3
#define HWIO_GCC_IPA_SREGR_SW_CTRL_PWR_DOWN_NO_SW_CTRL_FVAL                                                   0x0
#define HWIO_GCC_IPA_SREGR_SW_CTRL_PWR_DOWN_SW_CTRL_FVAL                                                      0x1
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SEL_SLP_STG_BMSK                                                         0x4
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SEL_SLP_STG_SHFT                                                         0x2
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_HW_FSM_FVAL                     0x0
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SEL_SLP_STG_SLP_STG_CLK_GATE_CONTROLD_BY_SW_CLK_EN_SLP_STG_BIT_FVAL        0x1
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SLP_STG_BMSK                                                             0x2
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SLP_STG_SHFT                                                             0x1
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_DISABLE_FVAL                                       0x0
#define HWIO_GCC_IPA_SREGR_SW_CLK_EN_SLP_STG_SLP_STG_CLOCK_ENABLE_FVAL                                        0x1

#define HWIO_GCC_IPA_CFG_SREGR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007902c)
#define HWIO_GCC_IPA_CFG_SREGR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007902c)
#define HWIO_GCC_IPA_CFG_SREGR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007902c)
#define HWIO_GCC_IPA_CFG_SREGR_RMSK                                                                    0xffffffff
#define HWIO_GCC_IPA_CFG_SREGR_ATTR                                                                           0x3
#define HWIO_GCC_IPA_CFG_SREGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_CFG_SREGR_ADDR, HWIO_GCC_IPA_CFG_SREGR_RMSK)
#define HWIO_GCC_IPA_CFG_SREGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_CFG_SREGR_ADDR, m)
#define HWIO_GCC_IPA_CFG_SREGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_CFG_SREGR_ADDR,v)
#define HWIO_GCC_IPA_CFG_SREGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_CFG_SREGR_ADDR,m,v,HWIO_GCC_IPA_CFG_SREGR_IN)
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_OFF_TIMER_BMSK                                                 0xfc000000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_OFF_TIMER_SHFT                                                       0x1a
#define HWIO_GCC_IPA_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_BMSK                                            0x2000000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_PERIPH_ON_ACK_STATUS_SHFT                                                 0x19
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_BMSK                                              0x1000000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_ON_ACK_STATUS_SHFT                                                   0x18
#define HWIO_GCC_IPA_CFG_SREGR_MEM_PERIPH_ON_STATUS_BMSK                                                 0x800000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_PERIPH_ON_STATUS_SHFT                                                     0x17
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_ON_STATUS_BMSK                                                   0x400000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CORE_ON_STATUS_SHFT                                                       0x16
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CPH_TIMER_BMSK                                                        0x3f0000
#define HWIO_GCC_IPA_CFG_SREGR_MEM_CPH_TIMER_SHFT                                                            0x10
#define HWIO_GCC_IPA_CFG_SREGR_SLEEP_TIMER_BMSK                                                            0xff00
#define HWIO_GCC_IPA_CFG_SREGR_SLEEP_TIMER_SHFT                                                               0x8
#define HWIO_GCC_IPA_CFG_SREGR_WAKEUP_TIMER_BMSK                                                             0xff
#define HWIO_GCC_IPA_CFG_SREGR_WAKEUP_TIMER_SHFT                                                              0x0

#define HWIO_GCC_IPA_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00079030)
#define HWIO_GCC_IPA_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079030)
#define HWIO_GCC_IPA_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079030)
#define HWIO_GCC_IPA_AHB_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_IPA_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_IPA_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_AHB_CBCR_ADDR, HWIO_GCC_IPA_AHB_CBCR_RMSK)
#define HWIO_GCC_IPA_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_AHB_CBCR_ADDR, m)
#define HWIO_GCC_IPA_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_AHB_CBCR_ADDR,v)
#define HWIO_GCC_IPA_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_AHB_CBCR_ADDR,m,v,HWIO_GCC_IPA_AHB_CBCR_IN)
#define HWIO_GCC_IPA_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_IPA_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_IPA_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_IPA_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_IPA_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_IPA_AHB_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_IPA_AHB_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_IPA_AHB_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_IPA_AHB_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_IPA_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_IPA_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_IPA_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_IPA_XO_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079034)
#define HWIO_GCC_IPA_XO_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079034)
#define HWIO_GCC_IPA_XO_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079034)
#define HWIO_GCC_IPA_XO_CBCR_RMSK                                                                      0x81c00005
#define HWIO_GCC_IPA_XO_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_IPA_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_XO_CBCR_ADDR, HWIO_GCC_IPA_XO_CBCR_RMSK)
#define HWIO_GCC_IPA_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_XO_CBCR_ADDR, m)
#define HWIO_GCC_IPA_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_XO_CBCR_ADDR,v)
#define HWIO_GCC_IPA_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_XO_CBCR_ADDR,m,v,HWIO_GCC_IPA_XO_CBCR_IN)
#define HWIO_GCC_IPA_XO_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_IPA_XO_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_IPA_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_IPA_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_IPA_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_IPA_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_IPA_XO_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_IPA_XO_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_IPA_XO_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_IPA_XO_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_IPA_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_IPA_XO_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_IPA_XO_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_IPA_XO_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_IPA_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_IPA_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_IPA_APB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00079038)
#define HWIO_GCC_IPA_APB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079038)
#define HWIO_GCC_IPA_APB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079038)
#define HWIO_GCC_IPA_APB_CBCR_RMSK                                                                     0x81c0000f
#define HWIO_GCC_IPA_APB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_IPA_APB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_APB_CBCR_ADDR, HWIO_GCC_IPA_APB_CBCR_RMSK)
#define HWIO_GCC_IPA_APB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_APB_CBCR_ADDR, m)
#define HWIO_GCC_IPA_APB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_APB_CBCR_ADDR,v)
#define HWIO_GCC_IPA_APB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_APB_CBCR_ADDR,m,v,HWIO_GCC_IPA_APB_CBCR_IN)
#define HWIO_GCC_IPA_APB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_IPA_APB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_IPA_APB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_IPA_APB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_IPA_APB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_IPA_APB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_IPA_APB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_IPA_APB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_IPA_APB_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_IPA_APB_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_IPA_APB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_IPA_APB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_IPA_APB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_IPA_APB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_IPA_APB_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_IPA_APB_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_IPA_APB_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_IPA_APB_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_IPA_APB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_IPA_APB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_IPA_APB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_IPA_APB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_IPA_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007903c)
#define HWIO_GCC_IPA_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007903c)
#define HWIO_GCC_IPA_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007903c)
#define HWIO_GCC_IPA_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_IPA_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_IPA_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPA_AT_CBCR_ADDR, HWIO_GCC_IPA_AT_CBCR_RMSK)
#define HWIO_GCC_IPA_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_AT_CBCR_ADDR, m)
#define HWIO_GCC_IPA_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_AT_CBCR_ADDR,v)
#define HWIO_GCC_IPA_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_AT_CBCR_ADDR,m,v,HWIO_GCC_IPA_AT_CBCR_IN)
#define HWIO_GCC_IPA_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_IPA_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_IPA_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_IPA_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_IPA_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_IPA_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_IPA_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_IPA_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_IPA_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_IPA_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_IPA_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_IPA_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_IPA_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_IPA_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_IPA_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_IPA_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_IPA_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_IPA_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_IPA_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_RPMH_IPA_CMD_DFSR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00079054)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079054)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079054)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_RMSK                                                                    0xffff
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_ATTR                                                                       0x3
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_CMD_DFSR_ADDR, HWIO_GCC_RPMH_IPA_CMD_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_CMD_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_CMD_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_CMD_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_CMD_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_RCG_SW_CTRL_BMSK                                                        0x8000
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_RCG_SW_CTRL_SHFT                                                           0xf
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_SW_PERF_STATE_BMSK                                                      0x7800
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_SW_PERF_STATE_SHFT                                                         0xb
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_SW_OVERRIDE_BMSK                                                         0x400
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_SW_OVERRIDE_SHFT                                                           0xa
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_PERF_STATE_UPDATE_STATUS_BMSK                                            0x200
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_PERF_STATE_UPDATE_STATUS_SHFT                                              0x9
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_FSM_STATE_BMSK                                                       0x1c0
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_FSM_STATE_SHFT                                                         0x6
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_HW_CLK_CONTROL_BMSK                                                       0x20
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_HW_CLK_CONTROL_SHFT                                                        0x5
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_CURR_PERF_STATE_BMSK                                                      0x1e
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_CURR_PERF_STATE_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_EN_BMSK                                                                0x1
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_EN_SHFT                                                                0x0
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_EN_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_RPMH_IPA_CMD_DFSR_DFS_EN_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007905c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007905c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007905c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079060)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079060)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079060)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079064)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079064)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079064)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079068)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079068)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079068)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007906c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007906c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007906c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079070)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079070)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079070)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079074)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079074)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079074)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079078)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079078)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079078)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007907c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007907c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007907c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00079080)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079080)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079080)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_RMSK                                                            0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ATTR                                                              0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079084)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079084)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079084)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079088)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079088)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079088)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007908c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007908c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007908c)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079090)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079090)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079090)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079094)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079094)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079094)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00079098)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079098)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079098)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_RMSK                                                           0x71f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ATTR                                                             0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_BMSK                                                   0x700
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SHFT                                                     0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                                0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                                0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                                0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                                0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_BMSK                                                    0x1f
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_SHFT                                                     0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                              0x2
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                                0x3
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                              0x4
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                                0x5
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                              0x6
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                                0x7
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                              0x8
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                                0x9
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                              0xa
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                                0xb
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                              0xc
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                                0xd
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                              0xe
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                                0xf
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                             0x10
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                               0x11
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                             0x12
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                              0x13
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                            0x14
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                              0x15
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                            0x16
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                              0x17
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                            0x18
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                              0x19
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                            0x1a
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                              0x1b
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                            0x1c
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                              0x1d
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                            0x1e
#define HWIO_GCC_RPMH_IPA_IPA_2X_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                              0x1f

#define HWIO_GCC_IPA_2X_CMD_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00079040)
#define HWIO_GCC_IPA_2X_CMD_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079040)
#define HWIO_GCC_IPA_2X_CMD_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079040)
#define HWIO_GCC_IPA_2X_CMD_RCGR_RMSK                                                                  0x80000013
#define HWIO_GCC_IPA_2X_CMD_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_IPA_2X_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_CMD_RCGR_ADDR, HWIO_GCC_IPA_2X_CMD_RCGR_RMSK)
#define HWIO_GCC_IPA_2X_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_CMD_RCGR_ADDR, m)
#define HWIO_GCC_IPA_2X_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_CMD_RCGR_ADDR,v)
#define HWIO_GCC_IPA_2X_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_CMD_RCGR_ADDR,m,v,HWIO_GCC_IPA_2X_CMD_RCGR_IN)
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_OFF_SHFT                                                               0x1f
#define HWIO_GCC_IPA_2X_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                         0x10
#define HWIO_GCC_IPA_2X_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                          0x4
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_EN_BMSK                                                                 0x2
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_EN_SHFT                                                                 0x1
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_IPA_2X_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_IPA_2X_CMD_RCGR_UPDATE_BMSK                                                                  0x1
#define HWIO_GCC_IPA_2X_CMD_RCGR_UPDATE_SHFT                                                                  0x0
#define HWIO_GCC_IPA_2X_CMD_RCGR_UPDATE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_IPA_2X_CMD_RCGR_UPDATE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_IPA_2X_CFG_RCGR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00079044)
#define HWIO_GCC_IPA_2X_CFG_RCGR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079044)
#define HWIO_GCC_IPA_2X_CFG_RCGR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079044)
#define HWIO_GCC_IPA_2X_CFG_RCGR_RMSK                                                                    0x11071f
#define HWIO_GCC_IPA_2X_CFG_RCGR_ATTR                                                                         0x3
#define HWIO_GCC_IPA_2X_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_CFG_RCGR_ADDR, HWIO_GCC_IPA_2X_CFG_RCGR_RMSK)
#define HWIO_GCC_IPA_2X_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_CFG_RCGR_ADDR, m)
#define HWIO_GCC_IPA_2X_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_CFG_RCGR_ADDR,v)
#define HWIO_GCC_IPA_2X_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_CFG_RCGR_ADDR,m,v,HWIO_GCC_IPA_2X_CFG_RCGR_IN)
#define HWIO_GCC_IPA_2X_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                     0x100000
#define HWIO_GCC_IPA_2X_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                         0x14
#define HWIO_GCC_IPA_2X_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_IPA_2X_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_IPA_2X_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                     0x10000
#define HWIO_GCC_IPA_2X_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                        0x10
#define HWIO_GCC_IPA_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                         0x0
#define HWIO_GCC_IPA_2X_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                        0x1
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_BMSK                                                               0x700
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SHFT                                                                 0x8
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                            0x0
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                            0x1
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                            0x2
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                            0x3
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                            0x4
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                            0x5
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                            0x6
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                            0x7
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_BMSK                                                                0x1f
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_SHFT                                                                 0x0
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                          0x0
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                            0x1
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                          0x2
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                            0x3
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                          0x4
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                            0x5
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                          0x6
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                            0x7
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                          0x8
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                            0x9
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                          0xa
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                            0xb
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                          0xc
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                            0xd
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                          0xe
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                            0xf
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                         0x10
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                           0x11
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                         0x12
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                          0x13
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                        0x14
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                          0x15
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                        0x16
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                          0x17
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                        0x18
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                          0x19
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                        0x1a
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                          0x1b
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                        0x1c
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                          0x1d
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                        0x1e
#define HWIO_GCC_IPA_2X_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                          0x1f

#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007916c)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007916c)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007916c)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_RMSK                                                                    0x1
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ATTR                                                                    0x3
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ADDR, HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_IPA_2X_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_IPA_DIV_CDIVR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00079170)
#define HWIO_GCC_IPA_DIV_CDIVR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00079170)
#define HWIO_GCC_IPA_DIV_CDIVR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00079170)
#define HWIO_GCC_IPA_DIV_CDIVR_RMSK                                                                           0xf
#define HWIO_GCC_IPA_DIV_CDIVR_ATTR                                                                           0x3
#define HWIO_GCC_IPA_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_IPA_DIV_CDIVR_ADDR, HWIO_GCC_IPA_DIV_CDIVR_RMSK)
#define HWIO_GCC_IPA_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPA_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_IPA_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_IPA_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_IPA_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPA_DIV_CDIVR_ADDR,m,v,HWIO_GCC_IPA_DIV_CDIVR_IN)
#define HWIO_GCC_IPA_DIV_CDIVR_CLK_DIV_BMSK                                                                   0xf
#define HWIO_GCC_IPA_DIV_CDIVR_CLK_DIV_SHFT                                                                   0x0

#define HWIO_GCC_MSS_CFG_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a000)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a000)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a000)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_MSS_CFG_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_CFG_AHB_CBCR_ADDR, HWIO_GCC_MSS_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_MSS_CFG_AHB_CBCR_IN)
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_MSS_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_MSS_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_MSS_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_MSS_CFG_AHB_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_MSS_CFG_AHB_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_MSS_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_MSS_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MSS_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a004)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a004)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a004)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_RMSK                                                    0x81d0000f
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ATTR                                                           0x3
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ADDR, HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_OFF_BMSK                                            0x80000000
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_OFF_SHFT                                                  0x1f
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                     0x1000000
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                          0x18
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                   0x800000
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                       0x17
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_DIS_BMSK                                              0x400000
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_DIS_SHFT                                                  0x16
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                  0x100000
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                      0x14
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                0x8
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                0x3
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ARES_BMSK                                                  0x4
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ARES_SHFT                                                  0x2
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                         0x0
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                            0x1
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_HW_CTL_BMSK                                                    0x2
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_HW_CTL_SHFT                                                    0x1
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                             0x1
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                0x1
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                0x0
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a008)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a008)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a008)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_RMSK                                                         0x81d0000f
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ATTR                                                                0x3
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ADDR, HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                          0x1000000
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                               0x18
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                        0x800000
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                            0x17
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_DIS_BMSK                                                   0x400000
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_DIS_SHFT                                                       0x16
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                       0x100000
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                           0x14
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                     0x8
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                     0x3
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ARES_BMSK                                                       0x4
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ARES_SHFT                                                       0x2
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                              0x0
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                 0x1
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_HW_CTL_BMSK                                                         0x2
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_HW_CTL_SHFT                                                         0x1
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_QMIP_MSS_Q6_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a00c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a00c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a00c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_RMSK                                                             0x81f0000f
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ATTR                                                                    0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ADDR, HWIO_GCC_MSS_OFFLINE_AXI_CBCR_RMSK)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ADDR, m)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ADDR,v)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_OFFLINE_AXI_CBCR_ADDR,m,v,HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IN)
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                              0x1000000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                   0x18
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                            0x800000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                0x17
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_DIS_BMSK                                                       0x400000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_DIS_SHFT                                                           0x16
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                            0x200000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                                0x15
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                           0x100000
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                               0x14
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_SW_ONLY_EN_BMSK                                                         0x8
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_SW_ONLY_EN_SHFT                                                         0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ARES_BMSK                                                           0x4
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ARES_SHFT                                                           0x2
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                  0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ARES_RESET_FVAL                                                     0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_HW_CTL_BMSK                                                             0x2
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_HW_CTL_SHFT                                                             0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_MSS_AXIS2_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003d000)
#define HWIO_GCC_MSS_AXIS2_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003d000)
#define HWIO_GCC_MSS_AXIS2_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003d000)
#define HWIO_GCC_MSS_AXIS2_CBCR_RMSK                                                                   0x81d00005
#define HWIO_GCC_MSS_AXIS2_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_MSS_AXIS2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_AXIS2_CBCR_ADDR, HWIO_GCC_MSS_AXIS2_CBCR_RMSK)
#define HWIO_GCC_MSS_AXIS2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_AXIS2_CBCR_ADDR, m)
#define HWIO_GCC_MSS_AXIS2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_AXIS2_CBCR_ADDR,v)
#define HWIO_GCC_MSS_AXIS2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_AXIS2_CBCR_ADDR,m,v,HWIO_GCC_MSS_AXIS2_CBCR_IN)
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                 0x100000
#define HWIO_GCC_MSS_AXIS2_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                     0x14
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_MSS_AXIS2_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_MSS_TRIG_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a010)
#define HWIO_GCC_MSS_TRIG_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a010)
#define HWIO_GCC_MSS_TRIG_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a010)
#define HWIO_GCC_MSS_TRIG_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_MSS_TRIG_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_MSS_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_TRIG_CBCR_ADDR, HWIO_GCC_MSS_TRIG_CBCR_RMSK)
#define HWIO_GCC_MSS_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_MSS_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_MSS_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_TRIG_CBCR_ADDR,m,v,HWIO_GCC_MSS_TRIG_CBCR_IN)
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_MSS_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_MSS_TRIG_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_MSS_TRIG_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_MSS_TRIG_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_MSS_TRIG_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_MSS_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_MSS_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MSS_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_MSS_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a014)
#define HWIO_GCC_MSS_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a014)
#define HWIO_GCC_MSS_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a014)
#define HWIO_GCC_MSS_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_MSS_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_MSS_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_AT_CBCR_ADDR, HWIO_GCC_MSS_AT_CBCR_RMSK)
#define HWIO_GCC_MSS_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_AT_CBCR_ADDR, m)
#define HWIO_GCC_MSS_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_AT_CBCR_ADDR,v)
#define HWIO_GCC_MSS_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_AT_CBCR_ADDR,m,v,HWIO_GCC_MSS_AT_CBCR_IN)
#define HWIO_GCC_MSS_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_MSS_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_MSS_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_MSS_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_MSS_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_MSS_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_MSS_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_MSS_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_MSS_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_MSS_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_MSS_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_MSS_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_MSS_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_MSS_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_MSS_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_MSS_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_MSS_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_MSS_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_MSS_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_MSS_SNOC_AXI_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a018)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a018)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a018)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_SNOC_AXI_CBCR_ADDR, HWIO_GCC_MSS_SNOC_AXI_CBCR_RMSK)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_SNOC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_SNOC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_SNOC_AXI_CBCR_ADDR,m,v,HWIO_GCC_MSS_SNOC_AXI_CBCR_IN)
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_MSS_SNOC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a01c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a01c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a01c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_RMSK                                                           0x81f0000f
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ATTR                                                                  0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ADDR, HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_RMSK)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_ADDR,m,v,HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IN)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                            0x1000000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                 0x18
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                          0x800000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                              0x17
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_DIS_BMSK                                                     0x400000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_DIS_SHFT                                                         0x16
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_PMU_CLK_DIS_BMSK                                          0x200000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_PMU_CLK_DIS_SHFT                                              0x15
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                         0x100000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                             0x14
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_SW_ONLY_EN_BMSK                                                       0x8
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_SW_ONLY_EN_SHFT                                                       0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ARES_BMSK                                                         0x4
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ARES_SHFT                                                         0x2
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                   0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_HW_CTL_BMSK                                                           0x2
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_HW_CTL_SHFT                                                           0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                    0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a020)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a020)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a020)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_RMSK                                                                 0xf
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ATTR                                                                 0x3
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ADDR, HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_RMSK)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_ADDR,m,v,HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_IN)
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_CLK_DIV_BMSK                                                         0xf
#define HWIO_GCC_MSS_PLL0_MAIN_DIV_CDIVR_CLK_DIV_SHFT                                                         0x0

#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a024)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a024)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a024)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_RMSK                                                           0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ATTR                                                           0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a044)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a044)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a044)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a048)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a048)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a048)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a04c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a04c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a04c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a050)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a050)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a050)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a054)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a054)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a054)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a058)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a058)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a058)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a05c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a05c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a05c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a060)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a060)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a060)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a064)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a064)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a064)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a068)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a068)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a068)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_RMSK                                                0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ATTR                                                  0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_BMSK                                        0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SHFT                                          0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_BMSK                                         0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_SHFT                                          0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                   0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                     0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                   0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                     0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                   0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                     0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                   0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                     0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                   0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                     0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                   0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                     0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                   0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                     0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                   0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                     0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                  0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                    0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                  0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                   0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                 0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                   0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                 0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                   0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                 0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                   0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                 0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                   0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                 0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                   0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                 0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                   0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a06c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a06c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a06c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a070)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a070)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a070)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a074)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a074)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a074)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a078)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a078)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a078)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a07c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a07c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a07c)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ADDR                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a080)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_PHYS                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a080)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_OFFS                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a080)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_RMSK                                               0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ATTR                                                 0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_BMSK                                       0x700
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SHFT                                         0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_BMSK                                        0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_SHFT                                         0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                  0x0
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                    0x1
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                  0x2
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                  0x4
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                    0x5
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                  0x6
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                    0x7
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                  0x8
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                    0x9
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                  0xa
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                    0xb
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                  0xc
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                    0xd
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                  0xe
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                    0xf
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                 0x10
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                   0x11
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                 0x12
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                  0x13
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                0x14
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                  0x15
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                0x16
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                  0x17
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                0x18
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                  0x19
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                  0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                  0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_Q6_MEMNOC_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                  0x1f

#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a028)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a028)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a028)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_RMSK                                                       0x80000013
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ATTR                                                              0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ADDR, HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_IN)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_OFF_BMSK                                              0x80000000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                    0x1f
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                              0x10
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                               0x4
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_EN_BMSK                                                      0x2
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_EN_SHFT                                                      0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                              0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                               0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_UPDATE_BMSK                                                       0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_UPDATE_SHFT                                                       0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a02c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a02c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a02c)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RMSK                                                         0x11071f
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ATTR                                                              0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ADDR, HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_IN)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                          0x100000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                              0x14
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                          0x10000
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                             0x10
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                             0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_BMSK                                                    0x700
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SHFT                                                      0x8
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                 0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                 0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                 0x2
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                 0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                 0x4
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                 0x5
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                 0x6
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                 0x7
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_BMSK                                                     0x1f
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_SHFT                                                      0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                               0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                 0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                               0x2
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                 0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                               0x4
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                 0x5
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                               0x6
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                 0x7
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                               0x8
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                 0x9
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                               0xa
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                 0xb
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                               0xc
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                 0xd
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                               0xe
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                 0xf
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                              0x10
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                0x11
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                              0x12
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                               0x13
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                             0x14
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                               0x15
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                             0x16
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                               0x17
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                             0x18
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                               0x19
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                             0x1a
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                               0x1b
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                             0x1c
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                               0x1d
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                             0x1e
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                               0x1f

#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a154)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a154)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a154)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_RMSK                                                         0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ATTR                                                         0x3
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ADDR, HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                              0x1
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                              0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_Q6_MEMNOC_AXI_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a178)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a178)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a178)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a17c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a17c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a17c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a180)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a180)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a180)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a184)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a184)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a184)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a188)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a188)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a188)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a18c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a18c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a18c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a190)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a190)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a190)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a194)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a194)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a194)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a198)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a198)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a198)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a19c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a19c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a19c)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1a0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1a0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1a0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1a4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1a4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1a4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1a8)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1a8)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1a8)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1ac)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1ac)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1ac)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1b0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1b0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1b0)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a1b4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a1b4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a1b4)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_RMSK                                                 0x71f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ATTR                                                   0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_BMSK                                         0x700
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SHFT                                           0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_BMSK                                          0x1f
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_SHFT                                           0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                    0x0
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                      0x1
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                    0x2
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                      0x3
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                    0x4
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                      0x5
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                    0x6
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                      0x7
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                    0x8
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                      0x9
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                    0xa
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                      0xb
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                    0xc
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                      0xd
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                    0xe
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                      0xf
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                   0x10
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                     0x11
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                   0x12
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                    0x13
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                  0x14
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                    0x15
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                  0x16
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                    0x17
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                  0x18
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                    0x19
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                  0x1a
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                    0x1b
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                  0x1c
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                    0x1d
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                  0x1e
#define HWIO_GCC_RPMH_SHUB_MSS_OFFLINE_AXI_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                    0x1f

#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a15c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a15c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a15c)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_RMSK                                                         0x80000013
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ATTR                                                                0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ADDR, HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_RMSK)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ADDR, m)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ADDR,v)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ADDR,m,v,HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_IN)
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_OFF_BMSK                                                0x80000000
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_OFF_SHFT                                                      0x1f
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                0x10
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                 0x4
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_EN_BMSK                                                        0x2
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_EN_SHFT                                                        0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_UPDATE_BMSK                                                         0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_UPDATE_SHFT                                                         0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_UPDATE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CMD_RCGR_UPDATE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a160)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a160)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a160)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RMSK                                                           0x11071f
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ATTR                                                                0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ADDR, HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RMSK)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ADDR, m)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ADDR,v)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_ADDR,m,v,HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_IN)
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_HW_CLK_CONTROL_BMSK                                            0x100000
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                0x14
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                         0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                          0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RCGLITE_DISABLE_BMSK                                            0x10000
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RCGLITE_DISABLE_SHFT                                               0x10
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                               0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_BMSK                                                      0x700
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SHFT                                                        0x8
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                   0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                   0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                   0x2
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                   0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                   0x4
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                   0x5
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                   0x6
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                   0x7
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_BMSK                                                       0x1f
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_SHFT                                                        0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                 0x0
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                   0x1
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                 0x2
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                   0x3
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                 0x4
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                   0x5
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                 0x6
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                   0x7
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                 0x8
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                   0x9
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                 0xa
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                   0xb
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                 0xc
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                   0xd
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                 0xe
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                   0xf
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                0x10
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                  0x11
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                0x12
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                 0x13
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                               0x14
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                 0x15
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                               0x16
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                 0x17
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                               0x18
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                 0x19
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                               0x1a
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                 0x1b
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                               0x1c
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                 0x1d
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                               0x1e
#define HWIO_GCC_MSS_OFFLINE_AXI_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                 0x1f

#define HWIO_GCC_GLM_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b000)
#define HWIO_GCC_GLM_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b000)
#define HWIO_GCC_GLM_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b000)
#define HWIO_GCC_GLM_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_GLM_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_GLM_BCR_IN          \
        in_dword_masked(HWIO_GCC_GLM_BCR_ADDR, HWIO_GCC_GLM_BCR_RMSK)
#define HWIO_GCC_GLM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_BCR_ADDR, m)
#define HWIO_GCC_GLM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_BCR_ADDR,v)
#define HWIO_GCC_GLM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_BCR_ADDR,m,v,HWIO_GCC_GLM_BCR_IN)
#define HWIO_GCC_GLM_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_GLM_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_GLM_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_GLM_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_GLM_AHB_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b004)
#define HWIO_GCC_GLM_AHB_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b004)
#define HWIO_GCC_GLM_AHB_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b004)
#define HWIO_GCC_GLM_AHB_CBCR_RMSK                                                                     0x81d00005
#define HWIO_GCC_GLM_AHB_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_GLM_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GLM_AHB_CBCR_ADDR, HWIO_GCC_GLM_AHB_CBCR_RMSK)
#define HWIO_GCC_GLM_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_AHB_CBCR_ADDR, m)
#define HWIO_GCC_GLM_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_AHB_CBCR_ADDR,v)
#define HWIO_GCC_GLM_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_AHB_CBCR_ADDR,m,v,HWIO_GCC_GLM_AHB_CBCR_IN)
#define HWIO_GCC_GLM_AHB_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_GLM_AHB_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_GLM_AHB_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_GLM_AHB_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_GLM_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_GLM_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_GLM_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b008)
#define HWIO_GCC_GLM_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b008)
#define HWIO_GCC_GLM_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b008)
#define HWIO_GCC_GLM_CBCR_RMSK                                                                         0x81c0000f
#define HWIO_GCC_GLM_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_GLM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GLM_CBCR_ADDR, HWIO_GCC_GLM_CBCR_RMSK)
#define HWIO_GCC_GLM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_CBCR_ADDR, m)
#define HWIO_GCC_GLM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_CBCR_ADDR,v)
#define HWIO_GCC_GLM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_CBCR_ADDR,m,v,HWIO_GCC_GLM_CBCR_IN)
#define HWIO_GCC_GLM_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_GLM_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_GLM_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_GLM_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_GLM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_GLM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_GLM_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_GLM_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_GLM_CBCR_SW_ONLY_EN_BMSK                                                                     0x8
#define HWIO_GCC_GLM_CBCR_SW_ONLY_EN_SHFT                                                                     0x3
#define HWIO_GCC_GLM_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_GLM_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_GLM_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_GLM_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_GLM_CBCR_HW_CTL_BMSK                                                                         0x2
#define HWIO_GCC_GLM_CBCR_HW_CTL_SHFT                                                                         0x1
#define HWIO_GCC_GLM_CBCR_HW_CTL_DISABLE_FVAL                                                                 0x0
#define HWIO_GCC_GLM_CBCR_HW_CTL_ENABLE_FVAL                                                                  0x1
#define HWIO_GCC_GLM_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_GLM_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_GLM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GLM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GLM_XO_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b00c)
#define HWIO_GCC_GLM_XO_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b00c)
#define HWIO_GCC_GLM_XO_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b00c)
#define HWIO_GCC_GLM_XO_CBCR_RMSK                                                                      0x81c00005
#define HWIO_GCC_GLM_XO_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_GLM_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GLM_XO_CBCR_ADDR, HWIO_GCC_GLM_XO_CBCR_RMSK)
#define HWIO_GCC_GLM_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_XO_CBCR_ADDR, m)
#define HWIO_GCC_GLM_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_XO_CBCR_ADDR,v)
#define HWIO_GCC_GLM_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_XO_CBCR_ADDR,m,v,HWIO_GCC_GLM_XO_CBCR_IN)
#define HWIO_GCC_GLM_XO_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_GLM_XO_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_GLM_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_GLM_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_GLM_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_GLM_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_GLM_XO_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_GLM_XO_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_GLM_XO_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_GLM_XO_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_GLM_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_GLM_XO_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_GLM_XO_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_GLM_XO_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_GLM_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLM_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_GLM_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b010)
#define HWIO_GCC_GLM_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b010)
#define HWIO_GCC_GLM_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b010)
#define HWIO_GCC_GLM_CMD_RCGR_RMSK                                                                     0x80000013
#define HWIO_GCC_GLM_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GLM_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GLM_CMD_RCGR_ADDR, HWIO_GCC_GLM_CMD_RCGR_RMSK)
#define HWIO_GCC_GLM_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_CMD_RCGR_ADDR, m)
#define HWIO_GCC_GLM_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_CMD_RCGR_ADDR,v)
#define HWIO_GCC_GLM_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_CMD_RCGR_ADDR,m,v,HWIO_GCC_GLM_CMD_RCGR_IN)
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_GLM_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_GLM_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_GLM_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_GLM_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_GLM_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_GLM_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_GLM_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_GLM_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007b014)
#define HWIO_GCC_GLM_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007b014)
#define HWIO_GCC_GLM_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007b014)
#define HWIO_GCC_GLM_CFG_RCGR_RMSK                                                                       0x11071f
#define HWIO_GCC_GLM_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_GLM_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GLM_CFG_RCGR_ADDR, HWIO_GCC_GLM_CFG_RCGR_RMSK)
#define HWIO_GCC_GLM_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GLM_CFG_RCGR_ADDR, m)
#define HWIO_GCC_GLM_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GLM_CFG_RCGR_ADDR,v)
#define HWIO_GCC_GLM_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLM_CFG_RCGR_ADDR,m,v,HWIO_GCC_GLM_CFG_RCGR_IN)
#define HWIO_GCC_GLM_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_GLM_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_GLM_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_GLM_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_GLM_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                        0x10000
#define HWIO_GCC_GLM_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                           0x10
#define HWIO_GCC_GLM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                            0x0
#define HWIO_GCC_GLM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                           0x1
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_GLM_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_GLM_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_GPU_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00061000)
#define HWIO_GCC_GPU_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061000)
#define HWIO_GCC_GPU_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061000)
#define HWIO_GCC_GPU_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_GPU_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_GPU_BCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_BCR_ADDR, HWIO_GCC_GPU_BCR_RMSK)
#define HWIO_GCC_GPU_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_BCR_ADDR, m)
#define HWIO_GCC_GPU_BCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_BCR_ADDR,v)
#define HWIO_GCC_GPU_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_BCR_ADDR,m,v,HWIO_GCC_GPU_BCR_IN)
#define HWIO_GCC_GPU_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_GPU_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_GPU_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_GPU_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_GPU_CFG_AHB_CBCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00061004)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061004)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061004)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_RMSK                                                                 0x81d0000f
#define HWIO_GCC_GPU_CFG_AHB_CBCR_ATTR                                                                        0x3
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_CFG_AHB_CBCR_ADDR, HWIO_GCC_GPU_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_GPU_CFG_AHB_CBCR_IN)
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_OFF_BMSK                                                         0x80000000
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_OFF_SHFT                                                               0x1f
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                  0x1000000
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                       0x18
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                0x800000
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                    0x17
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_DIS_BMSK                                                           0x400000
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_DIS_SHFT                                                               0x16
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                               0x100000
#define HWIO_GCC_GPU_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                   0x14
#define HWIO_GCC_GPU_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                             0x8
#define HWIO_GCC_GPU_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                             0x3
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ARES_BMSK                                                               0x4
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ARES_SHFT                                                               0x2
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                      0x0
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                         0x1
#define HWIO_GCC_GPU_CFG_AHB_CBCR_HW_CTL_BMSK                                                                 0x2
#define HWIO_GCC_GPU_CFG_AHB_CBCR_HW_CTL_SHFT                                                                 0x1
#define HWIO_GCC_GPU_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_GPU_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                             0x1
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                             0x0
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_GPU_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_QMIP_GPU_AHB_CBCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00061008)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061008)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061008)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_RMSK                                                                0x81d0000f
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_ATTR                                                                       0x3
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QMIP_GPU_AHB_CBCR_ADDR, HWIO_GCC_QMIP_GPU_AHB_CBCR_RMSK)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QMIP_GPU_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QMIP_GPU_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QMIP_GPU_AHB_CBCR_ADDR,m,v,HWIO_GCC_QMIP_GPU_AHB_CBCR_IN)
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_OFF_BMSK                                                        0x80000000
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_OFF_SHFT                                                              0x1f
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                 0x1000000
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                      0x18
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                               0x800000
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                   0x17
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_DIS_BMSK                                                          0x400000
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_DIS_SHFT                                                              0x16
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                              0x100000
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                  0x14
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_SW_ONLY_EN_BMSK                                                            0x8
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_SW_ONLY_EN_SHFT                                                            0x3
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ARES_BMSK                                                              0x4
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ARES_SHFT                                                              0x2
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                     0x0
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ARES_RESET_FVAL                                                        0x1
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_HW_CTL_BMSK                                                                0x2
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_HW_CTL_SHFT                                                                0x1
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                         0x1
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ENABLE_BMSK                                                            0x1
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ENABLE_SHFT                                                            0x0
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_QMIP_GPU_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_GPU_AT_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006100c)
#define HWIO_GCC_GPU_AT_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006100c)
#define HWIO_GCC_GPU_AT_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006100c)
#define HWIO_GCC_GPU_AT_CBCR_RMSK                                                                      0x81d0000f
#define HWIO_GCC_GPU_AT_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_GPU_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_AT_CBCR_ADDR, HWIO_GCC_GPU_AT_CBCR_RMSK)
#define HWIO_GCC_GPU_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_AT_CBCR_ADDR, m)
#define HWIO_GCC_GPU_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_AT_CBCR_ADDR,v)
#define HWIO_GCC_GPU_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_AT_CBCR_ADDR,m,v,HWIO_GCC_GPU_AT_CBCR_IN)
#define HWIO_GCC_GPU_AT_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_GPU_AT_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_GPU_AT_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_GPU_AT_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                    0x100000
#define HWIO_GCC_GPU_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                        0x14
#define HWIO_GCC_GPU_AT_CBCR_SW_ONLY_EN_BMSK                                                                  0x8
#define HWIO_GCC_GPU_AT_CBCR_SW_ONLY_EN_SHFT                                                                  0x3
#define HWIO_GCC_GPU_AT_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_GPU_AT_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_GPU_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_GPU_AT_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_GPU_AT_CBCR_HW_CTL_BMSK                                                                      0x2
#define HWIO_GCC_GPU_AT_CBCR_HW_CTL_SHFT                                                                      0x1
#define HWIO_GCC_GPU_AT_CBCR_HW_CTL_DISABLE_FVAL                                                              0x0
#define HWIO_GCC_GPU_AT_CBCR_HW_CTL_ENABLE_FVAL                                                               0x1
#define HWIO_GCC_GPU_AT_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_GPU_AT_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_GPU_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GPU_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061010)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061010)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061010)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_RMSK                                                              0x81d0000f
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ADDR, HWIO_GCC_GPU_MEMNOC_GFX_CBCR_RMSK)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ADDR, m)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ADDR,v)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MEMNOC_GFX_CBCR_ADDR,m,v,HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IN)
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_GPU_TRIG_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00061014)
#define HWIO_GCC_GPU_TRIG_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061014)
#define HWIO_GCC_GPU_TRIG_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061014)
#define HWIO_GCC_GPU_TRIG_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_GPU_TRIG_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_GPU_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_TRIG_CBCR_ADDR, HWIO_GCC_GPU_TRIG_CBCR_RMSK)
#define HWIO_GCC_GPU_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_GPU_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_GPU_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_TRIG_CBCR_ADDR,m,v,HWIO_GCC_GPU_TRIG_CBCR_IN)
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_GPU_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_GPU_TRIG_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_GPU_TRIG_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_GPU_TRIG_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_GPU_TRIG_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_GPU_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_GPU_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_GPU_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00061018)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061018)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061018)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_RMSK                                                            0x81d00005
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ADDR, HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_RMSK)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ADDR, m)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ADDR,v)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_ADDR,m,v,HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IN)
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_GPU_SNOC_DVM_GFX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061038)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061038)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061038)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF0_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006103c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006103c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006103c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF1_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061040)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061040)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061040)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF2_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061044)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061044)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061044)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF3_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061048)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061048)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061048)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF4_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006104c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006104c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006104c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF5_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061050)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061050)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061050)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF6_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061054)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061054)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061054)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF7_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00061058)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061058)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061058)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF8_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006105c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006105c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006105c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_RMSK                                                   0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ATTR                                                     0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_BMSK                                           0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SHFT                                             0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC0_FVAL                                        0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC2_FVAL                                        0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC3_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC4_FVAL                                        0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC5_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC6_FVAL                                        0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_SEL_SRC7_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_BMSK                                            0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_SHFT                                             0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_BYPASS_FVAL                                      0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV1_FVAL                                        0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV1_5_FVAL                                      0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV2_FVAL                                        0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV2_5_FVAL                                      0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV3_FVAL                                        0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV3_5_FVAL                                      0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV4_FVAL                                        0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV4_5_FVAL                                      0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV5_FVAL                                        0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV5_5_FVAL                                      0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV6_FVAL                                        0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV6_5_FVAL                                      0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV7_FVAL                                        0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV7_5_FVAL                                      0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV8_FVAL                                        0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV8_5_FVAL                                     0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV9_FVAL                                       0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV9_5_FVAL                                     0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV10_FVAL                                      0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV10_5_FVAL                                    0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV11_FVAL                                      0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV11_5_FVAL                                    0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV12_FVAL                                      0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV12_5_FVAL                                    0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV13_FVAL                                      0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV13_5_FVAL                                    0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV14_FVAL                                      0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV14_5_FVAL                                    0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV15_FVAL                                      0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV15_5_FVAL                                    0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF9_DFSR_SRC_DIV_DIV16_FVAL                                      0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00061060)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061060)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061060)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF10_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00061064)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061064)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061064)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF11_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00061068)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061068)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061068)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF12_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0006106c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006106c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006106c)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF13_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00061070)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061070)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061070)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF14_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00061074)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061074)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061074)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_RMSK                                                  0x71f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ATTR                                                    0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ADDR, HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_RMSK)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_ADDR,m,v,HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_IN)
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_BMSK                                          0x700
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SHFT                                            0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC0_FVAL                                       0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC2_FVAL                                       0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC3_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC4_FVAL                                       0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC5_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC6_FVAL                                       0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_SEL_SRC7_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_BMSK                                           0x1f
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_SHFT                                            0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_BYPASS_FVAL                                     0x0
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV1_FVAL                                       0x1
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV1_5_FVAL                                     0x2
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV2_FVAL                                       0x3
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV2_5_FVAL                                     0x4
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV3_FVAL                                       0x5
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV3_5_FVAL                                     0x6
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV4_FVAL                                       0x7
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV4_5_FVAL                                     0x8
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV5_FVAL                                       0x9
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV5_5_FVAL                                     0xa
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV6_FVAL                                       0xb
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV6_5_FVAL                                     0xc
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV7_FVAL                                       0xd
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV7_5_FVAL                                     0xe
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV8_FVAL                                       0xf
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV8_5_FVAL                                    0x10
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV9_FVAL                                      0x11
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV9_5_FVAL                                    0x12
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV10_FVAL                                     0x13
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV10_5_FVAL                                   0x14
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV11_FVAL                                     0x15
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV11_5_FVAL                                   0x16
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV12_FVAL                                     0x17
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV12_5_FVAL                                   0x18
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV13_FVAL                                     0x19
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV13_5_FVAL                                   0x1a
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV14_FVAL                                     0x1b
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV14_5_FVAL                                   0x1c
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV15_FVAL                                     0x1d
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV15_5_FVAL                                   0x1e
#define HWIO_GCC_RPMH_SHUB_GPU_MEMNOC_GFX_PERF15_DFSR_SRC_DIV_DIV16_FVAL                                     0x1f

#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006101c)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006101c)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006101c)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_RMSK                                                          0x80000013
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ADDR, HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_RMSK)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ADDR,m,v,HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_IN)
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_OFF_SHFT                                                       0x1f
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                 0x10
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                  0x4
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_EN_BMSK                                                         0x2
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_EN_SHFT                                                         0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_UPDATE_BMSK                                                          0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_UPDATE_SHFT                                                          0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00061020)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061020)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061020)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RMSK                                                            0x11071f
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ATTR                                                                 0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ADDR, HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RMSK)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_ADDR,m,v,HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_IN)
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                             0x100000
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                 0x14
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                          0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                           0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                             0x10000
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                0x10
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                 0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_BMSK                                                       0x700
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SHFT                                                         0x8
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                    0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                    0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                    0x2
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                    0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                    0x4
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                    0x5
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                    0x6
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                    0x7
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_BMSK                                                        0x1f
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_SHFT                                                         0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                  0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                    0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                  0x2
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                    0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                  0x4
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                    0x5
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                  0x6
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                    0x7
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                  0x8
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                    0x9
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                  0xa
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                    0xb
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                  0xc
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                    0xd
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                  0xe
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                    0xf
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                 0x10
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                   0x11
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                 0x12
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                  0x13
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                0x14
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                  0x15
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                0x16
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                  0x17
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                0x18
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                  0x19
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                0x1a
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                  0x1b
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                0x1c
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                  0x1d
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                0x1e
#define HWIO_GCC_GPU_MEMNOC_GFX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                  0x1f

#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00061148)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061148)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061148)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_RMSK                                                            0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ATTR                                                            0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_IN          \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ADDR, HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_RMSK)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ADDR, m)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ADDR,v)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_ADDR,m,v,HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_IN)
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_DCD_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_DCD_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_DCD_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_GPU_MEMNOC_GFX_DCD_CDIV_DCDR_DCD_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006114c)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006114c)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006114c)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_RMSK                                                                 0xf
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ATTR                                                                 0x3
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ADDR, HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_RMSK)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_ADDR,m,v,HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_IN)
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_CLK_DIV_BMSK                                                         0xf
#define HWIO_GCC_GPU_PLL0_MAIN_DIV_CDIVR_CLK_DIV_SHFT                                                         0x0

#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00061150)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061150)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061150)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_RMSK                                                                      0xf
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_ATTR                                                                      0x3
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_IN          \
        in_dword_masked(HWIO_GCC_GPU_TRIG_DIV_CDIVR_ADDR, HWIO_GCC_GPU_TRIG_DIV_CDIVR_RMSK)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_TRIG_DIV_CDIVR_ADDR, m)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_OUT(v)      \
        out_dword(HWIO_GCC_GPU_TRIG_DIV_CDIVR_ADDR,v)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_TRIG_DIV_CDIVR_ADDR,m,v,HWIO_GCC_GPU_TRIG_DIV_CDIVR_IN)
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_CLK_DIV_BMSK                                                              0xf
#define HWIO_GCC_GPU_TRIG_DIV_CDIVR_CLK_DIV_SHFT                                                              0x0

#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00062000)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062000)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062000)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_RMSK                                                            0x81d0000f
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ATTR                                                                   0x3
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ADDR, HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_RMSK)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ADDR, m)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ADDR,v)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_ADDR,m,v,HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IN)
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                             0x1000000
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                  0x18
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                           0x800000
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                               0x17
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_DIS_BMSK                                                      0x400000
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_DIS_SHFT                                                          0x16
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                          0x100000
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                              0x14
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_SW_ONLY_EN_BMSK                                                        0x8
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_SW_ONLY_EN_SHFT                                                        0x3
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ARES_BMSK                                                          0x4
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ARES_SHFT                                                          0x2
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                 0x0
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ARES_RESET_FVAL                                                    0x1
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_HW_CTL_BMSK                                                            0x2
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_HW_CTL_SHFT                                                            0x1
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_SNOC_ANOC_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_SCR_NIU_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00062004)
#define HWIO_GCC_SP_SCR_NIU_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062004)
#define HWIO_GCC_SP_SCR_NIU_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062004)
#define HWIO_GCC_SP_SCR_NIU_CBCR_RMSK                                                                  0x81d00005
#define HWIO_GCC_SP_SCR_NIU_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SP_SCR_NIU_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_SCR_NIU_CBCR_ADDR, HWIO_GCC_SP_SCR_NIU_CBCR_RMSK)
#define HWIO_GCC_SP_SCR_NIU_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_SCR_NIU_CBCR_ADDR, m)
#define HWIO_GCC_SP_SCR_NIU_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_SCR_NIU_CBCR_ADDR,v)
#define HWIO_GCC_SP_SCR_NIU_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_SCR_NIU_CBCR_ADDR,m,v,HWIO_GCC_SP_SCR_NIU_CBCR_IN)
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_SP_SCR_NIU_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SP_SCR_NIU_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SP_CFG_AHB_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00062008)
#define HWIO_GCC_SP_CFG_AHB_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062008)
#define HWIO_GCC_SP_CFG_AHB_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062008)
#define HWIO_GCC_SP_CFG_AHB_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_SP_CFG_AHB_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SP_CFG_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_CFG_AHB_CBCR_ADDR, HWIO_GCC_SP_CFG_AHB_CBCR_RMSK)
#define HWIO_GCC_SP_CFG_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CFG_AHB_CBCR_ADDR, m)
#define HWIO_GCC_SP_CFG_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_CFG_AHB_CBCR_ADDR,v)
#define HWIO_GCC_SP_CFG_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CFG_AHB_CBCR_ADDR,m,v,HWIO_GCC_SP_CFG_AHB_CBCR_IN)
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_SP_CFG_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_SP_CFG_AHB_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_SP_CFG_AHB_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SP_CFG_AHB_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_SP_CFG_AHB_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_SP_CFG_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_SP_CFG_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SP_CFG_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SP_SCSR_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006200c)
#define HWIO_GCC_SP_SCSR_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006200c)
#define HWIO_GCC_SP_SCSR_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006200c)
#define HWIO_GCC_SP_SCSR_CBCR_RMSK                                                                     0x81d00005
#define HWIO_GCC_SP_SCSR_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_SP_SCSR_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_SCSR_CBCR_ADDR, HWIO_GCC_SP_SCSR_CBCR_RMSK)
#define HWIO_GCC_SP_SCSR_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_SCSR_CBCR_ADDR, m)
#define HWIO_GCC_SP_SCSR_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_SCSR_CBCR_ADDR,v)
#define HWIO_GCC_SP_SCSR_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_SCSR_CBCR_ADDR,m,v,HWIO_GCC_SP_SCSR_CBCR_IN)
#define HWIO_GCC_SP_SCSR_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_SP_SCSR_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_SP_SCSR_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_SP_SCSR_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_SP_SCSR_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SP_SCSR_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SP_GPKT_XO_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00062010)
#define HWIO_GCC_SP_GPKT_XO_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062010)
#define HWIO_GCC_SP_GPKT_XO_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062010)
#define HWIO_GCC_SP_GPKT_XO_CBCR_RMSK                                                                  0x81c00005
#define HWIO_GCC_SP_GPKT_XO_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_SP_GPKT_XO_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_GPKT_XO_CBCR_ADDR, HWIO_GCC_SP_GPKT_XO_CBCR_RMSK)
#define HWIO_GCC_SP_GPKT_XO_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_GPKT_XO_CBCR_ADDR, m)
#define HWIO_GCC_SP_GPKT_XO_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_GPKT_XO_CBCR_ADDR,v)
#define HWIO_GCC_SP_GPKT_XO_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_GPKT_XO_CBCR_ADDR,m,v,HWIO_GCC_SP_GPKT_XO_CBCR_IN)
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_SP_GPKT_XO_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_SP_GPKT_XO_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_SP_GPKT_XO_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_SP_GPKT_XO_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_SP_GPKT_XO_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_SP_TRIG_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00062014)
#define HWIO_GCC_SP_TRIG_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062014)
#define HWIO_GCC_SP_TRIG_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062014)
#define HWIO_GCC_SP_TRIG_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_SP_TRIG_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_SP_TRIG_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_TRIG_CBCR_ADDR, HWIO_GCC_SP_TRIG_CBCR_RMSK)
#define HWIO_GCC_SP_TRIG_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_TRIG_CBCR_ADDR, m)
#define HWIO_GCC_SP_TRIG_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_TRIG_CBCR_ADDR,v)
#define HWIO_GCC_SP_TRIG_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_TRIG_CBCR_ADDR,m,v,HWIO_GCC_SP_TRIG_CBCR_IN)
#define HWIO_GCC_SP_TRIG_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_SP_TRIG_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_SP_TRIG_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_SP_TRIG_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_SP_TRIG_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_SP_TRIG_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_SP_TRIG_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_SP_TRIG_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_SP_TRIG_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_SP_TRIG_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_SP_TRIG_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_SP_TRIG_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_SP_AT_CBCR_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00062018)
#define HWIO_GCC_SP_AT_CBCR_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00062018)
#define HWIO_GCC_SP_AT_CBCR_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00062018)
#define HWIO_GCC_SP_AT_CBCR_RMSK                                                                       0x81d0000f
#define HWIO_GCC_SP_AT_CBCR_ATTR                                                                              0x3
#define HWIO_GCC_SP_AT_CBCR_IN          \
        in_dword_masked(HWIO_GCC_SP_AT_CBCR_ADDR, HWIO_GCC_SP_AT_CBCR_RMSK)
#define HWIO_GCC_SP_AT_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_AT_CBCR_ADDR, m)
#define HWIO_GCC_SP_AT_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_AT_CBCR_ADDR,v)
#define HWIO_GCC_SP_AT_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_AT_CBCR_ADDR,m,v,HWIO_GCC_SP_AT_CBCR_IN)
#define HWIO_GCC_SP_AT_CBCR_CLK_OFF_BMSK                                                               0x80000000
#define HWIO_GCC_SP_AT_CBCR_CLK_OFF_SHFT                                                                     0x1f
#define HWIO_GCC_SP_AT_CBCR_IGNORE_ALL_ARES_BMSK                                                        0x1000000
#define HWIO_GCC_SP_AT_CBCR_IGNORE_ALL_ARES_SHFT                                                             0x18
#define HWIO_GCC_SP_AT_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                      0x800000
#define HWIO_GCC_SP_AT_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                          0x17
#define HWIO_GCC_SP_AT_CBCR_CLK_DIS_BMSK                                                                 0x400000
#define HWIO_GCC_SP_AT_CBCR_CLK_DIS_SHFT                                                                     0x16
#define HWIO_GCC_SP_AT_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                     0x100000
#define HWIO_GCC_SP_AT_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                         0x14
#define HWIO_GCC_SP_AT_CBCR_SW_ONLY_EN_BMSK                                                                   0x8
#define HWIO_GCC_SP_AT_CBCR_SW_ONLY_EN_SHFT                                                                   0x3
#define HWIO_GCC_SP_AT_CBCR_CLK_ARES_BMSK                                                                     0x4
#define HWIO_GCC_SP_AT_CBCR_CLK_ARES_SHFT                                                                     0x2
#define HWIO_GCC_SP_AT_CBCR_CLK_ARES_NO_RESET_FVAL                                                            0x0
#define HWIO_GCC_SP_AT_CBCR_CLK_ARES_RESET_FVAL                                                               0x1
#define HWIO_GCC_SP_AT_CBCR_HW_CTL_BMSK                                                                       0x2
#define HWIO_GCC_SP_AT_CBCR_HW_CTL_SHFT                                                                       0x1
#define HWIO_GCC_SP_AT_CBCR_HW_CTL_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_SP_AT_CBCR_HW_CTL_ENABLE_FVAL                                                                0x1
#define HWIO_GCC_SP_AT_CBCR_CLK_ENABLE_BMSK                                                                   0x1
#define HWIO_GCC_SP_AT_CBCR_CLK_ENABLE_SHFT                                                                   0x0
#define HWIO_GCC_SP_AT_CBCR_CLK_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_SP_AT_CBCR_CLK_ENABLE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_NAV_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00005000)
#define HWIO_GCC_NAV_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00005000)
#define HWIO_GCC_NAV_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00005000)
#define HWIO_GCC_NAV_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_NAV_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_NAV_BCR_IN          \
        in_dword_masked(HWIO_GCC_NAV_BCR_ADDR, HWIO_GCC_NAV_BCR_RMSK)
#define HWIO_GCC_NAV_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NAV_BCR_ADDR, m)
#define HWIO_GCC_NAV_BCR_OUT(v)      \
        out_dword(HWIO_GCC_NAV_BCR_ADDR,v)
#define HWIO_GCC_NAV_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NAV_BCR_ADDR,m,v,HWIO_GCC_NAV_BCR_IN)
#define HWIO_GCC_NAV_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_NAV_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_NAV_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_NAV_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_NAV_AXI_CBCR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00005004)
#define HWIO_GCC_NAV_AXI_CBCR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00005004)
#define HWIO_GCC_NAV_AXI_CBCR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00005004)
#define HWIO_GCC_NAV_AXI_CBCR_RMSK                                                                     0x81d0000f
#define HWIO_GCC_NAV_AXI_CBCR_ATTR                                                                            0x3
#define HWIO_GCC_NAV_AXI_CBCR_IN          \
        in_dword_masked(HWIO_GCC_NAV_AXI_CBCR_ADDR, HWIO_GCC_NAV_AXI_CBCR_RMSK)
#define HWIO_GCC_NAV_AXI_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_NAV_AXI_CBCR_ADDR, m)
#define HWIO_GCC_NAV_AXI_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_NAV_AXI_CBCR_ADDR,v)
#define HWIO_GCC_NAV_AXI_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_NAV_AXI_CBCR_ADDR,m,v,HWIO_GCC_NAV_AXI_CBCR_IN)
#define HWIO_GCC_NAV_AXI_CBCR_CLK_OFF_BMSK                                                             0x80000000
#define HWIO_GCC_NAV_AXI_CBCR_CLK_OFF_SHFT                                                                   0x1f
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_ALL_ARES_BMSK                                                      0x1000000
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_ALL_ARES_SHFT                                                           0x18
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                    0x800000
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                        0x17
#define HWIO_GCC_NAV_AXI_CBCR_CLK_DIS_BMSK                                                               0x400000
#define HWIO_GCC_NAV_AXI_CBCR_CLK_DIS_SHFT                                                                   0x16
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                   0x100000
#define HWIO_GCC_NAV_AXI_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                       0x14
#define HWIO_GCC_NAV_AXI_CBCR_SW_ONLY_EN_BMSK                                                                 0x8
#define HWIO_GCC_NAV_AXI_CBCR_SW_ONLY_EN_SHFT                                                                 0x3
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ARES_BMSK                                                                   0x4
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ARES_SHFT                                                                   0x2
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ARES_NO_RESET_FVAL                                                          0x0
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ARES_RESET_FVAL                                                             0x1
#define HWIO_GCC_NAV_AXI_CBCR_HW_CTL_BMSK                                                                     0x2
#define HWIO_GCC_NAV_AXI_CBCR_HW_CTL_SHFT                                                                     0x1
#define HWIO_GCC_NAV_AXI_CBCR_HW_CTL_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_NAV_AXI_CBCR_HW_CTL_ENABLE_FVAL                                                              0x1
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ENABLE_BMSK                                                                 0x1
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ENABLE_SHFT                                                                 0x0
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_NAV_AXI_CBCR_CLK_ENABLE_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_AHB2PHY_SOUTH_BCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000a000)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000a000)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000a000)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_RMSK                                                                       0x1
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_ATTR                                                                       0x3
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_IN          \
        in_dword_masked(HWIO_GCC_AHB2PHY_SOUTH_BCR_ADDR, HWIO_GCC_AHB2PHY_SOUTH_BCR_RMSK)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AHB2PHY_SOUTH_BCR_ADDR, m)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_OUT(v)      \
        out_dword(HWIO_GCC_AHB2PHY_SOUTH_BCR_ADDR,v)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AHB2PHY_SOUTH_BCR_ADDR,m,v,HWIO_GCC_AHB2PHY_SOUTH_BCR_IN)
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_BLK_ARES_BMSK                                                              0x1
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_BLK_ARES_SHFT                                                              0x0
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_BLK_ARES_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_AHB2PHY_SOUTH_BCR_BLK_ARES_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_AHB2PHY_1_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000a004)
#define HWIO_GCC_AHB2PHY_1_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000a004)
#define HWIO_GCC_AHB2PHY_1_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000a004)
#define HWIO_GCC_AHB2PHY_1_CBCR_RMSK                                                                   0x81c0000f
#define HWIO_GCC_AHB2PHY_1_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_AHB2PHY_1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_AHB2PHY_1_CBCR_ADDR, HWIO_GCC_AHB2PHY_1_CBCR_RMSK)
#define HWIO_GCC_AHB2PHY_1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_AHB2PHY_1_CBCR_ADDR, m)
#define HWIO_GCC_AHB2PHY_1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_AHB2PHY_1_CBCR_ADDR,v)
#define HWIO_GCC_AHB2PHY_1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_AHB2PHY_1_CBCR_ADDR,m,v,HWIO_GCC_AHB2PHY_1_CBCR_IN)
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_AHB2PHY_1_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_AHB2PHY_1_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_AHB2PHY_1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_AHB2PHY_1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_AHB2PHY_1_CBCR_SW_ONLY_EN_BMSK                                                               0x8
#define HWIO_GCC_AHB2PHY_1_CBCR_SW_ONLY_EN_SHFT                                                               0x3
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_AHB2PHY_1_CBCR_HW_CTL_BMSK                                                                   0x2
#define HWIO_GCC_AHB2PHY_1_CBCR_HW_CTL_SHFT                                                                   0x1
#define HWIO_GCC_AHB2PHY_1_CBCR_HW_CTL_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_AHB2PHY_1_CBCR_HW_CTL_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_AHB2PHY_1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_CM_PHY_REFGEN1_BCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00012000)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00012000)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00012000)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_RMSK                                                                      0x1
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_ATTR                                                                      0x3
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_IN          \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN1_BCR_ADDR, HWIO_GCC_CM_PHY_REFGEN1_BCR_RMSK)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN1_BCR_ADDR, m)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_OUT(v)      \
        out_dword(HWIO_GCC_CM_PHY_REFGEN1_BCR_ADDR,v)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CM_PHY_REFGEN1_BCR_ADDR,m,v,HWIO_GCC_CM_PHY_REFGEN1_BCR_IN)
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_BLK_ARES_BMSK                                                             0x1
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_BLK_ARES_SHFT                                                             0x0
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_BLK_ARES_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CM_PHY_REFGEN1_BCR_BLK_ARES_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00012004)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00012004)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00012004)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_RMSK                                                              0x81c00005
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN1_CBCR_ADDR, HWIO_GCC_CM_PHY_REFGEN1_CBCR_RMSK)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN1_CBCR_ADDR, m)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CM_PHY_REFGEN1_CBCR_ADDR,v)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CM_PHY_REFGEN1_CBCR_ADDR,m,v,HWIO_GCC_CM_PHY_REFGEN1_CBCR_IN)
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CM_PHY_REFGEN1_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_CM_PHY_REFGEN2_BCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00014000)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00014000)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00014000)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_RMSK                                                                      0x1
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_ATTR                                                                      0x3
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_IN          \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN2_BCR_ADDR, HWIO_GCC_CM_PHY_REFGEN2_BCR_RMSK)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN2_BCR_ADDR, m)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_OUT(v)      \
        out_dword(HWIO_GCC_CM_PHY_REFGEN2_BCR_ADDR,v)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CM_PHY_REFGEN2_BCR_ADDR,m,v,HWIO_GCC_CM_PHY_REFGEN2_BCR_IN)
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_BLK_ARES_BMSK                                                             0x1
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_BLK_ARES_SHFT                                                             0x0
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_BLK_ARES_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_CM_PHY_REFGEN2_BCR_BLK_ARES_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00014004)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00014004)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00014004)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_RMSK                                                              0x81c00005
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_IN          \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN2_CBCR_ADDR, HWIO_GCC_CM_PHY_REFGEN2_CBCR_RMSK)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CM_PHY_REFGEN2_CBCR_ADDR, m)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_CM_PHY_REFGEN2_CBCR_ADDR,v)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CM_PHY_REFGEN2_CBCR_ADDR,m,v,HWIO_GCC_CM_PHY_REFGEN2_CBCR_IN)
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CM_PHY_REFGEN2_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_QSPI_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0003b000)
#define HWIO_GCC_QSPI_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003b000)
#define HWIO_GCC_QSPI_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003b000)
#define HWIO_GCC_QSPI_BCR_RMSK                                                                                0x1
#define HWIO_GCC_QSPI_BCR_ATTR                                                                                0x3
#define HWIO_GCC_QSPI_BCR_IN          \
        in_dword_masked(HWIO_GCC_QSPI_BCR_ADDR, HWIO_GCC_QSPI_BCR_RMSK)
#define HWIO_GCC_QSPI_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QSPI_BCR_ADDR, m)
#define HWIO_GCC_QSPI_BCR_OUT(v)      \
        out_dword(HWIO_GCC_QSPI_BCR_ADDR,v)
#define HWIO_GCC_QSPI_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QSPI_BCR_ADDR,m,v,HWIO_GCC_QSPI_BCR_IN)
#define HWIO_GCC_QSPI_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_QSPI_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_QSPI_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_QSPI_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0003b004)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003b004)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003b004)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_RMSK                                                        0x81d0000f
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ATTR                                                               0x3
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ADDR, HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_RMSK)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ADDR, m)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ADDR,v)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_ADDR,m,v,HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IN)
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                         0x1000000
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                              0x18
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                       0x800000
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                           0x17
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_DIS_BMSK                                                  0x400000
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_DIS_SHFT                                                      0x16
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                      0x100000
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                          0x14
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_SW_ONLY_EN_BMSK                                                    0x8
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_SW_ONLY_EN_SHFT                                                    0x3
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ARES_BMSK                                                      0x4
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ARES_SHFT                                                      0x2
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                             0x0
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ARES_RESET_FVAL                                                0x1
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_HW_CTL_BMSK                                                        0x2
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_HW_CTL_SHFT                                                        0x1
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                0x0
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_QSPI_CNOC_PERIPH_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_QSPI_CORE_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0003b008)
#define HWIO_GCC_QSPI_CORE_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003b008)
#define HWIO_GCC_QSPI_CORE_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003b008)
#define HWIO_GCC_QSPI_CORE_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_QSPI_CORE_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_QSPI_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CBCR_ADDR, HWIO_GCC_QSPI_CORE_CBCR_RMSK)
#define HWIO_GCC_QSPI_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CBCR_ADDR, m)
#define HWIO_GCC_QSPI_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_QSPI_CORE_CBCR_ADDR,v)
#define HWIO_GCC_QSPI_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QSPI_CORE_CBCR_ADDR,m,v,HWIO_GCC_QSPI_CORE_CBCR_IN)
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_QSPI_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_QSPI_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_QSPI_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_QSPI_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QSPI_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003b00c)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003b00c)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003b00c)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CMD_RCGR_ADDR, HWIO_GCC_QSPI_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QSPI_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QSPI_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_QSPI_CORE_CMD_RCGR_IN)
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_QSPI_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_QSPI_CORE_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0003b010)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003b010)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003b010)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CFG_RCGR_ADDR, HWIO_GCC_QSPI_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_QSPI_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_QSPI_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_QSPI_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_QSPI_CORE_CFG_RCGR_IN)
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_QSPI_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_RBCPR_MMCX_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00010000)
#define HWIO_GCC_RBCPR_MMCX_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00010000)
#define HWIO_GCC_RBCPR_MMCX_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00010000)
#define HWIO_GCC_RBCPR_MMCX_BCR_RMSK                                                                          0x1
#define HWIO_GCC_RBCPR_MMCX_BCR_ATTR                                                                          0x3
#define HWIO_GCC_RBCPR_MMCX_BCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_BCR_ADDR, HWIO_GCC_RBCPR_MMCX_BCR_RMSK)
#define HWIO_GCC_RBCPR_MMCX_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_BCR_ADDR, m)
#define HWIO_GCC_RBCPR_MMCX_BCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MMCX_BCR_ADDR,v)
#define HWIO_GCC_RBCPR_MMCX_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MMCX_BCR_ADDR,m,v,HWIO_GCC_RBCPR_MMCX_BCR_IN)
#define HWIO_GCC_RBCPR_MMCX_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_RBCPR_MMCX_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_RBCPR_MMCX_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_RBCPR_MMCX_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_RBCPR_MMCX_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00010004)
#define HWIO_GCC_RBCPR_MMCX_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00010004)
#define HWIO_GCC_RBCPR_MMCX_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00010004)
#define HWIO_GCC_RBCPR_MMCX_CBCR_RMSK                                                                  0x81c00005
#define HWIO_GCC_RBCPR_MMCX_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_RBCPR_MMCX_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CBCR_ADDR, HWIO_GCC_RBCPR_MMCX_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MMCX_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MMCX_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MMCX_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MMCX_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MMCX_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MMCX_CBCR_IN)
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_RBCPR_MMCX_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_RBCPR_MMCX_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_RBCPR_MMCX_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_RBCPR_MMCX_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MMCX_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00010008)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00010008)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00010008)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_RMSK                                                              0x81d0000f
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ATTR                                                                     0x3
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ADDR, HWIO_GCC_RBCPR_MMCX_AHB_CBCR_RMSK)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ADDR, m)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ADDR,v)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MMCX_AHB_CBCR_ADDR,m,v,HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IN)
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                               0x1000000
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                    0x18
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                             0x800000
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                 0x17
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_DIS_BMSK                                                        0x400000
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_DIS_SHFT                                                            0x16
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                            0x100000
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                0x14
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_SW_ONLY_EN_BMSK                                                          0x8
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_SW_ONLY_EN_SHFT                                                          0x3
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ARES_BMSK                                                            0x4
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ARES_SHFT                                                            0x2
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                   0x0
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ARES_RESET_FVAL                                                      0x1
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_HW_CTL_BMSK                                                              0x2
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_HW_CTL_SHFT                                                              0x1
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_RBCPR_MMCX_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0001000c)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001000c)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001000c)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_RMSK                                                              0x80000013
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ADDR, HWIO_GCC_RBCPR_MMCX_CMD_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MMCX_CMD_RCGR_IN)
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_OFF_SHFT                                                           0x1f
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                     0x10
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                      0x4
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_EN_BMSK                                                             0x2
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_EN_SHFT                                                             0x1
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_UPDATE_BMSK                                                              0x1
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_UPDATE_SHFT                                                              0x0
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_UPDATE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MMCX_CMD_RCGR_UPDATE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00010010)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00010010)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00010010)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RMSK                                                                0x11071f
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ATTR                                                                     0x3
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ADDR, HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RMSK)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ADDR, m)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ADDR,v)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RBCPR_MMCX_CFG_RCGR_ADDR,m,v,HWIO_GCC_RBCPR_MMCX_CFG_RCGR_IN)
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                 0x100000
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                     0x14
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                 0x10000
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                    0x10
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                     0x0
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                    0x1
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_BMSK                                                           0x700
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SHFT                                                             0x8
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                        0x0
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                        0x2
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                        0x3
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                        0x4
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                        0x5
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                        0x6
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                        0x7
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_BMSK                                                            0x1f
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_SHFT                                                             0x0
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                      0x0
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                        0x1
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                      0x2
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                        0x3
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                      0x4
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                        0x5
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                      0x6
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                        0x7
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                      0x8
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                        0x9
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                      0xa
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                        0xb
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                      0xc
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                        0xd
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                      0xe
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                        0xf
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                     0x10
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                       0x11
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                     0x12
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                      0x13
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                    0x14
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                      0x15
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                    0x16
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                      0x17
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                    0x18
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                      0x19
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                    0x1a
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                      0x1b
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                    0x1c
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                      0x1d
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                    0x1e
#define HWIO_GCC_RBCPR_MMCX_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                      0x1f

#define HWIO_GCC_IPCC_BCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00015000)
#define HWIO_GCC_IPCC_BCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00015000)
#define HWIO_GCC_IPCC_BCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00015000)
#define HWIO_GCC_IPCC_BCR_RMSK                                                                                0x1
#define HWIO_GCC_IPCC_BCR_ATTR                                                                                0x3
#define HWIO_GCC_IPCC_BCR_IN          \
        in_dword_masked(HWIO_GCC_IPCC_BCR_ADDR, HWIO_GCC_IPCC_BCR_RMSK)
#define HWIO_GCC_IPCC_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPCC_BCR_ADDR, m)
#define HWIO_GCC_IPCC_BCR_OUT(v)      \
        out_dword(HWIO_GCC_IPCC_BCR_ADDR,v)
#define HWIO_GCC_IPCC_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPCC_BCR_ADDR,m,v,HWIO_GCC_IPCC_BCR_IN)
#define HWIO_GCC_IPCC_BCR_BLK_ARES_BMSK                                                                       0x1
#define HWIO_GCC_IPCC_BCR_BLK_ARES_SHFT                                                                       0x0
#define HWIO_GCC_IPCC_BCR_BLK_ARES_DISABLE_FVAL                                                               0x0
#define HWIO_GCC_IPCC_BCR_BLK_ARES_ENABLE_FVAL                                                                0x1

#define HWIO_GCC_IPCC_CORE_CBCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00015004)
#define HWIO_GCC_IPCC_CORE_CBCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00015004)
#define HWIO_GCC_IPCC_CORE_CBCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00015004)
#define HWIO_GCC_IPCC_CORE_CBCR_RMSK                                                                   0x81c00005
#define HWIO_GCC_IPCC_CORE_CBCR_ATTR                                                                          0x3
#define HWIO_GCC_IPCC_CORE_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CBCR_ADDR, HWIO_GCC_IPCC_CORE_CBCR_RMSK)
#define HWIO_GCC_IPCC_CORE_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CBCR_ADDR, m)
#define HWIO_GCC_IPCC_CORE_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPCC_CORE_CBCR_ADDR,v)
#define HWIO_GCC_IPCC_CORE_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPCC_CORE_CBCR_ADDR,m,v,HWIO_GCC_IPCC_CORE_CBCR_IN)
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_OFF_BMSK                                                           0x80000000
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_OFF_SHFT                                                                 0x1f
#define HWIO_GCC_IPCC_CORE_CBCR_IGNORE_ALL_ARES_BMSK                                                    0x1000000
#define HWIO_GCC_IPCC_CORE_CBCR_IGNORE_ALL_ARES_SHFT                                                         0x18
#define HWIO_GCC_IPCC_CORE_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                  0x800000
#define HWIO_GCC_IPCC_CORE_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                      0x17
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_DIS_BMSK                                                             0x400000
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_DIS_SHFT                                                                 0x16
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ARES_BMSK                                                                 0x4
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ARES_SHFT                                                                 0x2
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ARES_NO_RESET_FVAL                                                        0x0
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ARES_RESET_FVAL                                                           0x1
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ENABLE_BMSK                                                               0x1
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ENABLE_SHFT                                                               0x0
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ENABLE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_IPCC_CORE_CBCR_CLK_ENABLE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_IPCC_AHB_CBCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00015008)
#define HWIO_GCC_IPCC_AHB_CBCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00015008)
#define HWIO_GCC_IPCC_AHB_CBCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00015008)
#define HWIO_GCC_IPCC_AHB_CBCR_RMSK                                                                    0x81d0000f
#define HWIO_GCC_IPCC_AHB_CBCR_ATTR                                                                           0x3
#define HWIO_GCC_IPCC_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_IPCC_AHB_CBCR_ADDR, HWIO_GCC_IPCC_AHB_CBCR_RMSK)
#define HWIO_GCC_IPCC_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPCC_AHB_CBCR_ADDR, m)
#define HWIO_GCC_IPCC_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_IPCC_AHB_CBCR_ADDR,v)
#define HWIO_GCC_IPCC_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPCC_AHB_CBCR_ADDR,m,v,HWIO_GCC_IPCC_AHB_CBCR_IN)
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                     0x1000000
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                          0x18
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                   0x800000
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                       0x17
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_DIS_BMSK                                                              0x400000
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_DIS_SHFT                                                                  0x16
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                  0x100000
#define HWIO_GCC_IPCC_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                      0x14
#define HWIO_GCC_IPCC_AHB_CBCR_SW_ONLY_EN_BMSK                                                                0x8
#define HWIO_GCC_IPCC_AHB_CBCR_SW_ONLY_EN_SHFT                                                                0x3
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ARES_BMSK                                                                  0x4
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ARES_SHFT                                                                  0x2
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                         0x0
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ARES_RESET_FVAL                                                            0x1
#define HWIO_GCC_IPCC_AHB_CBCR_HW_CTL_BMSK                                                                    0x2
#define HWIO_GCC_IPCC_AHB_CBCR_HW_CTL_SHFT                                                                    0x1
#define HWIO_GCC_IPCC_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_IPCC_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ENABLE_BMSK                                                                0x1
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ENABLE_SHFT                                                                0x0
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                        0x0
#define HWIO_GCC_IPCC_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                         0x1

#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0001500c)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001500c)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001500c)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_RMSK                                                               0x80000013
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CMD_RCGR_ADDR, HWIO_GCC_IPCC_CORE_CMD_RCGR_RMSK)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CMD_RCGR_ADDR, m)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_IPCC_CORE_CMD_RCGR_ADDR,v)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPCC_CORE_CMD_RCGR_ADDR,m,v,HWIO_GCC_IPCC_CORE_CMD_RCGR_IN)
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_OFF_SHFT                                                            0x1f
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                      0x10
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                       0x4
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_EN_BMSK                                                              0x2
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_EN_SHFT                                                              0x1
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                       0x1
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_UPDATE_BMSK                                                               0x1
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_UPDATE_SHFT                                                               0x0
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_UPDATE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_IPCC_CORE_CMD_RCGR_UPDATE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_IPCC_CORE_CFG_RCGR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00015010)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00015010)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00015010)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_RMSK                                                                 0x11071f
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_ATTR                                                                      0x3
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CFG_RCGR_ADDR, HWIO_GCC_IPCC_CORE_CFG_RCGR_RMSK)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_IPCC_CORE_CFG_RCGR_ADDR, m)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_IPCC_CORE_CFG_RCGR_ADDR,v)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_IPCC_CORE_CFG_RCGR_ADDR,m,v,HWIO_GCC_IPCC_CORE_CFG_RCGR_IN)
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                  0x100000
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                      0x14
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                               0x0
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                0x1
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                  0x10000
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                     0x10
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                      0x0
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                     0x1
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_BMSK                                                            0x700
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SHFT                                                              0x8
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                         0x0
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                         0x1
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                         0x2
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                         0x3
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                         0x4
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                         0x5
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                         0x6
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                         0x7
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_BMSK                                                             0x1f
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_SHFT                                                              0x0
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                       0x0
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                         0x1
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                       0x2
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                         0x3
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                       0x4
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                         0x5
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                       0x6
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                         0x7
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                       0x8
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                         0x9
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                       0xa
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                         0xb
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                       0xc
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                         0xd
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                       0xe
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                         0xf
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                      0x10
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                        0x11
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                      0x12
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                       0x13
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                     0x14
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                       0x15
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                     0x16
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                       0x17
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                     0x18
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                       0x19
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                     0x1a
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                       0x1b
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                     0x1c
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                       0x1d
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                     0x1e
#define HWIO_GCC_IPCC_CORE_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                       0x1f

#define HWIO_GCC_DPM_BCR_ADDR                                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00036000)
#define HWIO_GCC_DPM_BCR_PHYS                                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036000)
#define HWIO_GCC_DPM_BCR_OFFS                                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036000)
#define HWIO_GCC_DPM_BCR_RMSK                                                                                 0x1
#define HWIO_GCC_DPM_BCR_ATTR                                                                                 0x3
#define HWIO_GCC_DPM_BCR_IN          \
        in_dword_masked(HWIO_GCC_DPM_BCR_ADDR, HWIO_GCC_DPM_BCR_RMSK)
#define HWIO_GCC_DPM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_BCR_ADDR, m)
#define HWIO_GCC_DPM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_BCR_ADDR,v)
#define HWIO_GCC_DPM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_BCR_ADDR,m,v,HWIO_GCC_DPM_BCR_IN)
#define HWIO_GCC_DPM_BCR_BLK_ARES_BMSK                                                                        0x1
#define HWIO_GCC_DPM_BCR_BLK_ARES_SHFT                                                                        0x0
#define HWIO_GCC_DPM_BCR_BLK_ARES_DISABLE_FVAL                                                                0x0
#define HWIO_GCC_DPM_BCR_BLK_ARES_ENABLE_FVAL                                                                 0x1

#define HWIO_GCC_DPM_CBCR_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00036004)
#define HWIO_GCC_DPM_CBCR_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036004)
#define HWIO_GCC_DPM_CBCR_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036004)
#define HWIO_GCC_DPM_CBCR_RMSK                                                                         0x81c0000f
#define HWIO_GCC_DPM_CBCR_ATTR                                                                                0x3
#define HWIO_GCC_DPM_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DPM_CBCR_ADDR, HWIO_GCC_DPM_CBCR_RMSK)
#define HWIO_GCC_DPM_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_CBCR_ADDR, m)
#define HWIO_GCC_DPM_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_CBCR_ADDR,v)
#define HWIO_GCC_DPM_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_CBCR_ADDR,m,v,HWIO_GCC_DPM_CBCR_IN)
#define HWIO_GCC_DPM_CBCR_CLK_OFF_BMSK                                                                 0x80000000
#define HWIO_GCC_DPM_CBCR_CLK_OFF_SHFT                                                                       0x1f
#define HWIO_GCC_DPM_CBCR_IGNORE_ALL_ARES_BMSK                                                          0x1000000
#define HWIO_GCC_DPM_CBCR_IGNORE_ALL_ARES_SHFT                                                               0x18
#define HWIO_GCC_DPM_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                        0x800000
#define HWIO_GCC_DPM_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                            0x17
#define HWIO_GCC_DPM_CBCR_CLK_DIS_BMSK                                                                   0x400000
#define HWIO_GCC_DPM_CBCR_CLK_DIS_SHFT                                                                       0x16
#define HWIO_GCC_DPM_CBCR_SW_ONLY_EN_BMSK                                                                     0x8
#define HWIO_GCC_DPM_CBCR_SW_ONLY_EN_SHFT                                                                     0x3
#define HWIO_GCC_DPM_CBCR_CLK_ARES_BMSK                                                                       0x4
#define HWIO_GCC_DPM_CBCR_CLK_ARES_SHFT                                                                       0x2
#define HWIO_GCC_DPM_CBCR_CLK_ARES_NO_RESET_FVAL                                                              0x0
#define HWIO_GCC_DPM_CBCR_CLK_ARES_RESET_FVAL                                                                 0x1
#define HWIO_GCC_DPM_CBCR_HW_CTL_BMSK                                                                         0x2
#define HWIO_GCC_DPM_CBCR_HW_CTL_SHFT                                                                         0x1
#define HWIO_GCC_DPM_CBCR_HW_CTL_DISABLE_FVAL                                                                 0x0
#define HWIO_GCC_DPM_CBCR_HW_CTL_ENABLE_FVAL                                                                  0x1
#define HWIO_GCC_DPM_CBCR_CLK_ENABLE_BMSK                                                                     0x1
#define HWIO_GCC_DPM_CBCR_CLK_ENABLE_SHFT                                                                     0x0
#define HWIO_GCC_DPM_CBCR_CLK_ENABLE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_DPM_CBCR_CLK_ENABLE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_DPM_CX_AHB_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00036008)
#define HWIO_GCC_DPM_CX_AHB_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036008)
#define HWIO_GCC_DPM_CX_AHB_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036008)
#define HWIO_GCC_DPM_CX_AHB_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_DPM_CX_AHB_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_DPM_CX_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DPM_CX_AHB_CBCR_ADDR, HWIO_GCC_DPM_CX_AHB_CBCR_RMSK)
#define HWIO_GCC_DPM_CX_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_CX_AHB_CBCR_ADDR, m)
#define HWIO_GCC_DPM_CX_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_CX_AHB_CBCR_ADDR,v)
#define HWIO_GCC_DPM_CX_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_CX_AHB_CBCR_ADDR,m,v,HWIO_GCC_DPM_CX_AHB_CBCR_IN)
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_DPM_CX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_DPM_CX_AHB_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_DPM_CX_AHB_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_DPM_CX_AHB_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_DPM_CX_AHB_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_DPM_CX_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_DPM_CX_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_DPM_CX_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_DPM_MX_AHB_CBCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0003600c)
#define HWIO_GCC_DPM_MX_AHB_CBCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003600c)
#define HWIO_GCC_DPM_MX_AHB_CBCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003600c)
#define HWIO_GCC_DPM_MX_AHB_CBCR_RMSK                                                                  0x81d0000f
#define HWIO_GCC_DPM_MX_AHB_CBCR_ATTR                                                                         0x3
#define HWIO_GCC_DPM_MX_AHB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DPM_MX_AHB_CBCR_ADDR, HWIO_GCC_DPM_MX_AHB_CBCR_RMSK)
#define HWIO_GCC_DPM_MX_AHB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_MX_AHB_CBCR_ADDR, m)
#define HWIO_GCC_DPM_MX_AHB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_MX_AHB_CBCR_ADDR,v)
#define HWIO_GCC_DPM_MX_AHB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_MX_AHB_CBCR_ADDR,m,v,HWIO_GCC_DPM_MX_AHB_CBCR_IN)
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_OFF_BMSK                                                          0x80000000
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_OFF_SHFT                                                                0x1f
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_ALL_ARES_BMSK                                                   0x1000000
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_ALL_ARES_SHFT                                                        0x18
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                 0x800000
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                     0x17
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_DIS_BMSK                                                            0x400000
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_DIS_SHFT                                                                0x16
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_BMSK                                                0x100000
#define HWIO_GCC_DPM_MX_AHB_CBCR_IGNORE_RPMH_CLK_DIS_SHFT                                                    0x14
#define HWIO_GCC_DPM_MX_AHB_CBCR_SW_ONLY_EN_BMSK                                                              0x8
#define HWIO_GCC_DPM_MX_AHB_CBCR_SW_ONLY_EN_SHFT                                                              0x3
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ARES_BMSK                                                                0x4
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ARES_SHFT                                                                0x2
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ARES_NO_RESET_FVAL                                                       0x0
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ARES_RESET_FVAL                                                          0x1
#define HWIO_GCC_DPM_MX_AHB_CBCR_HW_CTL_BMSK                                                                  0x2
#define HWIO_GCC_DPM_MX_AHB_CBCR_HW_CTL_SHFT                                                                  0x1
#define HWIO_GCC_DPM_MX_AHB_CBCR_HW_CTL_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_DPM_MX_AHB_CBCR_HW_CTL_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ENABLE_BMSK                                                              0x1
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ENABLE_SHFT                                                              0x0
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_DPM_MX_AHB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_DPM_CB_CBCR_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00036010)
#define HWIO_GCC_DPM_CB_CBCR_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036010)
#define HWIO_GCC_DPM_CB_CBCR_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036010)
#define HWIO_GCC_DPM_CB_CBCR_RMSK                                                                      0x81c00005
#define HWIO_GCC_DPM_CB_CBCR_ATTR                                                                             0x3
#define HWIO_GCC_DPM_CB_CBCR_IN          \
        in_dword_masked(HWIO_GCC_DPM_CB_CBCR_ADDR, HWIO_GCC_DPM_CB_CBCR_RMSK)
#define HWIO_GCC_DPM_CB_CBCR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_CB_CBCR_ADDR, m)
#define HWIO_GCC_DPM_CB_CBCR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_CB_CBCR_ADDR,v)
#define HWIO_GCC_DPM_CB_CBCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_CB_CBCR_ADDR,m,v,HWIO_GCC_DPM_CB_CBCR_IN)
#define HWIO_GCC_DPM_CB_CBCR_CLK_OFF_BMSK                                                              0x80000000
#define HWIO_GCC_DPM_CB_CBCR_CLK_OFF_SHFT                                                                    0x1f
#define HWIO_GCC_DPM_CB_CBCR_IGNORE_ALL_ARES_BMSK                                                       0x1000000
#define HWIO_GCC_DPM_CB_CBCR_IGNORE_ALL_ARES_SHFT                                                            0x18
#define HWIO_GCC_DPM_CB_CBCR_IGNORE_ALL_CLK_DIS_BMSK                                                     0x800000
#define HWIO_GCC_DPM_CB_CBCR_IGNORE_ALL_CLK_DIS_SHFT                                                         0x17
#define HWIO_GCC_DPM_CB_CBCR_CLK_DIS_BMSK                                                                0x400000
#define HWIO_GCC_DPM_CB_CBCR_CLK_DIS_SHFT                                                                    0x16
#define HWIO_GCC_DPM_CB_CBCR_CLK_ARES_BMSK                                                                    0x4
#define HWIO_GCC_DPM_CB_CBCR_CLK_ARES_SHFT                                                                    0x2
#define HWIO_GCC_DPM_CB_CBCR_CLK_ARES_NO_RESET_FVAL                                                           0x0
#define HWIO_GCC_DPM_CB_CBCR_CLK_ARES_RESET_FVAL                                                              0x1
#define HWIO_GCC_DPM_CB_CBCR_CLK_ENABLE_BMSK                                                                  0x1
#define HWIO_GCC_DPM_CB_CBCR_CLK_ENABLE_SHFT                                                                  0x0
#define HWIO_GCC_DPM_CB_CBCR_CLK_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_DPM_CB_CBCR_CLK_ENABLE_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_DPM_CMD_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00036014)
#define HWIO_GCC_DPM_CMD_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036014)
#define HWIO_GCC_DPM_CMD_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036014)
#define HWIO_GCC_DPM_CMD_RCGR_RMSK                                                                     0x80000013
#define HWIO_GCC_DPM_CMD_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_DPM_CMD_RCGR_IN          \
        in_dword_masked(HWIO_GCC_DPM_CMD_RCGR_ADDR, HWIO_GCC_DPM_CMD_RCGR_RMSK)
#define HWIO_GCC_DPM_CMD_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_CMD_RCGR_ADDR, m)
#define HWIO_GCC_DPM_CMD_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_CMD_RCGR_ADDR,v)
#define HWIO_GCC_DPM_CMD_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_CMD_RCGR_ADDR,m,v,HWIO_GCC_DPM_CMD_RCGR_IN)
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_OFF_BMSK                                                            0x80000000
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_OFF_SHFT                                                                  0x1f
#define HWIO_GCC_DPM_CMD_RCGR_DIRTY_CFG_RCGR_BMSK                                                            0x10
#define HWIO_GCC_DPM_CMD_RCGR_DIRTY_CFG_RCGR_SHFT                                                             0x4
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_EN_BMSK                                                                    0x2
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_EN_SHFT                                                                    0x1
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_EN_DISABLE_FVAL                                                            0x0
#define HWIO_GCC_DPM_CMD_RCGR_ROOT_EN_ENABLE_FVAL                                                             0x1
#define HWIO_GCC_DPM_CMD_RCGR_UPDATE_BMSK                                                                     0x1
#define HWIO_GCC_DPM_CMD_RCGR_UPDATE_SHFT                                                                     0x0
#define HWIO_GCC_DPM_CMD_RCGR_UPDATE_DISABLE_FVAL                                                             0x0
#define HWIO_GCC_DPM_CMD_RCGR_UPDATE_ENABLE_FVAL                                                              0x1

#define HWIO_GCC_DPM_CFG_RCGR_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00036018)
#define HWIO_GCC_DPM_CFG_RCGR_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00036018)
#define HWIO_GCC_DPM_CFG_RCGR_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00036018)
#define HWIO_GCC_DPM_CFG_RCGR_RMSK                                                                       0x11071f
#define HWIO_GCC_DPM_CFG_RCGR_ATTR                                                                            0x3
#define HWIO_GCC_DPM_CFG_RCGR_IN          \
        in_dword_masked(HWIO_GCC_DPM_CFG_RCGR_ADDR, HWIO_GCC_DPM_CFG_RCGR_RMSK)
#define HWIO_GCC_DPM_CFG_RCGR_INM(m)      \
        in_dword_masked(HWIO_GCC_DPM_CFG_RCGR_ADDR, m)
#define HWIO_GCC_DPM_CFG_RCGR_OUT(v)      \
        out_dword(HWIO_GCC_DPM_CFG_RCGR_ADDR,v)
#define HWIO_GCC_DPM_CFG_RCGR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DPM_CFG_RCGR_ADDR,m,v,HWIO_GCC_DPM_CFG_RCGR_IN)
#define HWIO_GCC_DPM_CFG_RCGR_HW_CLK_CONTROL_BMSK                                                        0x100000
#define HWIO_GCC_DPM_CFG_RCGR_HW_CLK_CONTROL_SHFT                                                            0x14
#define HWIO_GCC_DPM_CFG_RCGR_HW_CLK_CONTROL_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_DPM_CFG_RCGR_HW_CLK_CONTROL_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_DPM_CFG_RCGR_RCGLITE_DISABLE_BMSK                                                        0x10000
#define HWIO_GCC_DPM_CFG_RCGR_RCGLITE_DISABLE_SHFT                                                           0x10
#define HWIO_GCC_DPM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_ENABLED_FVAL                                            0x0
#define HWIO_GCC_DPM_CFG_RCGR_RCGLITE_DISABLE_RCGLITE_DISABLED_FVAL                                           0x1
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_BMSK                                                                  0x700
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SHFT                                                                    0x8
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC0_FVAL                                                               0x0
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC1_FVAL                                                               0x1
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC2_FVAL                                                               0x2
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC3_FVAL                                                               0x3
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC4_FVAL                                                               0x4
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC5_FVAL                                                               0x5
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC6_FVAL                                                               0x6
#define HWIO_GCC_DPM_CFG_RCGR_SRC_SEL_SRC7_FVAL                                                               0x7
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_BMSK                                                                   0x1f
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_SHFT                                                                    0x0
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_BYPASS_FVAL                                                             0x0
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV1_FVAL                                                               0x1
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV1_5_FVAL                                                             0x2
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV2_FVAL                                                               0x3
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV2_5_FVAL                                                             0x4
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV3_FVAL                                                               0x5
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV3_5_FVAL                                                             0x6
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV4_FVAL                                                               0x7
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV4_5_FVAL                                                             0x8
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV5_FVAL                                                               0x9
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV5_5_FVAL                                                             0xa
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV6_FVAL                                                               0xb
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV6_5_FVAL                                                             0xc
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV7_FVAL                                                               0xd
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV7_5_FVAL                                                             0xe
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV8_FVAL                                                               0xf
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV8_5_FVAL                                                            0x10
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV9_FVAL                                                              0x11
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV9_5_FVAL                                                            0x12
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV10_FVAL                                                             0x13
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV10_5_FVAL                                                           0x14
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV11_FVAL                                                             0x15
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV11_5_FVAL                                                           0x16
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV12_FVAL                                                             0x17
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV12_5_FVAL                                                           0x18
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV13_FVAL                                                             0x19
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV13_5_FVAL                                                           0x1a
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV14_FVAL                                                             0x1b
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV14_5_FVAL                                                           0x1c
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV15_FVAL                                                             0x1d
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV15_5_FVAL                                                           0x1e
#define HWIO_GCC_DPM_CFG_RCGR_SRC_DIV_DIV16_FVAL                                                             0x1f

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018004)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018004)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018004)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP1_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018008)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018008)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018008)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP2_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0001800c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001800c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001800c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP3_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018010)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018010)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018010)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP4_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018014)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018014)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018014)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP5_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018018)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018018)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018018)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP6_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0001801c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001801c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001801c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP7_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018020)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018020)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018020)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP8_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ADDR                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00018024)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_PHYS                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018024)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_OFFS                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018024)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_RMSK                                         0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ATTR                                                0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                  0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                        0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                     0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                     0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP9_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                              0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018028)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018028)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018028)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP10_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0001802c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001802c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001802c)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP11_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018030)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018030)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018030)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP12_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018034)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018034)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018034)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_MAIN_PWRGRP13_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018038)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018038)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018038)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP14_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0001803c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001803c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001803c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP15_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018040)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018040)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018040)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP16_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018044)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018044)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018044)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP17_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018048)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018048)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018048)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP18_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0001804c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001804c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001804c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP19_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018050)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018050)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018050)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP20_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018054)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018054)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018054)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP21_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018058)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018058)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018058)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP22_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0001805c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001805c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001805c)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP23_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018060)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018060)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018060)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP24_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018064)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018064)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018064)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP25_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ADDR                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00018068)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_PHYS                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00018068)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_OFFS                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00018068)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_RMSK                                        0x80000001
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ATTR                                               0x3
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_IN          \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ADDR, HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_RMSK)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_INM(m)      \
        in_dword_masked(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ADDR, m)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_OUT(v)      \
        out_dword(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ADDR,v)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_ADDR,m,v,HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_IN)
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ON_BMSK                                 0x80000000
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ON_SHFT                                       0x1f
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ENABLE_BMSK                                    0x1
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ENABLE_SHFT                                    0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_GPLL0_OUT_EVEN_PWRGRP26_CLKGEN_ACGC_ACGCR_CLK_ENABLE_ENABLE_FVAL                             0x1

#define HWIO_GCC_SP_IPA_SGDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f000)
#define HWIO_GCC_SP_IPA_SGDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f000)
#define HWIO_GCC_SP_IPA_SGDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f000)
#define HWIO_GCC_SP_IPA_SGDSCR_RMSK                                                                           0x7
#define HWIO_GCC_SP_IPA_SGDSCR_ATTR                                                                           0x3
#define HWIO_GCC_SP_IPA_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_IPA_SGDSCR_ADDR, HWIO_GCC_SP_IPA_SGDSCR_RMSK)
#define HWIO_GCC_SP_IPA_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_IPA_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_IPA_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_IPA_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_IPA_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_IPA_SGDSCR_ADDR,m,v,HWIO_GCC_SP_IPA_SGDSCR_IN)
#define HWIO_GCC_SP_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                                0x4
#define HWIO_GCC_SP_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                                0x2
#define HWIO_GCC_SP_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SP_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SP_IPA_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                          0x2
#define HWIO_GCC_SP_IPA_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                          0x1
#define HWIO_GCC_SP_IPA_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SP_IPA_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_SP_IPA_SGDSCR_SW_OVERRIDE_BMSK                                                               0x1
#define HWIO_GCC_SP_IPA_SGDSCR_SW_OVERRIDE_SHFT                                                               0x0
#define HWIO_GCC_SP_IPA_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_SP_IPA_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f004)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f004)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f004)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RMSK                                                                     0x7
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ATTR                                                                     0x3
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ADDR, HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RMSK)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_ANOC_PCIE_SGDSCR_ADDR,m,v,HWIO_GCC_SP_ANOC_PCIE_SGDSCR_IN)
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                          0x2
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                    0x2
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                    0x1
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_SW_OVERRIDE_BMSK                                                         0x1
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_SW_OVERRIDE_SHFT                                                         0x0
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_ANOC_PCIE_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f008)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f008)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f008)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ADDR, HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RMSK)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_IN)
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f00c)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f00c)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f00c)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_USB30_PRIM_SGDSCR_ADDR, HWIO_GCC_SP_USB30_PRIM_SGDSCR_RMSK)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_USB30_PRIM_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_USB30_PRIM_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_USB30_PRIM_SGDSCR_ADDR,m,v,HWIO_GCC_SP_USB30_PRIM_SGDSCR_IN)
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_USB30_PRIM_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_UFS_PHY_SGDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f010)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f010)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f010)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_RMSK                                                                       0x7
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_ATTR                                                                       0x3
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_UFS_PHY_SGDSCR_ADDR, HWIO_GCC_SP_UFS_PHY_SGDSCR_RMSK)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_UFS_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_UFS_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_UFS_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_SP_UFS_PHY_SGDSCR_IN)
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                            0x4
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x2
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x2
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                      0x1
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                           0x0
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_SP_UFS_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_SP_USB3_PHY_SGDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f014)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f014)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f014)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_RMSK                                                                      0x7
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_ATTR                                                                      0x3
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_USB3_PHY_SGDSCR_ADDR, HWIO_GCC_SP_USB3_PHY_SGDSCR_RMSK)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_USB3_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_USB3_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_USB3_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_SP_USB3_PHY_SGDSCR_IN)
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                           0x4
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                           0x2
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x2
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                     0x1
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                          0x1
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                          0x0
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SP_USB3_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SP_MMU_SGDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f018)
#define HWIO_GCC_SP_MMU_SGDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f018)
#define HWIO_GCC_SP_MMU_SGDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f018)
#define HWIO_GCC_SP_MMU_SGDSCR_RMSK                                                                           0x7
#define HWIO_GCC_SP_MMU_SGDSCR_ATTR                                                                           0x3
#define HWIO_GCC_SP_MMU_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_MMU_SGDSCR_ADDR, HWIO_GCC_SP_MMU_SGDSCR_RMSK)
#define HWIO_GCC_SP_MMU_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_MMU_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_MMU_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_MMU_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_MMU_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_MMU_SGDSCR_ADDR,m,v,HWIO_GCC_SP_MMU_SGDSCR_IN)
#define HWIO_GCC_SP_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                                0x4
#define HWIO_GCC_SP_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                                0x2
#define HWIO_GCC_SP_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SP_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SP_MMU_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                          0x2
#define HWIO_GCC_SP_MMU_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                          0x1
#define HWIO_GCC_SP_MMU_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SP_MMU_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_SP_MMU_SGDSCR_SW_OVERRIDE_BMSK                                                               0x1
#define HWIO_GCC_SP_MMU_SGDSCR_SW_OVERRIDE_SHFT                                                               0x0
#define HWIO_GCC_SP_MMU_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_SP_MMU_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_SP_PCIE_1_SGDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f01c)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f01c)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f01c)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_RMSK                                                                        0x7
#define HWIO_GCC_SP_PCIE_1_SGDSCR_ATTR                                                                        0x3
#define HWIO_GCC_SP_PCIE_1_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_PCIE_1_SGDSCR_ADDR, HWIO_GCC_SP_PCIE_1_SGDSCR_RMSK)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PCIE_1_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_PCIE_1_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PCIE_1_SGDSCR_ADDR,m,v,HWIO_GCC_SP_PCIE_1_SGDSCR_IN)
#define HWIO_GCC_SP_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                             0x4
#define HWIO_GCC_SP_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                             0x2
#define HWIO_GCC_SP_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SP_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SP_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                       0x2
#define HWIO_GCC_SP_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                       0x1
#define HWIO_GCC_SP_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_SP_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_SP_PCIE_1_SGDSCR_SW_OVERRIDE_BMSK                                                            0x1
#define HWIO_GCC_SP_PCIE_1_SGDSCR_SW_OVERRIDE_SHFT                                                            0x0
#define HWIO_GCC_SP_PCIE_1_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SP_PCIE_1_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f020)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f020)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f020)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ADDR, HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RMSK)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_IN)
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_TURING_QTB_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f024)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f024)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f024)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_TURING_QTB_SGDSCR_ADDR, HWIO_GCC_SP_TURING_QTB_SGDSCR_RMSK)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_TURING_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_TURING_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_TURING_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_SP_TURING_QTB_SGDSCR_IN)
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_TURING_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f028)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f028)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f028)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ADDR, HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RMSK)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_IN)
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_SP_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_SP_PCIE_0_SGDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f02c)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f02c)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f02c)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_RMSK                                                                        0x7
#define HWIO_GCC_SP_PCIE_0_SGDSCR_ATTR                                                                        0x3
#define HWIO_GCC_SP_PCIE_0_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_PCIE_0_SGDSCR_ADDR, HWIO_GCC_SP_PCIE_0_SGDSCR_RMSK)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PCIE_0_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_PCIE_0_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PCIE_0_SGDSCR_ADDR,m,v,HWIO_GCC_SP_PCIE_0_SGDSCR_IN)
#define HWIO_GCC_SP_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                             0x4
#define HWIO_GCC_SP_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                             0x2
#define HWIO_GCC_SP_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SP_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SP_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                       0x2
#define HWIO_GCC_SP_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                       0x1
#define HWIO_GCC_SP_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_SP_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_SP_PCIE_0_SGDSCR_SW_OVERRIDE_BMSK                                                            0x1
#define HWIO_GCC_SP_PCIE_0_SGDSCR_SW_OVERRIDE_SHFT                                                            0x0
#define HWIO_GCC_SP_PCIE_0_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_SP_PCIE_0_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f030)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f030)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f030)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_RMSK                                                                     0x7
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_ATTR                                                                     0x3
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_LPASS_QTB_SGDSCR_ADDR, HWIO_GCC_SP_LPASS_QTB_SGDSCR_RMSK)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_LPASS_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_LPASS_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_LPASS_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_SP_LPASS_QTB_SGDSCR_IN)
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                          0x2
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                    0x2
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                    0x1
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                         0x1
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                         0x0
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_LPASS_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SP_MMNOC_SGDSCR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f034)
#define HWIO_GCC_SP_MMNOC_SGDSCR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f034)
#define HWIO_GCC_SP_MMNOC_SGDSCR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f034)
#define HWIO_GCC_SP_MMNOC_SGDSCR_RMSK                                                                         0x7
#define HWIO_GCC_SP_MMNOC_SGDSCR_ATTR                                                                         0x3
#define HWIO_GCC_SP_MMNOC_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_SP_MMNOC_SGDSCR_ADDR, HWIO_GCC_SP_MMNOC_SGDSCR_RMSK)
#define HWIO_GCC_SP_MMNOC_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_MMNOC_SGDSCR_ADDR, m)
#define HWIO_GCC_SP_MMNOC_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_SP_MMNOC_SGDSCR_ADDR,v)
#define HWIO_GCC_SP_MMNOC_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_MMNOC_SGDSCR_ADDR,m,v,HWIO_GCC_SP_MMNOC_SGDSCR_IN)
#define HWIO_GCC_SP_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                              0x4
#define HWIO_GCC_SP_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                              0x2
#define HWIO_GCC_SP_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_SP_MMNOC_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                        0x2
#define HWIO_GCC_SP_MMNOC_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                        0x1
#define HWIO_GCC_SP_MMNOC_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_MMNOC_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_MMNOC_SGDSCR_SW_OVERRIDE_BMSK                                                             0x1
#define HWIO_GCC_SP_MMNOC_SGDSCR_SW_OVERRIDE_SHFT                                                             0x0
#define HWIO_GCC_SP_MMNOC_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_SP_MMNOC_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                      0x1

#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00043000)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043000)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043000)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_RMSK                                                                      0x7
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_ATTR                                                                      0x3
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_IPA_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_IPA_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_IPA_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_IPA_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_IPA_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_IPA_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                           0x4
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                           0x2
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x2
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                     0x1
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_SW_OVERRIDE_BMSK                                                          0x1
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_SW_OVERRIDE_SHFT                                                          0x0
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_APCS_TZ_IPA_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00043004)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043004)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043004)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_ANOC_PCIE_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00043008)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043008)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043008)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RMSK                                                               0x7
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ATTR                                                               0x3
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                    0x2
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                              0x2
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                              0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                   0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                   0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0004300c)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004300c)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004300c)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RMSK                                                               0x7
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ATTR                                                               0x3
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                    0x2
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_BMSK                                              0x2
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_SHFT                                              0x1
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_SW_OVERRIDE_BMSK                                                   0x1
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_SW_OVERRIDE_SHFT                                                   0x0
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_USB30_PRIM_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00043010)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043010)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043010)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RMSK                                                                  0x7
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ATTR                                                                  0x3
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                       0x4
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                       0x2
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                 0x2
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                 0x1
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                      0x1
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                      0x0
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_TZ_UFS_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00043014)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043014)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043014)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RMSK                                                                 0x7
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ATTR                                                                 0x3
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                      0x4
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                      0x2
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                0x2
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                0x1
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                     0x1
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                     0x0
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_APCS_TZ_USB3_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00043018)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043018)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043018)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_RMSK                                                                      0x7
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_ATTR                                                                      0x3
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_MMU_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_MMU_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_MMU_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_MMU_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_MMU_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_MMU_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                           0x4
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                           0x2
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x2
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                     0x1
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_SW_OVERRIDE_BMSK                                                          0x1
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_SW_OVERRIDE_SHFT                                                          0x0
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_APCS_TZ_MMU_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0004301c)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004301c)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004301c)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_TZ_PCIE_1_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00043020)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043020)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043020)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RMSK                                                               0x7
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ATTR                                                               0x3
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                    0x2
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                              0x2
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                              0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                   0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                   0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00043024)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043024)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043024)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RMSK                                                               0x7
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ATTR                                                               0x3
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                    0x2
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                              0x2
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                              0x1
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                   0x1
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                   0x0
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_TURING_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00043028)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043028)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043028)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RMSK                                                              0x7
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ATTR                                                              0x3
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                   0x4
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                   0x2
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                             0x2
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                             0x1
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                  0x1
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                  0x0
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_APCS_TZ_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0004302c)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004302c)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004302c)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_TZ_PCIE_0_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00043030)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043030)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043030)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_LPASS_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00043034)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043034)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043034)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ADDR, HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RMSK)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ADDR, m)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ADDR,v)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_ADDR,m,v,HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_IN)
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_APCS_TZ_MMNOC_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00025000)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025000)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025000)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_RMSK                                                                       0x7
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_ATTR                                                                       0x3
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_IPA_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_IPA_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_IPA_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_IPA_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_IPA_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_IPA_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                            0x4
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x2
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x2
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                      0x1
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_SW_OVERRIDE_SHFT                                                           0x0
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MSS_Q6_IPA_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00025004)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025004)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025004)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RMSK                                                                 0x7
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ATTR                                                                 0x3
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                      0x4
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                      0x2
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                0x2
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                0x1
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_SW_OVERRIDE_BMSK                                                     0x1
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_SW_OVERRIDE_SHFT                                                     0x0
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_ANOC_PCIE_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00025008)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025008)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025008)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002500c)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002500c)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002500c)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_USB30_PRIM_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00025010)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025010)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025010)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_MSS_Q6_UFS_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00025014)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025014)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025014)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RMSK                                                                  0x7
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ATTR                                                                  0x3
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                       0x4
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                       0x2
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                 0x2
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                 0x1
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                      0x1
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                      0x0
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_MSS_Q6_USB3_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00025018)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025018)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025018)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_RMSK                                                                       0x7
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_ATTR                                                                       0x3
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MMU_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_MMU_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MMU_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MMU_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MMU_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_MMU_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                            0x4
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x2
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x2
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                      0x1
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_SW_OVERRIDE_SHFT                                                           0x0
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_MSS_Q6_MMU_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002501c)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002501c)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002501c)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MSS_Q6_PCIE_1_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00025020)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025020)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025020)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00025024)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025024)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025024)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RMSK                                                                0x7
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                     0x4
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                     0x2
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                               0x2
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                               0x1
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                    0x1
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                    0x0
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_TURING_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00025028)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025028)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025028)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RMSK                                                               0x7
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ATTR                                                               0x3
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                    0x4
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                    0x2
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                            0x0
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                             0x1
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                              0x2
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                              0x1
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                       0x1
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                   0x1
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                   0x0
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MSS_Q6_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0002502c)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002502c)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002502c)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MSS_Q6_PCIE_0_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00025030)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025030)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025030)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RMSK                                                                 0x7
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ATTR                                                                 0x3
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                      0x4
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                      0x2
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                0x2
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                0x1
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                     0x1
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                     0x0
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_LPASS_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00025034)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025034)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025034)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RMSK                                                                     0x7
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ATTR                                                                     0x3
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ADDR, HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RMSK)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ADDR, m)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ADDR,v)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_ADDR,m,v,HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_IN)
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                          0x2
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                    0x2
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                    0x1
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_SW_OVERRIDE_BMSK                                                         0x1
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_SW_OVERRIDE_SHFT                                                         0x0
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MSS_Q6_MMNOC_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_TME_IPA_SGDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00059000)
#define HWIO_GCC_TME_IPA_SGDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059000)
#define HWIO_GCC_TME_IPA_SGDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059000)
#define HWIO_GCC_TME_IPA_SGDSCR_RMSK                                                                          0x7
#define HWIO_GCC_TME_IPA_SGDSCR_ATTR                                                                          0x3
#define HWIO_GCC_TME_IPA_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_IPA_SGDSCR_ADDR, HWIO_GCC_TME_IPA_SGDSCR_RMSK)
#define HWIO_GCC_TME_IPA_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_IPA_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_IPA_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_IPA_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_IPA_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_IPA_SGDSCR_ADDR,m,v,HWIO_GCC_TME_IPA_SGDSCR_IN)
#define HWIO_GCC_TME_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                               0x4
#define HWIO_GCC_TME_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                               0x2
#define HWIO_GCC_TME_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TME_IPA_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_TME_IPA_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                         0x2
#define HWIO_GCC_TME_IPA_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                         0x1
#define HWIO_GCC_TME_IPA_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TME_IPA_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_TME_IPA_SGDSCR_SW_OVERRIDE_BMSK                                                              0x1
#define HWIO_GCC_TME_IPA_SGDSCR_SW_OVERRIDE_SHFT                                                              0x0
#define HWIO_GCC_TME_IPA_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TME_IPA_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00059004)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059004)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059004)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ADDR, HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RMSK)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_ANOC_PCIE_SGDSCR_ADDR,m,v,HWIO_GCC_TME_ANOC_PCIE_SGDSCR_IN)
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_ANOC_PCIE_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00059008)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059008)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059008)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ADDR, HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RMSK)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_IN)
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PCIE_1_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0005900c)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005900c)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005900c)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_USB30_PRIM_SGDSCR_ADDR, HWIO_GCC_TME_USB30_PRIM_SGDSCR_RMSK)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_USB30_PRIM_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_USB30_PRIM_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_USB30_PRIM_SGDSCR_ADDR,m,v,HWIO_GCC_TME_USB30_PRIM_SGDSCR_IN)
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_USB30_PRIM_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TME_UFS_PHY_SGDSCR_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00059010)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059010)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059010)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_RMSK                                                                      0x7
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_ATTR                                                                      0x3
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_UFS_PHY_SGDSCR_ADDR, HWIO_GCC_TME_UFS_PHY_SGDSCR_RMSK)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_UFS_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_UFS_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_UFS_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_TME_UFS_PHY_SGDSCR_IN)
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                           0x4
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                           0x2
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                    0x1
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                     0x2
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                     0x1
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                              0x1
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                          0x1
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                          0x0
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TME_UFS_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_TME_USB3_PHY_SGDSCR_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00059014)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059014)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059014)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_RMSK                                                                     0x7
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_ATTR                                                                     0x3
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_USB3_PHY_SGDSCR_ADDR, HWIO_GCC_TME_USB3_PHY_SGDSCR_RMSK)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_USB3_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_USB3_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_USB3_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_TME_USB3_PHY_SGDSCR_IN)
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                          0x4
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                          0x2
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                    0x2
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                    0x1
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                             0x1
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                         0x1
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                         0x0
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TME_USB3_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_TME_MMU_SGDSCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00059018)
#define HWIO_GCC_TME_MMU_SGDSCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059018)
#define HWIO_GCC_TME_MMU_SGDSCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059018)
#define HWIO_GCC_TME_MMU_SGDSCR_RMSK                                                                          0x7
#define HWIO_GCC_TME_MMU_SGDSCR_ATTR                                                                          0x3
#define HWIO_GCC_TME_MMU_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_MMU_SGDSCR_ADDR, HWIO_GCC_TME_MMU_SGDSCR_RMSK)
#define HWIO_GCC_TME_MMU_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_MMU_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_MMU_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_MMU_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_MMU_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_MMU_SGDSCR_ADDR,m,v,HWIO_GCC_TME_MMU_SGDSCR_IN)
#define HWIO_GCC_TME_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                               0x4
#define HWIO_GCC_TME_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                               0x2
#define HWIO_GCC_TME_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TME_MMU_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                        0x1
#define HWIO_GCC_TME_MMU_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                         0x2
#define HWIO_GCC_TME_MMU_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                         0x1
#define HWIO_GCC_TME_MMU_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TME_MMU_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_TME_MMU_SGDSCR_SW_OVERRIDE_BMSK                                                              0x1
#define HWIO_GCC_TME_MMU_SGDSCR_SW_OVERRIDE_SHFT                                                              0x0
#define HWIO_GCC_TME_MMU_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                      0x0
#define HWIO_GCC_TME_MMU_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                       0x1

#define HWIO_GCC_TME_PCIE_1_SGDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005901c)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005901c)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005901c)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_RMSK                                                                       0x7
#define HWIO_GCC_TME_PCIE_1_SGDSCR_ATTR                                                                       0x3
#define HWIO_GCC_TME_PCIE_1_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_PCIE_1_SGDSCR_ADDR, HWIO_GCC_TME_PCIE_1_SGDSCR_RMSK)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PCIE_1_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_PCIE_1_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PCIE_1_SGDSCR_ADDR,m,v,HWIO_GCC_TME_PCIE_1_SGDSCR_IN)
#define HWIO_GCC_TME_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                            0x4
#define HWIO_GCC_TME_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x2
#define HWIO_GCC_TME_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_TME_PCIE_1_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_TME_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x2
#define HWIO_GCC_TME_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                      0x1
#define HWIO_GCC_TME_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TME_PCIE_1_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_TME_PCIE_1_SGDSCR_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_TME_PCIE_1_SGDSCR_SW_OVERRIDE_SHFT                                                           0x0
#define HWIO_GCC_TME_PCIE_1_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TME_PCIE_1_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00059020)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059020)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059020)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ADDR, HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RMSK)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_IN)
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PCIE_0_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TME_TURING_QTB_SGDSCR_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00059024)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059024)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059024)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_RMSK                                                                   0x7
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_ATTR                                                                   0x3
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_TURING_QTB_SGDSCR_ADDR, HWIO_GCC_TME_TURING_QTB_SGDSCR_RMSK)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_TURING_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_TURING_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_TURING_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_TME_TURING_QTB_SGDSCR_IN)
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                        0x4
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                        0x2
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                  0x2
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                  0x1
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                           0x1
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                       0x0
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_TURING_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00059028)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059028)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059028)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RMSK                                                                  0x7
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ATTR                                                                  0x3
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ADDR, HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RMSK)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_ADDR,m,v,HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_IN)
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                       0x4
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                       0x2
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                0x1
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                 0x2
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                 0x1
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_BMSK                                                      0x1
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_SHFT                                                      0x0
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TME_UFS_MEM_PHY_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_TME_PCIE_0_SGDSCR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005902c)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005902c)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005902c)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_RMSK                                                                       0x7
#define HWIO_GCC_TME_PCIE_0_SGDSCR_ATTR                                                                       0x3
#define HWIO_GCC_TME_PCIE_0_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_PCIE_0_SGDSCR_ADDR, HWIO_GCC_TME_PCIE_0_SGDSCR_RMSK)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PCIE_0_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_PCIE_0_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PCIE_0_SGDSCR_ADDR,m,v,HWIO_GCC_TME_PCIE_0_SGDSCR_IN)
#define HWIO_GCC_TME_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                            0x4
#define HWIO_GCC_TME_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                            0x2
#define HWIO_GCC_TME_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_TME_PCIE_0_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                     0x1
#define HWIO_GCC_TME_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                      0x2
#define HWIO_GCC_TME_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                      0x1
#define HWIO_GCC_TME_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_TME_PCIE_0_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                               0x1
#define HWIO_GCC_TME_PCIE_0_SGDSCR_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_TME_PCIE_0_SGDSCR_SW_OVERRIDE_SHFT                                                           0x0
#define HWIO_GCC_TME_PCIE_0_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_TME_PCIE_0_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00059030)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059030)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059030)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_RMSK                                                                    0x7
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_ATTR                                                                    0x3
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_LPASS_QTB_SGDSCR_ADDR, HWIO_GCC_TME_LPASS_QTB_SGDSCR_RMSK)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_LPASS_QTB_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_LPASS_QTB_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_LPASS_QTB_SGDSCR_ADDR,m,v,HWIO_GCC_TME_LPASS_QTB_SGDSCR_IN)
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                         0x4
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                         0x2
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                   0x2
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                   0x1
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                            0x1
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_SW_OVERRIDE_BMSK                                                        0x1
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_SW_OVERRIDE_SHFT                                                        0x0
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_LPASS_QTB_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TME_MMNOC_SGDSCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00059034)
#define HWIO_GCC_TME_MMNOC_SGDSCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059034)
#define HWIO_GCC_TME_MMNOC_SGDSCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059034)
#define HWIO_GCC_TME_MMNOC_SGDSCR_RMSK                                                                        0x7
#define HWIO_GCC_TME_MMNOC_SGDSCR_ATTR                                                                        0x3
#define HWIO_GCC_TME_MMNOC_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_TME_MMNOC_SGDSCR_ADDR, HWIO_GCC_TME_MMNOC_SGDSCR_RMSK)
#define HWIO_GCC_TME_MMNOC_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_MMNOC_SGDSCR_ADDR, m)
#define HWIO_GCC_TME_MMNOC_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_TME_MMNOC_SGDSCR_ADDR,v)
#define HWIO_GCC_TME_MMNOC_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_MMNOC_SGDSCR_ADDR,m,v,HWIO_GCC_TME_MMNOC_SGDSCR_IN)
#define HWIO_GCC_TME_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                             0x4
#define HWIO_GCC_TME_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                             0x2
#define HWIO_GCC_TME_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_TME_MMNOC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                      0x1
#define HWIO_GCC_TME_MMNOC_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                       0x2
#define HWIO_GCC_TME_MMNOC_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                       0x1
#define HWIO_GCC_TME_MMNOC_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_MMNOC_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_MMNOC_SGDSCR_SW_OVERRIDE_BMSK                                                            0x1
#define HWIO_GCC_TME_MMNOC_SGDSCR_SW_OVERRIDE_SHFT                                                            0x0
#define HWIO_GCC_TME_MMNOC_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_TME_MMNOC_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_ACC_MISC_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0003e030)
#define HWIO_GCC_ACC_MISC_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003e030)
#define HWIO_GCC_ACC_MISC_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003e030)
#define HWIO_GCC_ACC_MISC_RMSK                                                                                0x1
#define HWIO_GCC_ACC_MISC_ATTR                                                                                0x3
#define HWIO_GCC_ACC_MISC_IN          \
        in_dword_masked(HWIO_GCC_ACC_MISC_ADDR, HWIO_GCC_ACC_MISC_RMSK)
#define HWIO_GCC_ACC_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_ACC_MISC_ADDR, m)
#define HWIO_GCC_ACC_MISC_OUT(v)      \
        out_dword(HWIO_GCC_ACC_MISC_ADDR,v)
#define HWIO_GCC_ACC_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ACC_MISC_ADDR,m,v,HWIO_GCC_ACC_MISC_IN)
#define HWIO_GCC_ACC_MISC_JTAG_ACC_SRC_SEL_EN_BMSK                                                            0x1
#define HWIO_GCC_ACC_MISC_JTAG_ACC_SRC_SEL_EN_SHFT                                                            0x0
#define HWIO_GCC_ACC_MISC_JTAG_ACC_SRC_SEL_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_ACC_MISC_JTAG_ACC_SRC_SEL_EN_ENABLE_FVAL                                                     0x1

#define HWIO_GCC_CPUSS_AHB_MISC_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00038020)
#define HWIO_GCC_CPUSS_AHB_MISC_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00038020)
#define HWIO_GCC_CPUSS_AHB_MISC_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00038020)
#define HWIO_GCC_CPUSS_AHB_MISC_RMSK                                                                         0xf1
#define HWIO_GCC_CPUSS_AHB_MISC_ATTR                                                                          0x3
#define HWIO_GCC_CPUSS_AHB_MISC_IN          \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_MISC_ADDR, HWIO_GCC_CPUSS_AHB_MISC_RMSK)
#define HWIO_GCC_CPUSS_AHB_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_CPUSS_AHB_MISC_ADDR, m)
#define HWIO_GCC_CPUSS_AHB_MISC_OUT(v)      \
        out_dword(HWIO_GCC_CPUSS_AHB_MISC_ADDR,v)
#define HWIO_GCC_CPUSS_AHB_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CPUSS_AHB_MISC_ADDR,m,v,HWIO_GCC_CPUSS_AHB_MISC_IN)
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_BMSK                                            0xf0
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_SHFT                                             0x4
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV1_FVAL                                        0x0
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV2_FVAL                                        0x1
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV3_FVAL                                        0x2
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV4_FVAL                                        0x3
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV5_FVAL                                        0x4
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV6_FVAL                                        0x5
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV7_FVAL                                        0x6
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV8_FVAL                                        0x7
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV9_FVAL                                        0x8
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV10_FVAL                                       0x9
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV11_FVAL                                       0xa
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV12_FVAL                                       0xb
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV13_FVAL                                       0xc
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV14_FVAL                                       0xd
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV15_FVAL                                       0xe
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIV_DIV16_FVAL                                       0xf
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIS_BMSK                                             0x1
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIS_SHFT                                             0x0
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIS_SCALE_NOT_DISABLE_FVAL                           0x0
#define HWIO_GCC_CPUSS_AHB_MISC_CPUSS_AHB_CLK_AUTO_SCALE_DIS_SCALE_DISABLE_FVAL                               0x1

#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f038)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f038)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f038)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_RMSK                                                         0xfffffd7f
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                            0x80000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                                  0x1f
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                     0x40000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                           0x1e
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                      0x20000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                            0x1d
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                                  0x10000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                        0x1c
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                                  0x8000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                       0x1b
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                   0x4000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                        0x1a
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                               0x2000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                    0x19
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                   0x1000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                        0x18
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                                  0x800000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                      0x17
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                                  0x400000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                      0x16
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                         0x200000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                             0x15
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                             0x100000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                                 0x14
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                                  0x80000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                     0x13
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                                  0x40000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                     0x12
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                                  0x20000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                     0x11
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                                  0x10000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                     0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                       0x8000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                          0xf
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                       0x4000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                          0xe
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                            0x2000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                               0xd
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                        0x800
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                          0xb
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                         0x400
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                           0xa
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                             0x100
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                               0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                                  0x40
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                   0x6
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                   0x20
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                    0x5
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                               0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                                0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                                0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                                0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                           0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                           0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                               0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                      0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                      0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                               0x1

#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f03c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f03c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f03c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_RMSK                                                          0xfffffd7f
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                       0x80000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                             0x1f
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                                0x40000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                      0x1e
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                                 0x20000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                       0x1d
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                             0x10000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                   0x1c
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                             0x8000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                  0x1b
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                              0x4000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                   0x1a
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                          0x2000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                               0x19
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                              0x1000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                   0x18
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                             0x800000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                 0x17
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                             0x400000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                 0x16
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                    0x200000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                        0x15
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                        0x100000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                            0x14
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                             0x80000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                                0x13
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                             0x40000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                                0x12
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                             0x20000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                                0x11
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                             0x10000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                                0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                  0x8000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                     0xf
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                  0x4000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                     0xe
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                       0x2000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                          0xd
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                   0x800
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                     0xb
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                    0x400
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                      0xa
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                        0x100
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                          0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                             0x40
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                              0x6
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                              0x20
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                               0x5
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                          0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                           0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                           0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                           0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                      0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                      0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                          0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                 0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                 0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f040)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f040)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f040)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                       0xffffffff
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                              0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                              0x80000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                    0x1f
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                            0x40000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                                  0x1e
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                         0x20000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                               0x1d
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                                0x10000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                      0x1c
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                                 0x8000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                      0x1b
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                                 0x4000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                      0x1a
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                                 0x2000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                      0x19
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                                 0x1000000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                      0x18
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                                  0x800000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                      0x17
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                                  0x400000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                      0x16
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                              0x200000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                                  0x15
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                              0x100000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                                  0x14
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                                 0x80000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                    0x13
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                              0x40000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                                 0x12
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                     0x20000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                        0x11
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                     0x10000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                        0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                      0x8000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                         0xf
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                      0x4000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                         0xe
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                      0x2000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                         0xd
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                      0x1000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                         0xc
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                       0x800
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                         0xb
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                       0x400
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                         0xa
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                                0x200
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                                  0x9
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                     0x100
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                       0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                     0x80
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                      0x7
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                    0x40
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                     0x6
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                                  0x20
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                   0x5
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                         0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                          0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                           0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                           0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                       0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                       0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                      0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                      0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                       0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                       0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                                0x1

#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f044)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f044)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f044)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                        0xffffffff
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                               0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                         0x80000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                               0x1f
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                       0x40000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                             0x1e
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                    0x20000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                          0x1d
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                           0x10000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                                 0x1c
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                            0x8000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                                 0x1b
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                            0x4000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                                 0x1a
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                            0x2000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                                 0x19
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                            0x1000000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                                 0x18
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                             0x800000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                                 0x17
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                             0x400000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                                 0x16
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                         0x200000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                             0x15
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                         0x100000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                             0x14
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                            0x80000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                               0x13
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                                0x20000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                   0x11
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                                0x10000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                   0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                                 0x8000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                    0xf
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                                 0x4000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                    0xe
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                                 0x2000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                    0xd
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                                 0x1000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                    0xc
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                                  0x800
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                    0xb
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                                  0x400
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                    0xa
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                           0x200
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                             0x9
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                                0x100
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                                  0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                                0x80
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                                 0x7
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                               0x40
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                                0x6
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                             0x20
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                              0x5
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                    0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                     0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                      0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                      0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                                  0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                                 0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                 0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                                  0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                                  0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1

#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f048)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f048)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f048)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                          0x7ffff
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                              0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                               0x40000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                                  0x12
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                   0x20000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                      0x11
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                   0x10000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                      0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                      0x8000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                         0xf
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                      0x4000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                         0xe
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                           0x2000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                              0xd
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                   0x1000
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                      0xc
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                                 0x800
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                   0xb
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                     0x400
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                       0xa
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                     0x200
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                       0x9
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                     0x100
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                       0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                      0x80
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                       0x7
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                      0x40
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                       0x6
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                      0x20
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                       0x5
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                      0x10
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                       0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                                  0x8
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                                  0x3
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                   0x4
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                   0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                   0x2
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                   0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                     0x1
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                     0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                              0x1

#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f04c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f04c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f04c)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                           0x7ffff
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                               0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                          0x40000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                             0x12
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                              0x20000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                                 0x11
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                              0x10000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                                 0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                                 0x8000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                    0xf
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                                 0x4000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                    0xe
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                      0x2000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                         0xd
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                              0x1000
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                                 0xc
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                            0x800
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                              0xb
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                                0x400
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                                  0xa
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                                0x200
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                                  0x9
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                                0x100
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                                  0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                                 0x80
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                                  0x7
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                                 0x40
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                                  0x6
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                                 0x20
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                                  0x5
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                                 0x10
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                                  0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                             0x8
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                             0x3
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                              0x4
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                              0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                              0x2
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                              0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                                0x1
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                                0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f050)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f050)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f050)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f054)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f054)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f054)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_RMSK                                                                 0x3ff
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ATTR                                                                   0x3
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                       0x200
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                         0x9
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                       0x100
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                         0x8
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                        0x80
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                         0x7
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                        0x40
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                         0x6
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                        0x20
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                         0x5
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                        0x10
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                         0x4
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                         0x8
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                         0x3
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                         0x4
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                         0x2
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                         0x2
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                         0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                  0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                         0x1
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                         0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00041000)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041000)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041000)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_RMSK                                                        0xfffffd7f
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                           0x80000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                                 0x1f
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                    0x40000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                          0x1e
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                     0x20000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                           0x1d
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                                 0x10000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                       0x1c
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                                 0x8000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                      0x1b
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                  0x4000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                       0x1a
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                              0x2000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                   0x19
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                  0x1000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                       0x18
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                        0x200000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                            0x15
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                            0x100000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                                0x14
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                                 0x80000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                    0x13
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                                 0x40000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                    0x12
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x20000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x11
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x10000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                      0x8000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                         0xf
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                      0x4000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                         0xe
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                           0x2000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                              0xd
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                                 0x1000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                    0xc
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                       0x800
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                         0xb
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                        0x400
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                          0xa
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                            0x100
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                              0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                                 0x40
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                  0x6
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                  0x20
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                   0x5
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                              0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                               0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                               0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                               0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                          0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                          0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                              0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                     0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                     0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                              0x1

#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00041004)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041004)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041004)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_RMSK                                                         0xfffffd7f
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                      0x80000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                            0x1f
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                               0x40000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                     0x1e
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                                0x20000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                      0x1d
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                            0x10000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x1c
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                            0x8000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                 0x1b
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                             0x4000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                  0x1a
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                         0x2000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                              0x19
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                             0x1000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                  0x18
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                   0x200000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                       0x15
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                       0x100000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                           0x14
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                            0x80000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                               0x13
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                            0x40000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                               0x12
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x8000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xf
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x4000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xe
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                      0x2000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                         0xd
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                            0x1000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                               0xc
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                  0x800
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                    0xb
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                   0x400
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                     0xa
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                       0x100
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                         0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                            0x40
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                             0x6
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                             0x20
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                              0x5
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                         0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                          0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                          0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                          0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                     0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                     0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                         0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00041008)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041008)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041008)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                      0xffffffff
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                             0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                             0x80000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                   0x1f
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                           0x40000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                                 0x1e
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                        0x20000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                              0x1d
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                               0x10000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                     0x1c
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                                0x8000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                     0x1b
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                                0x4000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                     0x1a
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                                0x2000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                     0x19
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                                0x1000000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                     0x18
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                             0x200000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                                 0x15
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                             0x100000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                                 0x14
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                                0x80000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                   0x13
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                             0x40000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                                0x12
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                    0x20000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                       0x11
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                    0x10000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                       0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                     0x2000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                        0xd
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                     0x1000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                        0xc
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                      0x800
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                        0xb
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                      0x400
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                        0xa
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                               0x200
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                                 0x9
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                    0x80
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                     0x7
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                   0x40
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                    0x6
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                                 0x20
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                  0x5
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                        0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                         0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                          0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                          0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                      0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                      0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                     0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                     0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                      0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                      0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                               0x1

#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0004100c)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004100c)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004100c)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                       0xffffffff
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                              0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                        0x80000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                              0x1f
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                      0x40000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                            0x1e
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                   0x20000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                         0x1d
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                          0x10000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                                0x1c
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                           0x8000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                                0x1b
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                           0x4000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                                0x1a
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                           0x2000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                                0x19
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                           0x1000000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                                0x18
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                        0x200000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                            0x15
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                        0x100000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                            0x14
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                           0x80000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                              0x13
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                        0x40000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                           0x12
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                               0x20000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                  0x11
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                               0x10000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                  0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                                0x2000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                   0xd
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                                0x1000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                   0xc
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                                 0x800
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                   0xb
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                                 0x400
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                   0xa
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                          0x200
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                            0x9
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                               0x80
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                                0x7
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                              0x40
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                               0x6
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                            0x20
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                             0x5
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                   0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                    0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                     0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                     0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                                 0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                                 0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                                0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                                 0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                                 0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00041010)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041010)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041010)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                         0x7ffff
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                             0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                              0x40000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                                 0x12
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                  0x20000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                     0x11
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                  0x10000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                     0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                          0x2000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                             0xd
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                                0x800
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                  0xb
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                    0x400
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                      0xa
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                    0x200
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                      0x9
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                     0x80
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                      0x7
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                     0x40
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                      0x6
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                     0x20
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                      0x5
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                     0x10
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                      0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                                 0x8
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                                 0x3
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                  0x4
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                  0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                  0x2
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                  0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                    0x1
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                    0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                             0x1

#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00041014)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041014)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041014)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                          0x7ffff
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                              0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                             0x20000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                                0x11
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                             0x10000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                                0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                     0x2000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                        0xd
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                           0x800
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                             0xb
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                               0x400
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                                 0xa
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                               0x200
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                                 0x9
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                                0x80
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                                 0x7
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                                0x40
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                                 0x6
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                                0x20
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                                 0x5
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                                0x10
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                                 0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                            0x8
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                            0x3
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                             0x4
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                             0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                             0x2
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                             0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                               0x1
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                               0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_RPM_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00041018)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041018)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041018)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPM_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0004101c)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004101c)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004101c)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00042000)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042000)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042000)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_RMSK                                                       0xfffffd7f
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                          0x80000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                                0x1f
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                   0x40000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                         0x1e
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                    0x20000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                          0x1d
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                                0x10000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                      0x1c
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                                0x8000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                     0x1b
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                 0x4000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                      0x1a
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                             0x2000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                  0x19
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                 0x1000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                      0x18
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                                0x800000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                    0x17
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                                0x400000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                    0x16
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                       0x200000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                           0x15
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                           0x100000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                               0x14
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                                0x80000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                   0x13
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                                0x40000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                   0x12
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                                0x20000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                   0x11
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                                0x10000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                   0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                     0x8000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                        0xf
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                     0x4000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                        0xe
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                          0x2000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                             0xd
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                                0x1000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                   0xc
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                      0x800
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                        0xb
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                       0x400
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                         0xa
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                           0x100
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                             0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                                0x40
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                 0x6
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                 0x20
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                  0x5
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                          0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                           0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                             0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                              0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                              0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                              0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                         0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                         0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                             0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                    0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                    0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                             0x1

#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00042004)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042004)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042004)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_RMSK                                                        0xfffffd7f
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                     0x80000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                           0x1f
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                              0x40000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                    0x1e
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                               0x20000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                     0x1d
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                           0x10000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                 0x1c
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                           0x8000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                0x1b
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                            0x4000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                 0x1a
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                        0x2000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                             0x19
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                            0x1000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                 0x18
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                           0x800000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                               0x17
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                           0x400000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                               0x16
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                  0x200000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                      0x15
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                      0x100000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                          0x14
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                           0x80000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                              0x13
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                           0x40000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                              0x12
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                           0x20000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                              0x11
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                           0x10000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                              0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                     0x2000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                        0xd
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                           0x1000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                              0xc
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                 0x800
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                   0xb
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                  0x400
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                    0xa
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                      0x100
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                        0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                           0x40
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                            0x6
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                            0x20
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                             0x5
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                        0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                         0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                         0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                         0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                    0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                    0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                        0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                               0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                               0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00042008)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042008)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042008)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                     0xffffffff
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                            0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                            0x80000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                  0x1f
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                          0x40000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                                0x1e
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                       0x20000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                             0x1d
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                              0x10000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                    0x1c
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                               0x8000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                    0x1b
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                               0x4000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                    0x1a
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                               0x2000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                    0x19
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                               0x1000000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                    0x18
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                                0x800000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                    0x17
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                                0x400000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                    0x16
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                            0x200000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                                0x15
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                            0x100000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                                0x14
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                               0x80000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                  0x13
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                            0x40000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                               0x12
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                   0x20000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                      0x11
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                   0x10000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                      0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                    0x8000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                       0xf
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                    0x4000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                       0xe
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                    0x2000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                       0xd
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                    0x1000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                       0xc
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                     0x800
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                       0xb
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                     0x400
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                       0xa
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                              0x200
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                                0x9
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                   0x100
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                     0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                   0x80
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                    0x7
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                  0x40
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                   0x6
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                                0x20
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                 0x5
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                       0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                        0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                         0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                         0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                     0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                     0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                    0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                    0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                     0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                     0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                              0x1

#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0004200c)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004200c)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004200c)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                      0xffffffff
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                             0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                       0x80000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                             0x1f
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                     0x40000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                           0x1e
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                  0x20000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                        0x1d
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                         0x10000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                               0x1c
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                          0x8000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                               0x1b
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                          0x4000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                               0x1a
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                          0x2000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                               0x19
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                          0x1000000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                               0x18
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                           0x800000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                               0x17
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                           0x400000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                               0x16
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                       0x200000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                           0x15
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                       0x100000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                           0x14
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                          0x80000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                             0x13
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                       0x40000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                          0x12
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                              0x20000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                 0x11
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                              0x10000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                 0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                               0x8000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                  0xf
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                               0x4000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                  0xe
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                               0x2000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                  0xd
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                               0x1000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                  0xc
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                                0x800
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                  0xb
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                                0x400
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                  0xa
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                         0x200
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                           0x9
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                              0x100
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                                0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                              0x80
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                               0x7
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                             0x40
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                              0x6
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                           0x20
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                            0x5
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                  0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                   0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                    0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                    0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                                0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                                0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                               0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                               0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                                0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                                0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00042010)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042010)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042010)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                        0x7ffff
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                            0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                             0x40000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                                0x12
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                 0x20000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                    0x11
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                 0x10000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                    0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                    0x8000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                       0xf
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                    0x4000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                       0xe
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                         0x2000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                            0xd
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                 0x1000
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                    0xc
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                               0x800
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                 0xb
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                   0x400
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                     0xa
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                   0x200
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                     0x9
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                   0x100
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                     0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                    0x80
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                     0x7
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                    0x40
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                     0x6
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                    0x20
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                     0x5
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                    0x10
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                     0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                                0x8
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                                0x3
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                 0x4
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                 0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                 0x2
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                 0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                   0x1
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                   0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                            0x1

#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00042014)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042014)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042014)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                         0x7ffff
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                             0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                        0x40000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                           0x12
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                               0x8000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                  0xf
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                               0x4000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                  0xe
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                    0x2000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                       0xd
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                            0x1000
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                               0xc
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                          0x800
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                            0xb
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                              0x400
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                                0xa
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                              0x200
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                                0x9
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                              0x100
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                                0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                               0x80
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                                0x7
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                               0x40
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                                0x6
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                               0x20
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                                0x5
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                               0x10
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                                0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                           0x8
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                           0x3
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                            0x4
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                            0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                            0x2
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                            0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                              0x1
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                              0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00042018)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042018)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042018)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_APCS_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0004201c)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004201c)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004201c)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00043038)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043038)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043038)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_RMSK                                                    0xfffffd7f
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                       0x80000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                             0x1f
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                0x40000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                      0x1e
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                 0x20000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                       0x1d
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                             0x10000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                   0x1c
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                             0x8000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                  0x1b
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                              0x4000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                   0x1a
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                          0x2000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                               0x19
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                              0x1000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                   0x18
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                             0x800000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                 0x17
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                             0x400000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                 0x16
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                    0x200000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                        0x15
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                        0x100000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                            0x14
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                             0x80000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                0x13
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                             0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                0x12
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                             0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                0x11
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                             0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                  0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                     0xf
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                  0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                     0xe
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                       0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                          0xd
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                             0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                0xc
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                   0x800
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                     0xb
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                    0x400
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                      0xa
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                        0x100
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                          0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                             0x40
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                              0x6
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                              0x20
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                               0x5
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                          0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                           0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                           0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                           0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                      0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                      0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                          0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0004303c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004303c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004303c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_RMSK                                                     0xfffffd7f
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                  0x80000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                        0x1f
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                           0x40000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                 0x1e
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                            0x20000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                  0x1d
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                        0x10000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                              0x1c
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                        0x8000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                             0x1b
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                         0x4000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                              0x1a
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                     0x2000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                          0x19
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                         0x1000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                              0x18
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                        0x800000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                            0x17
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                        0x400000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                            0x16
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                               0x200000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                   0x15
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                   0x100000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                       0x14
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                        0x80000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                           0x13
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                        0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                           0x12
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                        0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                           0x11
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                        0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                           0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                             0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                0xf
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                             0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                0xe
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                  0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                     0xd
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                        0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                           0xc
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                              0x800
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                0xb
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                               0x400
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                 0xa
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                   0x100
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                     0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                        0x40
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                         0x6
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                         0x20
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                          0x5
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                     0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                      0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                      0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                      0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                 0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                 0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                     0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                            0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1

#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00043040)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043040)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043040)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                  0xffffffff
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                         0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                         0x80000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                               0x1f
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                       0x40000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                             0x1e
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                    0x20000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                          0x1d
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                           0x10000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                 0x1c
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                            0x8000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                 0x1b
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                            0x4000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                 0x1a
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                            0x2000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                 0x19
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                            0x1000000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                 0x18
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                             0x800000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                 0x17
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                             0x400000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                 0x16
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                         0x200000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                             0x15
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                         0x100000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                             0x14
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                            0x80000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                               0x13
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                         0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                            0x12
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                   0x11
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                   0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                 0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                    0xf
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                 0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                    0xe
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                 0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                    0xd
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                 0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                    0xc
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                  0x800
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                    0xb
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                  0x400
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                    0xa
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                           0x200
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                             0x9
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                0x100
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                  0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                0x80
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                 0x7
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                               0x40
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                0x6
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                             0x20
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                              0x5
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                    0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                     0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                      0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                      0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                  0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                  0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                 0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                  0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                           0x1

#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00043044)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043044)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043044)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                   0xffffffff
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                          0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                    0x80000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                          0x1f
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                  0x40000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                        0x1e
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK               0x20000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                     0x1d
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                      0x10000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                            0x1c
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                       0x8000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                            0x1b
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                       0x4000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                            0x1a
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                       0x2000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                            0x19
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                       0x1000000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                            0x18
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                        0x800000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                            0x17
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                        0x400000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                            0x16
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                    0x200000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                        0x15
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                    0x100000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                        0x14
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                       0x80000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                          0x13
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                    0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                       0x12
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                           0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                              0x11
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                           0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                              0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                            0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                               0xf
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                            0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                               0xe
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                            0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                               0xd
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                            0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                               0xc
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                             0x800
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                               0xb
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                             0x400
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                               0xa
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                      0x200
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                        0x9
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                           0x100
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                             0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                           0x80
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                            0x7
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                          0x40
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                           0x6
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                        0x20
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                         0x5
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                               0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                 0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                 0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                             0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                             0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                            0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                            0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                             0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1

#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00043048)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043048)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043048)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                     0x7ffff
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                         0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                          0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                             0x12
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                              0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                 0x11
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                              0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                 0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                 0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                    0xf
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                 0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                    0xe
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                      0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                         0xd
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                              0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                 0xc
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                            0x800
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                              0xb
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                0x400
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                  0xa
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                0x200
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                  0x9
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                0x100
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                  0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                 0x80
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                  0x7
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                 0x40
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                  0x6
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                 0x20
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                  0x5
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                 0x10
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                  0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                             0x8
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                             0x3
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                              0x4
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                              0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                              0x2
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                              0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                0x1
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0004304c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004304c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004304c)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                      0x7ffff
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                          0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                     0x40000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                        0x12
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                         0x20000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                            0x11
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                         0x10000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                            0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                            0x8000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                               0xf
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                            0x4000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                               0xe
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                 0x2000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                    0xd
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL            0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL             0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                         0x1000
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                            0xc
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                       0x800
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                         0xb
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                           0x400
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                             0xa
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                           0x200
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                             0x9
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                           0x100
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                             0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                            0x80
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                             0x7
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                            0x40
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                             0x6
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                            0x20
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                             0x5
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                            0x10
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                             0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                        0x8
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                        0x3
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                         0x4
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                         0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                         0x2
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                         0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                           0x1
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                           0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_APCS_TZ_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1

#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00043050)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043050)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043050)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_APCS_TZ_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00043054)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043054)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043054)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00045000)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045000)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045000)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_RMSK                                                  0xfffffd7f
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ATTR                                                         0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                     0x80000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                           0x1f
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                              0x40000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                    0x1e
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                               0x20000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                     0x1d
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                           0x10000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                 0x1c
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                           0x8000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                0x1b
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                            0x4000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                 0x1a
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                        0x2000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                             0x19
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                            0x1000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                 0x18
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                           0x800000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                               0x17
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                           0x400000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                               0x16
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                  0x200000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                      0x15
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                      0x100000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                          0x14
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                           0x80000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                              0x13
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                           0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                              0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                           0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                              0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                           0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                              0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                   0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                   0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                     0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                        0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                           0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                              0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                 0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                   0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                  0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                    0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                      0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                        0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                           0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                            0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                            0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                             0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                        0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                         0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                         0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                         0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                    0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                    0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                        0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00045004)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045004)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045004)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_RMSK                                                   0xfffffd7f
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ATTR                                                          0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                0x80000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                      0x1f
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                         0x40000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                               0x1e
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                          0x20000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                0x1d
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                      0x10000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                            0x1c
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                      0x8000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                           0x1b
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                       0x4000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                            0x1a
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                   0x2000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                        0x19
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                       0x1000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                            0x18
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                      0x800000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                          0x17
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                      0x400000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                          0x16
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                             0x200000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                 0x15
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                 0x100000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                     0x14
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                      0x80000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                         0x13
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                      0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                         0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                      0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                         0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                      0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                         0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                           0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                              0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                           0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                              0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                   0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                      0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                         0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                            0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                              0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                             0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                               0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                 0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                   0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                      0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                       0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                       0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                        0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                   0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                    0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                    0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                    0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                               0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                               0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                   0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                          0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00045008)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045008)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045008)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                0xffffffff
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                       0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                       0x80000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                             0x1f
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                     0x40000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                           0x1e
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                  0x20000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                        0x1d
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                         0x10000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                               0x1c
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                          0x8000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                               0x1b
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                          0x4000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                               0x1a
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                          0x2000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                               0x19
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                          0x1000000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                               0x18
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                           0x800000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                               0x17
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                           0x400000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                               0x16
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                       0x200000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                           0x15
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                       0x100000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                           0x14
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                          0x80000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                             0x13
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                       0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                          0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                              0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                 0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                              0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                 0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                               0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                  0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                               0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                  0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                               0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                  0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                               0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                  0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                  0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                  0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                         0x200
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                           0x9
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                              0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                              0x80
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                               0x7
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                             0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                              0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                           0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                            0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                  0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                   0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                    0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                    0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                               0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0004500c)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004500c)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004500c)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                 0xffffffff
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                        0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                  0x80000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                        0x1f
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                0x40000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                      0x1e
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK             0x20000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                   0x1d
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL            0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL             0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                    0x10000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                          0x1c
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                     0x8000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                          0x1b
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                     0x4000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                          0x1a
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                     0x2000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                          0x19
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                     0x1000000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                          0x18
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                      0x800000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                          0x17
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                      0x400000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                          0x16
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                  0x200000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                      0x15
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                  0x100000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                      0x14
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                     0x80000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                        0x13
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                  0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                     0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                         0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                            0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                         0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                            0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                          0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                             0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                          0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                             0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                          0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                             0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                          0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                             0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                           0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                             0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                           0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                             0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                    0x200
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                      0x9
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                         0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                           0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                         0x80
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                          0x7
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                        0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                         0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                      0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                       0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                             0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                              0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                               0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                               0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                           0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                           0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                          0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                          0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                           0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00045010)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045010)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045010)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                   0x7ffff
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                       0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                        0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                           0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                            0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                               0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                            0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                               0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                               0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                  0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                               0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                  0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                    0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                       0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                            0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                               0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                          0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                            0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                              0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                              0x200
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                0x9
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                              0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                               0x80
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                0x7
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                               0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                               0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                               0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                           0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                           0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                            0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                            0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                            0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                            0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                              0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00045014)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045014)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045014)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                    0x7ffff
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                        0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                   0x40000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                      0x12
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                       0x20000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                          0x11
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                       0x10000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                          0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                          0x8000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                             0xf
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                          0x4000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                             0xe
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK               0x2000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                  0xd
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL          0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL           0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                       0x1000
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                          0xc
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                     0x800
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                       0xb
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                         0x400
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                           0xa
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                         0x200
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                           0x9
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                         0x100
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                           0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                          0x80
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                           0x7
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                          0x40
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                           0x6
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                          0x20
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                           0x5
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                          0x10
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                           0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                      0x8
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                      0x3
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                       0x4
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                       0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                       0x2
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                       0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                         0x1
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                         0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_LPASS_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1

#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00045018)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045018)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045018)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_LPASS_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0004501c)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004501c)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004501c)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b000)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b000)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b000)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_RMSK                                                 0xfffffd7f
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ATTR                                                        0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                    0x80000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                          0x1f
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                             0x40000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                   0x1e
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                              0x20000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                    0x1d
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                          0x10000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                0x1c
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                          0x8000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                               0x1b
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                           0x4000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                0x1a
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                       0x2000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                            0x19
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                           0x1000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                0x18
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                          0x800000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                              0x17
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                          0x400000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                              0x16
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                 0x200000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                     0x15
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                     0x100000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                         0x14
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                          0x80000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                             0x13
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                          0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                             0x12
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                          0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                             0x11
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                          0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                             0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                               0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                  0xf
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                               0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                  0xe
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                    0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                       0xd
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                          0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                             0xc
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                0x800
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                  0xb
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                 0x400
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                   0xa
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                     0x100
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                       0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                          0x40
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                           0x6
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                           0x20
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                            0x5
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                       0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                        0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                        0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                        0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                   0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                   0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                       0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b004)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b004)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b004)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_RMSK                                                  0xfffffd7f
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ATTR                                                         0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK               0x80000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                     0x1f
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                        0x40000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                              0x1e
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                         0x20000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                               0x1d
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                     0x10000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                           0x1c
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                     0x8000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                          0x1b
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                      0x4000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                           0x1a
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                  0x2000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                       0x19
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                      0x1000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                           0x18
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                     0x800000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                         0x17
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                     0x400000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                         0x16
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                            0x200000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                0x15
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                0x100000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                    0x14
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                     0x80000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                        0x13
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                     0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                        0x12
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                     0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                        0x11
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                     0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                        0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                          0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                             0xf
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                          0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                             0xe
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                               0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                  0xd
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                     0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                        0xc
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                           0x800
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                             0xb
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                            0x400
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                              0xa
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                0x100
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                  0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                     0x40
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                      0x6
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                      0x20
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                       0x5
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                  0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                   0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                   0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                   0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                              0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                              0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                  0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                         0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1

#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b008)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b008)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b008)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                               0xffffffff
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                      0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                      0x80000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                            0x1f
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                    0x40000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                          0x1e
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                 0x20000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                       0x1d
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                        0x10000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                              0x1c
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                         0x8000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                              0x1b
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                         0x4000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                              0x1a
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                         0x2000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                              0x19
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                         0x1000000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                              0x18
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                          0x800000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                              0x17
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                          0x400000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                              0x16
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                      0x200000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                          0x15
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                      0x100000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                          0x14
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                         0x80000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                            0x13
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                      0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                         0x12
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                             0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                0x11
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                             0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                              0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                 0xf
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                              0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                 0xe
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                              0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                 0xd
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                              0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                 0xc
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                               0x800
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                 0xb
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                               0x400
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                 0xa
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                        0x200
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                          0x9
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                             0x100
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                               0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                             0x80
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                              0x7
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                            0x40
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                             0x6
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                          0x20
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                           0x5
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                 0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                  0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                   0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                   0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                               0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                               0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                              0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                               0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b00c)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b00c)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b00c)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                0xffffffff
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                       0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                 0x80000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                       0x1f
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK               0x40000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                     0x1e
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK            0x20000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                  0x1d
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL           0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL            0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                   0x10000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                         0x1c
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                    0x8000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                         0x1b
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                    0x4000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                         0x1a
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                    0x2000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                         0x19
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                    0x1000000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                         0x18
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                     0x800000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                         0x17
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                     0x400000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                         0x16
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                 0x200000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                     0x15
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                 0x100000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                     0x14
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                    0x80000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                       0x13
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                 0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                    0x12
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                        0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                           0x11
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                        0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                           0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                         0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                            0xf
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                         0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                            0xe
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                         0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                            0xd
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                         0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                            0xc
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                          0x800
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                            0xb
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                          0x400
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                            0xa
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                   0x200
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                     0x9
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                        0x100
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                          0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                        0x80
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                         0x7
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                       0x40
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                        0x6
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                     0x20
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                      0x5
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                            0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                             0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                              0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                              0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                          0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                          0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                         0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                         0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                          0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1

#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b010)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b010)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b010)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                  0x7ffff
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                      0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                       0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                          0x12
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                           0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                              0x11
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                           0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                              0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                              0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                 0xf
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                              0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                 0xe
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                   0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                      0xd
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                           0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                              0xc
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                         0x800
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                           0xb
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                             0x400
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                               0xa
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                             0x200
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                               0x9
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                             0x100
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                               0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                              0x80
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                               0x7
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                              0x40
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                               0x6
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                              0x20
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                               0x5
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                              0x10
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                               0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                          0x8
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                          0x3
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                           0x4
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                           0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                           0x2
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                           0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                             0x1
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                      0x1

#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b014)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b014)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b014)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                   0x7ffff
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                       0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                  0x40000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                     0x12
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                      0x20000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                         0x11
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                      0x10000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                         0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                         0x8000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                            0xf
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                         0x4000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                            0xe
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK              0x2000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                 0xd
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL         0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL          0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                      0x1000
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                         0xc
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                    0x800
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                      0xb
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                        0x400
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                          0xa
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                        0x200
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                          0x9
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                        0x100
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                          0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                         0x80
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                          0x7
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                         0x40
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                          0x6
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                         0x20
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                          0x5
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                         0x10
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                          0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                     0x8
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                     0x3
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                      0x4
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                      0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                      0x2
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                      0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                        0x1
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                        0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TURING_DSP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1

#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b018)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b018)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b018)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_RMSK                                                        0x3ff
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ATTR                                                          0x3
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                              0x200
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                0x9
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                              0x100
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                0x8
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                               0x80
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                0x7
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                               0x40
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                0x6
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                               0x20
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                0x5
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                               0x10
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                0x4
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                0x8
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                0x3
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                0x4
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                0x2
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                0x2
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                         0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                0x1
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                         0x1

#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b01c)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b01c)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b01c)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00047000)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047000)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047000)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_RMSK                                                      0xfffffd7f
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                         0x80000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                               0x1f
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                  0x40000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                        0x1e
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                   0x20000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                         0x1d
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                               0x10000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                     0x1c
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                               0x8000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                    0x1b
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                0x4000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                     0x1a
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                            0x2000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                 0x19
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                0x1000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                     0x18
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                               0x800000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                   0x17
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                               0x400000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                   0x16
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                      0x200000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                          0x15
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                          0x100000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                              0x14
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                               0x80000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                  0x13
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                               0x40000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                  0x12
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                               0x20000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                  0x11
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                               0x10000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                  0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                    0x8000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                       0xf
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                    0x4000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                       0xe
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                         0x2000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                            0xd
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                               0x1000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                  0xc
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                     0x800
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                       0xb
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                      0x400
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                        0xa
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                          0x100
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                            0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                               0x40
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                0x6
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                0x20
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                 0x5
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                         0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                          0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                            0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                             0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                             0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                             0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                        0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                        0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                            0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                   0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                   0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                            0x1

#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00047004)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047004)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047004)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_RMSK                                                       0xfffffd7f
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                    0x80000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                          0x1f
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                             0x40000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                   0x1e
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                              0x20000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                    0x1d
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                          0x10000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                0x1c
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                          0x8000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                               0x1b
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                           0x4000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                0x1a
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                       0x2000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                            0x19
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                           0x1000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                0x18
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                          0x800000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                              0x17
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                          0x400000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                              0x16
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                 0x200000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                     0x15
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                     0x100000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                         0x14
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                          0x80000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                             0x13
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                          0x40000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                             0x12
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                          0x20000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                             0x11
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                          0x10000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                             0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                               0x8000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                  0xf
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                               0x4000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                  0xe
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                    0x2000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                       0xd
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                          0x1000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                             0xc
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                0x800
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                  0xb
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                 0x400
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                   0xa
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                     0x100
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                       0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                          0x40
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                           0x6
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                           0x20
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                            0x5
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                       0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                        0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                        0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                        0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                   0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                   0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                       0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                              0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                              0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00047008)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047008)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047008)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                    0xffffffff
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                           0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                           0x80000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                 0x1f
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                         0x40000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                               0x1e
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                      0x20000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                            0x1d
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                             0x10000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                   0x1c
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                              0x8000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                   0x1b
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                              0x4000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                   0x1a
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                              0x2000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                   0x19
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                              0x1000000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                   0x18
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                               0x800000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                   0x17
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                               0x400000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                   0x16
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                           0x200000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                               0x15
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                           0x100000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                               0x14
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                              0x80000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                 0x13
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                           0x40000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                              0x12
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                  0x20000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                     0x11
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                  0x10000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                     0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                   0x8000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                      0xf
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                   0x4000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                      0xe
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                   0x2000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                      0xd
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                   0x1000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                      0xc
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                    0x800
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                      0xb
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                    0x400
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                      0xa
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                             0x200
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                               0x9
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                  0x100
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                    0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                  0x80
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                   0x7
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                 0x40
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                  0x6
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                               0x20
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                0x5
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                      0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                       0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                        0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                        0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                    0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                    0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                   0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                   0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                    0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                    0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                             0x1

#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0004700c)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004700c)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004700c)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                     0xffffffff
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                            0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                      0x80000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                            0x1f
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                    0x40000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                          0x1e
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                 0x20000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                       0x1d
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                        0x10000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                              0x1c
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                         0x8000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                              0x1b
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                         0x4000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                              0x1a
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                         0x2000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                              0x19
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                         0x1000000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                              0x18
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                          0x800000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                              0x17
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                          0x400000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                              0x16
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                      0x200000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                          0x15
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                      0x100000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                          0x14
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                         0x80000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                            0x13
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                      0x40000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                         0x12
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                             0x20000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                0x11
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                             0x10000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                              0x8000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                 0xf
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                              0x4000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                 0xe
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                              0x2000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                 0xd
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                              0x1000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                 0xc
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                               0x800
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                 0xb
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                               0x400
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                 0xa
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                        0x200
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                          0x9
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                             0x100
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                               0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                             0x80
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                              0x7
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                            0x40
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                             0x6
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                          0x20
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                           0x5
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                 0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                  0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                   0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                   0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                               0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                               0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                              0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                              0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                               0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                               0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00047010)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047010)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047010)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                       0x7ffff
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                           0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                            0x40000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                               0x12
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                0x20000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                   0x11
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                0x10000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                   0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                   0x8000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                      0xf
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                   0x4000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                      0xe
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                        0x2000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                           0xd
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                0x1000
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                   0xc
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                              0x800
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                0xb
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                  0x400
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                    0xa
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                  0x200
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                    0x9
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                  0x100
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                    0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                   0x80
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                    0x7
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                   0x40
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                    0x6
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                   0x20
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                    0x5
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                   0x10
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                    0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                               0x8
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                               0x3
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                0x4
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                0x2
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                  0x1
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                  0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                           0x1

#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00047014)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047014)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047014)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                        0x7ffff
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                            0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                       0x40000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                          0x12
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                           0x20000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                              0x11
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                           0x10000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                              0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                              0x8000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                 0xf
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                              0x4000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                 0xe
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                   0x2000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                      0xd
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL              0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL               0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                           0x1000
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                              0xc
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                         0x800
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                           0xb
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                             0x400
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                               0xa
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                             0x200
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                               0x9
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                             0x100
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                               0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                              0x80
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                               0x7
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                              0x40
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                               0x6
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                              0x20
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                               0x5
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                              0x10
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                               0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                          0x8
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                          0x3
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                           0x4
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                           0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                           0x2
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                           0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                   0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                    0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                             0x1
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                             0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1

#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00047018)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047018)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047018)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0004701c)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004701c)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004701c)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_SPARE_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00025038)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025038)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025038)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_RMSK                                                     0xfffffd7f
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                        0x80000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                              0x1f
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                 0x40000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                       0x1e
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                  0x20000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                        0x1d
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                              0x10000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                    0x1c
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                              0x8000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                   0x1b
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                               0x4000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                    0x1a
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                           0x2000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                0x19
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                               0x1000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                    0x18
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                              0x800000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                  0x17
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                              0x400000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                  0x16
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                     0x200000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                         0x15
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                         0x100000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                             0x14
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                              0x80000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                 0x13
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                              0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                 0x12
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                              0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                 0x11
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                              0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                 0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                   0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                      0xf
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                   0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                      0xe
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                        0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                           0xd
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                              0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                 0xc
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                    0x800
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                      0xb
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                     0x400
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                       0xa
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                         0x100
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                           0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                              0x40
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                               0x6
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                               0x20
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                0x5
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                           0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                            0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                            0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                            0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                       0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                       0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                           0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                           0x1

#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0002503c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002503c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002503c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_RMSK                                                      0xfffffd7f
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                   0x80000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                         0x1f
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                            0x40000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                  0x1e
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                             0x20000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                   0x1d
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                         0x10000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                               0x1c
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                         0x8000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                              0x1b
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                          0x4000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                               0x1a
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                      0x2000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                           0x19
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                          0x1000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                               0x18
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                         0x800000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                             0x17
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                         0x400000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                             0x16
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                0x200000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                    0x15
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                    0x100000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                        0x14
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                         0x80000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                            0x13
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                         0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                            0x11
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                         0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                            0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                              0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                 0xf
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                              0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                 0xe
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                   0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                      0xd
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                         0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                            0xc
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                               0x800
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                 0xb
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                0x400
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                  0xa
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                    0x100
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                      0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                         0x40
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                          0x6
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                          0x20
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                           0x5
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                      0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                       0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                       0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                       0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                  0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                      0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                             0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1

#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00025040)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025040)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025040)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                   0xffffffff
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                          0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                          0x80000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                0x1f
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                        0x40000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                              0x1e
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                     0x20000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                           0x1d
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                            0x10000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                  0x1c
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                             0x8000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                  0x1b
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                             0x4000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                  0x1a
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                             0x2000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                  0x19
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                             0x1000000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                  0x18
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                              0x800000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                  0x17
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                              0x400000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                  0x16
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                          0x200000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                              0x15
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                          0x100000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                              0x14
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                             0x80000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                0x13
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                          0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                             0x12
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                 0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                    0x11
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                 0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                    0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                  0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                     0xf
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                  0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                     0xe
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                  0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                     0xd
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                   0x800
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                     0xb
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                   0x400
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                     0xa
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                            0x200
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                              0x9
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                 0x100
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                   0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                 0x80
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                  0x7
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                0x40
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                 0x6
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                              0x20
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                               0x5
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                     0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                      0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                       0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                       0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                   0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                   0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                  0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                   0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                            0x1

#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00025044)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025044)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025044)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                    0xffffffff
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                           0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                     0x80000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                           0x1f
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                   0x40000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                         0x1e
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                0x20000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                      0x1d
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                       0x10000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                             0x1c
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                        0x8000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                             0x1b
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                        0x4000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                             0x1a
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                        0x2000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                             0x19
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                        0x1000000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                             0x18
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                         0x800000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                             0x17
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                         0x400000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                             0x16
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                     0x200000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                         0x15
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                     0x100000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                         0x14
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                        0x80000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                           0x13
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                     0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                        0x12
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                             0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                0xf
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                             0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                0xe
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                             0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                0xd
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                              0x800
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                0xb
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                              0x400
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                0xa
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                       0x200
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                         0x9
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                            0x100
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                              0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                            0x80
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                             0x7
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                           0x40
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                            0x6
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                         0x20
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                          0x5
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                 0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                  0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                  0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                              0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                              0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                             0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                             0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                              0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00025048)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025048)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025048)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                      0x7ffff
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                          0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                           0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                              0x12
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                               0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                  0x11
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                               0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                  0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                  0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                     0xf
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                  0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                     0xe
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                       0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                          0xd
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                               0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                  0xc
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                             0x800
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                               0xb
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                 0x400
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                   0xa
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                 0x200
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                   0x9
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                 0x100
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                   0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                  0x80
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                   0x7
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                  0x40
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                   0x6
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                  0x20
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                   0x5
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                  0x10
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                   0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                              0x8
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                              0x3
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                               0x4
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                               0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                               0x2
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                               0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                 0x1
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0002504c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002504c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002504c)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                       0x7ffff
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                           0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                      0x40000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                         0x12
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                          0x20000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                             0x11
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                          0x10000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                             0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                             0x8000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                0xf
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                             0x4000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                0xe
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                  0x2000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                     0xd
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                          0x1000
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                             0xc
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                        0x800
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                          0xb
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                            0x400
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                              0xa
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                            0x200
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                              0x9
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                            0x100
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                              0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                             0x80
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                              0x7
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                             0x40
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                              0x6
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                             0x20
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                              0x5
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                             0x10
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                              0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                         0x8
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                         0x3
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                          0x4
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                          0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                          0x2
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                          0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                            0x1
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                            0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_MSS_Q6_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1

#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00025050)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025050)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025050)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_Q6_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00025054)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025054)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025054)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00046000)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046000)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046000)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_RMSK                                                        0xfffffd7f
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                           0x80000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                                 0x1f
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                    0x40000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                          0x1e
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                     0x20000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                           0x1d
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                                 0x10000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                       0x1c
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                                 0x8000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                      0x1b
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                  0x4000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                       0x1a
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                              0x2000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                   0x19
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                  0x1000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                       0x18
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                        0x200000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                            0x15
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                            0x100000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                                0x14
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                                 0x80000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                    0x13
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                                 0x40000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                    0x12
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x20000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x11
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x10000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                      0x8000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                         0xf
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                      0x4000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                         0xe
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                           0x2000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                              0xd
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                                 0x1000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                    0xc
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                       0x800
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                         0xb
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                        0x400
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                          0xa
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                            0x100
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                              0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                                 0x40
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                  0x6
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                  0x20
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                   0x5
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                           0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                            0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                              0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                               0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                               0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                               0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                          0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                          0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                              0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                     0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                     0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                              0x1

#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00046004)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046004)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046004)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_RMSK                                                         0xfffffd7f
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                      0x80000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                            0x1f
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                               0x40000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                     0x1e
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                                0x20000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                      0x1d
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                            0x10000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x1c
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                            0x8000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                 0x1b
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                             0x4000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                  0x1a
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                         0x2000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                              0x19
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                             0x1000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                  0x18
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                   0x200000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                       0x15
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                       0x100000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                           0x14
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                            0x80000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                               0x13
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                            0x40000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                               0x12
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x8000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xf
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x4000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xe
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                      0x2000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                         0xd
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                            0x1000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                               0xc
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                  0x800
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                    0xb
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                   0x400
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                     0xa
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                       0x100
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                         0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                            0x40
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                             0x6
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                             0x20
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                              0x5
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                         0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                          0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                          0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                          0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                     0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                     0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                         0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00046008)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046008)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046008)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                      0xffffffff
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                             0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                             0x80000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                   0x1f
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                           0x40000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                                 0x1e
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                        0x20000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                              0x1d
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                               0x10000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                     0x1c
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                                0x8000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                     0x1b
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                                0x4000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                     0x1a
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                                0x2000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                     0x19
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                                0x1000000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                     0x18
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                             0x200000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                                 0x15
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                             0x100000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                                 0x14
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                                0x80000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                   0x13
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                             0x40000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                                0x12
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                    0x20000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                       0x11
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                    0x10000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                       0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                     0x2000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                        0xd
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                     0x1000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                        0xc
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                      0x800
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                        0xb
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                      0x400
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                        0xa
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                               0x200
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                                 0x9
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                    0x80
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                     0x7
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                   0x40
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                    0x6
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                                 0x20
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                  0x5
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                        0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                         0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                          0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                          0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                      0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                      0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                     0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                     0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                      0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                      0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                               0x1

#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0004600c)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004600c)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004600c)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                       0xffffffff
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                              0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                        0x80000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                              0x1f
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                      0x40000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                            0x1e
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                   0x20000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                         0x1d
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                          0x10000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                                0x1c
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                           0x8000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                                0x1b
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                           0x4000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                                0x1a
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                           0x2000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                                0x19
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                           0x1000000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                                0x18
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                        0x200000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                            0x15
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                        0x100000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                            0x14
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                           0x80000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                              0x13
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                        0x40000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                           0x12
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                               0x20000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                  0x11
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                               0x10000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                  0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                                0x2000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                   0xd
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                                0x1000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                   0xc
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                                 0x800
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                   0xb
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                                 0x400
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                   0xa
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                          0x200
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                            0x9
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                               0x80
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                                0x7
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                              0x40
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                               0x6
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                            0x20
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                             0x5
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                   0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                    0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                     0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                     0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                                 0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                                 0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                                0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                                 0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                                 0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00046010)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046010)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046010)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                         0x7ffff
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                             0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                              0x40000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                                 0x12
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                  0x20000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                     0x11
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                  0x10000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                     0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                          0x2000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                             0xd
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                                0x800
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                  0xb
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                    0x400
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                      0xa
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                    0x200
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                      0x9
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                     0x80
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                      0x7
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                     0x40
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                      0x6
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                     0x20
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                      0x5
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                     0x10
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                      0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                                 0x8
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                                 0x3
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                  0x4
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                  0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                  0x2
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                  0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                    0x1
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                    0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                             0x1

#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00046014)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046014)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046014)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                          0x7ffff
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                              0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                             0x20000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                                0x11
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                             0x10000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                                0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                     0x2000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                        0xd
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                           0x800
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                             0xb
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                               0x400
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                                 0xa
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                               0x200
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                                 0x9
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                                0x80
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                                 0x7
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                                0x40
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                                 0x6
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                                0x20
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                                 0x5
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                                0x10
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                                 0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                            0x8
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                            0x3
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                             0x4
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                             0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                             0x2
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                             0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                               0x1
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                               0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_HYP_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00046018)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046018)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046018)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0004601c)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004601c)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004601c)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a000)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a000)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a000)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_RMSK                                                     0xfffffd7f
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                        0x80000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                              0x1f
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                 0x40000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                       0x1e
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                  0x20000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                        0x1d
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                              0x10000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                    0x1c
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                              0x8000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                   0x1b
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                               0x4000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                    0x1a
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                           0x2000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                0x19
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                               0x1000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                    0x18
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                              0x800000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                  0x17
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                              0x400000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                  0x16
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                     0x200000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                         0x15
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                         0x100000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                             0x14
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                              0x80000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                 0x13
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                              0x40000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                 0x12
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                              0x20000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                 0x11
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                              0x10000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                 0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                   0x8000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                      0xf
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                   0x4000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                      0xe
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                        0x2000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                           0xd
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                              0x1000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                 0xc
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                    0x800
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                      0xb
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                     0x400
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                       0xa
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                         0x100
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                           0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                              0x40
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                               0x6
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                               0x20
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                0x5
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                         0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                           0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                            0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                            0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                            0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                       0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                       0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                           0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                  0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                  0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                           0x1

#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a004)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a004)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a004)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_RMSK                                                      0xfffffd7f
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                   0x80000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                         0x1f
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                            0x40000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                  0x1e
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                             0x20000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                   0x1d
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                         0x10000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                               0x1c
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                         0x8000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                              0x1b
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                          0x4000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                               0x1a
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                      0x2000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                           0x19
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                          0x1000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                               0x18
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                         0x800000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                             0x17
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                         0x400000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                             0x16
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                0x200000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                    0x15
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                    0x100000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                        0x14
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                         0x80000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                            0x13
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                         0x20000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                            0x11
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                         0x10000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                            0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                              0x8000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                 0xf
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                              0x4000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                 0xe
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                   0x2000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                      0xd
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                         0x1000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                            0xc
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                               0x800
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                 0xb
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                0x400
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                  0xa
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                    0x100
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                      0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                         0x40
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                          0x6
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                          0x20
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                           0x5
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                      0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                       0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                       0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                       0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                  0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                      0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                             0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                             0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1

#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a008)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a008)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a008)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                   0xffffffff
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                          0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                          0x80000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                0x1f
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                        0x40000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                              0x1e
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                     0x20000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                           0x1d
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                            0x10000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                  0x1c
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                             0x8000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                  0x1b
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                             0x4000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                  0x1a
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                             0x2000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                  0x19
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                             0x1000000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                  0x18
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                              0x800000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                  0x17
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                              0x400000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                  0x16
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                          0x200000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                              0x15
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                          0x100000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                              0x14
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                             0x80000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                0x13
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                          0x40000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                             0x12
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                 0x20000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                    0x11
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                 0x10000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                    0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                  0x8000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                     0xf
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                  0x4000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                     0xe
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                  0x2000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                     0xd
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                   0x800
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                     0xb
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                   0x400
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                     0xa
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                            0x200
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                              0x9
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                 0x100
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                   0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                 0x80
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                  0x7
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                0x40
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                 0x6
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                              0x20
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                               0x5
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                     0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                      0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                       0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                       0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                   0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                   0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                  0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                  0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                   0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                   0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                            0x1

#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a00c)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a00c)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a00c)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                    0xffffffff
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                           0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                     0x80000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                           0x1f
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                   0x40000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                         0x1e
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                0x20000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                      0x1d
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL               0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                       0x10000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                             0x1c
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                        0x8000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                             0x1b
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                        0x4000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                             0x1a
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                        0x2000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                             0x19
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                        0x1000000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                             0x18
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                         0x800000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                             0x17
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                         0x400000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                             0x16
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                     0x200000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                         0x15
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                     0x100000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                         0x14
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                        0x80000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                           0x13
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                     0x40000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                        0x12
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                             0x8000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                0xf
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                             0x4000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                0xe
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                             0x2000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                0xd
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                              0x800
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                0xb
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                              0x400
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                0xa
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                       0x200
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                         0x9
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                            0x100
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                              0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                            0x80
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                             0x7
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                           0x40
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                            0x6
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                         0x20
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                          0x5
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                 0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                  0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                  0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                              0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                              0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                             0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                             0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                              0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                              0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1

#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a010)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a010)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a010)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                      0x7ffff
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                          0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                           0x40000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                              0x12
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                               0x20000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                  0x11
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                               0x10000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                  0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                  0x8000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                     0xf
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                  0x4000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                     0xe
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                       0x2000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                          0xd
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                               0x1000
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                  0xc
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                             0x800
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                               0xb
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                 0x400
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                   0xa
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                 0x200
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                   0x9
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                 0x100
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                   0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                  0x80
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                   0x7
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                  0x40
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                   0x6
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                  0x20
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                   0x5
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                  0x10
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                   0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                              0x8
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                              0x3
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                               0x4
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                               0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                               0x2
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                               0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                 0x1
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                 0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a014)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a014)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a014)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                       0x7ffff
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                           0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                      0x40000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                         0x12
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                          0x20000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                             0x11
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                          0x10000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                             0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                             0x8000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                0xf
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                             0x4000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                0xe
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                  0x2000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                     0xd
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL             0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL              0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                          0x1000
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                             0xc
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                        0x800
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                          0xb
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                            0x400
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                              0xa
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                            0x200
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                              0x9
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                            0x100
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                              0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                             0x80
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                              0x7
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                             0x40
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                              0x6
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                             0x20
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                              0x5
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                             0x10
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                              0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                         0x8
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                         0x3
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                 0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                  0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                          0x4
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                          0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                          0x2
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                          0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                            0x1
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                            0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_SPARE1_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1

#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a018)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a018)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a018)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SPARE1_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a01c)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a01c)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a01c)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00059038)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059038)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059038)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_RMSK                                                        0xfffffd7f
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_BMSK                           0x80000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_SHFT                                 0x1f
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_BMSK                                    0x40000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_SHFT                                          0x1e
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_DISABLE_FVAL                                   0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PIPE_CLK_ENA_ENABLE_FVAL                                    0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_BMSK                                     0x20000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_SHFT                                           0x1d
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_DISABLE_FVAL                                    0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_AUX_CLK_ENA_ENABLE_FVAL                                     0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_BMSK                                 0x10000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_SHFT                                       0x1c
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_CFG_AHB_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_BMSK                                 0x8000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_SHFT                                      0x1b
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_BMSK                                  0x4000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_SHFT                                       0x1a
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_AXI_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_BMSK                              0x2000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_SHFT                                   0x19
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_BMSK                                  0x1000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_SHFT                                       0x18
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_AUX_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_BMSK                                        0x200000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_SHFT                                            0x15
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_BMSK                            0x100000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_SHFT                                0x14
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_BMSK                                 0x80000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_SHFT                                    0x13
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_BMSK                                 0x40000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_SHFT                                    0x12
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x20000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x11
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_BMSK                                 0x10000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_SHFT                                    0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_BMSK                                      0x8000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_SHFT                                         0xf
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_GPU_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_BMSK                                      0x4000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_SHFT                                         0xe
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TME_GPLL0_CLK_SRC_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_BMSK                                           0x2000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_SHFT                                              0xd
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_PRNG_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_BMSK                                 0x1000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_SHFT                                    0xc
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_BMSK                                       0x800
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_SHFT                                         0xb
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QMIP_PCIE_AHB_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_BMSK                                        0x400
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_SHFT                                          0xa
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_BOOT_ROM_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_BMSK                                            0x100
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_SHFT                                              0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_BMSK                                                 0x40
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_SHFT                                                  0x6
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TLMM_CLK_ENA_ENABLE_FVAL                                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_BMSK                                                  0x20
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_SHFT                                                   0x5
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_DISABLE_FVAL                                           0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_CLK_ENA_ENABLE_FVAL                                            0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_BMSK                                              0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_SHFT                                               0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AXI_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_BMSK                                               0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_SHFT                                               0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_CE1_AHB_CLK_ENA_ENABLE_FVAL                                        0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_BMSK                                          0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_SHFT                                          0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_QDSS_CFG_AHB_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_BMSK                                              0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_SHFT                                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_TCSR_AHB_CLK_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_BMSK                                     0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_SHFT                                     0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_ENA_ENABLE_FVAL                              0x1

#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0005903c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005903c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005903c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_RMSK                                                         0xfffffd7f
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_BMSK                      0x80000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_SHFT                            0x1f
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_GPLL0_MAIN_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_BMSK                               0x40000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_SHFT                                     0x1e
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_BMSK                                0x20000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_SHFT                                      0x1d
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                               0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                                0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_BMSK                            0x10000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_SHFT                                  0x1c
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_BMSK                            0x8000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                 0x1b
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_BMSK                             0x4000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_SHFT                                  0x1a
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                         0x2000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                              0x19
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_BMSK                             0x1000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_SHFT                                  0x18
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_1_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PCIE_0_PHY_RCHNG_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                   0x200000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                       0x15
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_BMSK                       0x100000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_SHFT                           0x14
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CFG_NOC_PCIE_ANOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_BMSK                            0x80000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_SHFT                               0x13
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_DDRSS_PCIE_SF_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_BMSK                            0x40000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_SHFT                               0x12
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCU_ANOC_PCIE_QTB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x20000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x11
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_MSS_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_BMSK                            0x10000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_SHFT                               0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_DIV_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x8000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xf
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_GPU_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_BMSK                                 0x4000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_SHFT                                    0xe
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TME_GPLL0_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_BMSK                                      0x2000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_SHFT                                         0xd
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_PRNG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_BMSK                            0x1000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_SHFT                               0xc
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_AGGRE_NOC_PCIE_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_BMSK                                  0x800
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_SHFT                                    0xb
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QMIP_PCIE_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_BMSK                                   0x400
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_SHFT                                     0xa
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_BOOT_ROM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_BMSK                                       0x100
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_SHFT                                         0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_BMSK                                            0x40
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_SHFT                                             0x6
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_DISABLE_FVAL                                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TLMM_CLK_SLEEP_ENA_ENABLE_FVAL                                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_BMSK                                             0x20
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_SHFT                                              0x5
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_CLK_SLEEP_ENA_ENABLE_FVAL                                       0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_BMSK                                         0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_SHFT                                          0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_BMSK                                          0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_SHFT                                          0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_CE1_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_BMSK                                     0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_SHFT                                     0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_QDSS_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_BMSK                                         0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_SHFT                                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_TCSR_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_BMSK                                0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_SHFT                                0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_SYS_NOC_CPUSS_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1

#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00059040)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059040)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059040)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_RMSK                                                      0xffffffff
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ATTR                                                             0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ADDR, HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_RMSK)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_IN)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_BMSK                             0x80000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_SHFT                                   0x1f
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_BMSK                           0x40000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_SHFT                                 0x1e
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_BMSK                        0x20000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_SHFT                              0x1d
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_BMSK                               0x10000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_SHFT                                     0x1c
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_BMSK                                0x8000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_SHFT                                     0x1b
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_BMSK                                0x4000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_SHFT                                     0x1a
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_BMSK                                0x2000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_SHFT                                     0x19
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_BMSK                                0x1000000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_SHFT                                     0x18
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_BMSK                                 0x800000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_SHFT                                     0x17
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_BMSK                                 0x400000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_SHFT                                     0x16
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_BMSK                             0x200000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_SHFT                                 0x15
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_BMSK                             0x100000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_SHFT                                 0x14
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_BMSK                                0x80000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_SHFT                                   0x13
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_BMSK                             0x40000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_SHFT                                0x12
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_BMSK                                    0x20000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_SHFT                                       0x11
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S7_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_BMSK                                    0x10000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_SHFT                                       0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S6_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S5_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S4_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_BMSK                                     0x2000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_SHFT                                        0xd
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S3_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_BMSK                                     0x1000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_SHFT                                        0xc
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S2_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_BMSK                                      0x800
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_SHFT                                        0xb
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S1_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_BMSK                                      0x400
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_SHFT                                        0xa
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S0_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_BMSK                               0x200
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_SHFT                                 0x9
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_BMSK                                    0x80
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_SHFT                                     0x7
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_BMSK                                   0x40
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_SHFT                                    0x6
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_BMSK                                 0x20
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_SHFT                                  0x5
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_BMSK                                        0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_SHFT                                         0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_PIPE_CLK_ENA_ENABLE_FVAL                                  0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_BMSK                                          0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_SHFT                                          0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_AUX_CLK_ENA_ENABLE_FVAL                                   0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_BMSK                                      0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_SHFT                                      0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_BMSK                                     0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_SHFT                                     0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_BMSK                                      0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_SHFT                                      0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_ENA_ENABLE_FVAL                               0x1

#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00059044)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059044)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059044)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_RMSK                                                       0xffffffff
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ATTR                                                              0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ADDR, HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_RMSK)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ADDR, m)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ADDR,v)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ADDR,m,v,HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_IN)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_BMSK                        0x80000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_SHFT                              0x1f
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_ANOC_PCIE_PWRCTL_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_BMSK                      0x40000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_SHFT                            0x1e
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QMIP_AGGRE_NOC_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_BMSK                   0x20000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_SHFT                         0x1d
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_DISABLE_FVAL                  0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_NOC_PCIE_NORTH_DCD_XO_CLK_SLEEP_ENA_ENABLE_FVAL                   0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_BMSK                          0x10000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_SHFT                                0x1c
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_BMSK                           0x8000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_SHFT                                0x1b
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_BMSK                           0x4000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_SHFT                                0x1a
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_BMSK                           0x2000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_SHFT                                0x19
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_BMSK                           0x1000000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_SHFT                                0x18
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_BMSK                            0x800000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_SHFT                                0x17
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_BMSK                            0x400000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_SHFT                                0x16
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_BMSK                        0x200000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_SHFT                            0x15
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_BMSK                        0x100000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_SHFT                            0x14
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP_1_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_BMSK                           0x80000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_SHFT                              0x13
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_BMSK                        0x40000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_SHFT                           0x12
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_WRAP1_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_BMSK                               0x20000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_SHFT                                  0x11
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S7_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_BMSK                               0x10000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_SHFT                                  0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S6_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S5_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S4_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_BMSK                                0x2000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_SHFT                                   0xd
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S3_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_BMSK                                0x1000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_SHFT                                   0xc
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S2_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_BMSK                                 0x800
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_SHFT                                   0xb
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S1_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_BMSK                                 0x400
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_SHFT                                   0xa
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S0_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_BMSK                          0x200
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_SHFT                            0x9
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_AGGRE_NOC_SOUTH_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_BMSK                               0x80
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_SHFT                                0x7
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_QUPV3_I2C_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_BMSK                              0x40
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_SHFT                               0x6
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_CNOC_PCIE_SF_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_BMSK                            0x20
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_SHFT                             0x5
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_Q2A_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_BMSK                                   0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_SHFT                                    0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_PIPE_CLK_SLEEP_ENA_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_BMSK                                     0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_SHFT                                     0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_AUX_CLK_SLEEP_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_BMSK                                 0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_SHFT                                 0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_CFG_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_BMSK                                0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_SHFT                                0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_MSTR_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_BMSK                                 0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_SHFT                                 0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_1_PCIE_0_SLV_AXI_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1

#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00059048)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059048)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059048)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_RMSK                                                         0x7ffff
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ATTR                                                             0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ADDR, HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_RMSK)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_IN)
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_BMSK                              0x40000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_SHFT                                 0x12
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_BMSK                                  0x20000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_SHFT                                     0x11
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_BMSK                                  0x10000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_SHFT                                     0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_BMSK                                     0x8000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_SHFT                                        0xf
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S9_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_BMSK                                     0x4000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_SHFT                                        0xe
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_DISABLE_FVAL                                0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_I2C_S8_CLK_ENA_ENABLE_FVAL                                 0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_BMSK                          0x2000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_SHFT                             0xd
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_BMSK                                  0x1000
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_SHFT                                     0xc
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_ENA_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_BMSK                                0x800
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_SHFT                                  0xb
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_BMSK                                    0x400
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_SHFT                                      0xa
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_BMSK                                    0x200
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_SHFT                                      0x9
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_BMSK                                    0x100
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_SHFT                                      0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_BMSK                                     0x80
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_SHFT                                      0x7
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_BMSK                                     0x40
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_SHFT                                      0x6
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_BMSK                                     0x20
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_SHFT                                      0x5
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_BMSK                                     0x10
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_SHFT                                      0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_DISABLE_FVAL                              0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_ENA_ENABLE_FVAL                               0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_BMSK                                 0x8
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_SHFT                                 0x3
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_BMSK                                  0x4
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_SHFT                                  0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_BMSK                                  0x2
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_SHFT                                  0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_ENA_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_BMSK                                    0x1
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_SHFT                                    0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_CLOCK_BRANCH_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_ENA_ENABLE_FVAL                             0x1

#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0005904c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005904c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005904c)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_RMSK                                                          0x7ffff
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ATTR                                                              0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_IN          \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ADDR, HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_RMSK)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ADDR, m)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_OUT(v)      \
        out_dword(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ADDR,v)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ADDR,m,v,HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_IN)
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_BMSK                         0x40000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_SHFT                            0x12
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_TME_GPLL0_DIV2_CLK_SRC_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_BMSK                             0x20000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_SHFT                                0x11
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_BMSK                             0x10000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_SHFT                                0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP1_S7_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_BMSK                                0x8000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_SHFT                                   0xf
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S9_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_BMSK                                0x4000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_SHFT                                   0xe
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_DISABLE_FVAL                           0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_I2C_S8_CLK_SLEEP_ENA_ENABLE_FVAL                            0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_BMSK                     0x2000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_SHFT                        0xd
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_DISABLE_FVAL                0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_QOSGEN_EXTREF_CLK_SLEEP_ENA_ENABLE_FVAL                 0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_BMSK                             0x1000
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_SHFT                                0xc
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_TSCTR_CLK_SLEEP_ENA_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_BMSK                           0x800
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_SHFT                             0xb
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_ANOC_PCIE_NORTH_AT_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_BMSK                               0x400
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_SHFT                                 0xa
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S6_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_BMSK                               0x200
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_SHFT                                 0x9
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S5_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_BMSK                               0x100
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_SHFT                                 0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S4_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_BMSK                                0x80
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_SHFT                                 0x7
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S3_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_BMSK                                0x40
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_SHFT                                 0x6
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S2_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_BMSK                                0x20
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_SHFT                                 0x5
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S1_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_BMSK                                0x10
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_SHFT                                 0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_S0_CLK_SLEEP_ENA_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_BMSK                            0x8
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_SHFT                            0x3
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_DISABLE_FVAL                    0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_2X_CLK_SLEEP_ENA_ENABLE_FVAL                     0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_BMSK                             0x4
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_SHFT                             0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_M_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_BMSK                             0x2
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_SHFT                             0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_DISABLE_FVAL                     0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP_2_S_AHB_CLK_SLEEP_ENA_ENABLE_FVAL                      0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_BMSK                               0x1
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_SHFT                               0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_DISABLE_FVAL                       0x0
#define HWIO_GCC_TME_CLOCK_SLEEP_ENA_VOTE_2_QUPV3_WRAP2_CORE_CLK_SLEEP_ENA_ENABLE_FVAL                        0x1

#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00059050)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059050)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059050)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TME_PLL_BRANCH_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00059054)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059054)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059054)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TME_PLL_SLEEP_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c014)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c014)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c014)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_RMSK                                                                    0x1
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ADDR, HWIO_GCC_PCIE_0_LINK_DOWN_BCR_RMSK)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ADDR, m)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ADDR,v)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_LINK_DOWN_BCR_ADDR,m,v,HWIO_GCC_PCIE_0_LINK_DOWN_BCR_IN)
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_BLK_ARES_BMSK                                                           0x1
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_BLK_ARES_SHFT                                                           0x0
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_BLK_ARES_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_PCIE_0_LINK_DOWN_BCR_BLK_ARES_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_PCIE_0_MISC_RESET_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c018)
#define HWIO_GCC_PCIE_0_MISC_RESET_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c018)
#define HWIO_GCC_PCIE_0_MISC_RESET_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c018)
#define HWIO_GCC_PCIE_0_MISC_RESET_RMSK                                                                      0xff
#define HWIO_GCC_PCIE_0_MISC_RESET_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_0_MISC_RESET_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_MISC_RESET_ADDR, HWIO_GCC_PCIE_0_MISC_RESET_RMSK)
#define HWIO_GCC_PCIE_0_MISC_RESET_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_MISC_RESET_ADDR, m)
#define HWIO_GCC_PCIE_0_MISC_RESET_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_MISC_RESET_ADDR,v)
#define HWIO_GCC_PCIE_0_MISC_RESET_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_MISC_RESET_ADDR,m,v,HWIO_GCC_PCIE_0_MISC_RESET_IN)
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_STICKY_BCR_BLK_ARES_BMSK                                   0x80
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_STICKY_BCR_BLK_ARES_SHFT                                    0x7
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_STICKY_BCR_BLK_ARES_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_STICKY_BCR_BLK_ARES_ENABLE_FVAL                             0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CORE_STICKY_BCR_BLK_ARES_BMSK                                      0x40
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CORE_STICKY_BCR_BLK_ARES_SHFT                                       0x6
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CORE_STICKY_BCR_BLK_ARES_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CORE_STICKY_BCR_BLK_ARES_ENABLE_FVAL                                0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_STICKY_BCR_BLK_ARES_BMSK                                  0x20
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_STICKY_BCR_BLK_ARES_SHFT                                   0x5
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_STICKY_BCR_BLK_ARES_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_STICKY_BCR_BLK_ARES_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_PIPE_BCR_BLK_ARES_BMSK                                             0x10
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_PIPE_BCR_BLK_ARES_SHFT                                              0x4
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_PIPE_BCR_BLK_ARES_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_PIPE_BCR_BLK_ARES_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_AUX_BCR_BLK_ARES_BMSK                                               0x8
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_AUX_BCR_BLK_ARES_SHFT                                               0x3
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_AUX_BCR_BLK_ARES_DISABLE_FVAL                                       0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_AUX_BCR_BLK_ARES_ENABLE_FVAL                                        0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CFG_AHB_BCR_BLK_ARES_BMSK                                           0x4
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CFG_AHB_BCR_BLK_ARES_SHFT                                           0x2
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CFG_AHB_BCR_BLK_ARES_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_CFG_AHB_BCR_BLK_ARES_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_BCR_BLK_ARES_BMSK                                          0x2
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_BCR_BLK_ARES_SHFT                                          0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_BCR_BLK_ARES_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_MSTR_AXI_BCR_BLK_ARES_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_BCR_BLK_ARES_BMSK                                           0x1
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_BCR_BLK_ARES_SHFT                                           0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_BCR_BLK_ARES_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_0_MISC_RESET_PCIE_0_SLV_AXI_BCR_BLK_ARES_ENABLE_FVAL                                    0x1

#define HWIO_GCC_PCIE_0_PHY_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c01c)
#define HWIO_GCC_PCIE_0_PHY_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c01c)
#define HWIO_GCC_PCIE_0_PHY_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c01c)
#define HWIO_GCC_PCIE_0_PHY_BCR_RMSK                                                                          0x1
#define HWIO_GCC_PCIE_0_PHY_BCR_ATTR                                                                          0x3
#define HWIO_GCC_PCIE_0_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_BCR_ADDR, HWIO_GCC_PCIE_0_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_BCR_IN)
#define HWIO_GCC_PCIE_0_PHY_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_PCIE_0_PHY_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_PCIE_0_PHY_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_0_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c020)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c020)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c020)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_RMSK                                                                0x1
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ATTR                                                                0x3
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ADDR, HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_IN)
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_BLK_ARES_BMSK                                                       0x1
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_BLK_ARES_SHFT                                                       0x0
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_BLK_ARES_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_0_NOCSR_COM_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                0x1

#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0005c028)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005c028)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005c028)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_RMSK                                                            0x1
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ATTR                                                            0x3
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ADDR, HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_IN)
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_BMSK                                                   0x1
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_SHFT                                                   0x0
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_DISABLE_FVAL                                           0x0
#define HWIO_GCC_PCIE_0_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_ENABLE_FVAL                                            0x1

#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0005f00c)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005f00c)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005f00c)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_RMSK                                                                    0x1
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ADDR, HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_RMSK)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ADDR, m)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ADDR,v)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_ADDR,m,v,HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_IN)
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_BLK_ARES_BMSK                                                           0x1
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_BLK_ARES_SHFT                                                           0x0
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_BLK_ARES_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_PCIE_PHY_CFG_AHB_BCR_BLK_ARES_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_PCIE_PHY_COM_BCR_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005f010)
#define HWIO_GCC_PCIE_PHY_COM_BCR_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005f010)
#define HWIO_GCC_PCIE_PHY_COM_BCR_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005f010)
#define HWIO_GCC_PCIE_PHY_COM_BCR_RMSK                                                                        0x1
#define HWIO_GCC_PCIE_PHY_COM_BCR_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_PHY_COM_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_PHY_COM_BCR_ADDR, HWIO_GCC_PCIE_PHY_COM_BCR_RMSK)
#define HWIO_GCC_PCIE_PHY_COM_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_PHY_COM_BCR_ADDR, m)
#define HWIO_GCC_PCIE_PHY_COM_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_PHY_COM_BCR_ADDR,v)
#define HWIO_GCC_PCIE_PHY_COM_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_PHY_COM_BCR_ADDR,m,v,HWIO_GCC_PCIE_PHY_COM_BCR_IN)
#define HWIO_GCC_PCIE_PHY_COM_BCR_BLK_ARES_BMSK                                                               0x1
#define HWIO_GCC_PCIE_PHY_COM_BCR_BLK_ARES_SHFT                                                               0x0
#define HWIO_GCC_PCIE_PHY_COM_BCR_BLK_ARES_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_PCIE_PHY_COM_BCR_BLK_ARES_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e014)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e014)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e014)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_RMSK                                                                    0x1
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ATTR                                                                    0x3
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ADDR, HWIO_GCC_PCIE_1_LINK_DOWN_BCR_RMSK)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ADDR, m)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ADDR,v)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_LINK_DOWN_BCR_ADDR,m,v,HWIO_GCC_PCIE_1_LINK_DOWN_BCR_IN)
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_BLK_ARES_BMSK                                                           0x1
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_BLK_ARES_SHFT                                                           0x0
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_BLK_ARES_DISABLE_FVAL                                                   0x0
#define HWIO_GCC_PCIE_1_LINK_DOWN_BCR_BLK_ARES_ENABLE_FVAL                                                    0x1

#define HWIO_GCC_PCIE_1_MISC_RESET_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e018)
#define HWIO_GCC_PCIE_1_MISC_RESET_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e018)
#define HWIO_GCC_PCIE_1_MISC_RESET_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e018)
#define HWIO_GCC_PCIE_1_MISC_RESET_RMSK                                                                     0x1ff
#define HWIO_GCC_PCIE_1_MISC_RESET_ATTR                                                                       0x3
#define HWIO_GCC_PCIE_1_MISC_RESET_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_MISC_RESET_ADDR, HWIO_GCC_PCIE_1_MISC_RESET_RMSK)
#define HWIO_GCC_PCIE_1_MISC_RESET_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_MISC_RESET_ADDR, m)
#define HWIO_GCC_PCIE_1_MISC_RESET_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_MISC_RESET_ADDR,v)
#define HWIO_GCC_PCIE_1_MISC_RESET_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_MISC_RESET_ADDR,m,v,HWIO_GCC_PCIE_1_MISC_RESET_IN)
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PHY_AUX_BCR_BLK_ARES_BMSK                                         0x100
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PHY_AUX_BCR_BLK_ARES_SHFT                                           0x8
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PHY_AUX_BCR_BLK_ARES_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PHY_AUX_BCR_BLK_ARES_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_STICKY_BCR_BLK_ARES_BMSK                                   0x80
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_STICKY_BCR_BLK_ARES_SHFT                                    0x7
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_STICKY_BCR_BLK_ARES_DISABLE_FVAL                            0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_STICKY_BCR_BLK_ARES_ENABLE_FVAL                             0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CORE_STICKY_BCR_BLK_ARES_BMSK                                      0x40
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CORE_STICKY_BCR_BLK_ARES_SHFT                                       0x6
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CORE_STICKY_BCR_BLK_ARES_DISABLE_FVAL                               0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CORE_STICKY_BCR_BLK_ARES_ENABLE_FVAL                                0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_STICKY_BCR_BLK_ARES_BMSK                                  0x20
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_STICKY_BCR_BLK_ARES_SHFT                                   0x5
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_STICKY_BCR_BLK_ARES_DISABLE_FVAL                           0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_STICKY_BCR_BLK_ARES_ENABLE_FVAL                            0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PIPE_BCR_BLK_ARES_BMSK                                             0x10
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PIPE_BCR_BLK_ARES_SHFT                                              0x4
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PIPE_BCR_BLK_ARES_DISABLE_FVAL                                      0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_PIPE_BCR_BLK_ARES_ENABLE_FVAL                                       0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_AUX_BCR_BLK_ARES_BMSK                                               0x8
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_AUX_BCR_BLK_ARES_SHFT                                               0x3
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_AUX_BCR_BLK_ARES_DISABLE_FVAL                                       0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_AUX_BCR_BLK_ARES_ENABLE_FVAL                                        0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CFG_AHB_BCR_BLK_ARES_BMSK                                           0x4
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CFG_AHB_BCR_BLK_ARES_SHFT                                           0x2
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CFG_AHB_BCR_BLK_ARES_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_CFG_AHB_BCR_BLK_ARES_ENABLE_FVAL                                    0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_BCR_BLK_ARES_BMSK                                          0x2
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_BCR_BLK_ARES_SHFT                                          0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_BCR_BLK_ARES_DISABLE_FVAL                                  0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_MSTR_AXI_BCR_BLK_ARES_ENABLE_FVAL                                   0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_BCR_BLK_ARES_BMSK                                           0x1
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_BCR_BLK_ARES_SHFT                                           0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_BCR_BLK_ARES_DISABLE_FVAL                                   0x0
#define HWIO_GCC_PCIE_1_MISC_RESET_PCIE_1_SLV_AXI_BCR_BLK_ARES_ENABLE_FVAL                                    0x1

#define HWIO_GCC_PCIE_1_PHY_BCR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e01c)
#define HWIO_GCC_PCIE_1_PHY_BCR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e01c)
#define HWIO_GCC_PCIE_1_PHY_BCR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e01c)
#define HWIO_GCC_PCIE_1_PHY_BCR_RMSK                                                                          0x1
#define HWIO_GCC_PCIE_1_PHY_BCR_ATTR                                                                          0x3
#define HWIO_GCC_PCIE_1_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_BCR_ADDR, HWIO_GCC_PCIE_1_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_BCR_IN)
#define HWIO_GCC_PCIE_1_PHY_BCR_BLK_ARES_BMSK                                                                 0x1
#define HWIO_GCC_PCIE_1_PHY_BCR_BLK_ARES_SHFT                                                                 0x0
#define HWIO_GCC_PCIE_1_PHY_BCR_BLK_ARES_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PCIE_1_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                          0x1

#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e020)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e020)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e020)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_RMSK                                                                0x1
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ATTR                                                                0x3
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ADDR, HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_IN)
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_BLK_ARES_BMSK                                                       0x1
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_BLK_ARES_SHFT                                                       0x0
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_BLK_ARES_DISABLE_FVAL                                               0x0
#define HWIO_GCC_PCIE_1_NOCSR_COM_PHY_BCR_BLK_ARES_ENABLE_FVAL                                                0x1

#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007e024)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007e024)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007e024)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_RMSK                                                            0x1
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ATTR                                                            0x3
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ADDR, HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_RMSK)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ADDR, m)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ADDR,v)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_ADDR,m,v,HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_IN)
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_BMSK                                                   0x1
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_SHFT                                                   0x0
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_DISABLE_FVAL                                           0x0
#define HWIO_GCC_PCIE_1_PHY_NOCSR_COM_PHY_BCR_BLK_ARES_ENABLE_FVAL                                            0x1

#define HWIO_GCC_LPASS_RESET_ADDR                                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x000370b0)
#define HWIO_GCC_LPASS_RESET_PHYS                                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x000370b0)
#define HWIO_GCC_LPASS_RESET_OFFS                                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x000370b0)
#define HWIO_GCC_LPASS_RESET_RMSK                                                                             0x1
#define HWIO_GCC_LPASS_RESET_ATTR                                                                             0x3
#define HWIO_GCC_LPASS_RESET_IN          \
        in_dword_masked(HWIO_GCC_LPASS_RESET_ADDR, HWIO_GCC_LPASS_RESET_RMSK)
#define HWIO_GCC_LPASS_RESET_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_RESET_ADDR, m)
#define HWIO_GCC_LPASS_RESET_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_RESET_ADDR,v)
#define HWIO_GCC_LPASS_RESET_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_RESET_ADDR,m,v,HWIO_GCC_LPASS_RESET_IN)
#define HWIO_GCC_LPASS_RESET_LPASS_ARES_BMSK                                                                  0x1
#define HWIO_GCC_LPASS_RESET_LPASS_ARES_SHFT                                                                  0x0
#define HWIO_GCC_LPASS_RESET_LPASS_ARES_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_LPASS_RESET_LPASS_ARES_ENABLE_FVAL                                                           0x1

#define HWIO_GCC_DEBUG_MUX_MUXR_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00052024)
#define HWIO_GCC_DEBUG_MUX_MUXR_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052024)
#define HWIO_GCC_DEBUG_MUX_MUXR_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052024)
#define HWIO_GCC_DEBUG_MUX_MUXR_RMSK                                                                        0x3ff
#define HWIO_GCC_DEBUG_MUX_MUXR_ATTR                                                                          0x3
#define HWIO_GCC_DEBUG_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_DEBUG_MUX_MUXR_ADDR, HWIO_GCC_DEBUG_MUX_MUXR_RMSK)
#define HWIO_GCC_DEBUG_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_DEBUG_MUX_MUXR_ADDR, m)
#define HWIO_GCC_DEBUG_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_DEBUG_MUX_MUXR_ADDR,v)
#define HWIO_GCC_DEBUG_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DEBUG_MUX_MUXR_ADDR,m,v,HWIO_GCC_DEBUG_MUX_MUXR_IN)
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_BMSK                                                                0x3ff
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_SHFT                                                                  0x0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_BI_TCXO_FVAL                                                          0x1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_CORE_PI_SLEEP_CLK_FVAL                                                0x2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_TIC_CLK_FVAL                                                          0x3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_AUD_REF_CLK_FVAL                                                      0x4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_CORE_BI_PLL_TEST_SE_FVAL                                              0x5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_JBIST_REF_CLK_FVAL                                                0x6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_AOSS_GCC_CB_CLK_FVAL                                                  0x7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_CPUSS_AHB_CLK_FVAL                                        0x8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_NAV_QX_CLK_FVAL                                           0x9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_TME_QXM_CLK_FVAL                                          0xa
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_AXI_CLK_FVAL                                              0xb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_GC_AXI_CLK_FVAL                                           0xc
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_SF_AXI_CLK_FVAL                                           0xd
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_AHB_CFG_CLK_FVAL                                          0xe
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_AT_CLK_FVAL                                               0xf
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SYS_NOC_QOSGEN_EXTREF_CLK_FVAL                                   0x10
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_APSS_QH_CLK_FVAL                                            0x11
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_CENTER_QX_CLK_FVAL                                          0x12
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_SF_QX_CLK_FVAL                                              0x13
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_NORTH_QX_CLK_FVAL                                           0x14
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_PERIPH_SOUTH_CLK_FVAL                                       0x15
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_PERIPH_NORTH_CLK_FVAL                                       0x16
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_AHB_CLK_FVAL                                             0x17
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_WEST_AHB_CLK_FVAL                                        0x18
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_PCIE_SF_AXI_CLK_FVAL                                        0x19
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_NORTH_AHB_CLK_FVAL                                       0x1a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_EAST_AHB_CLK_FVAL                                        0x1b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_SOUTH_AHB_CLK_FVAL                                       0x1c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_MMNOC_AHB_CLK_FVAL                                       0x1d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_QDSS_STM_CLK_FVAL                                           0x1e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_USB3_PRIM_AXI_CLK_FVAL                                   0x1f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_LPASS_CLK_FVAL                                           0x20
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_WEST_DCD_XO_CLK_FVAL                                         0x21
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_EAST_DCD_XO_CLK_FVAL                                         0x22
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_NORTH_DCD_XO_CLK_FVAL                                        0x23
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_PCIE_NORTH_DCD_XO_CLK_FVAL                                   0x24
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_SOUTH_DCD_XO_CLK_FVAL                                        0x25
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_CENTER_DCD_XO_CLK_FVAL                                       0x26
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_AH2PHY_XO_CLK_FVAL                                       0x27
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_LPASS_DCD_XO_CLK_FVAL                                        0x28
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_MMNOC_CNOC_DCD_XO_CLK_FVAL                                   0x29
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CNOC_PERIPH_CLK_FVAL                                             0x2a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CONFIG_NOC_AT_CLK_FVAL                                           0x2b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CFG_NOC_PCIE_ANOC_AHB_CLK_FVAL                                   0x2c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_SOUTH_AHB_CFG_CLK_FVAL                                 0x2d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_AHB_CLK_FVAL                                           0x2e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_AGGRE_NOC_AHB_CLK_FVAL                                      0x2f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_CNOC_PERIPH_NORTH_AHB_CLK_FVAL                             0x30
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_CNOC_PERIPH_SOUTH_AHB_CLK_FVAL                             0x31
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_QOSGEN_EXTREF_CLK_FVAL                                 0x32
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_CENTER_AXI_CLK_FVAL                                    0x33
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_QDSS_BAM_CLK_FVAL                                      0x34
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_CENTER_HS_AXI_CLK_FVAL                                 0x35
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_WEST_AXI_CLK_FVAL                                      0x36
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_WEST_TUNNEL_CLK_FVAL                                   0x37
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_EAST_AXI_CLK_FVAL                                      0x38
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_EAST_TUNNEL_CLK_FVAL                                   0x39
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_SOUTH_HS_AXI_CLK_FVAL                                  0x3a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_SOUTH_TUNNEL_CLK_FVAL                                  0x3b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_NORTH_AXI_CLK_FVAL                                     0x3c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_NORTH_TUNNEL_CLK_FVAL                                  0x3d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_PCIE_AXI_CLK_FVAL                                      0x3e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_USB3_PRIM_AXI_CLK_FVAL                                     0x3f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_UFS_PHY_AXI_CLK_FVAL                                       0x40
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_IPA_CLK_FVAL                                           0x41
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_ANOC_PCIE_PWRCTL_CLK_FVAL                                        0x42
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TIC_CLK_FVAL                                                     0x43
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TIC_CFG_QX_CLK_FVAL                                              0x44
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IMEM_CFG_QX_CLK_FVAL                                             0x45
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IMEM_CFG_AHB_CLK_FVAL                                            0x46
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_CFG_QX_CLK_FVAL                                              0x47
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMU_TCU_CLK_FVAL                                                 0x48
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMU_TCU_SLP_STG_CLK_FVAL                                         0x49
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_ANOC_QTB1_CLK_FVAL                                           0x4a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_ANOC_QTB2_CLK_FVAL                                           0x4b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_MMNOC_QTB_SF_CLK_FVAL                                        0x4c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_MMNOC_QTB_HF01_CLK_FVAL                                      0x4d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_MMNOC_QTB_HF23_CLK_FVAL                                      0x4e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_ANOC_PCIE_QTB_CLK_FVAL                                       0x4f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_TURING_Q6_QTB0_CLK_FVAL                                      0x50
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCU_LPASS_AUDIO_QTB_CLK_FVAL                                     0x51
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_ANOC_PCIE_NORTH_AT_CLK_FVAL                                      0x52
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_ANOC_PCIE_TSCTR_CLK_FVAL                                         0x53
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_ANOC_PCIE_QOSGEN_EXTREF_CLK_FVAL                                 0x54
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_AT_CLK_FVAL                                                0x55
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_AHB_CFG_CLK_FVAL                                           0x56
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_MMNOC_DCD_XO_CLK_FVAL                                        0x57
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_TSCTR_CLK_FVAL                                             0x58
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_SF_CLK_FVAL                                                0x59
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_HF_QX_CLK_FVAL                                             0x5a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_PWRCTL_CLK_FVAL                                            0x5b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_QOSGEN_EXTREF_CLK_FVAL                                     0x5c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMSS_AT_CLK_FVAL                                                 0x5d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMSS_QMIP_CORE_CLK_FVAL                                          0x5e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMSS_TRIG_CLK_FVAL                                               0x5f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMSS_QM_AHB_CLK_FVAL                                             0x60
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_AHB_CLK_FVAL                                              0x61
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_CAMERA_NRT_AHB_CLK_FVAL                                     0x62
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_CAMERA_RT_AHB_CLK_FVAL                                      0x63
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_HF_AXI_CLK_FVAL                                           0x64
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_HF_AXI_SLP_STG_CLK_FVAL                                   0x65
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_SF_AXI_CLK_FVAL                                           0x66
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_SF_AXI_SLP_STG_CLK_FVAL                                   0x67
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CAMERA_XO_CLK_FVAL                                               0x68
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_CAMERA_GCC_DEBUG_CLK_FVAL                                            0x69
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DISP_AHB_CLK_FVAL                                                0x6a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_DISP_AHB_CLK_FVAL                                           0x6b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DISP_HF_AXI_CLK_FVAL                                             0x6c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DISP_XO_CLK_FVAL                                                 0x6d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_MDSS_GCC_DEBUG_CLK_FVAL                                              0x6e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VIDEO_AHB_CLK_FVAL                                               0x6f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_VIDEO_CVP_AHB_CLK_FVAL                                      0x70
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_VIDEO_VCODEC_AHB_CLK_FVAL                                   0x71
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_VIDEO_V_CPU_AHB_CLK_FVAL                                    0x72
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_VIDEO_CV_CPU_AHB_CLK_FVAL                                   0x73
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VIDEO_AXI0_CLK_FVAL                                              0x74
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VIDEO_AXI1_CLK_FVAL                                              0x75
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VIDEO_XO_CLK_FVAL                                                0x76
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_VIDEO_GCC_DEBUG_CLK_FVAL                                             0x77
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_DAP_AHB_CLK_FVAL                                            0x78
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_CFG_AHB_CLK_FVAL                                            0x79
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_CENTER_AT_CLK_FVAL                                          0x7a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SOUTH_AT_CLK_FVAL                                                0x7b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_WEST_AT_CLK_FVAL                                                 0x7c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NORTH_AT_CLK_FVAL                                                0x7d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PHY_AT_CLK_FVAL                                                  0x7e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_ETR_USB_CLK_FVAL                                            0x7f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_ETR_DDR_CLK_FVAL                                            0x80
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_STM_CLK_FVAL                                                0x81
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_TRACECLKIN_CLK_FVAL                                         0x82
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_TSCTR_CLK_FVAL                                              0x83
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_TRIG_CLK_FVAL                                               0x84
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_DAP_CLK_FVAL                                                0x85
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CENTER_APB_CLK_FVAL                                              0x86
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NORTH_APB_CLK_FVAL                                               0x87
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SOUTH_APB_CLK_FVAL                                               0x88
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_WEST_APB_CLK_FVAL                                                0x89
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_EAST_APB_CLK_FVAL                                                0x8a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MMNOC_APB_CLK_FVAL                                               0x8b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_XO_CLK_FVAL                                                 0x8c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QDSS_USB_PRIM_CLK_FVAL                                           0x8d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB30_PRIM_MASTER_CLK_FVAL                                       0x8e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB30_PRIM_SLEEP_CLK_FVAL                                        0x8f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB30_PRIM_MOCK_UTMI_CLK_FVAL                                    0x90
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB3_PRIM_PHY_AUX_CLK_FVAL                                       0x91
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB3_PRIM_PHY_COM_AUX_CLK_FVAL                                   0x92
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB3_PRIM_PHY_PIPE_CLK_FVAL                                      0x93
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB3_PRIM_LPC_GPLL_SRC_0_CLK_SRC_FVAL                            0x94
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_USB3_PRIM_LPC_GPLL_SRC_1_CLK_SRC_FVAL                            0x95
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_USB3DPPHY_GCC_DEBUG_CLK_FVAL                                         0x96
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_USB3_PHY_WRAPPER_GCC_USB30_PIPE_CLK_FVAL                             0x97
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_QUSB2PHY_PRIM_GCC_USB30_UTMI_CLK_FVAL                                0x98
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_USB3PHY_GCC_DEBUG_CLK_FVAL                                           0x99
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AHB2PHY_0_CLK_FVAL                                               0x9a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC2_APPS_CLK_FVAL                                              0x9b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC2_AHB_CLK_FVAL                                               0x9c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC2_AT_CLK_FVAL                                                0x9d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC4_APPS_CLK_FVAL                                              0x9e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC4_AHB_CLK_FVAL                                               0x9f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SDCC4_AT_CLK_FVAL                                                0xa0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S_AHB_CLK_FVAL                                         0xa1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_CORE_CLK_FVAL                                          0xa2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S0_CLK_FVAL                                            0xa3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S1_CLK_FVAL                                            0xa4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S2_CLK_FVAL                                            0xa5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S3_CLK_FVAL                                            0xa6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S4_CLK_FVAL                                            0xa7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S5_CLK_FVAL                                            0xa8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S6_CLK_FVAL                                            0xa9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S7_CLK_FVAL                                            0xaa
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S8_CLK_FVAL                                            0xab
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_I2C_S9_CLK_FVAL                                            0xac
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP_1_M_AHB_CLK_FVAL                                      0xad
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP_1_S_AHB_CLK_FVAL                                      0xae
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_CORE_CLK_FVAL                                        0xaf
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_CORE_2X_CLK_FVAL                                     0xb0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AGGRE_NOC_SOUTH_AXI_CLK_FVAL                                     0xb1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S0_CLK_FVAL                                          0xb2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S1_CLK_FVAL                                          0xb3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S2_CLK_FVAL                                          0xb4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S3_CLK_FVAL                                          0xb5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S4_CLK_FVAL                                          0xb6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S5_CLK_FVAL                                          0xb7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S6_CLK_FVAL                                          0xb8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP1_S7_CLK_FVAL                                          0xb9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP_2_M_AHB_CLK_FVAL                                      0xba
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP_2_S_AHB_CLK_FVAL                                      0xbb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_CORE_CLK_FVAL                                        0xbc
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_CORE_2X_CLK_FVAL                                     0xbd
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S0_CLK_FVAL                                          0xbe
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S1_CLK_FVAL                                          0xbf
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S2_CLK_FVAL                                          0xc0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S3_CLK_FVAL                                          0xc1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S4_CLK_FVAL                                          0xc2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S5_CLK_FVAL                                          0xc3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S6_CLK_FVAL                                          0xc4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QUPV3_WRAP2_S7_CLK_FVAL                                          0xc5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PDM_AHB_CLK_FVAL                                                 0xc6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PDM_XO4_CLK_FVAL                                                 0xc7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PDM2_CLK_FVAL                                                    0xc8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PMU_AHB_CLK_FVAL                                                 0xc9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PMU_CORE_CLK_FVAL                                                0xca
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PRNG_AHB_CLK_FVAL                                                0xcb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_AHB_CLK_FVAL                                                 0xcc
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_BOOT_ROM_AHB_CLK_FVAL                                        0xcd
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_SNOC_QXM_CLK_FVAL                                            0xce
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_GPLL0_CLK_SRC_FVAL                                           0xcf
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_GPLL0_DIV2_CLK_SRC_FVAL                                      0xd0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_TRIG_CLK_FVAL                                                0xd1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TME_AT_CLK_FVAL                                                  0xd2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_TME_GCC_DEBUG_CLK_FVAL                                               0xd3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCSR_AHB_CLK_FVAL                                                0xd4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TCSR_ACC_SERIAL_CLK_FVAL                                         0xd5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MEMRED_P2S_CLK_FVAL                                              0xd6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_BOOT_ROM_AHB_CLK_FVAL                                            0xd7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TLMM_AHB_CLK_FVAL                                                0xd8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TLMM_CLK_FVAL                                                    0xd9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AOSS_CNOC_M_AHB_CLK_FVAL                                         0xda
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AOSS_CNOC_S_AHB_CLK_FVAL                                         0xdb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AOSS_AT_CLK_FVAL                                                 0xdc
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_AOSS_GCC_DEBUG_CLK_FVAL                                              0xdd
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SPDM_FF_CLK_FVAL                                                 0xde
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SPDM_MEMNOC_CY_CLK_FVAL                                          0xdf
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SPDM_SNOC_CY_CLK_FVAL                                            0xe0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SPDM_PNOC_CY_CLK_FVAL                                            0xe1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CE1_CLK_FVAL                                                     0xe2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CE1_AXI_CLK_FVAL                                                 0xe3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CE1_AHB_CLK_FVAL                                                 0xe4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AT_CLK_FVAL                                                      0xe5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AHB_CLK_FVAL                                                     0xe6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_XO_CLK_FVAL                                                      0xe7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_XO_DIV4_CLK_FVAL                                                 0xe8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_XO_DIV16_CLK_FVAL                                                0xe9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SLEEP_CLK_FVAL                                                   0xea
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_MMNOC_SF_CLK_FVAL                                          0xeb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_MMNOC_HF_QX_CLK_FVAL                                       0xec
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_TCU_CLK_FVAL                                               0xed
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_TURING_Q6_AXI_CLK_FVAL                                     0xee
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_MSS_Q6_AXI_CLK_FVAL                                        0xef
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_MODEM_CLK_FVAL                                             0xf0
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_GPU_AXI_CLK_FVAL                                           0xf1
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_PCIE_SF_QTB_CLK_FVAL                                       0xf2
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_SNOC_GC_AXI_CLK_FVAL                                       0xf3
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_SNOC_SF_AXI_CLK_FVAL                                       0xf4
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_CONFIG_NOC_SF_CLK_FVAL                                     0xf5
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_CFG_AHB_CLK_FVAL                                           0xf6
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MEMNOC_CLK_FVAL                                                  0xf7
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_LPASS_SHUB_CLK_FVAL                                        0xf8
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_AT_CLK_FVAL                                                0xf9
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SHRM_CLK_FVAL                                                    0xfa
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_PWRCTL_CLK_FVAL                                            0xfb
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DDRSS_GPLL0_MAIN_CLK_SRC_FVAL                                    0xfc
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_DDRSS_GCC_DEBUG_CLK_FVAL                                             0xfd
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_CFG_NOC_SWAY_CLK_FVAL                                      0xfe
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_LPASS_QTB_AHB_CLK_FVAL                                      0xff
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_TRIG_CLK_FVAL                                             0x100
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_AT_CLK_FVAL                                               0x101
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_AON_NOC_DDRSS_SHUB_CLK_FVAL                               0x102
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_AGGRE_NOC_MPU_CLIENT_DDRSS_SHUB_CLK_FVAL                  0x103
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_HW_AF_NOC_DDRSS_SHUB_CLK_FVAL                             0x104
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_AGGRE_NOC_DDRSS_SHUB_CLK_FVAL                             0x105
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_LPASS_GCC_DEBUG_CLK_FVAL                                            0x106
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_QTB_AHB_CLK_FVAL                                          0x107
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_AUDIO_QTB_CLK_FVAL                                        0x108
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_QOSGEN_EXTREF_CLK_FVAL                                    0x109
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_QDSS_TSCTR_CLK_FVAL                                       0x10a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_QTB_AT_CLK_FVAL                                           0x10b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_XO_CLK_FVAL                                               0x10c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_LPASS_PWRCTL_CLK_FVAL                                           0x10d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_Q6_QTB0_CLK_FVAL                                         0x10e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_NSP_AHB_CLK_FVAL                                         0x10f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NSP_QOSGEN_EXTREF_CLK_FVAL                                      0x110
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NSP_QDSS_TSCTR_CLK_FVAL                                         0x111
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_QTB_AT_CLK_FVAL                                          0x112
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_XO_CLK_FVAL                                              0x113
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_PWRCTL_CLK_FVAL                                          0x114
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_MMNOC_SF_CLK_FVAL                                        0x115
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_Q6_AXI_CLK_FVAL                                          0x116
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_CFG_AHB_CLK_FVAL                                         0x117
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_AT_CLK_FVAL                                              0x118
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_TURING_NSP_AHB_CLK_FVAL                                    0x119
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_TURING_TRIG_CLK_FVAL                                            0x11a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_TURING_GCC_DEBUG_CLK_FVAL                                           0x11b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CPUSS_AHB_CLK_FVAL                                              0x11c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CPUSS_TRIG_CLK_FVAL                                             0x11d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CPUSS_AT_CLK_FVAL                                               0x11e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CPUSS_CONFIG_NOC_SF_CLK_FVAL                                    0x11f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_APSS_QDSS_TSCTR_CLK_FVAL                                        0x120
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_APSS_QDSS_APB_CLK_FVAL                                          0x121
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_CPUSS_GCC_DEBUG_CLK_FVAL                                            0x122
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NOC_BUS_TIMEOUT_EXTREF_CLK_FVAL                                 0x123
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_CX_CLK_FVAL                                               0x124
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_CX_AHB_CLK_FVAL                                           0x125
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MXC_CLK_FVAL                                              0x126
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MXC_AHB_CLK_FVAL                                          0x127
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MXA_CLK_FVAL                                              0x128
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MXA_AHB_CLK_FVAL                                          0x129
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_NSP_CLK_FVAL                                              0x12a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_NSP_AHB_CLK_FVAL                                          0x12b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_FRQ_MEASURE_REF_CLK_FVAL                                        0x12c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_QUSB2PHY_GCC_CLK_TEST_PRIM_FVAL                                     0x12d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_QUSB2PHY_GCC_CLK_TEST_SEC_FVAL                                      0x12e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GP1_CLK_FVAL                                                    0x12f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GP2_CLK_FVAL                                                    0x130
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GP3_CLK_FVAL                                                    0x131
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_PCIE_AHB_CLK_FVAL                                          0x132
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_SLV_Q2A_AXI_CLK_FVAL                                     0x133
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_SLV_AXI_CLK_FVAL                                         0x134
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_MSTR_AXI_CLK_FVAL                                        0x135
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_CFG_AHB_CLK_FVAL                                         0x136
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_AUX_CLK_FVAL                                             0x137
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_PIPE_CLK_FVAL                                            0x138
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_0_PHY_RCHNG_CLK_FVAL                                       0x139
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_PCIE_0_PIPE_CLK_FVAL                                                0x13a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_PCIE_0_GCC_DEBUG_CLK_FVAL                                           0x13b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_SLV_Q2A_AXI_CLK_FVAL                                     0x13c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_SLV_AXI_CLK_FVAL                                         0x13d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_MSTR_AXI_CLK_FVAL                                        0x13e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_CFG_AHB_CLK_FVAL                                         0x13f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_AUX_CLK_FVAL                                             0x140
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_PHY_AUX_CLK_FVAL                                         0x141
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_PIPE_CLK_FVAL                                            0x142
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_PCIE_1_PHY_RCHNG_CLK_FVAL                                       0x143
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_PCIE_1_PIPE_CLK_FVAL                                                0x144
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_PCIE_1_PHY_AUX_CLK_FVAL                                             0x145
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_PCIE_1_GCC_DEBUG_CLK_FVAL                                           0x146
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_AXI_CLK_FVAL                                            0x147
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_AHB_CLK_FVAL                                            0x148
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_TX_SYMBOL_0_CLK_FVAL                                    0x149
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_RX_SYMBOL_0_CLK_FVAL                                    0x14a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_UFS_PHY_TX_SYMBOL_0_CLK_FVAL                                        0x14b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_UFS_PHY_RX_SYMBOL_0_CLK_FVAL                                        0x14c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_UNIPRO_CORE_CLK_FVAL                                    0x14d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_ICE_CORE_CLK_FVAL                                       0x14e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_PHY_AUX_CLK_FVAL                                        0x14f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_PHY_RX_SYMBOL_1_CLK_FVAL                                    0x150
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_UFS_AT_CLK_FVAL                                                 0x151
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_UFS_PHY_RX_SYMBOL_1_CLK_FVAL                                        0x152
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_UFS_PHY_GCC_DEBUG_CLK_FVAL                                          0x153
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VDDMXC_VS_CLK_FVAL                                              0x154
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VDDCX_VS_CLK_FVAL                                               0x155
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VDDMX_VS_CLK_FVAL                                               0x156
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VDDA_VS_CLK_FVAL                                                0x157
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VS_CTRL_CLK_FVAL                                                0x158
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_VS_CTRL_AHB_CLK_FVAL                                            0x159
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_VS_CLK_FVAL                                                 0x15a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_VS_CLK_FVAL                                                 0x15b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_APC_VS_CLK_FVAL                                                 0x15c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MDSS_VS_0_CLK_FVAL                                              0x15d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MDSS_VS_1_CLK_FVAL                                              0x15e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_SLEEP_CLK_FVAL                                                      0x15f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DCC_AHB_CLK_FVAL                                                0x160
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_2X_CLK_FVAL                                                 0x161
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_CLK_FVAL                                                    0x162
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_AHB_CLK_FVAL                                                0x163
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_XO_CLK_FVAL                                                 0x164
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_APB_CLK_FVAL                                                0x165
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPA_AT_CLK_FVAL                                                 0x166
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_CFG_AHB_CLK_FVAL                                            0x167
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_MSS_OFFLINE_CFG_AHB_CLK_FVAL                               0x168
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_MSS_Q6_CFG_AHB_CLK_FVAL                                    0x169
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_OFFLINE_AXI_CLK_FVAL                                        0x16a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_AXIS2_CLK_FVAL                                              0x16b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_TRIG_CLK_FVAL                                               0x16c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_AT_CLK_FVAL                                                 0x16d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_SNOC_AXI_CLK_FVAL                                           0x16e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_Q6_MEMNOC_AXI_CLK_FVAL                                      0x16f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_MSS_GPLL0_DIV_CLK_SRC_FVAL                                      0x170
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_MSS_GCC_DEBUG_CLK_FVAL                                              0x171
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GLM_AHB_CLK_FVAL                                                0x172
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GLM_CLK_FVAL                                                    0x173
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GLM_XO_CLK_FVAL                                                 0x174
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_CFG_AHB_CLK_FVAL                                            0x175
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QMIP_GPU_AHB_CLK_FVAL                                           0x176
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_AT_CLK_FVAL                                                 0x177
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GPU_GCC_DEBUG_CLK_FVAL                                              0x178
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_MEMNOC_GFX_CLK_FVAL                                         0x179
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_TRIG_CLK_FVAL                                               0x17a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_SNOC_DVM_GFX_CLK_FVAL                                       0x17b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_GPLL0_CLK_SRC_FVAL                                          0x17c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_GPU_GPLL0_DIV_CLK_SRC_FVAL                                      0x17d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_SNOC_ANOC_AXI_CLK_FVAL                                       0x17e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_SCR_NIU_CLK_FVAL                                             0x17f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_CFG_AHB_CLK_FVAL                                             0x180
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_SCSR_CLK_FVAL                                                0x181
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_GPKT_XO_CLK_FVAL                                             0x182
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_TRIG_CLK_FVAL                                                0x183
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_SP_AT_CLK_FVAL                                                  0x184
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_SP_GCC_DEBUG_CLK_FVAL                                               0x185
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_NAV_AXI_CLK_FVAL                                                0x186
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_NAV_GCC_DEBUG_CLK_FVAL                                              0x187
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_AHB2PHY_1_CLK_FVAL                                              0x188
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CM_PHY_REFGEN1_CLK_FVAL                                         0x189
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_CM_PHY_REFGEN2_CLK_FVAL                                         0x18a
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QSPI_CNOC_PERIPH_AHB_CLK_FVAL                                   0x18b
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_QSPI_CORE_CLK_FVAL                                              0x18c
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MMCX_CLK_FVAL                                             0x18d
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_RBCPR_MMCX_AHB_CLK_FVAL                                         0x18e
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPCC_CORE_CLK_FVAL                                              0x18f
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_IPCC_AHB_CLK_FVAL                                               0x190
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DPM_CLK_FVAL                                                    0x191
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DPM_CX_AHB_CLK_FVAL                                             0x192
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DPM_MX_AHB_CLK_FVAL                                             0x193
#define HWIO_GCC_DEBUG_MUX_MUXR_MUX_SEL_GCC_DPM_CB_CLK_FVAL                                                 0x194

#define HWIO_GCC_PLL_TEST_MUX_MUXR_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00052034)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052034)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052034)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_RMSK                                                                      0x3f
#define HWIO_GCC_PLL_TEST_MUX_MUXR_ATTR                                                                       0x3
#define HWIO_GCC_PLL_TEST_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PLL_TEST_MUX_MUXR_ADDR, HWIO_GCC_PLL_TEST_MUX_MUXR_RMSK)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_TEST_MUX_MUXR_ADDR, m)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PLL_TEST_MUX_MUXR_ADDR,v)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_TEST_MUX_MUXR_ADDR,m,v,HWIO_GCC_PLL_TEST_MUX_MUXR_IN)
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_BMSK                                                              0x3f
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_SHFT                                                               0x0
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GCC_DEBUG_CLK_FVAL                                                 0x0
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL0_OUT_TEST_FVAL                                                0x1
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL1_OUT_TEST_FVAL                                                0x2
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL2_OUT_TEST_FVAL                                                0x3
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL3_OUT_TEST_FVAL                                                0x4
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL4_OUT_TEST_FVAL                                                0x5
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL5_OUT_TEST_FVAL                                                0x6
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL6_OUT_TEST_FVAL                                                0x7
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_CPUSS_GCC_PLL_TEST_CLK_FVAL                                        0x8
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_MSS_GCC_PLL_TEST_CLK_FVAL                                          0xa
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_LPASS_GCC_PLL_TEST_CLK_FVAL                                        0xb
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_TURING_GCC_PLL_TEST_CLK_FVAL                                       0xc
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPU_GCC_PLL_TEST_CLK_FVAL                                          0xd
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_NAV_GCC_PLL_TEST_CLK_FVAL                                          0xe
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_MSS_GCC_VQ6_LDO_NMO_OUT_FVAL                                      0x10
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_DDRSS_GCC_PLL_TEST_CLK_FVAL                                       0x11
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_MSS_GCC_Q6_LDO_NMO_OUT_FVAL                                       0x12
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_LPASS_GCC_Q6_LDO_NMO_OUT_FVAL                                     0x13
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_SPSS_GCC_PLL_TEST_CLK_FVAL                                        0x16
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_QREFS_GCC_CXO2_RXTAP0_CLK_TEST_SE_FVAL                            0x17
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_QREFS_GCC_CXO_RXTAP1_CLK_TEST_SE_FVAL                             0x18
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_QREFS_GCC_CXO_RXTAP2_CLK_TEST_SE_FVAL                             0x19
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_QREFS_GCC_CXO_RXTAP2A_CLK_TEST_SE_FVAL                            0x1a
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_QREFS_GCC_CXO_RXTAP3_CLK_TEST_SE_FVAL                             0x1b
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_DISP_GCC_PLL_TEST_CLK_FVAL                                        0x1c
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_CAM_GCC_PLL_TEST_CLK_FVAL                                         0x1d
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_VIDEO_GCC_PLL_TEST_CLK_FVAL                                       0x1e
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_AOSS_GCC_PLL_TEST_CLK_FVAL                                        0x1f
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL7_OUT_TEST_FVAL                                               0x21
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL8_OUT_TEST_FVAL                                               0x22
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_GPLL9_OUT_TEST_FVAL                                               0x23
#define HWIO_GCC_PLL_TEST_MUX_MUXR_OUT_SEL_UFS_PHY_GCC_TEST_CLK_FVAL                                         0x27

#define HWIO_GCC_PLL_STATUS_MUXR_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0005203c)
#define HWIO_GCC_PLL_STATUS_MUXR_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005203c)
#define HWIO_GCC_PLL_STATUS_MUXR_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005203c)
#define HWIO_GCC_PLL_STATUS_MUXR_RMSK                                                                        0x3f
#define HWIO_GCC_PLL_STATUS_MUXR_ATTR                                                                         0x3
#define HWIO_GCC_PLL_STATUS_MUXR_IN          \
        in_dword_masked(HWIO_GCC_PLL_STATUS_MUXR_ADDR, HWIO_GCC_PLL_STATUS_MUXR_RMSK)
#define HWIO_GCC_PLL_STATUS_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_STATUS_MUXR_ADDR, m)
#define HWIO_GCC_PLL_STATUS_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_PLL_STATUS_MUXR_ADDR,v)
#define HWIO_GCC_PLL_STATUS_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_STATUS_MUXR_ADDR,m,v,HWIO_GCC_PLL_STATUS_MUXR_IN)
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_BMSK                                                          0x3f
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_SHFT                                                           0x0
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_DEFAULT_ZERO_FVAL                                              0x0
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL0_STATUS_DEBUG_FVAL                                        0x1
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL1_STATUS_DEBUG_FVAL                                        0x2
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL2_STATUS_DEBUG_FVAL                                        0x3
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL3_STATUS_DEBUG_FVAL                                        0x4
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL4_STATUS_DEBUG_FVAL                                        0x5
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL5_STATUS_DEBUG_FVAL                                        0x6
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL6_STATUS_DEBUG_FVAL                                        0x7
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL7_STATUS_DEBUG_FVAL                                        0x8
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL8_STATUS_DEBUG_FVAL                                        0x9
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL9_STATUS_DEBUG_FVAL                                        0xa
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_JBIST_STATUS_DEBUG_FVAL                                        0xb
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_SYSTEM_NOC_CLK_SRC_DEBUG_BUS_FVAL                              0xc
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GPLL_LOCK_DET_STATUS_FVAL                                      0xd
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_RPMH_CE_IPA_STATUS_FVAL                                    0xe
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_RPMH_SHRM_QUPV3_STATUS_FVAL                                0xf
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_RPMH_SHUB_STATUS_FVAL                                     0x10
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_RPMH_SNOC_CNOC_STATUS_FVAL                                0x11
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_RPMH_MMNOC_CDSPNOC_STATUS_FVAL                            0x12
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_USB30_PRIM_GDS_FSM_STATE_FVAL                             0x13
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_ANOC_PCIE_GDS_FSM_STATE_FVAL                              0x14
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_IPA_GDS_FSM_STATE_FVAL                                    0x15
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_MMNOC_GDS_FSM_STATE_FVAL                                  0x16
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_PCIE_0_GDS_FSM_STATE_FVAL                                 0x17
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_PCIE_1_GDS_FSM_STATE_FVAL                                 0x18
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_UFS_PHY_GDS_FSM_STATE_FVAL                                0x19
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_TURING_QTB_GDS_FSM_STATE_FVAL                             0x1a
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_MMU_GDS_FSM_STATE_FVAL                                    0x1b
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_USB3_PHY_GDS_FSM_STATE_FVAL                               0x1c
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_LPASS_QTB_GDS_FSM_STATE_FVAL                              0x1d
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_PCIE_0_PHY_GDS_FSM_STATE_FVAL                             0x1e
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_PCIE_1_PHY_GDS_FSM_STATE_FVAL                             0x1f
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_DEBUG_BUG_MISC_FVAL                                           0x20
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_DEBUG_BUS_SLP_RET_SIGNALS_1_FVAL                          0x21
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_DEBUG_BUS_SLP_RET_SIGNALS_2_FVAL                          0x22
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_DEBUG_BUS_SLP_RET_SIGNALS_3_FVAL                          0x23
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_DEBUG_BUS_SLP_RET_SIGNALS_4_FVAL                          0x24
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_GCC_UFS_MEM_PHY_GDS_FSM_STATE_FVAL                            0x25
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_CC_ALL_CLKS_OFF_STATUS_0_FVAL                                 0x26
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_CC_ALL_CLKS_OFF_STATUS_1_FVAL                                 0x27
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_CC_ALL_CLKS_OFF_STATUS_2_FVAL                                 0x28
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_CC_ALL_CLKS_OFF_STATUS_3_FVAL                                 0x29
#define HWIO_GCC_PLL_STATUS_MUXR_DEBUG_BUS_SEL_CC_ALL_CLKS_OFF_STATUS_4_FVAL                                 0x2a

#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00052040)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052040)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052040)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_RMSK                                                              0x1
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ATTR                                                              0x3
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_IN          \
        in_dword_masked(HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ADDR, HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_RMSK)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ADDR, m)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ADDR,v)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_ADDR,m,v,HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_IN)
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_PLLTEST_DE_SEL_BMSK                                               0x1
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_PLLTEST_DE_SEL_SHFT                                               0x0
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_PLLTEST_DE_SEL_DEBUG_PREDIV_CLK_FVAL                              0x0
#define HWIO_GCC_DEBUG_OR_PLL_TEST_MUX_MUXR_PLLTEST_DE_SEL_PLLTEST_DE_FVAL                                    0x1

#define HWIO_GCC_PLLTEST_PAD_CFG_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00052044)
#define HWIO_GCC_PLLTEST_PAD_CFG_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052044)
#define HWIO_GCC_PLLTEST_PAD_CFG_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052044)
#define HWIO_GCC_PLLTEST_PAD_CFG_RMSK                                                                   0x3ffffff
#define HWIO_GCC_PLLTEST_PAD_CFG_ATTR                                                                         0x3
#define HWIO_GCC_PLLTEST_PAD_CFG_IN          \
        in_dword_masked(HWIO_GCC_PLLTEST_PAD_CFG_ADDR, HWIO_GCC_PLLTEST_PAD_CFG_RMSK)
#define HWIO_GCC_PLLTEST_PAD_CFG_INM(m)      \
        in_dword_masked(HWIO_GCC_PLLTEST_PAD_CFG_ADDR, m)
#define HWIO_GCC_PLLTEST_PAD_CFG_OUT(v)      \
        out_dword(HWIO_GCC_PLLTEST_PAD_CFG_ADDR,v)
#define HWIO_GCC_PLLTEST_PAD_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLLTEST_PAD_CFG_ADDR,m,v,HWIO_GCC_PLLTEST_PAD_CFG_IN)
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_BMSK                                                        0x3000000
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_SHFT                                                             0x18
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_NONE_FVAL                                                         0x0
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_PULLDOWN_FVAL                                                     0x1
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_KEEP_FVAL                                                         0x2
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_B_PULLUP_FVAL                                                       0x3
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS23_20_BMSK                                                  0xf00000
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS23_20_SHFT                                                      0x14
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_EN_BMSK                                                         0x80000
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_EN_SHFT                                                            0x13
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_EN_DISABLE_FVAL                                                     0x0
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_PLL_EN_ENABLE_FVAL                                                      0x1
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT18_BMSK                                                       0x40000
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT18_SHFT                                                          0x12
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_OE_BMSK                                                             0x20000
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_OE_SHFT                                                                0x11
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_OE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_OE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT16_BMSK                                                       0x10000
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT16_SHFT                                                          0x10
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_IE_BMSK                                                              0x8000
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_IE_SHFT                                                                 0xf
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_IE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_PLLTEST_PAD_CFG_CORE_IE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT14_BMSK                                                        0x4000
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BIT14_SHFT                                                           0xe
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_BMSK                                                               0x3800
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_SHFT                                                                  0xb
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_DRIVE_150MV_FVAL                                                      0x0
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_DRIVE_200MV_FVAL                                                      0x1
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_DRIVE_250MV_FVAL                                                      0x2
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_DRIVE_300MV_FVAL                                                      0x3
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_NEW_A_FVAL                                                            0x4
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_NEW_B_FVAL                                                            0x5
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_NEW_C_FVAL                                                            0x6
#define HWIO_GCC_PLLTEST_PAD_CFG_HDRIVE_NEW_D_FVAL                                                            0x7
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS10_6_BMSK                                                      0x7c0
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS10_6_SHFT                                                        0x6
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS5_0_BMSK                                                        0x3f
#define HWIO_GCC_PLLTEST_PAD_CFG_RESERVE_BITS5_0_SHFT                                                         0x0

#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00052048)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00052048)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00052048)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_RMSK                                                              0x3fffff
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ATTR                                                                   0x3
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_IN          \
        in_dword_masked(HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ADDR, HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_RMSK)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_INM(m)      \
        in_dword_masked(HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ADDR, m)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_OUT(v)      \
        out_dword(HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ADDR,v)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_ADDR,m,v,HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_IN)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CLR_CNT_BMSK                                                      0x200000
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CLR_CNT_SHFT                                                          0x15
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CLR_CNT_NO_RESET_CNT_FVAL                                              0x0
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CLR_CNT_RESET_CNT_FVAL                                                 0x1
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CNT_EN_BMSK                                                       0x100000
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CNT_EN_SHFT                                                           0x14
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CNT_EN_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_CNT_EN_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_XO_DIV4_TERM_CNT_BMSK                                              0xfffff
#define HWIO_GCC_CLOCK_FRQ_MEASURE_CTL_XO_DIV4_TERM_CNT_SHFT                                                  0x0

#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0005204c)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005204c)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005204c)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_RMSK                                                          0x3ffffff
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_ATTR                                                                0x1
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_IN          \
        in_dword_masked(HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_ADDR, HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_RMSK)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_ADDR, m)
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_XO_DIV4_CNT_DONE_BMSK                                         0x2000000
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_XO_DIV4_CNT_DONE_SHFT                                              0x19
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_MEASURE_CNT_BMSK                                              0x1ffffff
#define HWIO_GCC_CLOCK_FRQ_MEASURE_STATUS_MEASURE_CNT_SHFT                                                    0x0

#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00068040)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00068040)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00068040)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_RMSK                                                                     0x1
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ATTR                                                                     0x3
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_IN          \
        in_dword_masked(HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ADDR, HWIO_GCC_GDS_HW_CTRL_SW_OVRD_RMSK)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_INM(m)      \
        in_dword_masked(HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ADDR, m)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_OUT(v)      \
        out_dword(HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ADDR,v)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GDS_HW_CTRL_SW_OVRD_ADDR,m,v,HWIO_GCC_GDS_HW_CTRL_SW_OVRD_IN)
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_SW_OVERRIDE_BMSK                                                         0x1
#define HWIO_GCC_GDS_HW_CTRL_SW_OVRD_SW_OVERRIDE_SHFT                                                         0x0

#define HWIO_GCC_VTT_EN_TIMER_ADDR                                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006300c)
#define HWIO_GCC_VTT_EN_TIMER_PHYS                                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006300c)
#define HWIO_GCC_VTT_EN_TIMER_OFFS                                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006300c)
#define HWIO_GCC_VTT_EN_TIMER_RMSK                                                                        0xfffff
#define HWIO_GCC_VTT_EN_TIMER_ATTR                                                                            0x3
#define HWIO_GCC_VTT_EN_TIMER_IN          \
        in_dword_masked(HWIO_GCC_VTT_EN_TIMER_ADDR, HWIO_GCC_VTT_EN_TIMER_RMSK)
#define HWIO_GCC_VTT_EN_TIMER_INM(m)      \
        in_dword_masked(HWIO_GCC_VTT_EN_TIMER_ADDR, m)
#define HWIO_GCC_VTT_EN_TIMER_OUT(v)      \
        out_dword(HWIO_GCC_VTT_EN_TIMER_ADDR,v)
#define HWIO_GCC_VTT_EN_TIMER_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VTT_EN_TIMER_ADDR,m,v,HWIO_GCC_VTT_EN_TIMER_IN)
#define HWIO_GCC_VTT_EN_TIMER_PVC_LOAD_VALUE_BMSK                                                         0xfffff
#define HWIO_GCC_VTT_EN_TIMER_PVC_LOAD_VALUE_SHFT                                                             0x0

#define HWIO_GCC_VREF_EN_TIMER_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00063010)
#define HWIO_GCC_VREF_EN_TIMER_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00063010)
#define HWIO_GCC_VREF_EN_TIMER_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00063010)
#define HWIO_GCC_VREF_EN_TIMER_RMSK                                                                      0x3fffff
#define HWIO_GCC_VREF_EN_TIMER_ATTR                                                                           0x3
#define HWIO_GCC_VREF_EN_TIMER_IN          \
        in_dword_masked(HWIO_GCC_VREF_EN_TIMER_ADDR, HWIO_GCC_VREF_EN_TIMER_RMSK)
#define HWIO_GCC_VREF_EN_TIMER_INM(m)      \
        in_dword_masked(HWIO_GCC_VREF_EN_TIMER_ADDR, m)
#define HWIO_GCC_VREF_EN_TIMER_OUT(v)      \
        out_dword(HWIO_GCC_VREF_EN_TIMER_ADDR,v)
#define HWIO_GCC_VREF_EN_TIMER_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VREF_EN_TIMER_ADDR,m,v,HWIO_GCC_VREF_EN_TIMER_IN)
#define HWIO_GCC_VREF_EN_TIMER_MAX_INDEX_BMSK                                                            0x300000
#define HWIO_GCC_VREF_EN_TIMER_MAX_INDEX_SHFT                                                                0x14
#define HWIO_GCC_VREF_EN_TIMER_PVC_LOAD_VALUE_BMSK                                                        0xfffff
#define HWIO_GCC_VREF_EN_TIMER_PVC_LOAD_VALUE_SHFT                                                            0x0

#define HWIO_GCC_PLL_IS_ACTIVE_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00063018)
#define HWIO_GCC_PLL_IS_ACTIVE_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00063018)
#define HWIO_GCC_PLL_IS_ACTIVE_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00063018)
#define HWIO_GCC_PLL_IS_ACTIVE_RMSK                                                                          0x33
#define HWIO_GCC_PLL_IS_ACTIVE_ATTR                                                                           0x3
#define HWIO_GCC_PLL_IS_ACTIVE_IN          \
        in_dword_masked(HWIO_GCC_PLL_IS_ACTIVE_ADDR, HWIO_GCC_PLL_IS_ACTIVE_RMSK)
#define HWIO_GCC_PLL_IS_ACTIVE_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_IS_ACTIVE_ADDR, m)
#define HWIO_GCC_PLL_IS_ACTIVE_OUT(v)      \
        out_dword(HWIO_GCC_PLL_IS_ACTIVE_ADDR,v)
#define HWIO_GCC_PLL_IS_ACTIVE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_IS_ACTIVE_ADDR,m,v,HWIO_GCC_PLL_IS_ACTIVE_IN)
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL5_SEL_BMSK                                                                0x20
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL5_SEL_SHFT                                                                 0x5
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL4_SEL_BMSK                                                                0x10
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL4_SEL_SHFT                                                                 0x4
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL1_SEL_BMSK                                                                 0x2
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL1_SEL_SHFT                                                                 0x1
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL0_SEL_BMSK                                                                 0x1
#define HWIO_GCC_PLL_IS_ACTIVE_GPLL0_SEL_SHFT                                                                 0x0

#define HWIO_GCC_GDS_HW_CTRL_SPARE_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00068030)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00068030)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00068030)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_RMSK                                                                      0xff
#define HWIO_GCC_GDS_HW_CTRL_SPARE_ATTR                                                                       0x3
#define HWIO_GCC_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                                0xff
#define HWIO_GCC_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                                 0x0

#define HWIO_GCC_WCSS_PD_CLK_DIS_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00011104)
#define HWIO_GCC_WCSS_PD_CLK_DIS_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00011104)
#define HWIO_GCC_WCSS_PD_CLK_DIS_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00011104)
#define HWIO_GCC_WCSS_PD_CLK_DIS_RMSK                                                                         0x1
#define HWIO_GCC_WCSS_PD_CLK_DIS_ATTR                                                                         0x3
#define HWIO_GCC_WCSS_PD_CLK_DIS_IN          \
        in_dword_masked(HWIO_GCC_WCSS_PD_CLK_DIS_ADDR, HWIO_GCC_WCSS_PD_CLK_DIS_RMSK)
#define HWIO_GCC_WCSS_PD_CLK_DIS_INM(m)      \
        in_dword_masked(HWIO_GCC_WCSS_PD_CLK_DIS_ADDR, m)
#define HWIO_GCC_WCSS_PD_CLK_DIS_OUT(v)      \
        out_dword(HWIO_GCC_WCSS_PD_CLK_DIS_ADDR,v)
#define HWIO_GCC_WCSS_PD_CLK_DIS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_WCSS_PD_CLK_DIS_ADDR,m,v,HWIO_GCC_WCSS_PD_CLK_DIS_IN)
#define HWIO_GCC_WCSS_PD_CLK_DIS_SW_OVERRIDE_BMSK                                                             0x1
#define HWIO_GCC_WCSS_PD_CLK_DIS_SW_OVERRIDE_SHFT                                                             0x0

#define HWIO_GCC_SPARE0_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0005d000)
#define HWIO_GCC_SPARE0_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005d000)
#define HWIO_GCC_SPARE0_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005d000)
#define HWIO_GCC_SPARE0_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE0_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE0_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE0_REG_ADDR, HWIO_GCC_SPARE0_REG_RMSK)
#define HWIO_GCC_SPARE0_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE0_REG_ADDR, m)
#define HWIO_GCC_SPARE0_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE0_REG_ADDR,v)
#define HWIO_GCC_SPARE0_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE0_REG_ADDR,m,v,HWIO_GCC_SPARE0_REG_IN)
#define HWIO_GCC_SPARE0_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE0_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_SPARE1_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0005e000)
#define HWIO_GCC_SPARE1_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005e000)
#define HWIO_GCC_SPARE1_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005e000)
#define HWIO_GCC_SPARE1_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE1_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE1_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_REG_ADDR, HWIO_GCC_SPARE1_REG_RMSK)
#define HWIO_GCC_SPARE1_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_REG_ADDR, m)
#define HWIO_GCC_SPARE1_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_REG_ADDR,v)
#define HWIO_GCC_SPARE1_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_REG_ADDR,m,v,HWIO_GCC_SPARE1_REG_IN)
#define HWIO_GCC_SPARE1_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE1_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_SPARE2_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00071000)
#define HWIO_GCC_SPARE2_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00071000)
#define HWIO_GCC_SPARE2_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00071000)
#define HWIO_GCC_SPARE2_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE2_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE2_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE2_REG_ADDR, HWIO_GCC_SPARE2_REG_RMSK)
#define HWIO_GCC_SPARE2_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE2_REG_ADDR, m)
#define HWIO_GCC_SPARE2_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE2_REG_ADDR,v)
#define HWIO_GCC_SPARE2_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE2_REG_ADDR,m,v,HWIO_GCC_SPARE2_REG_IN)
#define HWIO_GCC_SPARE2_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE2_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_SPARE3_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00032000)
#define HWIO_GCC_SPARE3_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00032000)
#define HWIO_GCC_SPARE3_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00032000)
#define HWIO_GCC_SPARE3_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE3_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE3_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE3_REG_ADDR, HWIO_GCC_SPARE3_REG_RMSK)
#define HWIO_GCC_SPARE3_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE3_REG_ADDR, m)
#define HWIO_GCC_SPARE3_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE3_REG_ADDR,v)
#define HWIO_GCC_SPARE3_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE3_REG_ADDR,m,v,HWIO_GCC_SPARE3_REG_IN)
#define HWIO_GCC_SPARE3_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE3_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_SPARE4_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00003000)
#define HWIO_GCC_SPARE4_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00003000)
#define HWIO_GCC_SPARE4_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00003000)
#define HWIO_GCC_SPARE4_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE4_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE4_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE4_REG_ADDR, HWIO_GCC_SPARE4_REG_RMSK)
#define HWIO_GCC_SPARE4_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE4_REG_ADDR, m)
#define HWIO_GCC_SPARE4_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE4_REG_ADDR,v)
#define HWIO_GCC_SPARE4_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE4_REG_ADDR,m,v,HWIO_GCC_SPARE4_REG_IN)
#define HWIO_GCC_SPARE4_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE4_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_SPARE5_REG_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002e000)
#define HWIO_GCC_SPARE5_REG_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002e000)
#define HWIO_GCC_SPARE5_REG_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002e000)
#define HWIO_GCC_SPARE5_REG_RMSK                                                                       0xffffffff
#define HWIO_GCC_SPARE5_REG_ATTR                                                                              0x3
#define HWIO_GCC_SPARE5_REG_IN          \
        in_dword_masked(HWIO_GCC_SPARE5_REG_ADDR, HWIO_GCC_SPARE5_REG_RMSK)
#define HWIO_GCC_SPARE5_REG_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE5_REG_ADDR, m)
#define HWIO_GCC_SPARE5_REG_OUT(v)      \
        out_dword(HWIO_GCC_SPARE5_REG_ADDR,v)
#define HWIO_GCC_SPARE5_REG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE5_REG_ADDR,m,v,HWIO_GCC_SPARE5_REG_IN)
#define HWIO_GCC_SPARE5_REG_SPARE_BITS_BMSK                                                            0xffffffff
#define HWIO_GCC_SPARE5_REG_SPARE_BITS_SHFT                                                                   0x0

#define HWIO_GCC_GPU_MISC_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00061028)
#define HWIO_GCC_GPU_MISC_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061028)
#define HWIO_GCC_GPU_MISC_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061028)
#define HWIO_GCC_GPU_MISC_RMSK                                                                                0x3
#define HWIO_GCC_GPU_MISC_ATTR                                                                                0x3
#define HWIO_GCC_GPU_MISC_IN          \
        in_dword_masked(HWIO_GCC_GPU_MISC_ADDR, HWIO_GCC_GPU_MISC_RMSK)
#define HWIO_GCC_GPU_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MISC_ADDR, m)
#define HWIO_GCC_GPU_MISC_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MISC_ADDR,v)
#define HWIO_GCC_GPU_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MISC_ADDR,m,v,HWIO_GCC_GPU_MISC_IN)
#define HWIO_GCC_GPU_MISC_GPLL0_SRC_DISABLE_BMSK                                                              0x2
#define HWIO_GCC_GPU_MISC_GPLL0_SRC_DISABLE_SHFT                                                              0x1
#define HWIO_GCC_GPU_MISC_GPLL0_SRC_DISABLE_ENABLE_FVAL                                                       0x0
#define HWIO_GCC_GPU_MISC_GPLL0_SRC_DISABLE_DISABLE_FVAL                                                      0x1
#define HWIO_GCC_GPU_MISC_GPLL0_DIV_SRC_DISABLE_BMSK                                                          0x1
#define HWIO_GCC_GPU_MISC_GPLL0_DIV_SRC_DISABLE_SHFT                                                          0x0
#define HWIO_GCC_GPU_MISC_GPLL0_DIV_SRC_DISABLE_ENABLE_FVAL                                                   0x0
#define HWIO_GCC_GPU_MISC_GPLL0_DIV_SRC_DISABLE_DISABLE_FVAL                                                  0x1

#define HWIO_GCC_TME_MISC_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00024114)
#define HWIO_GCC_TME_MISC_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00024114)
#define HWIO_GCC_TME_MISC_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00024114)
#define HWIO_GCC_TME_MISC_RMSK                                                                                0x2
#define HWIO_GCC_TME_MISC_ATTR                                                                                0x3
#define HWIO_GCC_TME_MISC_IN          \
        in_dword_masked(HWIO_GCC_TME_MISC_ADDR, HWIO_GCC_TME_MISC_RMSK)
#define HWIO_GCC_TME_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_MISC_ADDR, m)
#define HWIO_GCC_TME_MISC_OUT(v)      \
        out_dword(HWIO_GCC_TME_MISC_ADDR,v)
#define HWIO_GCC_TME_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_MISC_ADDR,m,v,HWIO_GCC_TME_MISC_IN)
#define HWIO_GCC_TME_MISC_GPLL0_SRC_DISABLE_BMSK                                                              0x2
#define HWIO_GCC_TME_MISC_GPLL0_SRC_DISABLE_SHFT                                                              0x1
#define HWIO_GCC_TME_MISC_GPLL0_SRC_DISABLE_ENABLE_FVAL                                                       0x0
#define HWIO_GCC_TME_MISC_GPLL0_SRC_DISABLE_DISABLE_FVAL                                                      0x1

#define HWIO_GCC_DDRSS_MISC_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00034428)
#define HWIO_GCC_DDRSS_MISC_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00034428)
#define HWIO_GCC_DDRSS_MISC_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00034428)
#define HWIO_GCC_DDRSS_MISC_RMSK                                                                              0x2
#define HWIO_GCC_DDRSS_MISC_ATTR                                                                              0x3
#define HWIO_GCC_DDRSS_MISC_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MISC_ADDR, HWIO_GCC_DDRSS_MISC_RMSK)
#define HWIO_GCC_DDRSS_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MISC_ADDR, m)
#define HWIO_GCC_DDRSS_MISC_OUT(v)      \
        out_dword(HWIO_GCC_DDRSS_MISC_ADDR,v)
#define HWIO_GCC_DDRSS_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DDRSS_MISC_ADDR,m,v,HWIO_GCC_DDRSS_MISC_IN)
#define HWIO_GCC_DDRSS_MISC_GPLL0_SRC_DISABLE_BMSK                                                            0x2
#define HWIO_GCC_DDRSS_MISC_GPLL0_SRC_DISABLE_SHFT                                                            0x1
#define HWIO_GCC_DDRSS_MISC_GPLL0_SRC_DISABLE_ENABLE_FVAL                                                     0x0
#define HWIO_GCC_DDRSS_MISC_GPLL0_SRC_DISABLE_DISABLE_FVAL                                                    0x1

#define HWIO_GCC_DDRSS_MC_MISC_STATUS_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0003442c)
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003442c)
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003442c)
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_RMSK                                                                    0xe
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_ATTR                                                                    0x1
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_IN          \
        in_dword_masked(HWIO_GCC_DDRSS_MC_MISC_STATUS_ADDR, HWIO_GCC_DDRSS_MC_MISC_STATUS_RMSK)
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_DDRSS_MC_MISC_STATUS_ADDR, m)
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_COMPLETE_BMSK                                                     0x8
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_COMPLETE_SHFT                                                     0x3
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_COMPLETE_ENABLE_FVAL                                              0x0
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_COMPLETE_DISABLE_FVAL                                             0x1
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_UNSTALL_BMSK                                                            0x4
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_UNSTALL_SHFT                                                            0x2
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_UNSTALL_ENABLE_FVAL                                                     0x0
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_UNSTALL_DISABLE_FVAL                                                    0x1
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_REQ_BMSK                                                          0x2
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_REQ_SHFT                                                          0x1
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_REQ_ENABLE_FVAL                                                   0x0
#define HWIO_GCC_DDRSS_MC_MISC_STATUS_STALL_REQ_DISABLE_FVAL                                                  0x1

#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b000)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b000)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b000)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_RMSK                                                             0x80000001
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ATTR                                                                    0x3
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b004)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b004)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b004)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ATTR                                                                   0x3
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b008)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b008)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b008)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b00c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b00c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b00c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b010)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b010)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b010)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                               0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                      0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                       0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                             0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                           0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                           0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b014)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b014)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b014)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                            0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b018)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b018)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b018)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b020)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b020)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b020)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                             0x3
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b028)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b028)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b028)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                                0x3
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b02c)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b02c)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b02c)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_RMSK                                                              0x80000001
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ATTR                                                                     0x3
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_TZ_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b03c)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b03c)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b03c)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_RMSK                                                             0x80000001
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ATTR                                                                    0x3
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                      0x80000000
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                            0x1f
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                        0x1
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                        0x0
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_TZ_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b040)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b040)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b040)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_RMSK                                                            0x80000001
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ATTR                                                                   0x3
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                     0x80000000
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                           0x1f
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                       0x1
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                       0x0
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_TZ_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b044)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b044)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b044)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b048)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b048)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b048)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b04c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b04c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b04c)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                               0x80000001
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                      0x3
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                        0x80000000
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                              0x1f
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                          0x1
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                          0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TZ_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b050)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b050)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b050)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b054)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b054)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b054)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                     0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                            0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                              0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                    0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                                0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                                0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b05c)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b05c)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b05c)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                      0x80000001
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                             0x3
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                               0x80000000
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                     0x1f
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                                 0x1
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                                 0x0
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TZ_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b064)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b064)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b064)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                         0x80000001
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                                0x3
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                                  0x80000000
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                        0x1f
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                    0x1
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                    0x0
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_TZ_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b068)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b068)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b068)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_RMSK                                                              0x80000001
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ATTR                                                                     0x3
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                       0x80000000
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                             0x1f
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                         0x1
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                         0x0
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_TZ_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b070)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b070)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b070)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006b078)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006b078)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006b078)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                          0x3
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_TZ_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c000)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c000)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c000)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ATTR                                                                   0x3
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c004)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c004)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c004)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_RMSK                                                           0x80000001
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ATTR                                                                  0x3
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c008)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c008)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c008)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c00c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c00c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c00c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c010)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c010)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c010)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                              0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                     0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                      0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                            0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                          0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                          0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c014)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c014)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c014)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                    0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                           0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                            0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                  0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                                0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                                0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c018)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c018)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c018)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c020)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c020)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c020)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                            0x3
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c028)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c028)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c028)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                        0x80000001
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                               0x3
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c02c)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c02c)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c02c)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_RMSK                                                             0x80000001
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ATTR                                                                    0x3
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_HYP_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c03c)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c03c)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c03c)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_RMSK                                                            0x80000001
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ATTR                                                                   0x3
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                     0x80000000
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                           0x1f
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                       0x1
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                       0x0
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HYP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c040)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c040)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c040)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_RMSK                                                           0x80000001
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ATTR                                                                  0x3
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                    0x80000000
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                          0x1f
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                      0x1
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                      0x0
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_HYP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c044)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c044)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c044)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c048)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c048)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c048)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c04c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c04c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c04c)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                              0x80000001
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                     0x3
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                       0x80000000
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                             0x1f
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                         0x1
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                         0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_HYP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c050)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c050)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c050)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c054)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c054)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c054)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                    0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                           0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                             0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                   0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                               0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                               0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c05c)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c05c)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c05c)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                     0x80000001
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                            0x3
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                              0x80000000
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                    0x1f
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                                0x1
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                                0x0
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_HYP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c064)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c064)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c064)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                        0x80000001
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                               0x3
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                                 0x80000000
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                       0x1f
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                   0x1
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                   0x0
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_HYP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c068)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c068)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c068)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_RMSK                                                             0x80000001
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ATTR                                                                    0x3
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                      0x80000000
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                            0x1f
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                        0x1
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                        0x0
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c070)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c070)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c070)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006c078)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006c078)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006c078)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                         0x3
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HYP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d000)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d000)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d000)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_RMSK                                                          0x80000001
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ATTR                                                                 0x3
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d004)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d004)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d004)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ATTR                                                                0x3
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d008)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d008)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d008)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d00c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d00c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d00c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d010)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d010)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d010)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                            0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                   0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                    0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                          0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                        0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                        0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                 0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d014)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d014)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d014)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                         0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d018)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d018)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d018)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d020)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d020)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d020)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                          0x3
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d028)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d028)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d028)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                             0x3
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d02c)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d02c)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d02c)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_RMSK                                                           0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ATTR                                                                  0x3
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d03c)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d03c)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d03c)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_RMSK                                                          0x80000001
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ATTR                                                                 0x3
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                   0x80000000
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                         0x1f
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                     0x1
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                     0x0
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_HLOS1_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d040)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d040)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d040)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_RMSK                                                         0x80000001
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ATTR                                                                0x3
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                  0x80000000
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                        0x1f
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                    0x1
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                    0x0
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_HLOS1_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d044)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d044)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d044)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d048)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d048)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d048)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d04c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d04c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d04c)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                            0x80000001
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                   0x3
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                     0x80000000
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                           0x1f
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                       0x1
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                       0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                               0x0
#define HWIO_GCC_HLOS1_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d050)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d050)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d050)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d054)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d054)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d054)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                         0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d05c)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d05c)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d05c)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                          0x3
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HLOS1_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d064)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d064)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d064)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                      0x80000001
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                             0x3
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                               0x80000000
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                     0x1f
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                 0x1
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                 0x0
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_HLOS1_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d068)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d068)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d068)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_RMSK                                                           0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ATTR                                                                  0x3
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                    0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                          0x1f
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                      0x1
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                      0x0
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_HLOS1_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d070)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d070)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d070)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006d078)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006d078)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006d078)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS1_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e000)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e000)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e000)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_RMSK                                                          0x80000001
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ATTR                                                                 0x3
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                  0x80000000
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                        0x1f
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                      0x1
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                      0x0
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e004)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e004)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e004)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ATTR                                                                0x3
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e008)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e008)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e008)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e00c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e00c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e00c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e010)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e010)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e010)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                            0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                   0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                    0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                          0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                        0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                        0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                 0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e014)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e014)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e014)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                         0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e018)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e018)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e018)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e020)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e020)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e020)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                          0x3
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e028)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e028)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e028)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                             0x3
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e02c)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e02c)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e02c)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_RMSK                                                           0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ATTR                                                                  0x3
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e03c)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e03c)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e03c)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_RMSK                                                          0x80000001
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ATTR                                                                 0x3
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                   0x80000000
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                         0x1f
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                     0x1
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                     0x0
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_HLOS2_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e040)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e040)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e040)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_RMSK                                                         0x80000001
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ATTR                                                                0x3
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                  0x80000000
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                        0x1f
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                    0x1
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                    0x0
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_HLOS2_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e044)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e044)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e044)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e048)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e048)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e048)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e04c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e04c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e04c)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                            0x80000001
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                   0x3
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                     0x80000000
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                           0x1f
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                       0x1
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                       0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                               0x0
#define HWIO_GCC_HLOS2_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e050)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e050)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e050)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e054)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e054)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e054)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                         0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e05c)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e05c)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e05c)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                          0x3
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_HLOS2_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e064)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e064)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e064)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                      0x80000001
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                             0x3
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                               0x80000000
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                     0x1f
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                 0x1
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                 0x0
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_HLOS2_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e068)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e068)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e068)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_RMSK                                                           0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ATTR                                                                  0x3
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                    0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                          0x1f
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                      0x1
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                      0x0
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_HLOS2_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e070)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e070)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e070)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                        0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                              0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                            0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                            0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0006e078)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0006e078)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0006e078)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                0x80000001
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                       0x3
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                         0x80000000
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                               0x1f
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                           0x1
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                           0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_HLOS2_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c484)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c484)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c484)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_RMSK                                                                0xffffbfff
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_ATTR                                                                       0x3
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_MMNOC_GDS_HW_CTRL_IN)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_PWR_ON_STATUS_BMSK                                                  0x80000000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_PWR_ON_STATUS_SHFT                                                        0x1f
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_RESERVE_30_29_BMSK                                                  0x60000000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_RESERVE_30_29_SHFT                                                        0x1d
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_HYS_TIMER_BMSK                                                      0x1fe00000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_HYS_TIMER_SHFT                                                            0x15
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_MAX_RETRY_BMSK                                                        0x1e0000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_MAX_RETRY_SHFT                                                            0x11
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_DENY_ENABLE_BMSK                                                       0x10000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_DENY_ENABLE_SHFT                                                          0x10
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_COLLAPSE_OUT_BMSK                                                       0x8000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_COLLAPSE_OUT_SHFT                                                          0xf
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_HALT_ACK_TIMEOUT_BMSK                                                   0x3fc0
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_HALT_ACK_TIMEOUT_SHFT                                                      0x6
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_GDS_HW_STATE_BMSK                                                         0x3e
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_GDS_HW_STATE_SHFT                                                          0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SW_OVERRIDE_BMSK                                                           0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SW_OVERRIDE_SHFT                                                           0x0

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c488)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c488)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c488)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_RMSK                                                            0xfffff
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_ATTR                                                                0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_BMSK                                           0xc0000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_SHFT                                              0x12
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_BMSK                                           0x20000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_SHFT                                              0x11
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_BMSK                                       0x18000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_SHFT                                           0xf
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_BMSK                                  0x4000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_SHFT                                     0xe
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_BMSK                               0x3000
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_SHFT                                  0xc
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_BMSK                                  0xc00
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_SHFT                                    0xa
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_BMSK                                    0x200
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_SHFT                                      0x9
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_BMSK                                      0x100
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_SHFT                                        0x8
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_BMSK                                     0xc0
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_SHFT                                      0x6
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_BMSK                                0x30
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_SHFT                                 0x4
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_BMSK                                     0xc
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_SHFT                                     0x2
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_BMSK                                        0x3
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_SHFT                                        0x0

#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c48c)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c48c)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c48c)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_RMSK                                                          0x1ffff
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ATTR                                                              0x3
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ADDR, HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_IN)
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_RESERVE_4_15_BMSK                                             0x1ffe0
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_RESERVE_4_15_SHFT                                                 0x5
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_BMSK                                                0x18
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_SHFT                                                 0x3
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_BMSK                                             0x6
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_SHFT                                             0x1
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_BMSK                                                 0x1
#define HWIO_GCC_MMNOC_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_SHFT                                                 0x0

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c490)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c490)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c490)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_RMSK                                                            0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_ATTR                                                            0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_STATUS_BMSK                                                     0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_STATUS_STATUS_SHFT                                                     0x0

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c494)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c494)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c494)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_RMSK                                                              0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ATTR                                                              0x3
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ADDR,v)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_ADDR,m,v,HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_IN)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_MASK_BMSK                                                         0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_MASK_MASK_SHFT                                                         0x0

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c498)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c498)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c498)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_RMSK                                                             0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ATTR                                                             0x3
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ADDR,v)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_ADDR,m,v,HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_IN)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_BMSK                                                       0x1
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_SHFT                                                       0x0

#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c49c)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c49c)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c49c)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_RMSK                                                                0xff
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ATTR                                                                 0x3
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                          0xff
#define HWIO_GCC_MMNOC_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                           0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0000015c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000015c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000015c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_RMSK                                                            0xffffbfff
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ATTR                                                                   0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IN)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_PWR_ON_STATUS_BMSK                                              0x80000000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_PWR_ON_STATUS_SHFT                                                    0x1f
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_RESERVE_30_29_BMSK                                              0x60000000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_RESERVE_30_29_SHFT                                                    0x1d
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_HYS_TIMER_BMSK                                                  0x1fe00000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_HYS_TIMER_SHFT                                                        0x15
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_MAX_RETRY_BMSK                                                    0x1e0000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_MAX_RETRY_SHFT                                                        0x11
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_DENY_ENABLE_BMSK                                                   0x10000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_DENY_ENABLE_SHFT                                                      0x10
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_COLLAPSE_OUT_BMSK                                                   0x8000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_COLLAPSE_OUT_SHFT                                                      0xf
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_HALT_ACK_TIMEOUT_BMSK                                               0x3fc0
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_HALT_ACK_TIMEOUT_SHFT                                                  0x6
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_GDS_HW_STATE_BMSK                                                     0x3e
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_GDS_HW_STATE_SHFT                                                      0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SW_OVERRIDE_SHFT                                                       0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00000160)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000160)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000160)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RMSK                                                     0xffffffff
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ATTR                                                            0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_IN)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_24_31_BMSK                                       0xff000000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_24_31_SHFT                                             0x18
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_BMSK                                      0x800000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_SHFT                                          0x17
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_BMSK                                      0x400000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_SHFT                                          0x16
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_BMSK                                  0x200000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_SHFT                                      0x15
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_BMSK                         0x100000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_SHFT                             0x14
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_19_BMSK                                             0x80000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_19_SHFT                                                0x13
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_BMSK                            0x40000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_SHFT                               0x12
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_13_17_BMSK                                          0x3e000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_13_17_SHFT                                              0xd
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_BMSK                               0x1000
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_SHFT                                  0xc
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_6_11_BMSK                                             0xfc0
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_RESERVE_6_11_SHFT                                               0x6
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_BMSK                                0x20
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_SHFT                                 0x5
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_BMSK                                   0x10
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_SHFT                                    0x4
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_BMSK                                  0x8
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_SHFT                                  0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_BMSK                             0x4
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_SHFT                             0x2
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_BMSK                                 0x2
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_SHFT                                 0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_BMSK                                    0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_SHFT                                    0x0

#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00000464)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000464)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000464)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_RMSK                                                       0xffff
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ATTR                                                          0x3
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ADDR, HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_IN)
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_BMSK                                          0xfff8
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_SHFT                                             0x3
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_BMSK                                             0x4
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_SHFT                                             0x2
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_BMSK                                         0x2
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_SHFT                                         0x1
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_BMSK                                             0x1
#define HWIO_GCC_ANOC_PCIE_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_SHFT                                             0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00000468)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000468)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000468)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_RMSK                                                        0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_ATTR                                                        0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_STATUS_BMSK                                                 0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_STATUS_STATUS_SHFT                                                 0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0000046c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000046c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000046c)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_RMSK                                                          0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ATTR                                                          0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_IN)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_MASK_BMSK                                                     0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_MASK_MASK_SHFT                                                     0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00000470)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000470)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000470)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_RMSK                                                         0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ATTR                                                         0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_IN)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_BMSK                                                   0x1
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_SHFT                                                   0x0

#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00000474)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000474)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000474)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_RMSK                                                            0xff
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ATTR                                                             0x3
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                      0xff
#define HWIO_GCC_ANOC_PCIE_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                       0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008915c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008915c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008915c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_RMSK                                                           0xffffbfff
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ATTR                                                                  0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IN)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_PWR_ON_STATUS_BMSK                                             0x80000000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_PWR_ON_STATUS_SHFT                                                   0x1f
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_RESERVE_30_29_BMSK                                             0x60000000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_RESERVE_30_29_SHFT                                                   0x1d
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_HYS_TIMER_BMSK                                                 0x1fe00000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_HYS_TIMER_SHFT                                                       0x15
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_MAX_RETRY_BMSK                                                   0x1e0000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_MAX_RETRY_SHFT                                                       0x11
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_DENY_ENABLE_BMSK                                                  0x10000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_DENY_ENABLE_SHFT                                                     0x10
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_COLLAPSE_OUT_BMSK                                                  0x8000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_COLLAPSE_OUT_SHFT                                                     0xf
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_HALT_ACK_TIMEOUT_BMSK                                              0x3fc0
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_HALT_ACK_TIMEOUT_SHFT                                                 0x6
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_GDS_HW_STATE_BMSK                                                    0x3e
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_GDS_HW_STATE_SHFT                                                     0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SW_OVERRIDE_BMSK                                                      0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SW_OVERRIDE_SHFT                                                      0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00089160)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089160)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089160)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RMSK                                                    0xfffffffb
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ATTR                                                           0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_ADDR,m,v,HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_IN)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_24_31_BMSK                                      0xff000000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_24_31_SHFT                                            0x18
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_BMSK                                     0x800000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_SHFT                                         0x17
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_BMSK                                     0x400000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_SHFT                                         0x16
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_BMSK                                 0x200000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_SHFT                                     0x15
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_BMSK                        0x100000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_SHFT                            0x14
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_19_BMSK                                            0x80000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_19_SHFT                                               0x13
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_BMSK                           0x40000
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_SHFT                              0x12
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_8_17_BMSK                                          0x3ff00
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_RESERVE_8_17_SHFT                                              0x8
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_BMSK                                0x80
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_SHFT                                 0x7
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_BMSK                               0x40
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_SHFT                                0x6
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_BMSK                                  0x20
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_SHFT                                   0x5
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_BMSK                                0x10
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_SHFT                                 0x4
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_BMSK                            0x8
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_SHFT                            0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_BMSK                                0x2
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_SHFT                                0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_BMSK                                   0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_SHFT                                   0x0

#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00089464)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089464)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089464)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_RMSK                                                      0xffff
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ATTR                                                         0x3
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ADDR, HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_IN)
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_BMSK                                         0xfff8
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_SHFT                                            0x3
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_BMSK                                            0x4
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_SHFT                                            0x2
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_BMSK                                        0x2
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_SHFT                                        0x1
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_BMSK                                            0x1
#define HWIO_GCC_TURING_QTB_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_SHFT                                            0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00089468)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089468)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089468)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_RMSK                                                       0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_ATTR                                                       0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_STATUS_BMSK                                                0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_STATUS_STATUS_SHFT                                                0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0008946c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008946c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008946c)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_RMSK                                                         0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ATTR                                                         0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR,m,v,HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_IN)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_MASK_BMSK                                                    0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_MASK_MASK_SHFT                                                    0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00089470)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089470)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089470)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_RMSK                                                        0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ATTR                                                        0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR,m,v,HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_IN)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_BMSK                                                  0x1
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_SHFT                                                  0x0

#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00089474)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089474)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089474)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_RMSK                                                           0xff
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ATTR                                                            0x3
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                     0xff
#define HWIO_GCC_TURING_QTB_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                      0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f000)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f000)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f000)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_RMSK                                                            0xffffbfff
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ATTR                                                                   0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IN)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_PWR_ON_STATUS_BMSK                                              0x80000000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_PWR_ON_STATUS_SHFT                                                    0x1f
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_RESERVE_30_29_BMSK                                              0x60000000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_RESERVE_30_29_SHFT                                                    0x1d
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_HYS_TIMER_BMSK                                                  0x1fe00000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_HYS_TIMER_SHFT                                                        0x15
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_MAX_RETRY_BMSK                                                    0x1e0000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_MAX_RETRY_SHFT                                                        0x11
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_DENY_ENABLE_BMSK                                                   0x10000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_DENY_ENABLE_SHFT                                                      0x10
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_COLLAPSE_OUT_BMSK                                                   0x8000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_COLLAPSE_OUT_SHFT                                                      0xf
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_HALT_ACK_TIMEOUT_BMSK                                               0x3fc0
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_HALT_ACK_TIMEOUT_SHFT                                                  0x6
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_GDS_HW_STATE_BMSK                                                     0x3e
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_GDS_HW_STATE_SHFT                                                      0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SW_OVERRIDE_BMSK                                                       0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SW_OVERRIDE_SHFT                                                       0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f004)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f004)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f004)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RMSK                                                     0xfffffffb
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ATTR                                                            0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_IN)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_24_31_BMSK                                       0xff000000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_24_31_SHFT                                             0x18
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_BMSK                                      0x800000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_REQ_STATUS_SHFT                                          0x17
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_BMSK                                      0x400000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_REQ_STATUS_SHFT                                          0x16
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_BMSK                                  0x200000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_REQ_STATUS_SHFT                                      0x15
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_BMSK                         0x100000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_ACK_STATUS_SHFT                             0x14
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_19_BMSK                                             0x80000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_19_SHFT                                                0x13
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_BMSK                            0x40000
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_UP_ACK_STATUS_SHFT                               0x12
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_8_17_BMSK                                           0x3ff00
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_RESERVE_8_17_SHFT                                               0x8
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_BMSK                                 0x80
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_ACK_STATUS_SHFT                                  0x7
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_BMSK                                0x40
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_DOWN_DENY_STATUS_SHFT                                 0x6
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_BMSK                                   0x20
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT2_PWR_UP_ACK_STATUS_SHFT                                    0x5
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_BMSK                                 0x10
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_ACK_STATUS_SHFT                                  0x4
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_BMSK                             0x8
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_DVM_HALT1_PWR_DOWN_DENY_STATUS_SHFT                             0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_BMSK                                 0x2
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_DOWN_DENY_STATUS_SHFT                                 0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_BMSK                                    0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_STATUS_HALT1_PWR_UP_ACK_STATUS_SHFT                                    0x0

#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f008)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f008)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f008)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_RMSK                                                       0xffff
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ATTR                                                          0x3
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ADDR, HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_RMSK)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ADDR, m)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ADDR,v)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_ADDR,m,v,HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_IN)
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_BMSK                                          0xfff8
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_RESERVE_3_15_SHFT                                             0x3
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_BMSK                                             0x4
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_DVM_HALT_REQ_SHFT                                             0x2
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_BMSK                                         0x2
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_MMU_QTB_HALT_REQ_SHFT                                         0x1
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_BMSK                                             0x1
#define HWIO_GCC_LPASS_QTB_HALT_REQ_GDS_HW_CTRL_NOC_HALT_REQ_SHFT                                             0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f00c)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f00c)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f00c)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_RMSK                                                        0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_ATTR                                                        0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_STATUS_BMSK                                                 0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_STATUS_STATUS_SHFT                                                 0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f010)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f010)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f010)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_RMSK                                                          0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ATTR                                                          0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_IN)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_MASK_BMSK                                                     0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_MASK_MASK_SHFT                                                     0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f014)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f014)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f014)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_RMSK                                                         0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ATTR                                                         0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_IN)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_BMSK                                                   0x1
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_IRQ_CLEAR_CLEAR_SHFT                                                   0x0

#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f018)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f018)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f018)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_RMSK                                                            0xff
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ATTR                                                             0x3
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                      0xff
#define HWIO_GCC_LPASS_QTB_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                       0x0

#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00080890)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00080890)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00080890)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_RMSK                                                             0xff
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ATTR                                                              0x3
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_IN          \
        in_dword_masked(HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ADDR, HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_RMSK)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ADDR, m)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ADDR,v)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_ADDR,m,v,HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_IN)
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_SPARE_BMSK                                                       0xff
#define HWIO_GCC_ANOC_QTB_GDS_HW_CTRL_SPARE_SPARE_SHFT                                                        0x0

#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00080894)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00080894)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00080894)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_RMSK                                                             0x3ff
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ATTR                                                               0x3
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_IN          \
        in_dword_masked(HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ADDR, HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_RMSK)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ADDR, m)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ADDR,v)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_ADDR,m,v,HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_IN)
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_COUNT_BMSK                                                       0x3ff
#define HWIO_GCC_ANOC_QTB_RESET_CNTR_VALUE_COUNT_SHFT                                                         0x0

#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0008089c)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008089c)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008089c)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_RMSK                                                        0x3f
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ATTR                                                         0x3
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_IN          \
        in_dword_masked(HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ADDR, HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_RMSK)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ADDR, m)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ADDR,v)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_ADDR,m,v,HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_IN)
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_RESET_ALLOWED_BMSK                                          0x20
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_RESET_ALLOWED_SHFT                                           0x5
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_FSM_STATE_BMSK                                              0x1f
#define HWIO_GCC_ANOC_QTB_PWR_QCHANNEL_HANDSHAKE_FSM_STATE_SHFT                                               0x0

#define HWIO_GCC_ANOC_QTB_SREG_MISC_ADDR                                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00080480)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_PHYS                                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00080480)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_OFFS                                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00080480)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_RMSK                                                                      0x3
#define HWIO_GCC_ANOC_QTB_SREG_MISC_ATTR                                                                      0x3
#define HWIO_GCC_ANOC_QTB_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_ANOC_QTB_SREG_MISC_ADDR, HWIO_GCC_ANOC_QTB_SREG_MISC_RMSK)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_QTB_SREG_MISC_ADDR, m)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_QTB_SREG_MISC_ADDR,v)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_QTB_SREG_MISC_ADDR,m,v,HWIO_GCC_ANOC_QTB_SREG_MISC_IN)
#define HWIO_GCC_ANOC_QTB_SREG_MISC_QTB_2_MICRO_FORCE_MEM_CORE_ON_BMSK                                        0x2
#define HWIO_GCC_ANOC_QTB_SREG_MISC_QTB_2_MICRO_FORCE_MEM_CORE_ON_SHFT                                        0x1
#define HWIO_GCC_ANOC_QTB_SREG_MISC_QTB_1_MICRO_FORCE_MEM_CORE_ON_BMSK                                        0x1
#define HWIO_GCC_ANOC_QTB_SREG_MISC_QTB_1_MICRO_FORCE_MEM_CORE_ON_SHFT                                        0x0

#define HWIO_GCC_LPASS_SREG_MISC_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0008f01c)
#define HWIO_GCC_LPASS_SREG_MISC_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008f01c)
#define HWIO_GCC_LPASS_SREG_MISC_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008f01c)
#define HWIO_GCC_LPASS_SREG_MISC_RMSK                                                                         0x1
#define HWIO_GCC_LPASS_SREG_MISC_ATTR                                                                         0x3
#define HWIO_GCC_LPASS_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_LPASS_SREG_MISC_ADDR, HWIO_GCC_LPASS_SREG_MISC_RMSK)
#define HWIO_GCC_LPASS_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_SREG_MISC_ADDR, m)
#define HWIO_GCC_LPASS_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_SREG_MISC_ADDR,v)
#define HWIO_GCC_LPASS_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_SREG_MISC_ADDR,m,v,HWIO_GCC_LPASS_SREG_MISC_IN)
#define HWIO_GCC_LPASS_SREG_MISC_AUDIO_QTB_MICRO_FORCE_MEM_CORE_ON_BMSK                                       0x1
#define HWIO_GCC_LPASS_SREG_MISC_AUDIO_QTB_MICRO_FORCE_MEM_CORE_ON_SHFT                                       0x0

#define HWIO_GCC_MMNOC_SREG_MISC_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0000c480)
#define HWIO_GCC_MMNOC_SREG_MISC_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0000c480)
#define HWIO_GCC_MMNOC_SREG_MISC_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0000c480)
#define HWIO_GCC_MMNOC_SREG_MISC_RMSK                                                                         0x3
#define HWIO_GCC_MMNOC_SREG_MISC_ATTR                                                                         0x3
#define HWIO_GCC_MMNOC_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_MMNOC_SREG_MISC_ADDR, HWIO_GCC_MMNOC_SREG_MISC_RMSK)
#define HWIO_GCC_MMNOC_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_MMNOC_SREG_MISC_ADDR, m)
#define HWIO_GCC_MMNOC_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_MMNOC_SREG_MISC_ADDR,v)
#define HWIO_GCC_MMNOC_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMNOC_SREG_MISC_ADDR,m,v,HWIO_GCC_MMNOC_SREG_MISC_IN)
#define HWIO_GCC_MMNOC_SREG_MISC_HF_MICRO_FORCE_MEM_CORE_ON_BMSK                                              0x2
#define HWIO_GCC_MMNOC_SREG_MISC_HF_MICRO_FORCE_MEM_CORE_ON_SHFT                                              0x1
#define HWIO_GCC_MMNOC_SREG_MISC_SF_MICRO_FORCE_MEM_CORE_ON_BMSK                                              0x1
#define HWIO_GCC_MMNOC_SREG_MISC_SF_MICRO_FORCE_MEM_CORE_ON_SHFT                                              0x0

#define HWIO_GCC_ANOC_PCIE_SREG_MISC_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00000480)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00000480)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00000480)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_RMSK                                                                     0x1
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_ATTR                                                                     0x3
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_SREG_MISC_ADDR, HWIO_GCC_ANOC_PCIE_SREG_MISC_RMSK)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_ANOC_PCIE_SREG_MISC_ADDR, m)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_ANOC_PCIE_SREG_MISC_ADDR,v)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ANOC_PCIE_SREG_MISC_ADDR,m,v,HWIO_GCC_ANOC_PCIE_SREG_MISC_IN)
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_AGGRE_NOC_PCIE_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                          0x1
#define HWIO_GCC_ANOC_PCIE_SREG_MISC_AGGRE_NOC_PCIE_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                          0x0

#define HWIO_GCC_TURING_QTB_SREG_MISC_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00089494)
#define HWIO_GCC_TURING_QTB_SREG_MISC_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00089494)
#define HWIO_GCC_TURING_QTB_SREG_MISC_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00089494)
#define HWIO_GCC_TURING_QTB_SREG_MISC_RMSK                                                                    0x3
#define HWIO_GCC_TURING_QTB_SREG_MISC_ATTR                                                                    0x3
#define HWIO_GCC_TURING_QTB_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_TURING_QTB_SREG_MISC_ADDR, HWIO_GCC_TURING_QTB_SREG_MISC_RMSK)
#define HWIO_GCC_TURING_QTB_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_QTB_SREG_MISC_ADDR, m)
#define HWIO_GCC_TURING_QTB_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_TURING_QTB_SREG_MISC_ADDR,v)
#define HWIO_GCC_TURING_QTB_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_QTB_SREG_MISC_ADDR,m,v,HWIO_GCC_TURING_QTB_SREG_MISC_IN)
#define HWIO_GCC_TURING_QTB_SREG_MISC_QTB_1_MICRO_FORCE_MEM_CORE_ON_BMSK                                      0x2
#define HWIO_GCC_TURING_QTB_SREG_MISC_QTB_1_MICRO_FORCE_MEM_CORE_ON_SHFT                                      0x1
#define HWIO_GCC_TURING_QTB_SREG_MISC_QTB_0_MICRO_FORCE_MEM_CORE_ON_BMSK                                      0x1
#define HWIO_GCC_TURING_QTB_SREG_MISC_QTB_0_MICRO_FORCE_MEM_CORE_ON_SHFT                                      0x0

#define HWIO_GCC_MMU_TCU_SREG_MISC_ADDR                                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x00083480)
#define HWIO_GCC_MMU_TCU_SREG_MISC_PHYS                                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083480)
#define HWIO_GCC_MMU_TCU_SREG_MISC_OFFS                                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083480)
#define HWIO_GCC_MMU_TCU_SREG_MISC_RMSK                                                                       0x1
#define HWIO_GCC_MMU_TCU_SREG_MISC_ATTR                                                                       0x3
#define HWIO_GCC_MMU_TCU_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_MMU_TCU_SREG_MISC_ADDR, HWIO_GCC_MMU_TCU_SREG_MISC_RMSK)
#define HWIO_GCC_MMU_TCU_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_TCU_SREG_MISC_ADDR, m)
#define HWIO_GCC_MMU_TCU_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_MMU_TCU_SREG_MISC_ADDR,v)
#define HWIO_GCC_MMU_TCU_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_TCU_SREG_MISC_ADDR,m,v,HWIO_GCC_MMU_TCU_SREG_MISC_IN)
#define HWIO_GCC_MMU_TCU_SREG_MISC_MMU_TCU_MICRO_FORCE_MEM_CORE_ON_BMSK                                       0x1
#define HWIO_GCC_MMU_TCU_SREG_MISC_MMU_TCU_MICRO_FORCE_MEM_CORE_ON_SHFT                                       0x0

#define HWIO_GCC_CAMERA_SREG_MISC_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00016480)
#define HWIO_GCC_CAMERA_SREG_MISC_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016480)
#define HWIO_GCC_CAMERA_SREG_MISC_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016480)
#define HWIO_GCC_CAMERA_SREG_MISC_RMSK                                                                        0x3
#define HWIO_GCC_CAMERA_SREG_MISC_ATTR                                                                        0x3
#define HWIO_GCC_CAMERA_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_CAMERA_SREG_MISC_ADDR, HWIO_GCC_CAMERA_SREG_MISC_RMSK)
#define HWIO_GCC_CAMERA_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_CAMERA_SREG_MISC_ADDR, m)
#define HWIO_GCC_CAMERA_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_CAMERA_SREG_MISC_ADDR,v)
#define HWIO_GCC_CAMERA_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAMERA_SREG_MISC_ADDR,m,v,HWIO_GCC_CAMERA_SREG_MISC_IN)
#define HWIO_GCC_CAMERA_SREG_MISC_HF_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                         0x2
#define HWIO_GCC_CAMERA_SREG_MISC_HF_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                         0x1
#define HWIO_GCC_CAMERA_SREG_MISC_SF_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                         0x1
#define HWIO_GCC_CAMERA_SREG_MISC_SF_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                         0x0

#define HWIO_GCC_DISP_SREG_MISC_ADDR                                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00017480)
#define HWIO_GCC_DISP_SREG_MISC_PHYS                                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00017480)
#define HWIO_GCC_DISP_SREG_MISC_OFFS                                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00017480)
#define HWIO_GCC_DISP_SREG_MISC_RMSK                                                                          0x3
#define HWIO_GCC_DISP_SREG_MISC_ATTR                                                                          0x3
#define HWIO_GCC_DISP_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_DISP_SREG_MISC_ADDR, HWIO_GCC_DISP_SREG_MISC_RMSK)
#define HWIO_GCC_DISP_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_DISP_SREG_MISC_ADDR, m)
#define HWIO_GCC_DISP_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_DISP_SREG_MISC_ADDR,v)
#define HWIO_GCC_DISP_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DISP_SREG_MISC_ADDR,m,v,HWIO_GCC_DISP_SREG_MISC_IN)
#define HWIO_GCC_DISP_SREG_MISC_HF_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                           0x2
#define HWIO_GCC_DISP_SREG_MISC_HF_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                           0x1
#define HWIO_GCC_DISP_SREG_MISC_SF_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                           0x1
#define HWIO_GCC_DISP_SREG_MISC_SF_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                           0x0

#define HWIO_GCC_VIDEO_SREG_MISC_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00022480)
#define HWIO_GCC_VIDEO_SREG_MISC_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00022480)
#define HWIO_GCC_VIDEO_SREG_MISC_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00022480)
#define HWIO_GCC_VIDEO_SREG_MISC_RMSK                                                                         0x3
#define HWIO_GCC_VIDEO_SREG_MISC_ATTR                                                                         0x3
#define HWIO_GCC_VIDEO_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_VIDEO_SREG_MISC_ADDR, HWIO_GCC_VIDEO_SREG_MISC_RMSK)
#define HWIO_GCC_VIDEO_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_VIDEO_SREG_MISC_ADDR, m)
#define HWIO_GCC_VIDEO_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_VIDEO_SREG_MISC_ADDR,v)
#define HWIO_GCC_VIDEO_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_VIDEO_SREG_MISC_ADDR,m,v,HWIO_GCC_VIDEO_SREG_MISC_IN)
#define HWIO_GCC_VIDEO_SREG_MISC_AXI_1_MICRO_FORCE_MEM_CORE_ON_BMSK                                           0x2
#define HWIO_GCC_VIDEO_SREG_MISC_AXI_1_MICRO_FORCE_MEM_CORE_ON_SHFT                                           0x1
#define HWIO_GCC_VIDEO_SREG_MISC_AXI_0_MICRO_FORCE_MEM_CORE_ON_BMSK                                           0x1
#define HWIO_GCC_VIDEO_SREG_MISC_AXI_0_MICRO_FORCE_MEM_CORE_ON_SHFT                                           0x0

#define HWIO_GCC_PCIE_0_SREG_MISC_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0005b480)
#define HWIO_GCC_PCIE_0_SREG_MISC_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005b480)
#define HWIO_GCC_PCIE_0_SREG_MISC_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005b480)
#define HWIO_GCC_PCIE_0_SREG_MISC_RMSK                                                                        0x1
#define HWIO_GCC_PCIE_0_SREG_MISC_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_0_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_PCIE_0_SREG_MISC_ADDR, HWIO_GCC_PCIE_0_SREG_MISC_RMSK)
#define HWIO_GCC_PCIE_0_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_0_SREG_MISC_ADDR, m)
#define HWIO_GCC_PCIE_0_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_0_SREG_MISC_ADDR,v)
#define HWIO_GCC_PCIE_0_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_0_SREG_MISC_ADDR,m,v,HWIO_GCC_PCIE_0_SREG_MISC_IN)
#define HWIO_GCC_PCIE_0_SREG_MISC_MSTR_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                       0x1
#define HWIO_GCC_PCIE_0_SREG_MISC_MSTR_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                       0x0

#define HWIO_GCC_PCIE_1_SREG_MISC_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0007d480)
#define HWIO_GCC_PCIE_1_SREG_MISC_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007d480)
#define HWIO_GCC_PCIE_1_SREG_MISC_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007d480)
#define HWIO_GCC_PCIE_1_SREG_MISC_RMSK                                                                        0x1
#define HWIO_GCC_PCIE_1_SREG_MISC_ATTR                                                                        0x3
#define HWIO_GCC_PCIE_1_SREG_MISC_IN          \
        in_dword_masked(HWIO_GCC_PCIE_1_SREG_MISC_ADDR, HWIO_GCC_PCIE_1_SREG_MISC_RMSK)
#define HWIO_GCC_PCIE_1_SREG_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_PCIE_1_SREG_MISC_ADDR, m)
#define HWIO_GCC_PCIE_1_SREG_MISC_OUT(v)      \
        out_dword(HWIO_GCC_PCIE_1_SREG_MISC_ADDR,v)
#define HWIO_GCC_PCIE_1_SREG_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PCIE_1_SREG_MISC_ADDR,m,v,HWIO_GCC_PCIE_1_SREG_MISC_IN)
#define HWIO_GCC_PCIE_1_SREG_MISC_MSTR_AXI_MICRO_FORCE_MEM_CORE_ON_BMSK                                       0x1
#define HWIO_GCC_PCIE_1_SREG_MISC_MSTR_AXI_MICRO_FORCE_MEM_CORE_ON_SHFT                                       0x0

#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00076000)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076000)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076000)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_RMSK                                                             0x80000001
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ATTR                                                                    0x3
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00076004)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076004)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076004)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ATTR                                                                   0x3
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076008)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076008)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076008)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0007600c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007600c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007600c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x00076010)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076010)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076010)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                               0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                      0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                       0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                             0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                           0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                           0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                   0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                    0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00076014)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076014)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076014)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                            0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076018)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076018)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076018)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00076020)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076020)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076020)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                             0x3
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00076028)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076028)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076028)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                                0x3
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007602c)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007602c)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007602c)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_RMSK                                                              0x80000001
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ATTR                                                                     0x3
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_SP_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                      0x80000000
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                            0x1f
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                          0x1
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                          0x0
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_SP_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                   0x1

#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007603c)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007603c)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007603c)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_RMSK                                                             0x80000001
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ATTR                                                                    0x3
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                      0x80000000
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                            0x1f
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                        0x1
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                        0x0
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_SP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00076040)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076040)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076040)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_RMSK                                                            0x80000001
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ATTR                                                                   0x3
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                     0x80000000
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                           0x1f
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                       0x1
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                       0x0
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_SP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076044)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076044)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076044)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076048)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076048)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076048)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0007604c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007604c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007604c)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                               0x80000001
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                      0x3
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                        0x80000000
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                              0x1f
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                          0x1
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                          0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_SP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076050)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076050)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076050)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00076054)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076054)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076054)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                     0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                            0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                              0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                    0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                                0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                                0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0007605c)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007605c)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007605c)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                      0x80000001
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                             0x3
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                               0x80000000
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                     0x1f
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                                 0x1
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                                 0x0
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_SP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00076064)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076064)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076064)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                         0x80000001
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                                0x3
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                                  0x80000000
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                        0x1f
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                    0x1
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                    0x0
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_SP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ADDR                                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00076068)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_PHYS                                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076068)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_OFFS                                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076068)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_RMSK                                                              0x80000001
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ATTR                                                                     0x3
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_SP_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                       0x80000000
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                             0x1f
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                         0x1
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                         0x0
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_SP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076070)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076070)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076070)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                           0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                                 0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                               0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                               0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00076078)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00076078)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00076078)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                   0x80000001
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                          0x3
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                            0x80000000
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                                  0x1f
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                              0x1
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                              0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_SP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00077000)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077000)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077000)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ATTR                                                                   0x3
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00077004)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077004)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077004)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_RMSK                                                           0x80000001
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ATTR                                                                  0x3
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077008)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077008)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077008)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0007700c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007700c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007700c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00077010)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077010)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077010)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                              0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                                     0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                                      0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                            0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                          0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                          0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00077014)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077014)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077014)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                                    0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                           0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                            0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                                  0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                                0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                                0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077018)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077018)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077018)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00077020)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077020)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077020)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                            0x3
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00077028)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077028)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077028)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                        0x80000001
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                               0x3
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007702c)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007702c)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007702c)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_RMSK                                                             0x80000001
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ATTR                                                                    0x3
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                                     0x80000000
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                           0x1f
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                         0x1
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                         0x0
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                                 0x0
#define HWIO_GCC_MSS_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                                  0x1

#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007703c)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007703c)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007703c)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_RMSK                                                            0x80000001
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ATTR                                                                   0x3
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                                     0x80000000
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                           0x1f
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                       0x1
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                       0x0
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_MSS_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00077040)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077040)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077040)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_RMSK                                                           0x80000001
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ATTR                                                                  0x3
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                                    0x80000000
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                          0x1f
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                                      0x1
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                                      0x0
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                              0x0
#define HWIO_GCC_MSS_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                               0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077044)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077044)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077044)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077048)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077048)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077048)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0007704c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007704c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007704c)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                              0x80000001
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                                     0x3
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                       0x80000000
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                             0x1f
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                         0x1
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                         0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_MSS_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077050)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077050)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077050)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00077054)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077054)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077054)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                                    0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                           0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                             0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                                   0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                               0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                               0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0007705c)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007705c)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007705c)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_RMSK                                                     0x80000001
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                            0x3
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                              0x80000000
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                                    0x1f
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                                0x1
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                                0x0
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_MSS_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00077064)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077064)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077064)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                        0x80000001
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                               0x3
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                                 0x80000000
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                       0x1f
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                                   0x1
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                                   0x0
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                           0x0
#define HWIO_GCC_MSS_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                            0x1

#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00077068)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077068)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077068)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_RMSK                                                             0x80000001
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ATTR                                                                    0x3
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                                      0x80000000
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                            0x1f
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                        0x1
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                        0x0
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_MSS_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077070)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077070)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077070)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                          0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                                0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                              0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                              0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                                      0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                       0x1

#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00077078)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00077078)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00077078)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                                  0x80000001
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                         0x3
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                           0x80000000
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                                 0x1f
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                             0x1
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                             0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_MSS_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00019000)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019000)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019000)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ATTR                                                            0x3
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00019004)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019004)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019004)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_RMSK                                                    0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ATTR                                                           0x3
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_OFF_BMSK                                            0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_OFF_SHFT                                                  0x1f
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_BMSK                                                0x1
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_SHFT                                                0x0
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019008)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019008)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019008)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_BMSK                                   0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_OFF_SHFT                                         0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_BMSK                                       0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_SHFT                                       0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_CLK_CLK_ENABLE_ENABLE_FVAL                                0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0001900c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001900c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001900c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_BMSK                                   0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_OFF_SHFT                                         0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_BMSK                                       0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_SHFT                                       0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_CLK_CLK_ENABLE_ENABLE_FVAL                                0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00019010)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019010)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019010)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK                                       0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ATTR                                              0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_BMSK                               0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_OFF_SHFT                                     0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_BMSK                                   0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_SHFT                                   0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_DISABLE_FVAL                           0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_CLK_CLK_ENABLE_ENABLE_FVAL                            0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00019014)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019014)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019014)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK                                             0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ATTR                                                    0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_BMSK                                     0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_OFF_SHFT                                           0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_BMSK                                         0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_SHFT                                         0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_CLK_CLK_ENABLE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019018)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019018)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019018)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_BMSK                                   0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_OFF_SHFT                                         0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_BMSK                                       0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_SHFT                                       0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_CLK_CLK_ENABLE_ENABLE_FVAL                                0x1

#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x00019020)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019020)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019020)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_RMSK                                              0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ATTR                                                     0x3
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_BMSK                                      0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_OFF_SHFT                                            0x1f
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_BMSK                                          0x1
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_SHFT                                          0x0
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_DISABLE_FVAL                                  0x0
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_CLK_CLK_ENABLE_ENABLE_FVAL                                   0x1

#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00019028)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019028)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019028)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_RMSK                                                 0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ATTR                                                        0x3
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_BMSK                                         0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_OFF_SHFT                                               0x1f
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_BMSK                                             0x1
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_SHFT                                             0x0
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_DISABLE_FVAL                                     0x0
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_CLK_CLK_ENABLE_ENABLE_FVAL                                      0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0001902c)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001902c)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001902c)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ATTR                                                             0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0001903c)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001903c)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001903c)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_RMSK                                                     0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ATTR                                                            0x3
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_PWR_ON_BMSK                                              0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_PWR_ON_SHFT                                                    0x1f
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_BMSK                                                0x1
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_SHFT                                                0x0
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_TURING_DSP_VOTE_GPU_SMMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                         0x1

#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00019040)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019040)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019040)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_RMSK                                                    0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ATTR                                                           0x3
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_PWR_ON_BMSK                                             0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_PWR_ON_SHFT                                                   0x1f
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_BMSK                                               0x1
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_SHFT                                               0x0
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                                       0x0
#define HWIO_GCC_TURING_DSP_VOTE_LPASS_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                                        0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019044)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019044)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019044)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_BMSK                                    0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_PWR_ON_SHFT                                          0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_BMSK                                      0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_SHFT                                      0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB1_GDS_SW_COLLAPSE_ENABLE_FVAL                               0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019048)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019048)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019048)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_BMSK                                    0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_PWR_ON_SHFT                                          0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_BMSK                                      0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_SHFT                                      0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_QTB2_GDS_SW_COLLAPSE_ENABLE_FVAL                               0x1

#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0001904c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PHYS                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001904c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OFFS                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001904c)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK                                       0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ATTR                                              0x3
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_BMSK                                0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_PWR_ON_SHFT                                      0x1f
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_BMSK                                  0x1
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_SHFT                                  0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_TURING_DSP_VOTE_AGGRE_NOC_MMU_PCIE_QTB_GDS_SW_COLLAPSE_ENABLE_FVAL                           0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019050)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019050)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019050)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_BMSK                                    0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_PWR_ON_SHFT                                          0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_BMSK                                      0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_SHFT                                      0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF01_GDS_SW_COLLAPSE_ENABLE_FVAL                               0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00019054)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_PHYS                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019054)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_OFFS                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019054)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK                                             0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ATTR                                                    0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_BMSK                                      0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_PWR_ON_SHFT                                            0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_BMSK                                        0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_SHFT                                        0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_DISABLE_FVAL                                0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_SF_GDS_SW_COLLAPSE_ENABLE_FVAL                                 0x1

#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ADDR                                              (GCC_CLK_CTL_REG_REG_BASE      + 0x0001905c)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_PHYS                                              (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0001905c)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_OFFS                                              (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0001905c)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_RMSK                                              0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ATTR                                                     0x3
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_BMSK                                       0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_PWR_ON_SHFT                                             0x1f
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_BMSK                                         0x1
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_SHFT                                         0x0
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_DISABLE_FVAL                                 0x0
#define HWIO_GCC_TURING_DSP_VOTE_TURING_MMU_QTB0_GDS_SW_COLLAPSE_ENABLE_FVAL                                  0x1

#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00019064)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019064)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019064)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_RMSK                                                 0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ATTR                                                        0x3
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_BMSK                                          0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_PWR_ON_SHFT                                                0x1f
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_BMSK                                            0x1
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_SHFT                                            0x0
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_DISABLE_FVAL                                    0x0
#define HWIO_GCC_TURING_DSP_VOTE_ALL_SMMU_MMU_GDS_SW_COLLAPSE_ENABLE_FVAL                                     0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00019068)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019068)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019068)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_RMSK                                                      0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ATTR                                                             0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_PWR_ON_BMSK                                               0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_PWR_ON_SHFT                                                     0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_BMSK                                                 0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_SHFT                                                 0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMU_TCU_GDS_SW_COLLAPSE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019070)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019070)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019070)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_BMSK                                   0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_OFF_SHFT                                         0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_BMSK                                       0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_SHFT                                       0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_DISABLE_FVAL                               0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_CLK_CLK_ENABLE_ENABLE_FVAL                                0x1

#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00019078)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PHYS                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019078)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OFFS                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019078)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK                                           0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ATTR                                                  0x3
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_IN)
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_BMSK                                    0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_PWR_ON_SHFT                                          0x1f
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_BMSK                                      0x1
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_SHFT                                      0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_TURING_DSP_VOTE_MMNOC_MMU_QTB_HF23_GDS_SW_COLLAPSE_ENABLE_FVAL                               0x1

#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00019088)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00019088)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00019088)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_RMSK                                                     0x80000001
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ATTR                                                            0x3
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                             0x80000000
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                   0x1f
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                 0x1
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                 0x0
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                         0x0
#define HWIO_GCC_TURING_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00041124)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041124)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041124)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ATTR                                                                   0x3
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPM_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00025124)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025124)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025124)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_MSS_Q6_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00042124)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042124)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042124)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_RMSK                                                           0x80000001
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ATTR                                                                  0x3
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                   0x80000000
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                         0x1f
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                       0x1
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                       0x0
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                               0x0
#define HWIO_GCC_APCS_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                                0x1

#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00043124)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043124)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043124)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_RMSK                                                        0x80000001
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ATTR                                                               0x3
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                0x80000000
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                      0x1f
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                    0x1
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                    0x0
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                            0x0
#define HWIO_GCC_APCS_TZ_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                             0x1

#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00045124)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045124)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045124)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_RMSK                                                      0x80000001
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ATTR                                                             0x3
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                              0x80000000
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                    0x1f
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                  0x1
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                  0x0
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                          0x0
#define HWIO_GCC_LPASS_DSP_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                           0x1

#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00046124)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046124)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046124)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_RMSK                                                            0x80000001
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ATTR                                                                   0x3
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                    0x80000000
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                          0x1f
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                        0x1
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                        0x0
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                                0x0
#define HWIO_GCC_HYP_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a124)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a124)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a124)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_RMSK                                                         0x80000001
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ATTR                                                                0x3
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ADDR, HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_RMSK)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ADDR, m)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ADDR,v)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_ADDR,m,v,HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_IN)
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_OFF_BMSK                                                 0x80000000
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_OFF_SHFT                                                       0x1f
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_ENABLE_BMSK                                                     0x1
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_ENABLE_SHFT                                                     0x0
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_ENABLE_DISABLE_FVAL                                             0x0
#define HWIO_GCC_SPARE1_VOTE_QDSS_APB_CLK_CLK_ENABLE_ENABLE_FVAL                                              0x1

#define HWIO_GCC_JBIST_MODE_ADDR                                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00070000)
#define HWIO_GCC_JBIST_MODE_PHYS                                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00070000)
#define HWIO_GCC_JBIST_MODE_OFFS                                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00070000)
#define HWIO_GCC_JBIST_MODE_RMSK                                                                       0xffffffff
#define HWIO_GCC_JBIST_MODE_ATTR                                                                              0x3
#define HWIO_GCC_JBIST_MODE_IN          \
        in_dword_masked(HWIO_GCC_JBIST_MODE_ADDR, HWIO_GCC_JBIST_MODE_RMSK)
#define HWIO_GCC_JBIST_MODE_INM(m)      \
        in_dword_masked(HWIO_GCC_JBIST_MODE_ADDR, m)
#define HWIO_GCC_JBIST_MODE_OUT(v)      \
        out_dword(HWIO_GCC_JBIST_MODE_ADDR,v)
#define HWIO_GCC_JBIST_MODE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_JBIST_MODE_ADDR,m,v,HWIO_GCC_JBIST_MODE_IN)
#define HWIO_GCC_JBIST_MODE_RESERVE_BITS31_9_BMSK                                                      0xfffff800
#define HWIO_GCC_JBIST_MODE_RESERVE_BITS31_9_SHFT                                                             0xb
#define HWIO_GCC_JBIST_MODE_JBIST_PASS_BMSK                                                                 0x400
#define HWIO_GCC_JBIST_MODE_JBIST_PASS_SHFT                                                                   0xa
#define HWIO_GCC_JBIST_MODE_JBIST_ENABLE_BMSK                                                               0x200
#define HWIO_GCC_JBIST_MODE_JBIST_ENABLE_SHFT                                                                 0x9
#define HWIO_GCC_JBIST_MODE_DLL_CLK_EXT2_MUX_SEL_BMSK                                                       0x180
#define HWIO_GCC_JBIST_MODE_DLL_CLK_EXT2_MUX_SEL_SHFT                                                         0x7
#define HWIO_GCC_JBIST_MODE_DLL_CLK_EXT1_MUX_SEL_BMSK                                                        0x60
#define HWIO_GCC_JBIST_MODE_DLL_CLK_EXT1_MUX_SEL_SHFT                                                         0x5
#define HWIO_GCC_JBIST_MODE_PLL_LOCK_DET_BMSK                                                                0x10
#define HWIO_GCC_JBIST_MODE_PLL_LOCK_DET_SHFT                                                                 0x4
#define HWIO_GCC_JBIST_MODE_START_MEAS_BMSK                                                                   0x8
#define HWIO_GCC_JBIST_MODE_START_MEAS_SHFT                                                                   0x3
#define HWIO_GCC_JBIST_MODE_JBIST_TEST_BMSK                                                                   0x4
#define HWIO_GCC_JBIST_MODE_JBIST_TEST_SHFT                                                                   0x2
#define HWIO_GCC_JBIST_MODE_RESET_N_BMSK                                                                      0x2
#define HWIO_GCC_JBIST_MODE_RESET_N_SHFT                                                                      0x1
#define HWIO_GCC_JBIST_MODE_SLEEP_N_BMSK                                                                      0x1
#define HWIO_GCC_JBIST_MODE_SLEEP_N_SHFT                                                                      0x0

#define HWIO_GCC_JBIST_MEAS_DONE_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x00070018)
#define HWIO_GCC_JBIST_MEAS_DONE_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00070018)
#define HWIO_GCC_JBIST_MEAS_DONE_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00070018)
#define HWIO_GCC_JBIST_MEAS_DONE_RMSK                                                                  0xffffffff
#define HWIO_GCC_JBIST_MEAS_DONE_ATTR                                                                         0x3
#define HWIO_GCC_JBIST_MEAS_DONE_IN          \
        in_dword_masked(HWIO_GCC_JBIST_MEAS_DONE_ADDR, HWIO_GCC_JBIST_MEAS_DONE_RMSK)
#define HWIO_GCC_JBIST_MEAS_DONE_INM(m)      \
        in_dword_masked(HWIO_GCC_JBIST_MEAS_DONE_ADDR, m)
#define HWIO_GCC_JBIST_MEAS_DONE_OUT(v)      \
        out_dword(HWIO_GCC_JBIST_MEAS_DONE_ADDR,v)
#define HWIO_GCC_JBIST_MEAS_DONE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_JBIST_MEAS_DONE_ADDR,m,v,HWIO_GCC_JBIST_MEAS_DONE_IN)
#define HWIO_GCC_JBIST_MEAS_DONE_RESERVE_BITS31_1_BMSK                                                 0xfffffffe
#define HWIO_GCC_JBIST_MEAS_DONE_RESERVE_BITS31_1_SHFT                                                        0x1
#define HWIO_GCC_JBIST_MEAS_DONE_JBIST_DATA_STREAM_RDY_BMSK                                                   0x1
#define HWIO_GCC_JBIST_MEAS_DONE_JBIST_DATA_STREAM_RDY_SHFT                                                   0x0

#define HWIO_GCC_GLOBAL_EN_ADDR                                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007f000)
#define HWIO_GCC_GLOBAL_EN_PHYS                                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007f000)
#define HWIO_GCC_GLOBAL_EN_OFFS                                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007f000)
#define HWIO_GCC_GLOBAL_EN_RMSK                                                                        0xffffffff
#define HWIO_GCC_GLOBAL_EN_ATTR                                                                               0x3
#define HWIO_GCC_GLOBAL_EN_IN          \
        in_dword_masked(HWIO_GCC_GLOBAL_EN_ADDR, HWIO_GCC_GLOBAL_EN_RMSK)
#define HWIO_GCC_GLOBAL_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_GLOBAL_EN_ADDR, m)
#define HWIO_GCC_GLOBAL_EN_OUT(v)      \
        out_dword(HWIO_GCC_GLOBAL_EN_ADDR,v)
#define HWIO_GCC_GLOBAL_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GLOBAL_EN_ADDR,m,v,HWIO_GCC_GLOBAL_EN_IN)
#define HWIO_GCC_GLOBAL_EN_SPARE_ENABLE_BMSK                                                           0xffff8000
#define HWIO_GCC_GLOBAL_EN_SPARE_ENABLE_SHFT                                                                  0xf
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_7_BMSK                                                               0x4000
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_7_SHFT                                                                  0xe
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_7_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_7_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_6_BMSK                                                               0x2000
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_6_SHFT                                                                  0xd
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_6_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_6_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_5_BMSK                                                               0x1000
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_5_SHFT                                                                  0xc
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_5_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_5_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_4_BMSK                                                                0x800
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_4_SHFT                                                                  0xb
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_4_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_4_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_3_BMSK                                                                0x400
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_3_SHFT                                                                  0xa
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_3_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_3_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_2_BMSK                                                                0x200
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_2_SHFT                                                                  0x9
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_2_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_2_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_1_BMSK                                                                0x100
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_1_SHFT                                                                  0x8
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_1_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_1_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_0_BMSK                                                                 0x80
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_0_SHFT                                                                  0x7
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_0_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_MEM_ENABLE_0_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_REST_ENABLE_BMSK                                                                  0x40
#define HWIO_GCC_GLOBAL_EN_REST_ENABLE_SHFT                                                                   0x6
#define HWIO_GCC_GLOBAL_EN_REST_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_GLOBAL_EN_REST_ENABLE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_GLOBAL_EN_PERIPHERALS_ENABLE_BMSK                                                           0x20
#define HWIO_GCC_GLOBAL_EN_PERIPHERALS_ENABLE_SHFT                                                            0x5
#define HWIO_GCC_GLOBAL_EN_PERIPHERALS_ENABLE_DISABLE_FVAL                                                    0x0
#define HWIO_GCC_GLOBAL_EN_PERIPHERALS_ENABLE_ENABLE_FVAL                                                     0x1
#define HWIO_GCC_GLOBAL_EN_CENTER_ENABLE_BMSK                                                                0x10
#define HWIO_GCC_GLOBAL_EN_CENTER_ENABLE_SHFT                                                                 0x4
#define HWIO_GCC_GLOBAL_EN_CENTER_ENABLE_DISABLE_FVAL                                                         0x0
#define HWIO_GCC_GLOBAL_EN_CENTER_ENABLE_ENABLE_FVAL                                                          0x1
#define HWIO_GCC_GLOBAL_EN_SOUTH_ENABLE_BMSK                                                                  0x8
#define HWIO_GCC_GLOBAL_EN_SOUTH_ENABLE_SHFT                                                                  0x3
#define HWIO_GCC_GLOBAL_EN_SOUTH_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_SOUTH_ENABLE_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_NORTH_ENABLE_BMSK                                                                  0x4
#define HWIO_GCC_GLOBAL_EN_NORTH_ENABLE_SHFT                                                                  0x2
#define HWIO_GCC_GLOBAL_EN_NORTH_ENABLE_DISABLE_FVAL                                                          0x0
#define HWIO_GCC_GLOBAL_EN_NORTH_ENABLE_ENABLE_FVAL                                                           0x1
#define HWIO_GCC_GLOBAL_EN_WEST_ENABLE_BMSK                                                                   0x2
#define HWIO_GCC_GLOBAL_EN_WEST_ENABLE_SHFT                                                                   0x1
#define HWIO_GCC_GLOBAL_EN_WEST_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_GLOBAL_EN_WEST_ENABLE_ENABLE_FVAL                                                            0x1
#define HWIO_GCC_GLOBAL_EN_EAST_ENABLE_BMSK                                                                   0x1
#define HWIO_GCC_GLOBAL_EN_EAST_ENABLE_SHFT                                                                   0x0
#define HWIO_GCC_GLOBAL_EN_EAST_ENABLE_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_GLOBAL_EN_EAST_ENABLE_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_DEBUG_EN_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00075000)
#define HWIO_GCC_DEBUG_EN_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00075000)
#define HWIO_GCC_DEBUG_EN_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00075000)
#define HWIO_GCC_DEBUG_EN_RMSK                                                                         0xffffffff
#define HWIO_GCC_DEBUG_EN_ATTR                                                                                0x3
#define HWIO_GCC_DEBUG_EN_IN          \
        in_dword_masked(HWIO_GCC_DEBUG_EN_ADDR, HWIO_GCC_DEBUG_EN_RMSK)
#define HWIO_GCC_DEBUG_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_DEBUG_EN_ADDR, m)
#define HWIO_GCC_DEBUG_EN_OUT(v)      \
        out_dword(HWIO_GCC_DEBUG_EN_ADDR,v)
#define HWIO_GCC_DEBUG_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_DEBUG_EN_ADDR,m,v,HWIO_GCC_DEBUG_EN_IN)
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPACK_BMSK                                                            0x80000000
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPACK_SHFT                                                                  0x1f
#define HWIO_GCC_DEBUG_EN_SPARE_ENABLE_BMSK                                                            0x7ffffffe
#define HWIO_GCC_DEBUG_EN_SPARE_ENABLE_SHFT                                                                   0x1
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPREQ_BMSK                                                                   0x1
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPREQ_SHFT                                                                   0x0
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPREQ_DISABLE_FVAL                                                           0x0
#define HWIO_GCC_DEBUG_EN_CDBGPWRUPREQ_ENABLE_FVAL                                                            0x1

#define HWIO_GCC_CAM_CC_SGDSCR_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00016100)
#define HWIO_GCC_CAM_CC_SGDSCR_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00016100)
#define HWIO_GCC_CAM_CC_SGDSCR_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00016100)
#define HWIO_GCC_CAM_CC_SGDSCR_RMSK                                                                           0x7
#define HWIO_GCC_CAM_CC_SGDSCR_ATTR                                                                           0x3
#define HWIO_GCC_CAM_CC_SGDSCR_IN          \
        in_dword_masked(HWIO_GCC_CAM_CC_SGDSCR_ADDR, HWIO_GCC_CAM_CC_SGDSCR_RMSK)
#define HWIO_GCC_CAM_CC_SGDSCR_INM(m)      \
        in_dword_masked(HWIO_GCC_CAM_CC_SGDSCR_ADDR, m)
#define HWIO_GCC_CAM_CC_SGDSCR_OUT(v)      \
        out_dword(HWIO_GCC_CAM_CC_SGDSCR_ADDR,v)
#define HWIO_GCC_CAM_CC_SGDSCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_CAM_CC_SGDSCR_ADDR,m,v,HWIO_GCC_CAM_CC_SGDSCR_IN)
#define HWIO_GCC_CAM_CC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_BMSK                                                0x4
#define HWIO_GCC_CAM_CC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_SHFT                                                0x2
#define HWIO_GCC_CAM_CC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_DISABLE_FVAL                                        0x0
#define HWIO_GCC_CAM_CC_SGDSCR_PRE_PWRUP_RETAIN_FF_ENABLE_ENABLE_FVAL                                         0x1
#define HWIO_GCC_CAM_CC_SGDSCR_RETAIN_FF_ENABLE_BMSK                                                          0x2
#define HWIO_GCC_CAM_CC_SGDSCR_RETAIN_FF_ENABLE_SHFT                                                          0x1
#define HWIO_GCC_CAM_CC_SGDSCR_RETAIN_FF_ENABLE_DISABLE_FVAL                                                  0x0
#define HWIO_GCC_CAM_CC_SGDSCR_RETAIN_FF_ENABLE_ENABLE_FVAL                                                   0x1
#define HWIO_GCC_CAM_CC_SGDSCR_SW_OVERRIDE_BMSK                                                               0x1
#define HWIO_GCC_CAM_CC_SGDSCR_SW_OVERRIDE_SHFT                                                               0x0
#define HWIO_GCC_CAM_CC_SGDSCR_SW_OVERRIDE_DISABLE_FVAL                                                       0x0
#define HWIO_GCC_CAM_CC_SGDSCR_SW_OVERRIDE_ENABLE_FVAL                                                        0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081000)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081000)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081000)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081004)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081004)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081004)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081008)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081008)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081008)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0008100c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008100c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008100c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081010)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081010)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081010)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081014)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081014)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081014)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081018)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081018)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081018)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0008101c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008101c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008101c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081020)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081020)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081020)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00081024)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081024)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081024)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_RMSK                                                           0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                 0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                   0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                 0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                  0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                   0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                  0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                   0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                  0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                   0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                  0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                   0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                   0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                   0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                   0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                            0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                   0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                   0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                           0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                            0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00081028)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081028)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081028)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008102c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008102c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008102c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00081030)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081030)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081030)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00081034)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081034)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081034)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00081038)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081038)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081038)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008103c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008103c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008103c)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_SYS_NOC_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082000)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082000)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082000)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082004)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082004)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082004)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082008)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082008)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082008)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008200c)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008200c)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008200c)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082010)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082010)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082010)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082014)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082014)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082014)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082018)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082018)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082018)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008201c)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008201c)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008201c)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082020)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082020)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082020)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00082024)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082024)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082024)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_CNOC_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00082028)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082028)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082028)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008202c)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008202c)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008202c)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00082030)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082030)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082030)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00082034)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082034)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082034)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00082038)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082038)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082038)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008203c)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008203c)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008203c)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_CNOC_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086000)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086000)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086000)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086004)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086004)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086004)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086008)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086008)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086008)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008600c)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008600c)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008600c)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086010)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086010)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086010)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086014)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086014)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086014)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086018)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086018)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086018)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008601c)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008601c)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008601c)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086020)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086020)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086020)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00086024)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086024)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086024)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHUB_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00086028)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086028)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086028)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008602c)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008602c)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008602c)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00086030)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086030)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086030)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00086034)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086034)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086034)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00086038)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086038)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086038)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008603c)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008603c)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008603c)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHUB_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085000)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085000)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085000)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085004)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085004)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085004)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085008)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085008)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085008)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008500c)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008500c)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008500c)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085010)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085010)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085010)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085014)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085014)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085014)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085018)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085018)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085018)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008501c)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008501c)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008501c)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085020)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085020)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085020)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00085024)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085024)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085024)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_MMNOC_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00085028)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085028)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085028)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0008502c)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008502c)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008502c)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00085030)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085030)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085030)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00085034)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085034)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085034)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00085038)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085038)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085038)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0008503c)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008503c)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008503c)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_RMSK                                                            0x3ff
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                  0x200
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                    0x9
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                  0x100
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                   0x80
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                    0x7
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                   0x40
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                    0x6
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                   0x20
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                    0x5
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                   0x10
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                    0x8
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                    0x3
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                    0x4
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                    0x2
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                             0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                    0x1
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                    0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                            0x0
#define HWIO_GCC_RPMH_MMNOC_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                             0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b000)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b000)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b000)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b004)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b004)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b004)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b008)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b008)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b008)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b00c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b00c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b00c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b010)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b010)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b010)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b014)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b014)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b014)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b018)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b018)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b018)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b01c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b01c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b01c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b020)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b020)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b020)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ADDR                                                (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b024)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_PHYS                                                (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b024)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_OFFS                                                (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b024)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_RMSK                                                     0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ATTR                                                       0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                           0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                             0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                           0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                            0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                             0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                            0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                             0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                            0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                             0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                            0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                             0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                             0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                             0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                             0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                      0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                             0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                             0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                     0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                      0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b028)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b028)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b028)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b02c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b02c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b02c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b030)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b034)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b038)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ADDR                                               (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b03c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_PHYS                                               (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b03c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_OFFS                                               (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b03c)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_RMSK                                                    0x3ff
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ATTR                                                      0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                          0x200
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                            0x9
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                          0x100
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                           0x80
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                            0x7
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                           0x40
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                            0x6
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                           0x20
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                            0x5
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                           0x10
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                            0x8
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                            0x3
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                            0x4
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                            0x2
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                     0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                            0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                            0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                    0x0
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                     0x1

#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a000)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a000)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a000)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a004)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a004)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a004)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a008)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a008)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a008)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a00c)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a00c)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a00c)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a010)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a010)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a010)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a014)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a014)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a014)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a018)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a018)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a018)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a01c)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a01c)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a01c)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a020)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a020)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a020)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a024)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a024)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a024)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_PMU_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a028)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a028)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a028)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a02c)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a02c)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a02c)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a030)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a030)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a030)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a034)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a034)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a034)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a038)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a038)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a038)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a03c)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a03c)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a03c)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_PMU_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084000)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084000)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084000)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084004)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084004)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084004)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084008)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084008)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084008)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008400c)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008400c)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008400c)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084010)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084010)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084010)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084014)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084014)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084014)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084018)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084018)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084018)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008401c)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008401c)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008401c)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084020)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084020)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084020)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00084024)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084024)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084024)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_RMSK                                                                0x3ff
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                      0x200
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                        0x9
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                      0x100
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                       0x80
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                        0x7
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                       0x40
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                        0x6
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                       0x20
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                        0x5
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                       0x10
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                        0x8
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                        0x3
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                        0x4
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                        0x2
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                 0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                        0x1
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                        0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                                0x0
#define HWIO_GCC_RPMH_CE_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                 0x1

#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00084028)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084028)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084028)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008402c)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008402c)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008402c)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00084030)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084030)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084030)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00084034)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084034)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084034)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00084038)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084038)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084038)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008403c)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008403c)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008403c)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_CE_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087000)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087000)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087000)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087004)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087004)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087004)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087008)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087008)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087008)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008700c)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008700c)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008700c)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087010)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087010)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087010)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087014)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087014)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087014)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087018)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087018)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087018)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008701c)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008701c)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008701c)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087020)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087020)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087020)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00087024)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087024)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087024)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_SHRM_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00087028)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087028)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087028)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008702c)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008702c)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008702c)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00087030)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087030)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087030)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00087034)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087034)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087034)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00087038)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087038)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087038)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0008703c)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008703c)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008703c)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_RMSK                                                             0x3ff
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                   0x200
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                     0x9
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                   0x100
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                    0x80
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                     0x7
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                    0x40
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                     0x6
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                    0x20
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                     0x5
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                    0x10
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                     0x8
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                     0x3
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                     0x4
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                     0x2
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                              0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                     0x1
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                     0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                             0x0
#define HWIO_GCC_RPMH_SHRM_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                              0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c000)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c000)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c000)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c004)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c004)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c004)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c008)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c008)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c008)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c00c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c00c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c00c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c010)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c010)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c010)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c014)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c014)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c014)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c018)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c018)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c018)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c01c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c01c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c01c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c020)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c020)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c020)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c024)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c024)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c024)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_RMSK                                                          0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                  0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                 0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                  0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                 0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                  0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                 0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                  0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                 0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                  0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                  0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                  0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                  0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                           0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                  0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                  0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                          0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                           0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c028)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c028)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c028)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c02c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c02c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c02c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c030)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c030)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c030)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c034)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c034)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c034)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c038)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c038)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c038)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c03c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c03c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c03c)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_RMSK                                                         0x3ff
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                               0x200
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                 0x9
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                               0x100
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                0x80
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                 0x7
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                0x40
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                 0x6
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                0x20
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                 0x5
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                0x10
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                 0x8
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                 0x3
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                 0x4
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                 0x2
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                          0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                 0x1
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                 0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                         0x0
#define HWIO_GCC_RPMH_CDSP_NOC_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                          0x1

#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083000)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083000)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083000)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF0_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083004)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083004)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083004)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF1_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083008)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083008)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083008)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF2_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008300c)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008300c)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008300c)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF3_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083010)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083010)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083010)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF4_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083014)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083014)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083014)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF5_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083018)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083018)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083018)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF6_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0008301c)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008301c)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008301c)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF7_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083020)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083020)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083020)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF8_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00083024)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083024)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083024)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_RMSK                                                               0x3ff
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL9_BMSK                                                     0x200
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL9_SHFT                                                       0x9
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL8_BMSK                                                     0x100
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL8_SHFT                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL7_BMSK                                                      0x80
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL7_SHFT                                                       0x7
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL6_BMSK                                                      0x40
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL6_SHFT                                                       0x6
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL5_BMSK                                                      0x20
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL5_SHFT                                                       0x5
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL4_BMSK                                                      0x10
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL4_SHFT                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL3_BMSK                                                       0x8
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL3_SHFT                                                       0x3
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL2_BMSK                                                       0x4
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL2_SHFT                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL1_BMSK                                                       0x2
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL1_SHFT                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                                0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL0_BMSK                                                       0x1
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL0_SHFT                                                       0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                               0x0
#define HWIO_GCC_RPMH_IPA_PERF9_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                                0x1

#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00083028)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083028)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083028)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF10_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008302c)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008302c)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008302c)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF11_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00083030)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083030)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083030)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF12_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00083034)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083034)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083034)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF13_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00083038)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083038)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083038)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF14_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0008303c)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008303c)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008303c)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_RMSK                                                              0x3ff
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ADDR, HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_RMSK)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_IN)
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL9_BMSK                                                    0x200
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL9_SHFT                                                      0x9
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL9_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL9_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL8_BMSK                                                    0x100
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL8_SHFT                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL8_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL8_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL7_BMSK                                                     0x80
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL7_SHFT                                                      0x7
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL7_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL7_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL6_BMSK                                                     0x40
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL6_SHFT                                                      0x6
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL6_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL6_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL5_BMSK                                                     0x20
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL5_SHFT                                                      0x5
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL5_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL5_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL4_BMSK                                                     0x10
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL4_SHFT                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL4_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL4_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL3_BMSK                                                      0x8
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL3_SHFT                                                      0x3
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL3_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL3_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL2_BMSK                                                      0x4
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL2_SHFT                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL2_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL2_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL1_BMSK                                                      0x2
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL1_SHFT                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL1_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL1_ENABLE_FVAL                                               0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL0_BMSK                                                      0x1
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL0_SHFT                                                      0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL0_DISABLE_FVAL                                              0x0
#define HWIO_GCC_RPMH_IPA_PERF15_ENA_VOTE_GCC_GPLL0_ENABLE_FVAL                                               0x1

#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00081100)
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00081100)
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00081100)
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_RMSK                                                             0x1f
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_ATTR                                                              0x1
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_FSM_STATE_BMSK                                                   0x1f
#define HWIO_GCC_RPMH_SYS_NOC_INTERFACE_FSM_FSM_STATE_SHFT                                                    0x0

#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00082100)
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00082100)
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00082100)
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_RMSK                                                                0x1f
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_ATTR                                                                 0x1
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_FSM_STATE_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_CNOC_INTERFACE_FSM_FSM_STATE_SHFT                                                       0x0

#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x00083100)
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00083100)
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00083100)
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_RMSK                                                                 0x1f
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_ATTR                                                                  0x1
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_IPA_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_IPA_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_IPA_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_FSM_STATE_BMSK                                                       0x1f
#define HWIO_GCC_RPMH_IPA_INTERFACE_FSM_FSM_STATE_SHFT                                                        0x0

#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_ADDR                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x0008b100)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_PHYS                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008b100)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_OFFS                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008b100)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_RMSK                                                       0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_ATTR                                                        0x1
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_FSM_STATE_BMSK                                             0x1f
#define HWIO_GCC_RPMH_QUPV3_CORE_2X_INTERFACE_FSM_FSM_STATE_SHFT                                              0x0

#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00084100)
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00084100)
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00084100)
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_RMSK                                                                  0x1f
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_ATTR                                                                   0x1
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CE_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_CE_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CE_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_FSM_STATE_BMSK                                                        0x1f
#define HWIO_GCC_RPMH_CE_INTERFACE_FSM_FSM_STATE_SHFT                                                         0x0

#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0008c100)
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008c100)
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008c100)
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_RMSK                                                            0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_ATTR                                                             0x1
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_FSM_STATE_BMSK                                                  0x1f
#define HWIO_GCC_RPMH_CDSP_NOC_INTERFACE_FSM_FSM_STATE_SHFT                                                   0x0

#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00085100)
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00085100)
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00085100)
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_RMSK                                                               0x1f
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_ATTR                                                                0x1
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_FSM_STATE_BMSK                                                     0x1f
#define HWIO_GCC_RPMH_MMNOC_INTERFACE_FSM_FSM_STATE_SHFT                                                      0x0

#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00086100)
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00086100)
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00086100)
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_RMSK                                                                0x1f
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_ATTR                                                                 0x1
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_FSM_STATE_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHUB_INTERFACE_FSM_FSM_STATE_SHFT                                                       0x0

#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00087100)
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00087100)
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00087100)
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_RMSK                                                                0x1f
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_ATTR                                                                 0x1
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_FSM_STATE_BMSK                                                      0x1f
#define HWIO_GCC_RPMH_SHRM_INTERFACE_FSM_FSM_STATE_SHFT                                                       0x0

#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0008a100)
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0008a100)
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0008a100)
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_RMSK                                                                 0x1f
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_ATTR                                                                  0x1
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_IN          \
        in_dword_masked(HWIO_GCC_RPMH_PMU_INTERFACE_FSM_ADDR, HWIO_GCC_RPMH_PMU_INTERFACE_FSM_RMSK)
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_PMU_INTERFACE_FSM_ADDR, m)
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_FSM_STATE_BMSK                                                       0x1f
#define HWIO_GCC_RPMH_PMU_INTERFACE_FSM_FSM_STATE_SHFT                                                        0x0

#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x00061250)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00061250)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00061250)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_RMSK                                                                   0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ATTR                                                                   0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_IN          \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ADDR, HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_RMSK)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ADDR, m)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_OUT(v)      \
        out_dword(HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ADDR,v)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_ADDR,m,v,HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_IN)
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_MUX_SELECT_BMSK                                                        0x3
#define HWIO_GCC_GPU_MEMNOC_GFX_CLK_EN_MUX_SELECT_SHFT                                                        0x0

#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0007323c)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007323c)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007323c)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_RMSK                                                                   0x3
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ATTR                                                                   0x3
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_IN          \
        in_dword_masked(HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ADDR, HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_RMSK)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ADDR, m)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_OUT(v)      \
        out_dword(HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ADDR,v)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_ADDR,m,v,HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_IN)
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_MUX_SELECT_BMSK                                                        0x3
#define HWIO_GCC_MMU_MEMNOC_TCU_CLK_EN_MUX_SELECT_SHFT                                                        0x0

#define HWIO_GCC_MMU_GDSC_MISC_ADDR                                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x0007324c)
#define HWIO_GCC_MMU_GDSC_MISC_PHYS                                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007324c)
#define HWIO_GCC_MMU_GDSC_MISC_OFFS                                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007324c)
#define HWIO_GCC_MMU_GDSC_MISC_RMSK                                                                           0x3
#define HWIO_GCC_MMU_GDSC_MISC_ATTR                                                                           0x3
#define HWIO_GCC_MMU_GDSC_MISC_IN          \
        in_dword_masked(HWIO_GCC_MMU_GDSC_MISC_ADDR, HWIO_GCC_MMU_GDSC_MISC_RMSK)
#define HWIO_GCC_MMU_GDSC_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_MMU_GDSC_MISC_ADDR, m)
#define HWIO_GCC_MMU_GDSC_MISC_OUT(v)      \
        out_dword(HWIO_GCC_MMU_GDSC_MISC_ADDR,v)
#define HWIO_GCC_MMU_GDSC_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MMU_GDSC_MISC_ADDR,m,v,HWIO_GCC_MMU_GDSC_MISC_IN)
#define HWIO_GCC_MMU_GDSC_MISC_WAIT_FOR_LPASS_QTB_PWR_COLLAPSE_BMSK                                           0x2
#define HWIO_GCC_MMU_GDSC_MISC_WAIT_FOR_LPASS_QTB_PWR_COLLAPSE_SHFT                                           0x1
#define HWIO_GCC_MMU_GDSC_MISC_IGNORE_PMU_PWR_COLLAPSE_REQ_BMSK                                               0x1
#define HWIO_GCC_MMU_GDSC_MISC_IGNORE_PMU_PWR_COLLAPSE_REQ_SHFT                                               0x0

#define HWIO_GCC_MEMNOC_TURING_CLK_EN_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x00035490)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00035490)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00035490)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_RMSK                                                                    0x3
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_ATTR                                                                    0x3
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_TURING_CLK_EN_ADDR, HWIO_GCC_MEMNOC_TURING_CLK_EN_RMSK)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_TURING_CLK_EN_ADDR, m)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_TURING_CLK_EN_ADDR,v)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_TURING_CLK_EN_ADDR,m,v,HWIO_GCC_MEMNOC_TURING_CLK_EN_IN)
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_MUX_SELECT_BMSK                                                         0x3
#define HWIO_GCC_MEMNOC_TURING_CLK_EN_MUX_SELECT_SHFT                                                         0x0

#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ADDR                                                             (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a38c)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_PHYS                                                             (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a38c)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_OFFS                                                             (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a38c)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_RMSK                                                                    0x3
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ATTR                                                                    0x3
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ADDR, HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_RMSK)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ADDR, m)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ADDR,v)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_ADDR,m,v,HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_IN)
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_MUX_SELECT_BMSK                                                         0x3
#define HWIO_GCC_MEMNOC_MSS_Q6_CLK_EN_MUX_SELECT_SHFT                                                         0x0

#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a390)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a390)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a390)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_RMSK                                                               0x3
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ATTR                                                               0x3
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_IN          \
        in_dword_masked(HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ADDR, HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_RMSK)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_INM(m)      \
        in_dword_masked(HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ADDR, m)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_OUT(v)      \
        out_dword(HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ADDR,v)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_ADDR,m,v,HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_IN)
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_MUX_SELECT_BMSK                                                    0x3
#define HWIO_GCC_MEMNOC_MSS_OFFLINE_CLK_EN_MUX_SELECT_SHFT                                                    0x0

#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00037110)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00037110)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00037110)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_RMSK                                                              0x1
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ATTR                                                              0x3
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_IN          \
        in_dword_masked(HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ADDR, HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_RMSK)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ADDR, m)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ADDR,v)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_ADDR,m,v,HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_IN)
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_MUX_SEL_BMSK                                                      0x1
#define HWIO_GCC_LPASS_Q6SS_BOOT_GPLL0_MUXR_MUX_SEL_SHFT                                                      0x0

#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x0007a360)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0007a360)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0007a360)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_RMSK                                                                0x1
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ATTR                                                                0x3
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ADDR, HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_RMSK)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ADDR, m)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ADDR,v)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_ADDR,m,v,HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_IN)
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_MUX_SEL_BMSK                                                        0x1
#define HWIO_GCC_MSS_Q6SS_BOOT_GPLL0_MUXR_MUX_SEL_SHFT                                                        0x0

#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_ADDR                                                            (GCC_CLK_CTL_REG_REG_BASE      + 0x0003a000)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_PHYS                                                            (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0003a000)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_OFFS                                                            (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0003a000)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_RMSK                                                            0xffffffff
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_ATTR                                                                   0x3
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_IN          \
        in_dword_masked(HWIO_GCC_ACA_FAL10_VETO_ENABLE_ADDR, HWIO_GCC_ACA_FAL10_VETO_ENABLE_RMSK)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_INM(m)      \
        in_dword_masked(HWIO_GCC_ACA_FAL10_VETO_ENABLE_ADDR, m)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_OUT(v)      \
        out_dword(HWIO_GCC_ACA_FAL10_VETO_ENABLE_ADDR,v)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_ACA_FAL10_VETO_ENABLE_ADDR,m,v,HWIO_GCC_ACA_FAL10_VETO_ENABLE_IN)
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_BMSK                                         0xffffffff
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_SHFT                                                0x0
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_TIC_CFG_QX_CLK_ON_FVAL                          0x0
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_QUPV3_WRAP_0_M_AHB_CLK_ON_FVAL                  0x1
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_USB30_PRIM_MASTER_CLK_ON_FVAL                   0x2
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_USB30_SEC_MASTER_CLK_ON_FVAL                    0x3
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_QUPV3_WRAP_1_M_AHB_CLK_ON_FVAL                  0x4
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_QUPV3_WRAP_2_M_AHB_CLK_ON_FVAL                  0x5
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_SDCC2_AHB_CLK_ON_FVAL                           0x7
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_SDCC4_AHB_CLK_ON_FVAL                           0x8
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_QSPI_CNOC_PERIPH_AHB_CLK_ON_FVAL                0x9
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_IPA_CLK_ON_FVAL                                 0xa
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_CE1_AXI_CLK_ON_FVAL                             0xb
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_QDSS_ETR_USB_CLK_ON_FVAL                        0xc
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_SP_SNOC_ANOC_AXI_CLK_ON_FVAL                    0xd
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_UFS_CARD_AXI_CLK_ON_FVAL                        0xe
#define HWIO_GCC_ACA_FAL10_VETO_ENABLE_CLK_ON_VETO_ENABLE_GCC_UFS_PHY_AXI_CLK_ON_FVAL                         0xf

#define HWIO_GCC_PLL_MISC_ADDR                                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00048000)
#define HWIO_GCC_PLL_MISC_PHYS                                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00048000)
#define HWIO_GCC_PLL_MISC_OFFS                                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00048000)
#define HWIO_GCC_PLL_MISC_RMSK                                                                                0x1
#define HWIO_GCC_PLL_MISC_ATTR                                                                                0x3
#define HWIO_GCC_PLL_MISC_IN          \
        in_dword_masked(HWIO_GCC_PLL_MISC_ADDR, HWIO_GCC_PLL_MISC_RMSK)
#define HWIO_GCC_PLL_MISC_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_MISC_ADDR, m)
#define HWIO_GCC_PLL_MISC_OUT(v)      \
        out_dword(HWIO_GCC_PLL_MISC_ADDR,v)
#define HWIO_GCC_PLL_MISC_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_MISC_ADDR,m,v,HWIO_GCC_PLL_MISC_IN)
#define HWIO_GCC_PLL_MISC_HW_TRIGGERED_PLL_STBY_DIS_BMSK                                                      0x1
#define HWIO_GCC_PLL_MISC_HW_TRIGGERED_PLL_STBY_DIS_SHFT                                                      0x0
#define HWIO_GCC_PLL_MISC_HW_TRIGGERED_PLL_STBY_DIS_FEATURE_ON_FVAL                                           0x0
#define HWIO_GCC_PLL_MISC_HW_TRIGGERED_PLL_STBY_DIS_FEATURE_OFF_FVAL                                          0x1

#define HWIO_GCC_RPMH_ALL_CLK_OFF_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00048004)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00048004)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00048004)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_RMSK                                                                        0x1
#define HWIO_GCC_RPMH_ALL_CLK_OFF_ATTR                                                                        0x3
#define HWIO_GCC_RPMH_ALL_CLK_OFF_IN          \
        in_dword_masked(HWIO_GCC_RPMH_ALL_CLK_OFF_ADDR, HWIO_GCC_RPMH_ALL_CLK_OFF_RMSK)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_INM(m)      \
        in_dword_masked(HWIO_GCC_RPMH_ALL_CLK_OFF_ADDR, m)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_OUT(v)      \
        out_dword(HWIO_GCC_RPMH_ALL_CLK_OFF_ADDR,v)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPMH_ALL_CLK_OFF_ADDR,m,v,HWIO_GCC_RPMH_ALL_CLK_OFF_IN)
#define HWIO_GCC_RPMH_ALL_CLK_OFF_MUX_SEL_BMSK                                                                0x1
#define HWIO_GCC_RPMH_ALL_CLK_OFF_MUX_SEL_SHFT                                                                0x0
#define HWIO_GCC_RPMH_ALL_CLK_OFF_MUX_SEL_SELECT_GCC_AND_SUBCC_ALL_CLKS_OFF_FVAL                              0x0
#define HWIO_GCC_RPMH_ALL_CLK_OFF_MUX_SEL_SELECT_GCC_ONLY_ALL_CLKS_OFF_FVAL                                   0x1

#define HWIO_GCC_GDSC_ALL_CLK_OFF_ADDR                                                                 (GCC_CLK_CTL_REG_REG_BASE      + 0x00048008)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PHYS                                                                 (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00048008)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_OFFS                                                                 (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00048008)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_RMSK                                                                     0x3fff
#define HWIO_GCC_GDSC_ALL_CLK_OFF_ATTR                                                                        0x3
#define HWIO_GCC_GDSC_ALL_CLK_OFF_IN          \
        in_dword_masked(HWIO_GCC_GDSC_ALL_CLK_OFF_ADDR, HWIO_GCC_GDSC_ALL_CLK_OFF_RMSK)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_INM(m)      \
        in_dword_masked(HWIO_GCC_GDSC_ALL_CLK_OFF_ADDR, m)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_OUT(v)      \
        out_dword(HWIO_GCC_GDSC_ALL_CLK_OFF_ADDR,v)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_GDSC_ALL_CLK_OFF_ADDR,m,v,HWIO_GCC_GDSC_ALL_CLK_OFF_IN)
#define HWIO_GCC_GDSC_ALL_CLK_OFF_IPA_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                    0x2000
#define HWIO_GCC_GDSC_ALL_CLK_OFF_IPA_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                       0xd
#define HWIO_GCC_GDSC_ALL_CLK_OFF_ANOC_PCIE_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                              0x1000
#define HWIO_GCC_GDSC_ALL_CLK_OFF_ANOC_PCIE_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                 0xc
#define HWIO_GCC_GDSC_ALL_CLK_OFF_MMU_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                     0x800
#define HWIO_GCC_GDSC_ALL_CLK_OFF_MMU_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                       0xb
#define HWIO_GCC_GDSC_ALL_CLK_OFF_MMNOC_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                   0x400
#define HWIO_GCC_GDSC_ALL_CLK_OFF_MMNOC_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                     0xa
#define HWIO_GCC_GDSC_ALL_CLK_OFF_USB30_PRIM_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                              0x200
#define HWIO_GCC_GDSC_ALL_CLK_OFF_USB30_PRIM_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                0x9
#define HWIO_GCC_GDSC_ALL_CLK_OFF_USB3_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                0x100
#define HWIO_GCC_GDSC_ALL_CLK_OFF_USB3_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                  0x8
#define HWIO_GCC_GDSC_ALL_CLK_OFF_LPASS_QTB_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                0x80
#define HWIO_GCC_GDSC_ALL_CLK_OFF_LPASS_QTB_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                 0x7
#define HWIO_GCC_GDSC_ALL_CLK_OFF_TURING_QTB_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                               0x40
#define HWIO_GCC_GDSC_ALL_CLK_OFF_TURING_QTB_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                0x6
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_0_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                   0x20
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_0_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                    0x5
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_0_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                               0x10
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_0_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                0x4
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_1_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                    0x8
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_1_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                    0x3
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_1_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                0x4
#define HWIO_GCC_GDSC_ALL_CLK_OFF_PCIE_1_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                0x2
#define HWIO_GCC_GDSC_ALL_CLK_OFF_UFS_MEM_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                               0x2
#define HWIO_GCC_GDSC_ALL_CLK_OFF_UFS_MEM_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                               0x1
#define HWIO_GCC_GDSC_ALL_CLK_OFF_UFS_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_BMSK                                   0x1
#define HWIO_GCC_GDSC_ALL_CLK_OFF_UFS_PHY_GDSCR_SW_POWER_DOWN_COMPLETE_SHFT                                   0x0

#define HWIO_GCC_PLL_ALL_CLK_OFF_ADDR                                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0004800c)
#define HWIO_GCC_PLL_ALL_CLK_OFF_PHYS                                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004800c)
#define HWIO_GCC_PLL_ALL_CLK_OFF_OFFS                                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004800c)
#define HWIO_GCC_PLL_ALL_CLK_OFF_RMSK                                                                         0x1
#define HWIO_GCC_PLL_ALL_CLK_OFF_ATTR                                                                         0x3
#define HWIO_GCC_PLL_ALL_CLK_OFF_IN          \
        in_dword_masked(HWIO_GCC_PLL_ALL_CLK_OFF_ADDR, HWIO_GCC_PLL_ALL_CLK_OFF_RMSK)
#define HWIO_GCC_PLL_ALL_CLK_OFF_INM(m)      \
        in_dword_masked(HWIO_GCC_PLL_ALL_CLK_OFF_ADDR, m)
#define HWIO_GCC_PLL_ALL_CLK_OFF_OUT(v)      \
        out_dword(HWIO_GCC_PLL_ALL_CLK_OFF_ADDR,v)
#define HWIO_GCC_PLL_ALL_CLK_OFF_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_PLL_ALL_CLK_OFF_ADDR,m,v,HWIO_GCC_PLL_ALL_CLK_OFF_IN)
#define HWIO_GCC_PLL_ALL_CLK_OFF_MUX_SEL_BMSK                                                                 0x1
#define HWIO_GCC_PLL_ALL_CLK_OFF_MUX_SEL_SHFT                                                                 0x0

#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f058)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f058)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f058)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_RMSK                                                                0x1f
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                                0x10
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x4
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                 0x8
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x3
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                  0x4
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                  0x2
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                     0x2
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                     0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                     0x1
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                     0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_SP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1

#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ADDR                                                           (GCC_CLK_CTL_REG_REG_BASE      + 0x0002f05c)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_PHYS                                                           (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002f05c)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_OFFS                                                           (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002f05c)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_RMSK                                                                 0x1f
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ATTR                                                                  0x3
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                                 0x10
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                  0x4
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                  0x8
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                  0x3
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                   0x4
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                   0x2
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                           0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                            0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                      0x2
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                      0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                               0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                      0x1
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                      0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                              0x0
#define HWIO_GCC_SP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                               0x1

#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00041020)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041020)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041020)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_RMSK                                                               0x1f
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                               0x10
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                0x4
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                0x8
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                0x3
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                 0x4
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                 0x2
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                    0x2
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                    0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                    0x1
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                    0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_RPM_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1

#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00041024)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00041024)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00041024)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_RMSK                                                                0x1f
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                                0x10
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x4
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                 0x8
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x3
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                  0x4
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                  0x2
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                     0x2
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                     0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                     0x1
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                     0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_RPM_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1

#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00042020)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042020)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042020)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_RMSK                                                              0x1f
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                              0x10
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                               0x4
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                               0x8
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                               0x3
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                0x4
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                0x2
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                   0x2
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                   0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                            0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                   0x1
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                   0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                           0x0
#define HWIO_GCC_APCS_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                            0x1

#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00042024)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00042024)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00042024)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_RMSK                                                               0x1f
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                               0x10
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                0x4
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                0x8
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                0x3
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                 0x4
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                 0x2
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                    0x2
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                    0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                    0x1
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                    0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_APCS_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1

#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ADDR                                                     (GCC_CLK_CTL_REG_REG_BASE      + 0x00043058)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_PHYS                                                     (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00043058)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_OFFS                                                     (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00043058)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_RMSK                                                           0x1f
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ATTR                                                            0x3
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                           0x10
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                            0x4
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                            0x8
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                            0x3
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                    0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                     0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                             0x4
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                             0x2
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                0x2
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                0x1
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_APCS_TZ_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1

#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0004305c)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004305c)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004305c)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_RMSK                                                            0x1f
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                            0x10
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                             0x4
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                             0x8
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                             0x3
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                              0x4
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                              0x2
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                 0x2
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                 0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                 0x1
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                 0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_APCS_TZ_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1

#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x00045020)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045020)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045020)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_RMSK                                                         0x1f
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ATTR                                                          0x3
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                         0x10
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                          0x4
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                          0x8
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                          0x3
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                  0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                   0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                           0x4
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                           0x2
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                              0x2
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                              0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                              0x1
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                              0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_LPASS_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1

#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ADDR                                                    (GCC_CLK_CTL_REG_REG_BASE      + 0x00045024)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_PHYS                                                    (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00045024)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_OFFS                                                    (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00045024)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_RMSK                                                          0x1f
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ATTR                                                           0x3
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                          0x10
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                           0x4
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                           0x8
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                           0x3
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                   0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                    0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                            0x4
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                            0x2
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                    0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                     0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                               0x2
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                               0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                               0x1
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                               0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_LPASS_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1

#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ADDR                                                  (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b020)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_PHYS                                                  (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b020)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_OFFS                                                  (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b020)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_RMSK                                                        0x1f
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ATTR                                                         0x3
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                        0x10
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                         0x4
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                         0x8
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                         0x3
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                 0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                  0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                          0x4
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                          0x2
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                             0x2
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                             0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                             0x1
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                             0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_TURING_DSP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1

#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ADDR                                                   (GCC_CLK_CTL_REG_REG_BASE      + 0x0004b024)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_PHYS                                                   (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004b024)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_OFFS                                                   (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004b024)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_RMSK                                                         0x1f
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ATTR                                                          0x3
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                         0x10
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                          0x4
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                          0x8
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                          0x3
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                  0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                   0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                           0x4
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                           0x2
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                   0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                    0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                              0x2
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                              0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                              0x1
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                              0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_TURING_DSP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1

#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x00047020)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047020)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047020)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_RMSK                                                             0x1f
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                             0x10
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                              0x4
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                              0x8
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                              0x3
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                               0x4
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                               0x2
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                  0x2
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                  0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                  0x1
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                  0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1

#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ADDR                                                        (GCC_CLK_CTL_REG_REG_BASE      + 0x00047024)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_PHYS                                                        (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00047024)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_OFFS                                                        (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00047024)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_RMSK                                                              0x1f
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ATTR                                                               0x3
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                              0x10
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                               0x4
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                               0x8
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                               0x3
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                0x4
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                0x2
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                   0x2
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                   0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                            0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                   0x1
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                   0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                           0x0
#define HWIO_GCC_SPARE_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                            0x1

#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x00025058)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00025058)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00025058)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_RMSK                                                            0x1f
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                            0x10
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                             0x4
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                             0x8
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                             0x3
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                              0x4
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                              0x2
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                 0x2
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                 0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                 0x1
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                 0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_MSS_Q6_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1

#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0002505c)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0002505c)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0002505c)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_RMSK                                                             0x1f
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                             0x10
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                              0x4
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                              0x8
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                              0x3
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                               0x4
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                               0x2
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                  0x2
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                  0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                  0x1
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                  0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_MSS_Q6_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1

#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00046020)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046020)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046020)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_RMSK                                                               0x1f
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                               0x10
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                0x4
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                0x8
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                0x3
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                 0x4
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                 0x2
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                    0x2
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                    0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                    0x1
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                    0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_HYP_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1

#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x00046024)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00046024)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00046024)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_RMSK                                                                0x1f
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                                0x10
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x4
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                 0x8
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x3
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                  0x4
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                  0x2
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                     0x2
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                     0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                     0x1
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                     0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_HYP_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1

#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ADDR                                                      (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a020)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_PHYS                                                      (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a020)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_OFFS                                                      (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a020)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_RMSK                                                            0x1f
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ATTR                                                             0x3
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                            0x10
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                             0x4
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                             0x8
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                             0x3
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                     0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                      0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                              0x4
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                              0x2
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                 0x2
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                 0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                 0x1
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                 0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_SPARE1_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1

#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ADDR                                                       (GCC_CLK_CTL_REG_REG_BASE      + 0x0004a024)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_PHYS                                                       (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0004a024)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_OFFS                                                       (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0004a024)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_RMSK                                                             0x1f
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ATTR                                                              0x3
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                             0x10
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                              0x4
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                              0x8
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                              0x3
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                      0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                       0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                               0x4
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                               0x2
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                       0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                        0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                  0x2
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                  0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                  0x1
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                  0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_SPARE1_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1

#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ADDR                                                         (GCC_CLK_CTL_REG_REG_BASE      + 0x00059058)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_PHYS                                                         (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x00059058)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_OFFS                                                         (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x00059058)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_RMSK                                                               0x1f
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ATTR                                                                0x3
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ADDR, HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_IN)
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                               0x10
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                0x4
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                0x8
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                0x3
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                        0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                         0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                 0x4
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                 0x2
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                    0x2
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                    0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                    0x1
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                    0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                            0x0
#define HWIO_GCC_TME_GDSC_BRANCH_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                             0x1

#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ADDR                                                          (GCC_CLK_CTL_REG_REG_BASE      + 0x0005905c)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_PHYS                                                          (GCC_CLK_CTL_REG_REG_BASE_PHYS + 0x0005905c)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_OFFS                                                          (GCC_CLK_CTL_REG_REG_BASE_OFFS + 0x0005905c)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_RMSK                                                                0x1f
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ATTR                                                                 0x3
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_IN          \
        in_dword_masked(HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ADDR, HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_RMSK)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_INM(m)      \
        in_dword_masked(HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ADDR, m)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_OUT(v)      \
        out_dword(HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ADDR,v)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_ADDR,m,v,HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_IN)
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_BMSK                                0x10
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x4
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_BMSK                                 0x8
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_SHFT                                 0x3
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_DISABLE_FVAL                         0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_PHY_GDSC_SW_COLLAPSE_ENABLE_FVAL                          0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_BMSK                                  0x4
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_SHFT                                  0x2
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_DISABLE_FVAL                          0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_ANOC_PCIE_GDSC_SW_COLLAPSE_ENABLE_FVAL                           0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_BMSK                                     0x2
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_SHFT                                     0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_1_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_BMSK                                     0x1
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_SHFT                                     0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_DISABLE_FVAL                             0x0
#define HWIO_GCC_TME_GDSC_SLEEP_ENA_VOTE_GCC_PCIE_0_GDSC_SW_COLLAPSE_ENABLE_FVAL                              0x1


#endif /* __IPA_GCC_HWIO_H__ */
